/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/base/common/path","vs/base/common/errors","vs/platform/log/common/log","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/network","vs/base/common/resources","vs/base/common/arrays","vs/base/common/types","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/buffer","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/common/objects","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/base/common/uuid","vs/base/common/process","os","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","child_process","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","vs/base/common/map","vs/platform/product/common/product","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/codicons","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/iterator","net","vs/base/common/date","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/common/glob","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensionHostStarter","crypto","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensions/node/extensionHostStarter","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","util","minimist","path","assert","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ne=function(J){for(var e=[],D=0,L=J.length;D<L;D++)e[D]=te[J[D]];return e};define(te[99],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function D(L,R){if(!L)throw new Error(R?`Assertion failed (${R})`:"Assertion Failed")}e.ok=D}),define(te[65],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const D=Object.prototype.hasOwnProperty;function L(n){const I=[];for(let g in n)D.call(n,g)&&I.push(n[g]);return I}e.values=L;function R(n,I){for(let g in n)if(D.call(n,g)&&I({key:g,value:n[g]},function(){delete n[g]})===!1)return}e.forEach=R;function T(n,I){const g=Object.create(null);for(const w of n){const f=I(w);let p=g[f];p||(p=g[f]=[]),p.push(w)}return g}e.groupBy=T;function k(n){const I=Object.create(null);return n&&n.forEach((g,w)=>{I[w]=g}),I}e.fromMap=k;function C(n,I){const g=[],w=[];for(let f of n)I.has(f)||g.push(f);for(let f of I)n.has(f)||w.push(f);return{removed:g,added:w}}e.diffSets=C;function S(n,I){const g=[],w=[];for(let[f,p]of n)I.has(f)||g.push(p);for(let[f,p]of I)n.has(f)||w.push(p);return{removed:g,added:w}}e.diffMaps=S;class E{constructor(){this.map=new Map}add(I,g){let w=this.map.get(I);w||(w=new Set,this.map.set(I,w)),w.add(g)}delete(I,g){const w=this.map.get(I);!w||(w.delete(g),w.size===0&&this.map.delete(I))}forEach(I,g){const w=this.map.get(I);!w||w.forEach(g)}}e.SetMap=E}),define(te[66],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(k){return(C,S,E)=>{let n=null,I=null;if(typeof E.value=="function"?(n="value",I=E.value):typeof E.get=="function"&&(n="get",I=E.get),!I)throw new Error("not supported");E[n]=k(I,S)}}e.createDecorator=D;function L(k,C,S){let E=null,n=null;if(typeof S.value=="function"?(E="value",n=S.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(E="get",n=S.get),!n)throw new Error("not supported");const I=`$memoize$${C}`;S[E]=function(...g){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,g)}),this[I]}}e.memoize=L;function R(k,C,S){return D((E,n)=>{const I=`$debounce$${n}`,g=`$debounce$result$${n}`;return function(...w){this[g]||(this[g]=S?S():void 0),clearTimeout(this[I]),C&&(this[g]=C(this[g],...w),w=[this[g]]),this[I]=setTimeout(()=>{E.apply(this,w),this[g]=S?S():void 0},k)}})}e.debounce=R;function T(k,C,S){return D((E,n)=>{const I=`$throttle$timer$${n}`,g=`$throttle$result$${n}`,w=`$throttle$lastRun$${n}`,f=`$throttle$pending$${n}`;return function(...p){if(this[g]||(this[g]=S?S():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),C&&(this[g]=C(this[g],...p)),this[f])return;const d=this[w]+k;d<=Date.now()?(this[w]=Date.now(),E.apply(this,[this[g]]),this[g]=S?S():void 0):(this[f]=!0,this[I]=setTimeout(()=>{this[f]=!1,this[w]=Date.now(),E.apply(this,[this[g]]),this[g]=S?S():void 0},d-Date.now()))}})}e.throttle=T}),define(te[9],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(s=>{s(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=D,e.errorHandler=new D;function L(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=L;function R(c){S(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=R;function T(c){S(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=T;function k(c){if(c instanceof Error){let{name:t,message:s}=c;const r=c.stacktrace||c.stack;return{$isError:!0,name:t,message:s,stack:r}}return c}e.transformErrorForSerialization=k;const C="Canceled";function S(c){return c instanceof Error&&c.name===C&&c.message===C}e.isPromiseCanceledError=S;class E extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=E;function n(){const c=new Error(C);return c.name=c.message,c}e.canceled=n;function I(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=I;function g(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=g;function w(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=w;function f(c){const t=new Error(`${c} has been disposed`);return t.name="DISPOSED",t}e.disposed=f;function p(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=p;class d extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=d;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class y extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=y;function v(c){const t=c;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=v;function l(c,t=Object.create(null)){const s=new Error(c);return t.actions&&(s.actions=t.actions),s}e.createErrorWithActions=l}),define(te[17],ne([0,1,9]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(z,B=0){return z[z.length-(1+B)]}e.tail=L;function R(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.tail2=R;function T(z,B,X=(Z,V)=>Z===V){if(z===B)return!0;if(!z||!B||z.length!==B.length)return!1;for(let Z=0,V=z.length;Z<V;Z++)if(!X(z[Z],B[Z]))return!1;return!0}e.equals=T;function k(z,B,X){let Z=0,V=z.length-1;for(;Z<=V;){const G=(Z+V)/2|0,ie=X(z[G],B);if(ie<0)Z=G+1;else if(ie>0)V=G-1;else return G}return-(Z+1)}e.binarySearch=k;function C(z,B){let X=0,Z=z.length;if(Z===0)return 0;for(;X<Z;){const V=Math.floor((X+Z)/2);B(z[V])?Z=V:X=V+1}return X}e.findFirstInSorted=C;function S(z,B,X){if(z=z|0,z>=B.length)throw new TypeError("invalid index");let Z=B[Math.floor(B.length*Math.random())],V=[],G=[],ie=[];for(let re of B){const ae=X(re,Z);ae<0?V.push(re):ae>0?G.push(re):ie.push(re)}return z<V.length?S(z,V,X):z<V.length+ie.length?ie[0]:S(z-(V.length+ie.length),G,X)}e.quickSelect=S;function E(z,B){const X=[];let Z;for(const V of z.slice(0).sort(B))!Z||B(Z[0],V)!==0?(Z=[V],X.push(Z)):Z.push(V);return X}e.groupBy=E;function n(z,B,X){const Z=[];function V(re,ae,ue){if(ae===0&&ue.length===0)return;const fe=Z[Z.length-1];fe&&fe.start+fe.deleteCount===re?(fe.deleteCount+=ae,fe.toInsert.push(...ue)):Z.push({start:re,deleteCount:ae,toInsert:ue})}let G=0,ie=0;for(;;){if(G===z.length){V(G,0,B.slice(ie));break}if(ie===B.length){V(G,z.length-G,[]);break}const re=z[G],ae=B[ie],ue=X(re,ae);ue===0?(G+=1,ie+=1):ue<0?(V(G,1,[]),G+=1):ue>0&&(V(G,0,[ae]),ie+=1)}return Z}e.sortedDiff=n;function I(z,B,X){const Z=n(z,B,X),V=[],G=[];for(const ie of Z)V.push(...z.slice(ie.start,ie.start+ie.deleteCount)),G.push(...ie.toInsert);return{removed:V,added:G}}e.delta=I;function g(z,B,X){if(X===0)return[];const Z=z.slice(0,X).sort(B);return f(z,B,Z,X,z.length),Z}e.top=g;function w(z,B,X,Z,V){return X===0?Promise.resolve([]):new Promise((G,ie)=>{(async()=>{const re=z.length,ae=z.slice(0,X).sort(B);for(let ue=X,fe=Math.min(X+Z,re);ue<re;ue=fe,fe=Math.min(fe+Z,re)){if(ue>X&&await new Promise(de=>setTimeout(de)),V&&V.isCancellationRequested)throw(0,D.canceled)();f(z,B,ae,ue,fe)}return ae})().then(G,ie)})}e.topAsync=w;function f(z,B,X,Z,V){for(const G=X.length;Z<V;Z++){const ie=z[Z];if(B(ie,X[G-1])<0){X.pop();const re=C(X,ae=>B(ie,ae)<0);X.splice(re,0,ie)}}}function p(z){return z.filter(B=>!!B)}e.coalesce=p;function d(z){let B=0;for(let X=0;X<z.length;X++)z[X]&&(z[B]=z[X],B+=1);z.length=B}e.coalesceInPlace=d;function b(z,B,X){z.splice(X,0,z.splice(B,1)[0])}e.move=b;function y(z){return!Array.isArray(z)||z.length===0}e.isFalsyOrEmpty=y;function v(z){return Array.isArray(z)&&z.length>0}e.isNonEmptyArray=v;function l(z,B){if(!B)return z.filter((Z,V)=>z.indexOf(Z)===V);const X=Object.create(null);return z.filter(Z=>{const V=B(Z);return X[V]?!1:(X[V]=!0,!0)})}e.distinct=l;function c(z){const B=new Set;return z.filter(X=>B.has(X)?!1:(B.add(X),!0))}e.distinctES6=c;function t(z){const B=Object.create(null);return X=>{const Z=z(X);return B[Z]?!1:(B[Z]=!0,!0)}}e.uniqueFilter=t;function s(z,B){const X=r(z,B);if(X!==-1)return z[X]}e.findLast=s;function r(z,B){for(let X=z.length-1;X>=0;X--){const Z=z[X];if(B(Z))return X}return-1}e.lastIndex=r;function i(z,B){return z.length>0?z[0]:B}e.firstOrDefault=i;function a(z,B,X=(Z,V)=>Z===V){let Z=0;for(let V=0,G=Math.min(z.length,B.length);V<G&&X(z[V],B[V]);V++)Z++;return Z}e.commonPrefixLength=a;function o(z){return[].concat(...z)}e.flatten=o;function u(z,B){let X=typeof B=="number"?z:0;typeof B=="number"?X=z:(X=0,B=z);const Z=[];if(X<=B)for(let V=X;V<B;V++)Z.push(V);else for(let V=X;V>B;V--)Z.push(V);return Z}e.range=u;function h(z,B,X){return z.reduce((Z,V)=>(Z[B(V)]=X?X(V):V,Z),Object.create(null))}e.index=h;function m(z,B){return z.push(B),()=>A(z,B)}e.insert=m;function A(z,B){const X=z.indexOf(B);if(X>-1)return z.splice(X,1),B}e.remove=A;function _(z,B,X){const Z=z.slice(0,B),V=z.slice(B);return Z.concat(X,V)}e.arrayInsert=_;function O(z,B){let X;if(typeof B=="number"){let Z=B;X=()=>{const V=Math.sin(Z++)*179426549;return V-Math.floor(V)}}else X=Math.random;for(let Z=z.length-1;Z>0;Z-=1){const V=Math.floor(X()*(Z+1)),G=z[Z];z[Z]=z[V],z[V]=G}}e.shuffle=O;function N(z,B){const X=z.indexOf(B);X>-1&&(z.splice(X,1),z.unshift(B))}e.pushToStart=N;function P(z,B){const X=z.indexOf(B);X>-1&&(z.splice(X,1),z.push(B))}e.pushToEnd=P;function M(z,B){return Array.isArray(z)?z.map(B):B(z)}e.mapArrayOrNot=M;function $(z){return Array.isArray(z)?z:[z]}e.asArray=$;function U(z){return z[Math.floor(Math.random()*z.length)]}e.getRandomElement=U;function H(z,B){for(const X of z){const Z=B(X);if(Z!==void 0)return Z}}e.mapFind=H;function W(z,B,X){const Z=x(z,B),V=z.length,G=X.length;z.length=V+G;for(let ie=V-1;ie>=Z;ie--)z[ie+G]=z[ie];for(let ie=0;ie<G;ie++)z[ie+Z]=X[ie]}e.insertInto=W;function q(z,B,X,Z){const V=x(z,B),G=z.splice(V,X);return W(z,V,Z),G}e.splice=q;function x(z,B){return B<0?Math.max(B+z.length,0):Math.min(B,z.length)}function F(z,B){let X=Number.MAX_SAFE_INTEGER,Z=0;return z.forEach((V,G)=>{const ie=B(V);ie<X&&(X=ie,Z=G)}),Z}e.minIndex=F;function K(z,B){let X=Number.MIN_SAFE_INTEGER,Z=0;return z.forEach((V,G)=>{const ie=B(V);ie>X&&(X=ie,Z=G)}),Z}e.maxIndex=K;class j{constructor(B){this.items=B,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(B){let X=this.firstIdx;for(;X<this.items.length&&B(this.items[X]);)X++;const Z=X===this.firstIdx?null:this.items.slice(this.firstIdx,X);return this.firstIdx=X,Z}takeFromEndWhile(B){let X=this.lastIdx;for(;X>=0&&B(this.items[X]);)X--;const Z=X===this.lastIdx?null:this.items.slice(X+1,this.lastIdx+1);return this.lastIdx=X,Z}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=j}),define(te[67],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(L){const R=this;let T=!1,k;return function(){return T||(T=!0,k=L.apply(R,arguments)),k}}e.once=D}),define(te[55],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(L){function R(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}L.is=R;const T=Object.freeze([]);function k(){return T}L.empty=k;function*C(c){yield c}L.single=C;function S(c){return c||T}L.from=S;function E(c){return!c||c[Symbol.iterator]().next().done===!0}L.isEmpty=E;function n(c){return c[Symbol.iterator]().next().value}L.first=n;function I(c,t){for(const s of c)if(t(s))return!0;return!1}L.some=I;function g(c,t){for(const s of c)if(t(s))return s}L.find=g;function*w(c,t){for(const s of c)t(s)&&(yield s)}L.filter=w;function*f(c,t){let s=0;for(const r of c)yield t(r,s++)}L.map=f;function*p(...c){for(const t of c)for(const s of t)yield s}L.concat=p;function*d(c){for(const t of c)for(const s of t)yield s}L.concatNested=d;function b(c,t,s){let r=s;for(const i of c)r=t(r,i);return r}L.reduce=b;function*y(c,t,s=c.length){for(t<0&&(t+=c.length),s<0?s+=c.length:s>c.length&&(s=c.length);t<s;t++)yield c[t]}L.slice=y;function v(c,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,c];const r=c[Symbol.iterator]();for(let i=0;i<t;i++){const a=r.next();if(a.done)return[s,L.empty()];s.push(a.value)}return[s,{[Symbol.iterator](){return r}}]}L.consume=v;function l(c,t,s=(r,i)=>r===i){const r=c[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const a=r.next(),o=i.next();if(a.done!==o.done)return!1;if(a.done)return!0;if(!s(a.value,o.value))return!1}}L.equals=l})(D=e.Iterable||(e.Iterable={}))}),define(te[36],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var R;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(R=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function k(t,s=!1){let r=0,i=t.length,a="",o=0,u=16,h=0;function m($){let U=0,H=0;for(;U<$;){const W=t.charCodeAt(r);if(W>=48&&W<=57)H=H*16+W-48;else if(W>=65&&W<=70)H=H*16+W-65+10;else if(W>=97&&W<=102)H=H*16+W-97+10;else break;r++,U++}return U<$&&(H=-1),H}function A($){r=$,a="",o=0,u=16,h=0}function _(){const $=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&E(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&E(t.charCodeAt(r)))for(r++;r<t.length&&E(t.charCodeAt(r));)r++;else return h=3,t.substring($,r);let U=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&E(t.charCodeAt(r))){for(r++;r<t.length&&E(t.charCodeAt(r));)r++;U=r}else h=3;return t.substring($,U)}function O(){let $="",U=r;for(;;){if(r>=i){$+=t.substring(U,r),h=2;break}const H=t.charCodeAt(r);if(H===34){$+=t.substring(U,r),r++;break}if(H===92){if($+=t.substring(U,r),r++,r>=i){h=2;break}switch(t.charCodeAt(r++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const q=m(4);q>=0?$+=String.fromCharCode(q):h=4;break;default:h=5}U=r;continue}if(H>=0&&H<=31)if(S(H)){$+=t.substring(U,r),h=2;break}else h=6;r++}return $}function N(){if(a="",h=0,o=r,r>=i)return o=i,u=17;let $=t.charCodeAt(r);if(C($)){do r++,a+=String.fromCharCode($),$=t.charCodeAt(r);while(C($));return u=15}if(S($))return r++,a+=String.fromCharCode($),$===13&&t.charCodeAt(r)===10&&(r++,a+=`
`),u=14;switch($){case 123:return r++,u=1;case 125:return r++,u=2;case 91:return r++,u=3;case 93:return r++,u=4;case 58:return r++,u=6;case 44:return r++,u=5;case 34:return r++,a=O(),u=10;case 47:const U=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!S(t.charCodeAt(r));)r++;return a=t.substring(U,r),u=12}if(t.charCodeAt(r+1)===42){r+=2;const H=i-1;let W=!1;for(;r<H;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,W=!0;break}r++}return W||(r++,h=1),a=t.substring(U,r),u=13}return a+=String.fromCharCode($),r++,u=16;case 45:if(a+=String.fromCharCode($),r++,r===i||!E(t.charCodeAt(r)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=_(),u=11;default:for(;r<i&&P($);)r++,$=t.charCodeAt(r);if(o!==r){switch(a=t.substring(o,r),a){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return a+=String.fromCharCode($),r++,u=16}}function P($){if(C($)||S($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let $;do $=N();while($>=12&&$<=15);return $}return{setPosition:A,getPosition:()=>r,scan:s?M:N,getToken:()=>u,getTokenValue:()=>a,getTokenOffset:()=>o,getTokenLength:()=>r-o,getTokenError:()=>h}}e.createScanner=k;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function I(t,s){const r=[],i=new Object;let a;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function h(m,A,_,O){o.value=m,o.offset=A,o.length=_,o.type=O,o.colonOffset=void 0,a=o}try{v(t,{onObjectBegin:(m,A)=>{if(s<=m)throw i;a=void 0,u=s>m,r.push("")},onObjectProperty:(m,A,_)=>{if(s<A||(h(m,A,_,"property"),r[r.length-1]=m,s<=A+_))throw i},onObjectEnd:(m,A)=>{if(s<=m)throw i;a=void 0,r.pop()},onArrayBegin:(m,A)=>{if(s<=m)throw i;a=void 0,r.push(0)},onArrayEnd:(m,A)=>{if(s<=m)throw i;a=void 0,r.pop()},onLiteralValue:(m,A,_)=>{if(s<A||(h(m,A,_,c(m)),s<=A+_))throw i},onSeparator:(m,A,_)=>{if(s<=A)throw i;if(m===":"&&a&&a.type==="property")a.colonOffset=A,u=!1,a=void 0;else if(m===","){const O=r[r.length-1];typeof O=="number"?r[r.length-1]=O+1:(u=!0,r[r.length-1]=""),a=void 0}}})}catch(m){if(m!==i)throw m}return{path:r,previousNode:a,isAtPropertyKey:u,matches:m=>{let A=0;for(let _=0;A<m.length&&_<r.length;_++)if(m[A]===r[_]||m[A]==="*")A++;else if(m[A]!=="**")return!1;return A===m.length}}}e.getLocation=I;function g(t,s=[],r=T.DEFAULT){let i=null,a=[];const o=[];function u(m){Array.isArray(a)?a.push(m):i!==null&&(a[i]=m)}return v(t,{onObjectBegin:()=>{const m={};u(m),o.push(a),a=m,i=null},onObjectProperty:m=>{i=m},onObjectEnd:()=>{a=o.pop()},onArrayBegin:()=>{const m=[];u(m),o.push(a),a=m,i=null},onArrayEnd:()=>{a=o.pop()},onLiteralValue:u,onError:(m,A,_)=>{s.push({error:m,offset:A,length:_})}},r),a[0]}e.parse=g;function w(t,s=[],r=T.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(m){i.type==="property"&&(i.length=m-i.offset,i=i.parent)}function o(m){return i.children.push(m),m}v(t,{onObjectBegin:m=>{i=o({type:"object",offset:m,length:-1,parent:i,children:[]})},onObjectProperty:(m,A,_)=>{i=o({type:"property",offset:A,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:m,offset:A,length:_,parent:i})},onObjectEnd:(m,A)=>{i.length=m+A-i.offset,i=i.parent,a(m+A)},onArrayBegin:(m,A)=>{i=o({type:"array",offset:m,length:-1,parent:i,children:[]})},onArrayEnd:(m,A)=>{i.length=m+A-i.offset,i=i.parent,a(m+A)},onLiteralValue:(m,A,_)=>{o({type:c(m),offset:A,length:_,parent:i,value:m}),a(A+_)},onSeparator:(m,A,_)=>{i.type==="property"&&(m===":"?i.colonOffset=A:m===","&&a(A))},onError:(m,A,_)=>{s.push({error:m,offset:A,length:_})}},r);const h=i.children[0];return h&&delete h.parent,h}e.parseTree=w;function f(t,s){if(!t)return;let r=t;for(let i of s)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let a=!1;for(const o of r.children)if(Array.isArray(o.children)&&o.children[0].value===i){r=o.children[1],a=!0;break}if(!a)return}else{const a=i;if(r.type!=="array"||a<0||!Array.isArray(r.children)||a>=r.children.length)return;r=r.children[a]}return r}e.findNodeAtLocation=f;function p(t){if(!t.parent||!t.parent.children)return[];const s=p(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;s.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&s.push(r)}return s}e.getNodePath=p;function d(t){switch(t.type){case"array":return t.children.map(d);case"object":const s=Object.create(null);for(let r of t.children){const i=r.children[1];i&&(s[r.children[0].value]=d(i))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=d;function b(t,s,r=!1){return s>=t.offset&&s<t.offset+t.length||r&&s===t.offset+t.length}e.contains=b;function y(t,s,r=!1){if(b(t,s,r)){const i=t.children;if(Array.isArray(i))for(let a=0;a<i.length&&i[a].offset<=s;a++){const o=y(i[a],s,r);if(o)return o}return t}}e.findNodeAtOffset=y;function v(t,s,r=T.DEFAULT){const i=k(t,!1);function a(B){return B?()=>B(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(B){return B?X=>B(X,i.getTokenOffset(),i.getTokenLength()):()=>!0}const u=a(s.onObjectBegin),h=o(s.onObjectProperty),m=a(s.onObjectEnd),A=a(s.onArrayBegin),_=a(s.onArrayEnd),O=o(s.onLiteralValue),N=o(s.onSeparator),P=a(s.onComment),M=o(s.onError),$=r&&r.disallowComments,U=r&&r.allowTrailingComma;function H(){for(;;){const B=i.scan();switch(i.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:$||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(B){case 12:case 13:$?W(10):P();break;case 16:W(1);break;case 15:case 14:break;default:return B}}}function W(B,X=[],Z=[]){if(M(B),X.length+Z.length>0){let V=i.getToken();for(;V!==17;){if(X.indexOf(V)!==-1){H();break}else if(Z.indexOf(V)!==-1)break;V=H()}}}function q(B){const X=i.getTokenValue();return B?O(X):h(X),H(),!0}function x(){switch(i.getToken()){case 11:let B=0;try{B=JSON.parse(i.getTokenValue()),typeof B!="number"&&(W(2),B=0)}catch(X){W(2)}O(B);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return H(),!0}function F(){return i.getToken()!==10?(W(3,[],[2,5]),!1):(q(!1),i.getToken()===6?(N(":"),H(),z()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function K(){u(),H();let B=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(B||W(4,[],[]),N(","),H(),i.getToken()===2&&U)break}else B&&W(6,[],[]);F()||W(4,[],[2,5]),B=!0}return m(),i.getToken()!==2?W(7,[2],[]):H(),!0}function j(){A(),H();let B=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(B||W(4,[],[]),N(","),H(),i.getToken()===4&&U)break}else B&&W(6,[],[]);z()||W(4,[],[4,5]),B=!0}return _(),i.getToken()!==4?W(8,[4],[]):H(),!0}function z(){switch(i.getToken()){case 3:return j();case 1:return K();case 10:return q(!0);default:return x()}}return H(),i.getToken()===17?r.allowEmptyContent?!0:(W(4,[],[]),!1):z()?(i.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=v;function l(t,s){let r=k(t),i=[],a,o=0,u;do switch(u=r.getPosition(),a=r.scan(),a){case 12:case 13:case 17:o!==u&&i.push(t.substring(o,u)),s!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,s)),o=r.getPosition();break}while(a!==17);return i.join("")}e.stripComments=l;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(te[48],ne([0,1,36]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(S,E,n){let I,g,w,f,p;if(E){for(f=E.offset,p=f+E.length,w=f;w>0&&!C(S,w-1);)w--;let o=p;for(;o<S.length&&!C(S,o);)o++;g=S.substring(w,o),I=T(g,n)}else g=S,I=0,w=0,f=0,p=S.length;const d=k(n,S);let b=!1,y=0,v;n.insertSpaces?v=R(" ",n.tabSize||4):v="	";const l=(0,D.createScanner)(g,!1);let c=!1;function t(){return d+R(v,I+y)}function s(){let o=l.scan();for(b=!1;o===15||o===14;)b=b||o===14,o=l.scan();return c=o===16||l.getTokenError()!==0,o}const r=[];function i(o,u,h){!c&&u<p&&h>f&&S.substring(u,h)!==o&&r.push({offset:u,length:h-u,content:o})}let a=s();if(a!==17){const o=l.getTokenOffset()+w,u=R(v,I);i(u,w,o)}for(;a!==17;){let o=l.getTokenOffset()+l.getTokenLength()+w,u=s(),h="";for(;!b&&(u===12||u===13);){const A=l.getTokenOffset()+w;i(" ",o,A),o=l.getTokenOffset()+l.getTokenLength()+w,h=u===12?t():"",u=s()}if(u===2)a!==1&&(y--,h=t());else if(u===4)a!==3&&(y--,h=t());else{switch(a){case 3:case 1:y++,h=t();break;case 5:case 12:h=t();break;case 13:b?h=t():h=" ";break;case 6:h=" ";break;case 10:if(u===6){h="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?h=" ":u!==5&&u!==17&&(c=!0);break;case 16:c=!0;break}b&&(u===12||u===13)&&(h=t())}const m=l.getTokenOffset()+w;i(h,o,m),a=u}return r}e.format=L;function R(S,E){let n="";for(let I=0;I<E;I++)n+=S;return n}function T(S,E){let n=0,I=0;const g=E.tabSize||4;for(;n<S.length;){const w=S.charAt(n);if(w===" ")I++;else if(w==="	")I+=g;else break;n++}return Math.floor(I/g)}function k(S,E){for(let n=0;n<E.length;n++){const I=E.charAt(n);if(I==="\r")return n+1<E.length&&E.charAt(n+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=k;function C(S,E){return`\r
`.indexOf(S.charAt(E))!==-1}e.isEOL=C}),define(te[44],ne([0,1,36,48]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function R(E,n,I){return T(E,n,void 0,I)}e.removeProperty=R;function T(E,n,I,g,w){const f=n.slice(),p=[],d=(0,D.parseTree)(E,p);let b,y;for(;f.length>0&&(y=f.pop(),b=(0,D.findNodeAtLocation)(d,f),b===void 0&&I!==void 0);)typeof y=="string"?I={[y]:I}:I=[I];if(b)if(b.type==="object"&&typeof y=="string"&&Array.isArray(b.children)){const v=(0,D.findNodeAtLocation)(b,[y]);if(v!==void 0)if(I===void 0){if(!v.parent)throw new Error("Malformed AST");const l=b.children.indexOf(v.parent);let c,t=v.parent.offset+v.parent.length;if(l>0){const s=b.children[l-1];c=s.offset+s.length}else c=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return k(E,{offset:c,length:t-c,content:""},g)}else return k(E,{offset:v.offset,length:v.length,content:JSON.stringify(I)},g);else{if(I===void 0)return[];const l=`${JSON.stringify(y)}: ${JSON.stringify(I)}`,c=w?w(b.children.map(s=>s.children[0].value)):b.children.length;let t;if(c>0){const s=b.children[c-1];t={offset:s.offset+s.length,length:0,content:","+l}}else b.children.length===0?t={offset:b.offset+1,length:0,content:l}:t={offset:b.offset+1,length:0,content:l+","};return k(E,t,g)}}else if(b.type==="array"&&typeof y=="number"&&Array.isArray(b.children))if(I!==void 0){const v=`${JSON.stringify(I)}`;let l;if(b.children.length===0||y===0)l={offset:b.offset+1,length:0,content:b.children.length===0?v:v+","};else{const c=y===-1||y>b.children.length?b.children.length:y,t=b.children[c-1];l={offset:t.offset+t.length,length:0,content:","+v}}return k(E,l,g)}else{const v=y,l=b.children[v];let c;if(b.children.length===1)c={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===v){const t=b.children[v-1],s=t.offset+t.length,r=b.offset+b.length;c={offset:s,length:r-2-s,content:""}}else c={offset:l.offset,length:b.children[v+1].offset-l.offset,content:""};return k(E,c,g)}else throw new Error(`Can not add ${typeof y!="number"?"index":"property"} to parent of type ${b.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return k(E,{offset:d?d.offset:0,length:d?d.length:0,content:JSON.stringify(I)},g)}}e.setProperty=T;function k(E,n,I){let g=C(E,n),w=n.offset,f=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;w>0&&!(0,L.isEOL)(g,w-1);)w--;for(;f<g.length&&!(0,L.isEOL)(g,f);)f++}const p=(0,L.format)(g,{offset:w,length:f-w},I);for(let b=p.length-1;b>=0;b--){const y=p[b];g=C(g,y),w=Math.min(w,y.offset),f=Math.max(f,y.offset+y.length),f+=y.content.length-y.length}const d=E.length-(g.length-f)-w;return[{offset:w,length:d,content:g.substring(w,f)}]}e.withFormatting=k;function C(E,n){return E.substring(0,n.offset)+n.content+E.substring(n.offset+n.length)}e.applyEdit=C;function S(E,n){let I=n.slice(0).sort((w,f)=>{const p=w.offset-f.offset;return p===0?w.length-f.length:p}),g=E.length;for(let w=I.length-1;w>=0;w--){let f=I[w];if(f.offset+f.length<=g)E=C(E,f);else throw new Error("Overlapping edit");g=f.offset}return E}e.applyEdits=S}),define(te[2],ne([0,1,67,55]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const R=!1;let T=null;function k(i){T=i}if(e.setDisposableTracker=k,R){const i="__is_disposable_tracked__";k(new class{trackDisposable(a){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[i]||console.log(o)},3e3)}setParent(a,o){if(a&&a!==y.None)try{a[i]=!0}catch{}}markAsDisposed(a){if(a&&a!==y.None)try{a[i]=!0}catch{}}markAsSingleton(a){}})}function C(i){return T?.trackDisposable(i),i}function S(i){T?.markAsDisposed(i)}function E(i,a){T?.setParent(i,a)}function n(i,a){if(!!T)for(const o of i)T.setParent(o,a)}function I(i){return T?.markAsSingleton(i),i}e.markAsSingleton=I;class g extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=g;function w(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=w;function f(i){if(L.Iterable.is(i)){let a=[];for(const o of i)if(o)try{o.dispose()}catch(u){a.push(u)}if(a.length===1)throw a[0];if(a.length>1)throw new g(a);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=f;function p(...i){const a=d(()=>f(i));return n(i,a),a}e.combinedDisposable=p;function d(i){const a=C({dispose:(0,D.once)(()=>{S(a),i()})});return a}e.toDisposable=d;class b{constructor(){this._toDispose=new Set,this._isDisposed=!1,C(this)}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}clear(){try{f(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return E(a,this),this._isDisposed?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=b,b.DISABLE_DISPOSED_WARNING=!1;class y{constructor(){this._store=new b,C(this),E(this._store,this)}dispose(){S(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=y,y.None=Object.freeze({dispose(){}});class v{constructor(){this._isDisposed=!1,C(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&E(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,S(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&E(a,null),a}}e.MutableDisposable=v;class l{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=l;class c{constructor(){this.references=new Map}acquire(a,...o){let u=this.references.get(a);u||(u={counter:0,object:this.createReferencedObject(a,...o)},this.references.set(a,u));const{object:h}=u,m=(0,D.once)(()=>{--u.counter==0&&(this.destroyReferencedObject(a,u.object),this.references.delete(a))});return u.counter++,{object:h,dispose:m}}}e.ReferenceCollection=c;class t{constructor(a){this.referenceCollection=a}async acquire(a,...o){const u=this.referenceCollection.acquire(a,...o);try{return{object:await u.object,dispose:()=>u.dispose()}}catch(h){throw u.dispose(),h}}}e.AsyncReferenceCollection=t;class s{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=s;function r(i){const a=new b;try{i(a)}finally{a.dispose()}}e.disposeOnReturn=r}),define(te[100],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(T){this.element=T,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class L{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let T=this._first;for(;T!==D.Undefined;){const k=T.next;T.prev=D.Undefined,T.next=D.Undefined,T=k}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,k){const C=new D(T);if(this._first===D.Undefined)this._first=C,this._last=C;else if(k){const E=this._last;this._last=C,C.prev=E,E.next=C}else{const E=this._first;this._first=C,C.next=E,E.prev=C}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(C))}}shift(){if(this._first!==D.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==D.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==D.Undefined&&T.next!==D.Undefined){const k=T.prev;k.next=T.next,T.next.prev=k}else T.prev===D.Undefined&&T.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):T.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):T.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==D.Undefined;)yield T.element,T=T.next}}e.LinkedList=L}),function(){function J(R){const T=[];typeof R=="number"&&T.push("code/timeOrigin",R);function k(S){T.push(S,Date.now())}function C(){const S=[];for(let E=0;E<T.length;E+=2)S.push({name:T[E],startTime:T[E+1]});return S}return{mark:k,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const k of performance.getEntriesByType("mark"))T.push({name:k.name,startTime:Math.round(R+k.startTime)});return T}};if(typeof process=="object"){const R=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function D(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=D(L))}(),define(te[4],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const D="en";let L=!1,R=!1,T=!1,k=!1,C=!1,S=!1,E=!1,n,I=D,g,w;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?f=e.globals.vscode.process:typeof process!="undefined"&&(f=process);const p=typeof f?.versions?.electron=="string"&&f.type==="renderer";if(e.isElectronSandboxed=p&&f?.sandboxed,typeof navigator=="object"&&!p)w=navigator.userAgent,L=w.indexOf("Windows")>=0,R=w.indexOf("Macintosh")>=0,E=(w.indexOf("Macintosh")>=0||w.indexOf("iPad")>=0||w.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,T=w.indexOf("Linux")>=0,S=!0,n=navigator.language,I=n;else if(typeof f=="object"){L=f.platform==="win32",R=f.platform==="darwin",T=f.platform==="linux",k=T&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,n=D,I=D;const r=f.env.VSCODE_NLS_CONFIG;if(r)try{const i=JSON.parse(r),a=i.availableLanguages["*"];n=i.locale,I=a||D,g=i._translationsConfigFile}catch(i){}C=!0}else console.error("Unable to resolve platform.");var d;(function(r){r[r.Web=0]="Web",r[r.Mac=1]="Mac",r[r.Linux=2]="Linux",r[r.Windows=3]="Windows"})(d=e.Platform||(e.Platform={}));function b(r){switch(r){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let y=0;R?y=1:L?y=3:T&&(y=2),e.isWindows=L,e.isMacintosh=R,e.isLinux=T,e.isLinuxSnap=k,e.isNative=C,e.isWeb=S,e.isIOS=E,e.platform=y,e.userAgent=w,e.language=I;var v;(function(r){function i(){return e.language}r.value=i;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}r.isDefaultVariant=a;function o(){return e.language==="en"}r.isDefault=o})(v=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=g,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let a=[];e.globals.addEventListener("message",u=>{if(u.data&&u.data.vscodeSetImmediateId)for(let h=0,m=a.length;h<m;h++){const A=a[h];if(A.id===u.data.vscodeSetImmediateId){a.splice(h,1),A.callback();return}}});let o=0;return u=>{const h=++o;a.push({id:h,callback:u}),e.globals.postMessage({vscodeSetImmediateId:h},"*")}}if(typeof f?.nextTick=="function")return f.nextTick.bind(f);const i=Promise.resolve();return a=>i.then(a)}();var l;(function(r){r[r.Windows=1]="Windows",r[r.Macintosh=2]="Macintosh",r[r.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||E?2:L?1:3;let c=!0,t=!1;function s(){if(!t){t=!0;const r=new Uint8Array(2);r[0]=1,r[1]=2,c=new Uint16Array(r.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=s}),define(te[31],ne([0,1,4]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const R=D.globals.vscode.process;L={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()},nextTick(T){return(0,D.setImmediate)(T)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(R){return process.nextTick(R)}}:L={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},nextTick(R){return(0,D.setImmediate)(R)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(te[8],ne([0,1,31]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,R=97,T=90,k=122,C=46,S=47,E=92,n=58,I=63;class g extends Error{constructor(l,c,t){let s;typeof c=="string"&&c.indexOf("not ")===0?(s="must not be",c=c.replace(/^not /,"")):s="must be";const r=l.indexOf(".")!==-1?"property":"argument";let i=`The "${l}" ${r} ${s} of type ${c}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function w(v,l){if(typeof v!="string")throw new g(l,"string",v)}function f(v){return v===S||v===E}function p(v){return v===S}function d(v){return v>=L&&v<=T||v>=R&&v<=k}function b(v,l,c,t){let s="",r=0,i=-1,a=0,o=0;for(let u=0;u<=v.length;++u){if(u<v.length)o=v.charCodeAt(u);else{if(t(o))break;o=S}if(t(o)){if(!(i===u-1||a===1))if(a===2){if(s.length<2||r!==2||s.charCodeAt(s.length-1)!==C||s.charCodeAt(s.length-2)!==C){if(s.length>2){const h=s.lastIndexOf(c);h===-1?(s="",r=0):(s=s.slice(0,h),r=s.length-1-s.lastIndexOf(c)),i=u,a=0;continue}else if(s.length!==0){s="",r=0,i=u,a=0;continue}}l&&(s+=s.length>0?`${c}..`:"..",r=2)}else s.length>0?s+=`${c}${v.slice(i+1,u)}`:s=v.slice(i+1,u),r=u-i-1;i=u,a=0}else o===C&&a!==-1?++a:a=-1}return s}function y(v,l){if(l===null||typeof l!="object")throw new g("pathObject","Object",l);const c=l.dir||l.root,t=l.base||`${l.name||""}${l.ext||""}`;return c?c===l.root?`${c}${t}`:`${c}${v}${t}`:t}e.win32={resolve(...v){let l="",c="",t=!1;for(let s=v.length-1;s>=-1;s--){let r;if(s>=0){if(r=v[s],w(r,"path"),r.length===0)continue}else l.length===0?r=D.cwd():(r=D.env[`=${l}`]||D.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==l.toLowerCase()&&r.charCodeAt(2)===E)&&(r=`${l}\\`));const i=r.length;let a=0,o="",u=!1;const h=r.charCodeAt(0);if(i===1)f(h)&&(a=1,u=!0);else if(f(h))if(u=!0,f(r.charCodeAt(1))){let m=2,A=m;for(;m<i&&!f(r.charCodeAt(m));)m++;if(m<i&&m!==A){const _=r.slice(A,m);for(A=m;m<i&&f(r.charCodeAt(m));)m++;if(m<i&&m!==A){for(A=m;m<i&&!f(r.charCodeAt(m));)m++;(m===i||m!==A)&&(o=`\\\\${_}\\${r.slice(A,m)}`,a=m)}}}else a=1;else d(h)&&r.charCodeAt(1)===n&&(o=r.slice(0,2),a=2,i>2&&f(r.charCodeAt(2))&&(u=!0,a=3));if(o.length>0)if(l.length>0){if(o.toLowerCase()!==l.toLowerCase())continue}else l=o;if(t){if(l.length>0)break}else if(c=`${r.slice(a)}\\${c}`,t=u,u&&l.length>0)break}return c=b(c,!t,"\\",f),t?`${l}\\${c}`:`${l}${c}`||"."},normalize(v){w(v,"path");const l=v.length;if(l===0)return".";let c=0,t,s=!1;const r=v.charCodeAt(0);if(l===1)return p(r)?"\\":v;if(f(r))if(s=!0,f(v.charCodeAt(1))){let a=2,o=a;for(;a<l&&!f(v.charCodeAt(a));)a++;if(a<l&&a!==o){const u=v.slice(o,a);for(o=a;a<l&&f(v.charCodeAt(a));)a++;if(a<l&&a!==o){for(o=a;a<l&&!f(v.charCodeAt(a));)a++;if(a===l)return`\\\\${u}\\${v.slice(o)}\\`;a!==o&&(t=`\\\\${u}\\${v.slice(o,a)}`,c=a)}}}else c=1;else d(r)&&v.charCodeAt(1)===n&&(t=v.slice(0,2),c=2,l>2&&f(v.charCodeAt(2))&&(s=!0,c=3));let i=c<l?b(v.slice(c),!s,"\\",f):"";return i.length===0&&!s&&(i="."),i.length>0&&f(v.charCodeAt(l-1))&&(i+="\\"),t===void 0?s?`\\${i}`:i:s?`${t}\\${i}`:`${t}${i}`},isAbsolute(v){w(v,"path");const l=v.length;if(l===0)return!1;const c=v.charCodeAt(0);return f(c)||l>2&&d(c)&&v.charCodeAt(1)===n&&f(v.charCodeAt(2))},join(...v){if(v.length===0)return".";let l,c;for(let r=0;r<v.length;++r){const i=v[r];w(i,"path"),i.length>0&&(l===void 0?l=c=i:l+=`\\${i}`)}if(l===void 0)return".";let t=!0,s=0;if(typeof c=="string"&&f(c.charCodeAt(0))){++s;const r=c.length;r>1&&f(c.charCodeAt(1))&&(++s,r>2&&(f(c.charCodeAt(2))?++s:t=!1))}if(t){for(;s<l.length&&f(l.charCodeAt(s));)s++;s>=2&&(l=`\\${l.slice(s)}`)}return e.win32.normalize(l)},relative(v,l){if(w(v,"from"),w(l,"to"),v===l)return"";const c=e.win32.resolve(v),t=e.win32.resolve(l);if(c===t||(v=c.toLowerCase(),l=t.toLowerCase(),v===l))return"";let s=0;for(;s<v.length&&v.charCodeAt(s)===E;)s++;let r=v.length;for(;r-1>s&&v.charCodeAt(r-1)===E;)r--;const i=r-s;let a=0;for(;a<l.length&&l.charCodeAt(a)===E;)a++;let o=l.length;for(;o-1>a&&l.charCodeAt(o-1)===E;)o--;const u=o-a,h=i<u?i:u;let m=-1,A=0;for(;A<h;A++){const O=v.charCodeAt(s+A);if(O!==l.charCodeAt(a+A))break;O===E&&(m=A)}if(A!==h){if(m===-1)return t}else{if(u>h){if(l.charCodeAt(a+A)===E)return t.slice(a+A+1);if(A===2)return t.slice(a+A)}i>h&&(v.charCodeAt(s+A)===E?m=A:A===2&&(m=3)),m===-1&&(m=0)}let _="";for(A=s+m+1;A<=r;++A)(A===r||v.charCodeAt(A)===E)&&(_+=_.length===0?"..":"\\..");return a+=m,_.length>0?`${_}${t.slice(a,o)}`:(t.charCodeAt(a)===E&&++a,t.slice(a,o))},toNamespacedPath(v){if(typeof v!="string")return v;if(v.length===0)return"";const l=e.win32.resolve(v);if(l.length<=2)return v;if(l.charCodeAt(0)===E){if(l.charCodeAt(1)===E){const c=l.charCodeAt(2);if(c!==I&&c!==C)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(d(l.charCodeAt(0))&&l.charCodeAt(1)===n&&l.charCodeAt(2)===E)return`\\\\?\\${l}`;return v},dirname(v){w(v,"path");const l=v.length;if(l===0)return".";let c=-1,t=0;const s=v.charCodeAt(0);if(l===1)return f(s)?v:".";if(f(s)){if(c=t=1,f(v.charCodeAt(1))){let a=2,o=a;for(;a<l&&!f(v.charCodeAt(a));)a++;if(a<l&&a!==o){for(o=a;a<l&&f(v.charCodeAt(a));)a++;if(a<l&&a!==o){for(o=a;a<l&&!f(v.charCodeAt(a));)a++;if(a===l)return v;a!==o&&(c=t=a+1)}}}}else d(s)&&v.charCodeAt(1)===n&&(c=l>2&&f(v.charCodeAt(2))?3:2,t=c);let r=-1,i=!0;for(let a=l-1;a>=t;--a)if(f(v.charCodeAt(a))){if(!i){r=a;break}}else i=!1;if(r===-1){if(c===-1)return".";r=c}return v.slice(0,r)},basename(v,l){l!==void 0&&w(l,"ext"),w(v,"path");let c=0,t=-1,s=!0,r;if(v.length>=2&&d(v.charCodeAt(0))&&v.charCodeAt(1)===n&&(c=2),l!==void 0&&l.length>0&&l.length<=v.length){if(l===v)return"";let i=l.length-1,a=-1;for(r=v.length-1;r>=c;--r){const o=v.charCodeAt(r);if(f(o)){if(!s){c=r+1;break}}else a===-1&&(s=!1,a=r+1),i>=0&&(o===l.charCodeAt(i)?--i==-1&&(t=r):(i=-1,t=a))}return c===t?t=a:t===-1&&(t=v.length),v.slice(c,t)}for(r=v.length-1;r>=c;--r)if(f(v.charCodeAt(r))){if(!s){c=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":v.slice(c,t)},extname(v){w(v,"path");let l=0,c=-1,t=0,s=-1,r=!0,i=0;v.length>=2&&v.charCodeAt(1)===n&&d(v.charCodeAt(0))&&(l=t=2);for(let a=v.length-1;a>=l;--a){const o=v.charCodeAt(a);if(f(o)){if(!r){t=a+1;break}continue}s===-1&&(r=!1,s=a+1),o===C?c===-1?c=a:i!==1&&(i=1):c!==-1&&(i=-1)}return c===-1||s===-1||i===0||i===1&&c===s-1&&c===t+1?"":v.slice(c,s)},format:y.bind(null,"\\"),parse(v){w(v,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return l;const c=v.length;let t=0,s=v.charCodeAt(0);if(c===1)return f(s)?(l.root=l.dir=v,l):(l.base=l.name=v,l);if(f(s)){if(t=1,f(v.charCodeAt(1))){let m=2,A=m;for(;m<c&&!f(v.charCodeAt(m));)m++;if(m<c&&m!==A){for(A=m;m<c&&f(v.charCodeAt(m));)m++;if(m<c&&m!==A){for(A=m;m<c&&!f(v.charCodeAt(m));)m++;m===c?t=m:m!==A&&(t=m+1)}}}}else if(d(s)&&v.charCodeAt(1)===n){if(c<=2)return l.root=l.dir=v,l;if(t=2,f(v.charCodeAt(2))){if(c===3)return l.root=l.dir=v,l;t=3}}t>0&&(l.root=v.slice(0,t));let r=-1,i=t,a=-1,o=!0,u=v.length-1,h=0;for(;u>=t;--u){if(s=v.charCodeAt(u),f(s)){if(!o){i=u+1;break}continue}a===-1&&(o=!1,a=u+1),s===C?r===-1?r=u:h!==1&&(h=1):r!==-1&&(h=-1)}return a!==-1&&(r===-1||h===0||h===1&&r===a-1&&r===i+1?l.base=l.name=v.slice(i,a):(l.name=v.slice(i,r),l.base=v.slice(i,a),l.ext=v.slice(r,a))),i>0&&i!==t?l.dir=v.slice(0,i-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...v){let l="",c=!1;for(let t=v.length-1;t>=-1&&!c;t--){const s=t>=0?v[t]:D.cwd();w(s,"path"),s.length!==0&&(l=`${s}/${l}`,c=s.charCodeAt(0)===S)}return l=b(l,!c,"/",p),c?`/${l}`:l.length>0?l:"."},normalize(v){if(w(v,"path"),v.length===0)return".";const l=v.charCodeAt(0)===S,c=v.charCodeAt(v.length-1)===S;return v=b(v,!l,"/",p),v.length===0?l?"/":c?"./":".":(c&&(v+="/"),l?`/${v}`:v)},isAbsolute(v){return w(v,"path"),v.length>0&&v.charCodeAt(0)===S},join(...v){if(v.length===0)return".";let l;for(let c=0;c<v.length;++c){const t=v[c];w(t,"path"),t.length>0&&(l===void 0?l=t:l+=`/${t}`)}return l===void 0?".":e.posix.normalize(l)},relative(v,l){if(w(v,"from"),w(l,"to"),v===l||(v=e.posix.resolve(v),l=e.posix.resolve(l),v===l))return"";const c=1,t=v.length,s=t-c,r=1,i=l.length-r,a=s<i?s:i;let o=-1,u=0;for(;u<a;u++){const m=v.charCodeAt(c+u);if(m!==l.charCodeAt(r+u))break;m===S&&(o=u)}if(u===a)if(i>a){if(l.charCodeAt(r+u)===S)return l.slice(r+u+1);if(u===0)return l.slice(r+u)}else s>a&&(v.charCodeAt(c+u)===S?o=u:u===0&&(o=0));let h="";for(u=c+o+1;u<=t;++u)(u===t||v.charCodeAt(u)===S)&&(h+=h.length===0?"..":"/..");return`${h}${l.slice(r+o)}`},toNamespacedPath(v){return v},dirname(v){if(w(v,"path"),v.length===0)return".";const l=v.charCodeAt(0)===S;let c=-1,t=!0;for(let s=v.length-1;s>=1;--s)if(v.charCodeAt(s)===S){if(!t){c=s;break}}else t=!1;return c===-1?l?"/":".":l&&c===1?"//":v.slice(0,c)},basename(v,l){l!==void 0&&w(l,"ext"),w(v,"path");let c=0,t=-1,s=!0,r;if(l!==void 0&&l.length>0&&l.length<=v.length){if(l===v)return"";let i=l.length-1,a=-1;for(r=v.length-1;r>=0;--r){const o=v.charCodeAt(r);if(o===S){if(!s){c=r+1;break}}else a===-1&&(s=!1,a=r+1),i>=0&&(o===l.charCodeAt(i)?--i==-1&&(t=r):(i=-1,t=a))}return c===t?t=a:t===-1&&(t=v.length),v.slice(c,t)}for(r=v.length-1;r>=0;--r)if(v.charCodeAt(r)===S){if(!s){c=r+1;break}}else t===-1&&(s=!1,t=r+1);return t===-1?"":v.slice(c,t)},extname(v){w(v,"path");let l=-1,c=0,t=-1,s=!0,r=0;for(let i=v.length-1;i>=0;--i){const a=v.charCodeAt(i);if(a===S){if(!s){c=i+1;break}continue}t===-1&&(s=!1,t=i+1),a===C?l===-1?l=i:r!==1&&(r=1):l!==-1&&(r=-1)}return l===-1||t===-1||r===0||r===1&&l===t-1&&l===c+1?"":v.slice(l,t)},format:y.bind(null,"/"),parse(v){w(v,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(v.length===0)return l;const c=v.charCodeAt(0)===S;let t;c?(l.root="/",t=1):t=0;let s=-1,r=0,i=-1,a=!0,o=v.length-1,u=0;for(;o>=t;--o){const h=v.charCodeAt(o);if(h===S){if(!a){r=o+1;break}continue}i===-1&&(a=!1,i=o+1),h===C?s===-1?s=o:u!==1&&(u=1):s!==-1&&(u=-1)}if(i!==-1){const h=r===0&&c?1:r;s===-1||u===0||u===1&&s===i-1&&s===r+1?l.base=l.name=v.slice(h,i):(l.name=v.slice(h,s),l.base=v.slice(h,i),l.ext=v.slice(s,i))}return r>0?l.dir=v.slice(0,r-1):c&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[101],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var D;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(D=e.Source||(e.Source={}));var L;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(T,...k){const C=k.reduce((n,I)=>(n[I]=!0,n),{}),S=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(n=>!C[n]).forEach(n=>{for(let I=0;I<S.length;I++)if(n.search(S[I])!==-1){delete T[n];break}})}e.sanitizeProcessEnvironment=R}),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var L in D)(typeof exports=="object"?exports:J)[L]=D[L]}}(typeof self!="undefined"?self:this,function(){return function(J){var e={};function D(L){if(e[L])return e[L].exports;var R=e[L]={i:L,l:!1,exports:{}};return J[L].call(R.exports,R,R.exports,D),R.l=!0,R.exports}return D.m=J,D.c=e,D.d=function(L,R,T){D.o(L,R)||Object.defineProperty(L,R,{enumerable:!0,get:T})},D.r=function(L){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},D.t=function(L,R){if(1&R&&(L=D(L)),8&R||4&R&&typeof L=="object"&&L&&L.__esModule)return L;var T=Object.create(null);if(D.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:L}),2&R&&typeof L!="string")for(var k in L)D.d(T,k,function(C){return L[C]}.bind(null,k));return T},D.n=function(L){var R=L&&L.__esModule?function(){return L.default}:function(){return L};return D.d(R,"a",R),R},D.o=function(L,R){return Object.prototype.hasOwnProperty.call(L,R)},D.p="",D(D.s=0)}([function(J,e,D){(function(L){var R;e=J.exports=Z,R=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],S=e.src=[],E=0,n=E++;S[n]="0|[1-9]\\d*";var I=E++;S[I]="[0-9]+";var g=E++;S[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=E++;S[w]="("+S[n]+")\\.("+S[n]+")\\.("+S[n]+")";var f=E++;S[f]="("+S[I]+")\\.("+S[I]+")\\.("+S[I]+")";var p=E++;S[p]="(?:"+S[n]+"|"+S[g]+")";var d=E++;S[d]="(?:"+S[I]+"|"+S[g]+")";var b=E++;S[b]="(?:-("+S[p]+"(?:\\."+S[p]+")*))";var y=E++;S[y]="(?:-?("+S[d]+"(?:\\."+S[d]+")*))";var v=E++;S[v]="[0-9A-Za-z-]+";var l=E++;S[l]="(?:\\+("+S[v]+"(?:\\."+S[v]+")*))";var c=E++,t="v?"+S[w]+S[b]+"?"+S[l]+"?";S[c]="^"+t+"$";var s="[v=\\s]*"+S[f]+S[y]+"?"+S[l]+"?",r=E++;S[r]="^"+s+"$";var i=E++;S[i]="((?:<|>)?=?)";var a=E++;S[a]=S[I]+"|x|X|\\*";var o=E++;S[o]=S[n]+"|x|X|\\*";var u=E++;S[u]="[v=\\s]*("+S[o]+")(?:\\.("+S[o]+")(?:\\.("+S[o]+")(?:"+S[b]+")?"+S[l]+"?)?)?";var h=E++;S[h]="[v=\\s]*("+S[a]+")(?:\\.("+S[a]+")(?:\\.("+S[a]+")(?:"+S[y]+")?"+S[l]+"?)?)?";var m=E++;S[m]="^"+S[i]+"\\s*"+S[u]+"$";var A=E++;S[A]="^"+S[i]+"\\s*"+S[h]+"$";var _=E++;S[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=E++;S[O]="(?:~>?)";var N=E++;S[N]="(\\s*)"+S[O]+"\\s+",C[N]=new RegExp(S[N],"g");var P=E++;S[P]="^"+S[O]+S[u]+"$";var M=E++;S[M]="^"+S[O]+S[h]+"$";var $=E++;S[$]="(?:\\^)";var U=E++;S[U]="(\\s*)"+S[$]+"\\s+",C[U]=new RegExp(S[U],"g");var H=E++;S[H]="^"+S[$]+S[u]+"$";var W=E++;S[W]="^"+S[$]+S[h]+"$";var q=E++;S[q]="^"+S[i]+"\\s*("+s+")$|^$";var x=E++;S[x]="^"+S[i]+"\\s*("+t+")$|^$";var F=E++;S[F]="(\\s*)"+S[i]+"\\s*("+s+"|"+S[u]+")",C[F]=new RegExp(S[F],"g");var K=E++;S[K]="^\\s*("+S[u]+")\\s+-\\s+("+S[u]+")\\s*$";var j=E++;S[j]="^\\s*("+S[h]+")\\s+-\\s+("+S[h]+")\\s*$";var z=E++;S[z]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)R(B,S[B]),C[B]||(C[B]=new RegExp(S[B]));function X(ee,oe){if(ee instanceof Z)return ee;if(typeof ee!="string"||ee.length>T||!(oe?C[r]:C[c]).test(ee))return null;try{return new Z(ee,oe)}catch(ce){return null}}function Z(ee,oe){if(ee instanceof Z){if(ee.loose===oe)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof Z))return new Z(ee,oe);R("SemVer",ee,oe),this.loose=oe;var ce=ee.trim().match(oe?C[r]:C[c]);if(!ce)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+ce[1],this.minor=+ce[2],this.patch=+ce[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");ce[4]?this.prerelease=ce[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var pe=+ye;if(pe>=0&&pe<k)return pe}return ye}):this.prerelease=[],this.build=ce[5]?ce[5].split("."):[],this.format()}e.parse=X,e.valid=function(ee,oe){var ce=X(ee,oe);return ce?ce.version:null},e.clean=function(ee,oe){var ce=X(ee.trim().replace(/^[=v]+/,""),oe);return ce?ce.version:null},e.SemVer=Z,Z.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Z.prototype.toString=function(){return this.version},Z.prototype.compare=function(ee){return R("SemVer.compare",this.version,this.loose,ee),ee instanceof Z||(ee=new Z(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},Z.prototype.compareMain=function(ee){return ee instanceof Z||(ee=new Z(ee,this.loose)),G(this.major,ee.major)||G(this.minor,ee.minor)||G(this.patch,ee.patch)},Z.prototype.comparePre=function(ee){if(ee instanceof Z||(ee=new Z(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var oe=0;do{var ce=this.prerelease[oe],ye=ee.prerelease[oe];if(R("prerelease compare",oe,ce,ye),ce===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(ce===void 0)return-1;if(ce!==ye)return G(ce,ye)}while(++oe)},Z.prototype.inc=function(ee,oe){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",oe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",oe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",oe),this.inc("pre",oe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",oe),this.inc("pre",oe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ce=this.prerelease.length;--ce>=0;)typeof this.prerelease[ce]=="number"&&(this.prerelease[ce]++,ce=-2);ce===-1&&this.prerelease.push(0)}oe&&(this.prerelease[0]===oe?isNaN(this.prerelease[1])&&(this.prerelease=[oe,0]):this.prerelease=[oe,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,oe,ce,ye){typeof ce=="string"&&(ye=ce,ce=void 0);try{return new Z(ee,ce).inc(oe,ye).version}catch(pe){return null}},e.diff=function(ee,oe){if(ue(ee,oe))return null;var ce=X(ee),ye=X(oe);if(ce.prerelease.length||ye.prerelease.length){for(var pe in ce)if((pe==="major"||pe==="minor"||pe==="patch")&&ce[pe]!==ye[pe])return"pre"+pe;return"prerelease"}for(var pe in ce)if((pe==="major"||pe==="minor"||pe==="patch")&&ce[pe]!==ye[pe])return pe},e.compareIdentifiers=G;var V=/^[0-9]+$/;function G(ee,oe){var ce=V.test(ee),ye=V.test(oe);return ce&&ye&&(ee=+ee,oe=+oe),ce&&!ye?-1:ye&&!ce?1:ee<oe?-1:ee>oe?1:0}function ie(ee,oe,ce){return new Z(ee,ce).compare(new Z(oe,ce))}function re(ee,oe,ce){return ie(ee,oe,ce)>0}function ae(ee,oe,ce){return ie(ee,oe,ce)<0}function ue(ee,oe,ce){return ie(ee,oe,ce)===0}function fe(ee,oe,ce){return ie(ee,oe,ce)!==0}function de(ee,oe,ce){return ie(ee,oe,ce)>=0}function Ie(ee,oe,ce){return ie(ee,oe,ce)<=0}function Ce(ee,oe,ce,ye){var pe;switch(oe){case"===":typeof ee=="object"&&(ee=ee.version),typeof ce=="object"&&(ce=ce.version),pe=ee===ce;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof ce=="object"&&(ce=ce.version),pe=ee!==ce;break;case"":case"=":case"==":pe=ue(ee,ce,ye);break;case"!=":pe=fe(ee,ce,ye);break;case">":pe=re(ee,ce,ye);break;case">=":pe=de(ee,ce,ye);break;case"<":pe=ae(ee,ce,ye);break;case"<=":pe=Ie(ee,ce,ye);break;default:throw new TypeError("Invalid operator: "+oe)}return pe}function Ee(ee,oe){if(ee instanceof Ee){if(ee.loose===oe)return ee;ee=ee.value}if(!(this instanceof Ee))return new Ee(ee,oe);R("comparator",ee,oe),this.loose=oe,this.parse(ee),this.semver===_e?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(ee,oe){return G(oe,ee)},e.major=function(ee,oe){return new Z(ee,oe).major},e.minor=function(ee,oe){return new Z(ee,oe).minor},e.patch=function(ee,oe){return new Z(ee,oe).patch},e.compare=ie,e.compareLoose=function(ee,oe){return ie(ee,oe,!0)},e.rcompare=function(ee,oe,ce){return ie(oe,ee,ce)},e.sort=function(ee,oe){return ee.sort(function(ce,ye){return e.compare(ce,ye,oe)})},e.rsort=function(ee,oe){return ee.sort(function(ce,ye){return e.rcompare(ce,ye,oe)})},e.gt=re,e.lt=ae,e.eq=ue,e.neq=fe,e.gte=de,e.lte=Ie,e.cmp=Ce,e.Comparator=Ee;var _e={};function Pe(ee,oe){if(ee instanceof Pe)return ee.loose===oe?ee:new Pe(ee.raw,oe);if(ee instanceof Ee)return new Pe(ee.value,oe);if(!(this instanceof Pe))return new Pe(ee,oe);if(this.loose=oe,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(ce){return this.parseRange(ce.trim())},this).filter(function(ce){return ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function ke(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Fe(ee,oe,ce,ye,pe,Oe,De,Y,se,le,ge,me,be){return((oe=ke(ce)?"":ke(ye)?">="+ce+".0.0":ke(pe)?">="+ce+"."+ye+".0":">="+oe)+" "+(Y=ke(se)?"":ke(le)?"<"+(+se+1)+".0.0":ke(ge)?"<"+se+"."+(+le+1)+".0":me?"<="+se+"."+le+"."+ge+"-"+me:"<="+Y)).trim()}function $e(ee,oe){for(var ce=0;ce<ee.length;ce++)if(!ee[ce].test(oe))return!1;if(oe.prerelease.length){for(ce=0;ce<ee.length;ce++)if(R(ee[ce].semver),ee[ce].semver!==_e&&ee[ce].semver.prerelease.length>0){var ye=ee[ce].semver;if(ye.major===oe.major&&ye.minor===oe.minor&&ye.patch===oe.patch)return!0}return!1}return!0}function Ne(ee,oe,ce){try{oe=new Pe(oe,ce)}catch(ye){return!1}return oe.test(ee)}function qe(ee,oe,ce,ye){var pe,Oe,De,Y,se;switch(ee=new Z(ee,ye),oe=new Pe(oe,ye),ce){case">":pe=re,Oe=Ie,De=ae,Y=">",se=">=";break;case"<":pe=ae,Oe=de,De=re,Y="<",se="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ne(ee,oe,ye))return!1;for(var le=0;le<oe.set.length;++le){var ge=oe.set[le],me=null,be=null;if(ge.forEach(function(Te){Te.semver===_e&&(Te=new Ee(">=0.0.0")),me=me||Te,be=be||Te,pe(Te.semver,me.semver,ye)?me=Te:De(Te.semver,be.semver,ye)&&(be=Te)}),me.operator===Y||me.operator===se||(!be.operator||be.operator===Y)&&Oe(ee,be.semver)||be.operator===se&&De(ee,be.semver))return!1}return!0}Ee.prototype.parse=function(ee){var oe=this.loose?C[q]:C[x],ce=ee.match(oe);if(!ce)throw new TypeError("Invalid comparator: "+ee);this.operator=ce[1],this.operator==="="&&(this.operator=""),ce[2]?this.semver=new Z(ce[2],this.loose):this.semver=_e},Ee.prototype.toString=function(){return this.value},Ee.prototype.test=function(ee){return R("Comparator.test",ee,this.loose),this.semver===_e||(typeof ee=="string"&&(ee=new Z(ee,this.loose)),Ce(ee,this.operator,this.semver,this.loose))},Ee.prototype.intersects=function(ee,oe){if(!(ee instanceof Ee))throw new TypeError("a Comparator is required");var ce;if(this.operator==="")return ce=new Pe(ee.value,oe),Ne(this.value,ce,oe);if(ee.operator==="")return ce=new Pe(this.value,oe),Ne(ee.semver,ce,oe);var ye=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),pe=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),Oe=this.semver.version===ee.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Y=Ce(this.semver,"<",ee.semver,oe)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),se=Ce(this.semver,">",ee.semver,oe)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return ye||pe||Oe&&De||Y||se},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(ee){var oe=this.loose;ee=ee.trim(),R("range",ee,oe);var ce=oe?C[j]:C[K];ee=ee.replace(ce,Fe),R("hyphen replace",ee),ee=ee.replace(C[F],"$1$2$3"),R("comparator trim",ee,C[F]),ee=(ee=(ee=ee.replace(C[N],"$1~")).replace(C[U],"$1^")).split(/\s+/).join(" ");var ye=oe?C[q]:C[x],pe=ee.split(" ").map(function(Oe){return function(De,Y){return R("comp",De),De=function(se,le){return se.trim().split(/\s+/).map(function(ge){return function(me,be){R("caret",me,be);var Te=be?C[W]:C[H];return me.replace(Te,function(Le,Se,we,Re,Ae){var Ue;return R("caret",me,Le,Se,we,Re,Ae),ke(Se)?Ue="":ke(we)?Ue=">="+Se+".0.0 <"+(+Se+1)+".0.0":ke(Re)?Ue=Se==="0"?">="+Se+"."+we+".0 <"+Se+"."+(+we+1)+".0":">="+Se+"."+we+".0 <"+(+Se+1)+".0.0":Ae?(R("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Ue=Se==="0"?we==="0"?">="+Se+"."+we+"."+Re+Ae+" <"+Se+"."+we+"."+(+Re+1):">="+Se+"."+we+"."+Re+Ae+" <"+Se+"."+(+we+1)+".0":">="+Se+"."+we+"."+Re+Ae+" <"+(+Se+1)+".0.0"):(R("no pr"),Ue=Se==="0"?we==="0"?">="+Se+"."+we+"."+Re+" <"+Se+"."+we+"."+(+Re+1):">="+Se+"."+we+"."+Re+" <"+Se+"."+(+we+1)+".0":">="+Se+"."+we+"."+Re+" <"+(+Se+1)+".0.0"),R("caret return",Ue),Ue})}(ge,le)}).join(" ")}(De,Y),R("caret",De),De=function(se,le){return se.trim().split(/\s+/).map(function(ge){return function(me,be){var Te=be?C[M]:C[P];return me.replace(Te,function(Le,Se,we,Re,Ae){var Ue;return R("tilde",me,Le,Se,we,Re,Ae),ke(Se)?Ue="":ke(we)?Ue=">="+Se+".0.0 <"+(+Se+1)+".0.0":ke(Re)?Ue=">="+Se+"."+we+".0 <"+Se+"."+(+we+1)+".0":Ae?(R("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Ue=">="+Se+"."+we+"."+Re+Ae+" <"+Se+"."+(+we+1)+".0"):Ue=">="+Se+"."+we+"."+Re+" <"+Se+"."+(+we+1)+".0",R("tilde return",Ue),Ue})}(ge,le)}).join(" ")}(De,Y),R("tildes",De),De=function(se,le){return R("replaceXRanges",se,le),se.split(/\s+/).map(function(ge){return function(me,be){me=me.trim();var Te=be?C[A]:C[m];return me.replace(Te,function(Le,Se,we,Re,Ae,Ue){R("xRange",me,Le,Se,we,Re,Ae,Ue);var it=ke(we),Ge=it||ke(Re),je=Ge||ke(Ae);return Se==="="&&je&&(Se=""),it?Le=Se===">"||Se==="<"?"<0.0.0":"*":Se&&je?(Ge&&(Re=0),je&&(Ae=0),Se===">"?(Se=">=",Ge?(we=+we+1,Re=0,Ae=0):je&&(Re=+Re+1,Ae=0)):Se==="<="&&(Se="<",Ge?we=+we+1:Re=+Re+1),Le=Se+we+"."+Re+"."+Ae):Ge?Le=">="+we+".0.0 <"+(+we+1)+".0.0":je&&(Le=">="+we+"."+Re+".0 <"+we+"."+(+Re+1)+".0"),R("xRange return",Le),Le})}(ge,le)}).join(" ")}(De,Y),R("xrange",De),De=function(se,le){return R("replaceStars",se,le),se.trim().replace(C[z],"")}(De,Y),R("stars",De),De}(Oe,oe)}).join(" ").split(/\s+/);return this.loose&&(pe=pe.filter(function(Oe){return!!Oe.match(ye)})),pe=pe.map(function(Oe){return new Ee(Oe,oe)})},Pe.prototype.intersects=function(ee,oe){if(!(ee instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(ce){return ce.every(function(ye){return ee.set.some(function(pe){return pe.every(function(Oe){return ye.intersects(Oe,oe)})})})})},e.toComparators=function(ee,oe){return new Pe(ee,oe).set.map(function(ce){return ce.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new Z(ee,this.loose));for(var oe=0;oe<this.set.length;oe++)if($e(this.set[oe],ee))return!0;return!1},e.satisfies=Ne,e.maxSatisfying=function(ee,oe,ce){var ye=null,pe=null;try{var Oe=new Pe(oe,ce)}catch(De){return null}return ee.forEach(function(De){Oe.test(De)&&(ye&&pe.compare(De)!==-1||(pe=new Z(ye=De,ce)))}),ye},e.minSatisfying=function(ee,oe,ce){var ye=null,pe=null;try{var Oe=new Pe(oe,ce)}catch(De){return null}return ee.forEach(function(De){Oe.test(De)&&(ye&&pe.compare(De)!==1||(pe=new Z(ye=De,ce)))}),ye},e.validRange=function(ee,oe){try{return new Pe(ee,oe).range||"*"}catch(ce){return null}},e.ltr=function(ee,oe,ce){return qe(ee,oe,"<",ce)},e.gtr=function(ee,oe,ce){return qe(ee,oe,">",ce)},e.outside=qe,e.prerelease=function(ee,oe){var ce=X(ee,oe);return ce&&ce.prerelease.length?ce.prerelease:null},e.intersects=function(ee,oe,ce){return ee=new Pe(ee,ce),oe=new Pe(oe,ce),ee.intersects(oe)},e.coerce=function(ee){if(ee instanceof Z)return ee;if(typeof ee!="string")return null;var oe=ee.match(C[_]);return oe==null?null:X((oe[1]||"0")+"."+(oe[2]||"0")+"."+(oe[3]||"0"))}}).call(this,D(1))},function(J,e){var D,L,R=J.exports={};function T(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function C(d){if(D===setTimeout)return setTimeout(d,0);if((D===T||!D)&&setTimeout)return D=setTimeout,setTimeout(d,0);try{return D(d,0)}catch(b){try{return D.call(null,d,0)}catch(y){return D.call(this,d,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:T}catch(d){D=T}try{L=typeof clearTimeout=="function"?clearTimeout:k}catch(d){L=k}})();var S,E=[],n=!1,I=-1;function g(){n&&S&&(n=!1,S.length?E=S.concat(E):I=-1,E.length&&w())}function w(){if(!n){var d=C(g);n=!0;for(var b=E.length;b;){for(S=E,E=[];++I<b;)S&&S[I].run();I=-1,b=E.length}S=null,n=!1,function(y){if(L===clearTimeout)return clearTimeout(y);if((L===k||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(y);try{L(y)}catch(v){try{return L.call(null,y)}catch(l){return L.call(this,y)}}}(d)}}function f(d,b){this.fun=d,this.array=b}function p(){}R.nextTick=function(d){var b=new Array(arguments.length-1);if(arguments.length>1)for(var y=1;y<arguments.length;y++)b[y-1]=arguments[y];E.push(new f(d,b)),E.length!==1||n||C(w)},f.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=p,R.addListener=p,R.once=p,R.off=p,R.removeListener=p,R.removeAllListeners=p,R.emit=p,R.prependListener=p,R.prependOnceListener=p,R.listeners=function(d){return[]},R.binding=function(d){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(d){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(te[102],ne([0,1,4]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=D.globals.performance&&typeof D.globals.performance.now=="function";class R{constructor(k){this._highResolution=L&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new R(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=R}),define(te[3],ne([0,1,9,67,2,100,102]),function(J,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(l){l.None=()=>R.Disposable.None;function c(U){return(H,W=null,q)=>{let x=!1,F;return F=U(K=>{if(!x)return F?F.dispose():x=!0,H.call(W,K)},null,q),x&&F.dispose(),F}}l.once=c;function t(U,H){return u((W,q=null,x)=>U(F=>W.call(q,H(F)),null,x))}l.map=t;function s(U,H){return u((W,q=null,x)=>U(F=>{H(F),W.call(q,F)},null,x))}l.forEach=s;function r(U,H){return u((W,q=null,x)=>U(F=>H(F)&&W.call(q,F),null,x))}l.filter=r;function i(U){return U}l.signal=i;function a(...U){return(H,W=null,q)=>(0,R.combinedDisposable)(...U.map(x=>x(F=>H.call(W,F),null,q)))}l.any=a;function o(U,H,W){let q=W;return t(U,x=>(q=H(q,x),q))}l.reduce=o;function u(U){let H;const W=new g({onFirstListenerAdd(){H=U(W.fire,W)},onLastListenerRemove(){H.dispose()}});return W.event}function h(U,H,W=100,q=!1,x){let F,K,j,z=0;const B=new g({leakWarningThreshold:x,onFirstListenerAdd(){F=U(X=>{z++,K=H(K,X),q&&!j&&(B.fire(K),K=void 0),clearTimeout(j),j=setTimeout(()=>{const Z=K;K=void 0,j=void 0,(!q||z>1)&&B.fire(Z),z=0},W)})},onLastListenerRemove(){F.dispose()}});return B.event}l.debounce=h;function m(U,H=(W,q)=>W===q){let W=!0,q;return r(U,x=>{const F=W||!H(x,q);return W=!1,q=x,F})}l.latch=m;function A(U,H){return[l.filter(U,H),l.filter(U,W=>!H(W))]}l.split=A;function _(U,H=!1,W=[]){let q=W.slice(),x=U(j=>{q?q.push(j):K.fire(j)});const F=()=>{q&&q.forEach(j=>K.fire(j)),q=null},K=new g({onFirstListenerAdd(){x||(x=U(j=>K.fire(j)))},onFirstListenerDidAdd(){q&&(H?setTimeout(F):F())},onLastListenerRemove(){x&&x.dispose(),x=null}});return K.event}l.buffer=_;class O{constructor(H){this.event=H}map(H){return new O(t(this.event,H))}forEach(H){return new O(s(this.event,H))}filter(H){return new O(r(this.event,H))}reduce(H,W){return new O(o(this.event,H,W))}latch(){return new O(m(this.event))}debounce(H,W=100,q=!1,x){return new O(h(this.event,H,W,q,x))}on(H,W,q){return this.event(H,W,q)}once(H,W,q){return c(this.event)(H,W,q)}}function N(U){return new O(U)}l.chain=N;function P(U,H,W=q=>q){const q=(...j)=>K.fire(W(...j)),x=()=>U.on(H,q),F=()=>U.removeListener(H,q),K=new g({onFirstListenerAdd:x,onLastListenerRemove:F});return K.event}l.fromNodeEventEmitter=P;function M(U,H,W=q=>q){const q=(...j)=>K.fire(W(...j)),x=()=>U.addEventListener(H,q),F=()=>U.removeEventListener(H,q),K=new g({onFirstListenerAdd:x,onLastListenerRemove:F});return K.event}l.fromDOMEventEmitter=M;function $(U){return new Promise(H=>c(U)(H))}l.toPromise=$})(C=e.Event||(e.Event={}));class S{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${S._idPool++}`}start(c){this._stopWatch=new k.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let E=-1;function n(l){const c=E;return E=l,{dispose(){E=c}}}e.setGlobalLeakWarningThreshold=n;class I{constructor(c,t=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c){let t=E;if(typeof this.customThreshold=="number"&&(t=this.customThreshold),t<=0||c<t)return;this._stacks||(this._stacks=new Map);const s=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(s)||0;if(this._stacks.set(s,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=t*.5;let i,a=0;for(const[o,u]of this._stacks)(!i||a<u)&&(i=o,a=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${a}):`),console.warn(i)}return()=>{const i=this._stacks.get(s)||0;this._stacks.set(s,i-1)}}}class g{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=E>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(c,t,s)=>{this._listeners||(this._listeners=new T.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(t?[c,t]:c);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,t);const a=this._leakageMon?.check(this._listeners.size),o=(0,R.toDisposable)(()=>{a&&a(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return s instanceof R.DisposableStore?s.add(o):Array.isArray(s)&&s.push(o),o}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,c]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,s]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,s):t[0].call(t[1],s)}catch(r){(0,D.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=g;class w extends g{async fireAsync(c,t,s){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,c]);for(;this._asyncDeliveryQueue.size>0&&!t.isCancellationRequested;){const[r,i]=this._asyncDeliveryQueue.shift(),a=[],o={...i,waitUntil:u=>{if(Object.isFrozen(a))throw new Error("waitUntil can NOT be called asynchronous");s&&(u=s(u,typeof r=="function"?r:r[0])),a.push(u)}};try{typeof r=="function"?r.call(void 0,o):r[0].call(r[1],o)}catch(u){(0,D.onUnexpectedError)(u);continue}Object.freeze(a),await Promise.allSettled(a).then(u=>{for(const h of u)h.status==="rejected"&&(0,D.onUnexpectedError)(h.reason)})}}}}e.AsyncEmitter=w;class f extends g{constructor(c){super(c);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=f;class p extends f{constructor(c){super(c);this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=p;class d extends g{constructor(c){super(c);this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(t=>super.fire(t)),this._queuedEvents=[]})}}e.MicrotaskEmitter=d;class b{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const t={event:c,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);const s=()=>{this.hasListeners&&this.unhook(t);const r=this.events.indexOf(t);this.events.splice(r,1)};return(0,R.toDisposable)((0,L.once)(s))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(t=>this.emitter.fire(t))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=b;class y{constructor(){this.buffers=[]}wrapEvent(c){return(t,s,r)=>c(i=>{const a=this.buffers[this.buffers.length-1];a?a.push(()=>t.call(s,i)):t.call(s,i)},void 0,r)}bufferEvents(c){const t=[];this.buffers.push(t);const s=c();return this.buffers.pop(),t.forEach(r=>r()),s}}e.EventBufferer=y;class v{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=R.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=v}),define(te[27],ne([0,1,3]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(C,S){const E=setTimeout(C.bind(S),0);return{dispose(){clearTimeout(E)}}});var R;(function(C){function S(E){return E===C.None||E===C.Cancelled||E instanceof T?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}C.isCancellationToken=S,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(R=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=R.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=R.None}}e.CancellationTokenSource=k}),define(te[49],ne([0,1,3]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new D.Emitter}add(I){const g=this._icons.get(I.id);g?I.description?g.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const R=new L;e.iconRegistry=R;function T(n,I){return new C(n,I)}e.registerCodicon=T;function k(n){return n?n.replace(/\$\((.*?)\)/g,(I,g)=>` ${g} `).trim():""}e.getCodiconAriaLabel=k;class C{constructor(I,g,w){this.id=I,this.definition=g,this.description=w,R.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function S(n,I){const g=["codicon","codicon-"+n];return I&&g.push("codicon-modifier-"+I),g}e.getClassNamesArray=S;var E;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function g(p){if(p instanceof C)return["codicon","codicon-"+p.id];const d=I.exec(p.id);if(!d)return g(C.error);let[,b,y]=d;const v=["codicon","codicon-"+b];return y&&v.push("codicon-modifier-"+y.substr(1)),v}n.asClassNameArray=g;function w(p){return g(p).join(" ")}n.asClassName=w;function f(p){return"."+g(p).join(".")}n.asCSSSelector=f})(E=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",{fontCharacter:"\\eb0f"}),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(te[50],ne([0,1,9,2]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function R(v){const l=v;return l?[l.on,l.pause,l.resume,l.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=R;function T(v){const l=v;return l?R(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=T;function k(v,l){return new C(v,l)}e.newWriteableStream=k;class C{constructor(l,c){this.reducer=l,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(c=>c(l))}emitError(l){this.listeners.error.length===0?(0,D.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(c=>c(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,c){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(l,c){if(this.state.destroyed)return;let t;switch(l){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const s=t.indexOf(c);s>=0&&t.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(v,l){const c=[];let t;for(;(t=v.read())!==null;)c.push(t);return l(c)}e.consumeReadable=S;function E(v,l,c){const t=[];let s;for(;(s=v.read())!==null&&t.length<c;)t.push(s);return s===null&&t.length>0?l(t):{read:()=>{if(t.length>0)return t.shift();if(typeof s!="undefined"){const r=s;return s=void 0,r}return v.read()}}}e.peekReadable=E;function n(v,l){return new Promise((c,t)=>{const s=[];I(v,{onData:r=>{l&&s.push(r)},onError:r=>{l?t(r):c(void 0)},onEnd:()=>{c(l?l(s):void 0)}})})}e.consumeStream=n;function I(v,l){v.on("error",c=>l.onError(c)),v.on("end",()=>l.onEnd()),v.on("data",c=>l.onData(c))}e.listenStream=I;function g(v,l){return new Promise((c,t)=>{const s=new L.DisposableStore,r=[],i=u=>{if(r.push(u),r.length>l)return s.dispose(),v.pause(),c({stream:v,buffer:r,ended:!1})},a=u=>t(u),o=()=>c({stream:v,buffer:r,ended:!0});s.add((0,L.toDisposable)(()=>v.removeListener("error",a))),v.on("error",a),s.add((0,L.toDisposable)(()=>v.removeListener("end",o))),v.on("end",o),s.add((0,L.toDisposable)(()=>v.removeListener("data",i))),v.on("data",i)})}e.peekStream=g;function w(v,l){const c=k(l);return c.end(v),c}e.toStream=w;function f(){const v=k(()=>{throw new Error("not supported")});return v.end(),v}e.emptyStream=f;function p(v){let l=!1;return{read:()=>l?null:(l=!0,v)}}e.toReadable=p;function d(v,l,c){const t=k(c);return I(v,{onData:s=>t.write(l.data(s)),onError:s=>t.error(l.error?l.error(s):s),onEnd:()=>t.end()}),t}e.transform=d;function b(v,l,c){let t=!1;return{read:()=>{const s=l.read();return t?s:(t=!0,s!==null?c([v,s]):v)}}}e.prefixedReadable=b;function y(v,l,c){let t=!1;const s=k(c);return I(l,{onData:r=>t?s.write(r):(t=!0,s.write(c([v,r]))),onError:r=>s.error(r),onEnd:()=>{t||(t=!0,s.write(v)),s.end()}}),s}e.prefixedStream=y}),define(te[22],ne([0,1,50]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let R,T;class k{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return L?new k(Buffer.allocUnsafe(i)):new k(new Uint8Array(i))}static wrap(i){return L&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new k(i)}static fromString(i,a){return!(a?.dontUseNodeBuffer||!1)&&L?new k(Buffer.from(i)):(R||(R=new TextEncoder),new k(R.encode(i)))}static concat(i,a){if(typeof a=="undefined"){a=0;for(let h=0,m=i.length;h<m;h++)a+=i[h].byteLength}const o=k.alloc(a);let u=0;for(let h=0,m=i.length;h<m;h++){const A=i[h];o.set(A,u),u+=A.byteLength}return o}toString(){return L?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(i,a){return new k(this.buffer.subarray(i,a))}set(i,a){i instanceof k?this.buffer.set(i.buffer,a):this.buffer.set(i,a)}readUInt32BE(i){return E(this.buffer,i)}writeUInt32BE(i,a){n(this.buffer,i,a)}readUInt32LE(i){return I(this.buffer,i)}writeUInt32LE(i,a){g(this.buffer,i,a)}readUInt8(i){return w(this.buffer,i)}writeUInt8(i,a){f(this.buffer,i,a)}}e.VSBuffer=k;function C(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0}e.readUInt16LE=C;function S(r,i,a){r[a+0]=i&255,i=i>>>8,r[a+1]=i&255}e.writeUInt16LE=S;function E(r,i){return r[i]*2**24+r[i+1]*2**16+r[i+2]*2**8+r[i+3]}e.readUInt32BE=E;function n(r,i,a){r[a+3]=i,i=i>>>8,r[a+2]=i,i=i>>>8,r[a+1]=i,i=i>>>8,r[a]=i}e.writeUInt32BE=n;function I(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0|r[i+2]<<16>>>0|r[i+3]<<24>>>0}e.readUInt32LE=I;function g(r,i,a){r[a+0]=i&255,i=i>>>8,r[a+1]=i&255,i=i>>>8,r[a+2]=i&255,i=i>>>8,r[a+3]=i&255}e.writeUInt32LE=g;function w(r,i){return r[i]}e.readUInt8=w;function f(r,i,a){r[a]=i}e.writeUInt8=f;function p(r){return D.consumeReadable(r,i=>k.concat(i))}e.readableToBuffer=p;function d(r){return D.toReadable(r)}e.bufferToReadable=d;function b(r){return D.consumeStream(r,i=>k.concat(i))}e.streamToBuffer=b;async function y(r){return r.ended?k.concat(r.buffer):k.concat([...r.buffer,await b(r.stream)])}e.bufferedStreamToBuffer=y;function v(r){return D.toStream(r,i=>k.concat(i))}e.bufferToStream=v;function l(r){return D.transform(r,{data:i=>typeof i=="string"?k.fromString(i):k.wrap(i)},i=>k.concat(i))}e.streamToBufferReadableStream=l;function c(r){return D.newWriteableStream(i=>k.concat(i),r)}e.newWriteableBufferStream=c;function t(r,i){return D.prefixedReadable(r,i,a=>k.concat(a))}e.prefixedBufferReadable=t;function s(r,i){return D.prefixedStream(r,i,a=>k.concat(a))}e.prefixedBufferStream=s}),define(te[25],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.isFalsyOrWhitespace=D;const L=/{(\d+)}/g;function R(Y,...se){return se.length===0?Y:Y.replace(L,function(le,ge){const me=parseInt(ge,10);return isNaN(me)||me<0||me>=se.length?le:se[me]})}e.format=R;const T=/{([^}]+)}/g;function k(Y,se){return Y.replace(T,(le,ge)=>se[ge]??le)}e.format2=k;function C(Y){return Y.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=C;function S(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function E(Y,se){let le=0;const ge=se.charCodeAt(0);for(let me=Y.length-1;me>=0;me--)Y.charCodeAt(me)===ge&&le++;return le}e.count=E;function n(Y,se,le="\u2026"){return Y.length<=se?Y:`${Y.substr(0,se)}${le}`}e.truncate=n;function I(Y,se=" "){const le=g(Y,se);return w(le,se)}e.trim=I;function g(Y,se){if(!Y||!se)return Y;const le=se.length;if(le===0||Y.length===0)return Y;let ge=0;for(;Y.indexOf(se,ge)===ge;)ge=ge+le;return Y.substring(ge)}e.ltrim=g;function w(Y,se){if(!Y||!se)return Y;const le=se.length,ge=Y.length;if(le===0||ge===0)return Y;let me=ge,be=-1;for(;be=Y.lastIndexOf(se,me-1),!(be===-1||be+le!==me);){if(be===0)return"";me=be}return Y.substring(0,me)}e.rtrim=w;function f(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=f;function p(Y){return Y.replace(/\*/g,"")}e.stripWildcards=p;function d(Y,se,le={}){if(!Y)throw new Error("Cannot create regex from empty string");se||(Y=S(Y)),le.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let ge="";return le.global&&(ge+="g"),le.matchCase||(ge+="i"),le.multiline&&(ge+="m"),le.unicode&&(ge+="u"),new RegExp(Y,ge)}e.createRegExp=d;function b(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function y(Y){return!!Y.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=y;function v(Y){return(Y.global?"g":"")+(Y.ignoreCase?"i":"")+(Y.multiline?"m":"")+(Y.unicode?"u":"")}e.regExpFlags=v;function l(Y){return Y.split(/\r\n|\r|\n/)}e.splitLines=l;function c(Y){for(let se=0,le=Y.length;se<le;se++){const ge=Y.charCodeAt(se);if(ge!==32&&ge!==9)return se}return-1}e.firstNonWhitespaceIndex=c;function t(Y,se=0,le=Y.length){for(let ge=se;ge<le;ge++){const me=Y.charCodeAt(ge);if(me!==32&&me!==9)return Y.substring(se,ge)}return Y.substring(se,le)}e.getLeadingWhitespace=t;function s(Y,se=Y.length-1){for(let le=se;le>=0;le--){const ge=Y.charCodeAt(le);if(ge!==32&&ge!==9)return le}return-1}e.lastNonWhitespaceIndex=s;function r(Y,se){return Y<se?-1:Y>se?1:0}e.compare=r;function i(Y,se,le=0,ge=Y.length,me=0,be=se.length){for(;le<ge&&me<be;le++,me++){let Se=Y.charCodeAt(le),we=se.charCodeAt(me);if(Se<we)return-1;if(Se>we)return 1}const Te=ge-le,Le=be-me;return Te<Le?-1:Te>Le?1:0}e.compareSubstring=i;function a(Y,se){return o(Y,se,0,Y.length,0,se.length)}e.compareIgnoreCase=a;function o(Y,se,le=0,ge=Y.length,me=0,be=se.length){for(;le<ge&&me<be;le++,me++){let Se=Y.charCodeAt(le),we=se.charCodeAt(me);if(Se===we)continue;if(Se>=128||we>=128)return i(Y.toLowerCase(),se.toLowerCase(),le,ge,me,be);u(Se)&&(Se-=32),u(we)&&(we-=32);const Re=Se-we;if(Re!==0)return Re}const Te=ge-le,Le=be-me;return Te<Le?-1:Te>Le?1:0}e.compareSubstringIgnoreCase=o;function u(Y){return Y>=97&&Y<=122}e.isLowerAsciiLetter=u;function h(Y){return Y>=65&&Y<=90}e.isUpperAsciiLetter=h;function m(Y,se){return Y.length===se.length&&o(Y,se)===0}e.equalsIgnoreCase=m;function A(Y,se){const le=se.length;return se.length>Y.length?!1:o(Y,se,0,le)===0}e.startsWithIgnoreCase=A;function _(Y,se){let le,ge=Math.min(Y.length,se.length);for(le=0;le<ge;le++)if(Y.charCodeAt(le)!==se.charCodeAt(le))return le;return ge}e.commonPrefixLength=_;function O(Y,se){let le,ge=Math.min(Y.length,se.length);const me=Y.length-1,be=se.length-1;for(le=0;le<ge;le++)if(Y.charCodeAt(me-le)!==se.charCodeAt(be-le))return le;return ge}e.commonSuffixLength=O;function N(Y){return 55296<=Y&&Y<=56319}e.isHighSurrogate=N;function P(Y){return 56320<=Y&&Y<=57343}e.isLowSurrogate=P;function M(Y,se){return(Y-55296<<10)+(se-56320)+65536}e.computeCodePoint=M;function $(Y,se,le){const ge=Y.charCodeAt(le);if(N(ge)&&le+1<se){const me=Y.charCodeAt(le+1);if(P(me))return M(ge,me)}return ge}e.getNextCodePoint=$;function U(Y,se){const le=Y.charCodeAt(se-1);if(P(le)&&se>1){const ge=Y.charCodeAt(se-2);if(N(ge))return M(ge,le)}return le}function H(Y,se){const le=ee.getInstance(),ge=se,me=Y.length,be=$(Y,me,se);se+=be>=65536?2:1;let Te=le.getGraphemeBreakType(be);for(;se<me;){const Le=$(Y,me,se),Se=le.getGraphemeBreakType(Le);if(Ne(Te,Se))break;se+=Le>=65536?2:1,Te=Se}return se-ge}e.nextCharLength=H;function W(Y,se){const le=ee.getInstance(),ge=se,me=U(Y,se);se-=me>=65536?2:1;let be=le.getGraphemeBreakType(me);for(;se>0;){const Te=U(Y,se),Le=le.getGraphemeBreakType(Te);if(Ne(Le,be))break;se-=Te>=65536?2:1,be=Le}return ge-se}e.prevCharLength=W;function q(Y,se){const le=ee.getInstance(),ge=Y.length,me=se,be=$(Y,ge,se),Te=le.getGraphemeBreakType(be);se+=be>=65536?2:1;let Le=Te;for(;se<ge;){const we=$(Y,ge,se),Re=le.getGraphemeBreakType(we);if(Ne(Le,Re))break;se+=we>=65536?2:1,Le=Re}const Se=se;for(se=me,Le=Te;se>0;){const we=U(Y,se),Re=le.getGraphemeBreakType(we);if(Ne(Re,Le))break;se-=we>=65536?2:1,Le=Re}return[se,Se]}function x(Y,se){return se>0&&P(Y.charCodeAt(se))?q(Y,se-1):q(Y,se)}e.getCharContainingOffset=x;const F=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function K(Y){return F.test(Y)}e.containsRTL=K;const j=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function z(Y){return j.test(Y)}e.containsEmoji=z;const B=/^[\t\n\r\x20-\x7E]*$/;function X(Y){return B.test(Y)}e.isBasicASCII=X,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(Y){return e.UNUSUAL_LINE_TERMINATORS.test(Y)}e.containsUnusualLineTerminators=Z;function V(Y){for(let se=0,le=Y.length;se<le;se++)if(G(Y.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=V;function G(Y){return Y=+Y,Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.isFullWidthCharacter=G;function ie(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129003||Y>=129280&&Y<=129535||Y>=129648&&Y<=129750}e.isEmojiImprecise=ie;function re(Y,se){if(Y.length<se)return Y;const le=/\b/g;let ge=0;for(;le.test(Y)&&!(Y.length-le.lastIndex<se);)ge=le.lastIndex,le.lastIndex+=1;return Y.substring(ge).replace(/^\s/,"")}e.lcut=re;const ae=/\x1B\x5B[12]?K/g,ue=/\x1b\[\d+m/g,fe=/\x1b\[0?m/g;function de(Y){return Y&&(Y=Y.replace(ae,""),Y=Y.replace(ue,""),Y=Y.replace(fe,"")),Y}e.removeAnsiEscapeCodes=de,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ie(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ie;function Ce(Y){return Ie(Y)?Y.substr(1):Y}e.stripUTF8BOM=Ce;function Ee(Y,se){if(!Y||!se||Y.length<se.length)return!1;const le=se.length,ge=Y.toLowerCase();let me=0,be=-1;for(;me<le;){const Te=ge.indexOf(se[me],be+1);if(Te<0)return!1;be=Te,me++}return!0}e.fuzzyContains=Ee;function _e(Y,se=!1){return Y?(se&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.containsUppercaseCharacter=_e;function Pe(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.uppercaseFirstLetter=Pe;function ke(Y,se=1){if(se===0)return"";let le=-1;do le=Y.indexOf(`
`,le+1),se--;while(se>0&&le>=0);return le===-1?Y:(Y[le-1]==="\r"&&le--,Y.substr(0,le))}e.getNLines=ke;function Fe(Y){const se=90-65+1;return Y=Y%(2*se),Y<se?String.fromCharCode(97+Y):String.fromCharCode(65+Y-se)}e.singleLetterHash=Fe;function $e(Y){return ee.getInstance().getGraphemeBreakType(Y)}e.getGraphemeBreakType=$e;function Ne(Y,se){return Y===0?se!==5&&se!==7:Y===2&&se===3?!1:Y===4||Y===2||Y===3||se===4||se===2||se===3?!0:!(Y===8&&(se===8||se===9||se===11||se===12)||(Y===11||Y===9)&&(se===9||se===10)||(Y===12||Y===10)&&se===10||se===5||se===13||se===7||Y===1||Y===13&&se===14||Y===6&&se===6)}e.breakBetweenGraphemeBreakType=Ne;var qe;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(qe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ee{constructor(){this._data=oe()}static getInstance(){return ee._INSTANCE||(ee._INSTANCE=new ee),ee._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const le=this._data,ge=le.length/3;let me=1;for(;me<=ge;)if(se<le[3*me])me=2*me;else if(se>le[3*me+1])me=2*me+1;else return le[3*me+2];return 0}}ee._INSTANCE=null;function oe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function ce(Y,se){if(Y===0)return 0;const le=ye(Y,se);if(le!==void 0)return le;const ge=U(se,Y);return Y-=pe(ge),Y}e.getLeftDeleteOffset=ce;function ye(Y,se){let le=U(se,Y);for(Y-=pe(le);Oe(le)||le===65039||le===8419;){if(Y===0)return;le=U(se,Y),Y-=pe(le)}if(!!ie(le)){if(Y>=0){const ge=U(se,Y);ge===8205&&(Y-=pe(ge))}return Y}}function pe(Y){return Y>=65536?2:1}function Oe(Y){return 127995<=Y&&Y<=127999}var De;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(De||(De={}))}),define(te[18],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function D(h){return Array.isArray(h)}e.isArray=D;function L(h){return typeof h=="string"}e.isString=L;function R(h){return Array.isArray(h)&&h.every(m=>L(m))}e.isStringArray=R;function T(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.isObject=T;function k(h){return typeof h=="number"&&!isNaN(h)}e.isNumber=k;function C(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.isIterable=C;function S(h){return h===!0||h===!1}e.isBoolean=S;function E(h){return typeof h=="undefined"}e.isUndefined=E;function n(h){return!I(h)}e.isDefined=n;function I(h){return E(h)||h===null}e.isUndefinedOrNull=I;function g(h,m){if(!h)throw new Error(m?`Unexpected type, expected '${m}'`:"Unexpected type")}e.assertType=g;function w(h){if(I(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.assertIsDefined=w;function f(...h){const m=[];for(let A=0;A<h.length;A++){const _=h[A];if(I(_))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);m.push(_)}return m}e.assertAllDefined=f;const p=Object.prototype.hasOwnProperty;function d(h){if(!T(h))return!1;for(let m in h)if(p.call(h,m))return!1;return!0}e.isEmptyObject=d;function b(h){return typeof h=="function"}e.isFunction=b;function y(...h){return h.length>0&&h.every(b)}e.areFunctions=y;function v(h,m){const A=Math.min(h.length,m.length);for(let _=0;_<A;_++)l(h[_],m[_])}e.validateConstraints=v;function l(h,m){if(L(m)){if(typeof h!==m)throw new Error(`argument does not match constraint: typeof ${m}`)}else if(b(m)){try{if(h instanceof m)return}catch{}if(!I(h)&&h.constructor===m||m.length===1&&m.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function c(h){let m=[],A=Object.getPrototypeOf(h);for(;Object.prototype!==A;)m=m.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return m}e.getAllPropertyNames=c;function t(h){const m=[];for(const A of c(h))typeof h[A]=="function"&&m.push(A);return m}e.getAllMethodNames=t;function s(h,m){const A=O=>function(){const N=Array.prototype.slice.call(arguments,0);return m(O,N)};let _={};for(const O of h)_[O]=A(O);return _}e.createProxyObject=s;function r(h){return h===null?void 0:h}e.withNullAsUndefined=r;function i(h){return typeof h=="undefined"?null:h}e.withUndefinedAsNull=i;function a(h){return class{constructor(){return new Proxy({},{get(m,A){if(m[A])return m[A];throw new Error(`Not Implemented: ${h}->${String(A)}`)}})}}}e.NotImplementedProxy=a;function o(h,m="Unreachable"){throw new Error(m)}e.assertNever=o;function u(h){return!!h&&typeof h.then=="function"&&typeof h.catch=="function"}e.isPromise=u}),define(te[40],ne([0,1,8,4,25,18]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(r){return r===47||r===92}e.isPathSeparator=k;function C(r){return r.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=C;function S(r){return r.indexOf("/")===-1&&(r=C(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=S;function E(r,i=D.posix.sep){if(!r)return"";const a=r.length,o=r.charCodeAt(0);if(k(o)){if(k(r.charCodeAt(1))&&!k(r.charCodeAt(2))){let h=3;const m=h;for(;h<a&&!k(r.charCodeAt(h));h++);if(m!==h&&!k(r.charCodeAt(h+1))){for(h+=1;h<a;h++)if(k(r.charCodeAt(h)))return r.slice(0,h+1).replace(/[\\/]/g,i)}}return i}else if(b(o)&&r.charCodeAt(1)===58)return k(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let u=r.indexOf("://");if(u!==-1){for(u+=3;u<a;u++)if(k(r.charCodeAt(u)))return r.slice(0,u+1)}return""}e.getRoot=E;function n(r){if(!L.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let a=2;const o=a;for(;a<r.length&&(i=r.charCodeAt(a),i!==92);a++);return!(o===a||(i=r.charCodeAt(a+1),isNaN(i)||i===92))}e.isUNC=n;const I=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(r,i=L.isWindows){const a=i?I:g;return!(!r||r.length===0||/^\s+$/.test(r)||(a.lastIndex=0,a.test(r))||i&&w.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=f;function p(r,i,a){const o=r===i;return!a||o?o:!r||!i?!1:(0,R.equalsIgnoreCase)(r,i)}e.isEqual=p;function d(r,i,a,o=D.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(a){if(!(0,R.startsWithIgnoreCase)(r,i))return!1;if(i.length===r.length)return!0;let h=i.length;return i.charAt(i.length-1)===o&&h--,r.charAt(h)===o}return i.charAt(i.length-1)!==o&&(i+=o),r.indexOf(i)===0}e.isEqualOrParent=d;function b(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=b;function y(r,i){return L.isWindows&&r.endsWith(":")&&(r+=D.sep),(0,D.isAbsolute)(r)||(r=(0,D.join)(i,r)),r=(0,D.normalize)(r),L.isWindows?(r=(0,R.rtrim)(r,D.sep),r.endsWith(":")&&(r+=D.sep)):(r=(0,R.rtrim)(r,D.sep),r||(r=D.sep)),r}e.sanitizeFilePath=y;function v(r){const i=(0,D.normalize)(r);return L.isWindows?r.length>3?!1:l(i)&&(r.length===2||i.charCodeAt(2)===92):i===D.posix.sep}e.isRootOrDriveLetter=v;function l(r){return L.isWindows?b(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function c(r){return l(r)?r[0]:void 0}e.getDriveLetter=c;function t(r,i,a){return i.length>r.length?-1:r===i?0:(a&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=t;function s(r){const i=r.split(":");let a,o,u;if(i.forEach(h=>{const m=Number(h);(0,T.isNumber)(m)?o===void 0?o=m:u===void 0&&(u=m):a=a?[a,h].join(":"):h}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:o!==void 0?o:void 0,column:u!==void 0?u:o!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(te[26],ne([0,1,18]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const d=Array.isArray(p)?[]:{};return Object.keys(p).forEach(b=>{p[b]&&typeof p[b]=="object"?d[b]=L(p[b]):d[b]=p[b]}),d}e.deepClone=L;function R(p){if(!p||typeof p!="object")return p;const d=[p];for(;d.length>0;){const b=d.shift();Object.freeze(b);for(const y in b)if(T.call(b,y)){const v=b[y];typeof v=="object"&&!Object.isFrozen(v)&&d.push(v)}}return p}e.deepFreeze=R;const T=Object.prototype.hasOwnProperty;function k(p,d){return C(p,d,new Set)}e.cloneAndChange=k;function C(p,d,b){if((0,D.isUndefinedOrNull)(p))return p;const y=d(p);if(typeof y!="undefined")return y;if((0,D.isArray)(p)){const v=[];for(const l of p)v.push(C(l,d,b));return v}if((0,D.isObject)(p)){if(b.has(p))throw new Error("Cannot clone recursive data-structure");b.add(p);const v={};for(let l in p)T.call(p,l)&&(v[l]=C(p[l],d,b));return b.delete(p),v}return p}function S(p,d,b=!0){return(0,D.isObject)(p)?((0,D.isObject)(d)&&Object.keys(d).forEach(y=>{y in p?b&&((0,D.isObject)(p[y])&&(0,D.isObject)(d[y])?S(p[y],d[y],b):p[y]=d[y]):p[y]=d[y]}),p):d}e.mixin=S;function E(p,d){if(p===d)return!0;if(p==null||d===null||d===void 0||typeof p!=typeof d||typeof p!="object"||Array.isArray(p)!==Array.isArray(d))return!1;let b,y;if(Array.isArray(p)){if(p.length!==d.length)return!1;for(b=0;b<p.length;b++)if(!E(p[b],d[b]))return!1}else{const v=[];for(y in p)v.push(y);v.sort();const l=[];for(y in d)l.push(y);if(l.sort(),!E(v,l))return!1;for(b=0;b<v.length;b++)if(!E(p[v[b]],d[v[b]]))return!1}return!0}e.equals=E;function n(p){const d=new Set;return JSON.stringify(p,(b,y)=>{if((0,D.isObject)(y)||Array.isArray(y)){if(d.has(y))return"[Circular]";d.add(y)}return y})}e.safeStringify=n;function I(p,d,b){const y=d(p);return typeof y=="undefined"?b:y}e.getOrDefault=I;function g(p,d){const b=Object.create(null);return!p||!d||Object.keys(d).forEach(v=>{const l=p[v],c=d[v];E(l,c)||(b[v]=c)}),b}e.distinct=g;function w(p,d){const b=d.toLowerCase(),y=Object.keys(p).find(v=>v.toLowerCase()===b);return y?p[y]:p[d]}e.getCaseInsensitive=w;function f(p,d){const b=Object.create(null);for(const y of Object.keys(p))d(y,p[y])&&(b[y]=p[y]);return b}e.filter=f}),define(te[7],ne([0,1,8,4]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const R=/^\w[\w\d+.-]*$/,T=/^\//,k=/^\/\//;function C(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!R.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!T.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(r,i){return!r&&!i?"file":r}function E(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==I&&(i=I+i):i=I;break}return i}const n="",I="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class w{constructor(i,a,o,u,h,m=!1){typeof i=="object"?(this.scheme=i.scheme||n,this.authority=i.authority||n,this.path=i.path||n,this.query=i.query||n,this.fragment=i.fragment||n):(this.scheme=S(i,m),this.authority=a||n,this.path=E(this.scheme,o||n),this.query=u||n,this.fragment=h||n,C(this,m))}static isUri(i){return i instanceof w?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return v(this,!1)}with(i){if(!i)return this;let{scheme:a,authority:o,path:u,query:h,fragment:m}=i;return a===void 0?a=this.scheme:a===null&&(a=n),o===void 0?o=this.authority:o===null&&(o=n),u===void 0?u=this.path:u===null&&(u=n),h===void 0?h=this.query:h===null&&(h=n),m===void 0?m=this.fragment:m===null&&(m=n),a===this.scheme&&o===this.authority&&u===this.path&&h===this.query&&m===this.fragment?this:new p(a,o,u,h,m)}static parse(i,a=!1){const o=g.exec(i);return o?new p(o[2]||n,s(o[4]||n),s(o[5]||n),s(o[7]||n),s(o[9]||n),a):new p(n,n,n,n,n)}static file(i){let a=n;if(L.isWindows&&(i=i.replace(/\\/g,I)),i[0]===I&&i[1]===I){const o=i.indexOf(I,2);o===-1?(a=i.substring(2),i=I):(a=i.substring(2,o),i=i.substring(o)||I)}return new p("file",a,i,n,n)}static from(i){const a=new p(i.scheme,i.authority,i.path,i.query,i.fragment);return C(a,!0),a}static joinPath(i,...a){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return L.isWindows&&i.scheme==="file"?o=w.file(D.win32.join(v(i,!0),...a)).path:o=D.posix.join(i.path,...a),i.with({path:o})}toString(i=!1){return l(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof w)return i;{const a=new p(i);return a._formatted=i.external,a._fsPath=i._sep===f?i.fsPath:null,a}}else return i}}e.URI=w;const f=L.isWindows?1:void 0;class p extends w{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(i=!1){return i?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=f),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(r,i){let a,o=-1;for(let u=0;u<r.length;u++){const h=r.charCodeAt(u);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||i&&h===47)o!==-1&&(a+=encodeURIComponent(r.substring(o,u)),o=-1),a!==void 0&&(a+=r.charAt(u));else{a===void 0&&(a=r.substr(0,u));const m=d[h];m!==void 0?(o!==-1&&(a+=encodeURIComponent(r.substring(o,u)),o=-1),a+=m):o===-1&&(o=u)}}return o!==-1&&(a+=encodeURIComponent(r.substring(o))),a!==void 0?a:r}function y(r){let i;for(let a=0;a<r.length;a++){const o=r.charCodeAt(a);o===35||o===63?(i===void 0&&(i=r.substr(0,a)),i+=d[o]):i!==void 0&&(i+=r[a])}return i!==void 0?i:r}function v(r,i){let a;return r.authority&&r.path.length>1&&r.scheme==="file"?a=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?a=r.path.substr(1):a=r.path[1].toLowerCase()+r.path.substr(2):a=r.path,L.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=v;function l(r,i){const a=i?y:b;let o="",{scheme:u,authority:h,path:m,query:A,fragment:_}=r;if(u&&(o+=u,o+=":"),(h||u==="file")&&(o+=I,o+=I),h){let O=h.indexOf("@");if(O!==-1){const N=h.substr(0,O);h=h.substr(O+1),O=N.indexOf(":"),O===-1?o+=a(N,!1):(o+=a(N.substr(0,O),!1),o+=":",o+=a(N.substr(O+1),!1)),o+="@"}h=h.toLowerCase(),O=h.indexOf(":"),O===-1?o+=a(h,!1):(o+=a(h.substr(0,O),!1),o+=h.substr(O))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const O=m.charCodeAt(1);O>=65&&O<=90&&(m=`/${String.fromCharCode(O+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const O=m.charCodeAt(0);O>=65&&O<=90&&(m=`${String.fromCharCode(O+32)}:${m.substr(2)}`)}o+=a(m,!0)}return A&&(o+="?",o+=a(A,!1)),_&&(o+="#",o+=i?_:b(_,!1)),o}function c(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+c(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(t)?r.replace(t,i=>c(i)):r}}),define(te[103],ne([0,1,7]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(E){const n=E;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=L;function R(E){const n=[];let I;try{const g=JSON.parse(E.arguments),w=g[g.length-1];w&&w.__$stack&&(g.pop(),I=w.__$stack),n.push(...g)}catch(g){n.push("Unable to log remote console arguments",E.arguments)}return{args:n,stack:I}}e.parse=R;function T(E){if(typeof E!="string")return T(R(E).stack);const n=E;if(n){const I=k(n),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(g&&g.length===4)return{uri:D.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.getFirstFrame=T;function k(E){if(!E)return E;const n=E.indexOf(`
`);return n===-1?E:E.substring(0,n)}function C(E,n){const{args:I,stack:g}=R(E),w=typeof I[0]=="string"&&I.length===1;let f=k(g);f&&(f=`(${f.trim()})`);let p=[];if(typeof I[0]=="string"?f&&w?p=[`%c[${n}] %c${I[0]} %c${f}`,S("blue"),S(""),S("grey")]:p=[`%c[${n}] %c${I[0]}`,S("blue"),S(""),...I.slice(1)]:p=[`%c[${n}]%`,S("blue"),...I],f&&!w&&p.push(f),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,p)}e.log=C;function S(E){return`color: ${E}`}});var yt=this&&this.__classPrivateFieldSet||function(J,e,D,L,R){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!R)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!R:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?R.call(J,D):R?R.value=D:e.set(J,D),D},Be=this&&this.__classPrivateFieldGet||function(J,e,D,L){if(D==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!L:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?L:D==="a"?L.call(J):L?L.value:e.get(J)};define(te[41],ne([0,1,17,25,7]),function(J,e,D,L,R){"use strict";var T,k,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(r,i,a){let o=r.get(i);return o===void 0&&(o=a,r.set(i,o)),o}e.getOrSet=S;function E(r){const i=[];return r.forEach((a,o)=>{i.push(`${o} => ${a}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.mapToString=E;function n(r){const i=[];return r.forEach(a=>{i.push(a)}),`Set(${r.size}) {${i.join(", ")}}`}e.setToString=n;class I{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const a=i.charCodeAt(0),o=this._value.charCodeAt(this._pos);return a-o}value(){return this._value[this._pos]}}e.StringIterator=I;class g{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,L.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=g;class w{constructor(i=!0,a=!0){this._splitOnBackslash=i,this._caseSensitive=a}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const a=this._value.charCodeAt(this._to);if(a===47||this._splitOnBackslash&&a===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,L.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=w;var f;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(f||(f={}));class p{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new w(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,L.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=p;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(b||(b={}));class y{constructor(i){this._iter=i}static forUris(i=()=>!1){return new y(new p(i))}static forPaths(){return new y(new w)}static forStrings(){return new y(new I)}static forConfigKeys(){return new y(new g)}clear(){this._root=void 0}fill(i,a){if(a){const o=a.slice(0);(0,D.shuffle)(o);for(let u of o)this.set(u,i)}else{const o=i.slice(0);(0,D.shuffle)(o);for(let u of o)this.set(u[0],u[1])}}set(i,a){const o=this._iter.reset(i);let u;this._root||(this._root=new d,this._root.segment=o.value());const h=[];for(u=this._root;;){const A=o.cmp(u.segment);if(A>0)u.left||(u.left=new d,u.left.segment=o.value()),h.push([-1,u]),u=u.left;else if(A<0)u.right||(u.right=new d,u.right.segment=o.value()),h.push([1,u]),u=u.right;else if(o.hasNext())o.next(),u.mid||(u.mid=new d,u.mid.segment=o.value()),h.push([0,u]),u=u.mid;else break}const m=u.value;u.value=a,u.key=i;for(let A=h.length-1;A>=0;A--){const _=h[A][1];_.updateHeight();const O=_.balanceFactor();if(O<-1||O>1){const N=h[A][0],P=h[A+1][0];if(N===1&&P===1)h[A][1]=_.rotateLeft();else if(N===-1&&P===-1)h[A][1]=_.rotateRight();else if(N===1&&P===-1)_.right=h[A+1][1]=h[A+1][1].rotateRight(),h[A][1]=_.rotateLeft();else if(N===-1&&P===1)_.left=h[A+1][1]=h[A+1][1].rotateLeft(),h[A][1]=_.rotateRight();else throw new Error;if(A>0)switch(h[A-1][0]){case-1:h[A-1][1].left=h[A][1];break;case 1:h[A-1][1].right=h[A][1];break;case 0:h[A-1][1].mid=h[A][1];break}else this._root=h[0][1]}}return m}get(i){return this._getNode(i)?.value}_getNode(i){const a=this._iter.reset(i);let o=this._root;for(;o;){const u=a.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(a.hasNext())a.next(),o=o.mid;else break}return o}has(i){const a=this._getNode(i);return!(a?.value===void 0&&a?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,a){const o=this._iter.reset(i),u=[];let h=this._root;for(;h;){const m=o.cmp(h.segment);if(m>0)u.push([-1,h]),h=h.left;else if(m<0)u.push([1,h]),h=h.right;else if(o.hasNext())o.next(),u.push([0,h]),h=h.mid;else break}if(!!h){if(a?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const m=this._min(h.right),{key:A,value:_,segment:O}=m;this._delete(m.key,!1),h.key=A,h.value=_,h.segment=O}else{const m=h.left??h.right;if(u.length>0){const[A,_]=u[u.length-1];switch(A){case-1:_.left=m;break;case 0:_.mid=m;break;case 1:_.right=m;break}}else this._root=m}for(let m=u.length-1;m>=0;m--){const A=u[m][1];A.updateHeight();const _=A.balanceFactor();if(_>1?(A.right.balanceFactor()>=0||(A.right=u[m+1][1]=u[m+1][1].rotateRight()),u[m][1]=A.rotateLeft()):_<-1&&(A.left.balanceFactor()<=0||(A.left=u[m+1][1]=u[m+1][1].rotateLeft()),u[m][1]=A.rotateRight()),m>0)switch(u[m-1][0]){case-1:u[m-1][1].left=u[m][1];break;case 1:u[m-1][1].right=u[m][1];break;case 0:u[m-1][1].mid=u[m][1];break}else this._root=u[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const a=this._iter.reset(i);let o=this._root,u;for(;o;){const h=a.cmp(o.segment);if(h>0)o=o.left;else if(h<0)o=o.right;else if(a.hasNext())a.next(),u=o.value||u,o=o.mid;else break}return o&&o.value||u}findSuperstr(i){const a=this._iter.reset(i);let o=this._root;for(;o;){const u=a.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(a.hasNext())a.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(i){for(const[a,o]of this)i(o,a)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=a=>{if(!a)return!0;const o=a.balanceFactor();return o<-1||o>1?!1:i(a.left)&&i(a.right)};return i(this._root)}}e.TernarySearchTree=y;class v{constructor(i,a){this[T]="ResourceMap",i instanceof v?(this.map=new Map(i.map),this.toKey=a??v.defaultToKey):(this.map=new Map,this.toKey=i??v.defaultToKey)}set(i,a){return this.map.set(this.toKey(i),a),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,a){typeof a!="undefined"&&(i=i.bind(a));for(let[o,u]of this.map)i(u,R.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield R.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[R.URI.parse(i[0]),i[1]]}*[(T=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[R.URI.parse(i[0]),i[1]]}}e.ResourceMap=v,v.defaultToKey=r=>r.toString();var l;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(l=e.Touch||(e.Touch={}));class c{constructor(){this[k]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,a=0){const o=this._map.get(i);if(!!o)return a!==0&&this.touch(o,a),o.value}set(i,a,o=0){let u=this._map.get(i);if(u)u.value=a,o!==0&&this.touch(u,o);else{switch(u={key:i,value:a,next:void 0,previous:void 0},o){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(i,u),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const a=this._map.get(i);if(!!a)return this._map.delete(i),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,a){const o=this._state;let u=this._head;for(;u;){if(a?i.bind(a)(u.value,u.key,this):i(u.value,u.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const i=this,a=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==a)throw new Error("LinkedMap got modified during iteration.");if(o){const h={value:o.key,done:!1};return o=o.next,h}else return{value:void 0,done:!0}}};return u}values(){const i=this,a=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==a)throw new Error("LinkedMap got modified during iteration.");if(o){const h={value:o.value,done:!1};return o=o.next,h}else return{value:void 0,done:!0}}};return u}entries(){const i=this,a=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==a)throw new Error("LinkedMap got modified during iteration.");if(o){const h={value:[o.key,o.value],done:!1};return o=o.next,h}else return{value:void 0,done:!0}}};return u}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let a=this._head,o=this.size;for(;a&&o>i;)this._map.delete(a.key),a=a.next,o--;this._head=a,this._size=o,a&&(a.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const a=i.next,o=i.previous;if(!a||!o)throw new Error("Invalid list");a.previous=o,o.next=a}i.next=void 0,i.previous=void 0,this._state++}touch(i,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(i===this._head)return;const o=i.next,u=i.previous;i===this._tail?(u.next=void 0,this._tail=u):(o.previous=u,u.next=o),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(a===2){if(i===this._tail)return;const o=i.next,u=i.previous;i===this._head?(o.previous=void 0,this._head=o):(o.previous=u,u.next=o),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((a,o)=>{i.push([o,a])}),i}fromJSON(i){this.clear();for(const[a,o]of i)this.set(a,o)}}e.LinkedMap=c;class t extends c{constructor(i,a=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,a=2){return super.get(i,a)}peek(i){return super.get(i,0)}set(i,a){return super.set(i,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=t;class s{constructor(i){C.set(this,void 0),yt(this,C,i,"f")}get size(){return Be(this,C,"f").size}forEach(i,a){Be(this,C,"f").forEach(i,a)}get(i){return Be(this,C,"f").get(i)}has(i){return Be(this,C,"f").has(i)}entries(){return Be(this,C,"f").entries()}keys(){return Be(this,C,"f").keys()}values(){return Be(this,C,"f").values()}[(C=new WeakMap,Symbol.iterator)](){return Be(this,C,"f").entries()}}e.ReadonlyMapView=s}),define(te[104],ne([0,1,22,25,7]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function T(n){return JSON.stringify(n,S)}e.stringify=T;function k(n){let I=JSON.parse(n);return I=E(I),I}e.parse=k;var C;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(C=e.MarshalledId||(e.MarshalledId={}));function S(n,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,L.regExpFlags)(I)}:I}function E(n,I=0){if(!n||I>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return R.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof D.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let g=0;g<n.length;++g)n[g]=E(n[g],I+1);else for(const g in n)Object.hasOwnProperty.call(n,g)&&(n[g]=E(n[g],I+1))}return n}e.revive=E}),define(te[15],ne([0,1,4,7]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var R;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(R=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,E,n){this._hosts[S]=E,this._ports[S]=n}setConnectionToken(S,E){this._connectionTokens[S]=E}rewrite(S){if(this._delegate)return this._delegate(S);const E=S.authority;let n=this._hosts[E];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const I=this._ports[E],g=this._connectionTokens[E];let w=`path=${encodeURIComponent(S.path)}`;return typeof g=="string"&&(w+=`&tkn=${encodeURIComponent(g)}`),L.URI.from({scheme:D.isWeb?this._preferredWebSchema:R.vscodeRemoteResource,authority:`${n}:${I}`,path:"/vscode-remote-resource",query:w})}}e.RemoteAuthorities=new T;class k{asBrowserUri(S,E){const n=this.toUri(S,E);return n.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(n):n.scheme===R.file&&(D.isNative||typeof D.globals.importScripts=="function"&&D.globals.origin===`${R.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?n.with({scheme:R.vscodeFileResource,authority:n.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):n}asFileUri(S,E){const n=this.toUri(S,E);return n.scheme===R.vscodeFileResource?n.with({scheme:R.file,authority:n.authority!==k.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(S,E){return L.URI.isUri(S)?S:L.URI.parse(E.toUrl(S))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(te[68],ne([0,1,41]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new D.LRUCache(1e4);function R(E){return S(E,"NFC",L)}e.normalizeNFC=R;const T=new D.LRUCache(1e4);function k(E){return S(E,"NFD",T)}e.normalizeNFD=k;const C=/[^\u0000-\u0080]/;function S(E,n,I){if(!E)return E;const g=I.get(E);if(g)return g;let w;return C.test(E)?w=E.normalize(n):w=E,I.set(E,w),w}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(n){return k(n).replace(E,"")}}()}),define(te[16],ne([0,1,40,15,8,4,25,7]),function(J,e,D,L,R,T,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(w){return(0,C.uriToFsPath)(w,!0)}e.originalFSPath=S;class E{constructor(f){this._ignorePathCasing=f}compare(f,p,d=!1){return f===p?0:(0,k.compare)(this.getComparisonKey(f,d),this.getComparisonKey(p,d))}isEqual(f,p,d=!1){return f===p?!0:!f||!p?!1:this.getComparisonKey(f,d)===this.getComparisonKey(p,d)}getComparisonKey(f,p=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,p,d=!1){if(f.scheme===p.scheme){if(f.scheme===L.Schemas.file)return D.isEqualOrParent(S(f),S(p),this._ignorePathCasing(f))&&f.query===p.query&&(d||f.fragment===p.fragment);if((0,e.isEqualAuthority)(f.authority,p.authority))return D.isEqualOrParent(f.path,p.path,this._ignorePathCasing(f),"/")&&f.query===p.query&&(d||f.fragment===p.fragment)}return!1}joinPath(f,...p){return C.URI.joinPath(f,...p)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return R.posix.basename(f.path)}extname(f){return R.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let p;return f.scheme===L.Schemas.file?p=C.URI.file(R.dirname(S(f))).path:(p=R.posix.dirname(f.path),f.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),p="/")),f.with({path:p})}normalizePath(f){if(!f.path.length)return f;let p;return f.scheme===L.Schemas.file?p=C.URI.file(R.normalize(S(f))).path:p=R.posix.normalize(f.path),f.with({path:p})}relativePath(f,p){if(f.scheme!==p.scheme||!(0,e.isEqualAuthority)(f.authority,p.authority))return;if(f.scheme===L.Schemas.file){const y=R.relative(S(f),S(p));return T.isWindows?D.toSlashes(y):y}let d=f.path||"/",b=p.path||"/";if(this._ignorePathCasing(f)){let y=0;for(const v=Math.min(d.length,b.length);y<v&&!(d.charCodeAt(y)!==b.charCodeAt(y)&&d.charAt(y).toLowerCase()!==b.charAt(y).toLowerCase());y++);d=b.substr(0,y)+d.substr(y)}return R.posix.relative(d,b)}resolvePath(f,p){if(f.scheme===L.Schemas.file){const d=C.URI.file(R.resolve(S(f),p));return f.with({authority:d.authority,path:d.path})}return p=D.toPosixPath(p),f.with({path:R.posix.resolve(f.path,p)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,p){return f===p||(0,k.equalsIgnoreCase)(f,p)}hasTrailingPathSeparator(f,p=R.sep){if(f.scheme===L.Schemas.file){const d=S(f);return d.length>D.getRoot(d).length&&d[d.length-1]===p}else{const d=f.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,p=R.sep){return(0,e.hasTrailingPathSeparator)(f,p)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,p=R.sep){let d=!1;if(f.scheme===L.Schemas.file){const b=S(f);d=b!==void 0&&b.length===D.getRoot(b).length&&b[b.length-1]===p}else{p="/";const b=f.path;d=b.length===1&&b.charCodeAt(b.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(f,p)?f.with({path:f.path+"/"}):f}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(w=>w.scheme===L.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new E(w=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(w,f){const p=[];for(let d=0;d<w.length;d++){const b=f(w[d]);w.some((y,v)=>v===d?!1:(0,e.isEqualOrParent)(b,f(y)))||p.push(w[d])}return p}e.distinctParents=n;var I;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function f(p){const d=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(v=>{const[l,c]=v.split(":");l&&c&&d.set(l,c)});const y=p.path.substring(0,p.path.indexOf(";"));return y&&d.set(w.META_DATA_MIME,y),d}w.parseMetaData=f})(I=e.DataUri||(e.DataUri={}));function g(w,f,p){if(f){let d=w.path;return d&&d[0]!==R.posix.sep&&(d=R.posix.sep+d),w.with({scheme:p,authority:f,path:d})}return w.with({scheme:p})}e.toLocalResource=g}),define(te[6],ne([0,1,27,9,3,2,16]),function(J,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(W){return!!W&&typeof W.then=="function"}e.isThenable=C;function S(W){const q=new D.CancellationTokenSource,x=W(q.token),F=new Promise((K,j)=>{const z=q.token.onCancellationRequested(()=>{z.dispose(),q.dispose(),j((0,L.canceled)())});Promise.resolve(x).then(B=>{z.dispose(),q.dispose(),K(B)},B=>{z.dispose(),q.dispose(),j(B)})});return new class{cancel(){q.cancel()}then(K,j){return F.then(K,j)}catch(K){return this.then(void 0,K)}finally(K){return F.finally(K)}}}e.createCancelablePromise=S;function E(W,q,x){return Promise.race([W,new Promise(F=>q.onCancellationRequested(()=>F(x)))])}e.raceCancellation=E;async function n(W){let q=-1;const x=W.map((K,j)=>K.then(z=>(q=j,z))),F=await Promise.race(x);return W.forEach((K,j)=>{j!==q&&K.cancel()}),F}e.raceCancellablePromises=n;function I(W,q,x){let F;const K=setTimeout(()=>{F?.(void 0),x?.()},q);return Promise.race([W.finally(()=>clearTimeout(K)),new Promise(j=>F=j)])}e.raceTimeout=I;function g(W){return new Promise((q,x)=>{const F=W();C(F)?F.then(q,x):q(F)})}e.asPromise=g;class w{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(q){if(this.activePromise){if(this.queuedPromiseFactory=q,!this.queuedPromise){const x=()=>{this.queuedPromise=null;const F=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,F};this.queuedPromise=new Promise(F=>{this.activePromise.then(x,x).then(F)})}return new Promise((x,F)=>{this.queuedPromise.then(x,F)})}return this.activePromise=q(),new Promise((x,F)=>{this.activePromise.then(K=>{this.activePromise=null,x(K)},K=>{this.activePromise=null,F(K)})})}}e.Throttler=w;class f{constructor(){this.current=Promise.resolve(null)}queue(q){return this.current=this.current.then(()=>q(),()=>q())}}e.Sequencer=f;class p{constructor(){this.promiseMap=new Map}queue(q,x){const K=(this.promiseMap.get(q)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.promiseMap.get(q)===K&&this.promiseMap.delete(q)});return this.promiseMap.set(q,K),K}}e.SequencerByKey=p;class d{constructor(q){this.defaultDelay=q,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(q,x=this.defaultDelay){return this.task=q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((F,K)=>{this.doResolve=F,this.doReject=K}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const F=this.task;return this.task=null,F()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},x),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=d;class b{constructor(q){this.delayer=new d(q),this.throttler=new w}trigger(q,x){return this.delayer.trigger(()=>this.throttler.queue(q),x)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class y{constructor(){this._isOpen=!1,this._promise=new Promise((q,x)=>{this._completePromise=q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=y;class v extends y{constructor(q){super();this._timeout=setTimeout(()=>this.open(),q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=v;function l(W,q){return q?new Promise((x,F)=>{const K=setTimeout(()=>{j.dispose(),x()},W),j=q.onCancellationRequested(()=>{clearTimeout(K),j.dispose(),F((0,L.canceled)())})}):S(x=>l(W,x))}e.timeout=l;function c(W,q=0){const x=setTimeout(W,q);return(0,T.toDisposable)(()=>clearTimeout(x))}e.disposableTimeout=c;function t(W){const q=[];let x=0;const F=W.length;function K(){return x<F?W[x++]():null}function j(z){z!=null&&q.push(z);const B=K();return B?B.then(j):Promise.resolve(q)}return Promise.resolve(null).then(j)}e.sequence=t;function s(W,q=F=>!!F,x=null){let F=0;const K=W.length,j=()=>{if(F>=K)return Promise.resolve(x);const z=W[F++];return Promise.resolve(z()).then(X=>q(X)?Promise.resolve(X):j())};return j()}e.first=s;function r(W,q=F=>!!F,x=null){if(W.length===0)return Promise.resolve(x);let F=W.length;const K=()=>{F=-1;for(const j of W)j.cancel?.()};return new Promise((j,z)=>{for(const B of W)B.then(X=>{--F>=0&&q(X)?(K(),j(X)):F===0&&j(x)}).catch(X=>{--F>=0&&(K(),z(X))})})}e.firstParallel=r;class i{constructor(q){this._size=0,this.maxDegreeOfParalellism=q,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new R.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(q){return this._size++,new Promise((x,F)=>{this.outstandingPromises.push({factory:q,c:x,e:F}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const q=this.outstandingPromises.shift();this.runningPromises++;const x=q.factory();x.then(q.c,q.e),x.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=i;class a extends i{constructor(){super(1)}}e.Queue=a;class o{constructor(){this.queues=new Map}queueFor(q,x=k.extUri){const F=x.getComparisonKey(q);let K=this.queues.get(F);return K||(K=new a,R.Event.once(K.onFinished)(()=>{K?.dispose(),this.queues.delete(F)}),this.queues.set(F,K)),K}dispose(){this.queues.forEach(q=>q.dispose()),this.queues.clear()}}e.ResourceQueue=o;class u{constructor(q,x){this._token=-1,typeof q=="function"&&typeof x=="number"&&this.setIfNotSet(q,x)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(q,x){this.cancel(),this._token=setTimeout(()=>{this._token=-1,q()},x)}setIfNotSet(q,x){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,q()},x))}}e.TimeoutTimer=u;class h{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(q,x){this.cancel(),this._token=setInterval(()=>{q()},x)}}e.IntervalTimer=h;class m{constructor(q,x){this.timeoutToken=-1,this.runner=q,this.timeout=x,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,q)}get delay(){return this.timeout}set delay(q){this.timeout=q}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=m;class A{constructor(q,x){x%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.runner=q,this.timeout=x,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(q=this.timeout){q%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(q/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=A;class _ extends m{constructor(q,x){super(q,x);this.units=[]}work(q){this.units.push(q),this.isScheduled()||this.schedule()}doRun(){const q=this.units;this.units=[],this.runner&&this.runner(q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=_;class O extends T.Disposable{constructor(q,x,F,K){super();this.maxWorkChunkSize=q,this.maxPendingWork=x,this.throttleDelay=F,this.handler=K,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(q){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+q.length>this.maxPendingWork)return!1}else if(this.pending+q.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...q),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new m(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=W=>{const q=setTimeout(()=>{const F=Date.now()+15;W(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0,clearTimeout(q))}}}:e.runWhenIdle=(W,q)=>{const x=requestIdleCallback(W,typeof q=="number"?{timeout:q}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(x))}}}}();class N{constructor(q){this._didRun=!1,this._executor=()=>{try{this._value=q()}catch(x){this._error=x}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=N;async function P(W,q,x){let F;for(let K=0;K<x;K++)try{return await W()}catch(j){F=j,await l(q)}throw F}e.retry=P;class M{hasPending(q){return this._pending?typeof q=="number"?this._pending.taskId===q:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(q,x,F){return this._pending={taskId:q,cancel:()=>F?.(),promise:x},x.then(()=>this.donePending(q),()=>this.donePending(q)),x}donePending(q){this._pending&&q===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const q=this._next;this._next=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}setNext(q){if(this._next)this._next.run=q;else{let x,F;const K=new Promise((j,z)=>{x=j,F=z});this._next={run:q,promise:K,promiseResolve:x,promiseReject:F}}return this._next.promise}}e.TaskSequentializer=M;class ${constructor(q){this.interval=q,this.lastIncrementTime=0,this.value=0}increment(){const q=Date.now();return q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=q,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class U{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((q,x)=>{this.completeCallback=q,this.errorCallback=x})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(q){return new Promise(x=>{this.completeCallback(q),this.resolved=!0,x()})}error(q){return new Promise(x=>{this.errorCallback(q),this.rejected=!0,x()})}cancel(){new Promise(q=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,q()})}}e.DeferredPromise=U;var H;(function(W){async function q(x){let F;const K=await Promise.all(x.map(j=>j.then(z=>z,z=>{F||(F=z)})));if(typeof F!="undefined")throw F;return K}W.settled=q})(H=e.Promises||(e.Promises={}))}),define(te[69],ne([0,1,6,40,41,8,25]),function(J,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const S="**",E="/",n="[/\\\\]",I="[^/\\\\]",g=/\//g;function w(F){switch(F){case 0:return"";case 1:return`${I}*?`;default:return`(?:${n}|${I}+${n}|${n}${I}+)*?`}}function f(F,K){if(!F)return[];const j=[];let z=!1,B=!1,X="";for(const Z of F){switch(Z){case K:if(!z&&!B){j.push(X),X="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":B=!0;break;case"]":B=!1;break}X+=Z}return X&&j.push(X),j}e.splitGlobAware=f;function p(F){if(!F)return"";let K="";const j=f(F,E);if(j.every(z=>z===S))K=".*";else{let z=!1;j.forEach((B,X)=>{if(B===S){z||(K+=w(2),z=!0);return}let Z=!1,V="",G=!1,ie="";for(const re of B){if(re!=="}"&&Z){V+=re;continue}if(G&&(re!=="]"||!ie)){let ae;re==="-"?ae=re:(re==="^"||re==="!")&&!ie?ae="^":re===E?ae="":ae=k.escapeRegExpCharacters(re),ie+=ae;continue}switch(re){case"{":Z=!0;continue;case"[":G=!0;continue;case"}":K+=`(?:${f(V,",").map(fe=>p(fe)).join("|")})`,Z=!1,V="";break;case"]":K+="["+ie+"]",G=!1,ie="";break;case"?":K+=I;continue;case"*":K+=w(1);continue;default:K+=k.escapeRegExpCharacters(re)}}X<j.length-1&&(j[X+1]!==S||X+2<j.length)&&(K+=n),z=!1})}return K}const d=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,v=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),s=function(){return!1},r=function(){return null};function i(F,K){if(!F)return r;let j;typeof F!="string"?j=F.pattern:j=F,j=j.trim();const z=`${j}_${!!K.trimForExclusions}`;let B=t.get(z);if(B)return a(B,F);let X;if(d.test(j)){const Z=j.substr(4);B=function(V,G){return typeof V=="string"&&V.endsWith(Z)?j:null}}else(X=b.exec(o(j,K)))?B=u(X[1],j):(K.trimForExclusions?v:y).test(j)?B=h(j,K):(X=l.exec(o(j,K)))?B=m(X[1].substr(1),j,!0):(X=c.exec(o(j,K)))?B=m(X[1],j,!1):B=A(j);return t.set(z,B),a(B,F)}function a(F,K){return typeof K=="string"?F:function(j,z){return L.isEqualOrParent(j,K.base)?F(T.relative(K.base,j),z):null}}function o(F,K){return K.trimForExclusions&&F.endsWith("/**")?F.substr(0,F.length-2):F}function u(F,K){const j=`/${F}`,z=`\\${F}`,B=function(Z,V){return typeof Z!="string"?null:V?V===F?K:null:Z===F||Z.endsWith(j)||Z.endsWith(z)?K:null},X=[F];return B.basenames=X,B.patterns=[K],B.allBasenames=X,B}function h(F,K){const j=x(F.slice(1,-1).split(",").map(V=>i(V,K)).filter(V=>V!==r),F),z=j.length;if(!z)return r;if(z===1)return j[0];const B=function(V,G){for(let ie=0,re=j.length;ie<re;ie++)if(j[ie](V,G))return F;return null},X=j.find(V=>!!V.allBasenames);X&&(B.allBasenames=X.allBasenames);const Z=j.reduce((V,G)=>G.allPaths?V.concat(G.allPaths):V,[]);return Z.length&&(B.allPaths=Z),B}function m(F,K,j){const z=T.sep===T.posix.sep,B=z?F:F.replace(g,T.sep),X=T.sep+B,Z=T.posix.sep+F,V=j?function(G,ie){return typeof G=="string"&&(G===B||G.endsWith(X)||!z&&(G===F||G.endsWith(Z)))?K:null}:function(G,ie){return typeof G=="string"&&(G===B||!z&&G===F)?K:null};return V.allPaths=[(j?"*/":"./")+F],V}function A(F){try{const K=new RegExp(`^${p(F)}$`);return function(j){return K.lastIndex=0,typeof j=="string"&&K.test(j)?F:null}}catch(K){return r}}function _(F,K,j){return!F||typeof K!="string"?!1:O(F)(K,void 0,j)}e.match=_;function O(F,K={}){if(!F)return s;if(typeof F=="string"||$(F)){const j=i(F,K);if(j===r)return s;const z=function(B,X){return!!j(B,X)};return j.allBasenames&&(z.allBasenames=j.allBasenames),j.allPaths&&(z.allPaths=j.allPaths),z}return W(F,K)}e.parse=O;function N(F){if(!F)return;let K;return j=>(K||(K=(F()||Promise.resolve([])).then(z=>z?M(z):{})),K.then(z=>!!z[j]))}e.hasSiblingPromiseFn=N;function P(F){if(!F)return;let K;return j=>{if(!K){const z=F();K=z?M(z):{}}return!!K[j]}}e.hasSiblingFn=P;function M(F){const K={};for(const j of F)K[j]=!0;return K}function $(F){const K=F;return K&&typeof K.base=="string"&&typeof K.pattern=="string"}e.isRelativePattern=$;function U(F){return F.allBasenames||[]}e.getBasenameTerms=U;function H(F){return F.allPaths||[]}e.getPathTerms=H;function W(F,K){const j=x(Object.getOwnPropertyNames(F).map(V=>q(V,F[V],K)).filter(V=>V!==r)),z=j.length;if(!z)return r;if(!j.some(V=>!!V.requiresSiblings)){if(z===1)return j[0];const V=function(re,ae){for(let ue=0,fe=j.length;ue<fe;ue++){const de=j[ue](re,ae);if(de)return de}return null},G=j.find(re=>!!re.allBasenames);G&&(V.allBasenames=G.allBasenames);const ie=j.reduce((re,ae)=>ae.allPaths?re.concat(ae.allPaths):re,[]);return ie.length&&(V.allPaths=ie),V}const B=function(V,G,ie){let re;for(let ae=0,ue=j.length;ae<ue;ae++){const fe=j[ae];fe.requiresSiblings&&ie&&(G||(G=T.basename(V)),re||(re=G.substr(0,G.length-T.extname(V).length)));const de=fe(V,G,re,ie);if(de)return de}return null},X=j.find(V=>!!V.allBasenames);X&&(B.allBasenames=X.allBasenames);const Z=j.reduce((V,G)=>G.allPaths?V.concat(G.allPaths):V,[]);return Z.length&&(B.allPaths=Z),B}function q(F,K,j){if(K===!1)return r;const z=i(F,j);if(z===r)return r;if(typeof K=="boolean")return z;if(K){const B=K.when;if(typeof B=="string"){const X=(Z,V,G,ie)=>{if(!ie||!z(Z,V))return null;const re=B.replace("$(basename)",G),ae=ie(re);return(0,D.isThenable)(ae)?ae.then(ue=>ue?F:null):ae?F:null};return X.requiresSiblings=!0,X}}return z}function x(F,K){const j=F.filter(V=>!!V.basenames);if(j.length<2)return F;const z=j.reduce((V,G)=>{const ie=G.basenames;return ie?V.concat(ie):V},[]);let B;if(K){B=[];for(let V=0,G=z.length;V<G;V++)B.push(K)}else B=j.reduce((V,G)=>{const ie=G.patterns;return ie?V.concat(ie):V},[]);const X=function(V,G){if(typeof V!="string")return null;if(!G){let re;for(re=V.length;re>0;re--){const ae=V.charCodeAt(re-1);if(ae===47||ae===92)break}G=V.substr(re)}const ie=z.indexOf(G);return ie!==-1?B[ie]:null};X.basenames=z,X.patterns=B,X.allBasenames=z;const Z=F.filter(V=>!V.basenames);return Z.push(X),Z}}),define(te[105],ne([0,1,69,15,8,16,25]),function(J,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var C;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown",i.latex="text/latex"})(C=e.Mimes||(e.Mimes={}));let S=[],E=[],n=[];function I(i,a=!1){const o=g(i);S.push(o),o.userConfigured?n.push(o):E.push(o),a&&!o.userConfigured&&S.forEach(u=>{u.mime===o.mime||u.userConfigured||(o.extension&&u.extension===o.extension&&console.warn(`Overwriting extension <<${o.extension}>> to now point to mime <<${o.mime}>>`),o.filename&&u.filename===o.filename&&console.warn(`Overwriting filename <<${o.filename}>> to now point to mime <<${o.mime}>>`),o.filepattern&&u.filepattern===o.filepattern&&console.warn(`Overwriting filepattern <<${o.filepattern}>> to now point to mime <<${o.mime}>>`),o.firstline&&u.firstline===o.firstline&&console.warn(`Overwriting firstline <<${o.firstline}>> to now point to mime <<${o.mime}>>`))})}e.registerTextMime=I;function g(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?(0,D.parse)(i.filepattern.toLowerCase()):void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(R.posix.sep)>=0:!1}}function w(i){i?(S=S.filter(a=>!a.userConfigured),n=[]):(S=[],E=[],n=[])}e.clearTextMimes=w;function f(i,a){let o;if(i)switch(i.scheme){case L.Schemas.file:o=i.fsPath;break;case L.Schemas.data:o=T.DataUri.parseMetaData(i).get(T.DataUri.META_DATA_LABEL);break;default:o=i.path}if(!o)return[C.unknown];o=o.toLowerCase();const u=(0,R.basename)(o),h=p(o,u,n);if(h)return[h,C.text];const m=p(o,u,E);if(m)return[m,C.text];if(a){const A=d(a);if(A)return[A,C.text]}return[C.unknown]}e.guessMimeTypes=f;function p(i,a,o){let u=null,h=null,m=null;for(let A=o.length-1;A>=0;A--){const _=o[A];if(a===_.filenameLowercase){u=_;break}if(_.filepattern&&(!h||_.filepattern.length>h.filepattern.length)){const O=_.filepatternOnPath?i:a;_.filepatternLowercase?.(O)&&(h=_)}_.extension&&(!m||_.extension.length>m.extension.length)&&a.endsWith(_.extensionLowercase)&&(m=_)}return u?u.mime:h?h.mime:m?m.mime:null}function d(i){if((0,k.startsWithUTF8BOM)(i)&&(i=i.substr(1)),i.length>0)for(let a=S.length-1;a>=0;a--){const o=S[a];if(!o.firstline)continue;const u=i.match(o.firstline);if(u&&u.length>0)return o.mime}return null}function b(i){return i?typeof i=="string"?i===C.binary||i===C.text||i===C.unknown:i.length===1&&b(i[0]):!0}e.isUnspecific=b;const y={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},v={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function l(i){const a=(0,R.extname)(i),o=y[a.toLowerCase()];return o!==void 0?o:c(i)}e.getMediaOrTextMime=l;function c(i){const a=(0,R.extname)(i);return v[a.toLowerCase()]}e.getMediaMime=c;function t(i){for(const a in v)if(v[a]===i)return a}e.getExtensionForMimeType=t;const s=/^(.+)\/(.+?)(;.+)?$/;function r(i,a){const o=s.exec(i);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:a?void 0:i}e.normalizeMimeType=r}),define(te[106],ne([0,1,7]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(n){return n.toJSON()}class R{constructor(I){this._uriTransformer=I}transformIncoming(I){const g=this._uriTransformer.transformIncoming(I);return g===I?I:L(D.URI.from(g))}transformOutgoing(I){const g=this._uriTransformer.transformOutgoing(I);return g===I?I:L(D.URI.from(g))}transformOutgoingURI(I){const g=this._uriTransformer.transformOutgoing(I);return g===I?I:D.URI.from(g)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function T(n,I,g){if(!n||g>200)return null;if(typeof n=="object"){if(n instanceof D.URI)return I.transformOutgoing(n);for(let w in n)if(Object.hasOwnProperty.call(n,w)){const f=T(n[w],I,g+1);f!==null&&(n[w]=f)}}return null}function k(n,I){const g=T(n,I,0);return g===null?n:g}e.transformOutgoingURIs=k;function C(n,I,g,w){if(!n||w>200)return null;if(typeof n=="object"){if(n.$mid===1)return g?D.URI.revive(I.transformIncoming(n)):I.transformIncoming(n);for(let f in n)if(Object.hasOwnProperty.call(n,f)){const p=C(n[f],I,g,w+1);p!==null&&(n[f]=p)}}return null}function S(n,I){const g=C(n,I,!1,0);return g===null?n:g}e.transformIncomingURIs=S;function E(n,I){const g=C(n,I,!0,0);return g===null?n:g}e.transformAndReviveIncomingURIs=E}),define(te[30],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(S){return D.test(S)}e.isUUID=L;const R=new Uint8Array(16),T=[];for(let S=0;S<256;S++)T.push(S.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(S){for(let E=0;E<S.length;E++)S[E]=Math.floor(Math.random()*256);return S};function C(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let S=0,E="";return E+=T[R[S++]],E+=T[R[S++]],E+=T[R[S++]],E+=T[R[S++]],E+="-",E+=T[R[S++]],E+=T[R[S++]],E+="-",E+=T[R[S++]],E+=T[R[S++]],E+="-",E+=T[R[S++]],E+=T[R[S++]],E+="-",E+=T[R[S++]],E+=T[R[S++]],E+=T[R[S++]],E+=T[R[S++]],E+=T[R[S++]],E+=T[R[S++]],E}e.generateUuid=C}),define(te[70],ne([0,1,107]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(T="utf8"){this.stringDecoder=new D.StringDecoder(T),this.remaining=null}write(T){const k=[],C=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(C.length<1)return k;let S=0,E,n=S;for(;n<C.length;)if(E=C.charCodeAt(n),E===13||E===10){if(k.push(C.substring(S,n)),n++,n<C.length){const I=E;E=C.charCodeAt(n),(I===13&&E===10||I===10&&E===13)&&n++}S=n}else n++;return this.remaining=S<C.length?C.substr(S):null,k}end(){return this.remaining}}e.LineDecoder=L}),define(te[108],ne([0,1,32]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(C){const S=C.replace(/\-/g,":").toLowerCase();return!L.has(S)}function T(){return new Promise(async(C,S)=>{const E=setTimeout(()=>S("Unable to retrieve mac address (timeout after 10s)"),1e4);try{C(await k())}catch(n){S(n)}finally{clearTimeout(E)}})}e.getMac=T;function k(){return new Promise((C,S)=>{try{const E=(0,D.networkInterfaces)();for(let n in E){const I=E[n];if(I){for(const{mac:g}of I)if(R(g))return C(g)}}S("Unable to retrieve mac address (unexpected format)")}catch(E){S(E)}})}}),define(te[109],ne([0,1,32,9,41,30,108]),function(J,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,I=0;const g=(0,D.networkInterfaces)();for(let w in g){const f=g[w];if(f)for(const{mac:p,internal:d}of f)d||(I+=1,this._isVirtualMachineMacAddress(p.toUpperCase())&&(n+=1))}this._value=I>0?n/I:0}return this._value}};let C;async function S(){return C||(C=(async()=>await E()||T.generateUuid())()),C}e.getMachineId=S;async function E(){try{const n=await new Promise((g,w)=>{J(["crypto"],g,w)}),I=await(0,k.getMac)();return n.createHash("sha256").update(I,"utf8").digest("hex")}catch(n){L.onUnexpectedError(n);return}}}),define(te[19],ne([0,1,51,32,236,6,40,68,8,4,16,7,30]),function(J,e,D,L,R,T,k,C,S,E,n,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(w=e.RimRafMode||(e.RimRafMode={}));async function f(U,H=w.UNLINK){if((0,k.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return H===w.UNLINK?d(U):p(U)}async function p(U){try{const H=(0,S.join)((0,L.tmpdir)(),(0,g.generateUuid)());try{await e.Promises.rename(U,H)}catch(W){return d(U)}d(H).catch(W=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function d(U){return e.Promises.rmdir(U,{recursive:!0,maxRetries:3})}function b(U){if((0,k.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");D.rmdirSync(U,{recursive:!0})}e.rimrafSync=b;async function y(U,H){return c(await(H?v(U):(0,R.promisify)(D.readdir)(U)))}async function v(U){try{return await(0,R.promisify)(D.readdir)(U,{withFileTypes:!0})}catch(q){console.warn("[node.js fs] readdir with filetypes failed with error: ",q)}const H=[],W=await y(U);for(const q of W){let x=!1,F=!1,K=!1;try{const j=await e.Promises.lstat((0,S.join)(U,q));x=j.isFile(),F=j.isDirectory(),K=j.isSymbolicLink()}catch(j){console.warn("[node.js fs] unexpected error from lstat after readdir: ",j)}H.push({name:q,isFile:()=>x,isDirectory:()=>F,isSymbolicLink:()=>K})}return H}function l(U){return c(D.readdirSync(U))}e.readdirSync=l;function c(U){return U.map(H=>typeof H=="string"?E.isMacintosh?(0,C.normalizeNFC)(H):H:(H.name=E.isMacintosh?(0,C.normalizeNFC)(H.name):H.name,H))}async function t(U){const H=await y(U),W=[];for(const q of H)await r.existsDirectory((0,S.join)(U,q))&&W.push(q);return W}function s(U,H=1e3){return new Promise(W=>{let q=!1;const x=setInterval(()=>{q||(q=!0,D.access(U,F=>{q=!1,F&&(clearInterval(x),W(void 0))}))},H)})}e.whenDeleted=s;var r;(function(U){async function H(x){let F;try{if(F=await e.Promises.lstat(x),!F.isSymbolicLink())return{stat:F}}catch(K){}try{return{stat:await e.Promises.stat(x),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(E.isWindows&&K.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(j){if(j.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw j}throw K}}U.stat=H;async function W(x){try{const{stat:F,symbolicLink:K}=await U.stat(x);return F.isFile()&&K?.dangling!==!0}catch(F){}return!1}U.existsFile=W;async function q(x){try{const{stat:F,symbolicLink:K}=await U.stat(x);return F.isDirectory()&&K?.dangling!==!0}catch(F){}return!1}U.existsDirectory=q})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new T.ResourceQueue;function a(U,H,W){return i.queueFor(I.URI.file(U),n.extUriBiasedIgnorePathCase).queue(()=>{const q=m(W);return new Promise((x,F)=>u(U,H,q,K=>K?F(K):x()))})}let o=!0;function u(U,H,W,q){if(!o)return D.writeFile(U,H,{mode:W.mode,flag:W.flag},q);D.open(U,W.flag,W.mode,(x,F)=>{if(x)return q(x);D.writeFile(F,H,K=>{if(K)return D.close(F,()=>q(K));D.fdatasync(F,j=>(j&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",j),o=!1),D.close(F,z=>q(z))))})})}function h(U,H,W){const q=m(W);if(!o)return D.writeFileSync(U,H,{mode:q.mode,flag:q.flag});const x=D.openSync(U,q.flag,q.mode);try{D.writeFileSync(x,H);try{D.fdatasyncSync(x)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),o=!1}}finally{D.closeSync(x)}}e.writeFileSync=h;function m(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function A(U,H){if(U===H)return;async function W(q){try{const x=await e.Promises.lstat(q);if(x.isDirectory()||x.isSymbolicLink())return;await e.Promises.utimes(q,x.atime,new Date)}catch(x){}}try{await e.Promises.rename(U,H),await W(H)}catch(q){if(U.toLowerCase()!==H.toLowerCase()&&q.code==="EXDEV"||U.endsWith("."))await _(U,H,{preserveSymlinks:!1}),await f(U,w.MOVE),await W(H);else throw q}}async function _(U,H,W){return N(U,H,{root:{source:U,target:H},options:W,handledSourcePaths:new Set})}const O=511;async function N(U,H,W){if(W.handledSourcePaths.has(U))return;W.handledSourcePaths.add(U);const{stat:q,symbolicLink:x}=await r.stat(U);if(x){if(W.options.preserveSymlinks)try{return await $(U,H,W)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(x.dangling)return}return q.isDirectory()?P(U,H,q.mode&O,W):M(U,H,q.mode&O)}async function P(U,H,W,q){await e.Promises.mkdir(H,{recursive:!0,mode:W});const x=await y(U);for(const F of x)await N((0,S.join)(U,F),(0,S.join)(H,F),q)}async function M(U,H,W){await e.Promises.copyFile(U,H),await e.Promises.chmod(H,W)}async function $(U,H,W){let q=await e.Promises.readlink(U);(0,k.isEqualOrParent)(q,W.root.source,!E.isLinux)&&(q=(0,S.join)(W.root.target,q.substr(W.root.source.length+1))),await e.Promises.symlink(q,H)}e.Promises=new class{get access(){return(0,R.promisify)(D.access)}get stat(){return(0,R.promisify)(D.stat)}get lstat(){return(0,R.promisify)(D.lstat)}get utimes(){return(0,R.promisify)(D.utimes)}get read(){return(0,R.promisify)(D.read)}get readFile(){return(0,R.promisify)(D.readFile)}get write(){return(0,R.promisify)(D.write)}get appendFile(){return(0,R.promisify)(D.appendFile)}get fdatasync(){return(0,R.promisify)(D.fdatasync)}get truncate(){return(0,R.promisify)(D.truncate)}get rename(){return(0,R.promisify)(D.rename)}get copyFile(){return(0,R.promisify)(D.copyFile)}get open(){return(0,R.promisify)(D.open)}get close(){return(0,R.promisify)(D.close)}get symlink(){return(0,R.promisify)(D.symlink)}get readlink(){return(0,R.promisify)(D.readlink)}get chmod(){return(0,R.promisify)(D.chmod)}get mkdir(){return(0,R.promisify)(D.mkdir)}get unlink(){return(0,R.promisify)(D.unlink)}get rmdir(){return(0,R.promisify)(D.rmdir)}get realpath(){return(0,R.promisify)(D.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return y}get readDirsInDir(){return t}get writeFile(){return a}get rm(){return f}get move(){return A}get copy(){return _}}}),define(te[110],ne([0,1,51,8,25,19]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function k(n){const I=(0,L.dirname)(n);if(n===I)return n;const g=((0,L.basename)(n)||n).toLowerCase();try{const f=(0,T.readdirSync)(I).filter(p=>p.toLowerCase()===g);if(f.length===1){const p=k(I);if(p)return(0,L.join)(p,f[0])}else if(f.length>1){const p=f.indexOf(g);if(p>=0){const d=k(I);if(d)return(0,L.join)(d,f[p])}}}catch(w){}return null}e.realcaseSync=k;async function C(n){try{return await T.Promises.realpath(n)}catch(I){const g=E(n);return await T.Promises.access(g,D.constants.R_OK),g}}e.realpath=C;function S(n){try{return D.realpathSync(n)}catch(I){const g=E(n);return D.accessSync(g,D.constants.R_OK),g}}e.realpathSync=S;function E(n){return(0,R.rtrim)((0,L.normalize)(n),L.sep)}}),define(te[111],ne([0,1,56]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function L(C,S,E,n=1){let I=!1;return new Promise(g=>{const w=setTimeout(()=>{if(!I)return I=!0,g(0)},E);R(C,S,n,f=>{if(!I)return I=!0,clearTimeout(w),g(f)})})}e.findFreePort=L;function R(C,S,E,n){if(S===0)return n(0);const I=new D.Socket;I.once("connect",()=>(k(I),R(C+E,S-1,E,n))),I.once("data",()=>{}),I.once("error",g=>(k(I),g.code!=="ECONNREFUSED"?R(C+E,S-1,E,n):n(C))),I.connect(C,"127.0.0.1")}function T(C,S,E){let n=!1,I,g=1;const w=D.createServer({pauseOnConnect:!0});function f(p,d){n||(n=!0,w.removeAllListeners(),w.close(),I&&clearTimeout(I),d(p))}return new Promise(p=>{I=setTimeout(()=>{f(0,p)},E),w.on("listening",()=>{f(C,p)}),w.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&g<S?(C++,g++,w.listen(C,"127.0.0.1")):f(0,p)}),w.on("close",()=>{f(0,p)}),w.listen(C,"127.0.0.1")})}e.findFreePortFaster=T;function k(C){try{C.removeAllListeners("connect"),C.removeAllListeners("error"),C.end(),C.destroy(),C.unref()}catch(S){console.error(S)}}}),define(te[71],ne([0,1,32,8,19]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,k=/^Microsoft.PowerShell_.*/,C=/^Microsoft.PowerShellPreview_.*/;var S;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(S||(S={}));let E;switch(process.arch){case"ia32":case"x32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class I{constructor(c,t,s){this.exePath=c,this.displayName=t,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await R.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:l=!1}={}){return l?E===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:l=!1,findPreview:c=!1}={}){const t=g({useAlternateBitness:l});if(!t)return null;const s=L.join(t,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(s))return null;let r=-1,i=null;for(const u of await R.Promises.readdir(s)){let h=-1;if(c){const A=u.indexOf("-");if(A<0)continue;const _=u.substring(0,A);if(!T.test(_)||u.substring(A+1)!=="preview")continue;h=parseInt(_,10)}else{if(!T.test(u))continue;h=parseInt(u,10)}if(h<=r)continue;const m=L.join(s,u,"pwsh.exe");!await R.SymlinkSupport.existsFile(m)||(i=m,r=h)}if(!i)return null;const a=t.includes("x86")?" (x86)":"",o=c?" Preview":"";return new I(i,`PowerShell${o}${a}`,!0)}async function f({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const c=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=l?{pwshMsixDirRegex:C,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const r of await R.Promises.readdir(c))if(t.test(r)){const i=L.join(c,r,"pwsh.exe");return new I(i,s)}return null}function p(){const l=L.join(D.homedir(),".dotnet","tools","pwsh.exe");return new I(l,".NET Core PowerShell Global Tool")}function d(){const l=L.join(process.env.windir,E===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(l,"Windows PowerShell",!0)}async function*b(){let l=await w();l&&(yield l),l=await w({useAlternateBitness:!0}),l&&(yield l),l=await f(),l&&(yield l),l=p(),l&&(yield l),l=await w({findPreview:!0}),l&&(yield l),l=await f({findPreview:!0}),l&&(yield l),l=await w({useAlternateBitness:!0,findPreview:!0}),l&&(yield l),l=d(),l&&(yield l)}async function*y(){for await(const l of b())await l.exists()&&(yield l)}e.enumeratePowerShellInstallations=y;async function v(){for await(const l of y())return l;return null}e.getFirstAvailablePowerShellInstallation=v}),define(te[112],ne([0,1,37,15]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function R(k){return new Promise((C,S)=>{let E;const n=new Map;function I(w,f,p,d,b){const y=n.get(f);if(w===k||y){const v={name:g(p),cmd:p,pid:w,ppid:f,load:d,mem:b};n.set(w,v),w===k&&(E=v),y&&(y.children||(y.children=[]),y.children.push(v),y.children.length>1&&(y.children=y.children.sort((l,c)=>l.pid-c.pid)))}}function g(w){const f=/--disable-blink-features=Auxclick/,p=/\\watcher\\win32\\CodeHelper\.exe/,d=/--crashes-directory/,b=/\\pipe\\winpty-control/,y=/conhost\.exe/,v=/--type=([a-zA-Z-]+)/;if(p.exec(w))return"watcherService ";if(d.exec(w))return"electron-crash-reporter";if(b.exec(w))return"winpty-process";if(y.exec(w))return"console-window-host (Windows internal process)";let l=v.exec(w);if(l&&l.length===2)return l[1]==="renderer"?f.exec(w)?"shared-process":"window":l[1];const c=/[a-zA-Z-]+\.js/g;let t="";do l=c.exec(w),l&&(t+=l+" ");while(l);return t&&w.indexOf("node ")<0&&w.indexOf("node.exe")<0?`electron_node ${t}`:w}if(process.platform==="win32"){const w=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substr(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substr(5):f;new Promise((f,p)=>{J(["windows-process-tree"],f,p)}).then(f=>{f.getProcessList(k,p=>{f.getProcessCpuUsage(p,d=>{const b=new Map;d.forEach(y=>{const v=w(y.commandLine||"");b.set(y.pid,{name:g(v),cmd:v,pid:y.pid,ppid:y.ppid,load:y.cpu||0,mem:y.memory||0})}),E=b.get(k),E?(b.forEach(y=>{const v=b.get(y.ppid);v&&(v.children||(v.children=[]),v.children.push(y))}),b.forEach(y=>{y.children&&(y.children=y.children.sort((v,l)=>v.pid-l.pid))}),C(E)):S(new Error(`Root process ${k} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let w=function(){let f=[E];const p=[];for(;f.length;){const b=f.shift();b&&(p.push(b.pid),b.children&&(f=f.concat(b.children)))}let d=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",J).fsPath);d+=" "+p.join(" "),(0,D.exec)(d,{},(b,y,v)=>{if(b||v)S(b||new Error(v.toString()));else{const l=y.toString().split(`
`);for(let c=0;c<p.length;c++){const t=n.get(p[c]);t.load=parseFloat(l[c])}if(!E){S(new Error(`Root process ${k} not found`));return}C(E)}})};(0,D.exec)("which ps",{},(f,p,d)=>{if(f||d)if(process.platform!=="linux")S(f||new Error(d.toString()));else{const b=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",J).fsPath);(0,D.exec)(b,{},(y,v,l)=>{y||l?S(y||new Error(l.toString())):(T(v,I),w())})}else{const b=p.toString().trim(),y="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${b} ${y}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(v,l,c)=>{v||c&&!c.includes("screen size is bogus")?S(v||new Error(c.toString())):(T(l,I),process.platform==="linux"?w():E?C(E):S(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=R;function T(k,C){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=k.toString().split(`
`);for(const n of E){const I=S.exec(n.trim());I&&I.length===6&&C(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(te[113],ne([0,1,51,27,40,2,68,8,4,19]),function(J,e,D,L,R,T,k,C,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function n(f,p,d){return g({path:f,isDirectory:!1},p,d)}e.watchFile=n;function I(f,p,d){return g({path:f,isDirectory:!0},p,d)}e.watchFolder=I,e.CHANGE_BUFFER_DELAY=100;function g(f,p,d){if(S.isMacintosh&&(0,R.isEqualOrParent)(f.path,"/Volumes/"))return d(`Refusing to watch ${f.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const b=(0,C.basename)(f.path),y=new Map;let v=!1,l=[(0,T.toDisposable)(()=>{y.forEach(c=>(0,T.dispose)(c)),y.clear()})];try{const c=(0,D.watch)(f.path);l.push((0,T.toDisposable)(()=>{c.removeAllListeners(),c.close()}));const t=new Set;f.isDirectory&&E.Promises.readdir(f.path).then(s=>s.forEach(r=>t.add(r))),c.on("error",(s,r)=>{v||d(`Failed to watch ${f.path} for changes using fs.watch() (${s}, ${r})`)}),c.on("change",(s,r)=>{if(v)return;let i="";if(r&&(i=r.toString(),S.isMacintosh&&(i=(0,k.normalizeNFC)(i))),!i||s!=="change"&&s!=="rename")return;const a=f.isDirectory?(0,C.join)(f.path,i):f.path;if(f.isDirectory)if(s==="rename"){const o=y.get(a);o&&(0,T.dispose)(o);const u=setTimeout(async()=>{y.delete(a);const h=await E.Promises.exists(a);if(v)return;let m;h?t.has(i)?m="changed":(m="added",t.add(i)):(t.delete(i),m="deleted"),p(m,a)},e.CHANGE_BUFFER_DELAY);y.set(a,(0,T.toDisposable)(()=>clearTimeout(u)))}else{let o;t.has(i)?o="changed":(o="added",t.add(i)),p(o,a)}else if(s==="rename"||i!==b){const o=setTimeout(async()=>{const u=await E.Promises.exists(a);v||(u?(p("changed",a),l=[g(f,p,d)]):p("deleted",a))},e.CHANGE_BUFFER_DELAY);(0,T.dispose)(l),l=[(0,T.toDisposable)(()=>clearTimeout(o))]}else p("changed",a)})}catch(c){E.Promises.exists(f.path).then(t=>{t&&!v&&d(`Failed to watch ${f.path} for changes using fs.watch() (${c.toString()})`)})}return(0,T.toDisposable)(()=>{v=!0,l=(0,T.dispose)(l)})}async function w(f,p,d,b=512){const y=await E.Promises.open(f,"r"),v=Buffer.allocUnsafe(b),l=new L.CancellationTokenSource(d);let c,t=!1;const s=n(f,async r=>{if(r==="changed"){if(t)return;t=!0;try{for(;!l.token.isCancellationRequested;){const{bytesRead:i}=await E.Promises.read(y,v,0,b,null);if(!i||l.token.isCancellationRequested)break;p(v.slice(0,i))}}catch(i){c=new Error(i),l.dispose(!0)}finally{t=!1}}},r=>{c=new Error(r),l.dispose(!0)});return new Promise((r,i)=>{l.token.onCancellationRequested(async()=>{s.dispose(),await E.Promises.close(y),c?i(c):r()})})}e.watchFileContents=w});var he=this&&this.__decorate||function(J,e,D,L){var R=arguments.length,T=R<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,D):L,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(J,e,D,L);else for(var C=J.length-1;C>=0;C--)(k=J[C])&&(T=(R<3?k(T):R>3?k(e,D,T):k(e,D))||T);return R>3&&T&&Object.defineProperty(e,D,T),T};define(te[33],ne([0,1,17,6,22,27,66,9,3,2,104,25,18]),function(J,e,D,L,R,T,k,C,S,E,n,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var w;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(w=e.RequestType||(e.RequestType={}));function f(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(p=e.ResponseType||(e.ResponseType={}));function d(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(b||(b={}));class y{constructor(F){this.buffer=F,this.pos=0}read(F){const K=this.buffer.slice(this.pos,this.pos+F);return this.pos+=K.byteLength,K}}class v{constructor(){this.buffers=[]}get buffer(){return R.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var l;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(l||(l={}));function c(x){const F=R.VSBuffer.alloc(4);return F.writeUInt32BE(x,0),F}function t(x){return x.read(4).readUInt32BE(0)}function s(x){const F=R.VSBuffer.alloc(1);return F.writeUInt8(x,0),F}const r={Undefined:s(l.Undefined),String:s(l.String),Buffer:s(l.Buffer),VSBuffer:s(l.VSBuffer),Array:s(l.Array),Object:s(l.Object)},i=typeof Buffer!="undefined";function a(x,F){if(typeof F=="undefined")x.write(r.Undefined);else if(typeof F=="string"){const K=R.VSBuffer.fromString(F);x.write(r.String),x.write(c(K.byteLength)),x.write(K)}else if(i&&Buffer.isBuffer(F)){const K=R.VSBuffer.wrap(F);x.write(r.Buffer),x.write(c(K.byteLength)),x.write(K)}else if(F instanceof R.VSBuffer)x.write(r.VSBuffer),x.write(c(F.byteLength)),x.write(F);else if(Array.isArray(F)){x.write(r.Array),x.write(c(F.length));for(const K of F)a(x,K)}else{const K=R.VSBuffer.fromString(JSON.stringify(F));x.write(r.Object),x.write(c(K.byteLength)),x.write(K)}}function o(x){switch(x.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return x.read(t(x)).toString();case l.Buffer:return x.read(t(x)).buffer;case l.VSBuffer:return x.read(t(x));case l.Array:{const K=t(x),j=[];for(let z=0;z<K;z++)j.push(o(x));return j}case l.Object:return JSON.parse(x.read(t(x)).toString())}}class u{constructor(F,K,j=null,z=1e3){this.protocol=F,this.ctx=K,this.logger=j,this.timeoutDelay=z,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(F,K){this.channels.set(F,K),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const K=this.send([F.type]);this.logger&&this.logger.logOutgoing(K,0,1,d(F.type));return}case 201:case 202:case 204:case 203:{const K=this.send([F.type,F.id],F.data);this.logger&&this.logger.logOutgoing(K,F.id,1,d(F.type),F.data);return}}}send(F,K=void 0){const j=new v;return a(j,F),a(j,K),this.sendBuffer(j.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(K){return 0}}onRawMessage(F){const K=new y(F),j=o(K),z=o(K),B=j[0];switch(B){case 100:return this.logger&&this.logger.logIncoming(F.byteLength,j[1],1,`${f(B)}: ${j[2]}.${j[3]}`,z),this.onPromise({type:B,id:j[1],channelName:j[2],name:j[3],arg:z});case 102:return this.logger&&this.logger.logIncoming(F.byteLength,j[1],1,`${f(B)}: ${j[2]}.${j[3]}`,z),this.onEventListen({type:B,id:j[1],channelName:j[2],name:j[3],arg:z});case 101:return this.logger&&this.logger.logIncoming(F.byteLength,j[1],1,`${f(B)}`),this.disposeActiveRequest({type:B,id:j[1]});case 103:return this.logger&&this.logger.logIncoming(F.byteLength,j[1],1,`${f(B)}`),this.disposeActiveRequest({type:B,id:j[1]})}}onPromise(F){const K=this.channels.get(F.channelName);if(!K){this.collectPendingRequest(F);return}const j=new T.CancellationTokenSource;let z;try{z=K.call(this.ctx,F.name,F.arg,j.token)}catch(Z){z=Promise.reject(Z)}const B=F.id;z.then(Z=>{this.sendResponse({id:B,data:Z,type:201}),this.activeRequests.delete(F.id)},Z=>{Z instanceof Error?this.sendResponse({id:B,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:202}):this.sendResponse({id:B,data:Z,type:203}),this.activeRequests.delete(F.id)});const X=(0,E.toDisposable)(()=>j.cancel());this.activeRequests.set(F.id,X)}onEventListen(F){const K=this.channels.get(F.channelName);if(!K){this.collectPendingRequest(F);return}const j=F.id,B=K.listen(this.ctx,F.name,F.arg)(X=>this.sendResponse({id:j,data:X,type:204}));this.activeRequests.set(F.id,B)}disposeActiveRequest(F){const K=this.activeRequests.get(F.id);K&&(K.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let K=this.pendingRequests.get(F.channelName);K||(K=[],this.pendingRequests.set(F.channelName,K));const j=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);K.push({request:F,timeoutTimer:j})}flushPendingRequests(F){const K=this.pendingRequests.get(F);if(K){for(const j of K)switch(clearTimeout(j.timeoutTimer),j.request.type){case 100:this.onPromise(j.request);break;case 102:this.onEventListen(j.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}e.ChannelServer=u;var h;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class m{constructor(F,K=null){this.protocol=F,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new S.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(j=>this.onBuffer(j)),this.logger=K}getChannel(F){const K=this;return{call(j,z,B){return K.isDisposed?Promise.reject(C.canceled()):K.requestPromise(F,j,z,B)},listen(j,z){return K.isDisposed?Promise.reject(C.canceled()):K.requestEvent(F,j,z)}}}requestPromise(F,K,j,z=T.CancellationToken.None){const B=this.lastRequestId++,Z={id:B,type:100,channelName:F,name:K,arg:j};if(z.isCancellationRequested)return Promise.reject(C.canceled());let V;return new Promise((ie,re)=>{if(z.isCancellationRequested)return re(C.canceled());const ae=()=>{const Ie=Ce=>{switch(Ce.type){case 201:this.handlers.delete(B),ie(Ce.data);break;case 202:this.handlers.delete(B);const Ee=new Error(Ce.data.message);Ee.stack=Ce.data.stack,Ee.name=Ce.data.name,re(Ee);break;case 203:this.handlers.delete(B),re(Ce.data);break}};this.handlers.set(B,Ie),this.sendRequest(Z)};let ue=null;this.state===b.Idle?ae():(ue=(0,L.createCancelablePromise)(Ie=>this.whenInitialized()),ue.then(()=>{ue=null,ae()}));const fe=()=>{ue?(ue.cancel(),ue=null):this.sendRequest({id:B,type:101}),re(C.canceled())},de=z.onCancellationRequested(fe);V=(0,E.combinedDisposable)((0,E.toDisposable)(fe),de),this.activeRequests.add(V)}).finally(()=>{this.activeRequests.delete(V)})}requestEvent(F,K,j){const z=this.lastRequestId++,X={id:z,type:102,channelName:F,name:K,arg:j};let Z=null;const V=new S.Emitter({onFirstListenerAdd:()=>{Z=(0,L.createCancelablePromise)(ie=>this.whenInitialized()),Z.then(()=>{Z=null,this.activeRequests.add(V),this.sendRequest(X)})},onLastListenerRemove:()=>{Z?(Z.cancel(),Z=null):(this.activeRequests.delete(V),this.sendRequest({id:z,type:103}))}}),G=ie=>V.fire(ie.data);return this.handlers.set(z,G),V.event}sendRequest(F){switch(F.type){case 100:case 102:{const K=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger&&this.logger.logOutgoing(K,F.id,0,`${f(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const K=this.send([F.type,F.id]);this.logger&&this.logger.logOutgoing(K,F.id,0,f(F.type));return}}}send(F,K=void 0){const j=new v;return a(j,F),a(j,K),this.sendBuffer(j.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(K){return 0}}onBuffer(F){const K=new y(F),j=o(K),z=o(K),B=j[0];switch(B){case 200:return this.logger&&this.logger.logIncoming(F.byteLength,0,0,d(B)),this.onResponse({type:j[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(F.byteLength,j[1],0,d(B),z),this.onResponse({type:j[0],id:j[1],data:z})}}onResponse(F){if(F.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const K=this.handlers.get(F.id);K&&K(F)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}he([k.memoize],m.prototype,"onDidInitializePromise",null),e.ChannelClient=m;class A{constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new S.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new S.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:K,onDidClientDisconnect:j})=>{S.Event.once(K.onMessage)(B=>{const X=new y(B),Z=o(X),V=new u(K,Z),G=new m(K);this.channels.forEach((re,ae)=>V.registerChannel(ae,re));const ie={channelServer:V,channelClient:G,ctx:Z};this._connections.add(ie),this._onDidAddConnection.fire(ie),j(()=>{V.dispose(),G.dispose(),this._connections.delete(ie),this._onDidRemoveConnection.fire(ie)})})})}get connections(){const F=[];return this._connections.forEach(K=>F.push(K)),F}getChannel(F,K){const j=this;return{call(z,B,X){let Z;if((0,g.isFunction)(K)){let G=(0,D.getRandomElement)(j.connections.filter(K));Z=G?Promise.resolve(G):S.Event.toPromise(S.Event.filter(j.onDidAddConnection,K))}else Z=K.routeCall(j,z,B);const V=Z.then(G=>G.channelClient.getChannel(F));return O(V).call(z,B,X)},listen(z,B){if((0,g.isFunction)(K))return j.getMulticastEvent(F,K,z,B);const X=K.routeEvent(j,z,B).then(Z=>Z.channelClient.getChannel(F));return O(X).listen(z,B)}}}getMulticastEvent(F,K,j,z){const B=this;let X=new E.DisposableStore;const Z=new S.Emitter({onFirstListenerAdd:()=>{X=new E.DisposableStore;const V=new S.EventMultiplexer,G=new Map,ie=ae=>{const fe=ae.channelClient.getChannel(F).listen(j,z),de=V.add(fe);G.set(ae,de)},re=ae=>{const ue=G.get(ae);!ue||(ue.dispose(),G.delete(ae))};B.connections.filter(K).forEach(ie),S.Event.filter(B.onDidAddConnection,K)(ie,void 0,X),B.onDidRemoveConnection(re,void 0,X),V.event(Z.fire,Z,X),X.add(V)},onLastListenerRemove:()=>{X.dispose()}});return Z.event}registerChannel(F,K){this.channels.set(F,K),this._connections.forEach(j=>{j.channelServer.registerChannel(F,K)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class _{constructor(F,K,j=null){const z=new v;a(z,K),F.send(z.buffer),this.channelClient=new m(F,j),this.channelServer=new u(F,K,j)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,K){this.channelServer.registerChannel(F,K)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function O(x){return{call(F,K,j){return x.then(z=>z.call(F,K,j))},listen(F,K){const j=new S.Relay;return x.then(z=>j.input=z.listen(F,K)),j.event}}}e.getDelayedChannel=O;function N(x){let F=!1;return{call(K,j,z){return F?x.call(K,j,z):(0,L.timeout)(0).then(()=>F=!0).then(()=>x.call(K,j,z))},listen(K,j){if(F)return x.listen(K,j);const z=new S.Relay;return(0,L.timeout)(0).then(()=>F=!0).then(()=>z.input=x.listen(K,j)),z.event}}}e.getNextTickChannel=N;class P{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const K of F.connections)if(await Promise.resolve(this.fn(K.ctx)))return Promise.resolve(K);return await S.Event.toPromise(F.onDidAddConnection),await this.route(F)}}e.StaticRouter=P;var M;(function(x){function F(B,X){const Z=B,V=X&&X.disableMarshalling,G=new Map;for(const ie in Z)j(ie)&&G.set(ie,S.Event.buffer(Z[ie],!0));return new class{listen(ie,re,ae){const ue=G.get(re);if(ue)return ue;if(z(re)){const fe=Z[re];if(typeof fe=="function")return fe.call(Z,ae)}throw new Error(`Event not found: ${re}`)}call(ie,re,ae){const ue=Z[re];if(typeof ue=="function"){if(!V&&Array.isArray(ae))for(let fe=0;fe<ae.length;fe++)ae[fe]=(0,n.revive)(ae[fe]);return ue.apply(Z,ae)}throw new Error(`Method not found: ${re}`)}}}x.fromService=F;function K(B,X){const Z=X&&X.disableMarshalling;return new Proxy({},{get(V,G){if(typeof G=="string")return X?.properties?.has(G)?X.properties.get(G):z(G)?function(ie){return B.listen(G,ie)}:j(G)?B.listen(G):async function(...ie){let re;X&&!(0,g.isUndefinedOrNull)(X.context)?re=[X.context,...ie]:re=ie;const ae=await B.call(G,re);return Z?ae:(0,n.revive)(ae)};throw new Error(`Property not found: ${String(G)}`)}})}x.toService=K;function j(B){return B[0]==="o"&&B[1]==="n"&&I.isUpperAsciiLetter(B.charCodeAt(2))}function z(B){return/^onDynamic/.test(B)&&I.isUpperAsciiLetter(B.charCodeAt(9))}})(M=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){let F=x.toString();if(F!=="[object Object]")return F}return x}function H(x){return Array.isArray(x)?x.map(U):U(x)}function W(x,F,K,j,z,B,X){X=H(X);const Z=$[z],V=Z[j%Z.length];let G=[`%c[${x}]%c[${String(F).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(j).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${V}`];/\($/.test(B)?(G=G.concat(X),G.push(")")):G.push(X),console.log.apply(console,G)}e.logWithColors=W;class q{constructor(F,K){this._outgoingPrefix=F,this._incomingPrefix=K,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,K,j,z,B){this._totalOutgoing+=F,W(this._outgoingPrefix,this._totalOutgoing,F,K,j,z,B)}logIncoming(F,K,j,z,B){this._totalIncoming+=F,W(this._incomingPrefix,this._totalIncoming,F,K,j,z,B)}}e.IPCLogger=q}),define(te[114],ne([0,1,22,3,33]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(S){this.port=S,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",E=>D.VSBuffer.wrap(E.data)),S.start()}send(S){this.port.postMessage(S.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class k extends R.IPCClient{constructor(S,E){const n=new T(S);super(n,E);this.protocol=n}dispose(){this.protocol.disconnect()}}e.Client=k}),define(te[72],ne([0,1,22,3,2,4,31,33]),function(J,e,D,L,R,T,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var S;(function(r){r[r.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",r[r.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S=e.SocketCloseEventType||(e.SocketCloseEventType={}));let E=null;function n(){return E||(E=D.VSBuffer.alloc(0)),E}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(i){this._chunks.push(i),this._totalLength+=i.byteLength}read(i){return this._read(i,!0)}peek(i){return this._read(i,!1)}_read(i,a){if(i===0)return n();if(i>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===i){const m=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=i),m}if(this._chunks[0].byteLength>i){const m=this._chunks[0].slice(0,i);return a&&(this._chunks[0]=this._chunks[0].slice(i),this._totalLength-=i),m}let o=D.VSBuffer.alloc(i),u=0,h=0;for(;i>0;){const m=this._chunks[h];if(m.byteLength>i){const A=m.slice(0,i);o.set(A,u),u+=i,a&&(this._chunks[h]=m.slice(i),this._totalLength-=i),i-=i}else o.set(m,u),u+=m.byteLength,a?(this._chunks.shift(),this._totalLength-=m.byteLength):h++,i-=m.byteLength}return o}}e.ChunkStream=I;var g;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(g||(g={}));var w;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(w=e.ProtocolConstants||(e.ProtocolConstants={}));class f{constructor(i,a,o,u){this.type=i,this.id=a,this.ack=o,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends R.Disposable{constructor(i){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=i,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(i);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5);else{const o=this._state.messageType,u=this._state.id,h=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new f(o,u,h,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class d{constructor(i){this._isDisposed=!1,this._socket=i,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(i){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(i){if(this._isDisposed)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=D.VSBuffer.alloc(13);a.writeUInt8(i.type,0),a.writeUInt32BE(i.id,1),a.writeUInt32BE(i.ack,5),a.writeUInt32BE(i.data.byteLength,9),this._writeSoon(a,i.data)}_bufferAdd(i,a){const o=this._totalLength===0;return this._data.push(i,a),this._totalLength+=i.byteLength+a.byteLength,o}_bufferTake(){const i=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,i}_writeSoon(i,a){this._bufferAdd(i,a)&&T.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class b extends R.Disposable{constructor(i){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=i,this._socketWriter=this._register(new d(this._socket)),this._socketReader=this._register(new p(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(i){this._socketWriter.write(new f(1,0,0,i))}}e.Protocol=b;class y extends C.IPCClient{constructor(i,a,o=null){super(i,a,o);this.protocol=i}static fromSocket(i,a){return new y(new b(i),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const i=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),i.end()}}e.Client=y;class v{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,k.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(i){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(i):this._emitter.fire(i):this._bufferedMessages.push(i)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=v;class l{constructor(i){this.data=i,this.next=null}}class c{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let i=[],a=0,o=this._first;for(;o;)i[a++]=o.data,o=o.next;return i}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(i){const a=new l(i);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class t{constructor(){this.lastRuns=[];const i=Date.now();for(let a=0;a<t._HISTORY_LENGTH;a++)this.lastRuns[a]=i-1e3*a;setInterval(()=>{for(let a=t._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const i=Date.now(),a=(1+t._HISTORY_LENGTH)*1e3;let o=0;for(let u=0;u<t._HISTORY_LENGTH;u++)i-this.lastRuns[u]<=a&&o++;return 1-o/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class s{constructor(i,a=null,o=t.getInstance()){this._onControlMessage=new v,this.onControlMessage=this._onControlMessage.event,this._onMessage=new v,this.onMessage=this._onMessage.event,this._onDidDispose=new v,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new v,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new v,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=o,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=i,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),a&&this._socketReader.acceptChunk(a),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,R.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const i=new f(5,0,0,n());this._socketWriter.write(i),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const i=Date.now()-this._socketWriter.lastWriteTime;if(i>=5e3){const a=new f(4,0,0,n());this._socketWriter.write(a),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-i+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const i=Date.now()-this._socketReader.lastReadTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-i,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(i,a){this._isReconnecting=!0,this._socketDisposables=(0,R.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=i,this._socketWriter=new d(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(o=>this._receiveMessage(o))),this._socketDisposables.push(this._socket.onClose(o=>this._onSocketClose.fire(o))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1;const i=this._outgoingUnackMsg.toArray();for(let a=0,o=i.length;a<o;a++)this._socketWriter.write(i[a]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(i){if(i.ack>this._outgoingAckId){this._outgoingAckId=i.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=i.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(i.type===1){if(i.id>this._incomingMsgId)if(i.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new f(6,0,0,n())))}else this._incomingMsgId=i.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(i.data)}else if(i.type===2)this._onControlMessage.fire(i.data);else if(i.type===5)this._onDidDispose.fire();else if(i.type===6){const a=this._outgoingUnackMsg.toArray();for(let o=0,u=a.length;o<u;o++)this._socketWriter.write(a[o]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(i){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const o=new f(1,a,this._incomingAckId,i);this._outgoingUnackMsg.push(o),this._isReconnecting||(this._socketWriter.write(o),this._recvAckCheck())}sendControl(i){const a=new f(2,0,0,i);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const i=Date.now()-this._incomingMsgLastTime;if(i>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-i+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const i=this._outgoingUnackMsg.peek(),a=Date.now()-i.writtenTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-a,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const i=new f(3,0,this._incomingAckId,n());this._socketWriter.write(i)}}e.PersistentProtocol=s}),define(te[115],ne([0,1,116,3,33,114]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class k extends R.IPCServer{static getOnDidClientConnect(){const S=L.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(E,n)=>n);return L.Event.map(S,E=>{const{port1:n,port2:I}=new MessageChannel,w={protocol:new T.Protocol(n),onDidClientDisconnect:L.Event.fromDOMEventEmitter(n,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",E,[I]),w})}constructor(){super(k.getOnDidClientConnect())}}e.Server=k}),define(te[117],ne([0,1,22,9]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function R(C,S){C.proxyAuthorization&&(C.headers={...C.headers||{},"Proxy-Authorization":C.proxyAuthorization});const E=new XMLHttpRequest;return new Promise((n,I)=>{E.open(C.type||"GET",C.url||"",!0,C.user,C.password),T(E,C),E.responseType="arraybuffer",E.onerror=g=>I(new Error(E.statusText&&"XHR failed: "+E.statusText||"XHR failed")),E.onload=g=>{n({res:{statusCode:E.status,headers:k(E)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(E.response)))})},E.ontimeout=g=>I(new Error(`XHR timeout: ${C.timeout}ms`)),C.timeout&&(E.timeout=C.timeout),E.send(C.data),S.onCancellationRequested(()=>{E.abort(),I((0,L.canceled)())})})}e.request=R;function T(C,S){if(S.headers){e:for(let E in S.headers){switch(E){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}C.setRequestHeader(E,S.headers[E])}}}function k(C){const S=Object.create(null);for(const E of C.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(E){const n=E.indexOf(":");S[E.substr(0,n).trim().toLowerCase()]=E.substr(n+1).trim()}return S}}),define(te[73],ne([0,1,6,3,2,18]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));function C(I){const g=I;return g?.changed instanceof Map||g?.deleted instanceof Set}e.isStorageItemsChangeEvent=C;var S;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(S||(S={}));class E extends R.Disposable{constructor(g,w=Object.create(null)){super();this.database=g,this.options=w,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=S.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(E.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){g.changed?.forEach((w,f)=>this.accept(f,w)),g.deleted?.forEach(w=>this.accept(w,void 0))}accept(g,w){if(this.state===S.Closed)return;let f=!1;(0,T.isUndefinedOrNull)(w)?f=this.cache.delete(g):this.cache.get(g)!==w&&(this.cache.set(g,w),f=!0),f&&this._onDidChangeStorage.fire(g)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===S.None&&(this.state=S.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,w){const f=this.cache.get(g);return(0,T.isUndefinedOrNull)(f)?w:f}getBoolean(g,w){const f=this.get(g);return(0,T.isUndefinedOrNull)(f)?w:f==="true"}getNumber(g,w){const f=this.get(g);return(0,T.isUndefinedOrNull)(f)?w:parseInt(f,10)}async set(g,w){if(this.state===S.Closed)return;if((0,T.isUndefinedOrNull)(w))return this.delete(g);const f=String(w);if(this.cache.get(g)!==f)return this.cache.set(g,f),this.pendingInserts.set(g,f),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async delete(g){if(!(this.state===S.Closed||!this.cache.delete(g)))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=S.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(g){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=E,E.DEFAULT_FLUSH_DELAY=100;class n{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((w,f)=>this.items.set(f,w)),g.delete&&g.delete.forEach(w=>this.items.delete(w))}async close(){}}e.InMemoryStorageDatabase=n}),define(te[118],ne([11,12]),function(J,e){return J.create("vs/base/common/date",e)}),define(te[57],ne([0,1,118]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,R=L*60,T=R*24,k=T*7,C=T*30,S=T*365;function E(I,g){typeof I!="number"&&(I=I.getTime());const w=Math.round((new Date().getTime()-I)/1e3);if(w<-30)return(0,D.localize)(0,null,E(new Date().getTime()+w*1e3,!1));if(w<30)return(0,D.localize)(1,null);let f;return w<L?(f=w,g?f===1?(0,D.localize)(2,null,f):(0,D.localize)(3,null,f):f===1?(0,D.localize)(4,null,f):(0,D.localize)(5,null,f)):w<R?(f=Math.floor(w/L),g?f===1?(0,D.localize)(6,null,f):(0,D.localize)(7,null,f):f===1?(0,D.localize)(8,null,f):(0,D.localize)(9,null,f)):w<T?(f=Math.floor(w/R),g?f===1?(0,D.localize)(10,null,f):(0,D.localize)(11,null,f):f===1?(0,D.localize)(12,null,f):(0,D.localize)(13,null,f)):w<k?(f=Math.floor(w/T),g?f===1?(0,D.localize)(14,null,f):(0,D.localize)(15,null,f):f===1?(0,D.localize)(16,null,f):(0,D.localize)(17,null,f)):w<C?(f=Math.floor(w/k),g?f===1?(0,D.localize)(18,null,f):(0,D.localize)(19,null,f):f===1?(0,D.localize)(20,null,f):(0,D.localize)(21,null,f)):w<S?(f=Math.floor(w/C),g?f===1?(0,D.localize)(22,null,f):(0,D.localize)(23,null,f):f===1?(0,D.localize)(24,null,f):(0,D.localize)(25,null,f)):(f=Math.floor(w/S),g?f===1?(0,D.localize)(26,null,f):(0,D.localize)(27,null,f):f===1?(0,D.localize)(28,null,f):(0,D.localize)(29,null,f))}e.fromNow=E;function n(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(te[119],ne([11,12]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(te[38],ne([0,1,17,18,119]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(E,n){return n&&(E.stack||E.stacktrace)?R.localize(0,null,C(E),k(E.stack)||k(E.stacktrace)):C(E)}function k(E){return Array.isArray(E)?E.join(`
`):E}function C(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?R.localize(1,null,E.message):E.message||R.localize(2,null)}function S(E=null,n=!1){if(!E)return R.localize(3,null);if(Array.isArray(E)){const I=D.coalesce(E),g=S(I[0],n);return I.length>1?R.localize(4,null,g,I.length):g}if(L.isString(E))return E;if(E.detail){const I=E.detail;if(I.error)return T(I.error,n);if(I.exception)return T(I.exception,n)}return E.stack?T(E,n):E.message?E.message:R.localize(5,null)}e.toErrorMessage=S}),define(te[120],ne([11,12]),function(J,e){return J.create("vs/base/node/processes",e)}),define(te[74],ne([0,1,37,40,15,26,8,4,31,101,18,70,19,120]),function(J,e,D,L,R,T,k,C,S,E,n,I,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return E.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return E.TerminateResponseCode}});function f(c){switch(c){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function p(c,t){if(C.isWindows)try{const s={stdio:["pipe","pipe","ignore"]};t&&(s.cwd=t);const r=D.execFile("taskkill",["/T","/F","/PID",c.pid.toString()],s);return new Promise(i=>{r.once("error",a=>{i({success:!1,error:a})}),r.once("exit",(a,o)=>{i(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(s){return Promise.resolve({success:!1,error:s,code:s.status?f(s.status):1})}else if(C.isLinux||C.isMacintosh)try{const s=R.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(r=>{D.execFile(s,[c.pid.toString()],{encoding:"utf8",shell:!0},(i,a,o)=>{r(i?{success:!1,error:i}:{success:!0})})})}catch(s){return Promise.resolve({success:!1,error:s})}else c.kill("SIGKILL");return Promise.resolve({success:!0})}function d(c=S.env){return c.comspec||"cmd.exe"}e.getWindowsShell=d;class b{constructor(t,s,r,i){if(s!==void 0&&r!==void 0&&i!==void 0)this.cmd=t,this.args=s,this.shell=r,this.options=i;else{const a=t;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(S.env).forEach(o=>{a[o]=S.env[o]}),Object.keys(this.options.env).forEach(o=>{a[o]=this.options.env[o]}),this.options.env=a}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const s=t.lastIndexOf(k.sep);return s!==-1&&(t=t.substring(s+1)),b.WellKnowCommands[t]?t:"other"}start(t){return C.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(S.cwd()))?Promise.reject(new Error(w.localize(0,null))):this.useExec().then(s=>{let r,i;const a=new Promise((o,u)=>{r=o,i=u});if(s){let o=this.cmd;this.args&&(o=o+" "+this.args.join(" ")),this.childProcess=D.exec(o,this.options,(u,h,m)=>{this.childProcess=null;const A=u;A&&A.killed?i({killed:this.terminateRequested,stdout:h.toString(),stderr:m.toString()}):this.handleExec(r,t,u,h,m)})}else{let o=null;const u=h=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(h,r,t,i);const m={terminated:this.terminateRequested};n.isNumber(h)&&(m.cmdCode=h),r(m)};if(this.shell&&C.isWindows){const h=T.deepClone(this.options);h.windowsVerbatimArguments=!0,h.detached=!1;let m=!1,A=!1;const _=[];let O=this.ensureQuotes(this.cmd);_.push(O.value),m=O.quoted,this.args&&this.args.forEach(P=>{O=this.ensureQuotes(P),_.push(O.value),A=A&&O.quoted});const N=["/s","/c"];m?A?N.push('"'+_.join(" ")+'"'):_.length>1?N.push('"'+_[0]+'" '+_.slice(1).join(" ")):N.push('"'+_[0]+'"'):N.push(_.join(" ")),o=D.spawn(d(),N,h)}else this.cmd&&(o=D.spawn(this.cmd,this.args,this.options));o&&(this.childProcess=o,this.childProcessPromise=Promise.resolve(o),this.pidResolve&&(this.pidResolve(n.isNumber(o.pid)?o.pid:-1),this.pidResolve=void 0),o.on("error",h=>{this.childProcess=null,i({terminated:this.terminateRequested,error:h})}),o.pid&&(this.childProcess.on("close",u),this.handleSpawn(o,r,t,i,!0)))}return a})}handleClose(t,s,r,i){}ensureQuotes(t){return b.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,p(t,this.options.cwd).then(s=>(s.success&&(this.childProcess=null),s))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!C.isWindows)return t(!1);const s=D.spawn(d(),["/s","/c"]);s.on("error",r=>t(!0)),s.on("exit",r=>t(!1))})}}e.AbstractProcess=b,b.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},b.regexp=/^[^"].* .*[^"]/;class y extends b{constructor(t,s,r,i){super(t,s,r,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,s,r,i,a){[i,a].forEach((o,u)=>{const h=new I.LineDecoder;h.write(o).forEach(_=>{s({line:_,source:u===0?0:1})});const A=h.end();A&&s({line:A,source:u===0?0:1})}),t({terminated:this.terminateRequested,error:r})}handleSpawn(t,s,r,i,a){const o=new I.LineDecoder,u=new I.LineDecoder;t.stdout.on("data",h=>{o.write(h).forEach(A=>r({line:A,source:0}))}),t.stderr.on("data",h=>{u.write(h).forEach(A=>r({line:A,source:1}))}),this.stdoutLineDecoder=o,this.stderrLineDecoder=u}handleClose(t,s,r,i){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&r({line:a,source:0});const o=this.stderrLineDecoder?this.stderrLineDecoder.end():null;o&&r({line:o,source:1})}}e.LineProcess=y;function v(c){let t=[],s=!1;const r=function(i){if(s){t.push(i);return}(!c.send(i,o=>{if(o&&console.error(o),s=!1,t.length>0){const u=t.slice(0);t=[],u.forEach(h=>r(h))}})||C.isWindows)&&(s=!0)};return{send:r}}e.createQueuedSender=v;var l;(function(c){async function t(s,r,i){if(k.isAbsolute(s))return s;if(r===void 0&&(r=S.cwd()),k.dirname(s)!=="."||(i===void 0&&n.isString(S.env.PATH)&&(i=S.env.PATH.split(k.delimiter)),i===void 0||i.length===0))return k.join(r,s);async function o(u){if(await g.Promises.exists(u)){let h;try{h=await g.Promises.stat(u)}catch(m){m.message.startsWith("EACCES")&&(h=await g.Promises.lstat(u))}return h?!h.isDirectory():!1}return!1}for(let u of i){let h;if(k.isAbsolute(u)?h=k.join(u,s):h=k.join(r,u,s),await o(h))return h;let m=h+".com";if(await o(m)||(m=h+".exe",await o(m)))return m}return k.join(r,s)}c.findExecutable=t})(l=e.win32||(e.win32={}))}),define(te[121],ne([0,1,32,4,71,74]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(w,f){return w===1?L.isWindows?I():T.getWindowsShell(f):E(w,f)}e.getSystemShell=k;function C(w,f){return w===1?L.isWindows?g(f):T.getWindowsShell(f):E(w,f)}e.getSystemShellSync=C;let S=null;function E(w,f){if(L.isLinux&&w===2||L.isMacintosh&&w===3)return"/bin/bash";if(!S){let p;if(L.isWindows)p="/bin/bash";else{if(p=f.SHELL,!p)try{p=(0,D.userInfo)().shell}catch(d){}p||(p="sh"),p==="/bin/false"&&(p="/bin/bash")}S=p}return S}let n=null;async function I(){return n||(n=(await(0,R.getFirstAvailablePowerShellInstallation)()).exePath),n}function g(w){if(n)return n;const f=L.isWindows&&parseFloat((0,D.release)())>=10,p=w.hasOwnProperty("PROCESSOR_ARCHITEW6432"),d=`${w.windir}\\${p?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return f?d:T.getWindowsShell(w)}}),define(te[52],ne([0,1,37,6,22,27,103,9,3,2,26,4,74,33]),function(J,e,D,L,R,T,k,C,S,E,n,I,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends w.ChannelServer{constructor(b){super({send:y=>{try{process.send&&process.send(y.buffer.toString("base64"))}catch(v){}},onMessage:S.Event.fromNodeEventEmitter(process,"message",y=>R.VSBuffer.wrap(Buffer.from(y,"base64")))},b);process.once("disconnect",()=>this.dispose())}}e.Server=f;class p{constructor(b,y){this.modulePath=b,this.options=y,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new S.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=y&&y.timeout?y.timeout:6e4;this.disposeDelayer=new L.Delayer(v),this.child=null,this._client=null}getChannel(b){const y=this;return{call(v,l,c){return y.requestPromise(b,v,l,c)},listen(v,l){return y.requestEvent(b,v,l)}}}requestPromise(b,y,v,l=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(C.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(b),t=(0,L.createCancelablePromise)(i=>c.call(y,v,i)),s=l.onCancellationRequested(()=>t.cancel()),r=(0,E.toDisposable)(()=>t.cancel());return this.activeRequests.add(r),t.finally(()=>{s.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(b,y,v){if(!this.disposeDelayer)return S.Event.None;this.disposeDelayer.cancel();let l;const c=new S.Emitter({onFirstListenerAdd:()=>{l=this.getCachedChannel(b).listen(y,v)(c.fire,c),this.activeRequests.add(l)},onLastListenerRemove:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],y=Object.create(null);y.env={...(0,n.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(y.env={...y.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(y.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(y.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(y.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),y.execArgv===void 0&&(y.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),I.isMacintosh&&y.env&&delete y.env.DYLD_LIBRARY_PATH,this.child=(0,D.fork)(this.modulePath,b,y);const v=new S.Emitter;S.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,k.isRemoteConsoleLog)(a)){(0,k.log)(a,`IPC Library: ${this.options.serverName}`);return}v.fire(R.VSBuffer.wrap(Buffer.from(a,"base64")))});const c=this.options.useQueue?(0,g.createQueuedSender)(this.child):this.child,t=a=>this.child&&this.child.connected&&c.send(a.buffer.toString("base64")),s=v.event,r={send:t,onMessage:s};this._client=new w.ChannelClient(r);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,o)=>{process.removeListener("exit",i),this.activeRequests.forEach(u=>(0,E.dispose)(u)),this.activeRequests.clear(),a!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:o})})}return this._client}getCachedChannel(b){let y=this.channels.get(b);return y||(y=this.client.getChannel(b),this.channels.set(b,y)),y}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=p}),define(te[122],ne([11,12]),function(J,e){return J.create("vs/base/node/zip",e)}),define(te[123],ne([11,12]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[124],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(te[125],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(te[126],ne([11,12]),function(J,e){return J.create("vs/platform/environment/node/shellEnv",e)}),define(te[127],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[128],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[129],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[130],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[131],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[132],ne([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[133],ne([11,12]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[134],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(te[135],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(te[136],ne([11,12]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(te[137],ne([11,12]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[138],ne([11,12]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(te[139],ne([11,12]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[140],ne([11,12]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[141],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[142],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[143],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[144],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[145],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[146],ne([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[75],ne([0,1,57,66,15,8,31,16,7]),function(J,e,D,L,R,T,k,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class E{constructor(p,d,b){this._args=p,this.paths=d,this.productService=b}get appRoot(){return(0,T.dirname)(R.FileAccess.asFileUri("",J).fsPath)}get userHome(){return S.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return S.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return S.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,C.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,C.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const p=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",p)}return this.args.logsPath}get userDataSyncLogResource(){return S.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.joinPath)(S.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return S.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return S.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=k.env.VSCODE_PORTABLE;return p?S.URI.file((0,T.join)(p,"argv.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,C.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return S.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,T.resolve)(p):(0,T.normalize)((0,T.join)(R.FileAccess.asFileUri("",J).fsPath,"..","extensions"))}get extensionsDownloadPath(){const p=this.args["extensions-download-dir"];return p?(0,T.resolve)(p):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,T.resolve)(p);const d=k.env.VSCODE_EXTENSIONS;if(d)return d;const b=k.env.VSCODE_PORTABLE;return b?(0,T.join)(b,"extensions"):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(d=>/^[^:/?#]+?:\/\//.test(d)?S.URI.parse(d):S.URI.file((0,T.normalize)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?S.URI.parse(p):S.URI.file((0,T.normalize)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,C.joinPath)(S.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return S.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([L.memoize],E.prototype,"appRoot",null),he([L.memoize],E.prototype,"userHome",null),he([L.memoize],E.prototype,"userDataPath",null),he([L.memoize],E.prototype,"appSettingsHome",null),he([L.memoize],E.prototype,"tmpDir",null),he([L.memoize],E.prototype,"userRoamingDataHome",null),he([L.memoize],E.prototype,"settingsResource",null),he([L.memoize],E.prototype,"userDataSyncHome",null),he([L.memoize],E.prototype,"userDataSyncLogResource",null),he([L.memoize],E.prototype,"sync",null),he([L.memoize],E.prototype,"machineSettingsResource",null),he([L.memoize],E.prototype,"globalStorageHome",null),he([L.memoize],E.prototype,"workspaceStorageHome",null),he([L.memoize],E.prototype,"keybindingsResource",null),he([L.memoize],E.prototype,"keyboardLayoutResource",null),he([L.memoize],E.prototype,"argvResource",null),he([L.memoize],E.prototype,"snippetsHome",null),he([L.memoize],E.prototype,"isExtensionDevelopment",null),he([L.memoize],E.prototype,"untitledWorkspacesHome",null),he([L.memoize],E.prototype,"installSourcePath",null),he([L.memoize],E.prototype,"builtinExtensionsPath",null),he([L.memoize],E.prototype,"extensionsPath",null),he([L.memoize],E.prototype,"extensionDevelopmentLocationURI",null),he([L.memoize],E.prototype,"extensionDevelopmentKind",null),he([L.memoize],E.prototype,"extensionTestsLocationURI",null),he([L.memoize],E.prototype,"debugExtensionHost",null),he([L.memoize],E.prototype,"serviceMachineIdResource",null),he([L.memoize],E.prototype,"telemetryLogResource",null),he([L.memoize],E.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=E;function n(f,p){return w(f["inspect-extensions"],f["inspect-brk-extensions"],5870,p,f.debugId,f.extensionEnvironment)}e.parseExtensionHostPort=n;function I(f,p){return w(f["inspect-search"],f["inspect-brk-search"],5876,p,f.extensionEnvironment)}e.parseSearchPort=I;function g(f,p){return w(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,p,f.extensionEnvironment)}e.parsePtyHostPort=g;function w(f,p,d,b,y,v){const c=Number(p||f)||(b?null:d),t=c?Boolean(!!p):!1;let s;if(v)try{s=JSON.parse(v)}catch{}return{port:c,break:t,debugId:y,env:s}}}),define(te[147],ne([0,1,237,4,124]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,R.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(14,null)},category:{type:"string",cat:"e",description:(0,R.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,R.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,R.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,R.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,R.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,R.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,R.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,R.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{}};function C(f,p,d=k){const b={},y=[],v=[];for(let s in p){const r=p[s];r.alias&&(b[s]=r.alias),r.type==="string"||r.type==="string[]"?(y.push(s),r.deprecates&&y.push(r.deprecates)):r.type==="boolean"&&(v.push(s),r.deprecates&&v.push(r.deprecates))}const l=D(f,{string:y,boolean:v,alias:b}),c={},t=l;c._=l._.map(s=>String(s)).filter(s=>s.length>0),delete t._;for(let s in p){const r=p[s];r.alias&&delete t[r.alias];let i=t[s];r.deprecates&&t.hasOwnProperty(r.deprecates)&&(i||(i=t[r.deprecates]),delete t[r.deprecates]),typeof i!="undefined"&&(r.type==="string[]"?i&&!Array.isArray(i)&&(i=[i]):r.type==="string"&&Array.isArray(i)&&(i=i.pop(),d.onMultipleValues(s,i)),c[s]=i),delete t[s]}for(let s in t)d.onUnknownOption(s);return c}e.parseArgs=C;function S(f,p){let d="";return p.args&&(Array.isArray(p.args)?d=` <${p.args.join("> <")}>`:d=` <${p.args}>`),p.alias?`-${p.alias} --${f}${d}`:`--${f}${d}`}function E(f,p){let d=0,b=[];for(const c in f){const t=f[c],s=S(c,t);d=Math.max(d,s.length),b.push([s,t.description])}let y=d+2+1;if(p-y<25)return b.reduce((c,t)=>c.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let v=p-y-1,l=[];for(const c of b){let t=c[0],s=I(c[1],v),r=n(y-t.length-2);l.push("  "+t+r+s[0]);for(let i=1;i<s.length;i++)l.push(n(y)+s[i])}return l}e.formatOptions=E;function n(f){return" ".repeat(f)}function I(f,p){let d=[];for(;f.length;){let b=f.length<p?f.length:f.lastIndexOf(" ",p),y=f.slice(0,b).trim();f=f.slice(b),d.push(y)}return d}function g(f,p,d,b,y=!0){const v=process.stdout.isTTY&&process.stdout.columns||80;let l=[`${f} ${d}`];l.push(""),l.push(`${(0,R.localize)(32,null)}: ${p} [${(0,R.localize)(33,null)}][${(0,R.localize)(34,null)}...]`),l.push(""),y&&(L.isWindows?l.push((0,R.localize)(35,null,p)):l.push((0,R.localize)(36,null,p)),l.push(""));const c={};for(const t in b){const s=b[t];if(s.description&&s.cat){let r=c[s.cat];r||(c[s.cat]=r={}),r[t]=s}}for(let t in c){const s=t;let r=c[s];r&&(l.push(T[s]),l.push(...E(r,v)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=g;function w(f,p){return`${f||(0,R.localize)(37,null)}
${p||(0,R.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=w}),function(){"use strict";function J(e,D,L,R){function T(C){const S=k(C),E=[S];return e.isAbsolute(S)||E.unshift(R),e.resolve(...E)}function k(C){const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,L);const n=C["user-data-dir"];if(n)return n;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(I,"AppData","Roaming")}break;case"darwin":E=e.join(D.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,L)}return{getUserDataPath:T}}if(typeof define=="function")define(te[148],ne([0,238,32,15,16,31]),function(e,D,L,R,T,k){const C=T.dirname(R.FileAccess.asFileUri("",e)),S=e.__$__nodeRequire(T.joinPath(C,"package.json").fsPath);return J(D,L,S.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),L=require("os");module.exports=J(D,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[149],ne([0,1,32,75,148]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends L.AbstractNativeEnvironmentService{constructor(C,S){super(C,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,R.getUserDataPath)(C)},S)}}e.NativeEnvironmentService=T}),define(te[150],ne([0,1,7]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const L=/^([^@:]+@)?([^:]+):/,R=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,k=/([^@:.]+\.[^@:.]+)(:\d+)?$/,C=/^\s*url\s*=\s*(.+\S)\s*$/mg,S=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function E(d){const b=d.match(k);return b?b[1]:null}function n(d){if(d.indexOf("://")===-1){const b=d.match(L);return b?E(b[2]):null}try{const b=D.URI.parse(d);if(b.authority)return E(b.authority)}catch(b){}return null}function I(d,b){const y=new Set;let v;for(;v=C.exec(d);){const c=n(v[1]);c&&y.add(c)}const l=new Set(b);return Array.from(y).map(c=>l.has(c)?c:c.replace(S,"a"))}e.getDomainsOfRemotes=I;function g(d){const b=d.match(T);return b?b[2]:null}function w(d,b,y){return d&&b?(y&&b.endsWith(".git")&&(b=b.substr(0,b.length-4)),b.indexOf("/")===0?`${d}${b}`:`${d}/${b}`):null}function f(d,b){if(d.indexOf("://")===-1){const y=d.match(R);if(y)return w(y[2],y[3],b)}try{const y=D.URI.parse(d);if(y.authority)return w(g(y.authority),y.path,b)}catch(y){}return null}function p(d,b=!1){const y=[];let v;for(;v=C.exec(d);){const l=f(v[1],b);l&&y.push(l)}return y}e.getRemotes=p}),define(te[151],ne([0,1,26]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const L=/^%([\w\d.-]+)%$/i;function R(T,k){const C=S=>{if(typeof S!="string")return;const E=L.exec(S);if(!E)return;const n=k[E[1]]??S;return typeof n=="string"?n:typeof n.message=="string"?n.message:S};return(0,D.cloneAndChange)(T,C)}e.localizeManifest=R}),define(te[152],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,k,C,S){return this.channel.call("promptImportantExtensionsInstallNotification",[T,k,C,S])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class L{constructor(T){this.service=T}listen(T,k){throw new Error(`Event not found: ${k}`)}call(T,k,C){switch(k){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(C[0],C[1],C[2],C[3])}throw new Error(`Call not found: ${k}`)}}e.ExtensionRecommendationNotificationServiceChannel=L}),define(te[76],ne([0,1,133]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function T(g){return g=g.trim(),g==="*"||L.test(g)}e.isValidVersionStr=T;function k(g){if(!T(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let w=g.match(L);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}e.parseVersion=k;function C(g){if(!g)return null;let w=g.majorBase,f=g.majorMustEqual,p=g.minorBase,d=g.minorMustEqual,b=g.patchBase,y=g.patchMustEqual;g.hasCaret&&(w===0||(d=!1),y=!1);let v=0;if(g.preRelease){const l=R.exec(g.preRelease);if(l){const[,c,t,s]=l;v=Date.UTC(Number(c),Number(t)-1,Number(s))}}return{majorBase:w,majorMustEqual:f,minorBase:p,minorMustEqual:d,patchBase:b,patchMustEqual:y,isMinimum:g.hasGreaterEquals,notBefore:v}}e.normalizeVersion=C;function S(g,w,f){let p;typeof g=="string"?p=C(k(g)):p=g;let d;w instanceof Date?d=w.getTime():typeof w=="string"&&(d=new Date(w).getTime());let b;if(typeof f=="string"?b=C(k(f)):b=f,!p||!b)return!1;let y=p.majorBase,v=p.minorBase,l=p.patchBase,c=b.majorBase,t=b.minorBase,s=b.patchBase,r=b.notBefore,i=b.majorMustEqual,a=b.minorMustEqual,o=b.patchMustEqual;return b.isMinimum?y>c?!0:y<c?!1:v>t?!0:v<t||d&&d<r?!1:l>=s:(y===1&&c===0&&(!i||!a||!o)&&(c=1,t=0,s=0,i=!0,a=!1,o=!1),y<c?!1:y>c?!i:v<t?!1:v>t?!a:l<s?!1:l>s?!o:!(d&&d<r))}e.isValidVersion=S;function E(g,w,f,p){return f.isBuiltin||typeof f.main=="undefined"?!0:I(g,w,f.engines.vscode,p)}e.isValidExtensionVersion=E;function n(g,w,f){return g==="*"||I(w,f,g)}e.isEngineValid=n;function I(g,w,f,p=[]){let d=C(k(f));if(!d)return p.push(D.localize(0,null,f)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return p.push(D.localize(1,null,f)),!1}else if(!d.majorMustEqual)return p.push(D.localize(2,null,f)),!1;return S(g,w,d)?!0:(p.push(D.localize(3,null,g,f)),!1)}}),define(te[153],ne([0,1,2,15,33,52]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends D.Disposable{constructor(S,E,n,I){super();this.requests=S,this.onDidFilesChange=E,this.onLogMessage=n,this.verboseLogging=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const S=this._register(new T.Client(L.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(S.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=R.ProxyChannel.toService((0,R.getNextTickChannel)(S.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(E=>!this.isDisposed&&this.onDidFilesChange(E))),this._register(this.service.onDidLogMessage(E=>this.onLogMessage(E))),this.watch(this.requests)}setVerboseLogging(S){this.verboseLogging=S,this.isDisposed||this.service?.setVerboseLogging(S)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${S}`})}watch(S){this.requests=S,this.service?.watch(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(te[154],ne([0,1,2,15,33,52]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends D.Disposable{constructor(S,E,n,I,g={}){super();this.folders=S,this.onDidFilesChange=E,this.onLogMessage=n,this.verboseLogging=I,this.watcherOptions=g,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const S=this._register(new T.Client(L.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(S.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=R.ProxyChannel.toService((0,R.getNextTickChannel)(S.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(E=>!this.isDisposed&&this.onDidFilesChange(E))),this._register(this.service.onDidLogMessage(E=>this.onLogMessage(E))),this.service.watch(this.folders)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${S}`})}setVerboseLogging(S){this.verboseLogging=S,this.service&&this.service.setVerboseLogging(S)}watch(S){this.folders=S,this.service&&this.service.watch(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(te[155],ne([0,1,37,69,15,70]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class k{constructor(S,E,n,I,g){this.watchedFolder=S,this.eventCallback=n,this.logCallback=I,this.verboseLogging=g,this.restartCounter=0,Array.isArray(E)?this.ignored=E.map(w=>(0,L.parse)(w)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${S}, excludes: ${E.join(",")}`),this.startWatcher()}startWatcher(){const S=[this.watchedFolder];this.verboseLogging&&S.push("-verbose"),this.handle=(0,D.spawn)(R.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",J).fsPath,S);const E=new T.LineDecoder;this.handle.stdout.on("data",n=>{const I=[];for(const g of E.write(n)){const w=g.split("|");if(w.length===2){const f=Number(w[0]),p=w[1];if(f>=0&&f<3){if(this.ignored&&this.ignored.some(d=>d(p))){this.verboseLogging&&this.log(p);continue}I.push({type:k.changeTypeMap[f],path:p})}else this.log(w[1])}}I.length>0&&this.eventCallback(I)}),this.handle.on("error",n=>this.onError(n)),this.handle.stderr.on("data",n=>this.onError(n)),this.handle.on("exit",(n,I)=>this.onExit(n,I))}onError(S){this.error("process error: "+S.toString())}onExit(S,E){this.handle&&(this.error(`terminated unexpectedly (code: ${S}, signal: ${E})`),this.restartCounter<=k.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(S){this.logCallback({type:"error",message:`[File Watcher (C#)] ${S}`})}log(S){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${S}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=k,k.MAX_RESTARTS=5,k.changeTypeMap=[0,1,2]}),define(te[156],ne([0,1,8,25,155]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class T{constructor(C,S,E,n){this.onDidFilesChange=S,this.onLogMessage=E,this.verboseLogging=n,this.service=void 0,this.folder=C[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(D.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,D.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new R.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,C=>this.onFileEvents(C),C=>this.onLogMessage(C),this.verboseLogging)}setVerboseLogging(C){this.verboseLogging=C,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(C){this.isDisposed||C.length>0&&this.onDidFilesChange(C)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=T}),define(te[53],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(R,T=[],k=!1){this.ctor=R,this.staticArguments=T,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=D}),define(te[77],ne([0,1,53]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function R(k,C,S){C instanceof D.SyncDescriptor||(C=new D.SyncDescriptor(C,[],S)),L.push([k,C])}e.registerSingleton=R;function T(){return L}e.getSingletonServiceDescriptors=T}),define(te[157],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=D;class L{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let k of this._nodes.values())k.outgoing.size===0&&T.push(k);return T}insertEdge(T,k){const C=this.lookupOrInsertNode(T),S=this.lookupOrInsertNode(k);C.outgoing.set(this._hashFn(k),S),S.incoming.set(this._hashFn(T),C)}removeNode(T){const k=this._hashFn(T);this._nodes.delete(k);for(let C of this._nodes.values())C.outgoing.delete(k),C.incoming.delete(k)}lookupOrInsertNode(T){const k=this._hashFn(T);let C=this._nodes.get(k);return C||(C=new D(T),this._nodes.set(k,C)),C}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[k,C]of this._nodes)T.push(`${k}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,k]of this._nodes){const C=new Set([T]),S=this._findCycle(k,C);if(S)return S}}_findCycle(T,k){for(let[C,S]of T.outgoing){if(k.has(C))return[...k,C].join(" -> ");k.add(C);const E=this._findCycle(S,k);if(E)return E;k.delete(C)}}}e.Graph=L}),define(te[5],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function S(E){return E[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=S})(D=e._util||(e._util={})),e.IInstantiationService=R("instantiationService");function L(C,S,E,n){S[D.DI_TARGET]===S?S[D.DI_DEPENDENCIES].push({id:C,index:E,optional:n}):(S[D.DI_DEPENDENCIES]=[{id:C,index:E,optional:n}],S[D.DI_TARGET]=S)}function R(C){if(D.serviceIds.has(C))return D.serviceIds.get(C);const S=function(E,n,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(S,E,I,!1)};return S.toString=()=>C,D.serviceIds.set(C,S),S}e.createDecorator=R;function T(C){return C}e.refineServiceDecorator=T;function k(C){return function(S,E,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(C,S,n,!0)}}e.optional=k}),define(te[158],ne([0,1,5]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(te[159],ne([0,1,4,25,5]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=D.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",D.isMacintosh),k.set("isLinux",D.isLinux),k.set("isWindows",D.isWindows),k.set("isWeb",D.isWeb),k.set("isMacNative",D.isMacintosh&&!D.isWeb),k.set("isEdge",T.indexOf("Edg/")>=0),k.set("isFirefox",T.indexOf("Firefox")>=0),k.set("isChrome",T.indexOf("Chrome")>=0),k.set("isSafari",T.indexOf("Safari")>=0);const C=Object.prototype.hasOwnProperty;var S;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return g.INSTANCE}static true(){return w.INSTANCE}static has(P){return f.create(P)}static equals(P,M){return p.create(P,M)}static notEquals(P,M){return y.create(P,M)}static regex(P,M){return r.create(P,M)}static in(P,M){return d.create(P,M)}static not(P){return v.create(P)}static and(...P){return o.create(P,null)}static or(...P){return u.create(P,null,!0)}static greater(P,M){return l.create(P,M)}static less(P,M){return t.create(P,M)}static deserialize(P,M=!1){if(!!P)return this._deserializeOrExpression(P,M)}static _deserializeOrExpression(P,M){let $=P.split("||");return u.create($.map(U=>this._deserializeAndExpression(U,M)),null,!0)}static _deserializeAndExpression(P,M){let $=P.split("&&");return o.create($.map(U=>this._deserializeOne(U,M)),null)}static _deserializeOne(P,M){if(P=P.trim(),P.indexOf("!=")>=0){let $=P.split("!=");return y.create($[0].trim(),this._deserializeValue($[1],M))}if(P.indexOf("==")>=0){let $=P.split("==");return p.create($[0].trim(),this._deserializeValue($[1],M))}if(P.indexOf("=~")>=0){let $=P.split("=~");return r.create($[0].trim(),this._deserializeRegexValue($[1],M))}if(P.indexOf(" in ")>=0){let $=P.split(" in ");return d.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(P)){const $=P.split(">=");return c.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(P)){const $=P.split(">");return l.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(P)){const $=P.split("<=");return s.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(P)){const $=P.split("<");return t.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(P)?v.create(P.substr(1).trim()):f.create(P)}static _deserializeValue(P,M){if(P=P.trim(),P==="true")return!0;if(P==="false")return!1;let $=/^'([^']*)'$/.exec(P);return $?$[1].trim():P}static _deserializeRegexValue(P,M){if((0,L.isFalsyOrWhitespace)(P)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let $=P.indexOf("/"),U=P.lastIndexOf("/");if($===U||$<0){if(M)throw new Error(`bad regexp-value '${P}', missing /-enclosure`);return console.warn(`bad regexp-value '${P}', missing /-enclosure`),null}let H=P.slice($+1,U),W=P[U+1]==="i"?"i":"";try{return new RegExp(H,W)}catch(q){if(M)throw new Error(`bad regexp-value '${P}', parse error: ${q}`);return console.warn(`bad regexp-value '${P}', parse error: ${q}`),null}}}e.ContextKeyExpr=E;function n(N,P){const M=N?N.substituteConstants():void 0,$=P?P.substituteConstants():void 0;return!M&&!$?!0:!M||!$?!1:M.equals($)}e.expressionsAreEqualWithConstantSubstitution=n;function I(N,P){return N.cmp(P)}class g{constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return w.INSTANCE}}e.ContextKeyFalseExpr=g,g.INSTANCE=new g;class w{constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return g.INSTANCE}}e.ContextKeyTrueExpr=w,w.INSTANCE=new w;class f{constructor(P,M){this.key=P,this.negated=M,this.type=2}static create(P,M=null){const $=k.get(P);return typeof $=="boolean"?$?w.INSTANCE:g.INSTANCE:new f(P,M)}cmp(P){return P.type!==this.type?this.type-P.type:m(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=k.get(this.key);return typeof P=="boolean"?P?w.INSTANCE:g.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=f;class p{constructor(P,M,$){this.key=P,this.value=M,this.negated=$,this.type=4}static create(P,M,$=null){if(typeof M=="boolean")return M?f.create(P,$):v.create(P,$);const U=k.get(P);return typeof U=="boolean"?M===(U?"true":"false")?w.INSTANCE:g.INSTANCE:new p(P,M,$)}cmp(P){return P.type!==this.type?this.type-P.type:A(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){const P=k.get(this.key);if(typeof P=="boolean"){const M=P?"true":"false";return this.value===M?w.INSTANCE:g.INSTANCE}return this}evaluate(P){return P.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(P){return P.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=p;class d{constructor(P,M){this.key=P,this.valueKey=M,this.type=10,this.negated=null}static create(P,M){return new d(P,M)}cmp(P){return P.type!==this.type?this.type-P.type:A(this.key,this.valueKey,P.key,P.valueKey)}equals(P){return P.type===this.type?this.key===P.key&&this.valueKey===P.valueKey:!1}substituteConstants(){return this}evaluate(P){const M=P.getValue(this.valueKey),$=P.getValue(this.key);return Array.isArray(M)?M.indexOf($)>=0:typeof $=="string"&&typeof M=="object"&&M!==null?C.call(M,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(P){return P.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=b.create(this)),this.negated}}e.ContextKeyInExpr=d;class b{constructor(P){this._actual=P,this.type=11}static create(P){return new b(P)}cmp(P){return P.type!==this.type?this.type-P.type:this._actual.cmp(P._actual)}equals(P){return P.type===this.type?this._actual.equals(P._actual):!1}substituteConstants(){return this}evaluate(P){return!this._actual.evaluate(P)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(P){return new b(this._actual.map(P))}negate(){return this._actual}}e.ContextKeyNotInExpr=b;class y{constructor(P,M,$){this.key=P,this.value=M,this.negated=$,this.type=5}static create(P,M,$=null){if(typeof M=="boolean")return M?v.create(P,$):f.create(P,$);const U=k.get(P);return typeof U=="boolean"?M===(U?"true":"false")?g.INSTANCE:w.INSTANCE:new y(P,M,$)}cmp(P){return P.type!==this.type?this.type-P.type:A(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){const P=k.get(this.key);if(typeof P=="boolean"){const M=P?"true":"false";return this.value===M?g.INSTANCE:w.INSTANCE}return this}evaluate(P){return P.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(P){return P.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=y;class v{constructor(P,M){this.key=P,this.negated=M,this.type=3}static create(P,M=null){const $=k.get(P);return typeof $=="boolean"?$?g.INSTANCE:w.INSTANCE:new v(P,M)}cmp(P){return P.type!==this.type?this.type-P.type:m(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=k.get(this.key);return typeof P=="boolean"?P?g.INSTANCE:w.INSTANCE:this}evaluate(P){return!P.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(P){return P.mapNot(this.key)}negate(){return this.negated||(this.negated=f.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=v;class l{constructor(P,M,$){this.key=P,this.value=M,this.negated=$,this.type=12}static create(P,M,$=null){return new l(P,M,$)}cmp(P){return P.type!==this.type?this.type-P.type:A(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return parseFloat(P.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(P){return P.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class c{constructor(P,M,$){this.key=P,this.value=M,this.negated=$,this.type=13}static create(P,M,$=null){return new c(P,M,$)}cmp(P){return P.type!==this.type?this.type-P.type:A(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return parseFloat(P.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(P){return P.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=t.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=c;class t{constructor(P,M,$){this.key=P,this.value=M,this.negated=$,this.type=14}static create(P,M,$=null){return new t(P,M,$)}cmp(P){return P.type!==this.type?this.type-P.type:A(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return parseFloat(P.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(P){return P.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=c.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=t;class s{constructor(P,M,$){this.key=P,this.value=M,this.negated=$,this.type=15}static create(P,M,$=null){return new s(P,M,$)}cmp(P){return P.type!==this.type?this.type-P.type:A(this.key,this.value,P.key,P.value)}equals(P){return P.type===this.type?this.key===P.key&&this.value===P.value:!1}substituteConstants(){return this}evaluate(P){return parseFloat(P.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(P){return P.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=s;class r{constructor(P,M){this.key=P,this.regexp=M,this.type=7,this.negated=null}static create(P,M){return new r(P,M)}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.key<P.key)return-1;if(this.key>P.key)return 1;const M=this.regexp?this.regexp.source:"",$=P.regexp?P.regexp.source:"";return M<$?-1:M>$?1:0}equals(P){if(P.type===this.type){const M=this.regexp?this.regexp.source:"",$=P.regexp?P.regexp.source:"";return this.key===P.key&&M===$}return!1}substituteConstants(){return this}evaluate(P){let M=P.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const P=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${P}`}keys(){return[this.key]}map(P){return P.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class i{constructor(P){this._actual=P,this.type=8}static create(P){return new i(P)}cmp(P){return P.type!==this.type?this.type-P.type:this._actual.cmp(P._actual)}equals(P){return P.type===this.type?this._actual.equals(P._actual):!1}substituteConstants(){return this}evaluate(P){return!this._actual.evaluate(P)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(P){return new i(this._actual.map(P))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function a(N){let P=null;for(let M=0,$=N.length;M<$;M++){const U=N[M].substituteConstants();if(N[M]!==U&&P===null){P=[];for(let H=0;H<M;H++)P[H]=N[H]}P!==null&&(P[M]=U)}return P===null?N:P}class o{constructor(P,M){this.expr=P,this.negated=M,this.type=6}static create(P,M){return o._normalizeArr(P,M)}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let M=0,$=this.expr.length;M<$;M++){const U=I(this.expr[M],P.expr[M]);if(U!==0)return U}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let M=0,$=this.expr.length;M<$;M++)if(!this.expr[M].equals(P.expr[M]))return!1;return!0}return!1}substituteConstants(){const P=a(this.expr);return P===this.expr?this:o.create(P,this.negated)}evaluate(P){for(let M=0,$=this.expr.length;M<$;M++)if(!this.expr[M].evaluate(P))return!1;return!0}static _normalizeArr(P,M){const $=[];let U=!1;for(const H of P)if(!!H){if(H.type===1){U=!0;continue}if(H.type===0)return g.INSTANCE;if(H.type===6){$.push(...H.expr);continue}$.push(H)}if($.length===0&&U)return w.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(I);for(let H=1;H<$.length;H++)$[H-1].equals($[H])&&($.splice(H,1),H--);if($.length===1)return $[0];for(;$.length>1;){const H=$[$.length-1];if(H.type!==9)break;$.pop();const W=$.pop(),q=$.length===0,x=u.create(H.expr.map(F=>o.create([F,W],null)),null,q);x&&($.push(x),$.sort(I))}return $.length===1?$[0]:new o($,M)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(let M of this.expr)P.push(...M.keys());return P}map(P){return new o(this.expr.map(M=>M.map(P)),null)}negate(){if(!this.negated){const P=[];for(let M of this.expr)P.push(M.negate());this.negated=u.create(P,this,!0)}return this.negated}}class u{constructor(P,M){this.expr=P,this.negated=M,this.type=9}static create(P,M,$){return u._normalizeArr(P,M,$)}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let M=0,$=this.expr.length;M<$;M++){const U=I(this.expr[M],P.expr[M]);if(U!==0)return U}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let M=0,$=this.expr.length;M<$;M++)if(!this.expr[M].equals(P.expr[M]))return!1;return!0}return!1}substituteConstants(){const P=a(this.expr);return P===this.expr?this:u.create(P,this.negated,!1)}evaluate(P){for(let M=0,$=this.expr.length;M<$;M++)if(this.expr[M].evaluate(P))return!0;return!1}static _normalizeArr(P,M,$){let U=[],H=!1;if(P){for(let W=0,q=P.length;W<q;W++){const x=P[W];if(!!x){if(x.type===0){H=!0;continue}if(x.type===1)return w.INSTANCE;if(x.type===9){U=U.concat(x.expr);continue}U.push(x)}}if(U.length===0&&H)return g.INSTANCE;U.sort(I)}if(U.length!==0){if(U.length===1)return U[0];for(let W=1;W<U.length;W++)U[W-1].equals(U[W])&&(U.splice(W,1),W--);if(U.length===1)return U[0];if($){for(let W=0;W<U.length;W++)for(let q=W+1;q<U.length;q++)_(U[W],U[q])&&(U.splice(q,1),q--);if(U.length===1)return U[0]}return new u(U,M)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(let M of this.expr)P.push(...M.keys());return P}map(P){return new u(this.expr.map(M=>M.map(P)),null)}negate(){if(!this.negated){let P=[];for(let M of this.expr)P.push(M.negate());for(;P.length>1;){const M=P.shift(),$=P.shift(),U=[];for(const W of O(M))for(const q of O($))U.push(o.create([W,q],null));const H=P.length===0;P.unshift(u.create(U,null,H))}this.negated=P[0]}return this.negated}}class h extends f{constructor(P,M,$){super(P,null);this._defaultValue=M,typeof $=="object"?h._info.push({...$,key:P}):$!==!0&&h._info.push({key:P,description:$,type:M!=null?typeof M:void 0})}static all(){return h._info.values()}bindTo(P){return P.createKey(this.key,this._defaultValue)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return p.create(this.key,P)}notEqualsTo(P){return y.create(this.key,P)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(N,P){return N<P?-1:N>P?1:0}function A(N,P,M,$){return N<M?-1:N>M?1:P<$?-1:P>$?1:0}function _(N,P){if(P.type===6&&N.type!==9&&N.type!==6){for(const U of P.expr)if(N.equals(U))return!0}const M=N.negate(),$=O(M).concat(O(P));$.sort(I);for(let U=0;U<$.length;U++){const W=$[U].negate();for(let q=U+1;q<$.length;q++){const x=$[q];if(W.equals(x))return!0}}return!1}e.implies=_;function O(N){return N.type===9?N.expr:[N]}}),define(te[78],ne([0,1,5]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function L(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=L}),define(te[79],ne([0,1,5]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(te[13],ne([0,1,5]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(te[28],ne([0,1,15,128,5]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var T;(function(y){y.WIN32_X64="win32-x64",y.WIN32_IA32="win32-ia32",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(T=e.TargetPlatform||(e.TargetPlatform={}));function k(y){switch(y){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function C(y){switch(y){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=C;function S(y,v){switch(y){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=S;function E(y,v){return v==="web"&&!y.includes("web")}e.isNotWebExtensionInWebTargetPlatform=E;function n(y,v,l){return E(v,l)?!1:y==="undefined"||y==="universal"?!0:y==="unknown"?!1:y===l?!0:I(l).includes(y)}e.isTargetPlatformCompatible=n;function I(y){switch(y){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function g(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}e.isIExtensionIdentifier=g;var w;(function(y){y[y.NoneOrRelevance=0]="NoneOrRelevance",y[y.LastUpdatedDate=1]="LastUpdatedDate",y[y.Title=2]="Title",y[y.PublisherName=3]="PublisherName",y[y.InstallCount=4]="InstallCount",y[y.PublishedDate=10]="PublishedDate",y[y.AverageRating=6]="AverageRating",y[y.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var f;(function(y){y[y.Default=0]="Default",y[y.Ascending=1]="Ascending",y[y.Descending=2]="Descending"})(f=e.SortOrder||(e.SortOrder={}));var p;(function(y){y.Install="install",y.Uninstall="uninstall"})(p=e.StatisticType||(e.StatisticType={}));var d;(function(y){y[y.None=0]="None",y[y.Install=1]="Install",y[y.Update=2]="Update"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class b extends Error{constructor(v,l){super(v);this.code=l,this.name=l}}e.ExtensionManagementError=b,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")});var Q=this&&this.__param||function(J,e){return function(D,L){e(D,L,J)}};define(te[160],ne([0,1,2,28]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let R=class extends D.Disposable{constructor(k){super();this.extensionManagementService=k,this._register(k),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};R=he([Q(0,L.IExtensionManagementService)],R),e.DeprecatedExtensionsCleaner=R}),define(te[161],ne([0,1,3,2,26,7,106,28]),function(J,e,D,L,R,T,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function S(p,d){return T.URI.revive(d?d.transformIncoming(p):p)}function E(p,d){return d?d.transformOutgoingURI(p):p}function n(p,d){d=d||k.DefaultURITransformer;const b=p.manifest;return{...(0,k.transformAndReviveIncomingURIs)({...p,manifest:void 0},d),manifest:b}}function I(p,d){return d?(0,R.cloneAndChange)(p,b=>b instanceof T.URI?d.transformOutgoingURI(b):void 0):p}class g{constructor(d,b){this.service=d,this.getUriTransformer=b,this.onInstallExtension=D.Event.buffer(d.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(d.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(d.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(d.onDidUninstallExtension,!0)}listen(d,b){const y=this.getUriTransformer(d);switch(b){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,v=>v.map(l=>({...l,local:l.local?I(l.local,y):l.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(d,b,y){const v=this.getUriTransformer(d);switch(b){case"zip":return this.service.zip(n(y[0],v)).then(l=>E(l,v));case"unzip":return this.service.unzip(S(y[0],v));case"install":return this.service.install(S(y[0],v),y[1]);case"getManifest":return this.service.getManifest(S(y[0],v));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(y[0]);case"installFromGallery":return this.service.installFromGallery(y[0],y[1]);case"uninstall":return this.service.uninstall(n(y[0],v),y[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(n(y[0],v));case"getInstalled":return this.service.getInstalled(y[0]).then(l=>l.map(c=>I(c,v)));case"updateMetadata":return this.service.updateMetadata(n(y[0],v),y[1]).then(l=>I(l,v));case"updateExtensionScope":return this.service.updateExtensionScope(n(y[0],v),y[1]).then(l=>I(l,v));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=g;class w extends L.Disposable{constructor(d){super();this.channel=d,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(b=>this._onInstallExtension.fire({identifier:b.identifier,source:this.isUriComponents(b.source)?T.URI.revive(b.source):b.source}))),this._register(this.channel.listen("onDidInstallExtensions")(b=>this._onDidInstallExtensions.fire(b.map(y=>({...y,local:y.local?n(y.local,null):y.local,source:this.isUriComponents(y.source)?T.URI.revive(y.source):y.source}))))),this._register(this.channel.listen("onUninstallExtension")(b=>this._onUninstallExtension.fire(b))),this._register(this.channel.listen("onDidUninstallExtension")(b=>this._onDidUninstallExtension.fire(b)))}isUriComponents(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(d){const b=await this.getTargetPlatform();return d.allTargetPlatforms.some(y=>(0,C.isTargetPlatformCompatible)(y,d.allTargetPlatforms,b))}zip(d){return Promise.resolve(this.channel.call("zip",[d]).then(b=>T.URI.revive(b)))}unzip(d){return Promise.resolve(this.channel.call("unzip",[d]))}install(d,b){return Promise.resolve(this.channel.call("install",[d,b])).then(y=>n(y,null))}getManifest(d){return Promise.resolve(this.channel.call("getManifest",[d]))}installFromGallery(d,b){return Promise.resolve(this.channel.call("installFromGallery",[d,b])).then(y=>n(y,null))}uninstall(d,b){return Promise.resolve(this.channel.call("uninstall",[d,b]))}reinstallFromGallery(d){return Promise.resolve(this.channel.call("reinstallFromGallery",[d]))}getInstalled(d=null){return Promise.resolve(this.channel.call("getInstalled",[d])).then(b=>b.map(y=>n(y,null)))}updateMetadata(d,b){return Promise.resolve(this.channel.call("updateMetadata",[d,b])).then(y=>n(y,null))}updateExtensionScope(d,b){return Promise.resolve(this.channel.call("updateExtensionScope",[d,b])).then(y=>n(y,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=w;class f{constructor(d){this.service=d}listen(d,b){throw new Error("Invalid listen")}call(d,b,y){switch(b){case"getConfigBasedTips":return this.service.getConfigBasedTips(T.URI.revive(y[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=f}),define(te[80],ne([0,1,5]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var L;(function(k){k[k.FILE=1]="FILE",k[k.WORKSPACE=2]="WORKSPACE",k[k.EXE=3]="EXE"})(L=e.RecommendationSource||(e.RecommendationSource={}));function R(k){switch(k){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=R;var T;(function(k){k.Ignored="ignored",k.Cancelled="cancelled",k.TooMany="toomany",k.IncompatibleWindow="incompatibleWindow",k.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[81],ne([0,1,5]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,D.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(te[14],ne([0,1,41,8,25,18,7,135,5]),function(J,e,D,L,R,T,k,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function E(U){return U.create===!0}e.isFileOpenForWriteOptions=E;var n;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var I;(function(U){U[U.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var g;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function w(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=w;function f(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=f;function p(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function d(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=d;var b;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class y extends Error{constructor(H,W){super(H);this.code=W}}e.FileSystemProviderError=y;function v(U,H){const W=new y(U.toString(),H);return c(W,H),W}e.createFileSystemProviderError=v;function l(U){return U||v((0,C.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=l;function c(U,H){return U.name=H?`${H} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=c;function t(U){if(!U)return b.Unknown;if(U instanceof y)return U.code;const H=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!H)return b.Unknown;switch(H[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function s(U){if(U instanceof h)return U.fileOperationResult;switch(t(U)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var r;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class i{constructor(H,W,q){this.resource=H,this.operation=W,this.target=q}isOperation(H){return this.operation===H}}e.FileOperationEvent=i;var a;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class o{constructor(H,W){this.added=void 0,this.updated=void 0,this.deleted=void 0;const q=new Map;for(const x of H){const F=q.get(x.type);F?F.push([x.resource,x]):q.set(x.type,[[x.resource,x]])}for(const[x,F]of q)switch(x){case 1:this.added=D.TernarySearchTree.forUris(()=>W),this.added.fill(F);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>W),this.updated.fill(F);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>W),this.deleted.fill(F);break}}contains(H,...W){return this.doContains(H,{includeChildren:!1},...W)}affects(H,...W){return this.doContains(H,{includeChildren:!0},...W)}doContains(H,W,...q){if(!H)return!1;const x=q.length>0;return!!((!x||q.includes(1))&&(this.added?.get(H)||W.includeChildren&&this.added?.findSuperstr(H))||(!x||q.includes(0))&&(this.updated?.get(H)||W.includeChildren&&this.updated?.findSuperstr(H))||(!x||q.includes(2))&&(this.deleted?.findSubstr(H)||W.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=o;function u(U,H,W){return!U||!H||U===H||H.length>U.length?!1:(H.charAt(H.length-1)!==L.sep&&(H+=L.sep),W?(0,R.startsWithIgnoreCase)(U,H):U.indexOf(H)===0)}e.isParent=u;class h extends Error{constructor(H,W,q){super(H);this.fileOperationResult=W,this.options=q}}e.FileOperationError=h;class m extends h{constructor(H,W,q){super(H,2,q);this.stat=W}}e.NotModifiedSinceFileOperationError=m;var A;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var _;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(_=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=O;async function N(U,H){if(!H.hasProvider(k.URI.from({scheme:U.scheme})))return new Promise(W=>{const q=H.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===U.scheme&&x.added&&(q.dispose(),W())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class P{static formatSize(H){return(0,T.isNumber)(H)||(H=0),H<P.KB?(0,C.localize)(1,null,H.toFixed(0)):H<P.MB?(0,C.localize)(2,null,(H/P.KB).toFixed(2)):H<P.GB?(0,C.localize)(3,null,(H/P.MB).toFixed(2)):H<P.TB?(0,C.localize)(4,null,(H/P.GB).toFixed(2)):(0,C.localize)(5,null,(H/P.TB).toFixed(2))}}e.ByteSize=P,P.KB=1024,P.MB=P.KB*P.KB,P.GB=P.MB*P.KB,P.TB=P.GB*P.KB;var M;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(M=e.Arch||(e.Arch={}));function $(U){return{maxFileSize:U===0?300*P.MB:16*P.GB,maxHeapSize:U===0?700*P.MB:2*700*P.MB}}e.getPlatformLimits=$}),define(te[162],ne([0,1,82,50,14]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(C){this.fileService=C}checksum(C){return new Promise(async(S,E)=>{const n=(0,D.createHash)("md5"),I=(await this.fileService.readFileStream(C)).value;(0,L.listenStream)(I,{onData:g=>n.update(g.buffer),onError:g=>E(g),onEnd:()=>S(n.digest("base64").replace(/=+$/,""))})})}};T=he([Q(0,R.IFileService)],T),e.ChecksumService=T}),define(te[163],ne([0,1,239,125,147,14]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function k(g,w){const f={onUnknownOption:d=>{console.warn((0,L.localize)(0,null,d))},onMultipleValues:(d,b)=>{console.warn((0,L.localize)(1,null,d,b))}},p=(0,R.parseArgs)(g,R.OPTIONS,w?f:void 0);return p.goto&&p._.forEach(d=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(d),(0,L.localize)(2,null))),p["max-memory"]&&D(parseInt(p["max-memory"])>=T.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${T.MIN_MAX_MEMORY_SIZE_MB} MB.`),p}function C(g){const w=g.findIndex(f=>!/^-/.test(f));if(w>-1)return[...g.slice(0,w),...g.slice(w+1)]}function S(g){let[,...w]=g;process.env.VSCODE_DEV&&(w=C(w)||[]);const f=!I(process.env);return k(w,f)}e.parseMainProcessArgv=S;function E(g){const[,,...w]=g;return k(w,!0)}e.parseCLIProcessArgv=E;function n(g,...w){const f=g.indexOf("--");return f===-1?g.push(...w):g.splice(f,0,...w),g}e.addArg=n;function I(g){return g.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),define(te[164],ne([0,1,37,8,126,27,38,9,4,30,121,163]),function(J,e,D,L,R,T,k,C,S,E,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const g=1e4;let w;async function f(d,b,y){return b["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):S.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(y)&&!b["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(y)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),w||(w=new Promise(async(v,l)=>{const c=new T.CancellationTokenSource,t=setTimeout(()=>{c.dispose(!0),l((0,R.localize)(0,null))},g);try{v(await p(d,c.token))}catch(s){!(0,C.isPromiseCanceledError)(s)&&!c.token.isCancellationRequested&&l((0,R.localize)(1,null,(0,k.toErrorMessage)(s))),v({})}finally{clearTimeout(t),c.dispose()}})),w)}e.resolveShellEnv=f;async function p(d,b){return new Promise(async(y,v)=>{const l=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",l);const c=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",c);const t=(0,E.generateUuid)().replace(/-/g,"").substr(0,12),s=new RegExp(t+"(.*)"+t),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};d.trace("getUnixShellEnvironment#env",r);const i=await(0,n.getSystemShell)(S.OS,r);if(d.trace("getUnixShellEnvironment#shell",i),b.isCancellationRequested)return v(C.canceled);const a=(0,L.basename)(i);let o,u;/^pwsh(-preview)?$/.test(a)?(o=`& '${process.execPath}' -p '''${t}'' + JSON.stringify(process.env) + ''${t}'''`,u=["-Login","-Command"]):(o=`'${process.execPath}' -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,u=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(u),o);const h=(0,D.spawn)(i,[...u,o],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});b.onCancellationRequested(()=>(h.kill(),v(C.canceled))),h.on("error",_=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(_)),v(_)});const m=[];h.stdout.on("data",_=>m.push(_));const A=[];h.stderr.on("data",_=>A.push(_)),h.on("close",(_,O)=>{const N=Buffer.concat(m).toString("utf8");d.trace("getUnixShellEnvironment#raw",N);const P=Buffer.concat(A).toString("utf8");if(P.trim()&&d.trace("getUnixShellEnvironment#stderr",P),_||O)return v(new Error((0,R.localize)(2,null,_,O)));const M=s.exec(N),$=M?M[1]:"{}";try{const U=JSON.parse($);l?U.ELECTRON_RUN_AS_NODE=l:delete U.ELECTRON_RUN_AS_NODE,c?U.ELECTRON_NO_ATTACH_CONSOLE=c:delete U.ELECTRON_NO_ATTACH_CONSOLE,delete U.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",U),y(U)}catch(U){d.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(U)),v(U)}})})}}),define(te[83],ne([0,1,4,7,14]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function T(S){return S.map(E=>({type:E.type,resource:L.URI.file(E.path)}))}e.toFileChanges=T;function k(S){const E=new C;for(const n of S)E.processEvent(n);return E.normalize()}e.normalizeFileChanges=k;class C{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(E){return D.isLinux?E.path:E.path.toLowerCase()}processEvent(E){const n=this.mapPathToChange.get(this.toKey(E));let I=!1;if(n){const g=n.type,w=E.type;n.path!==E.path&&(w===1||w===0)?(n.type=2,I=!0):g===1&&w===2?(this.mapPathToChange.delete(this.toKey(E)),this.normalized.delete(n)):g===2&&w===1?n.type=0:g===1&&w===0||(n.type=w)}else I=!0;I&&(this.normalized.add(E),this.mapPathToChange.set(this.toKey(E),E))}normalize(){const E=[],n=[];return Array.from(this.normalized).filter(I=>I.type!==2?(E.push(I),!1):!0).sort((I,g)=>I.path.length-g.path.length).filter(I=>n.some(g=>(0,R.isParent)(I.path,g,!D.isLinux))?!1:(n.push(I.path),!0)).concat(E)}}}),define(te[165],ne([0,1,6,2,8,110,19,113,83]),function(J,e,D,L,R,T,k,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class E extends L.Disposable{constructor(I,g,w,f){super();this.path=I,this.onDidFilesChange=g,this.onLogMessage=w,this.verboseLogging=f,this.fileChangesDelayer=this._register(new D.ThrottledDelayer(C.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:g}=await k.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let w=this.path;if(g)try{w=await(0,T.realpath)(w)}catch(f){if(this.onError(f),g.dangling)return}I.isDirectory()?this._register((0,C.watchFolder)(w,(f,p)=>{this.onFileChange({type:f==="changed"?0:f==="added"?1:2,path:(0,R.join)(this.path,(0,R.basename)(p))})},f=>this.onError(f))):this._register((0,C.watchFile)(w,f=>{this.onFileChange({type:f==="changed"?0:2,path:this.path})},f=>this.onError(f)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const w=(0,S.normalizeFileChanges)(g);if(this.verboseLogging)for(const f of w)this.onVerbose(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`);w.length>0&&this.onDidFilesChange(w)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=E}),define(te[84],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...R){this._entries=new Map;for(let[T,k]of R)this.set(T,k)}set(R,T){const k=this._entries.get(R);return this._entries.set(R,T),k}has(R){return this._entries.has(R)}get(R){return this._entries.get(R)}}e.ServiceCollection=D}),define(te[166],ne([0,1,6,9,53,157,5,84]),function(J,e,D,L,R,T,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class E extends Error{constructor(f){super("cyclic dependency between services");this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class n{constructor(f=new C.ServiceCollection,p=!1,d){this._activeInstantiations=new Set,this._services=f,this._strict=p,this._parent=d,this._services.set(k.IInstantiationService,this)}createChild(f){return new n(f,this._strict,this)}invokeFunction(f,...p){let d=g.traceInvocation(f),b=!1;try{return f({get:(v,l)=>{if(b)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(v,d);if(!c&&l!==k.optional)throw new Error(`[invokeFunction] unknown service '${v}'`);return c}},...p)}finally{b=!0,d.stop()}}createInstance(f,...p){let d,b;return f instanceof R.SyncDescriptor?(d=g.traceCreation(f.ctor),b=this._createInstance(f.ctor,f.staticArguments.concat(p),d)):(d=g.traceCreation(f),b=this._createInstance(f,p,d)),d.stop(),b}_createInstance(f,p=[],d){let b=k._util.getServiceDependencies(f).sort((l,c)=>l.index-c.index),y=[];for(const l of b){let c=this._getOrCreateServiceInstance(l.id,d);if(!c&&this._strict&&!l.optional)throw new Error(`[createInstance] ${f.name} depends on UNKNOWN service ${l.id}.`);y.push(c)}let v=b.length>0?b[0].index:p.length;if(p.length!==v){console.warn(`[createInstance] First service dependency of ${f.name} at position ${v+1} conflicts with ${p.length} static arguments`);let l=v-p.length;l>0?p=p.concat(new Array(l)):p=p.slice(0,v)}return new f(...[...p,...y])}_setServiceInstance(f,p){if(this._services.get(f)instanceof R.SyncDescriptor)this._services.set(f,p);else if(this._parent)this._parent._setServiceInstance(f,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){let p=this._services.get(f);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):p}_getOrCreateServiceInstance(f,p){let d=this._getServiceInstanceOrDescriptor(f);return d instanceof R.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,d,p.branch(f,!0)):(p.branch(f,!1),d)}_safeCreateAndCacheServiceInstance(f,p,d){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,p,d)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,p,d){const b=new T.Graph(l=>l.id.toString());let y=0;const v=[{id:f,desc:p,_trace:d}];for(;v.length;){const l=v.pop();if(b.lookupOrInsertNode(l),y++>1e3)throw new E(b);for(let c of k._util.getServiceDependencies(l.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(c.id);if(!t&&!c.optional&&console.warn(`[createInstance] ${f} depends on ${c.id} which is NOT registered.`),t instanceof R.SyncDescriptor){const s={id:c.id,desc:t,_trace:l._trace.branch(c.id,!0)};b.insertEdge(l,s),v.push(s)}}}for(;;){const l=b.roots();if(l.length===0){if(!b.isEmpty())throw new E(b);break}for(const{data:c}of l){if(this._getServiceInstanceOrDescriptor(c.id)instanceof R.SyncDescriptor){const s=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,s)}b.removeNode(c)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,p,d=[],b,y){if(this._services.get(f)instanceof R.SyncDescriptor)return this._createServiceInstance(p,d,b,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,p,d,b,y);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(f,p=[],d,b){if(d){const y=new D.IdleValue(()=>this._createInstance(f,p,b));return new Proxy(Object.create(null),{get(v,l){if(l in v)return v[l];let c=y.value,t=c[l];return typeof t!="function"||(t=t.bind(c),v[l]=t),t},set(v,l,c){return y.value[l]=c,!0}})}else return this._createInstance(f,p,b)}}e.InstantiationService=n;var I;(function(w){w[w.Creation=0]="Creation",w[w.Invocation=1]="Invocation",w[w.Branch=2]="Branch"})(I||(I={}));class g{constructor(f,p){this.type=f,this.name=p,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return S?new g(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(f){return S?new g(0,f.name):g._None}branch(f,p){let d=new g(2,f.toString());return this._dep.push([f,p,d]),d}stop(){let f=Date.now()-this._start;g._totals+=f;let p=!1;function d(y,v){let l=[],c=new Array(y+1).join("	");for(const[t,s,r]of v._dep)if(s&&r){p=!0,l.push(`${c}CREATES -> ${t}`);let i=d(y+1,r);i&&l.push(i)}else l.push(`${c}uses -> ${t}`);return l.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(f>2||p)&&console.log(b.join(`
`))}}g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(te[167],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(R,T){this.server=R,this.router=T}getChannel(R){return this.server.getChannel(R,this.router)}registerChannel(R,T){this.server.registerChannel(R,T)}}e.MessagePortMainProcessService=D}),define(te[168],ne([0,1,33,53,77,5]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class k{constructor(w,f,p){const d=p.getChannel(w);return C(f)?new f.channelClientCtor(d):D.ProxyChannel.toService(d,f?.proxyOptions)}}function C(g){return!!g?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let S=class extends k{constructor(w,f,p){super(w,f,p)}};S=he([Q(2,e.IMainProcessService)],S);function E(g,w,f){(0,R.registerSingleton)(g,new L.SyncDescriptor(S,[w,f],f?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=E,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let n=class extends k{constructor(w,f,p){super(w,f,p)}};n=he([Q(2,e.ISharedProcessService)],n);function I(g,w,f){(0,R.registerSingleton)(g,new L.SyncDescriptor(n,[w,f],f?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=I}),define(te[58],ne([0,1,5]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,D.createDecorator)("localizationsService");function L(R){if(typeof R.languageId!="string"||!Array.isArray(R.translations)||R.translations.length===0)return!1;for(const T of R.translations)if(typeof T.id!="string"||typeof T.path!="string")return!1;return!(R.languageName&&typeof R.languageName!="string"||R.localizedLanguageName&&typeof R.localizedLanguageName!="string")}e.isValidLocalization=L}),define(te[169],ne([0,1,2,58]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let R=class extends D.Disposable{constructor(k){super();this.localizationsService=k,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};R=he([Q(0,L.ILocalizationsService)],R),e.LocalizationsUpdater=R}),define(te[10],ne([0,1,38,3,2,4,5]),function(J,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function C(){return new Date().toISOString()}var S;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class E extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class n extends E{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...s){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([t,...s]))}debug(t,...s){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([t,...s]))}info(t,...s){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([t,...s]))}warn(t,...s){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([t,...s]))}error(t,...s){if(this.checkLogLevel(S.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(S.Error,this.format(r))}else this.log(S.Error,this.format([t,...s]))}critical(t,...s){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([t,...s]))}flush(){}format(t){let s="";for(let r=0;r<t.length;r++){let i=t[r];if(typeof i=="object")try{i=JSON.stringify(i)}catch(a){}s+=(r>0?" ":"")+i}return s}}e.AbstractMessageLogger=n;class I extends E{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!T.isWindows}trace(t,...s){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...s):console.log(`[main ${C()}]`,t,...s))}debug(t,...s){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...s):console.log(`[main ${C()}]`,t,...s))}info(t,...s){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...s):console.log(`[main ${C()}]`,t,...s))}warn(t,...s){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,t,...s):console.warn(`[main ${C()}]`,t,...s))}error(t,...s){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,t,...s):console.error(`[main ${C()}]`,t,...s))}critical(t,...s){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,t,...s):console.error(`[main ${C()}]`,t,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class g extends E{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...s){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",t,...s)}debug(t,...s){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...s)}info(t,...s){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",t,...s)}warn(t,...s){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",t,...s)}error(t,...s){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",t,...s)}critical(t,...s){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...s)}dispose(){}flush(){}}e.ConsoleLogger=g;class w extends E{constructor(t,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(s)}trace(t,...s){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(t),...s])}debug(t,...s){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(t),...s])}info(t,...s){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(t),...s])}warn(t,...s){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(t),...s])}error(t,...s){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(t),...s])}critical(t,...s){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(t),...s])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=w;class f extends E{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const s of this.logServices)s.setLevel(t);super.setLevel(t)}trace(t,...s){for(const r of this.logServices)r.trace(t,...s)}debug(t,...s){for(const r of this.logServices)r.debug(t,...s)}info(t,...s){for(const r of this.logServices)r.info(t,...s)}warn(t,...s){for(const r of this.logServices)r.warn(t,...s)}error(t,...s){for(const r of this.logServices)r.error(t,...s)}critical(t,...s){for(const r of this.logServices)r.critical(t,...s)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=f;class p extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...s){this.logger.trace(t,...s)}debug(t,...s){this.logger.debug(t,...s)}info(t,...s){this.logger.info(t,...s)}warn(t,...s){this.logger.warn(t,...s)}error(t,...s){this.logger.error(t,...s)}critical(t,...s){this.logger.critical(t,...s)}flush(){this.logger.flush()}}e.LogService=p;class d extends R.Disposable{constructor(t,s){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(r))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,s){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,s?.always?S.Trace:this.logLevel,s),this.loggers.set(t.toString(),r),s?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=d;class b{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return S.Info}trace(t,...s){}debug(t,...s){}info(t,...s){}warn(t,...s){}error(t,...s){}critical(t,...s){}dispose(){}flush(){}}e.NullLogService=b;function y(c){if(c.verbose)return S.Trace;if(typeof c.logLevel=="string"){const t=v(c.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=y;function v(c){switch(c){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=v;function l(c){switch(c){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=l}),define(te[170],ne([0,1,6,9,2,8,19,13,10]),function(J,e,D,L,R,T,k,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let E=class extends R.Disposable{constructor(I,g){super();this.environmentService=I,this.logService=g,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.info("[logs cleanup]: Starting to clean up old logs.");try{const I=(0,T.basename)(this.environmentService.logsPath),g=(0,T.dirname)(this.environmentService.logsPath),p=(await k.Promises.readdir(g)).filter(b=>/^\d{8}T\d{6}$/.test(b)).sort().filter(b=>b!==I),d=p.slice(0,Math.max(0,p.length-9));d.length>0&&(this.logService.info(`[logs cleanup]: Removing log folders '${d.join(", ")}'`),await Promise.all(d.map(b=>k.Promises.rm((0,T.join)(g,b)))))}catch(I){(0,L.onUnexpectedError)(I)}}};E=he([Q(0,C.IEnvironmentService),Q(1,S.ILogService)],E),e.LogsDataCleaner=E}),define(te[171],ne([0,1,6,9,2,8,19,13,10]),function(J,e,D,L,R,T,k,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let E=class mt extends R.Disposable{constructor(I,g,w){super();this.backupWorkspacesPath=I,this.environmentService=g,this.logService=w,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.info("[storage cleanup]: Starting to clean up storage folders.");try{const I=await k.Promises.readFile(this.backupWorkspacesPath,"utf8"),w=JSON.parse(I).emptyWorkspaceInfos.map(p=>p.backupFolder),f=await k.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(f.map(async p=>{p.length!==mt.NON_EMPTY_WORKSPACE_ID_LENGTH&&w.indexOf(p)===-1&&(this.logService.info(`[storage cleanup]: Deleting storage folder ${p}.`),await k.Promises.rm((0,T.join)(this.environmentService.workspaceStorageHome.fsPath,p)))}))}catch(I){(0,L.onUnexpectedError)(I)}}};E.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,E=he([Q(1,C.INativeEnvironmentService),Q(2,S.ILogService)],E),e.StorageDataCleaner=E}),define(te[172],ne([0,1,37,6,38,3,2,15,8,19,13,10]),function(J,e,D,L,R,T,k,C,S,E,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let g=class extends k.Disposable{constructor(f,p){super();this.environmentService=f,this.logService=p,this.processesLimiter=new L.Limiter(5)}async postUninstall(f){const p=this.parseScript(f,"uninstall");return p&&(this.logService.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(p.script,"uninstall",p.args,!0,f).then(()=>this.logService.info(f.identifier.id,f.manifest.version,"Finished running post uninstall script"),d=>this.logService.error(f.identifier.id,f.manifest.version,`Failed to run post uninstall script: ${d}`)))),E.Promises.rm(this.getExtensionStoragePath(f)).then(void 0,d=>this.logService.error("Error while removing extension storage path",d))}parseScript(f,p){const d=`vscode:${p}`;if(f.location.scheme===C.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[d]=="string"){const b=f.manifest.scripts[d].split(" ");return b.length<2||b[0]!=="node"||!b[1]?(this.logService.warn(f.identifier.id,f.manifest.version,`${d} should be a node script`),null):{script:(0,S.join)(f.location.fsPath,b[1]),args:b.slice(2)||[]}}return null}runLifecycleHook(f,p,d,b,y){return new Promise((v,l)=>{const c=this.start(f,p,d,y);let t;const s=r=>{t&&(clearTimeout(t),t=null),r?l(r):v(void 0)};c.on("error",r=>{s((0,R.toErrorMessage)(r)||"Unknown")}),c.on("exit",(r,i)=>{s(r?`post-${p} process exited with code ${r}`:void 0)}),b&&(t=setTimeout(()=>{t=null,c.kill(),l("timed out")},5e3))})}start(f,p,d,b){const y={silent:!0,execArgv:void 0},v=(0,D.fork)(f,[`--type=extension-post-${p}`,...d],y);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const l=T.Event.fromNodeEventEmitter(v.stdout,"data"),c=T.Event.fromNodeEventEmitter(v.stderr,"data");l(r=>this.logService.info(b.identifier.id,b.manifest.version,`post-${p}`,r)),c(r=>this.logService.error(b.identifier.id,b.manifest.version,`post-${p}`,r));const t=T.Event.any(T.Event.map(l,r=>({data:`%c${r}`,format:[""]})),T.Event.map(c,r=>({data:`%c${r}`,format:["color: red"]})));return T.Event.debounce(t,(r,i)=>r?{data:r.data+i.data,format:[...r.format,...i.format]}:{data:i.data,format:i.format},100)(r=>{console.group(b.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),v}getExtensionStoragePath(f){return(0,S.join)(this.environmentService.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};g=he([Q(0,n.IEnvironmentService),Q(1,I.ILogService)],g),e.ExtensionsLifecycle=g}),define(te[173],ne([0,1,9,2,81,3,37,15,107,4,10,77]),function(J,e,D,L,R,T,k,C,S,E,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let g=class extends L.Disposable{constructor(p,d){super();this.id=p,this._logService=d,this._onStdout=this._register(new T.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new T.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new T.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this._onExit=this._register(new T.Emitter),this.onExit=this._onExit.event,this._process=null}register(p){this._register(p)}start(p){this._process=(0,k.fork)(C.FileAccess.asFileUri("bootstrap-fork",J).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],p);const d=this._process.pid;this._logService.info(`Starting extension host with pid ${d}.`);const b=new S.StringDecoder("utf-8");this._process.stdout?.on("data",v=>{const l=typeof v=="string"?v:b.write(v);this._onStdout.fire(l)});const y=new S.StringDecoder("utf-8");return this._process.stderr?.on("data",v=>{const l=typeof v=="string"?v:y.write(v);this._onStderr.fire(l)}),this._process.on("message",v=>{this._onMessage.fire(v)}),this._process.on("error",v=>{this._onError.fire({error:(0,D.transformErrorForSerialization)(v)})}),this._process.on("exit",(v,l)=>{this._onExit.fire({pid:d,code:v,signal:l})}),{pid:d}}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):E.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}};g=he([Q(1,n.ILogService)],g);let w=class vt{constructor(p){this._logService=p,this._extHosts=new Map}dispose(){}_getExtHost(p){const d=this._extHosts.get(p);if(!d)throw new Error("Unknown extension host!");return d}onDynamicStdout(p){return this._getExtHost(p).onStdout}onDynamicStderr(p){return this._getExtHost(p).onStderr}onDynamicMessage(p){return this._getExtHost(p).onMessage}onDynamicError(p){return this._getExtHost(p).onError}onDynamicExit(p){return this._getExtHost(p).onExit}async createExtensionHost(){const p=String(++vt._lastId),d=new g(p,this._logService);return this._extHosts.set(p,d),d.onExit(({pid:b,code:y,signal:v})=>{this._logService.info(`Extension host with pid ${b} exited with code: ${y}, signal: ${v}.`),setTimeout(()=>{d.dispose(),this._extHosts.delete(p)})}),{id:p}}async start(p,d){return this._getExtHost(p).start(d)}async enableInspectPort(p){const d=this._extHosts.get(p);return d?d.enableInspectPort():!1}async kill(p){const d=this._extHosts.get(p);!d||d.kill()}};w._lastId=0,w=he([Q(0,n.ILogService)],w),e.ExtensionHostStarter=w,(0,I.registerSingleton)(R.IExtensionHostStarter,w,!0)}),define(te[85],ne([0,1,3,7,10]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(g){this.service=g,this.onDidChangeLogLevel=D.Event.buffer(g.onDidChangeLogLevel,!0)}listen(g,w){switch(w){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${w}`)}async call(g,w,f){switch(w){case"setLevel":return this.service.setLevel(f)}throw new Error(`Call not found: ${w}`)}}e.LogLevelChannel=T;class k{constructor(g){this.channel=g}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(g){k.setLevel(this.channel,g)}static setLevel(g,w){return g.call("setLevel",w)}}e.LogLevelChannelClient=k;class C{constructor(g){this.loggerService=g,this.loggers=new Map}listen(g,w){throw new Error(`Event not found: ${w}`)}async call(g,w,f){switch(w){case"createLogger":this.createLogger(L.URI.revive(f[0]),f[1]);return;case"log":return this.log(L.URI.revive(f[0]),f[1]);case"consoleLog":return this.consoleLog(f[0],f[1])}throw new Error(`Call not found: ${w}`)}createLogger(g,w){this.loggers.set(g.toString(),this.loggerService.createLogger(g,w))}consoleLog(g,w){let f=console.log;switch(g){case R.LogLevel.Error:f=console.error;break;case R.LogLevel.Warning:f=console.warn;break;case R.LogLevel.Info:f=console.info;break}f.call(console,...w)}log(g,w){const f=this.loggers.get(g.toString());if(!f)throw new Error("Create the logger before logging");for(const[p,d]of w)switch(p){case R.LogLevel.Trace:f.trace(d);break;case R.LogLevel.Debug:f.debug(d);break;case R.LogLevel.Info:f.info(d);break;case R.LogLevel.Warning:f.warn(d);break;case R.LogLevel.Error:f.error(d);break;case R.LogLevel.Critical:f.critical(d);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=C;class S extends R.AbstractLoggerService{constructor(g,w,f){super(g,w);this.channel=f}createConsoleMainLogger(){return new R.AdapterLogger({log:(g,w)=>{this.channel.call("consoleLog",[g,w])}})}doCreateLogger(g,w,f){return new E(this.channel,g,w,f)}}e.LoggerChannelClient=S;class E extends R.AbstractMessageLogger{constructor(g,w,f,p){super(p?.always);this.channel=g,this.file=w,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(f),this.channel.call("createLogger",[w,p]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(g,w){const f=[[g,w]];this.isLoggerCreated?this.doLog(f):this.buffer.push(...f)}doLog(g){this.channel.call("log",[this.file,g])}}class n extends R.LogService{constructor(g,w){super(w);this.parent=g,this._register(g.onDidChangeLogLevel(f=>w.setLevel(f)))}setLevel(g){super.setLevel(g),this.parent.setLevel(g)}}e.FollowerLogService=n}),define(te[59],ne([0,1,5]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(te[42],ne([0,1,15,4,31,16]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const C=L.globals.vscode.context.configuration();if(C)k=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const C=(0,T.dirname)(D.FileAccess.asFileUri("",J));k=J.__$__nodeRequire((0,T.joinPath)(C,"product.json").fsPath);const S=J.__$__nodeRequire((0,T.joinPath)(C,"package.json").fsPath);R.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`}),Object.assign(k,{version:S.version})}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=k}),define(te[86],ne([0,1,22,9,136,14,42]),function(J,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function C(I,g,w,f,p,d){let b;try{await S(I,g,w,f,p,d)}catch(y){b=y}finally{b&&p.errorTransformer&&(b=p.errorTransformer(b)),typeof b!="undefined"&&w.error(b),w.end()}}e.readFileIntoStream=C;async function S(I,g,w,f,p,d){E(d);const b=await I.open(g,{create:!1});try{E(d);let y=0,v=0,l=p&&typeof p.length=="number"?p.length:void 0,c=D.VSBuffer.alloc(Math.min(p.bufferSize,typeof l=="number"?l:p.bufferSize)),t=p&&typeof p.position=="number"?p.position:0,s=0;do v=await I.read(b,t,c.buffer,s,c.byteLength-s),t+=v,s+=v,y+=v,typeof l=="number"&&(l-=v),s===c.byteLength&&(await w.write(f(c)),c=D.VSBuffer.alloc(Math.min(p.bufferSize,typeof l=="number"?l:p.bufferSize)),s=0);while(v>0&&(typeof l!="number"||l>0)&&E(d)&&n(y,p));if(s>0){let r=s;typeof l=="number"&&(r=Math.min(s,l)),w.write(f(c.slice(0,r)))}}catch(y){throw(0,T.ensureFileSystemProviderError)(y)}finally{await I.close(b)}}function E(I){if(I.isCancellationRequested)throw(0,L.canceled)();return!0}function n(I,g){if(g?.limits){if(typeof g.limits.memory=="number"&&I>g.limits.memory)throw(0,T.createFileSystemProviderError)((0,R.localize)(0,null,k.default.nameShort),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof g.limits.size=="number"&&I>g.limits.size)throw(0,T.createFileSystemProviderError)((0,R.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[174],ne([0,1,17,6,22,27,3,55,2,41,15,175,16,50,134,14,86,10]),function(J,e,D,L,R,T,k,C,S,E,n,I,g,w,f,p,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let y=class He extends S.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new k.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(He.FILE_EVENTS_THROTTLING.maxChangesChunkSize,He.FILE_EVENTS_THROTTLING.maxChangesBufferSize,He.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new p.FileChangesEvent(c,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(He.FILE_EVENTS_THROTTLING.maxChangesChunkSize,He.FILE_EVENTS_THROTTLING.maxChangesBufferSize,He.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new p.FileChangesEvent(c,!0)))),this.watchedResources=E.TernarySearchTree.forUris(c=>{const t=this.getProvider(c.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(l,c){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${l}`),this.provider.set(l,c),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:c});const t=new S.DisposableStore;return t.add(c.onDidChangeFile(s=>this.onDidChangeFile(s,this.isPathCaseSensitive(c)))),t.add(c.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:c,scheme:l}))),typeof c.onDidErrorOccur=="function"&&t.add(c.onDidErrorOccur(s=>this._onError.fire(new Error(s)))),(0,S.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:c}),this.provider.delete(l),(0,S.dispose)(t)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const c=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(t){c.push(t)}}),!this.provider.has(l)&&await L.Promises.settled(c)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,c){const t=this.provider.get(l.scheme);return!!(t&&t.capabilities&c)}listCapabilities(){return C.Iterable.map(this.provider,([l,c])=>({scheme:l,capabilities:c.capabilities}))}async withProvider(l){if(!(0,g.isAbsolutePath)(l))throw new p.FileOperationError((0,f.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const c=this.provider.get(l.scheme);if(!c){const t=new Error;throw t.name="ENOPRO",t.message=(0,f.localize)(1,null,l.toString()),t}return c}async withReadProvider(l){const c=await this.withProvider(l);if((0,p.hasOpenReadWriteCloseCapability)(c)||(0,p.hasReadWriteCapability)(c)||(0,p.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const c=await this.withProvider(l);if((0,p.hasOpenReadWriteCloseCapability)(c)||(0,p.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,c){try{return await this.doResolveFile(l,c)}catch(t){throw(0,p.toFileSystemProviderErrorCode)(t)===p.FileSystemProviderErrorCode.FileNotFound?new p.FileOperationError((0,f.localize)(2,null,this.resourceForError(l)),1):(0,p.ensureFileSystemProviderError)(t)}}async doResolveFile(l,c){const t=await this.withProvider(l),s=this.isPathCaseSensitive(t),r=c?.resolveTo,i=c?.resolveSingleChildDescendants,a=c?.resolveMetadata,o=await t.stat(l);let u;return this.toFileStat(t,l,o,void 0,!!a,(h,m)=>(u||(u=E.TernarySearchTree.forUris(()=>!s),u.set(l,!0),r&&u.fill(!0,r)),u.get(h.resource)||u.findSuperstr(h.resource.with({query:null,fragment:null}))?!0:h.isDirectory&&i?m===1:!1))}async toFileStat(l,c,t,s,r,i){const{providerExtUri:a}=this.getExtUri(l),o={resource:c,name:a.basename(c),isFile:(t.type&p.FileType.File)!=0,isDirectory:(t.type&p.FileType.Directory)!=0,isSymbolicLink:(t.type&p.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&p.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,p.etag)({mtime:t.mtime,size:t.size})};if(o.isDirectory&&i(o,s)){try{const u=await l.readdir(c),h=await L.Promises.settled(u.map(async([m,A])=>{try{const _=a.joinPath(c,m),O=r?await l.stat(_):{type:A};return await this.toFileStat(l,_,O,u.length,r,i)}catch(_){return this.logService.trace(_),null}}));o.children=(0,D.coalesce)(h)}catch(u){this.logService.trace(u),o.children=[]}return o}return o}async resolveAll(l){return L.Promises.settled(l.map(async c=>{try{return{stat:await this.doResolveFile(c.resource,c.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(l){const c=await this.withProvider(l);try{return!!await c.stat(l)}catch(t){return!1}}async canCreateFile(l,c){try{await this.doValidateCreateFile(l,c)}catch(t){return t}return!0}async doValidateCreateFile(l,c){if(!c?.overwrite&&await this.exists(l))throw new p.FileOperationError((0,f.localize)(3,null,this.resourceForError(l)),3,c)}async createFile(l,c=R.VSBuffer.fromString(""),t){await this.doValidateCreateFile(l,t);const s=await this.writeFile(l,c);return this._onDidRunOperation.fire(new p.FileOperationEvent(l,0,s)),s}async writeFile(l,c,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:r}=this.getExtUri(s);try{await this.validateWriteFile(s,l,t)||await this.mkdirp(s,r.dirname(l));let a;if((0,p.hasReadWriteCapability)(s)&&!(c instanceof R.VSBuffer))if((0,w.isReadableStream)(c)){const o=await(0,w.peekStream)(c,3);o.ended?a=R.VSBuffer.concat(o.buffer):a=o}else a=(0,w.peekReadable)(c,o=>R.VSBuffer.concat(o),3);else a=c;!(0,p.hasOpenReadWriteCloseCapability)(s)||(0,p.hasReadWriteCapability)(s)&&a instanceof R.VSBuffer?await this.doWriteUnbuffered(s,l,t,a):await this.doWriteBuffered(s,l,t,a instanceof R.VSBuffer?(0,R.bufferToReadable)(a):a)}catch(i){throw new p.FileOperationError((0,f.localize)(4,null,this.resourceForError(l),(0,p.ensureFileSystemProviderError)(i).toString()),(0,p.toFileOperationResult)(i),t)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,c,t){if(!!t?.unlock&&!(l.capabilities&8192))throw new Error((0,f.localize)(5,null,this.resourceForError(c)));let r;try{r=await l.stat(c)}catch(i){return}if((r.type&p.FileType.Directory)!=0)throw new p.FileOperationError((0,f.localize)(6,null,this.resourceForError(c)),0,t);if(this.throwIfFileIsReadonly(c,r),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==p.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&t.mtime<r.mtime&&t.etag!==(0,p.etag)({mtime:t.mtime,size:r.size}))throw new p.FileOperationError((0,f.localize)(7,null),3,t);return r}async readFile(l,c){const t=await this.withReadProvider(l);return c?.atomic?this.doReadFileAtomic(t,l,c):this.doReadFile(t,l,c)}async doReadFileAtomic(l,c,t){return new Promise((s,r)=>{this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri).queue(async()=>{try{const i=await this.doReadFile(l,c,t);s(i)}catch(i){r(i)}})})}async doReadFile(l,c,t){const s=await this.doReadFileStream(l,c,{...t,preferUnbuffered:!0});return{...s,value:await(0,R.streamToBuffer)(s.value)}}async readFileStream(l,c){const t=await this.withReadProvider(l);return this.doReadFileStream(t,l,c)}async doReadFileStream(l,c,t){const s=new T.CancellationTokenSource,r=this.validateReadFile(c,t).then(a=>a,a=>{throw s.cancel(),a});let i;try{return typeof t?.etag=="string"&&t.etag!==p.ETAG_DISABLED&&await r,!((0,p.hasOpenReadWriteCloseCapability)(l)||(0,p.hasFileReadStreamCapability)(l))||(0,p.hasReadWriteCapability)(l)&&t?.preferUnbuffered?i=this.readFileUnbuffered(l,c,t):(0,p.hasFileReadStreamCapability)(l)?i=this.readFileStreamed(l,c,s.token,t):i=this.readFileBuffered(l,c,s.token,t),{...await r,value:i}}catch(a){i&&await(0,w.consumeStream)(i);const o=(0,f.localize)(8,null,this.resourceForError(c),(0,p.ensureFileSystemProviderError)(a).toString());throw a instanceof p.NotModifiedSinceFileOperationError?new p.NotModifiedSinceFileOperationError(o,a.stat,t):new p.FileOperationError(o,(0,p.toFileOperationResult)(a),t)}}readFileStreamed(l,c,t,s=Object.create(null)){const r=l.readFileStream(c,s,t);return(0,w.transform)(r,{data:i=>i instanceof R.VSBuffer?i:R.VSBuffer.wrap(i),error:i=>new p.FileOperationError((0,f.localize)(9,null,this.resourceForError(c),(0,p.ensureFileSystemProviderError)(i).toString()),(0,p.toFileOperationResult)(i),s)},i=>R.VSBuffer.concat(i))}readFileBuffered(l,c,t,s=Object.create(null)){const r=(0,R.newWriteableBufferStream)();return(0,d.readFileIntoStream)(l,c,r,i=>i,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:i=>new p.FileOperationError((0,f.localize)(10,null,this.resourceForError(c),(0,p.ensureFileSystemProviderError)(i).toString()),(0,p.toFileOperationResult)(i),s)},t),r}readFileUnbuffered(l,c,t){const s=(0,w.newWriteableStream)(r=>R.VSBuffer.concat(r));return(async()=>{try{let r=await l.readFile(c);typeof t?.position=="number"&&(r=r.slice(t.position)),typeof t?.length=="number"&&(r=r.slice(0,t.length)),this.validateReadFileLimits(c,r.byteLength,t),s.end(R.VSBuffer.wrap(r))}catch(r){s.error(r),s.end()}})(),s}async validateReadFile(l,c){const t=await this.resolve(l,{resolveMetadata:!0});if(t.isDirectory)throw new p.FileOperationError((0,f.localize)(11,null,this.resourceForError(l)),0,c);if(typeof c?.etag=="string"&&c.etag!==p.ETAG_DISABLED&&c.etag===t.etag)throw new p.NotModifiedSinceFileOperationError((0,f.localize)(12,null),t,c);return this.validateReadFileLimits(l,t.size,c),t}validateReadFileLimits(l,c,t){if(t?.limits){let s;if(typeof t.limits.memory=="number"&&c>t.limits.memory&&(s=9),typeof t.limits.size=="number"&&c>t.limits.size&&(s=7),typeof s=="number")throw new p.FileOperationError((0,f.localize)(13,null,this.resourceForError(l)),s)}}async canMove(l,c,t){return this.doCanMoveCopy(l,c,"move",t)}async canCopy(l,c,t){return this.doCanMoveCopy(l,c,"copy",t)}async doCanMoveCopy(l,c,t,s){if(l.toString()!==c.toString())try{const r=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c);await this.doValidateMoveCopy(r,l,i,c,t,s)}catch(r){return r}return!0}async move(l,c,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),i=await this.doMoveCopy(s,l,r,c,"move",!!t),a=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(l,i==="move"?2:3,a)),a}async copy(l,c,t){const s=await this.withReadProvider(l),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),i=await this.doMoveCopy(s,l,r,c,"copy",!!t),a=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(l,i==="copy"?3:2,a)),a}async doMoveCopy(l,c,t,s,r,i){if(c.toString()===s.toString())return r;const{exists:a,isSameResourceWithDifferentPathCase:o}=await this.doValidateMoveCopy(l,c,t,s,r,i);if(a&&!o&&i&&await this.del(s,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(s)),r==="copy"){if(l===t&&(0,p.hasFileFolderCopyCapability)(l))await l.copy(c,s,{overwrite:i});else{const u=await this.resolve(c);u.isDirectory?await this.doCopyFolder(l,u,t,s):await this.doCopyFile(l,c,t,s)}return r}else return l===t?(await l.rename(c,s,{overwrite:i}),r):(await this.doMoveCopy(l,c,t,s,"copy",i),await this.del(c,{recursive:!0}),"copy")}async doCopyFile(l,c,t,s){if((0,p.hasOpenReadWriteCloseCapability)(l)&&(0,p.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(l,c,t,s);if((0,p.hasOpenReadWriteCloseCapability)(l)&&(0,p.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(l,c,t,s);if((0,p.hasReadWriteCapability)(l)&&(0,p.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(l,c,t,s);if((0,p.hasReadWriteCapability)(l)&&(0,p.hasReadWriteCapability)(t))return this.doPipeUnbuffered(l,c,t,s)}async doCopyFolder(l,c,t,s){await t.mkdir(s),Array.isArray(c.children)&&await L.Promises.settled(c.children.map(async r=>{const i=this.getExtUri(t).providerExtUri.joinPath(s,r.name);return r.isDirectory?this.doCopyFolder(l,await this.resolve(r.resource),t,i):this.doCopyFile(l,r.resource,t,i)}))}async doValidateMoveCopy(l,c,t,s,r,i){let a=!1;if(l===t){const{providerExtUri:u,isPathCaseSensitive:h}=this.getExtUri(l);if(h||(a=u.isEqual(c,s)),a&&r==="copy")throw new Error((0,f.localize)(14,null,this.resourceForError(c),this.resourceForError(s)));if(!a&&u.isEqualOrParent(s,c))throw new Error((0,f.localize)(15,null,this.resourceForError(c),this.resourceForError(s)))}const o=await this.exists(s);if(o&&!a){if(!i)throw new p.FileOperationError((0,f.localize)(16,null,this.resourceForError(c),this.resourceForError(s)),4);if(l===t){const{providerExtUri:u}=this.getExtUri(l);if(u.isEqualOrParent(c,s))throw new Error((0,f.localize)(17,null,this.resourceForError(c),this.resourceForError(s)))}}return{exists:o,isSameResourceWithDifferentPathCase:a}}getExtUri(l){const c=this.isPathCaseSensitive(l);return{providerExtUri:c?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:c}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(c,l);const t=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new p.FileOperationEvent(l,0,t)),t}async mkdirp(l,c){const t=[],{providerExtUri:s}=this.getExtUri(l);for(;!s.isEqual(c,s.dirname(c));)try{if(((await l.stat(c)).type&p.FileType.Directory)==0)throw new Error((0,f.localize)(18,null,this.resourceForError(c)));break}catch(r){if((0,p.toFileSystemProviderErrorCode)(r)!==p.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(s.basename(c)),c=s.dirname(c)}for(let r=t.length-1;r>=0;r--){c=s.joinPath(c,t[r]);try{await l.mkdir(c)}catch(i){if((0,p.toFileSystemProviderErrorCode)(i)!==p.FileSystemProviderErrorCode.FileExists)throw i}}}async canDelete(l,c){try{await this.doValidateDelete(l,c)}catch(t){return t}return!0}async doValidateDelete(l,c){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!c?.useTrash&&!(t.capabilities&4096))throw new Error((0,f.localize)(19,null,this.resourceForError(l)));let r;try{r=await t.stat(l)}catch(a){}if(r)this.throwIfFileIsReadonly(l,r);else throw new p.FileOperationError((0,f.localize)(20,null,this.resourceForError(l)),1);if(!!!c?.recursive){const a=await this.resolve(l);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,f.localize)(21,null,this.resourceForError(l)))}return t}async del(l,c){const t=await this.doValidateDelete(l,c),s=!!c?.useTrash,r=!!c?.recursive;await t.delete(l,{recursive:r,useTrash:s}),this._onDidRunOperation.fire(new p.FileOperationEvent(l,1))}onDidChangeFile(l,c){this._onDidChangeFilesRaw.fire({changes:l});let t,s;{for(const r of l)this.watchedResources.has(r.resource)?(t||(t=[]),t.push(r)):(s||(s=[]),s.push(r));t&&this._onDidFilesChange.fire(new p.FileChangesEvent(t,!c))}if(s){const r=c?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(s)&&He.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(l,c={recursive:!1,excludes:[]}){const t=new S.DisposableStore;{let s=!1,r=()=>{s=!0};t.add((0,S.toDisposable)(()=>r())),this.doWatch(l,c).then(i=>{s?(0,S.dispose)(i):r=()=>(0,S.dispose)(i)},i=>this.logService.error(i))}return c.recursive||(this.watchedResources.set(l,(this.watchedResources.get(l)??0)+1),t.add((0,S.toDisposable)(()=>{const s=this.watchedResources.get(l);typeof s=="number"&&(s<=1?this.watchedResources.delete(l):this.watchedResources.set(l,s-1))}))),t}async doWatch(l,c){const t=await this.withProvider(l),s=this.toWatchKey(t,l,c),r=this.activeWatchers.get(s)||{count:0,disposable:t.watch(l,c)};return this.activeWatchers.has(s)||this.activeWatchers.set(s,r),r.count+=1,(0,S.toDisposable)(()=>{r.count--,r.count===0&&((0,S.dispose)(r.disposable),this.activeWatchers.delete(s))})}toWatchKey(l,c,t){const{providerExtUri:s}=this.getExtUri(l);return[s.getComparisonKey(c),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,S.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,c,t,s){return this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri).queue(async()=>{const r=await l.open(c,{create:!0,unlock:t?.unlock??!1});try{(0,w.isReadableStream)(s)||(0,w.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(l,r,s):await this.doWriteReadableBufferedQueued(l,r,s)}catch(i){throw(0,p.ensureFileSystemProviderError)(i)}finally{await l.close(r)}})}async doWriteStreamBufferedQueued(l,c,t){let s=0,r;if((0,w.isReadableBufferedStream)(t)){if(t.buffer.length>0){const i=R.VSBuffer.concat(t.buffer);await this.doWriteBuffer(l,c,i,i.byteLength,s,0),s+=i.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise(async(i,a)=>{(0,w.listenStream)(r,{onData:async o=>{r.pause();try{await this.doWriteBuffer(l,c,o,o.byteLength,s,0)}catch(u){return a(u)}s+=o.byteLength,setTimeout(()=>r.resume())},onError:o=>a(o),onEnd:()=>i()})})}async doWriteReadableBufferedQueued(l,c,t){let s=0,r;for(;(r=t.read())!==null;)await this.doWriteBuffer(l,c,r,r.byteLength,s,0),s+=r.byteLength}async doWriteBuffer(l,c,t,s,r,i){let a=0;for(;a<s;)a+=await l.write(c,r+a,t.buffer,i+a,s-a)}async doWriteUnbuffered(l,c,t,s){return this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,c,t,s))}async doWriteUnbufferedQueued(l,c,t,s){let r;s instanceof R.VSBuffer?r=s:(0,w.isReadableStream)(s)?r=await(0,R.streamToBuffer)(s):(0,w.isReadableBufferedStream)(s)?r=await(0,R.bufferedStreamToBuffer)(s):r=(0,R.readableToBuffer)(s),await l.writeFile(c,r.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(l,c,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,c,t,s))}async doPipeBufferedQueued(l,c,t,s){let r,i;try{r=await l.open(c,{create:!1}),i=await t.open(s,{create:!0,unlock:!1});const a=R.VSBuffer.alloc(this.BUFFER_SIZE);let o=0,u=0,h=0;do h=await l.read(r,o,a.buffer,u,a.byteLength-u),await this.doWriteBuffer(t,i,a,h,o,u),o+=h,u+=h,u===a.byteLength&&(u=0);while(h>0)}catch(a){throw(0,p.ensureFileSystemProviderError)(a)}finally{await L.Promises.settled([typeof r=="number"?l.close(r):Promise.resolve(),typeof i=="number"?t.close(i):Promise.resolve()])}}async doPipeUnbuffered(l,c,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,c,t,s))}async doPipeUnbufferedQueued(l,c,t,s){return t.writeFile(s,await l.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,c,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,c,t,s))}async doPipeUnbufferedToBufferedQueued(l,c,t,s){const r=await t.open(s,{create:!0,unlock:!1});try{const i=await l.readFile(c);await this.doWriteBuffer(t,r,R.VSBuffer.wrap(i),i.byteLength,0,0)}catch(i){throw(0,p.ensureFileSystemProviderError)(i)}finally{await t.close(r)}}async doPipeBufferedToUnbuffered(l,c,t,s){const r=await(0,R.streamToBuffer)(this.readFileBuffered(l,c,T.CancellationToken.None));await this.doWriteUnbuffered(t,s,void 0,r)}throwIfFileSystemIsReadonly(l,c){if(l.capabilities&2048)throw new p.FileOperationError((0,f.localize)(22,null,this.resourceForError(c)),6);return l}throwIfFileIsReadonly(l,c){if((c.permissions??0)&p.FilePermission.Readonly)throw new p.FileOperationError((0,f.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===n.Schemas.file?l.fsPath:l.toString(!0)}};y.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},y=he([Q(0,b.ILogService)],y),e.FileService=y}),define(te[176],ne([0,1,17,6,22,3,40,2,8,4,16,50,19,137,14,86,165,153,154,83,156,10,42]),function(J,e,D,L,R,T,k,C,S,E,n,I,g,w,f,p,d,b,y,v,l,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class s extends C.Disposable{constructor(i,a){super();this.logService=i,this.options=a,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=T.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new T.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:a,symbolicLink:o}=await g.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(a,o),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(i){try{const a=await g.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),o=[];return await Promise.all(a.map(async u=>{try{let h;u.isSymbolicLink()?h=(await this.stat((0,n.joinPath)(i,u.name))).type:h=this.toType(u),o.push([u.name,h])}catch(h){this.logService.trace(h)}})),o}catch(a){throw this.toFileSystemProviderError(a)}}toType(i,a){let o;return a?.dangling?o=f.FileType.Unknown:i.isFile()?o=f.FileType.File:i.isDirectory()?o=f.FileType.Directory:o=f.FileType.Unknown,a&&(o|=f.FileType.SymbolicLink),o}async readFile(i){try{const a=this.toFilePath(i);return await g.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(i,a,o){const u=(0,I.newWriteableStream)(h=>R.VSBuffer.concat(h.map(m=>R.VSBuffer.wrap(m))).buffer);return(0,p.readFileIntoStream)(this,i,u,h=>h.buffer,{...a,bufferSize:this.BUFFER_SIZE},o),u}async writeFile(i,a,o){let u;try{const h=this.toFilePath(i);if(!o.create||!o.overwrite){if(await g.Promises.exists(h)){if(!o.overwrite)throw(0,f.createFileSystemProviderError)((0,w.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,f.createFileSystemProviderError)((0,w.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(u,0,a,0,a.byteLength)}catch(h){throw await this.toFileSystemProviderWriteError(i,h)}finally{typeof u=="number"&&await this.close(u)}}async open(i,a){try{const o=this.toFilePath(i);if((0,f.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:m}=await g.SymlinkSupport.stat(o);m.mode&128||await g.Promises.chmod(o,m.mode|128)}catch(m){this.logService.trace(m)}let u;if((0,f.isFileOpenForWriteOptions)(a)){if(E.isWindows)try{await g.Promises.truncate(o,0),u="r+"}catch(m){m.code!=="ENOENT"&&this.logService.trace(m)}u||(u="w")}else u="r";const h=await g.Promises.open(o,u);return this.mapHandleToPos.set(h,0),(0,f.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(h,i),h}catch(o){throw(0,f.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(i,o):this.toFileSystemProviderError(o)}}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await g.Promises.fdatasync(i)}catch(a){this.canFlush=!1,this.logService.error(a)}return await g.Promises.close(i)}catch(a){throw this.toFileSystemProviderError(a)}}async read(i,a,o,u,h){const m=this.normalizePos(i,a);let A=null;try{const _=await g.Promises.read(i,o,u,h,m);return typeof _=="number"?A=_:A=_.bytesRead,A}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(i,m,A)}}normalizePos(i,a){return a===this.mapHandleToPos.get(i)?null:a}updatePos(i,a,o){const u=this.mapHandleToPos.get(i);typeof u=="number"&&(typeof a=="number"||(typeof o=="number"?this.mapHandleToPos.set(i,u+o):this.mapHandleToPos.delete(i)))}async write(i,a,o,u,h){return(0,L.retry)(()=>this.doWrite(i,a,o,u,h),100,3)}async doWrite(i,a,o,u,h){const m=this.normalizePos(i,a);let A=null;try{const _=await g.Promises.write(i,o,u,h,m);return typeof _=="number"?A=_:A=_.bytesWritten,A}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),_)}finally{this.updatePos(i,m,A)}}async mkdir(i){try{await g.Promises.mkdir(this.toFilePath(i))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(i,a){try{const o=this.toFilePath(i);await this.doDelete(o,a)}catch(o){throw this.toFileSystemProviderError(o)}}async doDelete(i,a){a.recursive?await g.Promises.rm(i,g.RimRafMode.MOVE):await g.Promises.unlink(i)}async rename(i,a,o){const u=this.toFilePath(i),h=this.toFilePath(a);if(u!==h)try{await this.validateTargetDeleted(i,a,"move",o.overwrite),await g.Promises.move(u,h)}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,w.localize)(2,null,(0,S.basename)(u),(0,S.basename)((0,S.dirname)(h)),m.toString()))),this.toFileSystemProviderError(m)}}async copy(i,a,o){const u=this.toFilePath(i),h=this.toFilePath(a);if(u!==h)try{await this.validateTargetDeleted(i,a,"copy",o.overwrite),await g.Promises.copy(u,h,{preserveSymlinks:!0})}catch(m){throw(m.code==="EINVAL"||m.code==="EBUSY"||m.code==="ENAMETOOLONG")&&(m=new Error((0,w.localize)(3,null,(0,S.basename)(u),(0,S.basename)((0,S.dirname)(h)),m.toString()))),this.toFileSystemProviderError(m)}}async validateTargetDeleted(i,a,o,u){const h=this.toFilePath(i),m=this.toFilePath(a);let A=!1;if(!!(this.capabilities&1024)||(A=(0,k.isEqual)(h,m,!0)),A&&o==="copy")throw(0,f.createFileSystemProviderError)((0,w.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(!A&&await g.Promises.exists(m)){if(!u)throw(0,f.createFileSystemProviderError)((0,w.localize)(5,null),f.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(i,a){return a.recursive?this.watchRecursive(i,a):this.watchNonRecursive(i)}watchRecursive(i,a){const o={path:this.toFilePath(i),excludes:a.excludes},u=(0,D.insert)(this.recursiveFoldersToWatch,o);return this.refreshRecursiveWatchers(),(0,C.toDisposable)(()=>{u(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof b.FileWatcher)this.recursiveWatcher.watch(this.recursiveFoldersToWatch);else if((0,C.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let i,a;if(this.options?.watcher?.usePolling)i=y.FileWatcher,a=this.options?.watcher;else{let o;this.options?.enableLegacyRecursiveWatcher?o=!0:o=t.default.quality==="stable"&&E.isLinux,o&&this.recursiveFoldersToWatch.length===1?E.isWindows?i=l.FileWatcher:i=y.FileWatcher:i=b.FileWatcher}this.recursiveWatcher=new i(this.recursiveFoldersToWatch,o=>this._onDidChangeFile.fire((0,v.toFileChanges)(o)),o=>{o.type==="error"&&this._onDidWatchErrorOccur.fire(o.message),this.logService[o.type](o.message)},this.logService.getLevel()===c.LogLevel.Trace,a),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)}))}}watchNonRecursive(i){const a=new d.FileWatcher(this.toFilePath(i),u=>this._onDidChangeFile.fire((0,v.toFileChanges)(u)),u=>{u.type==="error"&&this._onDidWatchErrorOccur.fire(u.message),this.logService[u.type](u.message)},this.logService.getLevel()===c.LogLevel.Trace),o=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)});return(0,C.combinedDisposable)(a,o)}toFilePath(i){return(0,S.normalize)(i.fsPath)}toFileSystemProviderError(i){if(i instanceof f.FileSystemProviderError)return i;let a;switch(i.code){case"ENOENT":a=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=f.FileSystemProviderErrorCode.NoPermissions;break;default:a=f.FileSystemProviderErrorCode.Unknown}return(0,f.createFileSystemProviderError)(i,a)}async toFileSystemProviderWriteError(i,a){let o=this.toFileSystemProviderError(a);if(i&&o.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await g.SymlinkSupport.stat(this.toFilePath(i));u.mode&128||(o=(0,f.createFileSystemProviderError)(a,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.logService.trace(u)}return o}dispose(){super.dispose(),(0,C.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,C.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=s}),define(te[29],ne([0,1,5]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService")}),define(te[177],ne([0,1,6,9,2,8,19,10,29]),function(J,e,D,L,R,T,k,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let E=class extends R.Disposable{constructor(I,g,w){super();this.productService=g,this.logService=w,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,I&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(I)},30*1e3)).schedule()}async cleanUpCodeCaches(I){this.logService.info("[code cache cleanup]: Starting to clean up old code cache folders.");try{const g=Date.now(),w=(0,T.dirname)(I),f=(0,T.basename)(I),p=await k.Promises.readdir(w);await Promise.all(p.map(async d=>{if(d===f)return;const b=(0,T.join)(w,d),y=await k.Promises.stat(b);if(y.isDirectory()&&g-y.mtime.getTime()>this._DataMaxAge)return this.logService.info(`[code cache cleanup]: Removing code cache folder ${d}.`),k.Promises.rm(b)}))}catch(g){(0,L.onUnexpectedError)(g)}}};E=he([Q(1,S.IProductService),Q(2,C.ILogService)],E),e.CodeCacheCleaner=E}),define(te[178],ne([0,1,6,9,2,8,19,13,10,29]),function(J,e,D,L,R,T,k,C,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let n=class extends R.Disposable{constructor(g,w,f){super();this.environmentService=g,this.logService=w,this.productService=f,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.info("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const g=Object.create(null),w=JSON.parse(await k.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let y of Object.keys(w)){const v=w[y];g[`${v.hash}.${y}`]=!0}const f=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await k.Promises.exists(f))return;const d=await k.Promises.readdir(f);for(const y of d){if(g[y]){this.logService.info(`[language pack cache cleanup]: Skipping folder ${y}. Language pack still in use.`);continue}this.logService.info(`[language pack cache cleanup]: Removing unused language pack: ${y}`),await k.Promises.rm((0,T.join)(f,y))}const b=Date.now();for(const y of Object.keys(g)){const v=(0,T.join)(f,y),l=await k.Promises.readdir(v);for(const c of l){if(c==="tcf.json")continue;const t=(0,T.join)(v,c),s=await k.Promises.stat(t);s.isDirectory()&&b-s.mtime.getTime()>this._DataMaxAge&&(this.logService.info(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(y,c)}`),await k.Promises.rm(t))}}}catch(g){(0,L.onUnexpectedError)(g)}}};n=he([Q(0,C.INativeEnvironmentService),Q(1,S.ILogService),Q(2,E.IProductService)],n),e.LanguagePackCachedDataCleaner=n}),define(te[34],ne([0,1,99,18]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class R{constructor(){this.data=new Map}add(k,C){D.ok(L.isString(k)),D.ok(L.isObject(C)),D.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,C)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new R}),define(te[87],ne([0,1,3,34]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function R(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class T{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,E){this.schemasById[R(S)]=E,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new T;L.Registry.add(e.Extensions.JSONContribution,k)}),define(te[39],ne([0,1,17,3,18,123,87,34]),function(J,e,D,L,R,T,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var S;(function(y){y.Multiline="multilineText",y.Singleline="singlelineText"})(S=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var E;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const n=C.Registry.as(k.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(v,l=!0){this.registerConfigurations([v],l)}registerConfigurations(v,l=!0){const c=this.doRegisterConfigurations(v,l);n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterConfigurations(v){const l=this.doDeregisterConfigurations(v);n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}updateConfigurations({add:v,remove:l}){const c=[];c.push(...this.doDeregisterConfigurations(l)),c.push(...this.doRegisterConfigurations(v,!1)),n.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,D.distinct)(c))}registerDefaultConfigurations(v){const l=[],c=[];for(const t of v)for(const s in t)if(l.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]={...this.defaultValues[s]||{},...t[s]};const r={type:"object",default:this.defaultValues[s],description:T.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};c.push(w(s)),this.configurationProperties[s]=r,this.defaultLanguageConfigurationOverridesNode.properties[s]=r}else{this.defaultValues[s]=t[s];const r=this.configurationProperties[s];r&&(this.updatePropertyDefaultValue(s,r),this.updateSchema(s,r))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterDefaultConfigurations(v){const l=[];for(const c of v)for(const t in c)if(l.push(t),delete this.defaultValues[t],e.OVERRIDE_PROPERTY_PATTERN.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const s=this.configurationProperties[t];s&&(this.updatePropertyDefaultValue(t,s),this.updateSchema(t,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}notifyConfigurationSchemaUpdated(...v){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(v){for(const l of v)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(v,l){const c=[];return v.forEach(t=>{c.push(...this.validateAndRegisterProperties(t,l,t.extensionInfo)),this.configurationContributors.push(t),this.registerJSONConfiguration(t)}),c}doDeregisterConfigurations(v){const l=[],c=t=>{if(t.properties)for(const s in t.properties)l.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,t.properties[s]);t.allOf&&t.allOf.forEach(s=>c(s))};for(const t of v){c(t);const s=this.configurationContributors.indexOf(t);s!==-1&&this.configurationContributors.splice(s,1)}return l}validateAndRegisterProperties(v,l=!0,c,t=3){t=R.isUndefinedOrNull(v.scope)?t:v.scope;let s=[],r=v.properties;if(r)for(let a in r){if(l&&d(a)){delete r[a];continue}const o=r[a];if(this.updatePropertyDefaultValue(a,o),e.OVERRIDE_PROPERTY_PATTERN.test(a)?o.scope=void 0:(o.scope=R.isUndefinedOrNull(o.scope)?t:o.scope,o.restricted=R.isUndefinedOrNull(o.restricted)?!!c?.restrictedConfigurations?.includes(a):o.restricted),r[a].hasOwnProperty("included")&&!r[a].included){this.excludedConfigurationProperties[a]=r[a],delete r[a];continue}else this.configurationProperties[a]=r[a];!r[a].deprecationMessage&&r[a].markdownDeprecationMessage&&(r[a].deprecationMessage=r[a].markdownDeprecationMessage),s.push(a)}let i=v.allOf;if(i)for(let a of i)s.push(...this.validateAndRegisterProperties(a,l,c,t));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(v){const l=c=>{let t=c.properties;if(t)for(const r in t)this.updateSchema(r,t[r]);let s=c.allOf;s&&s.forEach(l)};l(v)}updateSchema(v,l){switch(e.allSettings.properties[v]=l,l.scope){case 1:e.applicationSettings.properties[v]=l;break;case 2:e.machineSettings.properties[v]=l;break;case 6:e.machineOverridableSettings.properties[v]=l;break;case 3:e.windowSettings.properties[v]=l;break;case 4:e.resourceSettings.properties[v]=l;break;case 5:e.resourceSettings.properties[v]=l,this.resourceLanguageSettingsSchema.properties[v]=l;break}}removeFromSchema(v,l){switch(delete e.allSettings.properties[v],l.scope){case 1:delete e.applicationSettings.properties[v];break;case 2:delete e.machineSettings.properties[v];break;case 6:delete e.machineOverridableSettings.properties[v];break;case 3:delete e.windowSettings.properties[v];break;case 4:case 5:delete e.resourceSettings.properties[v];break}}updateOverridePropertyPatternKey(){for(const v of this.overrideIdentifiers.values()){const l=`[${v}]`,c={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,c),e.allSettings.properties[l]=c,e.applicationSettings.properties[l]=c,e.machineSettings.properties[l]=c,e.machineOverridableSettings.properties[l]=c,e.windowSettings.properties[l]=c,e.resourceSettings.properties[l]=c}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(v,l){let c=this.defaultValues[v];R.isUndefined(c)&&(c=l.default),R.isUndefined(c)&&(c=f(l.type)),l.default=c}}const g="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(g);function w(y){return y.substring(1,y.length-1)}e.overrideIdentifierFromKey=w;function f(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const p=new I;C.Registry.add(e.Extensions.Configuration,p);function d(y){return y.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(y)?T.localize(5,null,y):p.getConfigurationProperties()[y]!==void 0?T.localize(6,null,y):null:T.localize(4,null)}e.validateProperty=d;function b(){const y=[],v=p.getConfigurationProperties();for(const l of Object.keys(v))y.push([l,v[l].scope]);return y.push(["launch",4]),y.push(["task",4]),y}e.getScopes=b}),define(te[20],ne([0,1,26,18,7,39,5,34]),function(J,e,D,L,R,T,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function S(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof R.URI)}e.isConfigurationOverrides=S;var E;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(E=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function I(s,r){const i=r?s?r.keys.filter(_=>s.keys.indexOf(_)===-1):[...r.keys]:[],a=s?r?s.keys.filter(_=>r.keys.indexOf(_)===-1):[...s.keys]:[],o=[];if(r&&s){for(const _ of s.keys)if(r.keys.indexOf(_)!==-1){const O=b(s.contents,_),N=b(r.contents,_);D.equals(O,N)||o.push(_)}}const u=[],h=_=>{const O={};for(const N of _)for(const P of N.identifiers)O[c(P)]=N;return O},m=r?h(r.overrides):{},A=s?h(s.overrides):{};if(Object.keys(m).length)for(const _ of i){const O=m[_];O&&u.push([(0,T.overrideIdentifierFromKey)(_),O.keys])}if(Object.keys(A).length)for(const _ of a){const O=A[_];O&&u.push([(0,T.overrideIdentifierFromKey)(_),O.keys])}if(Object.keys(m).length&&Object.keys(A).length)for(const _ of o){const O=A[_],N=m[_];if(O&&N){const P=I({contents:O.contents,keys:O.keys,overrides:[]},{contents:N.contents,keys:N.keys,overrides:[]});u.push([(0,T.overrideIdentifierFromKey)(_),[...P.added,...P.removed,...P.updated]])}}return{added:i,removed:a,updated:o,overrides:u}}e.compare=I;function g(s,r){const i=[];for(const a of Object.keys(s))if(T.OVERRIDE_PROPERTY_PATTERN.test(a)){const o={};for(const u in s[a])o[u]=s[a][u];i.push({identifiers:[(0,T.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(o),contents:w(o,r)})}return i}e.toOverrides=g;function w(s,r){const i=Object.create(null);for(let a in s)f(i,a,s[a],r);return i}e.toValuesTree=w;function f(s,r,i,a){const o=r.split("."),u=o.pop();let h=s;for(let m=0;m<o.length;m++){let A=o[m],_=h[A];switch(typeof _){case"undefined":_=h[A]=Object.create(null);break;case"object":break;default:a(`Ignoring ${r} as ${o.slice(0,m+1).join(".")} is ${JSON.stringify(_)}`);return}h=_}if(typeof h=="object"&&h!==null)try{h[u]=i}catch(m){a(`Ignoring ${r} as ${o.join(".")} is ${JSON.stringify(h)}`)}else a(`Ignoring ${r} as ${o.join(".")} is ${JSON.stringify(h)}`)}e.addToValueTree=f;function p(s,r){const i=r.split(".");d(s,i)}e.removeFromValueTree=p;function d(s,r){const i=r.shift();if(r.length===0){delete s[i];return}if(Object.keys(s).indexOf(i)!==-1){const a=s[i];typeof a=="object"&&!Array.isArray(a)&&(d(a,r),Object.keys(a).length===0&&delete s[i])}}function b(s,r,i){function a(h,m){let A=h;for(const _ of m){if(typeof A!="object"||A===null)return;A=A[_]}return A}const o=r.split("."),u=a(s,o);return typeof u=="undefined"?i:u}e.getConfigurationValue=b;function y(s,r,i){Object.keys(r).forEach(a=>{a!=="__proto__"&&(a in s?L.isObject(s[a])&&L.isObject(r[a])?y(s[a],r[a],i):i&&(s[a]=r[a]):s[a]=r[a])})}e.merge=y;function v(){const s=C.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=v;function l(){const s=Object.create(null),r=C.Registry.as(T.Extensions.Configuration).getConfigurationProperties();for(let i in r){let a=r[i].default;f(s,i,a,o=>console.error(`Conflict in default settings: ${o}`))}return s}e.getDefaultValues=l;function c(s){return`[${s}]`}e.keyFromOverrideIdentifier=c;function t(s,r,i){const a=s.inspect(r),o=s.inspect(i);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:a.defaultValue}e.getMigratedSettingValue=t}),define(te[88],ne([0,1,17,3,36,2,41,26,18,7,20,39,34]),function(J,e,D,L,R,T,k,C,S,E,n,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class w{constructor(t={},s=[],r=[]){this._contents=t,this._keys=s,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,n.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,s){const r=this.getContentsForOverrideIdentifer(s);return r?t?(0,n.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.keys;return[]}override(t){let s=this.overrideConfigurations.get(t);return s||(s=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,s)),s}merge(...t){const s=C.deepClone(this.contents),r=C.deepClone(this.overrides),i=[...this.keys];for(const a of t){this.mergeContents(s,a.contents);for(const o of a.overrides){const[u]=r.filter(h=>D.equals(h.identifiers,o.identifiers));u?this.mergeContents(u.contents,o.contents):r.push(C.deepClone(o))}for(const o of a.keys)i.indexOf(o)===-1&&i.push(o)}return new w(s,i,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(t){const s=this.getContentsForOverrideIdentifer(t);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let r={};for(const i of D.distinct([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[i],o=s[i];o&&(typeof a=="object"&&typeof o=="object"?(a=C.deepClone(a),this.mergeContents(a,o)):a=o),r[i]=a}return new w(r,this.keys,this.overrides)}mergeContents(t,s){for(const r of Object.keys(s)){if(r in t&&S.isObject(t[r])&&S.isObject(s[r])){this.mergeContents(t[r],s[r]);continue}t[r]=C.deepClone(s[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?C.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const s of this.overrides)if(s.identifiers.indexOf(t)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,s){this.addKey(t),(0,n.addToValueTree)(this.contents,t,s,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,n.removeFromValueTree)(this.contents,t)}addKey(t){let s=this.keys.length;for(let r=0;r<s;r++)t.indexOf(this.keys[r])===0&&(s=r);this.keys.splice(s,1,t)}removeKey(t){let s=this.keys.indexOf(t);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=w;class f extends w{constructor(){const t=(0,n.getDefaultValues)(),s=(0,n.getConfigurationKeys)(),r=[];for(const i of Object.keys(t))I.OVERRIDE_PROPERTY_PATTERN.test(i)&&r.push({identifiers:[(0,I.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,n.toValuesTree)(t[i],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,s,r)}}e.DefaultConfigurationModel=f;class p{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new w}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,s){if(!S.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,s)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,s){this._raw=t;const{contents:r,keys:i,overrides:a,restricted:o}=this.doParseRaw(t,s);this._configurationModel=new w(r,i,a),this._restrictedConfigurations=o||[]}doParseContent(t){let s={},r=null,i=[],a=[],o=[];function u(m){Array.isArray(i)?i.push(m):r!==null&&(i[r]=m)}let h={onObjectBegin:()=>{let m={};u(m),a.push(i),i=m,r=null},onObjectProperty:m=>{r=m},onObjectEnd:()=>{i=a.pop()},onArrayBegin:()=>{let m=[];u(m),a.push(i),i=m,r=null},onArrayEnd:()=>{i=a.pop()},onLiteralValue:u,onError:(m,A,_)=>{o.push({error:m,offset:A,length:_})}};if(t)try{R.visit(t,h),s=i[0]||{}}catch(m){console.error(`Error while parsing settings file ${this._name}: ${m}`),this._parseErrors=[m]}return s}doParseRaw(t,s){const r=g.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,r,!0,s);t=i.raw;const a=(0,n.toValuesTree)(t,h=>console.error(`Conflict in settings file ${this._name}: ${h}`)),o=Object.keys(t),u=(0,n.toOverrides)(t,h=>console.error(`Conflict in settings file ${this._name}: ${h}`));return{contents:a,keys:o,overrides:u,restricted:i.restricted}}filter(t,s,r,i){if(!i?.scopes&&!i?.skipRestricted)return{raw:t,restricted:[]};const a={},o=[];for(let u in t)if(I.OVERRIDE_PROPERTY_PATTERN.test(u)&&r){const h=this.filter(t[u],s,!1,i);a[u]=h.raw,o.push(...h.restricted)}else{const h=s[u],m=h?typeof h.scope!="undefined"?h.scope:3:void 0;h?.restricted&&o.push(u),(m===void 0||i.scopes===void 0||i.scopes.includes(m))&&(i.skipRestricted&&h?.restricted||(a[u]=t[u]))}return{raw:a,restricted:o}}}e.ConfigurationModelParser=p;class d extends T.Disposable{constructor(t,s,r,i){super();this.userSettingsResource=t,this.scopes=s,this.fileService=i,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new p(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new w}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=d;class b{constructor(t,s,r=new w,i=new w,a=new k.ResourceMap,o=new w,u=new k.ResourceMap,h=!0){this._defaultConfiguration=t,this._localUserConfiguration=s,this._remoteUserConfiguration=r,this._workspaceConfiguration=i,this._folderConfigurations=a,this._memoryConfiguration=o,this._memoryConfigurationByResource=u,this._freeze=h,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,s,r){return this.getConsolidateConfigurationModel(s,r).getValue(t)}updateValue(t,s,r={}){let i;r.resource?(i=this._memoryConfigurationByResource.get(r.resource),i||(i=new w,this._memoryConfigurationByResource.set(r.resource,i))):i=this._memoryConfiguration,s===void 0?i.removeValue(t):i.setValue(t,s),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,s,r){const i=this.getConsolidateConfigurationModel(s,r),a=this.getFolderConfigurationModelForResource(s.resource,r),o=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,u=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),h=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),m=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),A=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),_=r?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=a?s.overrideIdentifier?a.freeze().override(s.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,N=s.overrideIdentifier?o.override(s.overrideIdentifier).getValue(t):o.getValue(t),P=i.getValue(t),M=D.distinct(D.flatten(i.overrides.map($=>$.identifiers))).filter($=>i.getOverrideValue(t,$)!==void 0);return{defaultValue:u,userValue:h,userLocalValue:m,userRemoteValue:A,workspaceValue:_,workspaceFolderValue:O,memoryValue:N,value:P,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,user:h!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userLocal:m!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspace:_!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:a?.freeze().getValue(t),override:s.overrideIdentifier?a?.freeze().getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,memory:N!==void 0?{value:o.getValue(t),override:s.overrideIdentifier?o.getOverrideValue(t,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:M.length?M:void 0}}keys(t){const s=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,s){this._folderConfigurations.set(t,s),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,s){const r=s.filter(i=>I.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const a=(0,I.overrideIdentifierFromKey)(i),o=this._defaultConfiguration.getKeysForOverrideIdentifier(a),u=t.getKeysForOverrideIdentifier(a),h=[...u.filter(m=>o.indexOf(m)===-1),...o.filter(m=>u.indexOf(m)===-1),...o.filter(m=>!C.equals(this._defaultConfiguration.override(a).getValue(m),t.override(a).getValue(m)))];return[a,h]});return this.updateDefaultConfiguration(t),{keys:s,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:s,updated:r,removed:i,overrides:a}=(0,n.compare)(this.localUserConfiguration,t),o=[...s,...r,...i];return o.length&&this.updateLocalUserConfiguration(t),{keys:o,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:s,updated:r,removed:i,overrides:a}=(0,n.compare)(this.remoteUserConfiguration,t);let o=[...s,...r,...i];return o.length&&this.updateRemoteUserConfiguration(t),{keys:o,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:s,updated:r,removed:i,overrides:a}=(0,n.compare)(this.workspaceConfiguration,t);let o=[...s,...r,...i];return o.length&&this.updateWorkspaceConfiguration(t),{keys:o,overrides:a}}compareAndUpdateFolderConfiguration(t,s){const r=this.folderConfigurations.get(t),{added:i,updated:a,removed:o,overrides:u}=(0,n.compare)(r,s);let h=[...i,...a,...o];return(h.length||!r)&&this.updateFolderConfiguration(t,s),{keys:h,overrides:u}}compareAndDeleteFolderConfiguration(t){const s=this.folderConfigurations.get(t);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:i,removed:a,overrides:o}=(0,n.compare)(s,void 0);return{keys:[...r,...i,...a],overrides:o}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,s){let r=this.getConsolidatedConfigurationModelForResource(t,s);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},s){let r=this.getWorkspaceConsolidatedConfiguration();if(s&&t){const i=s.getFolder(t);i&&(r=this.getFolderConsolidatedConfiguration(i.uri)||r);const a=this._memoryConfigurationByResource.get(t);a&&(r=r.merge(a))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let s=this._foldersConsolidatedConfigurations.get(t);if(!s){const r=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(s=r.merge(i),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(t,s)):s=r}return s}getFolderConfigurationModelForResource(t,s){if(s&&t){const r=s.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,s)=>{const{contents:r,overrides:i,keys:a}=this._folderConfigurations.get(s);return t.push([s,{contents:r,overrides:i,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>t.add(s)),this.userConfiguration.freeze().keys.forEach(s=>t.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>s.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(i=>s.add(i))),[...s.values()]}static parse(t){const s=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((o,u)=>(o.set(E.URI.revive(u[0]),this.parseConfigurationModel(u[1])),o),new k.ResourceMap);return new b(s,r,new w,i,a,new w,new k.ResourceMap,!1)}static parseConfigurationModel(t){return new w(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function y(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const t=new Set,s=new Map;for(const i of c)i.keys.forEach(a=>t.add(a)),i.overrides.forEach(([a,o])=>{const u=(0,k.getOrSet)(s,a,new Set);o.forEach(h=>u.add(h))});const r=[];return s.forEach((i,a)=>r.push([a,[...i.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=y;class v{constructor(t,s,r,i){this.change=t,this.previous=s,this.currentConfiguraiton=r,this.currentWorkspace=i,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(u=>a.add(u)),t.overrides.forEach(([,u])=>u.forEach(h=>a.add(h))),this.affectedKeys=[...a.values()];const o=new w;this.affectedKeys.forEach(u=>o.setValue(u,{})),this.affectedKeysTree=o.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(s){const r=this.previousConfiguration?this.previousConfiguration.getValue(t,s,this.previous?.workspace):void 0,i=this.currentConfiguraiton.getValue(t,s,this.currentWorkspace);return!C.equals(r,i)}return!0}return!1}doesAffectedKeysTreeContains(t,s){let r=(0,n.toValuesTree)({[s]:!0},()=>{}),i;for(;typeof r=="object"&&(i=Object.keys(r)[0]);){if(t=t[i],!t)return!1;r=r[i]}return!0}}e.ConfigurationChangeEvent=v;class l extends v{constructor(t,s,r,i){super({keys:t.allKeys(),overrides:[]},void 0,t,s);this.source=r,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=l}),define(te[179],ne([0,1,6,3,2,16,20,88,39,34]),function(J,e,D,L,R,T,k,C,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends R.Disposable{constructor(g,w){super();this.settingsResource=g,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new C.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,w)),this.configuration=new C.Configuration(new C.DefaultConfigurationModel,new C.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(E.Registry.as(S.Extensions.Configuration).onDidUpdateConfiguration(f=>this.onDidDefaultConfigurationChange(f))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const g=await this.userConfiguration.loadConfiguration();this.configuration=new C.Configuration(new C.DefaultConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(g,w){const f=typeof g=="string"?g:void 0,p=(0,k.isConfigurationOverrides)(g)?g:(0,k.isConfigurationOverrides)(w)?w:{};return this.configuration.getValue(f,p,void 0)}updateValue(g,w,f,p){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const w=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(f,w,1)}onDidDefaultConfigurationChange(g){const w=this.configuration.toData(),f=this.configuration.compareAndUpdateDefaultConfiguration(new C.DefaultConfigurationModel,g);this.trigger(f,w,6)}trigger(g,w,f){const p=new C.ConfigurationChangeEvent(g,{data:w},this.configuration);p.source=f,p.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(p)}getTargetConfiguration(g){switch(g){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(te[180],ne([0,1,5]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,D.createDecorator)("remoteAuthorityResolverService");var L;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends Error{constructor(k,C=L.Unknown,S){super(k);this._message=k,this._code=C,this._detail=S,this.isHandled=C===L.NotAvailable&&S===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(k){return k instanceof R&&k._code===L.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof R&&k._code===L.NoResolverFound}static isHandled(k){return k instanceof R&&k.isHandled}}e.RemoteAuthorityResolverError=R}),define(te[181],ne([0,1,6,22,27,9,3,2,30,72,180]),function(J,e,D,L,R,T,k,C,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const I=30*1e3;var g;(function(j){j[j.Management=1]="Management",j[j.ExtensionHost=2]="ExtensionHost",j[j.Tunnel=3]="Tunnel"})(g=e.ConnectionType||(e.ConnectionType={}));function w(j){switch(j){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function f(j){const z=new R.CancellationTokenSource;return setTimeout(()=>z.cancel(),j),z.token}function p(j,z){if(j.isCancellationRequested||z.isCancellationRequested)return R.CancellationToken.Cancelled;const B=new R.CancellationTokenSource;return j.onCancellationRequested(()=>B.cancel()),z.onCancellationRequested(()=>B.cancel()),B.token}class d{constructor(z){this._state="pending",this._disposables=new C.DisposableStore,this.promise=new Promise((B,X)=>{this._resolvePromise=B,this._rejectPromise=X}),z.isCancellationRequested?this._timeout():this._disposables.add(z.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(z){this._state==="pending"?this._disposables.add(z):z.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const z=new Error("Time limit reached");return z.code="ETIMEDOUT",z.syscall="connect",z}resolve(z){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(z))}reject(z){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(z))}}function b(j,z){const B=new d(z);return B.registerDisposable(j.onControlMessage(X=>{const Z=JSON.parse(X.toString()),V=W(Z);V?B.reject(V):B.resolve(Z)})),B.promise}function y(j,z,B,X,Z,V){const G=new d(V);return z.connect(B,X,Z,(ie,re)=>{G.didTimeout?(ie&&j.error(ie),re?.dispose()):ie||!re?G.reject(ie):G.resolve(re)}),G.promise}function v(j,z){const B=new d(z);return j.then(X=>{B.didTimeout||B.resolve(X)},X=>{B.didTimeout||B.reject(X)}),B.promise}async function l(j,z,B,X){const Z=F(j,z);j.logService.trace(`${Z} 1/6. invoking socketFactory.connect().`);let V;try{V=await y(j.logService,j.socketFactory,j.host,j.port,`reconnectionToken=${j.reconnectionToken}&reconnection=${j.reconnectionProtocol?"true":"false"}`,X)}catch(ae){throw j.logService.error(`${Z} socketFactory.connect() failed or timed out. Error:`),j.logService.error(ae),ae}j.logService.trace(`${Z} 2/6. socketFactory.connect() was successful.`);let G,ie;j.reconnectionProtocol?(j.reconnectionProtocol.beginAcceptReconnection(V,null),G=j.reconnectionProtocol,ie=!1):(G=new E.PersistentProtocol(V,null),ie=!0),j.logService.trace(`${Z} 3/6. sending AuthRequest control message.`);const re={type:"auth",auth:j.connectionToken||"00000000000000000000"};G.sendControl(L.VSBuffer.fromString(JSON.stringify(re)));try{const ae=await b(G,p(X,f(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const de=new Error("Unexpected handshake message");throw de.code="VSCODE_CONNECTION_ERROR",de}j.logService.trace(`${Z} 4/6. received SignRequest control message.`);const ue=await v(j.signService.sign(ae.data),X),fe={type:"connectionType",commit:j.commit,signedData:ue,desiredConnectionType:z};return B&&(fe.args=B),j.logService.trace(`${Z} 5/6. sending ConnectionTypeRequest control message.`),G.sendControl(L.VSBuffer.fromString(JSON.stringify(fe))),{protocol:G,ownsProtocol:ie}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(j.logService.error(`${Z} the handshake timed out. Error:`),j.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(j.logService.error(`${Z} received error control message when negotiating connection. Error:`),j.logService.error(ae)),ie&&H(G),ae}}async function c(j,z,B,X){const Z=Date.now(),V=F(j,z),{protocol:G,ownsProtocol:ie}=await l(j,z,B,X),re=new d(X);return re.registerDisposable(G.onControlMessage(ae=>{const ue=JSON.parse(ae.toString()),fe=W(ue);fe?(j.logService.error(`${V} received error control message when negotiating connection. Error:`),j.logService.error(fe),ie&&H(G),re.reject(fe)):(j.reconnectionProtocol&&j.reconnectionProtocol.endAcceptReconnection(),j.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${K(Z)}!`),re.resolve({protocol:G,firstMessage:ue}))})),re.promise}async function t(j,z){const{protocol:B}=await c(j,1,void 0,z);return{protocol:B}}async function s(j,z,B){const{protocol:X,firstMessage:Z}=await c(j,2,z,B),V=Z&&Z.debugPort;return{protocol:X,debugPort:V}}async function r(j,z,B){const X=Date.now(),Z=F(j,3),{protocol:V}=await l(j,3,z,B);return j.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${K(X)}!`),V}async function i(j,z,B){const{host:X,port:Z,connectionToken:V}=await j.addressProvider.getAddress();return{commit:j.commit,host:X,port:Z,connectionToken:V,reconnectionToken:z,reconnectionProtocol:B,socketFactory:j.socketFactory,signService:j.signService,logService:j.logService}}async function a(j,z,B){try{const X=(0,S.generateUuid)(),Z=await i(j,X,null),{protocol:V}=await t(Z,R.CancellationToken.None);return new $(j,z,B,X,V)}catch(X){throw j.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),j.logService.error(X),M.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(X)),X}}e.connectRemoteAgentManagement=a;async function o(j,z){try{const B=(0,S.generateUuid)(),X=await i(j,B,null),{protocol:Z,debugPort:V}=await s(X,z,R.CancellationToken.None);return new U(j,z,B,Z,V)}catch(B){throw j.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),j.logService.error(B),M.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(B)),B}}e.connectRemoteAgentExtensionHost=o;async function u(j,z,B){const X=await i(j,(0,S.generateUuid)(),null);return await r(X,{host:z,port:B},R.CancellationToken.None)}e.connectRemoteAgentTunnel=u;function h(j){return(0,D.createCancelablePromise)(z=>new Promise((B,X)=>{const Z=setTimeout(B,j*1e3);z.onCancellationRequested(()=>{clearTimeout(Z),B()})}))}var m;(function(j){j[j.ConnectionLost=0]="ConnectionLost",j[j.ReconnectionWait=1]="ReconnectionWait",j[j.ReconnectionRunning=2]="ReconnectionRunning",j[j.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",j[j.ConnectionGain=4]="ConnectionGain"})(m=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class A{constructor(z,B){this.reconnectionToken=z,this.millisSinceLastIncomingData=B,this.type=0}}e.ConnectionLostEvent=A;class _{constructor(z,B,X,Z){this.reconnectionToken=z,this.millisSinceLastIncomingData=B,this.durationSeconds=X,this.cancellableTimer=Z,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=_;class O{constructor(z,B,X){this.reconnectionToken=z,this.millisSinceLastIncomingData=B,this.attempt=X,this.type=2}}e.ReconnectionRunningEvent=O;class N{constructor(z,B,X){this.reconnectionToken=z,this.millisSinceLastIncomingData=B,this.attempt=X,this.type=4}}e.ConnectionGainEvent=N;class P{constructor(z,B,X,Z){this.reconnectionToken=z,this.millisSinceLastIncomingData=B,this.attempt=X,this.handled=Z,this.type=3}}e.ReconnectionPermanentFailureEvent=P;class M extends C.Disposable{constructor(z,B,X,Z){super();this._connectionType=z,this._onDidStateChange=this._register(new k.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=B,this.reconnectionToken=X,this.protocol=Z,this._isReconnecting=!1,this._onDidStateChange.fire(new N(this.reconnectionToken,0,0)),this._register(Z.onSocketClose(V=>{const G=x(this._connectionType,this.reconnectionToken,!0);V?V.type===0?(this._options.logService.info(`${G} received socket close event (hadError: ${V.hadError}).`),V.error&&this._options.logService.error(V.error)):(this._options.logService.info(`${G} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this._options.logService.error(V.event)):this._options.logService.info(`${G} received socket close event.`),this._beginReconnecting()})),this._register(Z.onSocketTimeout(()=>{const V=x(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${V} received socket timeout event.`),this._beginReconnecting()})),M._instances.push(this),M._permanentFailure&&this._gotoPermanentFailure(M._permanentFailureMillisSinceLastIncomingData,M._permanentFailureAttempt,M._permanentFailureHandled)}static triggerPermanentFailure(z,B,X){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=z,this._permanentFailureAttempt=B,this._permanentFailureHandled=X,this._instances.forEach(Z=>Z._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(M._permanentFailure)return;const z=x(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${z} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const B=[0,5,5,10,10,10,10,10,30];let X=-1;do{X++;const Z=X<B.length?B[X]:B[B.length-1];try{if(Z>0){const G=h(Z);this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Z,G)),this._options.logService.info(`${z} waiting for ${Z} seconds before reconnecting...`);try{await G}catch{}}if(M._permanentFailure){this._options.logService.error(`${z} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X+1)),this._options.logService.info(`${z} resolving connection...`);const V=await i(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${z} connecting to ${V.host}:${V.port}...`),await this._reconnect(V,f(I)),this._options.logService.info(`${z} reconnected!`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),X+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(V),M.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),X+1,!1);break}if(X>360){this._options.logService.error(`${z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(V),M.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),X+1,!1);break}if(n.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this._options.logService.info(`${z} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this._options.logService.info(`${z} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((0,T.isPromiseCanceledError)(V)){this._options.logService.info(`${z} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if(V instanceof n.RemoteAuthorityResolverError){this._options.logService.error(`${z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(V),M.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),X+1,n.RemoteAuthorityResolverError.isHandled(V));break}this._options.logService.error(`${z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(V),M.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),X+1,!1);break}}while(!M._permanentFailure)}_gotoPermanentFailure(z,B,X){this._onDidStateChange.fire(new P(this.reconnectionToken,z,B,X)),H(this.protocol)}}M._permanentFailure=!1,M._permanentFailureMillisSinceLastIncomingData=0,M._permanentFailureAttempt=0,M._permanentFailureHandled=!1,M._instances=[];class $ extends M{constructor(z,B,X,Z,V){super(1,z,Z,V);this.client=this._register(new E.Client(V,{remoteAuthority:B,clientId:X},z.ipcLogger))}async _reconnect(z,B){await t(z,B)}}e.ManagementPersistentConnection=$;class U extends M{constructor(z,B,X,Z,V){super(2,z,X,Z);this._startArguments=B,this.debugPort=V}async _reconnect(z,B){await s(z,this._startArguments,B)}}e.ExtensionHostPersistentConnection=U;function H(j){try{j.acceptDisconnect();const z=j.getSocket();j.dispose(),z.dispose()}catch(z){(0,T.onUnexpectedError)(z)}}function W(j){if(j&&j.type==="error"){const z=new Error(`Connection error: ${j.reason}`);return z.code="VSCODE_CONNECTION_ERROR",z}return null}function q(j,z){for(;j.length<z;)j+=" ";return j}function x(j,z,B){return`[remote-connection][${q(w(j),13)}][${z.substr(0,5)}\u2026][${B?"reconnect":"initial"}]`}function F(j,z){return`${x(z,j.reconnectionToken,!!j.reconnectionProtocol)}[${j.host}:${j.port}]`}function K(j){return`${Date.now()-j} ms`}}),define(te[182],ne([0,1,15]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(E){return E.scheme===D.Schemas.vscodeRemote?E.authority:void 0}e.getRemoteAuthority=L;function R(E){if(!E)return;const n=E.indexOf("+");return n<0?E:E.substr(0,n)}e.getRemoteName=R;function T(E){return E.scheme!==D.Schemas.file&&E.scheme!==D.Schemas.vscodeRemote}e.isVirtualResource=T;function k(E){if(E.folders.length)return E.folders.every(n=>T(n.uri))?E.folders[0].uri:void 0;if(E.configuration&&T(E.configuration))return E.configuration}e.getVirtualWorkspaceLocation=k;function C(E){return k(E)?.scheme}e.getVirtualWorkspaceScheme=C;function S(E){return k(E)!==void 0}e.isVirtualWorkspace=S}),define(te[89],ne([0,1,25,5,182]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}e.getWorkspaceSupportTypeMessage=T;function k(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(C=e.ExtensionType||(e.ExtensionType={}));class S{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,f){if(typeof w=="undefined"||w===null)return typeof f=="undefined"||f===null;if(typeof f=="undefined"||f===null)return!1;if(typeof w=="string"||typeof f=="string"){let p=typeof w=="string"?w:w.value,d=typeof f=="string"?f:f.value;return D.equalsIgnoreCase(p,d)}return w._lower===f._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.ExtensionIdentifier=S;function E(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function n(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=n;function I(g,w){if(w&&g.enableProposedApi){const f=`onResolveRemoteAuthority:${(0,R.getRemoteName)(w)}`;return g.activationEvents?.indexOf(f)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[35],ne([0,1,25,89]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function R(f,p){return f.uuid&&p.uuid?f.uuid===p.uuid:f.id===p.id?!0:(0,D.compareIgnoreCase)(f.id,p.id)===0}e.areSameExtensions=R;class T{constructor(p,d){this.version=d,this.id=p.id,this.uuid=p.uuid}key(){return`${this.id}-${this.version}`}equals(p){return p instanceof T?R(this,p)&&this.version===p.version:!1}}e.ExtensionIdentifierWithVersion=T;function k(f,p){return`${f}.${p}`}e.getExtensionId=k;function C(f){return f.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function S(f,p){return C(k(f,p))}e.getGalleryExtensionId=S;function E(f,p){const d=[],b=y=>{for(const v of d)if(v.some(l=>R(p(l),p(y))))return v;return null};for(const y of f){const v=b(y);v?v.push(y):d.push([y])}return d}e.groupByExtension=E;function n(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function I(f){return{id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0),...f.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function g(f){const p=new Set;for(const d of f)d.malicious&&p.add(d.id.id);return p}e.getMaliciousExtensionsSet=g;function w(f,p){const d=[],b=p.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const y=b.shift();if(y&&d.every(v=>!R(v.identifier,{id:y}))){const v=f.filter(l=>R(l.identifier,{id:y}));v.length===1&&(d.push(v[0]),b.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}e.getExtensionDependencies=w}),define(te[183],ne([0,1,6,9,2,4,16,60,7,30,19,13,28,35,14,10]),function(J,e,D,L,R,T,k,C,S,E,n,I,g,w,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const d=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let b=class extends R.Disposable{constructor(v,l,c,t){super();this.fileService=l,this.extensionGalleryService=c,this.logService=t,this.extensionsDownloadDir=S.URI.file(v.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(v,l){await this.cleanUpPromise;const c=this.getName(v),t=(0,k.joinPath)(this.extensionsDownloadDir,c);if(!await this.fileService.exists(t)){const s=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,E.generateUuid)()}`);await this.fileService.exists(s)||await this.extensionGalleryService.download(v,s,l);try{await this.rename(s,t,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(s)}catch(i){}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",v.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,s.path),r}}return t}async delete(v){await this.cleanUpPromise,await this.fileService.del(v)}async rename(v,l,c){try{await n.Promises.rename(v.fsPath,l.fsPath)}catch(t){if(T.isWindows&&t&&t.code==="EPERM"&&Date.now()<c)return this.logService.info(`Failed renaming ${v} to ${l} with 'EPERM' error. Trying again...`),this.rename(v,l,c);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const v=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(v.children){const l=[],c=[];for(const r of v.children){const i=this.parse(r.name);i&&c.push([i,r])}const t=(0,w.groupByExtension)(c,([r])=>r),s=[];for(const r of t)r.sort((i,a)=>C.rcompare(i[0].version,a[0].version)),l.push(...r.slice(1).map(i=>i[1].resource)),s.push(r[0][1]);s.sort((r,i)=>r.mtime-i.mtime),l.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(r=>r.resource)),await D.Promises.settled(l.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(v){this.logService.error(v)}}getName(v){return this.cache?`${new w.ExtensionIdentifierWithVersion(v.identifier,v.version).key().toLowerCase()}${v.properties.targetPlatform!=="undefined"?`-${v.properties.targetPlatform}`:""}`:(0,E.generateUuid)()}parse(v){const l=d.exec(v);return l&&l[1]&&l[2]?new w.ExtensionIdentifierWithVersion({id:l[1]},l[2]):null}};b=he([Q(0,I.INativeEnvironmentService),Q(1,f.IFileService),Q(2,g.IExtensionGalleryService),Q(3,p.ILogService)],b),e.ExtensionsDownloader=b}),define(te[184],ne([0,1,2,8,19,89]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends D.Disposable{constructor(S,E){super();this.environmentService=S,this.extensionsManifestCache=(0,L.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(E.onDidInstallExtensions(n=>this.onDidInstallExtensions(n))),this._register(E.onDidUninstallExtension(n=>this.onDidUnInstallExtension(n)))}onDidInstallExtensions(S){S.some(E=>!!E.local)&&this.invalidate()}onDidUnInstallExtension(S){S.error||this.invalidate()}invalidate(){R.Promises.rm(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(te[185],ne([0,1,3,2,16,7,13,35,14,10]),function(J,e,D,L,R,T,k,C,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let n=class extends L.Disposable{constructor(g,w,f,p){super();this.extensionsManagementService=g,this.logService=p,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(y=>{this.installedExtensions=y.map(v=>v.identifier),this.startTimestamp=Date.now()}),this._register(g.onInstallExtension(y=>this.onInstallExtension(y))),this._register(g.onDidInstallExtensions(y=>this.onDidInstallExtensions(y))),this._register(g.onDidUninstallExtension(y=>this.onDidUninstallExtension(y)));const d=T.URI.file(f.extensionsPath),b=new R.ExtUri(y=>!w.hasCapability(y,1024));this._register(w.watch(d)),this._register(D.Event.filter(w.onDidChangeFilesRaw,y=>y.changes.some(v=>this.doesChangeAffects(v,d,b)))(()=>this.onDidChange()))}doesChangeAffects(g,w,f){return f.isEqual(f.dirname(g.resource),w)?f.isEqual(g.resource,f.joinPath(w,".obsolete"))?!0:!(g.type!==1&&g.type!==2||f.basename(g.resource).startsWith(".")):!1}onInstallExtension(g){this.addInstallingExtension(g.identifier)}onDidInstallExtensions(g){for(const w of g)this.removeInstallingExtension(w.identifier),w.local&&this.addInstalledExtension(w.identifier)}onDidUninstallExtension(g){g.error||this.removeInstalledExtension(g.identifier)}addInstallingExtension(g){this.removeInstallingExtension(g),this.installingExtensions.push(g)}removeInstallingExtension(g){this.installingExtensions=this.installingExtensions.filter(w=>!(0,C.areSameExtensions)(w,g))}addInstalledExtension(g){this.installedExtensions&&(this.removeInstalledExtension(g),this.installedExtensions.push(g))}removeInstalledExtension(g){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(w=>!(0,C.areSameExtensions)(w,g)))}async onDidChange(){if(this.installedExtensions){const g=await this.extensionsManagementService.getInstalled(1),w=g.filter(p=>[...this.installingExtensions,...this.installedExtensions].some(d=>(0,C.areSameExtensions)(d,p.identifier))?!1:p.installedTimestamp&&p.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",p.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",p.identifier.id),!1)),f=this.installedExtensions.filter(p=>this.installingExtensions.some(d=>(0,C.areSameExtensions)(d,p))?!1:g.every(d=>!(0,C.areSameExtensions)(d.identifier,p))?(this.logService.info("Detected extension removed from another source",p.id),!0):!1);this.installedExtensions=g.map(p=>p.identifier),(w.length||f.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:w,removed:f})}}};n=he([Q(1,S.IFileService),Q(2,k.INativeEnvironmentService),Q(3,E.ILogService)],n),e.ExtensionsWatcher=n}),define(te[186],ne([0,1,82,17,6,2,15,8,19,13,28,35,58,10]),function(J,e,D,L,R,T,k,C,S,E,n,I,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let f=class extends T.Disposable{constructor(b,y,v){super();this.extensionManagementService=b,this.logService=v,this.cache=this._register(new p(y,v)),this.extensionManagementService.registerParticipant({postInstall:async l=>this.postInstallExtension(l),postUninstall:async l=>this.postUninstallExtension(l)})}async getLanguageIds(){const b=await this.cache.getLanguagePacks(),y=["en",...Object.keys(b)];return(0,L.distinct)(y)}async postInstallExtension(b){b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",b.identifier.id),await this.update())}async postUninstallExtension(b){const y=await this.cache.getLanguagePacks();Object.keys(y).some(v=>y[v]&&y[v].extensions.some(l=>(0,I.areSameExtensions)(l.extensionIdentifier,b.identifier)))&&(this.logService.info("Removing language packs from the extension",b.identifier.id),await this.update())}async update(){const[b,y]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),v=await this.cache.update(y);return!(0,L.equals)(Object.keys(b),Object.keys(v))}};f=he([Q(0,n.IExtensionManagementService),Q(1,E.INativeEnvironmentService),Q(2,w.ILogService)],f),e.LocalizationsService=f;let p=class extends T.Disposable{constructor(b,y){super();this.logService=y,this.languagePacks={},this.languagePacksFilePath=(0,C.join)(b.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new R.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(b){return this.withLanguagePacks(y=>{Object.keys(y).forEach(v=>delete y[v]),this.createLanguagePacksFromExtensions(y,...b)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(b,...y){for(const v of y)v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(b,v);Object.keys(b).forEach(v=>this.updateHash(b[v]))}createLanguagePacksFromExtension(b,y){const v=y.identifier,l=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const c of l)if(y.location.scheme===k.Schemas.file&&(0,g.isValidLocalization)(c)){let t=b[c.languageId];t||(t={hash:"",extensions:[],translations:{}},b[c.languageId]=t);let s=t.extensions.filter(r=>(0,I.areSameExtensions)(r.extensionIdentifier,v))[0];s?s.version=y.manifest.version:t.extensions.push({extensionIdentifier:v,version:y.manifest.version});for(const r of c.translations)t.translations[r.id]=(0,C.join)(y.location.fsPath,r.path)}}updateHash(b){if(b){const y=(0,D.createHash)("md5");for(const v of b.extensions)y.update(v.extensionIdentifier.uuid||v.extensionIdentifier.id).update(v.version);b.hash=y.digest("hex")}}withLanguagePacks(b=()=>null){return this.languagePacksFileLimiter.queue(()=>{let y=null;return S.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,v=>v.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(v)).then(v=>{try{return JSON.parse(v)}catch(l){return{}}}).then(v=>(y=b(v),v)).then(v=>{for(const c of Object.keys(v))v[c]||delete v[c];this.languagePacks=v,this.initializedCache=!0;const l=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",l),S.Promises.writeFile(this.languagePacksFilePath,l)}).then(()=>y,v=>this.logService.error(v))})}};p=he([Q(0,E.INativeEnvironmentService),Q(1,w.ILogService)],p)}),define(te[187],ne([0,1,5]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(te[61],ne([0,1,3,4,5,10]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,R.createDecorator)("tunnelService");var k;(function(f){f.Http="http",f.Https="https"})(k=e.TunnelProtocol||(e.TunnelProtocol={}));var C;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(C=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var S;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(S=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function E(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const p=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!p)return{address:p[1],port:+p[2]}}e.extractLocalHostUriMetaDataForPortMapping=E,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function n(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=n,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=I;function g(f,p){return p?p!==1&&f<1024:!L.isWindows&&f<1024}e.isPortPrivileged=g;let w=class{constructor(p){this.logService=p,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(p,d){return this._tunnelProvider=p,p?(this._canElevate=d.elevation,this._privacyOptions=d.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return new Promise(async p=>{const d=[],b=Array.from(this._tunnels.values());for(let y of b){const v=Array.from(y.values());for(let l of v){const c=await l.value;c&&d.push(c)}}p(d)})}async dispose(){for(const p of this._tunnels.values()){for(const{value:d}of p.values())await d.then(b=>b?.dispose());p.clear()}this._tunnels.clear()}openTunnel(p,d,b,y,v=!1,l=C.Private,c){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${b} on local port ${y}.`),!p)return;d||(d="localhost");const t=this.retainOrCreateTunnel(p,d,b,y,v,l,c);return t?t.then(s=>{if(!s){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,b);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(s);return(s.tunnelRemoteHost!==d||s.tunnelRemotePort!==b)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}makeTunnel(p){return{tunnelRemotePort:p.tunnelRemotePort,tunnelRemoteHost:p.tunnelRemoteHost,tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress,privacy:p.privacy,protocol:p.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${p.tunnelRemoteHost}:${p.tunnelRemotePort} `);const d=this._tunnels.get(p.tunnelRemoteHost);if(d){const b=d.get(p.tunnelRemotePort);b&&(b.refcount--,await this.tryDisposeTunnel(p.tunnelRemoteHost,p.tunnelRemotePort,b))}}}}async tryDisposeTunnel(p,d,b){if(b.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${p}:${d}.`);const y=b.value.then(async v=>{v&&(await v.dispose(!0),this._onTunnelClosed.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this._tunnels.has(p)&&this._tunnels.get(p).delete(d),y}}async closeTunnel(p,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${p}:${d} `);const b=this._tunnels.get(p);if(b&&b.has(d)){const y=b.get(d);y.refcount=0,await this.tryDisposeTunnel(p,d,y)}}addTunnelToMap(p,d,b){this._tunnels.has(p)||this._tunnels.set(p,new Map),this._tunnels.get(p).set(d,{refcount:1,value:b})}async removeEmptyTunnelFromMap(p,d){const b=this._tunnels.get(p);b&&(await b.get(d)||b.delete(d),b.size===0&&this._tunnels.delete(p))}getTunnelFromMap(p,d){let b=[p];n(p)?(b.push(...e.LOCALHOST_ADDRESSES),b.push(...e.ALL_INTERFACES_ADDRESSES)):I(p)&&b.push(...e.ALL_INTERFACES_ADDRESSES);const y=b.map(v=>this._tunnels.get(v));for(const v of y){const l=v?.get(d);if(l)return l}}canTunnel(p){return!!E(p)}createWithProvider(p,d,b,y,v,l,c){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${b} on local port ${y}.`);const s={elevationRequired:v?g(y===void 0?b:y):!1},r={remoteAddress:{host:d,port:b},localAddressPort:y,privacy:l,public:l!==C.Private,protocol:c},i=p.forwardPort(r,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(d,b,i),i}};w=he([Q(0,T.ILogService)],w),e.AbstractTunnelService=w}),define(te[188],ne([0,1,10,61,2,9,6]),function(J,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class C extends R.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new k.DeferredPromise),this._addressPromise.p)}setAddress(n){this._address=n,this._addressPromise&&(this._addressPromise.complete(n),this._addressPromise=null)}setTunnel(n){this._register(n)}}let S=class pt extends R.Disposable{constructor(n,I){super();this._tunnelService=n,this._logService=I,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(n=>n.dispose())}async createTunnel(){return{id:String(++pt._lastId)}}async startTunnel(n,I,g,w,f){const p=new C,d=await Promise.resolve(this._tunnelService.openTunnel(p,I,g,w,f));if(!d)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${I}:${g} (remote).`),p.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(n))throw this._disposedTunnels.delete(n),p.dispose(),await d.dispose(),(0,T.canceled)();return p.setTunnel(d),this._tunnels.set(n,p),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${n}: ${d.localAddress} (local) to ${I}:${g} (remote).`),{tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress}}async setAddress(n,I){const g=this._tunnels.get(n);!g||g.setAddress(I)}async destroyTunnel(n){const I=this._tunnels.get(n);if(I){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${n}.`),this._tunnels.delete(n),await I.dispose();return}this._disposedTunnels.add(n)}};S._lastId=0,S=he([Q(0,L.ITunnelService),Q(1,D.ILogService)],S),e.SharedProcessTunnelService=S}),define(te[189],ne([0,1,117,20,10]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(C,S){this.configurationService=C,this.logService=S}request(C,S){return this.logService.trace("RequestService#request",C.url),C.proxyAuthorization||(C.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,D.request)(C,S)}async resolveProxy(C){}};T=he([Q(0,L.IConfigurationService),Q(1,R.ILogService)],T),e.RequestService=T}),define(te[43],ne([0,1,22,138,39,5,34]),function(J,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function C(f){return f.res.statusCode&&f.res.statusCode>=200&&f.res.statusCode<300||f.res.statusCode===1223}e.isSuccess=C;function S(f){return f.res.statusCode===204}async function E(f){if(!C(f))throw new Error("Server returned "+f.res.statusCode);return S(f)?null:(await(0,D.streamToBuffer)(f.stream)).toString()}e.asText=E;async function n(f){if(!C(f))throw new Error("Server returned "+f.res.statusCode);if(S(f))return null;const d=(await(0,D.streamToBuffer)(f.stream)).toString();try{return JSON.parse(d)}catch(b){throw b.message+=`:
`+d,b}}e.asJson=n;function I(f){w(f)}e.updateProxyConfigurationsScope=I;let g;function w(f){const p=k.Registry.as(R.Extensions.Configuration),d=g;g={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:f,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},p.updateConfigurations({add:[g],remove:d?[d]:[]})}w(2)}),define(te[190],ne([0,1,27,15,14,43]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(S,E){this.requestService=S,this.fileService=E}async download(S,E,n=D.CancellationToken.None){if(S.scheme===L.Schemas.file||S.scheme===L.Schemas.vscodeRemote){await this.fileService.copy(S,E);return}const I={type:"GET",url:S.toString()},g=await this.requestService.request(I,n);if(g.res.statusCode===200)await this.fileService.writeFile(E,g.stream);else{const w=await(0,T.asText)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${w}`)}}};k=he([Q(0,T.IRequestService),Q(1,R.IFileService)],k),e.DownloadService=k}),define(te[191],ne([0,1,17,27,65,2,16,150,14,10,29,43]),function(J,e,D,L,R,T,k,C,S,E,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let g=class extends T.Disposable{constructor(f,p,d,b){super();this.fileService=f,this.productService=p,this.requestService=d,this.logService=b,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,R.forEach)(this.productService.configBasedExtensionTips,({value:y})=>this.allConfigBasedTips.set(y.configPath,y))}getConfigBasedTips(f){return this.getValidConfigBasedTips(f)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(f){const p=[];for(const[d,b]of this.allConfigBasedTips)if(!(b.configScheme&&b.configScheme!==f.scheme))try{const y=await this.fileService.readFile((0,k.joinPath)(f,d)),v=new Map;(0,R.forEach)(b.recommendations,({key:c,value:t})=>{if((0,D.isNonEmptyArray)(t.remotes))for(const s of t.remotes)v.set(s,{extensionId:c,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else p.push({extensionId:c,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const l=(0,C.getDomainsOfRemotes)(y.value.toString(),[...v.keys()]);for(const c of l){const t=v.get(c);t&&p.push(t)}}catch(y){}return p}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const f=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},L.CancellationToken.None);if(f.res.statusCode!==200)return[];const p=await(0,I.asJson)(f);return p?p.workspaceRecommendations||[]:[]}catch(f){return this.logService.error(f),[]}}};g=he([Q(0,S.IFileService),Q(1,n.IProductService),Q(2,I.IRequestService),Q(3,E.ILogService)],g),e.ExtensionTipsService=g}),define(te[45],ne([0,1,22,30]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function R(T,k,C){let S=C&&C.get("storage.serviceMachineId",0)||null;if(S)return S;try{const n=(await k.readFile(T.serviceMachineIdResource)).value.toString();S=(0,L.isUUID)(n)?n:null}catch(E){S=null}if(!S){S=(0,L.generateUuid)();try{await k.writeFile(T.serviceMachineIdResource,D.VSBuffer.fromString(S))}catch(E){}}return C&&C.store("storage.serviceMachineId",S,0,1),S}e.getServiceMachineId=R}),define(te[90],ne([0,1,5]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[192],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{vsda(){return new Promise((R,T)=>J(["vsda"],R,T))}async sign(R){try{const T=await this.vsda(),k=new T.signer;if(k)return k.sign(R)}catch(T){}return R}}e.SignService=D}),define(te[23],ne([0,1,6,3,2,18,73,5]),function(J,e,D,L,R,T,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const S="__$__targetStorageMarker";e.IStorageService=(0,C.createDecorator)("storageService");var E;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(E=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(p){p[p.GLOBAL=0]="GLOBAL",p[p.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var I;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));class g extends R.Disposable{constructor(d={flushInterval:g.DEFAULT_FLUSH_INTERVAL}){super();this.options=d,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new R.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,R.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(d,b){b===S?(d===0?this._globalKeyTargets=void 0:d===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:d})):this._onDidChangeValue.fire({scope:d,key:b,target:this.getKeyTargets(d)[b]})}emitWillSaveState(d){this._onWillSaveState.fire({reason:d})}get(d,b,y){return this.getStorage(b)?.get(d,y)}getBoolean(d,b,y){return this.getStorage(b)?.getBoolean(d,y)}getNumber(d,b,y){return this.getStorage(b)?.getNumber(d,y)}store(d,b,y,v){if((0,T.isUndefinedOrNull)(b)){this.remove(d,y);return}this.withPausedEmitters(()=>{this.updateKeyTarget(d,y,v),this.getStorage(y)?.set(d,b)})}remove(d,b){this.withPausedEmitters(()=>{this.updateKeyTarget(d,b,void 0),this.getStorage(b)?.delete(d)})}withPausedEmitters(d){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{d()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(d,b){const y=[],v=this.getKeyTargets(d);for(const l of Object.keys(v))v[l]===b&&y.push(l);return y}updateKeyTarget(d,b,y){const v=this.getKeyTargets(b);typeof y=="number"?v[d]!==y&&(v[d]=y,this.getStorage(b)?.set(S,JSON.stringify(v))):typeof v[d]=="number"&&(delete v[d],this.getStorage(b)?.set(S,JSON.stringify(v)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(d){return d===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(d){const b=this.get(S,d);if(b)try{return JSON.parse(b)}catch(y){}return Object.create(null)}isNew(d){return this.getBoolean(e.IS_NEW_KEY,d)===!0}async flush(d=E.NONE){this._onWillSaveState.fire({reason:d}),await D.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const d=this.getStorage(0)?.items??new Map,b=this.getStorage(1)?.items??new Map;return f(d,b,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=g,g.DEFAULT_FLUSH_INTERVAL=60*1e3;class w extends g{constructor(){super();this.globalStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new k.Storage(new k.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(d=>this.emitDidChangeValue(1,d))),this._register(this.globalStorage.onDidChangeStorage(d=>this.emitDidChangeValue(0,d)))}getStorage(d){return d===0?this.globalStorage:this.workspaceStorage}getLogDetails(d){return d===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(d){}}e.InMemoryStorageService=w;async function f(p,d,b,y){const v=a=>{try{return JSON.parse(a)}catch(o){return a}},l=new Map,c=new Map;p.forEach((a,o)=>{l.set(o,a),c.set(o,v(a))});const t=new Map,s=new Map;d.forEach((a,o)=>{t.set(o,a),s.set(o,v(a))}),console.group(`Storage: Global (path: ${b})`);let r=[];l.forEach((a,o)=>{r.push({key:o,value:a})}),console.table(r),console.groupEnd(),console.log(c),console.group(`Storage: Workspace (path: ${y})`);let i=[];t.forEach((a,o)=>{i.push({key:o,value:a})}),console.table(i),console.groupEnd(),console.log(s)}e.logStorage=f}),define(te[193],ne([0,1,3,2,18,28,35,23]),function(J,e,D,L,R,T,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let S=class extends L.Disposable{constructor(I){super();this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new E(I)),this._register(this.storageManger.onDidChange(g=>this._onDidChangeEnablement.fire({extensions:g,source:"storage"})))}async enableExtension(I,g){return this._removeFromDisabledExtensions(I)?(this._onDidChangeEnablement.fire({extensions:[I],source:g}),!0):!1}async disableExtension(I,g){return this._addToDisabledExtensions(I)?(this._onDidChangeEnablement.fire({extensions:[I],source:g}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(I){let g=this.getDisabledExtensions();return g.every(w=>!(0,k.areSameExtensions)(w,I))?(g.push(I),this._setDisabledExtensions(g),!0):!1}_removeFromDisabledExtensions(I){let g=this.getDisabledExtensions();for(let w=0;w<g.length;w++){const f=g[w];if((0,k.areSameExtensions)(f,I))return g.splice(w,1),this._setDisabledExtensions(g),!0}return!1}_setDisabledExtensions(I){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,I)}_getExtensions(I){return this.storageManger.get(I,0)}_setExtensions(I,g){this.storageManger.set(I,g,0)}};S=he([Q(0,C.IStorageService)],S),e.GlobalExtensionEnablementService=S;class E extends L.Disposable{constructor(I){super();this.storageService=I,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(I.onDidChangeValue(g=>this.onDidStorageChange(g)))}get(I,g){let w;return g===0?((0,R.isUndefinedOrNull)(this.storage[I])&&(this.storage[I]=this._get(I,g)),w=this.storage[I]):w=this._get(I,g),JSON.parse(w)}set(I,g,w){let f=JSON.stringify(g.map(({id:d,uuid:b})=>({id:d,uuid:b})));this._get(I,w)!==f&&(w===0&&(g.length?this.storage[I]=f:delete this.storage[I]),this._set(I,g.length?f:void 0,w))}onDidStorageChange(I){if(I.scope===0&&!(0,R.isUndefinedOrNull)(this.storage[I.key])&&this._get(I.key,I.scope)!==this.storage[I.key]){const w=this.get(I.key,I.scope);delete this.storage[I.key];const f=this.get(I.key,I.scope),p=w.filter(b=>!f.some(y=>(0,k.areSameExtensions)(b,y))),d=f.filter(b=>!w.some(y=>(0,k.areSameExtensions)(y,b)));(p.length||d.length)&&this._onDidChange.fire([...p,...d])}}_get(I,g){return this.storageService.get(I,g,"[]")}_set(I,g,w){g?this.storageService.store(I,g,w,1):this.storageService.remove(I,w)}}e.StorageManager=E}),define(te[194],ne([0,1,3,2]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class R extends L.Disposable{constructor(E,n){super();this.channel=E,this.workspace=n}async getItems(){const E={workspace:this.workspace},n=await this.channel.call("getItems",E);return new Map(n)}updateItems(E){const n={workspace:this.workspace};return E.insert&&(n.insert=Array.from(E.insert.entries())),E.delete&&(n.delete=Array.from(E.delete.values())),this.channel.call("updateItems",n)}}class T extends R{constructor(E){super(E,void 0);this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(E=>this.onDidChangeGlobalStorage(E)))}onDidChangeGlobalStorage(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this._onDidChangeItemsExternal.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}async close(){this.dispose()}}class k extends R{constructor(E,n){super(E,n);this.onDidChangeItemsExternal=D.Event.None}async close(){const E={workspace:this.workspace};return this.channel.call("close",E)}}class C extends L.Disposable{constructor(E,n){super();this.channel=E,this.workspace=n,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new T(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new k(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=C}),define(te[195],ne([0,1,6,2,175,16,73,23,194]),function(J,e,D,L,R,T,k,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class E extends C.AbstractStorageService{constructor(I,g,w){super();this.mainProcessService=g,this.environmentService=w,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new L.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(I)}createGlobalStorage(){const I=new S.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),g=new k.Storage(I.globalStorage);return this._register(g.onDidChangeStorage(w=>this.emitDidChangeValue(0,w))),g}createWorkspaceStorage(I){const g=new S.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),I);if(g.workspaceStorage){const w=new k.Storage(g.workspaceStorage);return this.workspaceStorageDisposable.value=w.onDidChangeStorage(f=>this.emitDidChangeValue(1,f)),this.workspaceStorageId=I?.id,w}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){(0,R.mark)("code/willInitStorage");try{await D.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}finally{(0,R.mark)("code/didInitStorage")}}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,T.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(C.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(I){const g=this.workspaceStorage,w=g?.items??new Map;g&&(await g.close(),g.dispose()),this.workspaceStorage=this.createWorkspaceStorage(I),await this.workspaceStorage.init();for(const[f,p]of w)this.workspaceStorage.set(f,p)}}e.NativeStorageService=E}),define(te[196],ne([0,1,4,31,7,30]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(E){if(D.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function C(E,n,I,g,w,f,p,d,b,y){const v=Object.create(null);v["common.machineId"]=p,v.sessionID=(0,T.generateUuid)()+Date.now(),v.commitHash=w,v.version=f,v["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,D.PlatformToString)(D.platform),v["common.nodePlatform"]=L.platform,v["common.nodeArch"]=g,v["common.product"]=y||"desktop";const l=S(d||[]);l&&(v["common.msftInternal"]=l);let c=0;const t=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),D.isLinuxSnap&&(v["common.snap"]="true");const s=k(I);s&&(v["common.platformDetail"]=s);try{const r=await E.readFile(R.URI.file(b));v["common.source"]=r.value.toString().slice(0,30)}catch(r){}return v}e.resolveCommonProperties=C;function S(E){const n=L.env.USERDNSDOMAIN;if(!n)return!1;const I=n.toLowerCase();return E.some(g=>I===g)}e.verifyMicrosoftInternalDomain=S}),define(te[21],ne([0,1,5]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(T){T[T.NONE=0]="NONE",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var R;(function(T){T.OFF="off",T.ERROR="error",T.ON="on"})(R=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[197],ne([0,1,32,55,36,15,8,4,7,109,19,112,78,14,29,21]),function(J,e,D,L,R,T,k,C,S,E,n,I,g,w,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function d(c,t){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],r=new Map,i=new Map,a=2e4;function o(m,A,_,O){const N=A.substring(m.length+1);return new Promise(async P=>{let M;try{M=await n.Promises.readdir(A,{withFileTypes:!0})}catch(H){P();return}if(O.count>=a){O.count+=M.length,O.maxReached=!0,P();return}let $=M.length;if($===0){P();return}let U=M;O.count+M.length>a&&(O.maxReached=!0,$=a-O.count,U=M.slice(0,$)),O.count+=M.length;for(const H of U)if(H.isDirectory()){if(_.includes(H.name)||await o(m,(0,k.join)(A,H.name),_,O),--$==0){P();return}}else{const W=H.name.lastIndexOf(".");if(W>=0){const q=H.name.substring(W+1);q&&r.set(q,(r.get(q)??0)+1)}for(const q of s)q.relativePathPattern?.test(N)!==!1&&q.filePattern.test(H.name)&&i.set(q.tag,(i.get(q.tag)??0)+1);if(--$==0){P();return}}})}const u={count:0,maxReached:!1};await o(c,c,t,u);const h=await v(c);return{configFiles:b(i),fileTypes:b(r),fileCount:u.count,maxFilesReached:u.maxReached,launchConfigFiles:h}}e.collectWorkspaceStats=d;function b(c){return[...L.Iterable.map(c.entries(),([t,s])=>({name:t,count:s}))].sort((t,s)=>s.count-t.count)}function y(){const c={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/w.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/w.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(E.virtualMachineHint.value()*100)}%`},t=D.cpus();return t&&t.length>0&&(c.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),c}e.getMachineInfo=y;async function v(c){try{const t=new Map,s=(0,k.join)(c,".vscode","launch.json"),r=await n.Promises.readFile(s),i=[],a=(0,R.parse)(r.toString(),i);if(i.length)return console.log(`Unable to parse ${s}`),[];if((0,R.getNodeType)(a)==="object"&&a.configurations)for(const o of a.configurations){const u=o.type;u&&(t.has(u)?t.set(u,t.get(u)+1):t.set(u,1))}return b(t)}catch(t){return[]}}e.collectLaunchConfigs=v;let l=class{constructor(t,s){this.telemetryService=t,this.productService=s}formatMachineInfo(t){const s=[];return s.push(`OS Version:       ${t.os}`),s.push(`CPUs:             ${t.cpus}`),s.push(`Memory (System):  ${t.memory}`),s.push(`VM:               ${t.vmHint}`),s.join(`
`)}formatEnvironment(t){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const r=D.cpus();return r&&r.length>0&&s.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),s.push(`Memory (System):  ${(D.totalmem()/w.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/w.ByteSize.GB).toFixed(2)}GB free)`),C.isWindows||s.push(`Load (avg):       ${D.loadavg().map(i=>Math.round(i)).join(", ")}`),s.push(`VM:               ${Math.round(E.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${t.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(t,s){return Promise.all([(0,I.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async r=>{let[i,a]=r,o=this.formatProcessList(t,i);return s.forEach(u=>{if((0,g.isRemoteDiagnosticError)(u))o+=`
${u.errorMessage}`,a+=`
${u.errorMessage}`;else if(o+=`

Remote: ${u.hostName}`,u.processes&&(o+=`
${this.formatProcessList(t,u.processes)}`),u.workspaceMetadata){a+=`
|  Remote: ${u.hostName}`;for(const h of Object.keys(u.workspaceMetadata)){const m=u.workspaceMetadata[h];let A=`${m.fileCount} files`;m.maxFilesReached&&(A=`more than ${A}`),a+=`|    Folder (${h}): ${A}`,a+=this.formatWorkspaceStats(m)}}}),{processInfo:o,workspaceInfo:a}})}async getSystemInfo(t,s){const{memory:r,vmHint:i,os:a,cpus:o}=y(),u={os:a,memory:r,cpus:o,vmHint:i,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:s};return C.isWindows||(u.load=`${D.loadavg().map(h=>Math.round(h)).join(", ")}`),C.isLinux&&(u.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(u)}async getDiagnostics(t,s){const r=[];return(0,I.listProcesses)(t.mainPID).then(async i=>(r.push(""),r.push(this.formatEnvironment(t)),r.push(""),r.push(this.formatProcessList(t,i)),t.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(t))),s.forEach(a=>{if((0,g.isRemoteDiagnosticError)(a))r.push(`
${a.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${a.hostName}`),r.push(this.formatMachineInfo(a.machineInfo)),a.processes&&r.push(this.formatProcessList(t,a.processes)),a.workspaceMetadata)for(const o of Object.keys(a.workspaceMetadata)){const u=a.workspaceMetadata[o];let h=`${u.fileCount} files`;u.maxFilesReached&&(h=`more than ${h}`),r.push(`Folder (${o}): ${h}`),r.push(this.formatWorkspaceStats(u))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(t){const s=[],r=60;let i=0;const a=(m,A)=>{const _=` ${m}(${A})`;i+_.length>r?(s.push(o),o="|                 ",i=o.length):i+=_.length,o+=_};let o="|      File types:";const u=10;let h=t.fileTypes.length>u?u:t.fileTypes.length;for(let m=0;m<h;m++){const A=t.fileTypes[m];a(A.name,A.count)}if(s.push(o),t.configFiles.length>=0&&(o="|      Conf files:",i=0,t.configFiles.forEach(m=>{a(m.name,m.count)}),s.push(o)),t.launchConfigFiles.length>0){let m="|      Launch Configs:";t.launchConfigFiles.forEach(A=>{m+=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`}),s.push(m)}return s.join(`
`)}expandGPUFeatures(t){const s=Math.max(...Object.keys(t).map(r=>r.length));return Object.keys(t).map(r=>`${r}:  ${" ".repeat(s-r.length)}  ${t[r]}`).join(`
                  `)}formatWorkspaceMetadata(t){const s=[],r=[];return t.windows.forEach(i=>{i.folderURIs.length===0||!!i.remoteAuthority||(s.push(`|  Window (${i.title})`),i.folderURIs.forEach(a=>{const o=S.URI.revive(a);if(o.scheme===T.Schemas.file){const u=o.fsPath;r.push(d(u,["node_modules",".git"]).then(h=>{let m=`${h.fileCount} files`;h.maxFilesReached&&(m=`more than ${m}`),s.push(`|    Folder (${(0,k.basename)(u)}): ${m}`),s.push(this.formatWorkspaceStats(h))}).catch(h=>{s.push(`|      Error: Unable to collect workspace stats for folder ${u} (${h.toString()})`)}))}else s.push(`|    Folder (${o.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(i=>s.join(`
`)).catch(i=>`Unable to collect workspace stats: ${i}`)}formatProcessList(t,s){const r=new Map;t.windows.forEach(a=>r.set(a.pid,a.title));const i=[];return i.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(t.mainPID,r,i,s,0),i.join(`
`)}formatProcessItem(t,s,r,i,a){const o=a===0;let u;o?u=i.pid===t?`${this.productService.applicationName} main`:"remote agent":(u=`${"  ".repeat(a)} ${i.name}`,i.name==="window"&&(u=`${u} (${s.get(i.pid)})`));const h=process.platform==="win32"?i.mem:D.totalmem()*(i.mem/100);r.push(`${i.load.toFixed(0).padStart(5," ")}	${(h/w.ByteSize.MB).toFixed(0).padStart(6," ")}	${i.pid.toFixed(0).padStart(6," ")}	${u}`),Array.isArray(i.children)&&i.children.forEach(m=>this.formatProcessItem(t,s,r,m,a+1))}async reportWorkspaceStats(t){for(const{uri:s}of t.folders){const r=S.URI.revive(s);if(r.scheme!==T.Schemas.file)continue;const i=r.fsPath;try{const a=await d(i,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),a.fileTypes.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:o.name,count:o.count})}),a.launchConfigFiles.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:o.name,count:o.count})}),a.configFiles.forEach(o=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:o.name,count:o.count})})}catch{}}}};l=he([Q(0,p.ITelemetryService),Q(1,f.IProductService)],l),e.DiagnosticsService=l}),define(te[198],ne([0,1,17,6,27,9,3,2,4,7,127,28,35,10,42,21]),function(J,e,D,L,R,T,k,C,S,E,n,I,g,w,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.INSTALL_ERROR_LOCAL=e.ERROR_UNKNOWN=e.INSTALL_ERROR_VALIDATING=void 0,e.INSTALL_ERROR_VALIDATING="validating",e.ERROR_UNKNOWN="unknown",e.INSTALL_ERROR_LOCAL="local";let d=class extends C.Disposable{constructor(c,t,s){super();this.galleryService=c,this.telemetryService=t,this.logService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,C.toDisposable)(()=>{this.installingExtensions.forEach(r=>r.cancel()),this.uninstallingExtensions.forEach(r=>r.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(c){const t=await this.getTargetPlatform();return c.allTargetPlatforms.some(s=>(0,I.isTargetPlatformCompatible)(s,c.allTargetPlatforms,t))}async installFromGallery(c,t={}){if(!this.galleryService.isEnabled())throw new Error(n.localize(0,null));if(!await this.canInstall(c)){const r=await this.getTargetPlatform(),i=new I.ExtensionManagementError(n.localize(1,null,c.identifier.id,f.default.nameLong,(0,I.TargetPlatformToString)(r)),e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension.",c.identifier.id,i.message),y(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(c),void 0,i),i}try{c=await this.checkAndGetCompatibleVersion(c,!t.installGivenVersion)}catch(r){throw this.logService.error((0,T.getErrorMessage)(r)),y(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(c),void 0,r),r}const s=await this.galleryService.getManifest(c,R.CancellationToken.None);if(s===null){const r=new I.ExtensionManagementError(`Missing manifest for extension ${c.identifier.id}`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",c.identifier.id,r.message),y(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(c),void 0,r),r}if(s.version!==c.version){const r=new I.ExtensionManagementError(`Cannot install '${c.identifier.id}' extension because of version mismatch in Marketplace`,e.INSTALL_ERROR_VALIDATING);throw this.logService.error(r.message),y(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(c),void 0,r),r}return this.installExtension(s,c,t)}async uninstall(c,t={}){return this.logService.trace("ExtensionManagementService#uninstall",c.identifier.id),this.unininstallExtension(c,t)}async reinstallFromGallery(c){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",c.identifier.id),!this.galleryService.isEnabled())throw new Error(n.localize(2,null));const t=await this.findGalleryExtension(c);if(!t)throw new Error(n.localize(3,null));await this.createUninstallExtensionTask(c,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(t)}getExtensionsReport(){const c=new Date().getTime();return(!this.reportedExtensions||c-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=c),this.reportedExtensions}registerParticipant(c){this.participants.push(c)}async installExtension(c,t,s){if(!E.URI.isUri(t)){let u=this.installingExtensions.get(new g.ExtensionIdentifierWithVersion(t.identifier,t.version).key());if(u)return this.logService.info("Extensions is already requested to install",t.identifier.id),u.waitUntilTaskIsFinished();s={...s,installOnlyNewlyAddedFromExtensionPack:!0}}const r=[],i=[],a=this.createInstallExtensionTask(c,t,s);E.URI.isUri(t)||this.installingExtensions.set(new g.ExtensionIdentifierWithVersion(a.identifier,c.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:t}),this.logService.info("Installing extension:",a.identifier.id),r.push({task:a,manifest:c});let o=!1;try{if(s.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const h=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,c,!!s.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:m,manifest:A}of h)if(o=o||!!A.extensionDependencies?.some(_=>(0,g.areSameExtensions)({id:_},a.identifier)),this.installingExtensions.has(new g.ExtensionIdentifierWithVersion(m.identifier,m.version).key()))this.logService.info("Extension is already requested to install",m.identifier.id);else{const _=this.createInstallExtensionTask(A,m,{...s,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new g.ExtensionIdentifierWithVersion(_.identifier,A.version).key(),_),this._onInstallExtension.fire({identifier:_.identifier,source:m}),this.logService.info("Installing extension:",_.identifier.id),r.push({task:_,manifest:A})}}catch(h){if(E.URI.isUri(a.source))(0,D.isNonEmptyArray)(c.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,h.message),(0,D.isNonEmptyArray)(c.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,h.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),this.logService.error(h),h}const u=r.reduce((h,{task:m,manifest:A})=>(h.set(m.identifier.id.toLowerCase(),{task:m,manifest:A}),h),new Map);for(;u.size;){let h;const m=[...u.values()].filter(({manifest:A})=>!A.extensionDependencies?.some(_=>u.has(_.toLowerCase())));m.length?h=u.size===1?m:m.filter(({task:A})=>!(A===a&&!o)):(this.logService.info("Found extensions with circular dependencies",m.map(({task:A})=>A.identifier.id)),h=[...u.values()]),await this.joinAllSettled(h.map(async({task:A})=>{const _=new Date().getTime();try{const O=await A.run();if(await this.joinAllSettled(this.participants.map(N=>N.postInstall(O,A.source,s,R.CancellationToken.None))),!E.URI.isUri(A.source)&&(y(this.telemetryService,A.operation===2?"extensionGallery:update":"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-_,void 0),S.isWeb&&A.operation===1))try{await this.galleryService.reportStatistic(O.manifest.publisher,O.manifest.name,O.manifest.version,"install")}catch(N){}i.push({local:O,identifier:A.identifier,operation:A.operation,source:A.source})}catch(O){throw E.URI.isUri(A.source)||y(this.telemetryService,A.operation===2?"extensionGallery:update":"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-_,O),this.logService.error("Error while installing the extension:",A.identifier.id),this.logService.error(O),O}finally{u.delete(A.identifier.id.toLowerCase())}}))}return i.forEach(({identifier:h})=>this.logService.info("Extension installed successfully:",h.id)),this._onDidInstallExtensions.fire(i),i.filter(({identifier:h})=>(0,g.areSameExtensions)(h,a.identifier))[0].local}catch(u){if(r.forEach(({task:h})=>h.cancel()),i.length)try{const h=await Promise.allSettled(i.map(({local:m})=>this.createUninstallExtensionTask(m,{versionOnly:!0}).run()));for(let m=0;m<h.length;m++){const A=h[m],{identifier:_}=i[m];A.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",_.id):this.logService.warn("Rollback: Error while uninstalling extension",_.id,(0,T.getErrorMessage)(A.reason))}}catch(h){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(h),i.map(({identifier:m})=>m.id))}throw this.logService.error("Failed to install extension:",a.identifier.id,(0,T.getErrorMessage)(u)),this._onDidInstallExtensions.fire(r.map(({task:h})=>({identifier:h.identifier,operation:1,source:h.source}))),u instanceof Error&&(u.name=u&&u.code?u.code:e.ERROR_UNKNOWN),u}finally{for(const{task:u,manifest:h}of r)if(!E.URI.isUri(u.source)){const m=new g.ExtensionIdentifierWithVersion(u.identifier,h.version).key();this.installingExtensions.delete(m)||this.logService.warn("Installation task is not found in the cache",m)}}}async joinAllSettled(c){const t=[],s=[],r=await Promise.allSettled(c);for(const i of r)i.status==="fulfilled"?t.push(i.value):s.push(i.reason);if(s.length)throw b(s);return t}async getAllDepsAndPackExtensionsToInstall(c,t,s){if(!this.galleryService.isEnabled())return[];let r=await this.getInstalled();const i=[c,...r.map(u=>u.identifier)],a=[],o=async(u,h)=>{const m=h.extensionDependencies||[],A=[...m];if(h.extensionPack){const _=s?r.find(O=>(0,g.areSameExtensions)(O.identifier,u)):void 0;for(const O of h.extensionPack)_&&_.manifest.extensionPack&&_.manifest.extensionPack.some(N=>(0,g.areSameExtensions)({id:N},{id:O}))||A.every(N=>!(0,g.areSameExtensions)({id:N},{id:O}))&&A.push(O)}if(A.length){const _=[...i,...a.map(N=>N.gallery.identifier)],O=A.filter(N=>_.every(P=>!(0,g.areSameExtensions)(P,{id:N})));if(O.length){const N=await this.galleryService.query({names:O,pageSize:A.length},R.CancellationToken.None);for(const P of N.firstPage){if(_.find(H=>(0,g.areSameExtensions)(H,P.identifier)))continue;if(!m.some(H=>(0,g.areSameExtensions)({id:H},P.identifier))&&!await this.canInstall(P)){this.logService.info("Skipping the packed extension as it cannot be installed",P.identifier.id);continue}const $=await this.checkAndGetCompatibleVersion(P,!0),U=await this.galleryService.getManifest($,R.CancellationToken.None);if(U===null)throw new I.ExtensionManagementError(`Missing manifest for extension ${$.identifier.id}`,e.INSTALL_ERROR_VALIDATING);a.push({gallery:$,manifest:U}),await o($.identifier,U)}}}};return await o(c,t),r=await this.getInstalled(),a.filter(u=>!r.some(h=>(0,g.areSameExtensions)(h.identifier,u.gallery.identifier)))}async checkAndGetCompatibleVersion(c,t){if(await this.isMalicious(c))throw new I.ExtensionManagementError(n.localize(4,null,c.identifier.id),I.INSTALL_ERROR_MALICIOUS);const s=await this.getCompatibleVersion(c,t);if(!s)throw new I.ExtensionManagementError(n.localize(5,null,c.identifier.id,f.default.version),I.INSTALL_ERROR_INCOMPATIBLE);return s}async getCompatibleVersion(c,t){const s=await this.getTargetPlatform();let r=null;return await this.galleryService.isExtensionCompatible(c,s)&&(r=c),!r&&t&&(r=await this.galleryService.getCompatibleExtension(c,s)),r}async isMalicious(c){const t=await this.getExtensionsReport();return(0,g.getMaliciousExtensionsSet)(t).has(c.identifier.id)}async unininstallExtension(c,t){const s=this.uninstallingExtensions.get(c.identifier.id.toLowerCase());if(s)return this.logService.info("Extensions is already requested to uninstall",c.identifier.id),s.waitUntilTaskIsFinished();const r=(u,h)=>{const m=this.createUninstallExtensionTask(u,h);return this.uninstallingExtensions.set(m.extension.identifier.id.toLowerCase(),m),this.logService.info("Uninstalling extension:",u.identifier.id),this._onUninstallExtension.fire(u.identifier),m},i=(u,h)=>{h?this.logService.error("Failed to uninstall extension:",u.identifier.id,h.message):this.logService.info("Successfully uninstalled extension:",u.identifier.id),y(this.telemetryService,"extensionGallery:uninstall",(0,g.getLocalExtensionTelemetryData)(u),void 0,h),this._onDidUninstallExtension.fire({identifier:u.identifier,error:h?.code})},a=[],o=[];try{a.push(r(c,{}));const u=await this.getInstalled(1);if(t.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",c.identifier.id);else{const h=this.getAllPackExtensionsToUninstall(c,u);for(const m of h)this.uninstallingExtensions.has(m.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",m.identifier.id):a.push(r(m,{}))}t.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",c.identifier.id):this.checkForDependents(a.map(h=>h.extension),u,c),await this.joinAllSettled(a.map(async h=>{try{if(await h.run(),await this.joinAllSettled(this.participants.map(m=>m.postUninstall(h.extension,t,R.CancellationToken.None))),h.extension.identifier.uuid)try{await this.galleryService.reportStatistic(h.extension.manifest.publisher,h.extension.manifest.name,h.extension.manifest.version,"uninstall")}catch(m){}i(h.extension)}catch(m){const A=m instanceof I.ExtensionManagementError?m:new I.ExtensionManagementError((0,T.getErrorMessage)(m),e.ERROR_UNKNOWN);throw i(h.extension,A),A}finally{o.push(h)}}))}catch(u){const h=u instanceof I.ExtensionManagementError?u:new I.ExtensionManagementError((0,T.getErrorMessage)(u),e.ERROR_UNKNOWN);for(const m of a){try{m.cancel()}catch(A){}o.includes(m)||i(m.extension,h)}throw h}finally{for(const u of a)this.uninstallingExtensions.delete(u.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",u.extension.identifier.id)}}checkForDependents(c,t,s){for(const r of c){const i=this.getDependents(r,t);if(i.length){const a=i.filter(o=>!c.some(u=>(0,g.areSameExtensions)(u.identifier,o.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(r,a,s))}}}getDependentsErrorMessage(c,t,s){return s===c?t.length===1?n.localize(6,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?n.localize(7,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):n.localize(8,null,s.manifest.displayName||s.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):t.length===1?n.localize(9,null,s.manifest.displayName||s.manifest.name,c.manifest.displayName||c.manifest.name,t[0].manifest.displayName||t[0].manifest.name):t.length===2?n.localize(10,null,s.manifest.displayName||s.manifest.name,c.manifest.displayName||c.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):n.localize(11,null,s.manifest.displayName||s.manifest.name,c.manifest.displayName||c.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name)}getAllPackExtensionsToUninstall(c,t,s=[]){if(s.indexOf(c)!==-1)return[];s.push(c);const r=c.manifest.extensionPack?c.manifest.extensionPack:[];if(r.length){const i=t.filter(o=>!o.isBuiltin&&r.some(u=>(0,g.areSameExtensions)({id:u},o.identifier))),a=[];for(const o of i)a.push(...this.getAllPackExtensionsToUninstall(o,t,s));return[...i,...a]}return[]}getDependents(c,t){return t.filter(s=>s.manifest.extensionDependencies&&s.manifest.extensionDependencies.some(r=>(0,g.areSameExtensions)({id:r},c.identifier)))}async findGalleryExtension(c){if(c.identifier.uuid){const t=await this.findGalleryExtensionById(c.identifier.uuid);return t||this.findGalleryExtensionByName(c.identifier.id)}return this.findGalleryExtensionByName(c.identifier.id)}async findGalleryExtensionById(c){return(await this.galleryService.query({ids:[c],pageSize:1},R.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(c){return(await this.galleryService.query({names:[c],pageSize:1},R.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const c=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${c.length} reported extensions from service`),c}catch(c){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};d=he([Q(0,I.IExtensionGalleryService),Q(1,p.ITelemetryService),Q(2,w.ILogService)],d),e.AbstractExtensionManagementService=d;function b(l){const c=Array.isArray(l)?l:[l];return c.length===1?c[0]instanceof Error?c[0]:new Error(c[0]):c.reduce((t,s)=>new Error(`${t.message}${t.message?",":""}${s instanceof Error?s.message:s}`),new Error(""))}e.joinErrors=b;function y(l,c,t,s,r){const i=r?r instanceof I.ExtensionManagementError?r.code:e.ERROR_UNKNOWN:void 0;l.publicLogError(c,{...t,success:!r,duration:s,errorcode:i})}e.reportTelemetry=y;class v{constructor(){this.barrier=new L.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(c=>this.doRun(c))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,L.createCancelablePromise)(c=>new Promise((t,s)=>{const r=c.onCancellationRequested(()=>{r.dispose(),s((0,T.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=v}),define(te[199],ne([0,1,17,6,65,3,8,4,31,7,129,13,28,191,80,14,10,59,29,43,23,21]),function(J,e,D,L,R,T,k,C,S,E,n,I,g,w,f,p,d,b,y,v,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",s="extensionTips/lastPromptedMediumImpExeTime";let r=class extends w.ExtensionTipsService{constructor(a,o,u,h,m,A,_,O,N,P){super(_,O,N,P);this.environmentService=a,this.telemetryService=o,this.extensionManagementService=u,this.storageService=h,this.nativeHostService=m,this.extensionRecommendationNotificationService=A,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&(0,R.forEach)(O.exeBasedExtensionTips,({key:M,value:$})=>{const U=[],H=[],W=[];(0,R.forEach)($.recommendations,({key:q,value:x})=>{x.important?$.important?U.push({extensionId:q,extensionName:x.name,isExtensionPack:!!x.isExtensionPack}):H.push({extensionId:q,extensionName:x.name,isExtensionPack:!!x.isExtensionPack}):W.push({extensionId:q,extensionName:x.name,isExtensionPack:!!x.isExtensionPack})}),U.length&&this.highImportanceExecutableTips.set(M,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:U}),H.length&&this.mediumImportanceExecutableTips.set(M,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:H}),W.length&&this.allOtherExecutableTips.set(M,{exeFriendlyName:$.friendlyName,windowsPath:$.windowsPath,recommendations:W})}),(0,L.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...a,...o]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const a=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(a,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(o,u)}groupImportantTipsByExe(a,o){const u=new Map;a.forEach(O=>u.set(O.extensionId.toLowerCase(),O));const{installed:h,uninstalled:m}=this.groupByInstalled([...u.keys()],o);for(const O of h){const N=u.get(O);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:N.exeName})}for(const O of m){const N=u.get(O);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:N.exeName})}const A=this.getPromptedExecutableTips(),_=new Map;for(const O of m){const N=u.get(O);if(N&&(!A[N.exeName]||!A[N.exeName].includes(N.extensionId))){let P=_.get(N.exeName);P||(P=[],_.set(N.exeName,P)),P.push(N)}}return _}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[a,o]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(o[0].exeName,o);break;case"ignored":this.highImportanceTipsByExe.delete(a);break;case"incompatibleWindow":const h=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(h(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const m=this._register((0,L.disposableTimeout)(()=>{m.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const a=this.getLastPromptedMediumExeTime(),o=Date.now()-a,u=7*24*60*60*1e3;if(o<u){const A=this._register((0,L.disposableTimeout)(()=>{A.dispose(),this.promptMediumImportanceExeBasedTip()},u-o));return}const[h,m]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(m).then(A=>{switch(A){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(h),this.addToRecommendedExecutables(m[0].exeName,m);const _=this._register((0,L.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},u));break;case"ignored":this.mediumImportanceTipsByExe.delete(h),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const O=T.Event.once(T.Event.latch(T.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(O(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const N=this._register((0,L.disposableTimeout)(()=>{N.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(a){const o=a.map(({extensionId:h})=>h.toLowerCase()),u=(0,n.localize)(0,null,a[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(o,u,`@exe:"${a[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let a=this.storageService.getNumber(s,0);return a||(a=Date.now(),this.updateLastPromptedMediumExeTime(a)),a}updateLastPromptedMediumExeTime(a){this.storageService.store(s,a,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(a,o){const u=this.getPromptedExecutableTips();u[a]=o.map(({extensionId:h})=>h.toLowerCase()),this.storageService.store(t,JSON.stringify(u),0,0)}groupByInstalled(a,o){const u=[],h=[],m=o.reduce((A,_)=>(A.add(_.identifier.id.toLowerCase()),A),new Set);return a.forEach(A=>{m.has(A.toLowerCase())?u.push(A):h.push(A)}),{installed:u,uninstalled:h}}async getValidExecutableBasedExtensionTips(a){const o=[],u=new Map;for(const h of a.keys()){const m=a.get(h);if(!m||!(0,D.isNonEmptyArray)(m.recommendations))continue;const A=[];C.isWindows?m.windowsPath&&A.push(m.windowsPath.replace("%USERPROFILE%",S.env.USERPROFILE).replace("%ProgramFiles(x86)%",S.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",S.env.ProgramFiles).replace("%APPDATA%",S.env.APPDATA).replace("%WINDIR%",S.env.WINDIR)):(A.push((0,k.join)("/usr/local/bin",h)),A.push((0,k.join)("/usr/bin",h)),A.push((0,k.join)(this.environmentService.userHome.fsPath,h)));for(const _ of A){let O=u.get(_);if(O===void 0&&(O=await this.fileService.exists(E.URI.file(_)),u.set(_,O)),O)for(const{extensionId:N,extensionName:P,isExtensionPack:M}of m.recommendations)o.push({extensionId:N,extensionName:P,isExtensionPack:M,exeName:h,exeFriendlyName:m.exeFriendlyName,windowsPath:m.windowsPath})}}return o}};r=he([Q(0,I.INativeEnvironmentService),Q(1,c.ITelemetryService),Q(2,g.IExtensionManagementService),Q(3,l.IStorageService),Q(4,b.INativeHostService),Q(5,f.IExtensionRecommendationNotificationService),Q(6,p.IFileService),Q(7,y.IProductService),Q(8,v.IRequestService),Q(9,d.ILogService)],r),e.ExtensionTipsService=r}),define(te[91],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(T){this.appenders=T}listen(T,k){throw new Error(`Event not found: ${k}`)}call(T,k,{eventName:C,data:S}){return this.appenders.forEach(E=>E.log(C,S)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class L{constructor(T){this.channel=T}log(T,k){return this.channel.call("log",{eventName:T,data:k}).then(void 0,C=>`Failed to log telemetry: ${console.warn(C)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(te[46],ne([0,1,26,18,20,21]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class k{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(b,y){return Promise.resolve(void 0)}publicLog2(b,y){return this.publicLog(b,y)}publicLogError(b,y){return Promise.resolve(void 0)}publicLogError2(b,y){return this.publicLogError(b,y)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=k,e.NullTelemetryService=new k;class C{async publicLog(b,y,v){}async publicLogError(b,y,v){}}e.NullEndpointTelemetryService=C,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(d,b){return b.onDidChangeConfiguration(y=>{y.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(y.source),configurationKeys:f(y.sourceConfig)})})}e.configurationTelemetry=S;function E(d,b){return!(b.disableTelemetry||!d.enableTelemetry)}e.supportsTelemetry=E;function n(d){const b=d.getValue(T.TELEMETRY_SETTING_ID),y=d.getValue(T.TELEMETRY_OLD_SETTING_ID);if(y!==void 0&&y===!1)return 0;switch(b??"on"){case"on":return 3;case"error":return 2;case"off":return 0}}e.getTelemetryLevel=n;function I(d){const b=Object.create(null),y=Object.create(null),v=Object.create(null);w(d,v);for(let l in v){l=l.length>150?l.substr(l.length-149):l;const c=v[l];typeof c=="number"?y[l]=c:typeof c=="boolean"?y[l]=c?1:0:typeof c=="string"?b[l]=c.substring(0,1023):typeof c!="undefined"&&c!==null&&(b[l]=c)}return{properties:b,measurements:y}}e.validateTelemetryData=I;function g(d){if(!d)return"none";let b="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(v=>{d.indexOf(`${v}+`)===0&&(b=v)}),b}e.cleanRemoteAuthority=g;function w(d,b,y=0,v){if(!!d)for(let l of Object.getOwnPropertyNames(d)){const c=d[l],t=v?v+l:l;Array.isArray(c)?b[t]=(0,D.safeStringify)(c):c instanceof Date?b[t]=c.toISOString():(0,L.isObject)(c)?y<2?w(c,b,y+1,t+"."):b[t]=(0,D.safeStringify)(c):b[t]=c}}function f(d){if(!d)return[];const b=[];return p(b,"",d),b}function p(d,b,y){y&&typeof y=="object"&&!Array.isArray(y)?Object.keys(y).forEach(v=>p(d,b?`${b}.${v}`:v,y[v])):d.push(b)}}),define(te[200],ne([0,1,17,27,9,26,4,31,7,20,13,28,35,76,14,10,29,43,45,23,21,46]),function(J,e,D,L,R,T,k,C,S,E,n,I,g,w,f,p,d,b,y,v,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const t=k.isWeb?"web":(0,I.getTargetPlatform)(k.platform,C.arch);var s;(function(V){V[V.None=0]="None",V[V.IncludeVersions=1]="IncludeVersions",V[V.IncludeFiles=2]="IncludeFiles",V[V.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",V[V.IncludeSharedAccounts=8]="IncludeSharedAccounts",V[V.IncludeVersionProperties=16]="IncludeVersionProperties",V[V.ExcludeNonValidated=32]="ExcludeNonValidated",V[V.IncludeInstallationTargets=64]="IncludeInstallationTargets",V[V.IncludeAssetUri=128]="IncludeAssetUri",V[V.IncludeStatistics=256]="IncludeStatistics",V[V.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",V[V.Unpublished=4096]="Unpublished"})(s||(s={}));function r(...V){return String(V.reduce((G,ie)=>G|ie,0))}var i;(function(V){V[V.Tag=1]="Tag",V[V.ExtensionId=4]="ExtensionId",V[V.Category=5]="Category",V[V.ExtensionName=7]="ExtensionName",V[V.Target=8]="Target",V[V.Featured=9]="Featured",V[V.SearchText=10]="SearchText",V[V.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},h={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class m{constructor(G=h){this.state=G}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(G,ie=this.state.pageSize){return new m({...this.state,pageNumber:G,pageSize:ie})}withFilter(G,...ie){const re=[...this.state.criteria,...ie.length?ie.map(ae=>({filterType:G,value:ae})):[{filterType:G}]];return new m({...this.state,criteria:re})}withSortBy(G){return new m({...this.state,sortBy:G})}withSortOrder(G){return new m({...this.state,sortOrder:G})}withFlags(...G){return new m({...this.state,flags:G.reduce((ie,re)=>ie|re,0)})}withAssetTypes(...G){return new m({...this.state,assetTypes:G})}get raw(){const{criteria:G,pageNumber:ie,pageSize:re,sortBy:ae,sortOrder:ue,flags:fe,assetTypes:de}=this.state;return{filters:[{criteria:G,pageNumber:ie,pageSize:re,sortBy:ae,sortOrder:ue}],assetTypes:de,flags:fe}}get searchText(){const G=this.state.criteria.filter(ie=>ie.filterType===i.SearchText)[0];return G&&G.value?G.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(G=>String(G.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function A(V,G){const ie=(V||[]).filter(re=>re.statisticName===G)[0];return ie?ie.value:0}function _(V){const G="Microsoft.VisualStudio.Code.Translation.";return V.files.filter(re=>re.assetType.indexOf(G)===0).reduce((re,ae)=>{const ue=M(V,ae.assetType);return ue&&re.push([ae.assetType.substring(G.length),ue]),re},[])}function O(V){if(V.properties){const G=V.properties.filter(ae=>ae.key===a.Repository),ie=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),re=G.filter(ae=>ie.test(ae.value))[0];return re?{uri:re.value,fallbackUri:re.value}:null}return M(V,a.Repository)}function N(V){return{uri:`${V.fallbackAssetUri}/${a.VSIX}?redirect=true${V.targetPlatform?`&targetPlatform=${V.targetPlatform}`:""}`,fallbackUri:`${V.fallbackAssetUri}/${a.VSIX}${V.targetPlatform?`?targetPlatform=${V.targetPlatform}`:""}`}}function P(V){const G=M(V,a.Icon);if(G)return G;const ie=I.DefaultIconPath;return{uri:ie,fallbackUri:ie}}function M(V,G){return V.files.filter(re=>re.assetType===G)[0]?{uri:`${V.assetUri}/${G}`,fallbackUri:`${V.fallbackAssetUri}/${G}`}:null}function $(V,G){const ie=V.properties?V.properties.filter(ae=>ae.key===G):[],re=ie.length>0&&ie[0].value;return re?re.split(",").map(ae=>(0,g.adoptToGalleryExtensionId)(ae)):[]}function U(V){const G=V.properties?V.properties.filter(ie=>ie.key===o.Engine):[];return G.length>0&&G[0].value||""}function H(V){const G=V.properties?V.properties.filter(re=>re.key===o.LocalizedLanguages):[],ie=G.length>0&&G[0].value||"";return ie?ie.split(","):[]}function W(V){return V.indexOf("preview")!==-1}function q(V){return V.targetPlatform?(0,I.toTargetPlatform)(V.targetPlatform):"undefined"}function x(V){const G=(0,D.distinct)(V.versions.map(q)),ie=!!V.tags?.includes(I.WEB_EXTENSION_TAG),re=G.indexOf("web");return ie?re===-1&&G.push("web"):re!==-1&&G.splice(re,1),G}function F(V,G){const ie=(0,I.getFallbackTargetPlarforms)(G);for(let re=0;re<V.length;re++){const ae=V[re];if(ae.version===V[re-1]?.version){let ue=re;const fe=q(ae);if(fe===G)for(;ue>0&&V[ue-1].version===ae.version;)ue--;else if(ie.includes(fe))for(;ue>0&&V[ue-1].version===ae.version&&q(V[ue-1])!==G;)ue--;ue!==re&&(V.splice(re,1),V.splice(ue,0,ae))}}return V}e.sortExtensionVersions=F;function K(V,G,ie,re,ae){const ue=x(V);let fe=V.versions[0];return fe=V.versions.find(de=>de.version===fe.version&&(0,I.isTargetPlatformCompatible)(q(de),ue,ae))||fe,j(V,fe,ue,G,ie,re)}function j(V,G,ie,re,ae,ue){const fe={manifest:M(G,a.Manifest),readme:M(G,a.Details),changelog:M(G,a.Changelog),license:M(G,a.License),repository:O(G),download:N(G),icon:P(G),coreTranslations:_(G)};return{identifier:{id:(0,g.getGalleryExtensionId)(V.publisher.publisherName,V.extensionName),uuid:V.extensionId},name:V.extensionName,version:G.version,displayName:V.displayName,publisherId:V.publisher.publisherId,publisher:V.publisher.publisherName,publisherDisplayName:V.publisher.displayName,description:V.shortDescription||"",installCount:A(V.statistics,"install"),rating:A(V.statistics,"averagerating"),ratingCount:A(V.statistics,"ratingcount"),categories:V.categories||[],tags:V.tags||[],releaseDate:Date.parse(V.releaseDate),lastUpdated:Date.parse(V.lastUpdated),allTargetPlatforms:ie,assets:fe,properties:{dependencies:$(G,o.Dependency),extensionPack:$(G,o.ExtensionPack),engine:U(G),localizedLanguages:H(G),targetPlatform:q(G)},preview:W(V.flags),telemetryData:{index:(ae.pageNumber-1)*ae.pageSize+re,querySource:ue}}}let z=class{constructor(G,ie,re,ae,ue,fe,de,Ie){this.requestService=ie,this.logService=re,this.environmentService=ae,this.telemetryService=ue,this.fileService=fe,this.productService=de,this.configurationService=Ie;const Ce=de.extensionsGallery;this.extensionsGalleryUrl=Ce&&Ce.serviceUrl,this.extensionsControlUrl=Ce&&Ce.controlUrl,this.commonHeadersPromise=Z(de.version,de,this.environmentService,this.configurationService,this.fileService,G)}api(G=""){return`${this.extensionsGalleryUrl}${G}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(G,ie){const re=[];let ae=new m().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,G.length).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExtensionName,...G.map(({id:fe})=>fe.toLowerCase()));G.every(fe=>!fe.version)&&(ae=ae.withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties,s.IncludeLatestVersionOnly));const{galleryExtensions:ue}=await this.queryGallery(ae,t,L.CancellationToken.None);for(let fe=0;fe<ue.length;fe++){const de=ue[fe];if(!de.versions.length)continue;const Ie=(0,g.getGalleryExtensionId)(de.publisher.publisherName,de.extensionName),Ce=G.find(Ee=>(0,g.areSameExtensions)(Ee,{id:Ie}))?.version;if(Ce){const Ee=de.versions.find(_e=>_e.version===Ce);Ee&&re.push(j(de,Ee,x(de),fe,ae))}else re.push(K(de,fe,ae,void 0,t))}return re}async getCompatibleExtension(G,ie){const re=(0,I.isIExtensionIdentifier)(G)?null:G;if(re){if((0,I.isNotWebExtensionInWebTargetPlatform)(re.allTargetPlatforms,ie))return null;if(await this.isExtensionCompatible(re,ie))return re}const{id:ae,uuid:ue}=re?re.identifier:G;let fe=new m().withFlags(s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");ue?fe=fe.withFilter(i.ExtensionId,ue):fe=fe.withFilter(i.ExtensionName,ae);const{galleryExtensions:de}=await this.queryGallery(fe,ie,L.CancellationToken.None),[Ie]=de;if(!Ie||!Ie.versions.length)return null;const Ce=x(Ie);if((0,I.isNotWebExtensionInWebTargetPlatform)(Ce,ie))return null;for(let Ee of Ie.versions){if(!U(Ee)){const _e=await this.getEngine(Ee);Ee={...Ee,properties:[...Ee.properties||[],{key:o.Engine,value:_e}]}}if(await this.isRawExtensionVersionCompatible(Ee,Ce,ie))return j(Ie,Ee,Ce,0,fe)}return null}async isExtensionCompatible(G,ie){if(!(0,I.isTargetPlatformCompatible)(G.properties.targetPlatform,G.allTargetPlatforms,ie))return!1;let re=G.properties.engine;if(!re){const ae=await this.getManifest(G,L.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");re=ae.engines.vscode}return(0,w.isEngineValid)(re,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(G,ie,re){if(!(0,I.isTargetPlatformCompatible)(q(G),ie,re))return!1;const ae=await this.getEngine(G);return(0,w.isEngineValid)(ae,this.productService.version,this.productService.date)}async query(G,ie){const re=L.CancellationToken.isCancellationToken(G)?{}:G,ae=L.CancellationToken.isCancellationToken(G)?G:ie;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let ue=re.text||"";const fe=(0,T.getOrDefault)(re,Pe=>Pe.pageSize,50);let de=new m().withFlags(s.IncludeLatestVersionOnly,s.IncludeAssetUri,s.IncludeStatistics,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,fe).withFilter(i.Target,"Microsoft.VisualStudio.Code");ue?(ue=ue.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,ke,Fe)=>(de=de.withFilter(i.Category,Fe||ke),"")),ue=ue.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Pe,ke,Fe)=>(de=de.withFilter(i.Tag,Fe||ke),"")),ue=ue.replace(/\bfeatured(\s+|\b|$)/g,()=>(de=de.withFilter(i.Featured),"")),ue=ue.trim(),ue&&(ue=ue.length<200?ue:ue.substring(0,200),de=de.withFilter(i.SearchText,ue)),de=de.withSortBy(0)):re.ids?de=de.withFilter(i.ExtensionId,...re.ids):re.names?de=de.withFilter(i.ExtensionName,...re.names):de=de.withSortBy(4),typeof re.sortBy=="number"&&(de=de.withSortBy(re.sortBy)),typeof re.sortOrder=="number"&&(de=de.withSortOrder(re.sortOrder));const{galleryExtensions:Ie,total:Ce}=await this.queryGallery(de,t,ae),Ee=Ie.map((Pe,ke)=>K(Pe,ke,de,re.source,t)),_e=async(Pe,ke)=>{if(ke.isCancellationRequested)throw(0,R.canceled)();const Fe=de.withPage(Pe+1),{galleryExtensions:$e}=await this.queryGallery(Fe,t,ke);return $e.map((Ne,qe)=>K(Ne,qe,Fe,re.source,t))};return{firstPage:Ee,total:Ce,pageSize:de.pageSize,getPage:_e}}async queryGallery(G,ie,re){if(!this.isEnabled())throw new Error("No extension gallery service configured.");G=G.withFlags(G.flags,s.ExcludeNonValidated).withFilter(i.ExcludeWithFlags,r(s.Unpublished));const ae=await this.commonHeadersPromise,ue=JSON.stringify(G.raw),fe={...ae,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ue.length)},de=new Date().getTime();let Ie,Ce,Ee=0;try{if(Ie=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ue,headers:fe},re),Ie.res.statusCode&&Ie.res.statusCode>=400&&Ie.res.statusCode<500)return{galleryExtensions:[],total:Ee};const _e=await(0,b.asJson)(Ie);if(_e){const Pe=_e.results[0],ke=Pe.extensions;ke.forEach($e=>F($e.versions,ie));const Fe=Pe.resultMetadata&&Pe.resultMetadata.filter($e=>$e.metadataType==="ResultCount")[0];return Ee=Fe&&Fe.metadataItems.filter($e=>$e.name==="TotalCount")[0].count||0,{galleryExtensions:ke,total:Ee}}return{galleryExtensions:[],total:Ee}}catch(_e){throw Ce=_e,_e}finally{this.telemetryService.publicLog2("galleryService:query",{...G.telemetryData,requestBodySize:String(ue.length),duration:new Date().getTime()-de,success:!!Ie&&(0,b.isSuccess)(Ie),responseBodySize:Ie?.res.headers["Content-Length"],statusCode:Ie?String(Ie.res.statusCode):void 0,errorCode:Ce?(0,R.isPromiseCanceledError)(Ce)?"canceled":(0,R.getErrorMessage)(Ce).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ee)})}}async reportStatistic(G,ie,re,ae){if(!this.isEnabled())return;const ue=k.isWeb?this.api(`/itemName/${G}.${ie}/version/${re}/statType/${ae==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${G}/extensions/${ie}/${re}/stats?statType=${ae}`),fe=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ie={...await this.commonHeadersPromise,Accept:fe};try{await this.requestService.request({type:"POST",url:ue,headers:Ie},L.CancellationToken.None)}catch(Ce){}}async download(G,ie,re){this.logService.trace("ExtensionGalleryService#download",G.identifier.id);const ae=(0,g.getGalleryExtensionTelemetryData)(G),ue=new Date().getTime(),fe=Ee=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ae,duration:Ee}),de=re===1?"install":re===2?"update":"",Ie=de?{uri:`${G.assets.download.uri}${S.URI.parse(G.assets.download.uri).query?"&":"?"}${de}=true`,fallbackUri:`${G.assets.download.fallbackUri}${S.URI.parse(G.assets.download.fallbackUri).query?"&":"?"}${de}=true`}:G.assets.download,Ce=await this.getAsset(Ie);await this.fileService.writeFile(ie,Ce.stream),fe(new Date().getTime()-ue)}async getReadme(G,ie){if(G.assets.readme){const re=await this.getAsset(G.assets.readme,{},ie);return await(0,b.asText)(re)||""}return""}async getManifest(G,ie){if(G.assets.manifest){const re=await this.getAsset(G.assets.manifest,{},ie),ae=await(0,b.asText)(re);return ae?JSON.parse(ae):null}return null}async getManifestFromRawExtensionVersion(G,ie){const re=M(G,a.Manifest);if(!re)throw new Error("Manifest was not found");const ae={"Accept-Encoding":"gzip"},ue=await this.getAsset(re,{headers:ae});return await(0,b.asJson)(ue)}async getCoreTranslation(G,ie){const re=G.assets.coreTranslations.filter(ae=>ae[0]===ie.toUpperCase())[0];if(re){const ae=await this.getAsset(re[1]),ue=await(0,b.asText)(ae);return ue?JSON.parse(ue):null}return null}async getChangelog(G,ie){if(G.assets.changelog){const re=await this.getAsset(G.assets.changelog,{},ie);return await(0,b.asText)(re)||""}return""}async getAllCompatibleVersions(G,ie){let re=new m().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1).withFilter(i.Target,"Microsoft.VisualStudio.Code");G.identifier.uuid?re=re.withFilter(i.ExtensionId,G.identifier.uuid):re=re.withFilter(i.ExtensionName,G.identifier.id);const{galleryExtensions:ae}=await this.queryGallery(re,ie,L.CancellationToken.None);if(!ae.length)return[];const ue=x(ae[0]);if((0,I.isNotWebExtensionInWebTargetPlatform)(ue,ie))return[];const fe=[];for(const de of ae[0].versions)try{fe[fe.length-1]?.version!==de.version&&await this.isRawExtensionVersionCompatible(de,ue,ie)&&fe.push({version:de.version,date:de.lastUpdated})}catch(Ie){}return fe}async getAsset(G,ie={},re=L.CancellationToken.None){const ae=await this.commonHeadersPromise,ue={type:"GET"},fe={...ae,...ie.headers||{}};ie={...ie,...ue,headers:fe};const de=G.uri,Ie=G.fallbackUri,Ce={...ie,url:de};try{const Ee=await this.requestService.request(Ce,re);if(Ee.res.statusCode===200)return Ee;const _e=await(0,b.asText)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${_e}`)}catch(Ee){if((0,R.isPromiseCanceledError)(Ee))throw Ee;const _e=(0,R.getErrorMessage)(Ee);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:de,message:_e});const Pe={...ie,url:Ie};return this.requestService.request(Pe,re)}}async getEngine(G){let ie=U(G);if(!ie){const re=await this.getManifestFromRawExtensionVersion(G,L.CancellationToken.None);if(!re)throw new Error("Manifest was not found");ie=re.engines.vscode}return ie}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const G=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(G.res.statusCode!==200)throw new Error("Could not get extensions report.");const ie=await(0,b.asJson)(G),re=new Map;if(ie)for(const ae of ie.malicious){const ue=re.get(ae)||{id:{id:ae},malicious:!0,slow:!1};ue.malicious=!0,re.set(ae,ue)}return[...re.values()]}};z=he([Q(1,b.IRequestService),Q(2,p.ILogService),Q(3,n.IEnvironmentService),Q(4,l.ITelemetryService),Q(5,f.IFileService),Q(6,d.IProductService),Q(7,E.IConfigurationService)],z);let B=class extends z{constructor(G,ie,re,ae,ue,fe,de,Ie){super(G,ie,re,ae,ue,fe,de,Ie)}};B=he([Q(0,v.IStorageService),Q(1,b.IRequestService),Q(2,p.ILogService),Q(3,n.IEnvironmentService),Q(4,l.ITelemetryService),Q(5,f.IFileService),Q(6,d.IProductService),Q(7,E.IConfigurationService)],B),e.ExtensionGalleryService=B;let X=class extends z{constructor(G,ie,re,ae,ue,fe,de){super(void 0,G,ie,re,ae,ue,fe,de)}};X=he([Q(0,b.IRequestService),Q(1,p.ILogService),Q(2,n.IEnvironmentService),Q(3,l.ITelemetryService),Q(4,f.IFileService),Q(5,d.IProductService),Q(6,E.IConfigurationService)],X),e.ExtensionGalleryServiceWithNoStorageService=X;async function Z(V,G,ie,re,ae,ue){const fe={"X-Market-Client-Id":`VSCode ${V}`,"User-Agent":`VSCode ${V}`},de=await(0,y.getServiceMachineId)(ie,ae,ue);return(0,c.supportsTelemetry)(G,ie)&&(0,c.getTelemetryLevel)(re)===3&&(fe["X-Market-User-Id"]=de),fe}e.resolveMarketplaceHeaders=Z}),define(te[92],ne([0,1,2,13,10,46]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let k=class extends D.Disposable{constructor(S,E,n=""){super();this.prefix=n;const I=S.getLogger(E.telemetryLogResource);I?this.logger=this._register(I):(this.logger=this._register(S.createLogger(E.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(S,E){this.logger.trace(`${this.prefix}telemetry/${S}`,(0,T.validateTelemetryData)(E))}};k=he([Q(0,R.ILoggerService),Q(1,L.IEnvironmentService)],k),e.TelemetryLogAppender=k}),define(te[93],ne([0,1,2,26,4,25,139,20,39,42,34,21,46]),function(J,e,D,L,R,T,k,C,S,E,n,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let w=class{constructor(d,b){this._configurationService=b,this._experimentProperties={},this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=d.appenders,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let y of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,T.escapeRegExpCharacters)(y),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(y=>{const v=/^[a-f0-9]+$/i.test(y["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!v})})}setExperimentProperty(d,b){this._experimentProperties[d]=b}_updateTelemetryLevel(){this._telemetryLevel=(0,g.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const d=await this._commonProperties;let b=d.sessionID,y=d["common.instanceId"],v=d["common.machineId"],l=d["common.firstSessionDate"],c=d["common.msftInternal"];return{sessionId:b,instanceId:y,machineId:v,firstSessionDate:l,msftInternal:c}}dispose(){this._disposables.dispose()}_log(d,b,y,v){return this.telemetryLevel<b?Promise.resolve(void 0):this._commonProperties.then(l=>{y=(0,L.mixin)(y,l),y=(0,L.mixin)(y,this._experimentProperties),y=(0,L.cloneAndChange)(y,c=>{if(typeof c=="string")return this._cleanupInfo(c,v)}),this._appenders.forEach(c=>c.log(d,y))},l=>{console.error(l)})}publicLog(d,b,y){return this._log(d,3,b,y)}publicLog2(d,b,y){return this.publicLog(d,b,y)}publicLogError(d,b){return this.sendErrorTelemetry?this._log(d,2,b,!0):Promise.resolve(void 0)}publicLogError2(d,b){return this.publicLogError(d,b)}_anonymizeFilePaths(d){let b=d;const y=[];for(let t of this._cleanupPatterns)for(;;){const s=t.exec(d);if(!s)break;y.push([s.index,t.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(b="";;){const t=l.exec(d);if(!t)break;!v.test(t[0])&&y.every(([s,r])=>t.index<s||t.index>=r)&&(b+=d.substring(c,t.index)+"<REDACTED: user-file-path>",c=l.lastIndex)}return c<d.length&&(b+=d.substr(c)),b}_removePropertiesWithPossibleUserInfo(d){if(!d)return d;const b=d.toLowerCase(),y=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(b)?"<REDACTED: secret>":y.test(b)?"<REDACTED: email>":d}_cleanupInfo(d,b){let y=d;b&&(y=this._anonymizeFilePaths(y));for(let v of this._cleanupPatterns)y=y.replace(v,"");return y=this._removePropertiesWithPossibleUserInfo(y),y}};w.IDLE_START_EVENT_NAME="UserIdleStart",w.IDLE_STOP_EVENT_NAME="UserIdleStop",w=he([Q(1,C.IConfigurationService)],w),e.TelemetryService=w;const f=R.isWeb?"":" "+(0,k.localize)(0,null);n.Registry.as(S.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(1,null),properties:{[I.TELEMETRY_SETTING_ID]:{type:"string",enum:["on","error","off"],enumDescriptions:[(0,k.localize)(2,null),(0,k.localize)(3,null),(0,k.localize)(4,null)],markdownDescription:E.default.privacyStatementUrl?(0,k.localize)(6,null,E.default.nameLong,E.default.privacyStatementUrl)+f:(0,k.localize)(5,null,E.default.nameLong)+f,default:"on",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),n.Registry.as(S.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(7,null),properties:{[I.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,k.localize)(9,null,E.default.nameLong,E.default.privacyStatementUrl):(0,k.localize)(8,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(10,null,`\`#${I.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[201],ne([0,1,9,26,46]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function T(C){const S=await new Promise((n,I)=>{J(["applicationinsights"],n,I)});let E;return S.defaultClient?(E=new S.TelemetryClient(C),E.channel.setUseDiskRetryCaching(!0)):(S.setup(C).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),E=S.defaultClient),C.indexOf("AIF-")===0&&(E.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),E}class k{constructor(S,E,n){this._eventPrefix=S,this._defaultData=E,this._defaultData||(this._defaultData=Object.create(null)),typeof n=="function"?this._aiClient=n():this._aiClient=n,this._asyncAIClient=null}_withAIClient(S){if(!!this._aiClient){if(typeof this._aiClient!="string"){S(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=T(this._aiClient)),this._asyncAIClient.then(E=>{S(E)},E=>{(0,D.onUnexpectedError)(E),console.error(E)})}}log(S,E){!this._aiClient||(E=(0,L.mixin)(E,this._defaultData),E=(0,R.validateTelemetryData)(E),this._withAIClient(n=>n.trackEvent({name:this._eventPrefix+"/"+S,properties:E.properties,measurements:E.measurements})))}flush(){return this._aiClient?new Promise(S=>{this._withAIClient(E=>{E.flush({callback:()=>{this._aiClient=void 0,S(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=k}),define(te[202],ne([0,1,15,52,20,13,10,21,91,92,93]),function(J,e,D,L,R,T,k,C,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let I=class{constructor(w,f,p,d){this.configurationService=w,this.telemetryService=f,this.loggerService=p,this.environmentService=d,this.customTelemetryServices=new Map}async getCustomTelemetryService(w){if(!this.customTelemetryServices.has(w.id)){const{machineId:f,sessionId:p}=await this.telemetryService.getTelemetryInfo(),d=Object.create(null);d["common.vscodemachineid"]=f,d["common.vscodesessionid"]=p;const b=[w.id,JSON.stringify(d),w.aiKey],v=new L.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:b,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),l=[new S.TelemetryAppenderClient(v),new E.TelemetryLogAppender(this.loggerService,this.environmentService,`[${w.id}] `)];this.customTelemetryServices.set(w.id,new n.TelemetryService({appenders:l,sendErrorTelemetry:w.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(w.id)}async publicLog(w,f,p){await(await this.getCustomTelemetryService(w)).publicLog(f,p)}async publicLogError(w,f,p){await(await this.getCustomTelemetryService(w)).publicLogError(f,p)}};I=he([Q(0,R.IConfigurationService),Q(1,C.ITelemetryService),Q(2,k.ILoggerService),Q(3,T.IEnvironmentService)],I),e.CustomEndpointTelemetryService=I}),define(te[203],ne([0,1,6,27,3,2,10]),function(J,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let C=class extends T.Disposable{constructor(E,n){super();this._logService=n,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new R.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=E===void 0?15e3:E}createRequest(E){return new Promise((n,I)=>{const g=++this._lastRequestId;this._pendingRequests.set(g,n),this._onCreateRequest.fire({requestId:g,...E});const w=new L.CancellationTokenSource;(0,D.timeout)(this._timeout,w.token).then(()=>I(`Request ${g} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(g,[(0,T.toDisposable)(()=>w.cancel())])})}acceptReply(E,n){const I=this._pendingRequests.get(E);I?(this._pendingRequests.delete(E),(0,T.dispose)(this._pendingRequestDisposables.get(E)||[]),this._pendingRequestDisposables.delete(E),I(n)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${E}`)}};C=he([Q(1,k.ILogService)],C),e.RequestStore=C}),define(te[94],ne([0,1,5]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var L;(function(d){d.Shell="terminal.integrated.shell.",d.ShellArgs="terminal.integrated.shellArgs.",d.DefaultProfile="terminal.integrated.defaultProfile.",d.Profiles="terminal.integrated.profiles."})(L=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var R;(function(d){d.ShellLinux="terminal.integrated.shell.linux",d.ShellMacOs="terminal.integrated.shell.osx",d.ShellWindows="terminal.integrated.shell.windows",d.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",d.AutomationShellLinux="terminal.integrated.automationShell.linux",d.AutomationShellMacOs="terminal.integrated.automationShell.osx",d.AutomationShellWindows="terminal.integrated.automationShell.windows",d.ShellArgsLinux="terminal.integrated.shellArgs.linux",d.ShellArgsMacOs="terminal.integrated.shellArgs.osx",d.ShellArgsWindows="terminal.integrated.shellArgs.windows",d.ProfilesWindows="terminal.integrated.profiles.windows",d.ProfilesMacOs="terminal.integrated.profiles.osx",d.ProfilesLinux="terminal.integrated.profiles.linux",d.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",d.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",d.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",d.UseWslProfiles="terminal.integrated.useWslProfiles",d.TabsEnabled="terminal.integrated.tabs.enabled",d.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",d.TabsHideCondition="terminal.integrated.tabs.hideCondition",d.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",d.TabsShowActions="terminal.integrated.tabs.showActions",d.TabsLocation="terminal.integrated.tabs.location",d.TabsFocusMode="terminal.integrated.tabs.focusMode",d.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",d.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",d.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",d.CopyOnSelection="terminal.integrated.copyOnSelection",d.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",d.FontFamily="terminal.integrated.fontFamily",d.FontSize="terminal.integrated.fontSize",d.LetterSpacing="terminal.integrated.letterSpacing",d.LineHeight="terminal.integrated.lineHeight",d.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",d.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",d.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",d.BellDuration="terminal.integrated.bellDuration",d.FontWeight="terminal.integrated.fontWeight",d.FontWeightBold="terminal.integrated.fontWeightBold",d.CursorBlinking="terminal.integrated.cursorBlinking",d.CursorStyle="terminal.integrated.cursorStyle",d.CursorWidth="terminal.integrated.cursorWidth",d.Scrollback="terminal.integrated.scrollback",d.DetectLocale="terminal.integrated.detectLocale",d.DefaultLocation="terminal.integrated.defaultLocation",d.GpuAcceleration="terminal.integrated.gpuAcceleration",d.TerminalTitleSeparator="terminal.integrated.tabs.separator",d.TerminalTitle="terminal.integrated.tabs.title",d.TerminalDescription="terminal.integrated.tabs.description",d.RightClickBehavior="terminal.integrated.rightClickBehavior",d.Cwd="terminal.integrated.cwd",d.ConfirmOnExit="terminal.integrated.confirmOnExit",d.ConfirmOnKill="terminal.integrated.confirmOnKill",d.EnableBell="terminal.integrated.enableBell",d.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",d.AllowChords="terminal.integrated.allowChords",d.AllowMnemonics="terminal.integrated.allowMnemonics",d.EnvMacOs="terminal.integrated.env.osx",d.EnvLinux="terminal.integrated.env.linux",d.EnvWindows="terminal.integrated.env.windows",d.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",d.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",d.ShowExitAlert="terminal.integrated.showExitAlert",d.SplitCwd="terminal.integrated.splitCwd",d.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",d.WordSeparators="terminal.integrated.wordSeparators",d.EnableFileLinks="terminal.integrated.enableFileLinks",d.UnicodeVersion="terminal.integrated.unicodeVersion",d.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",d.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",d.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",d.LocalEchoStyle="terminal.integrated.localEchoStyle",d.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",d.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",d.CustomGlyphs="terminal.integrated.customGlyphs",d.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",d.InheritEnv="terminal.integrated.inheritEnv",d.ShowLinkHover="terminal.integrated.showLinkHover"})(R=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(d){d.CommandPrompt="cmd",d.PowerShell="pwsh",d.Wsl="wsl",d.GitBash="gitbash"})(T=e.WindowsShellType||(e.WindowsShellType={}));var k;(function(d){d[d.Api=0]="Api",d[d.Process=1]="Process",d[d.Sequence=2]="Sequence",d[d.Config=3]="Config"})(k=e.TitleEventSource||(e.TitleEventSource={}));var C;(function(d){d.LocalPty="localPty",d.PtyHost="ptyHost",d.Log="log",d.Heartbeat="heartbeat"})(C=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var S;(function(d){d.Cwd="cwd",d.InitialCwd="initialCwd",d.FixedDimensions="fixedDimensions"})(S=e.ProcessPropertyType||(e.ProcessPropertyType={}));var E;(function(d){d[d.BeatInterval=5e3]="BeatInterval",d[d.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",d[d.SecondWaitMultiplier=1]="SecondWaitMultiplier",d[d.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E=e.HeartbeatConstants||(e.HeartbeatConstants={}));var n;(function(d){d[d.Panel=1]="Panel",d[d.Editor=2]="Editor"})(n=e.TerminalLocation||(e.TerminalLocation={}));var I;(function(d){d.TerminalView="view",d.Editor="editor"})(I=e.TerminalLocationString||(e.TerminalLocationString={}));var g;(function(d){d.CwdDetection="cwdDetection"})(g=e.ProcessCapability||(e.ProcessCapability={}));var w;(function(d){d[d.GraceTime=6e4]="GraceTime",d[d.ShortGraceTime=6e3]="ShortGraceTime"})(w=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var f;(function(d){d[d.HighWatermarkChars=1e5]="HighWatermarkChars",d[d.LowWatermarkChars=5e3]="LowWatermarkChars",d[d.CharCountAckSize=5e3]="CharCountAckSize"})(f=e.FlowControlConstants||(e.FlowControlConstants={}));var p;(function(d){d.GitBash="Git Bash",d.Pwsh="PowerShell"})(p=e.ProfileSource||(e.ProfileSource={}))}),define(te[204],ne([0,1,5]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(te[205],ne([0,1,32,26,8,4,31,18,19]),function(J,e,D,L,R,T,k,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function E(){const I=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let g=0;return I&&I.length===4&&(g=parseInt(I[3])),g}e.getWindowsBuildNumber=E;async function n(I,g,w,f=k.env,p=S.Promises.exists){if(R.isAbsolute(I))return await p(I)?I:void 0;if(g===void 0&&(g=k.cwd()),R.dirname(I)!=="."){const v=R.join(g,I);return await p(v)?v:void 0}const b=(0,L.getCaseInsensitive)(f,"PATH");if(w===void 0&&(0,C.isString)(b)&&(w=b.split(R.delimiter)),w===void 0||w.length===0){const v=R.join(g,I);return await p(v)?v:void 0}for(let v of w){let l;if(R.isAbsolute(v)?l=R.join(v,I):l=R.join(g,v,I),await p(l))return l;if(T.isWindows){let c=l+".com";if(await p(c)||(c=l+".exe",await p(c)))return c}}const y=R.join(g,I);return await p(y)?y:void 0}e.findExecutable=n}),define(te[206],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var D;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(D=e.ColorScheme||(e.ColorScheme={}))}),define(te[95],ne([0,1,49,3,2,5,34,206]),function(J,e,D,L,R,T,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var S;(function(d){function b(y){return y&&typeof y=="object"&&typeof y.id=="string"}d.isThemeColor=b})(S=e.ThemeColor||(e.ThemeColor={}));function E(d){return{id:d}}e.themeColorFromId=E;var n;(function(d){function b(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||S.isThemeColor(s.color))}d.isThemeIcon=b;const y=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function v(s){const r=y.exec(s);if(!r)return;let[,i]=r;return{id:i}}d.fromString=v;function l(s,r){let i=s.id;const a=i.lastIndexOf("~");return a!==-1&&(i=i.substring(0,a)),r&&(i=`${i}~${r}`),{id:i}}d.modify=l;function c(s,r){return s.id===r.id&&s.color?.id===r.color?.id}d.isEqual=c;function t(s,r){return{id:s.id,color:r?E(r):void 0}}d.asThemeIcon=t,d.asClassNameArray=D.CSSIcon.asClassNameArray,d.asClassName=D.CSSIcon.asClassName,d.asCSSSelector=D.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function I(d){switch(d){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),(0,R.toDisposable)(()=>{const y=this.themingParticipants.indexOf(b);this.themingParticipants.splice(y,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let w=new g;k.Registry.add(e.Extensions.ThemingContribution,w);function f(d){return w.onColorThemeChange(d)}e.registerThemingParticipant=f;class p extends R.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(y=>this.onThemeChange(y)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,y){let v=this.theme.getColor(b);return v&&y&&(v=y(v,this.theme)),v?v.toString():null}}e.Themable=p}),define(te[207],ne([0,1,49,95]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProfileSchemaEnums=void 0;function R(C,S){const E=C.map(n=>({name:n.profileName,description:T(n)}));return S&&E.push(...S.map(n=>({name:n.title,description:k(n)}))),{values:E.map(n=>n.name),markdownDescriptions:E.map(n=>n.description)}}e.createProfileSchemaEnums=R;function T(C){let S=`$(${L.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:D.Codicon.terminal.id}) ${C.profileName}
- path: ${C.path}`;return C.args&&(typeof C.args=="string"?S+=`
- args: "${C.args}"`:S+=`
- args: [${C.args.length===0?"":`'${C.args.join("','")}'`}]`),C.overrideName!==void 0&&(S+=`
- overrideName: ${C.overrideName}`),C.color&&(S+=`
- color: ${C.color}`),C.env&&(S+=`
- env: ${JSON.stringify(C.env)}`),S}function k(C){return`$(${L.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:D.Codicon.terminal.id}) ${C.title}
- extensionIdenfifier: ${C.extensionIdentifier}`}}),define(te[208],ne([0,1,49,140,39,34,207]),function(J,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const C={args:{description:(0,L.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,L.localize)(1,null),type:"boolean"},icon:{description:(0,L.localize)(2,null),type:"string",enum:Array.from(D.iconRegistry.all,d=>d.id),markdownEnumDescriptions:Array.from(D.iconRegistry.all,d=>`$(${d.id})`)},color:{description:(0,L.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,L.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},S={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(5,null),type:["string","array"],items:{type:"string"}},...C}},E=(0,L.localize)(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),n=(0,L.localize)(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),I=(0,L.localize)(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),g={id:"terminal",order:100,title:(0,L.localize)(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:n},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(15,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:n},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,L.localize)(19,null)}},{type:"string",markdownDescription:(0,L.localize)(20,null)}],default:[],markdownDeprecationMessage:I},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,L.localize)(22,null),enum:["PowerShell","Git Bash"]},...C}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(23,null),type:"string"},id:{description:(0,L.localize)(24,null),type:"string"},title:{description:(0,L.localize)(25,null),type:"string"},...C}},{type:"null"},S]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(26,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(27,null),type:"string"},id:{description:(0,L.localize)(28,null),type:"string"},title:{description:(0,L.localize)(29,null),type:"string"},...C}},{type:"null"},S]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(30,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,L.localize)(31,null),type:"string"},id:{description:(0,L.localize)(32,null),type:"string"},title:{description:(0,L.localize)(33,null),type:"string"},...C}},{type:"null"},S]}},["terminal.integrated.useWslProfiles"]:{description:(0,L.localize)(34,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,L.localize)(35,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,L.localize)(36,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,L.localize)(37,null),type:"boolean",default:!0}}};function w(){T.Registry.as(R.Extensions.Configuration).registerConfiguration(g),p()}e.registerTerminalPlatformConfiguration=w;let f;function p(d,b){const y=T.Registry.as(R.Extensions.Configuration);let v;d&&(v=(0,k.createProfileSchemaEnums)(d?.profiles,b));const l=f;f={id:"terminal",order:100,title:(0,L.localize)(38,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(39,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:d?.os===3?v?.values:void 0,markdownEnumDescriptions:d?.os===3?v?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(40,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:d?.os===2?v?.values:void 0,markdownEnumDescriptions:d?.os===2?v?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(41,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:d?.os===1?v?.values:void 0,markdownEnumDescriptions:d?.os===1?v?.markdownDescriptions:void 0}}},y.updateConfigurations({add:[f],remove:l?[l]:[]})}e.registerTerminalDefaultProfileConfiguration=p}),define(te[209],ne([0,1,37,49,8,4,19,71,205,95]),function(J,e,D,L,R,T,k,C,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let n;function I(t,s,r,i,a=process.env,o,u,h,m){return o=o||{existsFile:k.SymlinkSupport.existsFile,readFile:k.Promises.readFile},T.isWindows?g(r,o,a,u,i.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:i.getValue("terminal.integrated.profiles.windows"),typeof s=="string"?s:i.getValue("terminal.integrated.defaultProfile.windows"),m,h):v(o,u,r,t&&typeof t=="object"?{...t}:i.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof s=="string"?s:i.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),m,h,a)}e.detectAvailableProfiles=I;async function g(t,s,r,i,a,o,u,h,m){const A=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),_=`${process.env.windir}\\${A?"Sysnative":"System32"}`;let O=!1;(0,S.getWindowsBuildNumber)()>=16299&&(O=!0),await p(h);const N=new Map;t&&(N.set("PowerShell",{source:"PowerShell",icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),N.set("Windows PowerShell",{path:`${_}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:L.Codicon.terminalPowershell,isAutoDetected:!0}),N.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),N.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),N.set("Command Prompt",{path:`${_}\\cmd.exe`,icon:L.Codicon.terminalCmd,isAutoDetected:!0})),l(o,N);const P=await w(N.entries(),u,s,r,i,m);if(t||!t&&a)try{const M=await b(`${_}\\${O?"wsl":"bash"}.exe`,u);for(const $ of M)(!o||!($.profileName in o))&&P.push($)}catch(M){i?.info("WSL is not installed, so could not detect WSL profiles")}return P}async function w(t,s,r,i=process.env,a,o){const u=[];for(const[h,m]of t){if(m===null)continue;let A,_,O;if("source"in m){const M=n?.get(m.source);if(!M)continue;A=M.paths,_=m.args||M.args,m.icon?O=f(m.icon):M.icon&&(O=M.icon)}else A=Array.isArray(m.path)?m.path:[m.path],_=T.isWindows||Array.isArray(m.args)?m.args:void 0,O=f(m.icon)||void 0;const N=await o?.(A)||A.slice(),P=await c(h,s,N,r,i,_,m.env,m.overrideName,m.isAutoDetected,a);P?(P.isAutoDetected=m.isAutoDetected,P.icon=O,P.color=m.color,u.push(P)):a?.trace("profile not validated",h,A)}return u}function f(t){return typeof t=="string"?{id:t}:t}async function p(t){n&&!t||(n=new Map,n.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),n.set("PowerShell",{profileName:"PowerShell",paths:t||await d(),icon:E.ThemeIcon.asThemeIcon(L.Codicon.terminalPowershell)}))}async function d(){const t=[];for await(const s of(0,C.enumeratePowerShellInstallations)())t.push(s.exePath);return t}async function b(t,s){const r=[],i=await new Promise((u,h)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le"},(m,A)=>{if(m)return h("Problem occurred when getting wsl distros");u(A)})});if(!i)return[];const a=new RegExp(/[\r?\n]/),o=i.split(a).filter(u=>u.trim().length>0&&u!=="");for(const u of o){if(u===""||u.startsWith("docker-desktop"))continue;const h=`${u} (WSL)`,m={profileName:h,path:t,args:["-d",`${u}`],isDefault:h===s,icon:y(u)};r.push(m)}return r}function y(t){return t.includes("Ubuntu")?E.ThemeIcon.asThemeIcon(L.Codicon.terminalUbuntu):t.includes("Debian")?E.ThemeIcon.asThemeIcon(L.Codicon.terminalDebian):E.ThemeIcon.asThemeIcon(L.Codicon.terminalLinux)}async function v(t,s,r,i,a,o,u,h){const m=new Map;if(r){const A=(await t.readFile("/etc/shells")).toString(),_=o||A.split(`
`).filter(N=>N.trim().indexOf("#")!==0&&N.trim().length>0),O=new Map;for(const N of _){let P=(0,R.basename)(N),M=O.get(P)||0;M++,M>1&&(P=`${P} (${M})`),O.set(P,M),m.set(P,{path:N,isAutoDetected:!0})}}return l(i,m),await w(m.entries(),a,t,h,s,u)}function l(t,s){if(!!t)for(const[r,i]of Object.entries(t))i===null||!("path"in i)&&!("source"in i)?s.delete(r):s.set(r,i)}async function c(t,s,r,i,a,o,u,h,m,A){if(r.length===0)return Promise.resolve(void 0);const _=r.shift();if(_==="")return c(t,s,r,i,a,o,u,h,m);const O={profileName:t,path:_,args:o,env:u,overrideName:h,isAutoDetected:m,isDefault:t===s};if((0,R.basename)(_)===_){const P=a.PATH?a.PATH.split(R.delimiter):void 0;return await(0,S.findExecutable)(_,void 0,P,void 0,i.existsFile)?O:c(t,s,r,i,a,o)}return await i.existsFile((0,R.normalize)(_))?O:c(t,s,r,i,a,o,u,h,m)}}),define(te[210],ne([0,1,3,2,15,4,33,52,20,13,75,164,10,85,21,203,94,208,209]),function(J,e,D,L,R,T,k,C,S,E,n,I,g,w,f,p,d,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var v;(function(t){t[t.MaxRestarts=5]="MaxRestarts"})(v||(v={}));let l=0,c=class extends L.Disposable{constructor(s,r,i,a,o){super();this._reconnectConstants=s,this._configurationService=r,this._environmentService=i,this._logService=a,this._telemetryService=o,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new D.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new D.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new D.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new D.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onProcessDidChangeHasChildProcesses=this._register(new D.Emitter),this.onProcessDidChangeHasChildProcesses=this._onProcessDidChangeHasChildProcesses.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,(0,b.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,L.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new p.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost()}async _resolveShellEnv(){if(T.isWindows)return process.env;try{return await(0,I.resolveShellEnv)(this._logService,{_:[]},process.env)}catch(s){return this._logService.error("ptyHost was unable to resolve shell environment",s),{}}}_startPtyHost(){const s={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:l,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},r=(0,n.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);r&&(r.break&&r.port?s.debugBrk=r.port:!r.break&&r.port&&(s.debug=r.port));const i=new C.Client(R.FileAccess.asFileUri("bootstrap-fork",J).fsPath,s);this._onPtyHostStart.fire(),k.ProxyChannel.toService(i.getChannel(d.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(i.onDidProcessExit(h=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(h.code),this._isDisposed||(this._restartCount<=v.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${h.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${h.code}, giving up`))}));const o=i.getChannel(d.TerminalIpcChannels.Log);w.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{w.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const u=k.ProxyChannel.toService(i.getChannel(d.TerminalIpcChannels.PtyHost));return this._register(u.onProcessData(h=>this._onProcessData.fire(h))),this._register(u.onProcessExit(h=>this._onProcessExit.fire(h))),this._register(u.onProcessReady(h=>this._onProcessReady.fire(h))),this._register(u.onProcessTitleChanged(h=>this._onProcessTitleChanged.fire(h))),this._register(u.onProcessShellTypeChanged(h=>this._onProcessShellTypeChanged.fire(h))),this._register(u.onProcessOverrideDimensions(h=>this._onProcessOverrideDimensions.fire(h))),this._register(u.onProcessResolvedShellLaunchConfig(h=>this._onProcessResolvedShellLaunchConfig.fire(h))),this._register(u.onProcessDidChangeHasChildProcesses(h=>this._onProcessDidChangeHasChildProcesses.fire(h))),this._register(u.onDidChangeProperty(h=>this._onDidChangeProperty.fire(h))),this._register(u.onProcessReplay(h=>this._onProcessReplay.fire(h))),this._register(u.onProcessOrphanQuestion(h=>this._onProcessOrphanQuestion.fire(h))),this._register(u.onDidRequestDetach(h=>this._onDidRequestDetach.fire(h))),[i,u]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(s,r,i,a,o,u,h,m,A,_,O){const N=setTimeout(()=>this._handleUnresponsiveCreateProcess(),d.HeartbeatConstants.CreateProcessTimeout),P=await this._proxy.createProcess(s,r,i,a,o,u,h,m,A,_,O);return clearTimeout(N),l=Math.max(l,P),P}updateTitle(s,r,i){return this._proxy.updateTitle(s,r,i)}updateIcon(s,r,i){return this._proxy.updateIcon(s,r,i)}attachToProcess(s){return this._proxy.attachToProcess(s)}detachFromProcess(s){return this._proxy.detachFromProcess(s)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(s){return this._proxy.start(s)}shutdown(s,r){return this._proxy.shutdown(s,r)}input(s,r){return this._proxy.input(s,r)}processBinary(s,r){return this._proxy.processBinary(s,r)}resize(s,r,i){return this._proxy.resize(s,r,i)}acknowledgeDataEvent(s,r){return this._proxy.acknowledgeDataEvent(s,r)}setUnicodeVersion(s,r){return this._proxy.setUnicodeVersion(s,r)}getInitialCwd(s){return this._proxy.getInitialCwd(s)}getCwd(s){return this._proxy.getCwd(s)}getLatency(s){return this._proxy.getLatency(s)}orphanQuestionReply(s){return this._proxy.orphanQuestionReply(s)}getDefaultSystemShell(s){return this._proxy.getDefaultSystemShell(s)}async getProfiles(s,r,i,a=!1){const o=await this._shellEnv;return(0,y.detectAvailableProfiles)(r,i,a,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,s))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(s){return this._proxy.getWslPath(s)}setTerminalLayoutInfo(s){return this._proxy.setTerminalLayoutInfo(s)}async getTerminalLayoutInfo(s){return await this._proxy.getTerminalLayoutInfo(s)}async requestDetachInstance(s,r){return this._proxy.requestDetachInstance(s,r)}async acceptDetachInstanceReply(s,r){return this._proxy.acceptDetachInstanceReply(s,r)}async serializeTerminalState(s){return this._proxy.serializeTerminalState(s)}async reviveTerminalProcesses(s){return this._proxy.reviveTerminalProcesses(s)}async refreshProperty(s,r){return this._proxy.refreshProperty(s,r)}async updateProperty(s,r,i){return this._proxy.updateProperty(s,r,i)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier+d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${d.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(s,r){return this._resolveVariablesRequestStore.createRequest({workspaceId:s,originalText:r})}async acceptPtyHostResolvedVariables(s,r){this._resolveVariablesRequestStore.acceptReply(s,r)}};c=he([Q(1,S.IConfigurationService),Q(2,E.IEnvironmentService),Q(3,g.ILogService),Q(4,f.ITelemetryService)],c),e.PtyHostService=c}),define(te[54],ne([0,1,44]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function L(k,C,S,E){const n=(0,D.setProperty)(k,C,S,E)[0];return n&&(k=k.substring(0,n.offset)+n.content+k.substring(n.offset+n.length)),k}e.edit=L;function R(k,C,S){let E=S;for(;E>=0;){if(k.charAt(E)===C.charAt(C.length-1)&&C.length===1)return E+1;if(E--,C.length===2&&E>=0&&k.charAt(E)===C.charAt(0))return E+2}return 0}e.getLineStartOffset=R;function T(k,C,S){let E=S;for(;E>=0;)if(k.charAt(E)===C.charAt(C.length-1)&&C.length===1||(E++,C.length===2&&E>=0&&k.charAt(E)===C.charAt(1)))return E;return k.length-1}e.getLineEndOffset=T}),define(te[211],ne([0,1,26,60]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(I,g,w,f,p){const d=[],b=[],y=[];if(!g){const _=I.filter(({identifier:O})=>p.every(N=>N.toLowerCase()!==O.id.toLowerCase()));return{local:{added:d,removed:b,updated:y},remote:_.length>0?{added:_,updated:[],removed:[],all:_}:null}}I=I.map(E),g=g.map(E),w=w?w.map(E):null;const v=new Map,l=_=>{_.uuid&&v.set(_.id.toLowerCase(),_.uuid)};I.forEach(({identifier:_})=>l(_)),g.forEach(({identifier:_})=>l(_)),w&&w.forEach(({identifier:_})=>l(_));const c=_=>{const O=_.identifier.uuid||v.get(_.identifier.id.toLowerCase());return O?`uuid:${O}`:`id:${_.identifier.id.toLowerCase()}`},t=(_,O)=>(_.set(c(O),O),_),s=I.reduce(t,new Map),r=g.reduce(t,new Map),i=g.reduce((_,O)=>{const N=c(O);O=(0,D.deepClone)(O);const P=s.get(N);return P&&(P.installed&&(O.installed=!0),O.version||(O.version=P.version)),t(_,O)},new Map),a=w?w.reduce(t,new Map):null,o=f.reduce(t,new Map),u=p.reduce((_,O)=>{const N=v.get(O.toLowerCase());return _.add(N?`uuid:${N}`:`id:${O.toLowerCase()}`)},new Set),h=T(s,r,u);if(h.added.size>0||h.removed.size>0||h.updated.size>0){const _=T(a,s,u),O=T(a,r,u),N=(P,M)=>{const $=s.get(P);if($){const U=r.get(P);return{...M?U:$,version:(U.version&&L.gt(U.version,$.version),$.version),state:k($,U,a?.get(P))}}};for(const P of O.removed.values()){const M=s.get(P);M&&b.push(M.identifier)}for(const P of O.added.values())if(_.added.has(P)){if(h.updated.has(P)){const M=N(P,!0);M&&(y.push(n(M,P)),i.set(P,M))}}else{const M=r.get(P);M.installed&&d.push(n(M,P))}for(const P of O.updated.values()){const M=N(P,!0);M&&(y.push(n(M,P)),i.set(P,M))}for(const P of _.added.values())O.added.has(P)||i.set(P,s.get(P));for(const P of _.updated.values())if(!O.removed.has(P)&&!O.updated.has(P)){const M=N(P,!1);M&&(i.get(P)?.installed&&(M.installed=!0),i.set(P,M))}for(const P of _.removed.values())!o.has(P)&&!O.updated.has(P)&&a?.get(P)?.installed&&i.delete(P)}const m=[],A=T(r,i,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(A.added.size>0||A.updated.size>0||A.removed.size>0)&&i.forEach((_,O)=>m.push(n(_,O))),{local:{added:d,removed:b,updated:y},remote:m.length?{added:[...A.added].map(_=>i.get(_)),updated:[...A.updated].map(_=>i.get(_)),removed:[...A.removed].map(_=>r.get(_)),all:m}:null}}e.merge=R;function T(I,g,w,{checkInstalledProperty:f,checkVersionProperty:p}={checkInstalledProperty:!1,checkVersionProperty:!1}){const d=I?[...I.keys()].filter(c=>!w.has(c)):[],b=[...g.keys()].filter(c=>!w.has(c)),y=b.filter(c=>d.indexOf(c)===-1).reduce((c,t)=>(c.add(t),c),new Set),v=d.filter(c=>b.indexOf(c)===-1).reduce((c,t)=>(c.add(t),c),new Set),l=new Set;for(const c of d){if(v.has(c))continue;const t=I.get(c),s=g.get(c);(!s||t.disabled!==s.disabled||!S(t.state,s.state)||p&&t.version!==s.version||f&&t.installed!==s.installed)&&l.add(c)}return{added:y,removed:v,updated:l}}function k(I,g,w){const f=I.state,p=g.state,d=w?.state;if(!g.version||f&&L.gt(I.version,g.version))return f;if(p&&L.gt(g.version,I.version)||!f)return p;if(!p)return f;const b=(0,D.deepClone)(f),y=d?C(d,p):{added:Object.keys(p).reduce((l,c)=>(l.add(c),l),new Set),removed:new Set,updated:new Set},v=d?C(d,f):{added:Object.keys(f).reduce((l,c)=>(l.add(c),l),new Set),removed:new Set,updated:new Set};for(const l of[...y.added.values(),...y.updated.values()])b[l]=p[l];for(const l of y.removed.values())v.updated.has(l)||delete b[l];return b}function C(I,g){const w=Object.keys(I),f=Object.keys(g),p=f.filter(y=>w.indexOf(y)===-1).reduce((y,v)=>(y.add(v),y),new Set),d=w.filter(y=>f.indexOf(y)===-1).reduce((y,v)=>(y.add(v),y),new Set),b=new Set;for(const y of w){if(d.has(y))continue;const v=I[y],l=g[y];(0,D.equals)(v,l)||b.add(y)}return{added:p,removed:d,updated:b}}function S(I={},g={}){const{added:w,removed:f,updated:p}=C(I,g);return w.size===0&&f.size===0&&p.size===0}function E(I){return{...I,disabled:!!I.disabled,installed:!!I.installed}}function n(I,g){const w={identifier:{id:I.identifier.id,uuid:g.startsWith("uuid:")?g.substring("uuid:".length):void 0}};return I.version&&(w.version=I.version),I.disabled&&(w.disabled=!0),I.installed&&(w.installed=!0),I.state&&(w.state=I.state),w}}),define(te[96],ne([0,1,17,3,2,35,5,29,23]),function(J,e,D,L,R,T,k,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,k.createDecorator)("IExtensionsStorageSyncService");const E=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let n=class nt extends R.Disposable{constructor(g,w){super();this.storageService=g,this.productService=w,this._onDidChangeExtensionsStorage=this._register(new L.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(f=>this.onDidChangeStorageValue(f)))}static toKey(g){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(g.id)}@${g.version}`}static fromKey(g){const w=E.exec(g);if(w&&w[1])return{id:w[1],version:w[2]}}initialize(){const g=this.storageService.keys(0,1);for(const w of g){const f=nt.fromKey(w);f&&this.extensionsWithKeysForSync.add(f.id.toLowerCase())}}onDidChangeStorageValue(g){if(g.scope!==0)return;if(this.extensionsWithKeysForSync.has(g.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const w=nt.fromKey(g.key);if(w){this.extensionsWithKeysForSync.add(w.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(g,w){this.storageService.store(nt.toKey(g),JSON.stringify(w),0,1)}getKeysForSync(g){const w=this.productService.extensionSyncedKeys?.[g.id.toLowerCase()],f=this.storageService.get(nt.toKey(g),0),p=f?JSON.parse(f):void 0;return p&&w?(0,D.distinct)([...p,...w]):p||w}};n=he([Q(0,S.IStorageService),Q(1,C.IProductService)],n),e.ExtensionsStorageSyncService=n}),define(te[97],ne([0,1,17,20,5]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,R.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(C){this.configurationService=C}hasToNeverSyncExtension(C){return this.getConfiguredIgnoredExtensions().includes(C.toLowerCase())}hasToAlwaysSyncExtension(C){return this.getConfiguredIgnoredExtensions().includes(`-${C.toLowerCase()}`)}updateIgnoredExtensions(C,S){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return E=E.filter(n=>n!==C&&n!==`-${C}`),S&&E.push(C.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}updateSynchronizedExtensions(C,S){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return E=E.filter(n=>n!==C&&n!==`-${C}`),S&&E.push(`-${C.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}getIgnoredExtensions(C){const S=C.filter(g=>g.isMachineScoped).map(g=>g.identifier.id.toLowerCase()),E=this.getConfiguredIgnoredExtensions().map(g=>g.toLowerCase()),n=[],I=[];if(Array.isArray(E))for(const g of E)g.startsWith("-")?I.push(g.substring(1)):n.push(g);return(0,D.distinct)([...S,...n].filter(g=>I.indexOf(g)===-1))}getConfiguredIgnoredExtensions(){let C=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return C!==void 0||(C=this.configurationService.inspect("sync.ignoredExtensions").userValue,C!==void 0)?C:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(S=>S.toLowerCase())}};T=he([Q(0,L.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(te[212],ne([0,1,17,36,26,159,54]),function(J,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function C(l){return(0,L.parse)(l)||[]}e.parseKeybindings=C;async function S(l,c,t,s,r){const i=C(l),a=C(c),o=t?C(t):null,u=[...i,...a,...o||[]].map(H=>H.key),h=await r.resolveUserBindings(u);let m=n(i,a,o,h);if(!m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:l,hasChanges:!1,hasConflicts:!1};if(!m.hasLocalForwarded&&m.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};if(m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};const A=g(i),_=g(a),O=o?g(o):null,N=f(A,_,h),P=O?f(O,A,h):{added:[...A.keys()].reduce((H,W)=>(H.add(W),H),new Set),removed:new Set,updated:new Set},M=O?f(O,_,h):{added:[..._.keys()].reduce((H,W)=>(H.add(W),H),new Set),removed:new Set,updated:new Set},$=E(N,P,M);let U=l;for(const H of $.removed.values())$.conflicts.has(H)||(U=y(U,H,s));for(const H of $.added.values()){if($.conflicts.has(H))continue;const W=_.get(H);if(W.some(q=>q.command!==`-${H}`&&m.conflicts.has(h[q.key]))){$.conflicts.add(H);continue}U=b(U,W,s)}for(const H of $.updated.values()){if($.conflicts.has(H))continue;const W=_.get(H);if(W.some(q=>q.command!==`-${H}`&&m.conflicts.has(h[q.key]))){$.conflicts.add(H);continue}U=v(U,H,W,s)}return{mergeContent:U,hasChanges:!0,hasConflicts:$.conflicts.size>0}}e.merge=S;function E(l,c,t){const s=new Set,r=new Set,i=new Set,a=new Set;for(const o of c.removed.values())t.updated.has(o)&&a.add(o);for(const o of t.removed.values())a.has(o)||(c.updated.has(o)?a.add(o):r.add(o));for(const o of c.added.values())a.has(o)||t.added.has(o)&&l.updated.has(o)&&a.add(o);for(const o of t.added.values())a.has(o)||(c.added.has(o)?l.updated.has(o)&&a.add(o):s.add(o));for(const o of c.updated.values())a.has(o)||t.updated.has(o)&&l.updated.has(o)&&a.add(o);for(const o of t.updated.values())a.has(o)||(c.updated.has(o)?l.updated.has(o)&&a.add(o):i.add(o));return{added:s,removed:r,updated:i,conflicts:a}}function n(l,c,t,s){const r=new Set,i=I(l,s),a=I(c,s),o=t?I(t,s):null,u=w(i,a);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const h=o?w(o,i):{added:[...i.keys()].reduce((P,M)=>(P.add(M),P),new Set),removed:new Set,updated:new Set};if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:r,removed:r,updated:r,conflicts:r};const m=o?w(o,a):{added:[...a.keys()].reduce((P,M)=>(P.add(M),P),new Set),removed:new Set,updated:new Set};if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const{added:A,removed:_,updated:O,conflicts:N}=E(u,h,m);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:A,removed:_,updated:O,conflicts:N}}function I(l,c){const t=new Map;for(const s of l){const r=c[s.key];let i=t.get(r);i||(i=[],t.set(r,i)),i.push(s)}return t}function g(l){const c=new Map;for(const t of l){const s=t.command[0]==="-"?t.command.substring(1):t.command;let r=c.get(s);r||(r=[],c.set(s,r)),r.push(t)}return c}function w(l,c){const t=[...l.keys()],s=[...c.keys()],r=s.filter(o=>t.indexOf(o)===-1).reduce((o,u)=>(o.add(u),o),new Set),i=t.filter(o=>s.indexOf(o)===-1).reduce((o,u)=>(o.add(u),o),new Set),a=new Set;for(const o of t){if(i.has(o))continue;const u=l.get(o).map(m=>({...m,key:o})),h=c.get(o).map(m=>({...m,key:o}));(0,D.equals)(u,h,(m,A)=>d(m,A))||a.add(o)}return{added:r,removed:i,updated:a}}function f(l,c,t){const s=[...l.keys()],r=[...c.keys()],i=r.filter(u=>s.indexOf(u)===-1).reduce((u,h)=>(u.add(h),u),new Set),a=s.filter(u=>r.indexOf(u)===-1).reduce((u,h)=>(u.add(h),u),new Set),o=new Set;for(const u of s){if(a.has(u))continue;const h=l.get(u).map(A=>({...A,key:t[A.key]})),m=c.get(u).map(A=>({...A,key:t[A.key]}));p(h,m)||o.add(u)}return{added:i,removed:a,updated:o}}function p(l,c){return!(!(0,D.equals)(l.filter(({command:t})=>t[0]!=="-"),c.filter(({command:t})=>t[0]!=="-"),(t,s)=>d(t,s))||!(0,D.equals)(l.filter(({command:t})=>t[0]==="-"),c.filter(({command:t})=>t[0]==="-"),(t,s)=>d(t,s)))}function d(l,c){if(l.command!==c.command||l.key!==c.key)return!1;const t=T.ContextKeyExpr.deserialize(l.when),s=T.ContextKeyExpr.deserialize(c.when);return!(t&&!s||!t&&s||t&&s&&!t.equals(s)||!R.equals(l.args,c.args))}function b(l,c,t){for(const s of c)l=k.edit(l,[-1],s,t);return l}function y(l,c,t){const s=C(l);for(let r=s.length-1;r>=0;r--)(s[r].command===c||s[r].command===`-${c}`)&&(l=k.edit(l,[r],void 0,t));return l}function v(l,c,t,s){const r=C(l),i=r.findIndex(a=>a.command===c||a.command===`-${c}`);for(let a=r.length-1;a>=0;a--)(r[a].command===c||r[a].command===`-${c}`)&&(l=k.edit(l,[a],void 0,s));for(let a=t.length-1;a>=0;a--)l=k.edit(l,[i],t[a],s);return l}}),define(te[213],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(T,k,C){const S={},E={},n=new Set;if(!k)return{local:{added:S,updated:E,removed:[...n.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const I=L(T,k);if(I.added.size===0&&I.removed.size===0&&I.updated.size===0)return{local:{added:S,updated:E,removed:[...n.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const g=L(C,T),w=L(C,k),f={},p={},d=new Set,b=new Set;for(const y of g.removed.values())w.updated.has(y)?S[y]=k[y]:d.add(y);for(const y of w.removed.values())b.has(y)||(g.updated.has(y)?b.add(y):n.add(y));for(const y of g.updated.values())b.has(y)||(w.updated.has(y)?I.updated.has(y)&&b.add(y):p[y]=T[y]);for(const y of w.updated.values())b.has(y)||(g.updated.has(y)?I.updated.has(y)&&b.add(y):T[y]!==void 0&&(E[y]=k[y]));for(const y of g.added.values())b.has(y)||(w.added.has(y)?I.updated.has(y)&&b.add(y):f[y]=T[y]);for(const y of w.added.values())b.has(y)||(g.added.has(y)?I.updated.has(y)&&b.add(y):S[y]=k[y]);return{local:{added:S,removed:[...n.values()],updated:E},remote:{added:f,removed:[...d.values()],updated:p},conflicts:[...b.values()]}}e.merge=D;function L(T,k){const C=T?Object.keys(T):[],S=k?Object.keys(k):[],E=S.filter(g=>C.indexOf(g)===-1).reduce((g,w)=>(g.add(w),g),new Set),n=C.filter(g=>S.indexOf(g)===-1).reduce((g,w)=>(g.add(w),g),new Set),I=new Set;for(const g of C){if(n.has(g))continue;const w=T[g],f=k[g];w!==f&&I.add(g)}return{added:E,removed:n,updated:I}}function R(T,k){const{added:C,removed:S,updated:E}=L(T,k);return C.size===0&&S.size===0&&E.size===0}e.areSame=R}),define(te[24],ne([0,1,17,16,18,145,39,28,5,87,34]),function(J,e,D,L,R,T,k,C,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function I(){const o=n.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(u=>!!o[u].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=I;function g(){const o=n.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(o).filter(A=>!!o[A].ignoreSync),h=Object.keys(o).filter(A=>o[A].scope===2||o[A].scope===6),m=I();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...u,...h,...m])}e.getDefaultIgnoredSettings=g,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function w(){const o="vscode://schemas/ignoredSettings",u=n.Registry.as(k.Extensions.Configuration);u.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:C.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const h=n.Registry.as(E.Extensions.JSONContribution),m=()=>{const A=I(),_=g().filter(M=>M!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(k.allSettings.properties).filter(M=>_.indexOf(M)===-1),N=_.filter(M=>A.indexOf(M)===-1),P={items:{type:"string",enum:[...O,...N.map(M=>`-${M}`)]}};h.registerSchema(o,P)};return u.onDidUpdateConfiguration(()=>m())}e.registerConfiguration=w;function f(o){return o&&(0,R.isObject)(o)&&(0,R.isString)(o.id)&&(0,R.isArray)(o.scopes)}e.isAuthenticationProvider=f;var p;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Extensions="extensions",o.GlobalState="globalState"})(p=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function d(o,u,h){return h.joinPath(u.userDataSyncHome,o,`lastSync${o}.json`)}e.getLastSyncResourceUri=d,e.IUserDataSyncStoreManagementService=(0,S.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,S.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,S.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function b(o){const u={};return u[e.HEADER_EXECUTION_ID]=o,u}e.createSyncHeaders=b;var y;(function(o){o.Unauthorized="Unauthorized",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.UnresolvedConflicts="UnresolvedConflicts",o.Unknown="Unknown"})(y=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class v extends Error{constructor(u,h,m,A){super(u);this.code=h,this.resource=m,this.operationId=A,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=v;class l extends v{constructor(u,h,m,A,_){super(u,m,void 0,_);this.url=h,this.serverCode=A}}e.UserDataSyncStoreError=l;class c extends v{constructor(u,h){super(u,h)}}e.UserDataAutoSyncError=c,function(o){function u(h){if(h instanceof o)return h;const m=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(h.name);if(m&&m[1]){const A=m[2]==="unknown"?void 0:m[2],_=m[3]==="unknown"?void 0:m[3];return new o(h.message,m[1],A,_)}return new o(h.message,"Unknown")}o.toUserDataSyncError=u}(v=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var s;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(s=e.Change||(e.Change={}));var r;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(r=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function i(o){return`sync.enable.${o}`}e.getEnablementKey=i,e.IUserDataSyncResourceEnablementService=(0,S.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,S.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,S.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,S.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,S.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,S.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function a(o,u){if(o.scheme!==e.USER_DATA_SYNC_SCHEME)return o=o.with({scheme:u.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(h=>(0,L.isEqualOrParent)(o,(0,L.joinPath)(u.userDataSyncHome,h,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=a}),define(te[47],ne([0,1,17,6,22,27,3,36,2,16,25,18,7,141,20,13,14,45,23,21,24]),function(J,e,D,L,R,T,k,C,S,E,n,I,g,w,f,p,d,b,y,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function c(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&(Object.keys(a).length===2||Object.keys(a).length===3&&a.machineId!==void 0&&typeof a.machineId=="string"))}e.isSyncData=c;let t=class extends S.Disposable{constructor(o,u,h,m,A,_,O,N,P,M){super();this.resource=o,this.fileService=u,this.environmentService=h,this.userDataSyncStoreService=A,this.userDataSyncBackupStoreService=_,this.userDataSyncResourceEnablementService=O,this.telemetryService=N,this.logService=P,this.configurationService=M,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new L.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new k.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,n.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(h.userDataSyncHome,1024)?E.extUri:E.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(h.userDataSyncHome,o),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(o,h,this.extUri),this.currentMachineIdPromise=(0,b.getServiceMachineId)(h,u,m)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const o=await this.syncPreviewPromise;this.syncPreviewPromise=null;const u=await this.performSync(o.remoteUserData,o.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(u)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const o=await this.getLastSyncUserData();(o?(await this.doGenerateSyncResourcePreview(o,o,!0,this.getUserDataSyncConfiguration(),T.CancellationToken.None)).resourcePreviews.some(({remoteChange:h})=>h!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(o){if(this._status!==o){const u=this._status;o==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),u==="hasConflicts"&&o==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=o,this._onDidChangStatus.fire(o)}}async sync(o,u={}){await this._sync(o,!0,this.getUserDataSyncConfiguration(),u)}async preview(o,u,h={}){return this._sync(o,!1,u,h)}async apply(o,u={}){try{this.syncHeaders={...u};const h=await this.doApply(o);return this.setStatus(h),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(o,u,h,m){try{if(this.syncHeaders={...m},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let A="idle";try{const _=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(o,_);return A=await this.performSync(O,_,u,h),A==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):A==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(A)}}finally{this.syncHeaders={}}}async replace(o){const u=await this.resolveContent(o);if(!u)return!1;const h=this.parseSyncData(u);if(!h)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const m=await this.getLastSyncUserData(),A=await this.getLatestRemoteUserData(null,m),_=await this.isRemoteDataFromCurrentMachine(A),O=await this.generateSyncPreview({ref:A.ref,syncData:h},m,_,this.getUserDataSyncConfiguration(),T.CancellationToken.None),N=[];for(const P of O){const M=await this.getAcceptResult(P,P.remoteResource,void 0,T.CancellationToken.None),{remoteChange:$}=await this.getAcceptResult(P,P.previewResource,P.remoteContent,T.CancellationToken.None);N.push([P,{...M,remoteChange:$!==0?$:2}])}await this.applyResult(A,m,N,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(o){const u=await this.currentMachineIdPromise;return!!o.syncData?.machineId&&o.syncData.machineId===u}async getLatestRemoteUserData(o,u){if(u){const h=o&&o.latest?o.latest[this.resource]:void 0;if(u.ref===h||h===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async performSync(o,u,h,m){if(o.syncData&&o.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,w.localize)(0,null,this.resource,this.version,o.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(o,u,h,m)}catch(A){if(A instanceof l.UserDataSyncError)switch(A.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(o,u,h,m);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),o=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.performSync(o,u,h,m)}throw A}}async doSync(o,u,h,m){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,L.createCancelablePromise)(_=>this.doGenerateSyncResourcePreview(o,u,h,m,_)));const A=await this.syncPreviewPromise;return this.updateConflicts(A.resourcePreviews),A.resourcePreviews.some(({mergeState:_})=>_==="conflict")?"hasConflicts":h?await this.doApply(!1):"syncing"}catch(A){throw this.syncPreviewPromise=null,A}}async merge(o){return await this.updateSyncResourcePreview(o,async u=>{const h=await this.getMergeResult(u,T.CancellationToken.None);await this.fileService.writeFile(u.previewResource,R.VSBuffer.fromString(h?.content||""));const m=h&&!h.hasConflicts?await this.getAcceptResult(u,u.previewResource,void 0,T.CancellationToken.None):void 0;return u.acceptResult=m,u.mergeState=h.hasConflicts?"conflict":m?"accepted":"preview",u.localChange=m?m.localChange:h.localChange,u.remoteChange=m?m.remoteChange:h.remoteChange,u}),this.syncPreviewPromise}async accept(o,u){return await this.updateSyncResourcePreview(o,async h=>{const m=await this.getAcceptResult(h,o,u,T.CancellationToken.None);return h.acceptResult=m,h.mergeState="accepted",h.localChange=m.localChange,h.remoteChange=m.remoteChange,h}),this.syncPreviewPromise}async discard(o){return await this.updateSyncResourcePreview(o,async u=>{const h=await this.getMergeResult(u,T.CancellationToken.None);return await this.fileService.writeFile(u.previewResource,R.VSBuffer.fromString(h.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=h.localChange,u.remoteChange=h.remoteChange,u}),this.syncPreviewPromise}async updateSyncResourcePreview(o,u){if(!this.syncPreviewPromise)return;let h=await this.syncPreviewPromise;const m=h.resourcePreviews.findIndex(({localResource:A,remoteResource:_,previewResource:O})=>this.extUri.isEqual(A,o)||this.extUri.isEqual(_,o)||this.extUri.isEqual(O,o));m!==-1&&(this.syncPreviewPromise=(0,L.createCancelablePromise)(async A=>{const _=[...h.resourcePreviews];return _[m]=await u(_[m]),{...h,resourcePreviews:_}}),h=await this.syncPreviewPromise,this.updateConflicts(h.resourcePreviews),h.resourcePreviews.some(({mergeState:A})=>A==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(o){if(!this.syncPreviewPromise)return"idle";const u=await this.syncPreviewPromise;return u.resourcePreviews.some(({mergeState:h})=>h==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:h})=>h!=="accepted")?"syncing":(await this.applyResult(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(h=>[h,h.acceptResult]),o),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(o){}}updateConflicts(o){const u=o.filter(({mergeState:h})=>h==="conflict");(0,D.equals)(this._conflicts,u,(h,m)=>this.extUri.isEqual(h.previewResource,m.previewResource))||(this._conflicts=u,this._onDidChangeConflicts.fire(u))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:u,ref:h})=>({created:u,uri:this.toRemoteBackupResource(h)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:u,ref:h})=>({created:u,uri:this.toLocalBackupResource(h)}))}toRemoteBackupResource(o){return g.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${o}`})}toLocalBackupResource(o){return g.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${o}`})}async getMachineId({uri:o}){const u=this.extUri.basename(o);if(this.extUri.isEqual(o,this.toRemoteBackupResource(u))){const{content:h}=await this.getUserData(u);if(h)return this.parseSyncData(h)?.machineId}}async resolveContent(o){const u=this.extUri.basename(o);if(this.extUri.isEqual(o,this.toRemoteBackupResource(u))){const{content:h}=await this.getUserData(u);return h}return this.extUri.isEqual(o,this.toLocalBackupResource(u))?this.userDataSyncBackupStoreService.resolveContent(this.resource,u):null}async resolvePreviewContent(o){const u=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(u)for(const h of u.resourcePreviews){if(this.extUri.isEqual(h.acceptedResource,o))return h.acceptResult?h.acceptResult.content:null;if(this.extUri.isEqual(h.remoteResource,o))return h.remoteContent;if(this.extUri.isEqual(h.localResource,o))return h.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(o){}}async doGenerateSyncResourcePreview(o,u,h,m,A){const _=await this.isRemoteDataFromCurrentMachine(o),O=await this.generateSyncPreview(o,u,_,m,A),N=[];for(const P of O){const M=P.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(P.localChange===0&&P.remoteChange===0)N.push({...P,acceptedResource:M,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const $=h?await this.getMergeResult(P,A):void 0;if(A.isCancellationRequested)break;await this.fileService.writeFile(P.previewResource,R.VSBuffer.fromString($?.content||""));const U=$&&!$.hasConflicts?await this.getAcceptResult(P,P.previewResource,void 0,A):void 0;N.push({...P,acceptResult:U,mergeState:$?.hasConflicts?"conflict":U?"accepted":"preview",localChange:U?U.localChange:$?$.localChange:P.localChange,remoteChange:U?U.remoteChange:$?$.remoteChange:P.remoteChange})}}return{remoteUserData:o,lastSyncUserData:u,resourcePreviews:N,isLastSyncFromCurrentMachine:_}}async getLastSyncUserData(){try{const o=await this.fileService.readFile(this.lastSyncResource),u=JSON.parse(o.value.toString()),h=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=u.version&&h&&u.version!==h,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${h}.`),await this.resetLocal(),null;const m=u;if(m.content===null)return{ref:u.ref,syncData:null};const A=JSON.parse(m.content);if(c(A))return{...u,syncData:A,content:void 0}}catch(o){o instanceof d.FileOperationError&&o.fileOperationResult===1||this.logService.error(o)}return null}async updateLastSyncUserData(o,u={}){if(u.ref||u.content||u.version)throw new Error("Cannot have core properties as additional");const h=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),m={ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null,version:h,...u};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(m)))}async getRemoteUserData(o){const{ref:u,content:h}=await this.getUserData(o);let m=null;return h!==null&&(m=this.parseSyncData(h)),{ref:u,syncData:m}}parseSyncData(o){try{const u=JSON.parse(o);if(c(u))return u}catch(u){this.logService.error(u)}throw new l.UserDataSyncError((0,w.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(o){if((0,I.isString)(o)){const u=await this.userDataSyncStoreService.resolveContent(this.resource,o);return{ref:o,content:u}}else{const u=o?{ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,u,this.syncHeaders)}}async updateRemoteUserData(o,u){const h=await this.currentMachineIdPromise,m={version:this.version,machineId:h,content:o};return u=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(m),u,this.syncHeaders),{ref:u,syncData:m}}async backupLocal(o){const u={version:this.version,content:o};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(u))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};t=he([Q(1,d.IFileService),Q(2,p.IEnvironmentService),Q(3,y.IStorageService),Q(4,l.IUserDataSyncStoreService),Q(5,l.IUserDataSyncBackupStoreService),Q(6,l.IUserDataSyncResourceEnablementService),Q(7,v.ITelemetryService),Q(8,l.IUserDataSyncLogService),Q(9,f.IConfigurationService)],t),e.AbstractSynchroniser=t;let s=class extends t{constructor(o,u,h,m,A,_,O,N,P,M,$){super(u,h,m,A,_,O,N,P,M,$);this.file=o,this._register(this.fileService.watch(this.extUri.dirname(o))),this._register(this.fileService.onDidFilesChange(U=>this.onFileChanges(U)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(o){return null}}async updateLocalFileContent(o,u,h){try{u?await this.fileService.writeFile(this.file,R.VSBuffer.fromString(o),h?void 0:u):await this.fileService.createFile(this.file,R.VSBuffer.fromString(o),{overwrite:h})}catch(m){throw m instanceof d.FileOperationError&&m.fileOperationResult===1||m instanceof d.FileOperationError&&m.fileOperationResult===3?new l.UserDataSyncError(m.message,"LocalPreconditionFailed"):m}}onFileChanges(o){!o.contains(this.file)||this.triggerLocalChange()}};s=he([Q(2,d.IFileService),Q(3,p.IEnvironmentService),Q(4,y.IStorageService),Q(5,l.IUserDataSyncStoreService),Q(6,l.IUserDataSyncBackupStoreService),Q(7,l.IUserDataSyncResourceEnablementService),Q(8,v.ITelemetryService),Q(9,l.IUserDataSyncLogService),Q(10,f.IConfigurationService)],s),e.AbstractFileSynchroniser=s;let r=class extends s{constructor(o,u,h,m,A,_,O,N,P,M,$,U){super(o,u,h,m,A,_,O,N,P,M,U);this.userDataSyncUtilService=$,this._formattingOptions=void 0}hasErrors(o){const u=[];return(0,C.parse)(o,u,{allowEmptyContent:!0,allowTrailingComma:!0}),u.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};r=he([Q(2,d.IFileService),Q(3,p.IEnvironmentService),Q(4,y.IStorageService),Q(5,l.IUserDataSyncStoreService),Q(6,l.IUserDataSyncBackupStoreService),Q(7,l.IUserDataSyncResourceEnablementService),Q(8,v.ITelemetryService),Q(9,l.IUserDataSyncLogService),Q(10,l.IUserDataSyncUtilService),Q(11,f.IConfigurationService)],r),e.AbstractJsonFileSynchroniser=r;let i=class{constructor(o,u,h,m){this.resource=o,this.environmentService=u,this.logService=h,this.fileService=m,this.extUri=this.fileService.hasCapability(u.userDataSyncHome,1024)?E.extUri:E.extUriIgnorePathCase,this.lastSyncResource=(0,l.getLastSyncResourceUri)(this.resource,u,E.extUri)}async initialize({ref:o,content:u}){if(!u){this.logService.info("Remote content does not exist.",this.resource);return}const h=this.parseSyncData(u);if(!h)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:o,syncData:h})}catch(A){this.logService.error(A)}}parseSyncData(o){try{const u=JSON.parse(o);if(c(u))return u}catch(u){this.logService.error(u)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(o,u={}){const h={ref:o.ref,content:o.syncData?JSON.stringify(o.syncData):null,...u};await this.fileService.writeFile(this.lastSyncResource,R.VSBuffer.fromString(JSON.stringify(h)))}};i=he([Q(1,p.IEnvironmentService),Q(2,l.IUserDataSyncLogService),Q(3,d.IFileService)],i),e.AbstractInitializer=i}),define(te[214],ne([0,1,6,27,9,3,44,48,25,7,20,13,28,35,14,23,21,47,211,96,97,24]),function(J,e,D,L,R,T,k,C,S,E,n,I,g,w,f,p,d,b,y,v,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function t(o,u){const h=JSON.parse(o.content);if(o.version===1||o.version===2){const m=(await u.getInstalled(0)).filter(A=>A.isBuiltin);for(const A of h)o.version===1&&(A.enabled===!1&&(A.disabled=!0),delete A.enabled),o.version===2&&m.every(_=>!(0,w.areSameExtensions)(_.identifier,A.identifier))&&(A.installed=!0)}return h}function s(o,u,h){const m=h.get((0,w.getExtensionId)(o,u),0)||"{}";return JSON.parse(m)}e.getExtensionStorageState=s;function r(o,u,h,m){m.store((0,w.getExtensionId)(o,u),JSON.stringify(h),0,1)}e.storeExtensionStorageState=r;let i=class ht extends b.AbstractSynchroniser{constructor(u,h,m,A,_,O,N,P,M,$,U,H,W,q){super("extensions",h,u,m,A,_,H,W,M,U);this.storageService=m,this.extensionManagementService=O,this.extensionEnablementService=N,this.ignoredExtensionsManagementService=P,this.extensionGalleryService=$,this.extensionsStorageSyncService=q,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:c.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.debounce(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,x=>x.some(({local:F})=>!!F)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,x=>!x.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(u,h){const m=u.syncData?await t(u.syncData,this.extensionManagementService):null,A=h?.skippedExtensions||[],_=h?.syncData?await t(h.syncData,this.extensionManagementService):null,O=await this.extensionManagementService.getInstalled(void 0,!0),N=this.getLocalExtensions(O),P=this.ignoredExtensionsManagementService.getIgnoredExtensions(O);m?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:M,remote:$}=(0,y.merge)(N,m,_,A,P),U={local:M,remote:$,content:this.getPreviewContent(N,M.added,M.updated,M.removed),localChange:M.added.length>0||M.removed.length>0||M.updated.length>0?2:0,remoteChange:$!==null?2:0};return[{skippedExtensions:A,localResource:this.localResource,localContent:this.format(N),localExtensions:N,remoteResource:this.remoteResource,remoteContent:m?this.format(m):null,previewResource:this.previewResource,previewResult:U,localChange:U.localChange,remoteChange:U.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(u,h,m,A){const _=[...h,...m],O=new Set,N=P=>{O.add(P.id.toLowerCase()),P.uuid&&O.add(P.uuid)};_.forEach(({identifier:P})=>N(P)),A.forEach(N);for(const P of u)O.has(P.identifier.id.toLowerCase())||P.identifier.uuid&&O.has(P.identifier.uuid)||_.push(P);return this.format(_)}async getMergeResult(u,h){return{...u.previewResult,hasConflicts:!1}}async getAcceptResult(u,h,m,A){if(this.extUri.isEqual(h,this.localResource))return this.acceptLocal(u);if(this.extUri.isEqual(h,this.remoteResource))return this.acceptRemote(u);if(this.extUri.isEqual(h,this.previewResource))return u.previewResult;throw new Error(`Invalid Resource: ${h.toString()}`)}async acceptLocal(u){const h=await this.extensionManagementService.getInstalled(),m=this.ignoredExtensionsManagementService.getIgnoredExtensions(h),A=(0,y.merge)(u.localExtensions,null,null,u.skippedExtensions,m),{local:_,remote:O}=A;return{content:u.localContent,local:_,remote:O,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:O!==null?2:0}}async acceptRemote(u){const h=await this.extensionManagementService.getInstalled(),m=this.ignoredExtensionsManagementService.getIgnoredExtensions(h),A=u.remoteContent?JSON.parse(u.remoteContent):null;if(A!==null){const _=(0,y.merge)(u.localExtensions,A,u.localExtensions,[],m),{local:O,remote:N}=_;return{content:u.remoteContent,local:O,remote:N,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:N!==null?2:0}}else return{content:u.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(u,h,m,A){let{skippedExtensions:_,localExtensions:O}=m[0][0],{local:N,remote:P,localChange:M,remoteChange:$}=m[0][1];if(M===0&&$===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),M!==0&&(await this.backupLocal(JSON.stringify(O)),_=await this.updateLocalExtensions(N.added,N.removed,N.updated,_)),P){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const U=JSON.stringify(P.all);u=await this.updateRemoteUserData(U,A?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${P.added.length?` Added: ${JSON.stringify(P.added.map(H=>H.identifier.id))}.`:""}${P.updated.length?` Updated: ${JSON.stringify(P.updated.map(H=>H.identifier.id))}.`:""}${P.removed.length?` Removed: ${JSON.stringify(P.removed.map(H=>H.identifier.id))}.`:""}`)}h?.ref!==u.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(u,{skippedExtensions:_}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${_.length?` Skipped: ${JSON.stringify(_.map(U=>U.identifier.id))}.`:""}`))}async getAssociatedResources({uri:u}){return[{resource:this.extUri.joinPath(u,"extensions.json"),comparableResource:ht.EXTENSIONS_DATA_URI}]}async resolveContent(u){if(this.extUri.isEqual(u,ht.EXTENSIONS_DATA_URI)){const m=await this.extensionManagementService.getInstalled(),A=this.ignoredExtensionsManagementService.getIgnoredExtensions(m),_=this.getLocalExtensions(m).filter(O=>!A.some(N=>(0,w.areSameExtensions)({id:N},O.identifier)));return this.format(_)}if(this.extUri.isEqual(this.remoteResource,u)||this.extUri.isEqual(this.localResource,u)||this.extUri.isEqual(this.acceptedResource,u))return this.resolvePreviewContent(u);let h=await super.resolveContent(u);if(h)return h;if(h=await super.resolveContent(this.extUri.dirname(u)),h){const m=this.parseSyncData(h);if(m)switch(this.extUri.basename(u)){case"extensions.json":return this.format(this.parseExtensions(m))}}return null}format(u){u.sort((A,_)=>!A.identifier.uuid&&_.identifier.uuid?-1:A.identifier.uuid&&!_.identifier.uuid?1:(0,S.compare)(A.identifier.id,_.identifier.id));const h=JSON.stringify(u),m=(0,C.format)(h,void 0,{});return(0,k.applyEdits)(h,m)}async hasLocalData(){try{const u=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(u).some(m=>m.installed||m.disabled))return!0}catch(u){}return!1}async updateLocalExtensions(u,h,m,A){const _=[],O=[],N=await this.extensionManagementService.getInstalled();if(h.length){const M=N.filter(({identifier:$,isBuiltin:U})=>!U&&h.some(H=>(0,w.areSameExtensions)($,H)));await D.Promises.settled(M.map(async $=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,$.identifier.id),await this.extensionManagementService.uninstall($,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,$.identifier.id),_.push($.identifier)}))}(u.length||m.length)&&await D.Promises.settled([...u,...m].map(async M=>{const $=N.find(H=>(0,w.areSameExtensions)(H.identifier,M.identifier));if($&&$.isBuiltin){M.state&&$.manifest.version===M.version&&this.updateExtensionState(M.state,$.manifest.publisher,$.manifest.name,$.manifest.version),M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id)),_.push(M.identifier);return}const U=(await this.extensionGalleryService.getExtensions([M.identifier],L.CancellationToken.None))[0];if(M.state&&($?$.manifest.version===M.version:!!U)){const H=$?$.manifest.publisher:U.publisher,W=$?$.manifest.name:U.name;this.updateExtensionState(M.state,H,W,$?.manifest.version)}if(U)try{M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id,U.version),await this.extensionEnablementService.disableExtension(U.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id,U.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id,U.version),await this.extensionEnablementService.enableExtension(U.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id,U.version)),$||(await this.extensionManagementService.canInstall(U)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,M.identifier.id,U.version),await this.extensionManagementService.installFromGallery(U,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,M.identifier.id,U.version),_.push(U.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,U.displayName||U.identifier.id),O.push(M)))}catch(H){O.push(M),H instanceof g.ExtensionManagementError&&H.code===g.INSTALL_ERROR_INCOMPATIBLE?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,U.displayName||U.identifier.id):(this.logService.error(H),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,U.displayName||U.identifier.id))}else O.push(M),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,M.identifier.id)}));const P=[];for(const M of A)_.some($=>(0,w.areSameExtensions)($,M.identifier))||P.push(M);for(const M of O)P.some($=>(0,w.areSameExtensions)($.identifier,M.identifier))||P.push(M);return P}updateExtensionState(u,h,m,A){const _=s(h,m,this.storageService),O=A?this.extensionsStorageSyncService.getKeysForSync({id:(0,w.getGalleryExtensionId)(h,m),version:A}):void 0;O?O.forEach(N=>{_[N]=u[N]}):Object.keys(u).forEach(N=>_[N]=u[N]),r(h,m,_,this.storageService)}parseExtensions(u){return JSON.parse(u.content)}getLocalExtensions(u){const h=this.extensionEnablementService.getDisabledExtensions();return u.map(({identifier:m,isBuiltin:A,manifest:_})=>{const O={identifier:m,version:_.version};h.some(N=>(0,w.areSameExtensions)(N,m))&&(O.disabled=!0),A||(O.installed=!0);try{const N=this.extensionsStorageSyncService.getKeysForSync({id:m.id,version:_.version});if(N){const P=s(_.publisher,_.name,this.storageService);O.state=Object.keys(P).reduce((M,$)=>(N.includes($)&&(M[$]=P[$]),M),{})}}catch(N){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,R.getErrorMessage)(N))}return O})}};i.EXTENSIONS_DATA_URI=E.URI.from({scheme:c.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=he([Q(0,I.IEnvironmentService),Q(1,f.IFileService),Q(2,p.IStorageService),Q(3,c.IUserDataSyncStoreService),Q(4,c.IUserDataSyncBackupStoreService),Q(5,g.IExtensionManagementService),Q(6,g.IGlobalExtensionEnablementService),Q(7,l.IIgnoredExtensionsManagementService),Q(8,c.IUserDataSyncLogService),Q(9,g.IExtensionGalleryService),Q(10,n.IConfigurationService),Q(11,c.IUserDataSyncResourceEnablementService),Q(12,d.ITelemetryService),Q(13,v.IExtensionsStorageSyncService)],i),e.ExtensionsSynchroniser=i;let a=class extends b.AbstractInitializer{constructor(u,h,m,A,_){super("extensions",A,_,m);this.extensionManagementService=u,this.ignoredExtensionsManagementService=h}async parseExtensions(u){return u.syncData?await t(u.syncData,this.extensionManagementService):null}generatePreview(u,h){const m=[],A=[],_=[];for(const O of u){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(O.identifier.id))continue;const N=h.find(P=>(0,w.areSameExtensions)(P.identifier,O.identifier));N?(m.push(N),O.disabled&&_.push(O.identifier)):O.installed&&(A.push(O.identifier),O.disabled&&_.push(O.identifier))}return{installedExtensions:m,newExtensions:A,disabledExtensions:_,remoteExtensions:u}}};a=he([Q(0,g.IExtensionManagementService),Q(1,l.IIgnoredExtensionsManagementService),Q(2,f.IFileService),Q(3,I.IEnvironmentService),Q(4,c.IUserDataSyncLogService)],a),e.AbstractExtensionsInitializer=a}),define(te[215],ne([0,1,26,24]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function R(C,S,E,n,I){if(!S)return{remote:Object.keys(C).length>0?C:null,local:{added:{},removed:[],updated:{}}};const g=T(C,S);if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const w=E?T(E,S):{added:Object.keys(S).reduce((y,v)=>(y.add(v),y),new Set),removed:new Set,updated:new Set},f=E?T(E,C):{added:Object.keys(C).reduce((y,v)=>(y.add(v),y),new Set),removed:new Set,updated:new Set},p={added:{},removed:[],updated:{}},d=D.deepClone(S),b=!E;for(const y of f.added.values())y!==L.SYNC_SERVICE_URL_TYPE&&b&&w.added.has(y)||(d[y]=C[y]);for(const y of f.updated.values())d[y]=C[y];for(const y of f.removed.values())n.unregistered.includes(y)||delete d[y];for(const y of w.added.values()){const v=S[y];if(n.machine.includes(y)){I.info(`GlobalState: Skipped adding ${y} in local storage because it is declared as machine scoped.`);continue}if(E&&f.added.has(y))continue;const l=C[y];l&&l.value===v.value||y===L.SYNC_SERVICE_URL_TYPE&&b&&f.added.has(y)||(l?p.updated[y]=v:p.added[y]=v)}for(const y of w.updated.values()){const v=S[y];if(n.machine.includes(y)){I.info(`GlobalState: Skipped updating ${y} in local storage because it is declared as machine scoped.`);continue}if(f.updated.has(y)||f.removed.has(y))continue;const l=C[y];l&&l.value===v.value||(p.updated[y]=v)}for(const y of w.removed.values()){if(n.machine.includes(y)){I.trace(`GlobalState: Skipped removing ${y} in local storage because it is declared as machine scoped.`);continue}f.updated.has(y)||f.removed.has(y)||p.removed.push(y)}return{local:p,remote:k(d,S)?null:d}}e.merge=R;function T(C,S){const E=Object.keys(C),n=Object.keys(S),I=n.filter(f=>E.indexOf(f)===-1).reduce((f,p)=>(f.add(p),f),new Set),g=E.filter(f=>n.indexOf(f)===-1).reduce((f,p)=>(f.add(p),f),new Set),w=new Set;for(const f of E){if(g.has(f))continue;const p=C[f],d=S[f];D.equals(p,d)||w.add(f)}return{added:I,removed:g,updated:w}}function k(C,S){const{added:E,removed:n,updated:I}=T(C,S);return E.size===0&&n.size===0&&I.size===0}}),define(te[216],ne([0,1,22,3,36,44,48,4,7,30,20,13,14,10,45,23,21,47,54,215,24]),function(J,e,D,L,R,T,k,C,S,E,n,I,g,w,f,p,d,b,y,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const c="globalState.argv.",t=["locale"];function s(u){const h=u.storage?Object.keys(u.storage).sort():[],m={};h.forEach(O=>m[O]=u.storage[O]),u.storage=m;const A=JSON.stringify(u),_=(0,k.format)(A,void 0,{});return(0,T.applyEdits)(A,_)}const r=1;let i=class ft extends b.AbstractSynchroniser{constructor(h,m,A,_,O,N,P,M,$){super("globalState",h,O,$,m,A,N,P,_,M);this.storageService=$,this.version=r,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(h.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(h.onDidFilesChange,U=>U.contains(this.environmentService.argvResource)),L.Event.filter($.onDidChangeValue,U=>U.scope===0&&U.target!==void 0?U.target===0:$.keys(0,0).includes(U.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(h,m,A){const _=h.syncData?JSON.parse(h.syncData.content):null;m=m===null&&A?h:m;const O=m&&m.syncData?JSON.parse(m.syncData.content):null,N=await this.getLocalGlobalState();_?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const P=this.getStorageKeys(O),{local:M,remote:$}=(0,v.merge)(N.storage,_?_.storage:null,O?O.storage:null,P,this.logService),U={content:null,local:M,remote:$,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:$!==null?2:0};return[{localResource:this.localResource,localContent:s(N),localUserData:N,remoteResource:this.remoteResource,remoteContent:_?s(_):null,previewResource:this.previewResource,previewResult:U,localChange:U.localChange,remoteChange:U.remoteChange,acceptedResource:this.acceptedResource,storageKeys:P}]}async getMergeResult(h,m){return{...h.previewResult,hasConflicts:!1}}async getAcceptResult(h,m,A,_){if(this.extUri.isEqual(m,this.localResource))return this.acceptLocal(h);if(this.extUri.isEqual(m,this.remoteResource))return this.acceptRemote(h);if(this.extUri.isEqual(m,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${m.toString()}`)}async acceptLocal(h){return{content:h.localContent,local:{added:{},removed:[],updated:{}},remote:h.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(h){if(h.remoteContent!==null){const m=JSON.parse(h.remoteContent),{local:A,remote:_}=(0,v.merge)(h.localUserData.storage,m.storage,null,h.storageKeys,this.logService);return{content:h.remoteContent,local:A,remote:_,localChange:Object.keys(A.added).length>0||Object.keys(A.updated).length>0||A.removed.length>0?2:0,remoteChange:_!==null?2:0}}else return{content:h.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(h,m,A,_){let{localUserData:O}=A[0][0],{local:N,remote:P,localChange:M,remoteChange:$}=A[0][1];if(M===0&&$===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),M!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(O)),await this.writeLocalGlobalState(N),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),$!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const U=JSON.stringify({storage:P});h=await this.updateRemoteUserData(U,_?null:h.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}m?.ref!==h.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(h),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:h}){return[{resource:this.extUri.joinPath(h,"globalState.json"),comparableResource:ft.GLOBAL_STATE_DATA_URI}]}async resolveContent(h){if(this.extUri.isEqual(h,ft.GLOBAL_STATE_DATA_URI)){const A=await this.getLocalGlobalState();return s(A)}if(this.extUri.isEqual(this.remoteResource,h)||this.extUri.isEqual(this.localResource,h)||this.extUri.isEqual(this.acceptedResource,h))return this.resolvePreviewContent(h);let m=await super.resolveContent(h);if(m)return m;if(m=await super.resolveContent(this.extUri.dirname(h)),m){const A=this.parseSyncData(m);if(A)switch(this.extUri.basename(h)){case"globalState.json":return s(JSON.parse(A.content))}}return null}async hasLocalData(){try{const{storage:h}=await this.getLocalGlobalState();if(Object.keys(h).length>1||h[`${c}.locale`]?.value!=="en")return!0}catch(h){}return!1}async getLocalGlobalState(){const h={},m=await this.getLocalArgvContent(),A=(0,R.parse)(m);for(const _ of t)A[_]!==void 0&&(h[`${c}${_}`]={version:1,value:A[_]});for(const _ of this.storageService.keys(0,0)){const O=this.storageService.get(_,0);O&&(h[_]={version:1,value:O})}return{storage:h}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(h){}return"{}"}async writeLocalGlobalState({added:h,removed:m,updated:A}){const _={},O={},N=(M,$)=>{for(const U of M){if(U.startsWith(c)){_[U.substring(c.length)]=$?$[U].value:void 0;continue}if($){const H=$[U];H.value!==String(this.storageService.get(U,0))&&(O[U]=H.value)}else this.storageService.get(U,0)!==void 0&&(O[U]=void 0)}};if(N(Object.keys(h),h),N(Object.keys(A),A),N(m),Object.keys(_).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(_),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(O).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const M of Object.keys(O))this.storageService.store(M,O[M],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(O))}}async updateArgv(h){const m=await this.getLocalArgvContent();let A=m;for(const _ of Object.keys(h))A=(0,y.edit)(A,[_],h[_],{});m!==A&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(A)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(h){const m=this.storageService.keys(0,0),A=this.storageService.keys(0,1),_=[...m,...A],O=h?.storage?Object.keys(h.storage).filter(N=>!N.startsWith(c)&&!_.includes(N)&&this.storageService.get(N,0)!==void 0):[];if(!C.isWeb){const N=[...l.ALL_SYNC_RESOURCES.map(P=>(0,l.getEnablementKey)(P)),l.SYNC_SERVICE_URL_TYPE];O.push(...N),A.push(...N)}return{user:m,machine:A,unregistered:O}}};i.GLOBAL_STATE_DATA_URI=S.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),i=he([Q(0,g.IFileService),Q(1,l.IUserDataSyncStoreService),Q(2,l.IUserDataSyncBackupStoreService),Q(3,l.IUserDataSyncLogService),Q(4,I.IEnvironmentService),Q(5,l.IUserDataSyncResourceEnablementService),Q(6,d.ITelemetryService),Q(7,n.IConfigurationService),Q(8,p.IStorageService)],i),e.GlobalStateSynchroniser=i;let a=class extends b.AbstractInitializer{constructor(h,m,A,_){super("globalState",A,_,m);this.storageService=h}async doInitialize(h){const m=h.syncData?JSON.parse(h.syncData.content):null;if(!m){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const A={},_={};for(const O of Object.keys(m.storage))O.startsWith(c)?A[O.substring(c.length)]=m.storage[O].value:this.storageService.get(O,0)===void 0&&(_[O]=m.storage[O].value);if(Object.keys(A).length){let O="{}";try{O=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(N){}for(const N of Object.keys(A))O=(0,y.edit)(O,[N],A[N],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(O))}if(Object.keys(_).length)for(const O of Object.keys(_))this.storageService.store(O,_[O],0,0)}};a=he([Q(0,p.IStorageService),Q(1,g.IFileService),Q(2,I.IEnvironmentService),Q(3,l.IUserDataSyncLogService)],a),e.GlobalStateInitializer=a;let o=class{constructor(h,m,A,_,O){this.userDataSyncStoreClient=h,this.storageService=m,this.environmentService=A,this.fileService=_,this.logService=O}getSyncStoreType(h){return this.parseGlobalState(h)?.storage[l.SYNC_SERVICE_URL_TYPE]?.value}async sync(h){const m=(0,l.createSyncHeaders)((0,E.generateUuid)());try{return await this.doSync(h,m)}catch(A){if(A instanceof l.UserDataSyncError)switch(A.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(h,m)}throw A}}async doSync(h,m){const A=await this.userDataSyncStoreClient.read("globalState",null,m),_=this.parseGlobalState(A)||{storage:{}};_.storage[l.SYNC_SERVICE_URL_TYPE]={value:h,version:r};const O=await(0,f.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),N={version:r,machineId:O,content:s(_)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(N),A.ref,m)}parseGlobalState({content:h}){if(!h)return null;const m=JSON.parse(h);if((0,b.isSyncData)(m))return m?JSON.parse(m.content):null;throw new Error("Invalid remote data")}};o=he([Q(1,p.IStorageService),Q(2,I.IEnvironmentService),Q(3,g.IFileService),Q(4,w.ILogService)],o),e.UserDataSyncStoreTypeSynchronizer=o}),define(te[217],ne([0,1,17,22,3,36,4,18,142,20,13,14,23,21,47,212,24]),function(J,e,D,L,R,T,k,C,S,E,n,I,g,w,f,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function b(l,c,t){try{const s=JSON.parse(l);if(!c)return(0,C.isUndefined)(s.all)?null:s.all;switch(k.OS){case 2:return(0,C.isUndefined)(s.mac)?null:s.mac;case 3:return(0,C.isUndefined)(s.linux)?null:s.linux;case 1:return(0,C.isUndefined)(s.windows)?null:s.windows}}catch(s){return t.error(s),null}}e.getKeybindingsContentFromSyncContent=b;let y=class extends f.AbstractJsonFileSynchroniser{constructor(c,t,s,r,i,a,o,u,h,m){super(o.keybindingsResource,"keybindings",a,o,u,c,t,i,m,s,h,r);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.Event.filter(r.onDidChangeConfiguration,A=>A.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(c,t,s,r){const i=c.syncData?b(c.syncData.content,r.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;t=t===null&&s?c:t;const a=t?this.getKeybindingsContentFromLastSyncUserData(t):null,o=await this.getLocalFileContent(),u=await this.getFormattingOptions();let h=null,m=!1,A=!1,_=!1;if(i){let N=o?o.value.toString():"[]";if(N=N||"[]",this.hasErrors(N))throw new d.UserDataSyncError((0,S.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==N||a!==i){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const P=await(0,p.merge)(N,i,a,u,this.userDataSyncUtilService);P.hasChanges&&(h=P.mergeContent,_=P.hasConflicts,m=_||P.mergeContent!==N,A=_||P.mergeContent!==i)}}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),h=o.value.toString(),A=!0);const O={content:h,localChange:m?o?2:1:0,remoteChange:A?2:0,hasConflicts:_};return[{fileContent:o,localResource:this.localResource,localContent:o?o.value.toString():null,localChange:O.localChange,remoteResource:this.remoteResource,remoteContent:i,remoteChange:O.remoteChange,previewResource:this.previewResource,previewResult:O,acceptedResource:this.acceptedResource}]}async getMergeResult(c,t){return c.previewResult}async getAcceptResult(c,t,s,r){if(this.extUri.isEqual(t,this.localResource))return{content:c.fileContent?c.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:c.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return s===void 0?{content:c.previewResult.content,localChange:c.previewResult.localChange,remoteChange:c.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(c,t,s,r){const{fileContent:i}=s[0][0];let{content:a,localChange:o,remoteChange:u}=s[0][1];if(o===0&&u===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a)))throw new d.UserDataSyncError((0,S.localize)(1,null),"LocalInvalidContent",this.resource);if(o!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),i&&await this.backupLocal(this.toSyncContent(i.value.toString())),await this.updateLocalFileContent(a||"[]",i,r),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),u!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const h=this.toSyncContent(a||"[]",c.syncData?.content);c=await this.updateRemoteUserData(h,r?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(h){}t?.ref!==c.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(c,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const c=await this.getLocalFileContent();if(c){const t=(0,T.parse)(c.value.toString());if((0,D.isNonEmptyArray)(t))return!0}}catch(c){if(c.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:c}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(c,"keybindings.json"),comparableResource:t}]}async resolveContent(c){if(this.extUri.isEqual(this.remoteResource,c)||this.extUri.isEqual(this.localResource,c)||this.extUri.isEqual(this.acceptedResource,c))return this.resolvePreviewContent(c);let t=await super.resolveContent(c);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(c)),t){const s=this.parseSyncData(t);if(s)switch(this.extUri.basename(c)){case"keybindings.json":return b(s.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(c){return!c.syncData||c.platformSpecific!==void 0&&c.platformSpecific!==this.syncKeybindingsPerPlatform()?null:b(c.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(c,t){let s={};try{s=JSON.parse(t||"{}")}catch(r){this.logService.error(r)}switch(this.syncKeybindingsPerPlatform()?delete s.all:s.all=c,k.OS){case 2:s.mac=c;break;case 3:s.linux=c;break;case 1:s.windows=c;break}return JSON.stringify(s)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};y=he([Q(0,d.IUserDataSyncStoreService),Q(1,d.IUserDataSyncBackupStoreService),Q(2,d.IUserDataSyncLogService),Q(3,E.IConfigurationService),Q(4,d.IUserDataSyncResourceEnablementService),Q(5,I.IFileService),Q(6,n.IEnvironmentService),Q(7,g.IStorageService),Q(8,d.IUserDataSyncUtilService),Q(9,w.ITelemetryService)],y),e.KeybindingsSynchroniser=y;let v=class extends f.AbstractInitializer{constructor(c,t,s){super("keybindings",t,s,c)}async doInitialize(c){const t=c.syncData?this.getKeybindingsContentFromSyncContent(c.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,L.VSBuffer.fromString(t)),await this.updateLastSyncUserData(c)}async isEmpty(){try{const c=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,T.parse)(c.value.toString());return!(0,D.isNonEmptyArray)(t)}catch(c){return c.fileOperationResult===1}}getKeybindingsContentFromSyncContent(c){try{return b(c,!0,this.logService)}catch(t){return this.logService.error(t),null}}};v=he([Q(0,I.IFileService),Q(1,n.IEnvironmentService),Q(2,d.IUserDataSyncLogService)],v),e.KeybindingsInitializer=v}),define(te[218],ne([0,1,17,36,44,48,26,54,24]),function(J,e,D,L,R,T,k,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function E(o,u,h){let m=[];h?m=I(h):m=n(u);const A=[],_=[...(0,S.getDisallowedIgnoredSettings)()];if(Array.isArray(m))for(const O of m)O.startsWith("-")?_.push(O.substring(1)):A.push(O);return(0,D.distinct)([...o,...A].filter(O=>_.indexOf(O)===-1))}e.getIgnoredSettings=E;function n(o){let u=o.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=o.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:o.getValue("settingsSync.ignoredSettings")||[]}function I(o){const u=(0,L.parse)(o);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function g(o,u,h,m){if(h.length){const A=a(u),_=(0,L.parse)(u),O=(0,L.parse)(o),N=[];for(const P of h){const M=_[P],$=O[P];M===void 0?o=C.edit(o,[P],void 0,m):$!==void 0?o=C.edit(o,[P],M,m):N.push(c(P,A))}N.sort((P,M)=>P.startOffset-M.startOffset),N.forEach(P=>o=b(P.setting.key,u,o,m))}return o}e.updateIgnoredSettings=g;function w(o,u,h,m,A,_){const O=g(o,u,m,_),N=h!==O,P=h!==u;if(!N&&!P)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(N&&!P)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if(P&&!N)return{conflictsSettings:[],localContent:g(u,o,m,_),remoteContent:null,hasConflicts:!1};if(h===null&&p(o)){const G=f(o,u,m)?null:g(u,o,m,_);return{conflictsSettings:[],localContent:G,remoteContent:null,hasConflicts:!1}}let M=o,$=u;const U=(0,L.parse)(o),H=(0,L.parse)(u),W=h?(0,L.parse)(h):null,q=m.reduce((G,ie)=>(G.add(ie),G),new Set),x=d(U,H,q),F=d(W,U,q),K=d(W,H,q),j=new Map,z=new Set,B=G=>{z.add(G);const ie=A.filter(({key:re})=>re===G)[0];ie?(M=C.edit(M,[G],ie.value,_),$=C.edit($,[G],ie.value,_)):j.set(G,{key:G,localValue:U[G],remoteValue:H[G]})};for(const G of F.removed.values())K.updated.has(G)?B(G):$=C.edit($,[G],void 0,_);for(const G of K.removed.values())z.has(G)||(F.updated.has(G)?B(G):M=C.edit(M,[G],void 0,_));for(const G of F.updated.values())z.has(G)||(K.updated.has(G)?x.updated.has(G)&&B(G):$=C.edit($,[G],U[G],_));for(const G of K.updated.values())z.has(G)||(F.updated.has(G)?x.updated.has(G)&&B(G):M=C.edit(M,[G],H[G],_));for(const G of F.added.values())z.has(G)||(K.added.has(G)?x.updated.has(G)&&B(G):$=b(G,M,$,_));for(const G of K.added.values())z.has(G)||(F.added.has(G)?x.updated.has(G)&&B(G):M=b(G,$,M,_));const X=j.size>0||!f(M,$,m),Z=X||!f(M,o,[]),V=X||!f($,u,[]);return{localContent:Z?M:null,remoteContent:V?$:null,conflictsSettings:[...j.values()],hasConflicts:X}}e.merge=w;function f(o,u,h){if(o===u)return!0;const m=(0,L.parse)(o),A=(0,L.parse)(u),_=h.reduce((P,M)=>(P.add(M),P),new Set),O=a(o).filter(P=>!(P.setting&&_.has(P.setting.key))),N=a(u).filter(P=>!(P.setting&&_.has(P.setting.key)));if(O.length!==N.length)return!1;for(let P=0;P<O.length;P++){const M=O[P],$=N[P];if(M.setting&&$.setting){if(M.setting.key!==$.setting.key||!k.equals(m[M.setting.key],A[M.setting.key]))return!1}else if(!M.setting&&!$.setting){if(M.value!==$.value)return!1}else return!1}return!0}e.areSame=f;function p(o){return o?a(o).length===0:!0}e.isEmpty=p;function d(o,u,h){const m=o?Object.keys(o).filter(P=>!h.has(P)):[],A=Object.keys(u).filter(P=>!h.has(P)),_=A.filter(P=>m.indexOf(P)===-1).reduce((P,M)=>(P.add(M),P),new Set),O=m.filter(P=>A.indexOf(P)===-1).reduce((P,M)=>(P.add(M),P),new Set),N=new Set;if(o)for(const P of m){if(O.has(P))continue;const M=o[P],$=u[P];k.equals(M,$)||N.add(P)}return{added:_,removed:O,updated:N}}function b(o,u,h,m){const A=(0,L.parse)(u),_=a(u),O=a(h),N=y(o,_,O);return v(h,o,A[o],N,O,m)}e.addSetting=b;function y(o,u,h){const m=u.findIndex(_=>_.setting?.key===o),A=u[m-1];if(A){if(A.setting){const O=c(A.setting.key,h);if(O)return{index:h.indexOf(O),insertAfter:!0}}else{const O=t(m,u);if(O){const N=c(O.setting.key,h);if(N){const P=s(h.indexOf(N),h),M=r(u,O,u[m]);if(P){const $=r(h,N,P),U=i(M,$);return U?{index:h.indexOf(U),insertAfter:!0}:{index:h.indexOf(P),insertAfter:!1}}else{const $=r(h,N,h[h.length-1]),U=i(M,$);return U?{index:h.indexOf(U),insertAfter:!0}:{index:h.length-1,insertAfter:!0}}}}}const _=u[m+1];if(_)if(_.setting){const O=c(_.setting.key,h);if(O)return{index:h.indexOf(O),insertAfter:!1}}else{const O=s(m,u);if(O){const N=c(O.setting.key,h);if(N){const P=t(h.indexOf(N),h),M=r(u,u[m],O);if(P){const $=r(h,P,N),U=i(M.reverse(),$.reverse());return U?{index:h.indexOf(U),insertAfter:!1}:{index:h.indexOf(P),insertAfter:!0}}else{const $=r(h,h[0],N),U=i(M.reverse(),$.reverse());return U?{index:h.indexOf(U),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:h.length-1,insertAfter:!0}}function v(o,u,h,m,A,_){let O;return m.index===-1?O=(0,R.setProperty)(o,[u],h,_):O=l(o,u,h,m,A,_).map(N=>(0,R.withFormatting)(o,N,_)[0]),(0,R.applyEdits)(o,O)}function l(o,u,h,m,A,_){const O=`${JSON.stringify(u)}: ${JSON.stringify(h)}`,N=(0,T.getEOL)(_,o),P=A[m.index];if(m.insertAfter){const M=[];if(P.setting)M.push({offset:P.endOffset,length:0,content:","+O});else{const $=s(m.index,A),U=t(m.index,A),H=U?.setting?.commaOffset;U&&H===void 0&&M.push({offset:U.endOffset,length:0,content:","});const W=H!==void 0&&H>P.endOffset;M.push({offset:W?H+1:P.endOffset,length:0,content:$?N+O+",":N+O})}return M}else{if(P.setting)return[{offset:P.startOffset,length:0,content:O+","}];const M=(A[m.index-1]&&!A[m.index-1].setting?N:"")+O+(s(m.index,A)?",":"")+N;return[{offset:P.startOffset,length:0,content:M}]}}function c(o,u){return u.filter(h=>h.setting?.key===o)[0]}function t(o,u){for(let h=o-1;h>=0;h--)if(u[h].setting)return u[h]}function s(o,u){for(let h=o+1;h<u.length;h++)if(u[h].setting)return u[h]}function r(o,u,h){const m=o.indexOf(u),A=o.indexOf(h);return o.filter((_,O)=>m<O&&O<A)}function i(o,u){if(o.length&&u.length){let h=0;for(;h<u.length&&h<o.length;h++)if(o[h].value!==u[h].value)return u[h-1];return u[h-1]}}function a(o){const u=[];let h=-1,m,A;const _={onObjectBegin:O=>{h++},onObjectProperty:(O,N,P)=>{h===0&&(m=N,A=O)},onObjectEnd:(O,N)=>{h--,h===0&&u.push({startOffset:m,endOffset:O+N,value:o.substring(m,O+N),setting:{key:A,commaOffset:void 0}})},onArrayBegin:(O,N)=>{h++},onArrayEnd:(O,N)=>{h--,h===0&&u.push({startOffset:m,endOffset:O+N,value:o.substring(m,O+N),setting:{key:A,commaOffset:void 0}})},onLiteralValue:(O,N,P)=>{h===0&&u.push({startOffset:m,endOffset:N+P,value:o.substring(m,N+P),setting:{key:A,commaOffset:void 0}})},onSeparator:(O,N,P)=>{if(h===0&&O===","){let M=u.length-1;for(;M>=0&&!u[M].setting;M--);const $=u[M];$&&u.splice(M,1,{startOffset:$.startOffset,endOffset:$.endOffset,value:$.value,setting:{key:$.setting.key,commaOffset:N}})}},onComment:(O,N)=>{h===0&&u.push({startOffset:O,endOffset:O+N,value:o.substring(O,O+N)})}};return(0,L.visit)(o,_),u}}),define(te[219],ne([0,1,22,3,44,143,20,88,13,28,14,23,21,47,54,218,24]),function(J,e,D,L,R,T,k,C,S,E,n,I,g,w,f,p,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function b(t){return t&&t.settings&&typeof t.settings=="string"&&Object.keys(t).length===1}function y(t){const s=JSON.parse(t);return b(s)?s:{settings:t}}e.parseSettingsSyncContent=y;let v=class extends w.AbstractJsonFileSynchroniser{constructor(s,r,i,a,o,u,h,m,A,_,O){super(r.settingsResource,"settings",s,r,i,a,o,A,_,u,h,m);this.extensionManagementService=O,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(s){const r=await this.getLastSyncUserData(),i=await this.getLatestRemoteUserData(s,r),a=this.getSettingsSyncContent(i),o=new C.ConfigurationModelParser(d.USER_DATA_SYNC_CONFIGURATION_SCOPE);return a?.settings&&o.parse(a.settings),o.configurationModel.getValue(d.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(s,r,i){const a=await this.getLocalFileContent(),o=await this.getFormattingOptions(),u=this.getSettingsSyncContent(s);r=r===null&&i?s:r;const h=r?this.getSettingsSyncContent(r):null,m=await this.getIgnoredSettings();let A=null,_=!1,O=!1,N=!1;if(u){let M=a?a.value.toString().trim():"{}";M=M||"{}",this.validateContent(M),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const $=(0,p.merge)(M,u.settings,h?h.settings:null,m,[],o);A=$.localContent||$.remoteContent,_=$.localContent!==null,O=$.remoteContent!==null,N=$.hasConflicts}else a&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),A=a.value.toString(),O=!0);const P={content:A,localChange:_?2:0,remoteChange:O?2:0,hasConflicts:N};return[{fileContent:a,localResource:this.localResource,localContent:a?a.value.toString():null,localChange:P.localChange,remoteResource:this.remoteResource,remoteContent:u?u.settings:null,remoteChange:P.remoteChange,previewResource:this.previewResource,previewResult:P,acceptedResource:this.acceptedResource}]}async getMergeResult(s,r){const i=await this.getFormattingOptions(),a=await this.getIgnoredSettings();return{...s.previewResult,content:s.previewResult.content?(0,p.updateIgnoredSettings)(s.previewResult.content,"{}",a,i):null}}async getAcceptResult(s,r,i,a){const o=await this.getFormattingOptions(),u=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:s.fileContent?(0,p.updateIgnoredSettings)(s.fileContent.value.toString(),"{}",u,o):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:s.remoteContent!==null?(0,p.updateIgnoredSettings)(s.remoteContent,s.fileContent?s.fileContent.value.toString():"{}",u,o):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return i===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:i!==null?(0,p.updateIgnoredSettings)(i,s.fileContent?s.fileContent.value.toString():"{}",u,o):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(s,r,i,a){const{fileContent:o}=i[0][0];let{content:u,localChange:h,remoteChange:m}=i[0][1];if(h===0&&m===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),u=u?u.trim():"{}",u=u||"{}",this.validateContent(u),h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),o&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(o.value.toString()))),await this.updateLocalFileContent(u,o,a),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),m!==0){const A=await this.getFormattingOptions(),_=this.getSettingsSyncContent(s),O=await this.getIgnoredSettings(u);u=(0,p.updateIgnoredSettings)(u,_?_.settings:"{}",O,A),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),s=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(u)),a?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(A){}r?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(s),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const r=await this.getFormattingOptions(),i=(0,f.edit)(s.value.toString(),[d.CONFIGURATION_SYNC_STORE_KEY],void 0,r);return!(0,p.isEmpty)(i)}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:s}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(s,"settings.json"),comparableResource:r}]}async resolveContent(s){if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s))return this.resolvePreviewContent(s);let r=await super.resolveContent(s);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(s)),r){const i=this.parseSyncData(r);if(i){const a=this.parseSettingsSyncContent(i.content);if(a)switch(this.extUri.basename(s)){case"settings.json":return a.settings}}}return null}async resolvePreviewContent(s){let r=await super.resolvePreviewContent(s);if(r){const i=await this.getFormattingOptions(),a=await this.getIgnoredSettings();r=(0,p.updateIgnoredSettings)(r,"{}",a,i)}return r}getSettingsSyncContent(s){return s.syncData?this.parseSettingsSyncContent(s.syncData.content):null}parseSettingsSyncContent(s){try{return y(s)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(s){return{settings:s}}async getIgnoredSettings(s){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,a=>a.some(({local:o})=>!!o)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,a=>!a.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const r=await this._defaultIgnoredSettings;return(0,p.getIgnoredSettings)(r,this.configurationService,s)}validateContent(s){if(this.hasErrors(s))throw new d.UserDataSyncError((0,T.localize)(0,null),"LocalInvalidContent",this.resource)}async recoverSettings(){try{const s=await this.getLocalFileContent();if(!s)return;const r=JSON.parse(s.value.toString());if(!c(r))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const i=this.parseSettingsSyncContent(r.content);if(!i||!i.settings)return;let a=i.settings;const o=await this.getFormattingOptions();for(const u in r)if(["version","content","machineId"].indexOf(u)===-1&&r[u]!==void 0){const h=(0,R.setProperty)(a,[u],r[u],o);h.length&&(a=(0,R.applyEdits)(a,h))}await this.fileService.writeFile(this.file,D.VSBuffer.fromString(a))}catch(s){}}};v=he([Q(0,n.IFileService),Q(1,S.IEnvironmentService),Q(2,I.IStorageService),Q(3,d.IUserDataSyncStoreService),Q(4,d.IUserDataSyncBackupStoreService),Q(5,d.IUserDataSyncLogService),Q(6,d.IUserDataSyncUtilService),Q(7,k.IConfigurationService),Q(8,d.IUserDataSyncResourceEnablementService),Q(9,g.ITelemetryService),Q(10,E.IExtensionManagementService)],v),e.SettingsSynchroniser=v;let l=class extends w.AbstractInitializer{constructor(s,r,i){super("settings",r,i,s)}async doInitialize(s){const r=s.syncData?this.parseSettingsSyncContent(s.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.environmentService.settingsResource);return(0,p.isEmpty)(s.value.toString().trim())}catch(s){return s.fileOperationResult===1}}parseSettingsSyncContent(s){try{return y(s)}catch(r){this.logService.error(r)}return null}};l=he([Q(0,n.IFileService),Q(1,S.IEnvironmentService),Q(2,d.IUserDataSyncLogService)],l),e.SettingsInitializer=l;function c(t){return!!(t&&t.version!==void 0&&typeof t.version=="number"&&t.content!==void 0&&typeof t.content=="string"&&t.machineId!==void 0&&typeof t.machineId=="string")}}),define(te[220],ne([0,1,22,3,26,20,13,14,23,21,47,213,24]),function(J,e,D,L,R,T,k,C,S,E,n,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let w=class extends n.AbstractSynchroniser{constructor(d,b,y,v,l,c,t,s,r){super("snippets",b,d,y,v,l,s,r,c,t);this.version=1,this.snippetsFolder=d.snippetsHome,this._register(this.fileService.watch(d.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(L.Event.filter(this.fileService.onDidFilesChange,i=>i.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(d,b,y){const v=await this.getSnippetsFileContents(),l=this.toSnippetsContents(v),c=d.syncData?this.parseSnippets(d.syncData):null;b=b===null&&y?d:b;const t=b&&b.syncData?this.parseSnippets(b.syncData):null;c?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,I.merge)(l,c,t);return this.getResourcePreviews(s,v,c||{})}async getMergeResult(d,b){return d.previewResult}async getAcceptResult(d,b,y,v){if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:d.fileContent?d.fileContent.value.toString():null,localChange:0,remoteChange:d.fileContent?d.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:d.remoteContent,localChange:d.remoteContent!==null?d.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder))return y===void 0?{content:d.previewResult.content,localChange:d.previewResult.localChange,remoteChange:d.previewResult.remoteChange}:{content:y,localChange:y===null?d.fileContent!==null?3:0:2,remoteChange:y===null?d.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${b.toString()}`)}async applyResult(d,b,y,v){const l=y.map(([c,t])=>({...c,acceptResult:t}));l.every(({localChange:c,remoteChange:t})=>c===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),l.some(({localChange:c})=>c!==0)&&(await this.updateLocalBackup(l),await this.updateLocalSnippets(l,v)),l.some(({remoteChange:c})=>c!==0)&&(d=await this.updateRemoteSnippets(l,d,v)),b?.ref!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:c}of l)try{await this.fileService.del(c)}catch(t){}}getResourcePreviews(d,b,y){const v=new Map;for(const l of Object.keys(d.local.added)){const c={content:d.local.added[l],hasConflicts:!1,localChange:1,remoteChange:0};v.set(l,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(d.local.updated)){const c={content:d.local.updated[l],hasConflicts:!1,localChange:2,remoteChange:0};v.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[l],localContent:b[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of d.local.removed){const c={content:null,hasConflicts:!1,localChange:3,remoteChange:0};v.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[l],localContent:b[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(d.remote.added)){const c={content:d.remote.added[l],hasConflicts:!1,localChange:0,remoteChange:1};v.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[l],localContent:b[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(d.remote.updated)){const c={content:d.remote.updated[l],hasConflicts:!1,localChange:0,remoteChange:2};v.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[l],localContent:b[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of d.remote.removed){const c={content:null,hasConflicts:!1,localChange:0,remoteChange:3};v.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of d.conflicts){const c={content:b[l]?b[l].value.toString():null,hasConflicts:!0,localChange:b[l]?2:1,remoteChange:y[l]?2:1};v.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[l]||null,localContent:b[l]?b[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(b))if(!v.has(l)){const c={content:b[l]?b[l].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};v.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[l]||null,localContent:b[l]?b[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:y[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:c,localChange:c.localChange,remoteChange:c.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...v.values()]}async getAssociatedResources({uri:d}){let b=await super.resolveContent(d);if(b){const y=this.parseSyncData(b);if(y){const v=this.parseSnippets(y),l=[];for(const c of Object.keys(v)){const t=this.extUri.joinPath(d,c),s=this.extUri.joinPath(this.snippetsFolder,c),r=await this.fileService.exists(s);l.push({resource:t,comparableResource:r?s:this.extUri.joinPath(this.syncPreviewFolder,c).with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"})})}return l}}return[]}async resolveContent(d){if(this.extUri.isEqualOrParent(d,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(d,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(d,this.syncPreviewFolder.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(d);let b=await super.resolveContent(d);if(b)return b;if(b=await super.resolveContent(this.extUri.dirname(d)),b){const y=this.parseSyncData(b);if(y)return this.parseSnippets(y)[this.extUri.basename(d)]||null}return null}async hasLocalData(){try{const d=await this.getSnippetsFileContents();if(Object.keys(d).length)return!0}catch(d){}return!1}async updateLocalBackup(d){const b={};for(const y of d)y.fileContent&&(b[this.extUri.basename(y.localResource)]=y.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(b)))}async updateLocalSnippets(d,b){for(const{fileContent:y,acceptResult:v,localResource:l,remoteResource:c,localChange:t}of d)if(t!==0){const s=c?this.extUri.basename(c):this.extUri.basename(l),r=this.extUri.joinPath(this.snippetsFolder,s);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(r)),await this.fileService.del(r),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(r))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(r)),await this.fileService.createFile(r,D.VSBuffer.fromString(v.content),{overwrite:b}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(r))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(r)),await this.fileService.writeFile(r,D.VSBuffer.fromString(v.content),b?void 0:y),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(r)))}}async updateRemoteSnippets(d,b,y){const v=b.syncData?this.parseSnippets(b.syncData):{},l=(0,R.deepClone)(v);for(const{acceptResult:c,localResource:t,remoteResource:s,remoteChange:r}of d)if(r!==0){const i=t?this.extUri.basename(t):this.extUri.basename(s);r===3?delete l[i]:l[i]=c.content}return(0,I.areSame)(v,l)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),b=await this.updateRemoteUserData(JSON.stringify(l),y?null:b.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),b}parseSnippets(d){return JSON.parse(d.content)}toSnippetsContents(d){const b={};for(const y of Object.keys(d))b[y]=d[y].value.toString();return b}async getSnippetsFileContents(){const d={};let b;try{b=await this.fileService.resolve(this.snippetsFolder)}catch(y){if(y instanceof C.FileOperationError&&y.fileOperationResult===1)return d;throw y}for(const y of b.children||[]){const v=y.resource,l=this.extUri.extname(v);if(l===".json"||l===".code-snippets"){const c=this.extUri.relativePath(this.snippetsFolder,v),t=await this.fileService.readFile(v);d[c]=t}}return d}};w=he([Q(0,k.IEnvironmentService),Q(1,C.IFileService),Q(2,S.IStorageService),Q(3,g.IUserDataSyncStoreService),Q(4,g.IUserDataSyncBackupStoreService),Q(5,g.IUserDataSyncLogService),Q(6,T.IConfigurationService),Q(7,g.IUserDataSyncResourceEnablementService),Q(8,E.ITelemetryService)],w),e.SnippetsSynchroniser=w;let f=class extends n.AbstractInitializer{constructor(d,b,y){super("snippets",b,y,d)}async doInitialize(d){const b=d.syncData?JSON.parse(d.syncData.content):null;if(!b){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const v of Object.keys(b)){const l=b[v];if(l){const c=this.extUri.joinPath(this.environmentService.snippetsHome,v);await this.fileService.createFile(c,D.VSBuffer.fromString(l)),this.logService.info("Created snippet",this.extUri.basename(c))}}await this.updateLastSyncUserData(d)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(d){return d.fileOperationResult===1}}};f=he([Q(0,C.IFileService),Q(1,k.IEnvironmentService),Q(2,g.IUserDataSyncLogService)],f),e.SnippetsInitializer=f}),define(te[62],ne([0,1,3,2,5,24]),function(J,e,D,L,R,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,R.createDecorator)("IUserDataSyncAccountService");let k=class extends L.Disposable{constructor(S){super();this.userDataSyncStoreService=S,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(S.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(S.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(S){(S&&this._account?S.token!==this._account.token||S.authenticationProviderId!==this._account.authenticationProviderId:S!==this._account)&&(this._account=S,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(S))}};k=he([Q(0,T.IUserDataSyncStoreService)],k),e.UserDataSyncAccountService=k}),define(te[221],ne([0,1,6,22,57,2,16,20,13,14,24]),function(J,e,D,L,R,T,k,C,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let I=class extends T.Disposable{constructor(w,f,p,d){super();this.environmentService=w,this.fileService=f,this.configurationService=p,this.logService=d,n.ALL_SYNC_RESOURCES.forEach(b=>this.cleanUpBackup(b))}async getAllRefs(w){const f=(0,k.joinPath)(this.environmentService.userDataSyncHome,w),p=await this.fileService.resolve(f);return p.children?p.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort().reverse().map(b=>({ref:b.name,created:this.getCreationTime(b)})):[]}async resolveContent(w,f){if(!f){const p=await this.getAllRefs(w);p.length&&(f=p[p.length-1].ref)}if(f){const p=(0,k.joinPath)(this.environmentService.userDataSyncHome,w,f);return(await this.fileService.readFile(p)).value.toString()}return null}async backup(w,f){const p=(0,k.joinPath)(this.environmentService.userDataSyncHome,w),d=(0,k.joinPath)(p,`${(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(d,L.VSBuffer.fromString(f))}catch(b){this.logService.error(b)}try{this.cleanUpBackup(w)}catch(b){}}async cleanUpBackup(w){const f=(0,k.joinPath)(this.environmentService.userDataSyncHome,w);try{try{if(!await this.fileService.exists(f))return}catch(d){return}const p=await this.fileService.resolve(f);if(p.children){const d=p.children.filter(l=>l.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(l.name)).sort(),b=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let y=d.filter(l=>Date.now()-this.getCreationTime(l)>b);const v=d.length-y.length;v<10&&(y=y.slice(10-v)),await D.Promises.settled(y.map(async l=>{this.logService.info("Deleting from backup",l.resource.path),await this.fileService.del(l.resource)}))}}catch(p){this.logService.error(p)}}getCreationTime(w){return w.ctime||new Date(parseInt(w.name.substring(0,4)),parseInt(w.name.substring(4,6))-1,parseInt(w.name.substring(6,8)),parseInt(w.name.substring(9,11)),parseInt(w.name.substring(11,13)),parseInt(w.name.substring(13,15))).getTime()}};I=he([Q(0,S.IEnvironmentService),Q(1,E.IFileService),Q(2,C.IConfigurationService),Q(3,n.IUserDataSyncLogService)],I),e.UserDataSyncBackupStoreService=I}),define(te[222],ne([0,1,2,7]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class R{constructor(g){this.service=g}listen(g,w){switch(w){case"onError":return this.service.onError}throw new Error(`Event not found: ${w}`)}call(g,w,f){switch(w){case"triggerSync":return this.service.triggerSync(f[0],f[1],f[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(f[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=R;class T{constructor(g){this.service=g}listen(g,w){throw new Error(`Event not found: ${w}`)}call(g,w,f){switch(w){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(f[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(L.URI.revive(f[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class k{constructor(g){this.channel=g}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(g){return this.channel.call("resolveUserKeybindings",[g])}async resolveFormattingOptions(g){return this.channel.call("resolveFormattingOptions",[g])}}e.UserDataSyncUtilServiceClient=k;class C{constructor(g){this.service=g}listen(g,w){switch(w){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${w}`)}async call(g,w,f){switch(w){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(f[0],f[1]);case"setEnablement":return this.service.setEnablement(f[0],f[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=C;class S{constructor(g){this.service=g}listen(g,w){switch(w){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${w}`)}call(g,w,f){switch(w){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(f)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=S;class E{constructor(g){this.service=g}listen(g,w){switch(w){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${w}`)}call(g,w,f){switch(w){case"switch":return this.service.switch(f[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=E;class n extends D.Disposable{constructor(g){super();this.channel=g,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(g){return this.channel.call("switch",[g])}async getPreviousUserDataSyncStore(){const g=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(g)}revive(g){return{url:L.URI.revive(g.url),type:g.type,defaultUrl:L.URI.revive(g.defaultUrl),insidersUrl:L.URI.revive(g.insidersUrl),stableUrl:L.URI.revive(g.stableUrl),canSwitch:g.canSwitch,authenticationProviders:g.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=n}),define(te[223],ne([0,1,13,10]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let R=class extends L.AbstractLogger{constructor(k,C){super();this.logger=this._register(k.createLogger(C.userDataSyncLogResource,{name:"settingssync"}))}trace(k,...C){this.logger.trace(k,...C)}debug(k,...C){this.logger.debug(k,...C)}info(k,...C){this.logger.info(k,...C)}warn(k,...C){this.logger.warn(k,...C)}error(k,...C){this.logger.error(k,...C)}critical(k,...C){this.logger.critical(k,...C)}flush(){this.logger.flush()}};R=he([Q(0,L.ILoggerService),Q(1,D.IEnvironmentService)],R),e.UserDataSyncLogService=R}),define(te[63],ne([0,1,3,2,4,25,146,13,14,5,29,45,23,24]),function(J,e,D,L,R,T,k,C,S,E,n,I,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,E.createDecorator)("IUserDataSyncMachinesService");const f="sync.currentMachineName";let p=class Ze extends L.Disposable{constructor(b,y,v,l,c,t){super();this.storageService=v,this.userDataSyncStoreService=l,this.logService=c,this.productService=t,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,I.getServiceMachineId)(b,y,v)}async getMachines(b){const y=await this.currentMachineIdPromise;return(await this.readMachinesData(b)).machines.map(l=>({...l,isCurrent:l.id===y}))}async addCurrentMachine(b){const y=await this.currentMachineIdPromise,v=await this.readMachinesData(b);v.machines.some(({id:l})=>l===y)||(v.machines.push({id:y,name:this.computeCurrentMachineName(v.machines)}),await this.writeMachinesData(v))}async removeCurrentMachine(b){const y=await this.currentMachineIdPromise,v=await this.readMachinesData(b),l=v.machines.filter(({id:c})=>c!==y);l.length!==v.machines.length&&(v.machines=l,await this.writeMachinesData(v))}async renameMachine(b,y,v){const l=await this.currentMachineIdPromise,c=await this.readMachinesData(v),t=c.machines.find(({id:s})=>s===b);t&&(t.name=y,await this.writeMachinesData(c),c.machines.some(({id:s})=>s===l)&&this.storageService.store(f,y,0,1))}async setEnablement(b,y){const v=await this.readMachinesData(),l=v.machines.find(({id:c})=>c===b);l&&(l.disabled=y?void 0:!0,await this.writeMachinesData(v))}computeCurrentMachineName(b){const y=this.storageService.get(f,0);if(y)return y;const v=`${this.productService.nameLong} (${(0,R.PlatformToString)(R.isWeb?0:R.platform)})`,l=new RegExp(`${(0,T.escapeRegExpCharacters)(v)}\\s#(\\d+)`);let c=0;for(const t of b){const s=l.exec(t.name),r=s?parseInt(s[1]):0;c=r>c?r:c}return`${v} #${c+1}`}async readMachinesData(b){this.userData=await this.readUserData(b);const y=this.parse(this.userData);if(y.version!==Ze.VERSION)throw new Error((0,k.localize)(0,null,this.productService.nameLong));return y}async writeMachinesData(b){const y=JSON.stringify(b),v=await this.userDataSyncStoreService.write(Ze.RESOURCE,y,this.userData?.ref||null);this.userData={ref:v,content:y},this._onDidChange.fire()}async readUserData(b){if(this.userData){const y=b&&b.latest?b.latest[Ze.RESOURCE]:void 0;if(this.userData.ref===y)return this.userData;if(y===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ze.RESOURCE,this.userData)}parse(b){if(b.content!==null)try{return JSON.parse(b.content)}catch(y){this.logService.error(y)}return{version:Ze.VERSION,machines:[]}}};p.VERSION=1,p.RESOURCE="machines",p=he([Q(0,C.IEnvironmentService),Q(1,S.IFileService),Q(2,g.IStorageService),Q(3,w.IUserDataSyncStoreService),Q(4,w.IUserDataSyncLogService),Q(5,n.IProductService)],p),e.UserDataSyncMachinesService=p}),define(te[98],ne([0,1,6,57,38,9,3,2,4,16,7,144,13,29,23,21,24,62,63]),function(J,e,D,L,R,T,k,C,S,E,n,I,g,w,f,p,d,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const v="sync.enable",l="sync.disableMachineEventually",c="sync.sessionId",t="sync.storeUrl",s="sync.productQuality";let r=class extends C.Disposable{constructor(u,h,m){super();this.storageService=u,this.environmentService=h,this.userDataSyncStoreManagementService=m,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(u.onDidChangeValue(A=>this.onDidStorageChange(A)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(v,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(u){u&&!this.canToggleEnablement()||this.storageService.store(v,u,0,1)}onDidStorageChange(u){if(u.scope===0&&v===u.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};r=he([Q(0,f.IStorageService),Q(1,g.IEnvironmentService),Q(2,d.IUserDataSyncStoreManagementService)],r),e.UserDataAutoSyncEnablementService=r;let i=class extends C.Disposable{constructor(u,h,m,A,_,O,N,P,M,$,U){super();this.userDataSyncStoreManagementService=h,this.userDataSyncStoreService=m,this.userDataSyncResourceEnablementService=A,this.userDataSyncService=_,this.logService=O,this.userDataSyncAccountService=N,this.telemetryService=P,this.userDataSyncMachinesService=M,this.storageService=$,this.autoSync=this._register(new C.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=U,this.syncTriggerDelayer=this._register(new D.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=h.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=u.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(h.onDidChangeUserDataSyncStore(()=>{(0,E.isEqual)(this.syncUrl,h.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=h.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(N.onDidChangeAccount(()=>this.updateAutoSync())),this._register(m.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(k.Event.debounce(_.onDidChangeLocal,(H,W)=>H?[...H,W]:[W],1e3)(H=>this.triggerSync(H,!1,!1))),this._register(k.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,H])=>H)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const u=this.storageService.get(t,0);return u?n.URI.parse(u):void 0}set syncUrl(u){u?this.storageService.store(t,u.toString(),0,1):this.storageService.remove(t,0)}get productQuality(){return this.storageService.get(s,0)}set productQuality(u){u?this.storageService.store(s,u,0,1):this.storageService.remove(s,0)}updateAutoSync(){const{enabled:u,message:h}=this.isAutoSyncEnabled();u?this.autoSync.value===void 0&&(this.autoSync.value=new a(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(m=>this.onDidFinishSync(m))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(h&&this.logService.info(h),this.autoSync.clear()):h&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(h))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,L.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(u,h,m){try{this.userDataSyncAccountService.account&&!m&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(c,0),u?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(A){if(h)this.logService.error(A),this.updateEnablement(!1);else throw A}}updateEnablement(u){this.userDataAutoSyncEnablementService.isEnabled()!==u&&(this.telemetryService.publicLog2(v,{enabled:u}),this.userDataAutoSyncEnablementService.setEnablement(u),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(u){if(!u){this.successiveFailures=0;return}const h=d.UserDataSyncError.toUserDataSyncError(u);h instanceof d.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:h.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),h.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):h.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):h.code==="LocalTooManyRequests"||h.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):h.code==="UpgradeRequired"||h.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):h.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${h.resource} content with newer version than of client. Requires client upgrade.`)):h.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${h.resource} content with older version than of client. Requires server reset.`)):h.code==="ServiceChanged"||h.code==="DefaultServiceChanged"?S.isWeb&&h.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(h),this.successiveFailures++),this._onError.fire(h)}async disableMachineEventually(){this.storageService.store(l,!0,0,1),await(0,D.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(l,0,!1)}stopDisableMachineEventually(){this.storageService.remove(l,0)}async triggerSync(u,h,m){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(h&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...u),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",m)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};i=he([Q(0,w.IProductService),Q(1,d.IUserDataSyncStoreManagementService),Q(2,d.IUserDataSyncStoreService),Q(3,d.IUserDataSyncResourceEnablementService),Q(4,d.IUserDataSyncService),Q(5,d.IUserDataSyncLogService),Q(6,b.IUserDataSyncAccountService),Q(7,p.ITelemetryService),Q(8,y.IUserDataSyncMachinesService),Q(9,f.IStorageService),Q(10,d.IUserDataAutoSyncEnablementService)],i),e.UserDataAutoSyncService=i;class a extends C.Disposable{constructor(u,h,m,A,_,O,N,P){super();this.lastSyncUrl=u,this.interval=h,this.userDataSyncStoreManagementService=m,this.userDataSyncStoreService=A,this.userDataSyncService=_,this.userDataSyncMachinesService=O,this.logService=N,this.storageService=P,this.intervalHandler=this._register(new C.MutableDisposable),this._onDidStartSync=this._register(new k.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new k.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,C.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(a.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(a.INTERVAL_SYNCING,!1),this.interval)}sync(u,h){const m=(0,D.createCancelablePromise)(async A=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(_){if((0,T.isPromiseCanceledError)(_))return}return this.doSync(u,h,A)});return this.syncPromise=m,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,E.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const u=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),h=this.userDataSyncStoreManagementService.userDataSyncStore;return!!h&&!!u&&(!(0,E.isEqual)(h.defaultUrl,u.defaultUrl)||!(0,E.isEqual)(h.insidersUrl,u.insidersUrl)||!(0,E.isEqual)(h.stableUrl,u.stableUrl))}async doSync(u,h,m){this.logService.info(`Auto Sync: Triggered by ${u}`),this._onDidStartSync.fire();let A;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,h),m.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new d.UserDataAutoSyncError((0,I.localize)(0,null),"DefaultServiceChanged"):new d.UserDataAutoSyncError((0,I.localize)(1,null),"ServiceChanged"):new d.UserDataAutoSyncError((0,I.localize)(2,null),"TurnedOff");const _=this.storageService.get(c,0);if(_&&this.manifest&&_!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new d.UserDataAutoSyncError((0,I.localize)(3,null),"DefaultServiceChanged"):new d.UserDataAutoSyncError((0,I.localize)(4,null),"ServiceChanged"):new d.UserDataAutoSyncError((0,I.localize)(5,null),"SessionExpired");const O=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(m.isCancellationRequested)return;const N=O.find(P=>P.isCurrent);if(N?.disabled)throw new d.UserDataAutoSyncError((0,I.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(P){throw new d.UserDataAutoSyncError((0,R.toErrorMessage)(P),P instanceof d.UserDataSyncError?P.code:"Unknown")}if(this.manifest&&this.manifest.session!==_&&this.storageService.store(c,this.manifest.session,0,1),m.isCancellationRequested)return;N||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(_){this.logService.error(_),A=_}this._onDidFinishSync.fire(A)}register(u){return super._register(u)}}a.INTERVAL_SYNCING="Interval"}),define(te[224],ne([0,1,3,2,4,23,21,24]),function(J,e,D,L,R,T,k,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let S=class extends L.Disposable{constructor(n,I){super();this.storageService=n,this.telemetryService=I,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(n.onDidChangeValue(g=>this.onDidStorageChange(g)))}isResourceEnabled(n){return this.storageService.getBoolean((0,C.getEnablementKey)(n),0,!0)}setResourceEnablement(n,I){if(this.isResourceEnabled(n)!==I){const g=(0,C.getEnablementKey)(n);this.telemetryService.publicLog2(g,{enabled:I}),this.storeResourceEnablement(g,I)}}getResourceSyncStateVersion(n){}storeResourceEnablement(n,I){this.storageService.store(n,I,0,R.isWeb?0:1)}onDidStorageChange(n){if(n.scope===0){const I=C.ALL_SYNC_RESOURCES.filter(g=>(0,C.getEnablementKey)(g)===n.key)[0];if(I){this._onDidChangeResourceEnablement.fire([I,this.isResourceEnabled(I)]);return}}}};S=he([Q(0,T.IStorageService),Q(1,k.ITelemetryService)],S),e.UserDataSyncResourceEnablementService=S}),define(te[225],ne([0,1,17,6,38,9,3,2,16,30,20,5,23,21,214,216,217,219,220,24]),function(J,e,D,L,R,T,k,C,S,E,n,I,g,w,f,p,d,b,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const l="sync.lastSyncTime";let c=class extends C.Disposable{constructor(i,a,o,u,h,m,A){super();this.userDataSyncStoreService=i,this.userDataSyncStoreManagementService=a,this.instantiationService=o,this.configurationService=u,this.logService=h,this.telemetryService=m,this.storageService=A,this._status="uninitialized",this._onDidChangeStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new k.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new k.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new k.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new k.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(b.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(d.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(y.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(p.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(f.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(k.Event.any(...this.synchronisers.map(_=>k.Event.map(_.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(k.Event.any(...this.synchronisers.map(_=>k.Event.map(_.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(l,0,void 0),this.onDidChangeLocal=k.Event.any(...this.synchronisers.map(_=>k.Event.map(_.onDidChangeLocal,()=>_.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(i,a){await this.checkEnablement();const o=(0,E.generateUuid)();try{const A=(0,v.createSyncHeaders)(o);a&&(A["Cache-Control"]="no-cache"),i=await this.userDataSyncStoreService.manifest(i,A)}catch(A){const _=v.UserDataSyncError.toUserDataSyncError(A);throw this.reportUserDataSyncError(_,o),_}let u=!1;const h=this;let m;return{manifest:i,run(){if(u)throw new Error("Can run a task only once");return m=(0,L.createCancelablePromise)(A=>h.sync(i,o,A)),m.finally(()=>m=void 0)},async stop(){if(m&&m.cancel(),h.status!=="idle")return h.stop()}}}async createManualSyncTask(){await this.checkEnablement();const i=(0,E.generateUuid)(),a=(0,v.createSyncHeaders)(i);let o;try{o=await this.userDataSyncStoreService.manifest(null,a)}catch(u){const h=v.UserDataSyncError.toUserDataSyncError(u);throw this.reportUserDataSyncError(h,i),h}return new t(i,o,a,this.synchronisers,this.configurationService,this.logService)}async sync(i,a,o){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),o.isCancellationRequested)return;const u=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const h=(0,v.createSyncHeaders)(a);for(const m of this.synchronisers){if(o.isCancellationRequested)return;try{await m.sync(i,h)}catch(A){let _=!1;if(A instanceof v.UserDataSyncError)switch(A.code){case"TooLarge":A=new v.UserDataSyncError(A.message,A.code,m.resource),_=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":_=!0;break}const O=v.UserDataSyncError.toUserDataSyncError(A);if(this.reportUserDataSyncError(O,a),_)throw O;this.logService.error(A),this.logService.error(`${m.resource}: ${(0,R.toErrorMessage)(A)}`),this._syncErrors.push([m.resource,O])}}this.logService.info(`Sync done. Took ${new Date().getTime()-u}ms`),this.updateLastSyncTime()}catch(h){const m=v.UserDataSyncError.toUserDataSyncError(h);throw this.reportUserDataSyncError(m,a),m}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const i of this.synchronisers)try{i.status!=="idle"&&await i.stop()}catch(a){this.logService.error(a)}}async replace(i){await this.checkEnablement();for(const a of this.synchronisers)if(await a.replace(i))return}async accept(i,a,o,u){await this.checkEnablement();const h=this.getSynchroniser(i);await h.accept(a,o),u&&await h.apply(!1,(0,v.createSyncHeaders)((0,E.generateUuid)()))}async resolveContent(i){for(const a of this.synchronisers){const o=await a.resolveContent(i);if(o)return o}return null}getRemoteSyncResourceHandles(i){return this.getSynchroniser(i).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(i){return this.getSynchroniser(i).getLocalSyncResourceHandles()}getAssociatedResources(i,a){return this.getSynchroniser(i).getAssociatedResources(a)}getMachineId(i,a){return this.getSynchroniser(i).getMachineId(a)}async hasLocalData(){const i=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const a of i)if(await a.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(i){this.logService.error(i)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(l,0);for(const i of this.synchronisers)try{await i.resetLocal()}catch(a){this.logService.error(`${i.resource}: ${(0,R.toErrorMessage)(a)}`),this.logService.error(a)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const i of this.synchronisers)if(await i.hasPreviouslySynced())return!0;return!1}setStatus(i){const a=this._status;this._status!==i&&(this._status=i,this._onDidChangeStatus.fire(i),a==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const i=this.computeStatus();this.setStatus(i)}updateConflicts(){const i=this.computeConflicts();(0,D.equals)(this._conflicts,i,([a,o],[u,h])=>a===a&&(0,D.equals)(o,h,(m,A)=>(0,S.isEqual)(m.previewResource,A.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(i))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(l,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(i,a){this.telemetryService.publicLog2("sync/error",{code:i.code,serverCode:i instanceof v.UserDataSyncStoreError?String(i.serverCode):void 0,url:i instanceof v.UserDataSyncStoreError?i.url:void 0,resource:i.resource,executionId:a,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(i=>i.status==="hasConflicts").map(i=>[i.resource,i.conflicts.map(s)])}getSynchroniser(i){return this.synchronisers.find(a=>a.resource===i)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};c=he([Q(0,v.IUserDataSyncStoreService),Q(1,v.IUserDataSyncStoreManagementService),Q(2,I.IInstantiationService),Q(3,n.IConfigurationService),Q(4,v.IUserDataSyncLogService),Q(5,w.ITelemetryService),Q(6,g.IStorageService)],c),e.UserDataSyncService=c;class t extends C.Disposable{constructor(i,a,o,u,h,m){super();this.id=i,this.manifest=a,this.syncHeaders=o,this.synchronisers=u,this.configurationService=h,this.logService=m,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new k.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,L.createCancelablePromise)(i=>this.getPreviews(i))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(i){throw this.logService.error(i),i}}async accept(i,a){try{return await this.performAction(i,o=>o.accept(i,a))}catch(o){throw this.logService.error(o),o}}async merge(i){try{return i?await this.performAction(i,a=>a.merge(i)):await this.mergeAll()}catch(a){throw this.logService.error(a),a}}async discard(i){try{return await this.performAction(i,a=>a.discard(i))}catch(a){throw this.logService.error(a),a}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const i=[];for(const[,a]of this.previews)for(const o of a.resourcePreviews)o.mergeState==="conflict"&&i.push(o.previewResource);for(const a of i)await this.discard(a);return this.previews}catch(i){throw this.logService.error(i),i}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const i=[];for(const[a,o]of this.previews){this.synchronizingResources.push([a,o.resourcePreviews.map(m=>m.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(m=>m.resource===a);for(const m of o.resourcePreviews)(m.localChange!==0||m.remoteChange!==0)&&m.mergeState==="preview"&&await u.merge(m.previewResource);const h=await u.apply(!1,this.syncHeaders);h&&i.push(this.toSyncResourcePreview(u.resource,h)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(m=>m[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}catch(i){throw this.logService.error(i),i}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,a]of this.previews){this.synchronizingResources.push([i,a.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const o=this.synchronisers.find(u=>u.resource===i);for(const u of a.resourcePreviews)await o.accept(u.remoteResource);await o.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,a]of this.previews){this.synchronizingResources.push([i,a.resourcePreviews.map(u=>u.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const o=this.synchronisers.find(u=>u.resource===i);for(const u of a.resourcePreviews)await o.accept(u.localResource);await o.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(u=>u[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async stop(){for(const i of this.synchronisers)try{await i.stop()}catch(a){(0,T.isPromiseCanceledError)(a)||this.logService.error(a)}this.reset()}async performAction(i,a){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const o=this.previews.findIndex(([,P])=>P.resourcePreviews.some(({localResource:M,previewResource:$,remoteResource:U})=>(0,S.isEqual)(i,M)||(0,S.isEqual)(i,$)||(0,S.isEqual)(i,U)));if(o===-1)return this.previews;const[u,h]=this.previews[o],m=h.resourcePreviews.find(({localResource:P,remoteResource:M,previewResource:$})=>(0,S.isEqual)(P,i)||(0,S.isEqual)(M,i)||(0,S.isEqual)($,i));if(!m)return this.previews;let A=this.synchronizingResources.find(P=>P[0]===u);A||(A=[u,[]],this.synchronizingResources.push(A)),A[1].some(P=>(0,S.isEqual)(P,m.localResource))||(A[1].push(m.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const _=this.synchronisers.find(P=>P.resource===this.previews[o][0]),O=await a(_);O?this.previews.splice(o,1,this.toSyncResourcePreview(_.resource,O)):this.previews.splice(o,1);const N=this.synchronizingResources.findIndex(P=>P[0]===u);return this.synchronizingResources[N][1].splice(A[1].findIndex(P=>(0,S.isEqual)(P,m.localResource)),1),A[1].length||(this.synchronizingResources.splice(N,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const i=[];for(const[a,o]of this.previews){this.synchronizingResources.push([a,o.resourcePreviews.map(m=>m.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(m=>m.resource===a);let h=o;for(const m of o.resourcePreviews)(m.localChange!==0||m.remoteChange!==0)&&m.mergeState==="preview"&&(h=await u.merge(m.previewResource));h&&i.push(this.toSyncResourcePreview(u.resource,h)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(m=>m[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}async getPreviews(i){const a=[],o=await this.getUserDataSyncConfiguration();for(const u of this.synchronisers){if(i.isCancellationRequested)return[];const h=await u.preview(this.manifest,o,this.syncHeaders);h&&a.push(this.toSyncResourcePreview(u.resource,h))}return a}async getUserDataSyncConfiguration(){const i=this.configurationService.getValue(v.USER_DATA_SYNC_CONFIGURATION_SCOPE),a=await this.synchronisers.find(o=>o instanceof b.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...i,...a}}toSyncResourcePreview(i,a){return[i,{isLastSyncFromCurrentMachine:a.isLastSyncFromCurrentMachine,resourcePreviews:a.resourcePreviews.map(s)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function s(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(te[226],ne([0,1,3,2,18,7,24]),function(J,e,D,L,R,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class C{constructor(I,g){this.service=I,this.logService=g,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(I,g){switch(g){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${g}`)}async call(I,g,w){try{return await this._call(I,g,w)}catch(f){throw this.logService.error(f),f}}async _call(I,g,w){switch(g){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(T.URI.revive(w[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(w[0],T.URI.revive(w[1]),w[2],w[3]);case"resolveContent":return this.service.resolveContent(T.URI.revive(w[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(w[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(w[0]);case"getAssociatedResources":return this.service.getAssociatedResources(w[0],{created:w[1].created,uri:T.URI.revive(w[1].uri)});case"getMachineId":return this.service.getMachineId(w[0],{created:w[1].created,uri:T.URI.revive(w[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(g.startsWith("manualSync/")){const f=g.substring("manualSync/".length),p=w[0],d=this.getManualSyncTask(p);switch(w=w.slice(1),f){case"preview":return d.preview();case"accept":return d.accept(T.URI.revive(w[0]),w[1]);case"merge":return d.merge(T.URI.revive(w[0]));case"discard":return d.discard(T.URI.revive(w[0]));case"discardConflicts":return d.discardConflicts();case"apply":return d.apply();case"pull":return d.pull();case"push":return d.push();case"stop":return d.stop();case"_getStatus":return d.status;case"dispose":return this.disposeManualSyncTask(d)}}throw new Error("Invalid call")}getManualSyncTask(I){const g=this.manualSyncTasks.get(this.createKey(I));if(!g)throw new Error(`Manual sync taks not found: ${I}`);return g.manualSyncTask}async createManualSyncTask(){const I=new L.DisposableStore,g=I.add(await this.service.createManualSyncTask());return I.add(g.onSynchronizeResources(w=>this.onManualSynchronizeResources.fire({manualSyncTaskId:g.id,data:w}))),this.manualSyncTasks.set(this.createKey(g.id),{manualSyncTask:g,disposables:I}),{id:g.id,manifest:g.manifest,status:g.status}}disposeManualSyncTask(I){I.dispose();const g=this.createKey(I.id);this.manualSyncTasks.get(g)?.disposables.dispose(),this.manualSyncTasks.delete(g)}createKey(I){return`manualSyncTask-${I}`}}e.UserDataSyncChannel=C;class S extends L.Disposable{constructor(I){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(g,w,f){return I.call(g,w,f).then(null,p=>{throw k.UserDataSyncError.toUserDataSyncError(p)})},listen(g,w){return I.listen(g,w)}},this.channel.call("_getInitialData").then(([g,w,f])=>{this.updateStatus(g),this.updateConflicts(w),f&&this.updateLastSyncTime(f),this._register(this.channel.listen("onDidChangeStatus")(p=>this.updateStatus(p))),this._register(this.channel.listen("onDidChangeLastSyncTime")(p=>this.updateLastSyncTime(p)))}),this._register(this.channel.listen("onDidChangeConflicts")(g=>this.updateConflicts(g))),this._register(this.channel.listen("onSyncErrors")(g=>this._onSyncErrors.fire(g.map(([w,f])=>[w,k.UserDataSyncError.toUserDataSyncError(f)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:I,manifest:g,status:w}=await this.channel.call("createManualSyncTask"),f=this,p=new E(I,g,w,{async call(d,b,y){return f.channel.call(`manualSync/${d}`,[I,...(0,R.isArray)(b)?b:[b]],y)},listen(d,b){return D.Event.map(D.Event.filter(f.channel.listen(`manualSync/${d}`,b),y=>!p.isDiposed()&&y.manualSyncTaskId===I),y=>y.data)}});return p}replace(I){return this.channel.call("replace",[I])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(I,g,w,f){return this.channel.call("accept",[I,g,w,f])}resolveContent(I){return this.channel.call("resolveContent",[I])}async getLocalSyncResourceHandles(I){return(await this.channel.call("getLocalSyncResourceHandles",[I])).map(({created:w,uri:f})=>({created:w,uri:T.URI.revive(f)}))}async getRemoteSyncResourceHandles(I){return(await this.channel.call("getRemoteSyncResourceHandles",[I])).map(({created:w,uri:f})=>({created:w,uri:T.URI.revive(f)}))}async getAssociatedResources(I,g){return(await this.channel.call("getAssociatedResources",[I,g])).map(({resource:f,comparableResource:p})=>({resource:T.URI.revive(f),comparableResource:T.URI.revive(p)}))}async getMachineId(I,g){return this.channel.call("getMachineId",[I,g])}async updateStatus(I){this._status=I,this._onDidChangeStatus.fire(I)}async updateConflicts(I){this._conflicts=I.map(([g,w])=>[g,w.map(f=>({...f,localResource:T.URI.revive(f.localResource),remoteResource:T.URI.revive(f.remoteResource),previewResource:T.URI.revive(f.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(I){this._lastSyncTime!==I&&(this._lastSyncTime=I,this._onDidChangeLastSyncTime.fire(I))}}e.UserDataSyncChannelClient=S;class E extends L.Disposable{constructor(I,g,w,f){super();this.id=I,this.manifest=g,this._disposed=!1,this._status=w;const p=this;this.channel={async call(d,b,y){try{const v=await f.call(d,b,y);return p.isDiposed()||(p._status=await f.call("_getStatus")),v}catch(v){throw k.UserDataSyncError.toUserDataSyncError(v)}},listen(d,b){return f.listen(d,b)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const I=await this.channel.call("preview");return this.deserializePreviews(I)}async accept(I,g){const w=await this.channel.call("accept",[I,g]);return this.deserializePreviews(w)}async merge(I){const g=await this.channel.call("merge",[I]);return this.deserializePreviews(g)}async discard(I){const g=await this.channel.call("discard",[I]);return this.deserializePreviews(g)}async discardConflicts(){const I=await this.channel.call("discardConflicts");return this.deserializePreviews(I)}async apply(){const I=await this.channel.call("apply");return this.deserializePreviews(I)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(I){return I.map(([g,w])=>[g,{isLastSyncFromCurrentMachine:w.isLastSyncFromCurrentMachine,resourcePreviews:w.resourcePreviews.map(f=>({...f,localResource:T.URI.revive(f.localResource),remoteResource:T.URI.revive(f.remoteResource),previewResource:T.URI.revive(f.previewResource),acceptedResource:T.URI.revive(f.acceptedResource)}))}])}}}),define(te[227],ne([0,1,6,27,9,3,2,105,4,16,18,7,30,20,13,14,29,43,45,23,24]),function(J,e,D,L,R,T,k,C,S,E,n,I,g,w,f,p,d,b,y,v,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const c="sync.previous.store",t="sync.donot-make-requests-until",s="sync.user-session-id",r="sync.machine-session-id",i=100,a=1e3*60*5;let o=class extends k.Disposable{constructor(O,N,P){super();this.productService=O,this.configurationService=N,this.storageService=P,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(P.onDidChangeValue,M=>M.key===l.SYNC_SERVICE_URL_TYPE&&M.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(l.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(l.SYNC_SERVICE_URL_TYPE,O,0,S.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[l.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(l.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,N){O=S.isWeb&&O?.web?{...O,...O.web}:O;const P={...O||{},...N||{}};if(P&&(0,n.isString)(P.url)&&(0,n.isObject)(P.authenticationProviders)&&Object.keys(P.authenticationProviders).every(M=>(0,n.isArray)(P.authenticationProviders[M].scopes))){const M=P,$=!!M.canSwitch&&!N?.url,U=M.url===M.insidersUrl?"insiders":"stable",H=($?this.userDataSyncStoreType:void 0)||U,W=N?.url||(H==="insiders"?M.insidersUrl:H==="stable"?M.stableUrl:M.url);return{url:I.URI.parse(W),type:H,defaultType:U,defaultUrl:I.URI.parse(M.url),stableUrl:I.URI.parse(M.stableUrl),insidersUrl:I.URI.parse(M.insidersUrl),canSwitch:$,authenticationProviders:Object.keys(M.authenticationProviders).reduce((q,x)=>(q.push({id:x,scopes:M.authenticationProviders[x].scopes}),q),[])}}}};o=he([Q(0,d.IProductService),Q(1,w.IConfigurationService),Q(2,v.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let u=class extends o{constructor(O,N,P){super(O,N,P);const M=this.storageService.get(c,0);M&&(this.previousConfigurationSyncStore=JSON.parse(M));const $=this.productService[l.CONFIGURATION_SYNC_STORE_KEY];$?this.storageService.store(c,JSON.stringify($),0,1):this.storageService.remove(c,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};u=he([Q(0,d.IProductService),Q(1,w.IConfigurationService),Q(2,v.IStorageService)],u),e.UserDataSyncStoreManagementService=u;let h=class extends k.Disposable{constructor(O,N,P,M,$,U,H){super();this.requestService=P,this.logService=M,this.storageService=H,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,y.getServiceMachineId)($,U,H).then(W=>{const q={"X-Client-Name":`${N.applicationName}${S.isWeb?"-web":""}`,"X-Client-Version":N.version};return N.commit&&(q["X-Client-Commit"]=N.commit),q}),this.session=new A(i,a,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,k.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,N){this.authToken={token:O,type:N}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,E.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(t,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(N=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),N).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,N=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O),P={},M=await this.request(N.toString(),{type:"GET",headers:P},[],L.CancellationToken.None);return(await(0,b.asJson)(M)||[]).map(({url:U,created:H})=>({ref:(0,E.relativePath)(N,N.with({path:U})),created:H*1e3}))}async resolveContent(O,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const P=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O,N).toString(),M={};M["Cache-Control"]="no-cache";const $=await this.request(P,{type:"GET",headers:M},[],L.CancellationToken.None);return await(0,b.asText)($)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),P={};await this.request(N,{type:"DELETE",headers:P},[],L.CancellationToken.None)}async read(O,N,P={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();P={...P},P["Cache-Control"]="no-cache",N&&(P["If-None-Match"]=N.ref);const $=await this.request(M,{type:"GET",headers:P},[304],L.CancellationToken.None);let U=null;if($.res.statusCode===304&&(U=N),U===null){const H=$.res.headers.etag;if(!H)throw new l.UserDataSyncStoreError("Server did not return the ref",M,"NoRef",$.res.statusCode,$.res.headers[l.HEADER_OPERATION_ID]);const W=await(0,b.asText)($);if(!W&&$.res.statusCode===304)throw new l.UserDataSyncStoreError("Empty response",M,"EmptyResponse",$.res.statusCode,$.res.headers[l.HEADER_OPERATION_ID]);U={ref:H,content:W}}return U}async write(O,N,P,M={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();M={...M},M["Content-Type"]=C.Mimes.text,P&&(M["If-Match"]=P);const U=await this.request($,{type:"POST",data:N,headers:M},[],L.CancellationToken.None),H=U.res.headers.etag;if(!H)throw new l.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",U.res.statusCode,U.res.headers[l.HEADER_OPERATION_ID]);return H}async manifest(O,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const P=(0,E.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();N={...N},N["Content-Type"]="application/json",O&&(N["If-None-Match"]=O.ref);const M=await this.request(P,{type:"GET",headers:N},[304],L.CancellationToken.None);let $=null;if(M.res.statusCode===304&&($=O),!$){const H=M.res.headers.etag;if(!H)throw new l.UserDataSyncStoreError("Server did not return the ref",P,"NoRef",M.res.statusCode,M.res.headers[l.HEADER_OPERATION_ID]);const W=await(0,b.asText)(M);if(!W&&M.res.statusCode===304)throw new l.UserDataSyncStoreError("Empty response",P,"EmptyResponse",M.res.statusCode,M.res.headers[l.HEADER_OPERATION_ID]);W&&($={...JSON.parse(W),ref:H})}const U=this.storageService.get(s,0);return U&&$&&U!==$.session&&this.clearSession(),$===null&&U&&this.clearSession(),$&&this.storageService.store(s,$.session,0,1),$}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),N={"Content-Type":C.Mimes.text};await this.request(O,{type:"DELETE",headers:N},[],L.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(s,0),this.storageService.remove(r,0)}async request(O,N,P,M){if(!this.authToken)throw new l.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new l.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const $=await this.commonHeadersPromise;N.headers={...N.headers||{},...$,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(N.headers),this.logService.trace("Sending request to server",{url:O,type:N.type,headers:{...N.headers,authorization:void 0}});let U;try{U=await this.session.request(O,N,M)}catch(x){if(!(x instanceof l.UserDataSyncStoreError)){let F="RequestFailed";const K=(0,R.getErrorMessage)(x).toLowerCase();K.includes("xhr timeout")?F="RequestTimeout":K.includes("protocol")&&K.includes("not supported")?F="RequestProtocolNotSupported":K.includes("request path contains unescaped characters")?F="RequestPathNotEscaped":K.includes("headers must be an object")?F="RequestHeadersNotObject":(0,R.isPromiseCanceledError)(x)&&(F="RequestCanceled"),x=new l.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,F,void 0,void 0)}throw this.logService.info("Request failed",O),x}const H=U.res.headers[l.HEADER_OPERATION_ID],W={url:O,status:U.res.statusCode,"execution-id":N.headers[l.HEADER_EXECUTION_ID],"operation-id":H},q=(0,b.isSuccess)(U)||U.res.statusCode&&P.indexOf(U.res.statusCode)!==-1;if(q?this.logService.trace("Request succeeded",W):this.logService.info("Request failed",W),U.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new l.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",U.res.statusCode,H);if(this._onTokenSucceed.fire(),U.res.statusCode===409)throw new l.UserDataSyncStoreError(`${N.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",U.res.statusCode,H);if(U.res.statusCode===410)throw new l.UserDataSyncStoreError(`${N.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",U.res.statusCode,H);if(U.res.statusCode===412)throw new l.UserDataSyncStoreError(`${N.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",U.res.statusCode,H);if(U.res.statusCode===413)throw new l.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",U.res.statusCode,H);if(U.res.statusCode===426)throw new l.UserDataSyncStoreError(`${N.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",U.res.statusCode,H);if(U.res.statusCode===429){const x=U.res.headers["retry-after"];throw x?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(x)*1e3)),new l.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",U.res.statusCode,H)):new l.UserDataSyncStoreError(`${N.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",U.res.statusCode,H)}if(!q)throw new l.UserDataSyncStoreError("Server returned "+U.res.statusCode,O,"Unknown",U.res.statusCode,H);return U}addSessionHeaders(O){let N=this.storageService.get(r,0);N===void 0&&(N=(0,g.generateUuid)(),this.storageService.store(r,N,0,1)),O["X-Machine-Session-Id"]=N;const P=this.storageService.get(s,0);P!==void 0&&(O["X-User-Session-Id"]=P)}};h=he([Q(1,d.IProductService),Q(2,b.IRequestService),Q(3,l.IUserDataSyncLogService),Q(4,f.IEnvironmentService),Q(5,p.IFileService),Q(6,v.IStorageService)],h),e.UserDataSyncStoreClient=h;let m=class extends h{constructor(O,N,P,M,$,U,H){super(O.userDataSyncStore?.url,N,P,M,$,U,H);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};m=he([Q(0,l.IUserDataSyncStoreManagementService),Q(1,d.IProductService),Q(2,b.IRequestService),Q(3,l.IUserDataSyncLogService),Q(4,f.IEnvironmentService),Q(5,p.IFileService),Q(6,v.IStorageService)],m),e.UserDataSyncStoreService=m;class A{constructor(O,N,P,M){this.limit=O,this.interval=N,this.requestService=P,this.logService=M,this.requests=[],this.startTime=void 0}request(O,N,P){if(this.isExpired()&&this.reset(),N.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new l.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(N,P)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=A}),define(te[228],ne([0,1,3,59,29,23,21,98,24,62,63]),function(J,e,D,L,R,T,k,C,S,E,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let I=class extends C.UserDataAutoSyncService{constructor(w,f,p,d,b,y,v,l,c,t,s,r){super(w,f,p,d,b,v,l,c,t,s,r);this._register(D.Event.debounce(D.Event.any(D.Event.map(y.onDidFocusWindow,()=>"windowFocus"),D.Event.map(y.onDidOpenWindow,()=>"windowOpen")),(i,a)=>i?[...i,a]:[a],1e3)(i=>this.triggerSync(i,!0,!1)))}};I=he([Q(0,R.IProductService),Q(1,S.IUserDataSyncStoreManagementService),Q(2,S.IUserDataSyncStoreService),Q(3,S.IUserDataSyncResourceEnablementService),Q(4,S.IUserDataSyncService),Q(5,L.INativeHostService),Q(6,S.IUserDataSyncLogService),Q(7,E.IUserDataSyncAccountService),Q(8,k.ITelemetryService),Q(9,n.IUserDataSyncMachinesService),Q(10,T.IStorageService),Q(11,S.IUserDataAutoSyncEnablementService)],I),e.UserDataAutoSyncService=I}),define(te[229],ne([0,1,6,3,2]),function(J,e,D,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends R.Disposable{constructor({onDidOpenWindow:C,onDidFocusWindow:S,getActiveWindowId:E}){super();this.disposables=this._register(new R.DisposableStore),L.Event.latch(L.Event.any(C,S))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>E()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch(I){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(C){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=C}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(te[64],ne([0,1,51,6,8,18,19,122,240,241]),function(J,e,D,L,R,T,k,C,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class n extends Error{constructor(t,s){let r=s.message;switch(t){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r);this.type=t,this.cause=s}}e.ExtractError=n;function I(c){const t=c.externalFileAttributes>>16||33188;return[448,56,7].map(s=>t&s).reduce((s,r)=>s+r,t&61440)}function g(c){if(c instanceof n)return c;let t;return/end of central directory record signature not found/.test(c.message)&&(t="CorruptZip"),new n(t,c)}function w(c,t,s,r,i,a){const o=R.dirname(t),u=R.join(r,o);if(!u.startsWith(r))return Promise.reject(new Error(C.localize(0,null,t)));const h=R.join(r,t);let m;return a.onCancellationRequested(()=>{m&&m.destroy()}),Promise.resolve(k.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((A,_)=>{if(!a.isCancellationRequested)try{m=(0,D.createWriteStream)(h,{mode:s}),m.once("close",()=>A()),m.once("error",_),c.once("error",_),c.pipe(m)}catch(O){_(O)}}))}function f(c,t,s,r){let i=(0,L.createCancelablePromise)(()=>Promise.resolve()),a=0;return r.onCancellationRequested(()=>{i.cancel(),c.close()}),new Promise((o,u)=>{const h=new L.Sequencer,m=A=>{A.isCancellationRequested||(a++,c.readEntry())};c.once("error",u),c.once("close",()=>i.then(()=>{r.isCancellationRequested||c.entryCount===a?o():u(new n("Incomplete",new Error(C.localize(1,null,a,c.entryCount))))},u)),c.readEntry(),c.on("entry",A=>{if(r.isCancellationRequested)return;if(!s.sourcePathRegex.test(A.fileName)){m(r);return}const _=A.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(_)){const P=R.join(t,_);i=(0,L.createCancelablePromise)(M=>k.Promises.mkdir(P,{recursive:!0}).then(()=>m(M)).then(void 0,u));return}const O=d(c,A),N=I(A);i=(0,L.createCancelablePromise)(P=>h.queue(()=>O.then(M=>w(M,_,N,t,s,P).then(()=>m(P)))).then(null,u))})})}function p(c,t=!1){return new Promise((s,r)=>{(0,S.open)(c,t?{lazyEntries:!0}:void 0,(i,a)=>{i?r(g(i)):s((0,T.assertIsDefined)(a))})})}function d(c,t){return new Promise((s,r)=>{c.openReadStream(t,(i,a)=>{i?r(g(i)):s((0,T.assertIsDefined)(a))})})}function b(c,t){return new Promise((s,r)=>{const i=new E.ZipFile;t.forEach(o=>{o.contents?i.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&i.addFile(o.localPath,o.path)}),i.end();const a=(0,D.createWriteStream)(c);i.outputStream.pipe(a),i.outputStream.once("error",r),a.once("error",r),a.once("finish",()=>s(c))})}e.zip=b;function y(c,t,s={},r){const i=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let a=p(c,!0);return s.overwrite&&(a=a.then(o=>k.Promises.rm(t).then(()=>o))),a.then(o=>f(o,t,{sourcePathRegex:i},r))}e.extract=y;function v(c,t){return p(c).then(s=>new Promise((r,i)=>{s.on("entry",a=>{a.fileName===t&&d(s,a).then(o=>r(o),o=>i(o))}),s.once("close",()=>i(new Error(C.localize(2,null,t))))}))}function l(c,t){return v(c,t).then(s=>new Promise((r,i)=>{const a=[];s.once("error",i),s.on("data",o=>a.push(o)),s.on("end",()=>r(Buffer.concat(a)))}))}e.buffer=l}),define(te[230],ne([0,1,64,131]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function R(T){return(0,D.buffer)(T,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch(C){throw new Error((0,L.localize)(0,null))}})}e.getManifest=R}),define(te[231],ne([0,1,17,6,9,2,15,8,4,16,60,7,30,19,64,132,13,28,35,151,14,10,29]),function(J,e,D,L,R,T,k,C,S,E,n,I,g,w,f,p,d,b,y,v,l,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const s="scanningSystem",r="scanningUser",i="extracting",a="deleting",o="renaming";let u=class extends T.Disposable{constructor(m,A,_,O,N){super();this.beforeRemovingExtension=m,this.fileService=A,this.logService=_,this.environmentService=O,this.productService=N,this._devSystemExtensionsPath=null,this.systemExtensionsPath=O.builtinExtensionsPath,this.extensionsPath=O.extensionsPath,this.uninstalledPath=C.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new L.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(m){const A=[];(m===null||m===0)&&A.push(this.scanSystemExtensions().then(null,_=>Promise.reject(new b.ExtensionManagementError(this.joinErrors(_).message,s)))),(m===null||m===1)&&A.push(this.scanUserExtensions(!0).then(null,_=>Promise.reject(new b.ExtensionManagementError(this.joinErrors(_).message,r))));try{const _=await Promise.all(A);return(0,D.flatten)(_)}catch(_){throw this.joinErrors(_)}}async scanUserExtensions(m){this.logService.trace("Started scanning user extensions");let[A,_]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return _=_.filter(O=>!A[new y.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).key()]),m&&(_=(0,y.groupByExtension)(_,N=>N.identifier).map(N=>N.sort((P,M)=>n.rcompare(P.manifest.version,M.manifest.version))[0])),this.logService.trace("Scanned user extensions:",_.length),_}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(m,A,_,O){const N=m.key(),P=C.join(this.extensionsPath,`.${(0,g.generateUuid)()}`),M=C.join(this.extensionsPath,N);try{await w.Promises.rm(M)}catch(U){try{await w.Promises.rm(M)}catch(H){}throw new b.ExtensionManagementError((0,p.localize)(0,null,M,m.id),a)}await this.extractAtLocation(m,A,P,O);let $=await this.scanExtension(I.URI.file(P),1);if(!$)throw new Error((0,p.localize)(1,null,P));await this.storeMetadata($,{..._,installedTimestamp:Date.now()});try{await this.rename(m,P,M,Date.now()+2*60*1e3),this.logService.info("Renamed to",M)}catch(U){try{await w.Promises.rm(P)}catch(H){}if(U.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",m.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(U)}. Deleted from extracted location`,P),U}try{$=await this.scanExtension(I.URI.file(M),1)}catch(U){}if($)return $;throw new Error((0,p.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(m,A){return this.setMetadata(m,A),await this.storeMetadata(m,{...A,installedTimestamp:m.installedTimestamp}),m}async storeMetadata(m,A){A.isMachineScoped=A.isMachineScoped||void 0,A.isBuiltin=A.isBuiltin||void 0,A.installedTimestamp=A.installedTimestamp||void 0;const _=C.join(m.location.fsPath,"package.json"),O=await w.Promises.readFile(_,"utf8"),{manifest:N}=await this.parseManifest(O);return N.__metadata=A,await w.Promises.writeFile(_,JSON.stringify(N,null,"	")),m}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...m){const A=m.map(_=>new y.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version));await this.withUninstalledExtensions(_=>{A.forEach(O=>_[O.key()]=!0)})}async setInstalled(m){await this.withUninstalledExtensions(O=>delete O[m.key()]);const _=(await this.scanExtensions(1)).find(O=>new y.ExtensionIdentifierWithVersion(O.identifier,O.manifest.version).equals(m))||null;return _?(await this.storeMetadata(_,{installedTimestamp:Date.now()}),this.scanExtension(_.location,1)):null}async withUninstalledExtensions(m){return this.uninstalledFileLimiter.queue(async()=>{let A;try{A=await w.Promises.readFile(this.uninstalledPath,"utf8")}catch(O){if(O.code!=="ENOENT")throw O}let _={};if(A)try{_=JSON.parse(A)}catch(O){}return m&&(m(_),Object.keys(_).length?await w.Promises.writeFile(this.uninstalledPath,JSON.stringify(_)):await w.Promises.rm(this.uninstalledPath)),_})}async removeExtension(m,A){this.logService.trace(`Deleting ${A} extension from disk`,m.identifier.id,m.location.fsPath),await w.Promises.rm(m.location.fsPath),this.logService.info("Deleted from disk",m.identifier.id,m.location.fsPath)}async removeUninstalledExtension(m){await this.removeExtension(m,"uninstalled"),await this.withUninstalledExtensions(A=>delete A[new y.ExtensionIdentifierWithVersion(m.identifier,m.manifest.version).key()])}async extractAtLocation(m,A,_,O){this.logService.trace(`Started extracting the extension from ${A} to ${_}`);try{await w.Promises.rm(_)}catch(N){throw new b.ExtensionManagementError(this.joinErrors(N).message,a)}try{await(0,f.extract)(A,_,{sourcePath:"extension",overwrite:!0},O),this.logService.info(`Extracted extension to ${_}:`,m.id)}catch(N){try{await w.Promises.rm(_)}catch(P){}throw new b.ExtensionManagementError(N.message,N instanceof f.ExtractError&&N.type?N.type:i)}}async rename(m,A,_,O){try{await w.Promises.rename(A,_)}catch(N){if(S.isWindows&&N&&N.code==="EPERM"&&Date.now()<O)return this.logService.info(`Failed renaming ${A} to ${_} with 'EPERM' error. Trying again...`,m.id),this.rename(m,A,_,O);throw new b.ExtensionManagementError(N.message||(0,p.localize)(3,null,A,_),N.code||o)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const m=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return m;const A=this.scanDevSystemExtensions(),[_,O]=await Promise.all([m,A]);return[..._,...O]}async scanExtensionsInDir(m,A){const _=new L.Limiter(10),O=await this.fileService.resolve(I.URI.file(m));return O.children?(await Promise.all(O.children.filter(P=>P.isDirectory).map(P=>_.queue(async()=>A===1&&(0,E.basename)(P.resource).indexOf(".")===0?null:this.scanExtension(P.resource,A))))).filter(P=>P&&P.identifier):[]}async scanExtension(m,A){try{const _=await this.fileService.resolve(m);if(_.children){const{manifest:O,metadata:N}=await this.readManifest(m.fsPath),P=_.children.find(({name:H})=>/^readme(\.txt|\.md|)$/i.test(H))?.resource,M=_.children.find(({name:H})=>/^changelog(\.txt|\.md|)$/i.test(H))?.resource,$={id:(0,y.getGalleryExtensionId)(O.publisher,O.name)},U={type:A,identifier:$,manifest:O,location:m,readmeUrl:P,changelogUrl:M,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:A===0};return N&&(this.setMetadata(U,N),U.installedTimestamp=N.installedTimestamp),U}}catch(_){A!==0&&this.logService.trace(_)}return null}async scanDefaultSystemExtensions(){const m=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",m.length),m}async scanDevSystemExtensions(){const m=this.getDevSystemExtensionsList();if(m.length){const A=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",A.length),A.filter(_=>m.some(O=>(0,y.areSameExtensions)(_.identifier,{id:O})))}else return[]}setMetadata(m,A){m.publisherDisplayName=A.publisherDisplayName||null,m.publisherId=A.publisherId||null,m.identifier.uuid=A.id,m.isMachineScoped=!!A.isMachineScoped,m.isBuiltin=m.type===0||!!A.isBuiltin}async removeUninstalledExtensions(){const m=await this.getUninstalledExtensions(),A=await this.scanAllUserExtensions(),_=new Set;for(const P of A)m[new y.ExtensionIdentifierWithVersion(P.identifier,P.manifest.version).key()]||_.add(P.identifier.id.toLowerCase());const O=(0,y.groupByExtension)(A,P=>P.identifier);await L.Promises.settled(O.map(async P=>{const M=P.sort(($,U)=>n.rcompare($.manifest.version,U.manifest.version))[0];_.has(M.identifier.id.toLowerCase())||await this.beforeRemovingExtension(M)}));const N=A.filter(P=>m[new y.ExtensionIdentifierWithVersion(P.identifier,P.manifest.version).key()]);await L.Promises.settled(N.map(P=>this.removeUninstalledExtension(P)))}async removeOutdatedExtensions(){const m=await this.scanAllUserExtensions(),A=[],_=(0,y.groupByExtension)(m,O=>O.identifier);A.push(...(0,D.flatten)(_.map(O=>O.sort((N,P)=>n.rcompare(N.manifest.version,P.manifest.version)).slice(1)))),await L.Promises.settled(A.map(O=>this.removeExtension(O,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(m=>m.name)}joinErrors(m){const A=Array.isArray(m)?m:[m];return A.length===1?A[0]instanceof Error?A[0]:new Error(A[0]):A.reduce((_,O)=>new Error(`${_.message}${_.message?",":""}${O instanceof Error?O.message:O}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=C.normalize(C.join(k.FileAccess.asFileUri("",J).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(m){const A=[w.Promises.readFile(C.join(m,"package.json"),"utf8").then(P=>this.parseManifest(P)),w.Promises.readFile(C.join(m,"package.nls.json"),"utf8").then(void 0,P=>P.code!=="ENOENT"?Promise.reject(P):"{}").then(P=>JSON.parse(P))],[{manifest:_,metadata:O},N]=await Promise.all(A);return{manifest:(0,v.localizeManifest)(_,N),metadata:O}}parseManifest(m){return new Promise((A,_)=>{try{const O=JSON.parse(m),N=O.__metadata||null;A({manifest:O,metadata:N})}catch(O){_(new Error((0,p.localize)(4,null)))}})}};u=he([Q(1,l.IFileService),Q(2,c.ILogService),Q(3,d.INativeEnvironmentService),Q(4,t.IProductService)],u),e.ExtensionsScanner=u}),define(te[232],ne([0,1,38,9,15,8,4,31,16,60,7,30,19,64,130,79,13,198,28,35,183,172,230,184,231,185,76,14,5,10,42,21]),function(J,e,D,L,R,T,k,C,S,E,n,I,g,w,f,p,d,b,y,v,l,c,t,s,r,i,a,o,u,h,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const _="unsetUninstalled",O="downloading";let N=class extends b.AbstractExtensionManagementService{constructor(W,q,x,F,K,j,z){super(W,q,x);this.environmentService=F,this.downloadService=K,this.fileService=z;const B=this._register(j.createInstance(c.ExtensionsLifecycle));this.extensionsScanner=this._register(j.createInstance(r.ExtensionsScanner,Z=>B.postUninstall(Z))),this.manifestCache=this._register(new s.ExtensionsManifestCache(F,this)),this.extensionsDownloader=this._register(j.createInstance(l.ExtensionsDownloader));const X=this._register(new i.ExtensionsWatcher(this,z,F,x));this._register(X.onDidChangeExtensionsByAnotherSource(({added:Z,removed:V})=>{Z.length&&this._onDidInstallExtensions.fire(Z.map(G=>({identifier:G.identifier,operation:0,local:G}))),V.forEach(G=>this._onDidUninstallExtension.fire({identifier:G}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const W=await this.isAlpineLinux(),q=(0,y.getTargetPlatform)(W?"alpine":k.platform,C.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",q),q})()),this._targetPlatformPromise}async isAlpineLinux(){if(!k.isLinux)return!1;let W;try{W=(await this.fileService.readFile(n.URI.file("/etc/os-release"))).value.toString()}catch(q){try{W=(await this.fileService.readFile(n.URI.file("/usr/lib/os-release"))).value.toString()}catch(x){this.logService.debug("Error while getting the os-release file.",(0,L.getErrorMessage)(x))}}return!!W&&(W.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(W){this.logService.trace("ExtensionManagementService#zip",W.identifier.id);const q=await this.collectFiles(W),x=await(0,w.zip)((0,S.joinPath)(this.environmentService.tmpDir,(0,I.generateUuid)()).fsPath,q);return n.URI.file(x)}async unzip(W){return this.logService.trace("ExtensionManagementService#unzip",W.toString()),(await this.install(W)).identifier}async getManifest(W){const q=await this.downloadVsix(W),x=T.resolve(q.fsPath);return(0,t.getManifest)(x)}getInstalled(W=null){return this.extensionsScanner.scanExtensions(W)}async install(W,q={}){this.logService.trace("ExtensionManagementService#install",W.toString());const x=await this.downloadVsix(W),F=await(0,t.getManifest)(T.resolve(x.fsPath));if(F.engines&&F.engines.vscode&&!(0,a.isEngineValid)(F.engines.vscode,m.default.version,m.default.date))throw new Error(f.localize(0,null,(0,v.getGalleryExtensionId)(F.publisher,F.name),m.default.version));return this.installExtension(F,x,q)}async updateMetadata(W,q){return this.logService.trace("ExtensionManagementService#updateMetadata",W.identifier.id),W=await this.extensionsScanner.saveMetadataForLocalExtension(W,{...W.manifest.__metadata||{},...q}),this.manifestCache.invalidate(),W}async updateExtensionScope(W,q){return this.logService.trace("ExtensionManagementService#updateExtensionScope",W.identifier.id),W=await this.extensionsScanner.saveMetadataForLocalExtension(W,{...W.manifest.__metadata||{},isMachineScoped:q}),this.manifestCache.invalidate(),W}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(W){if(W.scheme===R.Schemas.file)return W;const q=(0,S.joinPath)(this.environmentService.tmpDir,(0,I.generateUuid)());return await this.downloadService.download(W,q),q}createInstallExtensionTask(W,q,x){return n.URI.isUri(q)?new $(W,q,x,this.galleryService,this.extensionsScanner,this.logService):new M(q,x,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(W,q){return new U(W,q,this.extensionsScanner)}async collectFiles(W){const q=async F=>{let K=await g.Promises.readdir(F);K=K.map(B=>T.join(F,B));const j=await Promise.all(K.map(B=>g.Promises.stat(B)));let z=Promise.resolve([]);return j.forEach((B,X)=>{const Z=K[X];B.isFile()&&(z=z.then(V=>[...V,Z])),B.isDirectory()&&(z=z.then(V=>q(Z).then(G=>[...V,...G])))}),z};return(await q(W.location.fsPath)).map(F=>({path:`extension/${T.relative(W.location.fsPath,F)}`,localPath:F}))}};N=he([Q(0,y.IExtensionGalleryService),Q(1,A.ITelemetryService),Q(2,h.ILogService),Q(3,d.INativeEnvironmentService),Q(4,p.IDownloadService),Q(5,u.IInstantiationService),Q(6,o.IFileService)],N),e.ExtensionManagementService=N;class P extends b.AbstractExtensionTask{constructor(W,q,x,F){super();this.identifier=W,this.source=q,this.extensionsScanner=x,this.logService=F,this._operation=1}get operation(){return this._operation}async installExtension(W,q){try{const x=await this.unsetUninstalledAndGetLocal(W.identifierWithVersion);if(x)return W.metadata?this.extensionsScanner.saveMetadataForLocalExtension(x,W.metadata):x}catch(x){throw k.isMacintosh?new y.ExtensionManagementError(f.localize(1,null),_):new y.ExtensionManagementError(f.localize(2,null),_)}return this.extract(W,q)}async unsetUninstalledAndGetLocal(W){if(!await this.isUninstalled(W))return null;this.logService.trace("Removing the extension from uninstalled list:",W.id);const x=await this.extensionsScanner.setInstalled(W);return this.logService.info("Removed the extension from uninstalled list:",W.id),x}async isUninstalled(W){return!!(await this.extensionsScanner.getUninstalledExtensions())[W.key()]}async extract({zipPath:W,identifierWithVersion:q,metadata:x},F){let K=await this.extensionsScanner.extractUserExtension(q,W,x,F);return this.logService.info("Extracting completed.",q.id),K}}class M extends P{constructor(W,q,x,F,K){super(W.identifier,W,F,K);this.gallery=W,this.options=q,this.extensionsDownloader=x}async doRun(W){const x=(await this.extensionsScanner.scanExtensions(null)).find(K=>(0,v.areSameExtensions)(K.identifier,this.gallery.identifier));x&&(this._operation=2);const F=await this.downloadInstallableExtension(this.gallery,this._operation);F.metadata.isMachineScoped=this.options.isMachineScoped||x?.isMachineScoped,F.metadata.isBuiltin=this.options.isBuiltin||x?.isBuiltin;try{const K=await this.installExtension(F,W);return x&&E.neq(x.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(x),K}catch(K){throw await this.deleteDownloadedVSIX(F.zipPath),K}}async deleteDownloadedVSIX(W){try{await this.extensionsDownloader.delete(n.URI.file(W))}catch(q){this.logService.warn("Error while deleting the downloaded vsix",W.toString(),(0,L.getErrorMessage)(q))}}async downloadInstallableExtension(W,q){const x={id:W.identifier.uuid,publisherId:W.publisherId,publisherDisplayName:W.publisherDisplayName};let F;try{this.logService.trace("Started downloading extension:",W.identifier.id),F=(await this.extensionsDownloader.downloadExtension(W,q)).fsPath,this.logService.info("Downloaded extension:",W.identifier.id,F)}catch(K){throw new y.ExtensionManagementError((0,b.joinErrors)(K).message,O)}try{const K=await(0,t.getManifest)(F);return{zipPath:F,identifierWithVersion:new v.ExtensionIdentifierWithVersion(W.identifier,K.version),metadata:x}}catch(K){throw await this.deleteDownloadedVSIX(F),new y.ExtensionManagementError((0,b.joinErrors)(K).message,b.INSTALL_ERROR_VALIDATING)}}}class $ extends P{constructor(W,q,x,F,K,j){super({id:(0,v.getGalleryExtensionId)(W.publisher,W.name)},q,K,j);this.manifest=W,this.location=q,this.options=x,this.galleryService=F}async doRun(W){const q=new v.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),F=(await this.extensionsScanner.scanExtensions(1)).find(j=>(0,v.areSameExtensions)(this.identifier,j.identifier)),K=await this.getMetadata(this.identifier.id,W);if(K.isMachineScoped=this.options.isMachineScoped||F?.isMachineScoped,K.isBuiltin=this.options.isBuiltin||F?.isBuiltin,F)if(this._operation=2,q.equals(new v.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version)))try{await this.extensionsScanner.removeExtension(F,"existing")}catch(j){throw new Error(f.localize(3,null,this.manifest.displayName||this.manifest.name))}else E.gt(F.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(F);else{const j=await this.unsetUninstalledAndGetLocal(q);if(j)try{await this.extensionsScanner.removeExtension(j,"existing")}catch(z){throw new Error(f.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:T.resolve(this.location.fsPath),identifierWithVersion:q,metadata:K},W)}async getMetadata(W,q){try{const x=(await this.galleryService.query({names:[W],pageSize:1},q)).firstPage[0];if(x)return{id:x.identifier.uuid,publisherDisplayName:x.publisherDisplayName,publisherId:x.publisherId}}catch(x){}return{}}}class U extends b.AbstractExtensionTask{constructor(W,q,x){super();this.extension=W,this.options=q,this.extensionsScanner=x}async doRun(W){const q=[],x=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const F=new v.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);q.push(...x.filter(K=>F.equals(new v.ExtensionIdentifierWithVersion(K.identifier,K.manifest.version))))}else q.push(...x.filter(F=>(0,v.areSameExtensions)(F.identifier,this.extension.identifier)));if(!q.length)throw new Error(f.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...q),this.options.remove)for(const F of q)try{W.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(F)}catch(K){throw new Error(f.localize(6,null,(0,D.toErrorMessage)(K)))}}}}),define(te[233],ne([0,1,82,56,32,22,9,3,2,8,4,30,33,72,242]),function(J,e,D,L,R,T,k,C,S,E,n,I,g,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class p{constructor(u){this.socket=u,this._errorListener=h=>{if(h){if(h.code==="EPIPE")return;(0,k.onUnexpectedError)(h)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(u){const h=m=>u(T.VSBuffer.wrap(m));return this.socket.on("data",h),{dispose:()=>this.socket.off("data",h)}}onClose(u){const h=m=>{u({type:0,hadError:m,error:void 0})};return this.socket.on("close",h),{dispose:()=>this.socket.off("close",h)}}onEnd(u){return this.socket.on("end",u),{dispose:()=>this.socket.off("end",u)}}write(u){if(!this.socket.destroyed)try{this.socket.write(u.buffer,h=>{if(h){if(h.code==="EPIPE")return;(0,k.onUnexpectedError)(h)}})}catch(h){if(h.code==="EPIPE")return;(0,k.onUnexpectedError)(h)}}end(){this.socket.end()}drain(){return new Promise((u,h)=>{if(this.socket.bufferSize===0){u();return}const m=()=>{this.socket.off("close",m),this.socket.off("end",m),this.socket.off("error",m),this.socket.off("timeout",m),this.socket.off("drain",m),u()};this.socket.on("close",m),this.socket.on("end",m),this.socket.on("error",m),this.socket.on("timeout",m),this.socket.on("drain",m)})}}e.NodeSocket=p;var d;(function(o){o[o.MinHeaderByteSize=2]="MinHeaderByteSize"})(d||(d={}));var b;(function(o){o[o.PeekHeader=1]="PeekHeader",o[o.ReadHeader=2]="ReadHeader",o[o.ReadBody=3]="ReadBody",o[o.Fin=4]="Fin"})(b||(b={}));class y extends S.Disposable{constructor(u,h,m,A){super();this._onDidZlibFlush=this._register(new C.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new C.Emitter),this._onClose=this._register(new C.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=u,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=h,this._recordInflateBytes=A,h?(this._zlibInflate=f.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",_=>{console.error(_),(0,k.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})}),this._zlibInflate.on("data",_=>{this._pendingInflateData.push(_)}),m&&(this._zlibInflate.write(m.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=f.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",_=>{console.error(_),(0,k.onUnexpectedError)(_),this._onClose.fire({type:0,hadError:!0,error:_})}),this._zlibDeflate.on("data",_=>{this._pendingDeflateData.push(_)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new w.ChunkStream,this._register(this.socket.onData(_=>this._acceptChunk(_))),this._register(this.socket.onClose(_=>this._onClose.fire(_)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?T.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):T.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this._onData.event(u)}onClose(u){return this._onClose.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){this._totalOutgoingDataBytes+=u.byteLength,this._zlibDeflate?(this._zlibDeflate.write(u.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let h=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,h=h.slice(0,h.length-4),this._isEnded||this._write(T.VSBuffer.wrap(h),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(u,!1)}_write(u,h){let m=2;u.byteLength<126?m+=0:u.byteLength<2**16?m+=2:m+=8;const A=T.VSBuffer.alloc(m);if(h?A.writeUInt8(194,0):A.writeUInt8(130,0),u.byteLength<126)A.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){A.writeUInt8(126,1);let _=1;A.writeUInt8(u.byteLength>>>8&255,++_),A.writeUInt8(u.byteLength>>>0&255,++_)}else{A.writeUInt8(127,1);let _=1;A.writeUInt8(0,++_),A.writeUInt8(0,++_),A.writeUInt8(0,++_),A.writeUInt8(0,++_),A.writeUInt8(u.byteLength>>>24&255,++_),A.writeUInt8(u.byteLength>>>16&255,++_),A.writeUInt8(u.byteLength>>>8&255,++_),A.writeUInt8(u.byteLength>>>0&255,++_)}this._totalOutgoingWireBytes+=A.byteLength+u.byteLength,this.socket.write(T.VSBuffer.concat([A,u]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(u){if(u.byteLength!==0){for(this._totalIncomingWireBytes+=u.byteLength,this._incomingData.acceptChunk(u);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const h=this._incomingData.peek(this._state.readLen),m=h.readUInt8(0),A=(m&128)>>>7,_=(m&64)>>>6,O=h.readUInt8(1),N=(O&128)>>>7,P=O&127;this._state.state=2,this._state.readLen=2+(N?4:0)+(P===126?2:0)+(P===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(_)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0}else if(this._state.state===2){const h=this._incomingData.read(this._state.readLen),m=h.readUInt8(1),A=(m&128)>>>7;let _=m&127,O=1;_===126?_=h.readUInt8(++O)*2**8+h.readUInt8(++O):_===127&&(_=h.readUInt8(++O)*0+h.readUInt8(++O)*0+h.readUInt8(++O)*0+h.readUInt8(++O)*0+h.readUInt8(++O)*2**24+h.readUInt8(++O)*2**16+h.readUInt8(++O)*2**8+h.readUInt8(++O));let N=0;A&&(N=h.readUInt8(++O)*2**24+h.readUInt8(++O)*2**16+h.readUInt8(++O)*2**8+h.readUInt8(++O)),this._state.state=3,this._state.readLen=_,this._state.mask=N}else if(this._state.state===3){const h=this._incomingData.read(this._state.readLen);v(h,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(h.buffer)),this._zlibInflate.write(h.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const m=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=m.length,this._onData.fire(T.VSBuffer.wrap(m))})):(this._totalIncomingDataBytes+=h.byteLength,this._onData.fire(h))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await C.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=y;function v(o,u){if(u===0)return;let h=o.byteLength>>>2;for(let P=0;P<h;P++){const M=o.readUInt32BE(P*4);o.writeUInt32BE(M^u,P*4)}let m=h*4,A=o.byteLength-m;const _=u>>>24&255,O=u>>>16&255,N=u>>>8&255;A>=1&&o.writeUInt8(o.readUInt8(m)^_,m),A>=2&&o.writeUInt8(o.readUInt8(m+1)^O,m+1),A>=3&&o.writeUInt8(o.readUInt8(m+2)^N,m+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function c(){const o=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${o}-sock`;let u;return e.XDG_RUNTIME_DIR?u=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${o}.sock`):u=(0,E.join)((0,R.tmpdir)(),`vscode-ipc-${o}.sock`),s(u),u}e.createRandomIPCHandle=c;function t(o,u,h){const m=(0,D.createHash)("md5").update(o).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${m}-${h}-${u}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-${m.substr(0,8)}-${h}-${u}.sock`):A=(0,E.join)(o,`${h}-${u}.sock`),s(A),A}e.createStaticIPCHandle=t;function s(o){const u=l[n.platform];typeof u=="number"&&o.length>=u&&console.warn(`WARNING: IPC handle "${o}" is longer than ${u} chars, try a shorter --user-data-dir`)}class r extends g.IPCServer{constructor(u){super(r.toClientConnectionEvent(u));this.server=u}static toClientConnectionEvent(u){const h=C.Event.fromNodeEventEmitter(u,"connection");return C.Event.map(h,m=>({protocol:new w.Protocol(new p(m)),onDidClientDisconnect:C.Event.once(C.Event.fromNodeEventEmitter(m,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=r;function i(o){return new Promise((u,h)=>{const m=(0,L.createServer)();m.on("error",h),m.listen(o,()=>{m.removeListener("error",h),u(new r(m))})})}e.serve=i;function a(o,u){return new Promise((h,m)=>{const A=(0,L.createConnection)(o,()=>{A.removeListener("error",m),h(w.Client.fromSocket(new p(A),u))});A.once("error",m)})}e.connect=a}),define(te[234],ne([0,1,56,233]),function(J,e,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(R,T,k,C){const S=n=>C(n,void 0),E=D.createConnection({host:R,port:T},()=>{E.removeListener("error",S);const n=Buffer.alloc(16);for(let f=0;f<16;f++)n[f]=Math.round(Math.random()*256);const I=n.toString("base64");let g=[`GET ws://${/:/.test(R)?`[${R}]`:R}:${T}/?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${I}`];E.write(g.join(`\r
`)+`\r
\r
`);const w=f=>{f.toString().indexOf(`\r
\r
`)>=0&&(E.off("data",w),C(void 0,new L.NodeSocket(E)))};E.on("data",w)});E.once("error",S)}}}),define(te[235],ne([0,1,56,111,234,6,2,20,10,29,181,61,90]),function(J,e,D,L,R,T,k,C,S,E,n,I,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function w(b,y,v,l,c){return new f(b,y,v,l,c).waitForReady()}class f extends k.Disposable{constructor(y,v,l,c,t){super();this.defaultTunnelHost=v,this.suggestedLocalPort=t,this.privacy=I.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=y,this._server=D.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=c,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(v=>{v()})}async waitForReady(){let y=await(0,L.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),v=null;return this._server.listen(y,this.defaultTunnelHost),await this._barrier.wait(),v=this._server.address(),v||(y=0,this._server.listen(y,this.defaultTunnelHost),await this._barrier.wait(),v=this._server.address()),this.tunnelLocalPort=v.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${v.port}`,this}async _onConnection(y){y.pause();const v=(0,I.isLocalhost)(this.tunnelRemoteHost)||(0,I.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,n.connectRemoteAgentTunnel)(this._options,v,this.tunnelRemotePort),c=l.getSocket().socket,t=l.readEntireBuffer();l.dispose(),t.byteLength>0&&y.write(t.buffer),y.on("end",()=>{this._socketsDispose.delete(y.localAddress),c.end()}),y.on("close",()=>c.end()),y.on("error",()=>{this._socketsDispose.delete(y.localAddress),c.destroy()}),c.on("end",()=>y.end()),c.on("close",()=>y.end()),c.on("error",()=>{y.destroy()}),y.pipe(c),c.pipe(y),this._socketsDispose.set(y.localAddress,()=>{y.end(),c.end()})}}let p=class extends I.AbstractTunnelService{constructor(y,v,l,c,t){super(v);this.socketFactory=y,this.signService=l,this.productService=c,this.configurationService=t}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(y,v,l,c,t,s,r){const i=this.getTunnelFromMap(v,l);if(i)return++i.refcount,i.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,v,l,c,t,s,r);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${v}:${l} on local port ${c}.`);const a={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:y,signService:this.signService,logService:this.logService,ipcLogger:null},o=w(a,this.defaultTunnelHost,v,l,c);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(v,l,o),o}}};p=he([Q(1,S.ILogService),Q(2,g.ISignService),Q(3,E.IProductService),Q(4,C.IConfigurationService)],p),e.BaseTunnelService=p;let d=class extends p{constructor(y,v,l,c){super(R.nodeSocketFactory,y,v,l,c)}};d=he([Q(0,S.ILogService),Q(1,g.ISignService),Q(2,E.IProductService),Q(3,C.IConfigurationService)],d),e.TunnelService=d}),define(te[243],ne([0,1,116,51,244,32,38,9,2,15,16,7,33,115,177,160,178,169,170,171,158,162,20,179,78,197,79,190,13,149,193,200,28,161,199,232,80,152,14,174,176,53,5,166,84,167,168,58,186,10,85,59,42,29,189,43,23,195,196,21,91,92,93,46,201,202,94,204,210,96,97,98,24,62,221,222,223,63,224,225,226,227,228,229,81,173,90,192,61,235,187,188]),function(J,e,D,L,R,T,k,C,S,E,n,I,g,w,f,p,d,b,y,v,l,c,t,s,r,i,a,o,u,h,m,A,_,O,N,P,M,$,U,H,W,q,x,F,K,j,z,B,X,Z,V,G,ie,re,ae,ue,fe,de,Ie,Ce,Ee,_e,Pe,ke,Fe,$e,Ne,qe,ee,oe,ce,ye,pe,Oe,De,Y,se,le,ge,me,be,Te,Le,Se,we,Re,Ae,Ue,it,Ge,je,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class wt extends S.Disposable{constructor(ve){super();this.configuration=ve,this.server=this._register(new w.Server),(0,R.gracefulify)(L),this.registerListeners()}registerListeners(){const ve=()=>this.dispose();process.once("exit",ve),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve)}async open(){const ve=await this.initServices();(0,pe.registerConfiguration)(),ve.invokeFunction(Me=>{const xe=Me.get(Z.ILogService);xe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Me),this.registerErrorHandler(xe)}),this._register((0,S.combinedDisposable)(ve.createInstance(f.CodeCacheCleaner,this.configuration.codeCachePath),ve.createInstance(d.LanguagePackCachedDataCleaner),ve.createInstance(v.StorageDataCleaner,this.configuration.backupWorkspacesPath),ve.createInstance(y.LogsDataCleaner),ve.createInstance(b.LocalizationsUpdater),ve.createInstance(p.DeprecatedExtensionsCleaner)))}async initServices(){const ve=new K.ServiceCollection,Me={_serviceBrand:void 0,...ie.default};ve.set(re.IProductService,Me);const xe=new g.StaticRouter(We=>We==="main"),Je=new j.MessagePortMainProcessService(this.server,xe);ve.set(z.IMainProcessService,Je);const ze=new h.NativeEnvironmentService(this.configuration.args,Me);ve.set(u.INativeEnvironmentService,ze);const rt=new V.LogLevelChannelClient(this.server.getChannel("logLevel",xe)),Xe=new V.LoggerChannelClient(this.configuration.logLevel,rt.onDidChangeLogLevel,Je.getChannel("logger"));ve.set(Z.ILoggerService,Xe);const at=this._register(new Z.MultiplexLogService([this._register(new Z.ConsoleLogger(this.configuration.logLevel)),this._register(Xe.createLogger((0,n.joinPath)(I.URI.file(ze.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Ke=this._register(new V.FollowerLogService(rt,at));ve.set(Z.ILogService,Ke);const Qe=this._register(new H.FileService(Ke));ve.set(U.IFileService,Qe);const ot=this._register(new W.DiskFileSystemProvider(Ke));Qe.registerProvider(E.Schemas.file,ot);const Ve=this._register(new s.ConfigurationService(ze.settingsResource,Qe));ve.set(t.IConfigurationService,Ve);const et=new de.NativeStorageService(void 0,Je,ze);ve.set(fe.IStorageService,et),this._register((0,S.toDisposable)(()=>et.flush())),await Promise.all([Ve.initialize(),et.initialize()]),ve.set(ue.IRequestService,new q.SyncDescriptor(ae.RequestService)),ve.set(l.IChecksumService,new q.SyncDescriptor(c.ChecksumService));const st=g.ProxyChannel.toService(Je.getChannel("nativeHost"),{context:this.configuration.windowId});ve.set(G.INativeHostService,st),ve.set(a.IDownloadService,new q.SyncDescriptor(o.DownloadService));const ct=this._register(new Se.ActiveWindowManager(st)),lt=new g.StaticRouter(We=>ct.getActiveClientId().then(ut=>We===ut));ve.set(M.IExtensionRecommendationNotificationService,new $.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",lt)));let Ye;const tt=[];if((0,ke.supportsTelemetry)(Me,ze)){const We=new _e.TelemetryLogAppender(Xe,ze);tt.push(We);const{appRoot:ut,extensionsPath:It,installSourcePath:Ct}=ze;if(Me.aiConfig&&Me.aiConfig.asimovKey){const gt=new Fe.AppInsightsAppender("monacoworkbench",null,Me.aiConfig.asimovKey);this._register((0,S.toDisposable)(()=>gt.flush())),tt.push(gt)}Ye=new Pe.TelemetryService({appenders:tt,commonProperties:(0,Ie.resolveCommonProperties)(Qe,(0,T.release)(),(0,T.hostname)(),process.arch,Me.commit,Me.version,this.configuration.machineId,Me.msftInternalDomains,Ct),sendErrorTelemetry:!0,piiPaths:[ut,It]},Ve)}else{Ye=ke.NullTelemetryService;const We=ke.NullAppender;tt.push(We)}this.server.registerChannel("telemetryAppender",new Ee.TelemetryAppenderChannel(tt)),ve.set(Ce.ITelemetryService,Ye);const bt=new $e.CustomEndpointTelemetryService(Ve,Ye,Xe,ze);return ve.set(Ce.ICustomEndpointTelemetryService,bt),ve.set(_.IExtensionManagementService,new q.SyncDescriptor(P.ExtensionManagementService)),ve.set(_.IExtensionGalleryService,new q.SyncDescriptor(A.ExtensionGalleryService)),ve.set(_.IExtensionTipsService,new q.SyncDescriptor(N.ExtensionTipsService)),ve.set(B.ILocalizationsService,new q.SyncDescriptor(X.LocalizationsService)),ve.set(r.IDiagnosticsService,new q.SyncDescriptor(i.DiagnosticsService)),ve.set(Oe.IUserDataSyncAccountService,new q.SyncDescriptor(Oe.UserDataSyncAccountService)),ve.set(pe.IUserDataSyncLogService,new q.SyncDescriptor(se.UserDataSyncLogService)),ve.set(pe.IUserDataSyncUtilService,new Y.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",We=>We.ctx!=="main"))),ve.set(_.IGlobalExtensionEnablementService,new q.SyncDescriptor(m.GlobalExtensionEnablementService)),ve.set(ce.IIgnoredExtensionsManagementService,new q.SyncDescriptor(ce.IgnoredExtensionsManagementService)),ve.set(oe.IExtensionsStorageSyncService,new q.SyncDescriptor(oe.ExtensionsStorageSyncService)),ve.set(pe.IUserDataSyncStoreManagementService,new q.SyncDescriptor(Te.UserDataSyncStoreManagementService)),ve.set(pe.IUserDataSyncStoreService,new q.SyncDescriptor(Te.UserDataSyncStoreService)),ve.set(le.IUserDataSyncMachinesService,new q.SyncDescriptor(le.UserDataSyncMachinesService)),ve.set(pe.IUserDataSyncBackupStoreService,new q.SyncDescriptor(De.UserDataSyncBackupStoreService)),ve.set(pe.IUserDataAutoSyncEnablementService,new q.SyncDescriptor(ye.UserDataAutoSyncEnablementService)),ve.set(pe.IUserDataSyncResourceEnablementService,new q.SyncDescriptor(ge.UserDataSyncResourceEnablementService)),ve.set(pe.IUserDataSyncService,new q.SyncDescriptor(me.UserDataSyncService)),ve.set(qe.ILocalPtyService,this._register(new ee.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ve.getValue("terminal.integrated.persistentSessionScrollback")??100},Ve,ze,Ke,Ye))),ve.set(we.IExtensionHostStarter,this._register(new Re.ExtensionHostStarter(Ke))),ve.set(Ae.ISignService,new q.SyncDescriptor(Ue.SignService)),ve.set(it.ITunnelService,new q.SyncDescriptor(Ge.TunnelService)),ve.set(je.ISharedProcessTunnelService,new q.SyncDescriptor(St.SharedProcessTunnelService)),new F.InstantiationService(ve)}initChannels(ve){const Me=new O.ExtensionManagementChannel(ve.get(_.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Me);const xe=g.ProxyChannel.fromService(ve.get(B.ILocalizationsService));this.server.registerChannel("localizations",xe);const Je=g.ProxyChannel.fromService(ve.get(r.IDiagnosticsService));this.server.registerChannel("diagnostics",Je);const ze=new O.ExtensionTipsChannel(ve.get(_.IExtensionTipsService));this.server.registerChannel("extensionTipsService",ze);const rt=g.ProxyChannel.fromService(ve.get(l.IChecksumService));this.server.registerChannel("checksum",rt);const Xe=new Y.UserDataSyncMachinesServiceChannel(ve.get(le.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Xe);const at=g.ProxyChannel.fromService(ve.get(Ce.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",at);const Ke=new Y.UserDataSyncAccountServiceChannel(ve.get(Oe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ke);const Qe=new Y.UserDataSyncStoreManagementServiceChannel(ve.get(pe.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Qe);const ot=new be.UserDataSyncChannel(ve.get(pe.IUserDataSyncService),ve.get(Z.ILogService));this.server.registerChannel("userDataSync",ot);const Ve=this._register(ve.get(x.IInstantiationService).createInstance(Le.UserDataAutoSyncService)),et=new Y.UserDataAutoSyncChannel(Ve);this.server.registerChannel("userDataAutoSync",et);const st=ve.get(qe.ILocalPtyService),ct=g.ProxyChannel.fromService(st);this.server.registerChannel(Ne.TerminalIpcChannels.LocalPty,ct);const lt=g.ProxyChannel.fromService(ve.get(we.IExtensionHostStarter));this.server.registerChannel(we.ipcExtensionHostStarterChannelName,lt);const Ye=g.ProxyChannel.fromService(ve.get(je.ISharedProcessTunnelService));this.server.registerChannel(je.ipcSharedProcessTunnelChannelName,Ye)}registerErrorHandler(ve){window.addEventListener("unhandledrejection",Me=>{(0,C.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,C.setUnexpectedErrorHandler)(Me=>{const xe=(0,k.toErrorMessage)(Me,!0);!xe||ve.error(`[uncaught exception in sharedProcess]: ${xe}`)})}}async function Et(dt){const ve=new wt(dt);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Et})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e96a97448aae1572246bf7c438b7c2ee68a964c0/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
