/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/path","vs/base/common/uri","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/base/common/errors","vs/base/common/buffer","vs/base/node/pfs","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/workspaces/common/workspaces","vs/base/common/uuid","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/base/common/extpath","fs","vs/base/common/process","vs/base/common/labels","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","vs/platform/product/common/product","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/common/environment","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/base/common/errorMessage","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/processes","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/linkedList","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/driver/electron-main/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","path","assert","vs/code/electron-main/main"],x=function(K){for(var e=[],v=0,L=K.length;v<L;v++)e[v]=Z[K[v]];return e};define(Z[103],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(L,M){if(!L)throw new Error(M?`Assertion failed (${M})`:"Assertion Failed")}e.ok=v}),define(Z[47],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(I){return(n,f,w)=>{let i=null,P=null;if(typeof w.value=="function"?(i="value",P=w.value):typeof w.get=="function"&&(i="get",P=w.get),!P)throw new Error("not supported");w[i]=I(P,f)}}e.createDecorator=v;function L(I,n,f){let w=null,i=null;if(typeof f.value=="function"?(w="value",i=f.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(w="get",i=f.get),!i)throw new Error("not supported");const P=`$memoize$${n}`;f[w]=function(...E){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,E)}),this[P]}}e.memoize=L;function M(I,n,f){return v((w,i)=>{const P=`$debounce$${i}`,E=`$debounce$result$${i}`;return function(...y){this[E]||(this[E]=f?f():void 0),clearTimeout(this[P]),n&&(this[E]=n(this[E],...y),y=[this[E]]),this[P]=setTimeout(()=>{w.apply(this,y),this[E]=f?f():void 0},I)}})}e.debounce=M;function D(I,n,f){return v((w,i)=>{const P=`$throttle$timer$${i}`,E=`$throttle$result$${i}`,y=`$throttle$lastRun$${i}`,d=`$throttle$pending$${i}`;return function(...m){if(this[E]||(this[E]=f?f():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),n&&(this[E]=n(this[E],...m)),this[d])return;const b=this[y]+I;b<=Date.now()?(this[y]=Date.now(),w.apply(this,[this[E]]),this[E]=f?f():void 0):(this[d]=!0,this[P]=setTimeout(()=>{this[d]=!1,this[y]=Date.now(),w.apply(this,[this[E]]),this[E]=f?f():void 0},b-Date.now()))}})}e.throttle=D}),define(Z[17],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(l=>{l(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=v,e.errorHandler=new v;function L(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=L;function M(u){f(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=M;function D(u){f(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=D;function I(u){if(u instanceof Error){let{name:t,message:l}=u;const s=u.stacktrace||u.stack;return{$isError:!0,name:t,message:l,stack:s}}return u}e.transformErrorForSerialization=I;const n="Canceled";function f(u){return u instanceof Error&&u.name===n&&u.message===n}e.isPromiseCanceledError=f;class w extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=w;function i(){const u=new Error(n);return u.name=u.message,u}e.canceled=i;function P(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=P;function E(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=E;function y(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function d(u){const t=new Error(`${u} has been disposed`);return t.name="DISPOSED",t}e.disposed=d;function m(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=m;class b extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=b;class S extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=S;class c extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=c;function h(u){const t=u;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=h;function o(u,t=Object.create(null)){const l=new Error(u);return t.actions&&(l.actions=t.actions),l}e.createErrorWithActions=o}),define(Z[30],x([0,1,17]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(A,W=0){return A[A.length-(1+W)]}e.tail=L;function M(A){if(A.length===0)throw new Error("Invalid tail call");return[A.slice(0,A.length-1),A[A.length-1]]}e.tail2=M;function D(A,W,B=(Y,U)=>Y===U){if(A===W)return!0;if(!A||!W||A.length!==W.length)return!1;for(let Y=0,U=A.length;Y<U;Y++)if(!B(A[Y],W[Y]))return!1;return!0}e.equals=D;function I(A,W,B){let Y=0,U=A.length-1;for(;Y<=U;){const N=(Y+U)/2|0,Q=B(A[N],W);if(Q<0)Y=N+1;else if(Q>0)U=N-1;else return N}return-(Y+1)}e.binarySearch=I;function n(A,W){let B=0,Y=A.length;if(Y===0)return 0;for(;B<Y;){const U=Math.floor((B+Y)/2);W(A[U])?Y=U:B=U+1}return B}e.findFirstInSorted=n;function f(A,W,B){if(A=A|0,A>=W.length)throw new TypeError("invalid index");let Y=W[Math.floor(W.length*Math.random())],U=[],N=[],Q=[];for(let J of W){const re=B(J,Y);re<0?U.push(J):re>0?N.push(J):Q.push(J)}return A<U.length?f(A,U,B):A<U.length+Q.length?Q[0]:f(A-(U.length+Q.length),N,B)}e.quickSelect=f;function w(A,W){const B=[];let Y;for(const U of A.slice(0).sort(W))!Y||W(Y[0],U)!==0?(Y=[U],B.push(Y)):Y.push(U);return B}e.groupBy=w;function i(A,W,B){const Y=[];function U(J,re,le){if(re===0&&le.length===0)return;const ee=Y[Y.length-1];ee&&ee.start+ee.deleteCount===J?(ee.deleteCount+=re,ee.toInsert.push(...le)):Y.push({start:J,deleteCount:re,toInsert:le})}let N=0,Q=0;for(;;){if(N===A.length){U(N,0,W.slice(Q));break}if(Q===W.length){U(N,A.length-N,[]);break}const J=A[N],re=W[Q],le=B(J,re);le===0?(N+=1,Q+=1):le<0?(U(N,1,[]),N+=1):le>0&&(U(N,0,[re]),Q+=1)}return Y}e.sortedDiff=i;function P(A,W,B){const Y=i(A,W,B),U=[],N=[];for(const Q of Y)U.push(...A.slice(Q.start,Q.start+Q.deleteCount)),N.push(...Q.toInsert);return{removed:U,added:N}}e.delta=P;function E(A,W,B){if(B===0)return[];const Y=A.slice(0,B).sort(W);return d(A,W,Y,B,A.length),Y}e.top=E;function y(A,W,B,Y,U){return B===0?Promise.resolve([]):new Promise((N,Q)=>{(async()=>{const J=A.length,re=A.slice(0,B).sort(W);for(let le=B,ee=Math.min(B+Y,J);le<J;le=ee,ee=Math.min(ee+Y,J)){if(le>B&&await new Promise(ae=>setTimeout(ae)),U&&U.isCancellationRequested)throw(0,v.canceled)();d(A,W,re,le,ee)}return re})().then(N,Q)})}e.topAsync=y;function d(A,W,B,Y,U){for(const N=B.length;Y<U;Y++){const Q=A[Y];if(W(Q,B[N-1])<0){B.pop();const J=n(B,re=>W(Q,re)<0);B.splice(J,0,Q)}}}function m(A){return A.filter(W=>!!W)}e.coalesce=m;function b(A){let W=0;for(let B=0;B<A.length;B++)A[B]&&(A[W]=A[B],W+=1);A.length=W}e.coalesceInPlace=b;function S(A,W,B){A.splice(B,0,A.splice(W,1)[0])}e.move=S;function c(A){return!Array.isArray(A)||A.length===0}e.isFalsyOrEmpty=c;function h(A){return Array.isArray(A)&&A.length>0}e.isNonEmptyArray=h;function o(A,W){if(!W)return A.filter((Y,U)=>A.indexOf(Y)===U);const B=Object.create(null);return A.filter(Y=>{const U=W(Y);return B[U]?!1:(B[U]=!0,!0)})}e.distinct=o;function u(A){const W=new Set;return A.filter(B=>W.has(B)?!1:(W.add(B),!0))}e.distinctES6=u;function t(A){const W=Object.create(null);return B=>{const Y=A(B);return W[Y]?!1:(W[Y]=!0,!0)}}e.uniqueFilter=t;function l(A,W){const B=s(A,W);if(B!==-1)return A[B]}e.findLast=l;function s(A,W){for(let B=A.length-1;B>=0;B--){const Y=A[B];if(W(Y))return B}return-1}e.lastIndex=s;function r(A,W){return A.length>0?A[0]:W}e.firstOrDefault=r;function a(A,W,B=(Y,U)=>Y===U){let Y=0;for(let U=0,N=Math.min(A.length,W.length);U<N&&B(A[U],W[U]);U++)Y++;return Y}e.commonPrefixLength=a;function g(A){return[].concat(...A)}e.flatten=g;function p(A,W){let B=typeof W=="number"?A:0;typeof W=="number"?B=A:(B=0,W=A);const Y=[];if(B<=W)for(let U=B;U<W;U++)Y.push(U);else for(let U=B;U>W;U--)Y.push(U);return Y}e.range=p;function k(A,W,B){return A.reduce((Y,U)=>(Y[W(U)]=B?B(U):U,Y),Object.create(null))}e.index=k;function R(A,W){return A.push(W),()=>T(A,W)}e.insert=R;function T(A,W){const B=A.indexOf(W);if(B>-1)return A.splice(B,1),W}e.remove=T;function O(A,W,B){const Y=A.slice(0,W),U=A.slice(W);return Y.concat(B,U)}e.arrayInsert=O;function V(A,W){let B;if(typeof W=="number"){let Y=W;B=()=>{const U=Math.sin(Y++)*179426549;return U-Math.floor(U)}}else B=Math.random;for(let Y=A.length-1;Y>0;Y-=1){const U=Math.floor(B()*(Y+1)),N=A[Y];A[Y]=A[U],A[U]=N}}e.shuffle=V;function ne(A,W){const B=A.indexOf(W);B>-1&&(A.splice(B,1),A.unshift(W))}e.pushToStart=ne;function se(A,W){const B=A.indexOf(W);B>-1&&(A.splice(B,1),A.push(W))}e.pushToEnd=se;function G(A,W){return Array.isArray(A)?A.map(W):W(A)}e.mapArrayOrNot=G;function te(A){return Array.isArray(A)?A:[A]}e.asArray=te;function F(A){return A[Math.floor(Math.random()*A.length)]}e.getRandomElement=F;function j(A,W){for(const B of A){const Y=W(B);if(Y!==void 0)return Y}}e.mapFind=j;function q(A,W,B){const Y=H(A,W),U=A.length,N=B.length;A.length=U+N;for(let Q=U-1;Q>=Y;Q--)A[Q+N]=A[Q];for(let Q=0;Q<N;Q++)A[Q+Y]=B[Q]}e.insertInto=q;function $(A,W,B,Y){const U=H(A,W),N=A.splice(U,B);return q(A,U,Y),N}e.splice=$;function H(A,W){return W<0?Math.max(W+A.length,0):Math.min(W,A.length)}function _(A,W){let B=Number.MAX_SAFE_INTEGER,Y=0;return A.forEach((U,N)=>{const Q=W(U);Q<B&&(B=Q,Y=N)}),Y}e.minIndex=_;function z(A,W){let B=Number.MIN_SAFE_INTEGER,Y=0;return A.forEach((U,N)=>{const Q=W(U);Q>B&&(B=Q,Y=N)}),Y}e.maxIndex=z;class C{constructor(W){this.items=W,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(W){let B=this.firstIdx;for(;B<this.items.length&&W(this.items[B]);)B++;const Y=B===this.firstIdx?null:this.items.slice(this.firstIdx,B);return this.firstIdx=B,Y}takeFromEndWhile(W){let B=this.lastIdx;for(;B>=0&&W(this.items[B]);)B--;const Y=B===this.lastIdx?null:this.items.slice(B+1,this.lastIdx+1);return this.lastIdx=B,Y}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=C}),define(Z[43],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(L){const M=this;let D=!1,I;return function(){return D||(D=!0,I=L.apply(M,arguments)),I}}e.once=v}),define(Z[66],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(L){function M(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}L.is=M;const D=Object.freeze([]);function I(){return D}L.empty=I;function*n(u){yield u}L.single=n;function f(u){return u||D}L.from=f;function w(u){return!u||u[Symbol.iterator]().next().done===!0}L.isEmpty=w;function i(u){return u[Symbol.iterator]().next().value}L.first=i;function P(u,t){for(const l of u)if(t(l))return!0;return!1}L.some=P;function E(u,t){for(const l of u)if(t(l))return l}L.find=E;function*y(u,t){for(const l of u)t(l)&&(yield l)}L.filter=y;function*d(u,t){let l=0;for(const s of u)yield t(s,l++)}L.map=d;function*m(...u){for(const t of u)for(const l of t)yield l}L.concat=m;function*b(u){for(const t of u)for(const l of t)yield l}L.concatNested=b;function S(u,t,l){let s=l;for(const r of u)s=t(s,r);return s}L.reduce=S;function*c(u,t,l=u.length){for(t<0&&(t+=u.length),l<0?l+=u.length:l>u.length&&(l=u.length);t<l;t++)yield u[t]}L.slice=c;function h(u,t=Number.POSITIVE_INFINITY){const l=[];if(t===0)return[l,u];const s=u[Symbol.iterator]();for(let r=0;r<t;r++){const a=s.next();if(a.done)return[l,L.empty()];l.push(a.value)}return[l,{[Symbol.iterator](){return s}}]}L.consume=h;function o(u,t,l=(s,r)=>s===r){const s=u[Symbol.iterator](),r=t[Symbol.iterator]();for(;;){const a=s.next(),g=r.next();if(a.done!==g.done)return!1;if(a.done)return!0;if(!l(a.value,g.value))return!1}}L.equals=o})(v=e.Iterable||(e.Iterable={}))}),define(Z[40],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var M;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(M=e.ParseErrorCode||(e.ParseErrorCode={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D=e.ParseOptions||(e.ParseOptions={}));function I(t,l=!1){let s=0,r=t.length,a="",g=0,p=16,k=0;function R(te){let F=0,j=0;for(;F<te;){const q=t.charCodeAt(s);if(q>=48&&q<=57)j=j*16+q-48;else if(q>=65&&q<=70)j=j*16+q-65+10;else if(q>=97&&q<=102)j=j*16+q-97+10;else break;s++,F++}return F<te&&(j=-1),j}function T(te){s=te,a="",g=0,p=16,k=0}function O(){const te=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&w(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&w(t.charCodeAt(s)))for(s++;s<t.length&&w(t.charCodeAt(s));)s++;else return k=3,t.substring(te,s);let F=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&w(t.charCodeAt(s))){for(s++;s<t.length&&w(t.charCodeAt(s));)s++;F=s}else k=3;return t.substring(te,F)}function V(){let te="",F=s;for(;;){if(s>=r){te+=t.substring(F,s),k=2;break}const j=t.charCodeAt(s);if(j===34){te+=t.substring(F,s),s++;break}if(j===92){if(te+=t.substring(F,s),s++,s>=r){k=2;break}switch(t.charCodeAt(s++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:const $=R(4);$>=0?te+=String.fromCharCode($):k=4;break;default:k=5}F=s;continue}if(j>=0&&j<=31)if(f(j)){te+=t.substring(F,s),k=2;break}else k=6;s++}return te}function ne(){if(a="",k=0,g=s,s>=r)return g=r,p=17;let te=t.charCodeAt(s);if(n(te)){do s++,a+=String.fromCharCode(te),te=t.charCodeAt(s);while(n(te));return p=15}if(f(te))return s++,a+=String.fromCharCode(te),te===13&&t.charCodeAt(s)===10&&(s++,a+=`
`),p=14;switch(te){case 123:return s++,p=1;case 125:return s++,p=2;case 91:return s++,p=3;case 93:return s++,p=4;case 58:return s++,p=6;case 44:return s++,p=5;case 34:return s++,a=V(),p=10;case 47:const F=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<r&&!f(t.charCodeAt(s));)s++;return a=t.substring(F,s),p=12}if(t.charCodeAt(s+1)===42){s+=2;const j=r-1;let q=!1;for(;s<j;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,q=!0;break}s++}return q||(s++,k=1),a=t.substring(F,s),p=13}return a+=String.fromCharCode(te),s++,p=16;case 45:if(a+=String.fromCharCode(te),s++,s===r||!w(t.charCodeAt(s)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=O(),p=11;default:for(;s<r&&se(te);)s++,te=t.charCodeAt(s);if(g!==s){switch(a=t.substring(g,s),a){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return a+=String.fromCharCode(te),s++,p=16}}function se(te){if(n(te)||f(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let te;do te=ne();while(te>=12&&te<=15);return te}return{setPosition:T,getPosition:()=>s,scan:l?G:ne,getToken:()=>p,getTokenValue:()=>a,getTokenOffset:()=>g,getTokenLength:()=>s-g,getTokenError:()=>k}}e.createScanner=I;function n(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function w(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function P(t,l){const s=[],r=new Object;let a;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function k(R,T,O,V){g.value=R,g.offset=T,g.length=O,g.type=V,g.colonOffset=void 0,a=g}try{h(t,{onObjectBegin:(R,T)=>{if(l<=R)throw r;a=void 0,p=l>R,s.push("")},onObjectProperty:(R,T,O)=>{if(l<T||(k(R,T,O,"property"),s[s.length-1]=R,l<=T+O))throw r},onObjectEnd:(R,T)=>{if(l<=R)throw r;a=void 0,s.pop()},onArrayBegin:(R,T)=>{if(l<=R)throw r;a=void 0,s.push(0)},onArrayEnd:(R,T)=>{if(l<=R)throw r;a=void 0,s.pop()},onLiteralValue:(R,T,O)=>{if(l<T||(k(R,T,O,u(R)),l<=T+O))throw r},onSeparator:(R,T,O)=>{if(l<=T)throw r;if(R===":"&&a&&a.type==="property")a.colonOffset=T,p=!1,a=void 0;else if(R===","){const V=s[s.length-1];typeof V=="number"?s[s.length-1]=V+1:(p=!0,s[s.length-1]=""),a=void 0}}})}catch(R){if(R!==r)throw R}return{path:s,previousNode:a,isAtPropertyKey:p,matches:R=>{let T=0;for(let O=0;T<R.length&&O<s.length;O++)if(R[T]===s[O]||R[T]==="*")T++;else if(R[T]!=="**")return!1;return T===R.length}}}e.getLocation=P;function E(t,l=[],s=D.DEFAULT){let r=null,a=[];const g=[];function p(R){Array.isArray(a)?a.push(R):r!==null&&(a[r]=R)}return h(t,{onObjectBegin:()=>{const R={};p(R),g.push(a),a=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{a=g.pop()},onArrayBegin:()=>{const R=[];p(R),g.push(a),a=R,r=null},onArrayEnd:()=>{a=g.pop()},onLiteralValue:p,onError:(R,T,O)=>{l.push({error:R,offset:T,length:O})}},s),a[0]}e.parse=E;function y(t,l=[],s=D.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(R){r.type==="property"&&(r.length=R-r.offset,r=r.parent)}function g(R){return r.children.push(R),R}h(t,{onObjectBegin:R=>{r=g({type:"object",offset:R,length:-1,parent:r,children:[]})},onObjectProperty:(R,T,O)=>{r=g({type:"property",offset:T,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:R,offset:T,length:O,parent:r})},onObjectEnd:(R,T)=>{r.length=R+T-r.offset,r=r.parent,a(R+T)},onArrayBegin:(R,T)=>{r=g({type:"array",offset:R,length:-1,parent:r,children:[]})},onArrayEnd:(R,T)=>{r.length=R+T-r.offset,r=r.parent,a(R+T)},onLiteralValue:(R,T,O)=>{g({type:u(R),offset:T,length:O,parent:r,value:R}),a(T+O)},onSeparator:(R,T,O)=>{r.type==="property"&&(R===":"?r.colonOffset=T:R===","&&a(T))},onError:(R,T,O)=>{l.push({error:R,offset:T,length:O})}},s);const k=r.children[0];return k&&delete k.parent,k}e.parseTree=y;function d(t,l){if(!t)return;let s=t;for(let r of l)if(typeof r=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let a=!1;for(const g of s.children)if(Array.isArray(g.children)&&g.children[0].value===r){s=g.children[1],a=!0;break}if(!a)return}else{const a=r;if(s.type!=="array"||a<0||!Array.isArray(s.children)||a>=s.children.length)return;s=s.children[a]}return s}e.findNodeAtLocation=d;function m(t){if(!t.parent||!t.parent.children)return[];const l=m(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;l.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&l.push(s)}return l}e.getNodePath=m;function b(t){switch(t.type){case"array":return t.children.map(b);case"object":const l=Object.create(null);for(let s of t.children){const r=s.children[1];r&&(l[s.children[0].value]=b(r))}return l;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=b;function S(t,l,s=!1){return l>=t.offset&&l<t.offset+t.length||s&&l===t.offset+t.length}e.contains=S;function c(t,l,s=!1){if(S(t,l,s)){const r=t.children;if(Array.isArray(r))for(let a=0;a<r.length&&r[a].offset<=l;a++){const g=c(r[a],l,s);if(g)return g}return t}}e.findNodeAtOffset=c;function h(t,l,s=D.DEFAULT){const r=I(t,!1);function a(W){return W?()=>W(r.getTokenOffset(),r.getTokenLength()):()=>!0}function g(W){return W?B=>W(B,r.getTokenOffset(),r.getTokenLength()):()=>!0}const p=a(l.onObjectBegin),k=g(l.onObjectProperty),R=a(l.onObjectEnd),T=a(l.onArrayBegin),O=a(l.onArrayEnd),V=g(l.onLiteralValue),ne=g(l.onSeparator),se=a(l.onComment),G=g(l.onError),te=s&&s.disallowComments,F=s&&s.allowTrailingComma;function j(){for(;;){const W=r.scan();switch(r.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:te||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(W){case 12:case 13:te?q(10):se();break;case 16:q(1);break;case 15:case 14:break;default:return W}}}function q(W,B=[],Y=[]){if(G(W),B.length+Y.length>0){let U=r.getToken();for(;U!==17;){if(B.indexOf(U)!==-1){j();break}else if(Y.indexOf(U)!==-1)break;U=j()}}}function $(W){const B=r.getTokenValue();return W?V(B):k(B),j(),!0}function H(){switch(r.getToken()){case 11:let W=0;try{W=JSON.parse(r.getTokenValue()),typeof W!="number"&&(q(2),W=0)}catch(B){q(2)}V(W);break;case 7:V(null);break;case 8:V(!0);break;case 9:V(!1);break;default:return!1}return j(),!0}function _(){return r.getToken()!==10?(q(3,[],[2,5]),!1):($(!1),r.getToken()===6?(ne(":"),j(),A()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function z(){p(),j();let W=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(W||q(4,[],[]),ne(","),j(),r.getToken()===2&&F)break}else W&&q(6,[],[]);_()||q(4,[],[2,5]),W=!0}return R(),r.getToken()!==2?q(7,[2],[]):j(),!0}function C(){T(),j();let W=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(W||q(4,[],[]),ne(","),j(),r.getToken()===4&&F)break}else W&&q(6,[],[]);A()||q(4,[],[4,5]),W=!0}return O(),r.getToken()!==4?q(8,[4],[]):j(),!0}function A(){switch(r.getToken()){case 3:return C();case 1:return z();case 10:return $(!0);default:return H()}}return j(),r.getToken()===17?s.allowEmptyContent?!0:(q(4,[],[]),!1):A()?(r.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}e.visit=h;function o(t,l){let s=I(t),r=[],a,g=0,p;do switch(p=s.getPosition(),a=s.scan(),a){case 12:case 13:case 17:g!==p&&r.push(t.substring(g,p)),l!==void 0&&r.push(s.getTokenValue().replace(/[^\r\n]/g,l)),g=s.getPosition();break}while(a!==17);return r.join("")}e.stripComments=o;function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(Z[104],x([0,1,40]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(f,w,i){let P,E,y,d,m;if(w){for(d=w.offset,m=d+w.length,y=d;y>0&&!n(f,y-1);)y--;let g=m;for(;g<f.length&&!n(f,g);)g++;E=f.substring(y,g),P=D(E,i)}else E=f,P=0,y=0,d=0,m=f.length;const b=I(i,f);let S=!1,c=0,h;i.insertSpaces?h=M(" ",i.tabSize||4):h="	";const o=(0,v.createScanner)(E,!1);let u=!1;function t(){return b+M(h,P+c)}function l(){let g=o.scan();for(S=!1;g===15||g===14;)S=S||g===14,g=o.scan();return u=g===16||o.getTokenError()!==0,g}const s=[];function r(g,p,k){!u&&p<m&&k>d&&f.substring(p,k)!==g&&s.push({offset:p,length:k-p,content:g})}let a=l();if(a!==17){const g=o.getTokenOffset()+y,p=M(h,P);r(p,y,g)}for(;a!==17;){let g=o.getTokenOffset()+o.getTokenLength()+y,p=l(),k="";for(;!S&&(p===12||p===13);){const T=o.getTokenOffset()+y;r(" ",g,T),g=o.getTokenOffset()+o.getTokenLength()+y,k=p===12?t():"",p=l()}if(p===2)a!==1&&(c--,k=t());else if(p===4)a!==3&&(c--,k=t());else{switch(a){case 3:case 1:c++,k=t();break;case 5:case 12:k=t();break;case 13:S?k=t():k=" ";break;case 6:k=" ";break;case 10:if(p===6){k="";break}case 7:case 8:case 9:case 11:case 2:case 4:p===12||p===13?k=" ":p!==5&&p!==17&&(u=!0);break;case 16:u=!0;break}S&&(p===12||p===13)&&(k=t())}const R=o.getTokenOffset()+y;r(k,g,R),a=p}return s}e.format=L;function M(f,w){let i="";for(let P=0;P<w;P++)i+=f;return i}function D(f,w){let i=0,P=0;const E=w.tabSize||4;for(;i<f.length;){const y=f.charAt(i);if(y===" ")P++;else if(y==="	")P+=E;else break;i++}return Math.floor(P/E)}function I(f,w){for(let i=0;i<w.length;i++){const P=w.charAt(i);if(P==="\r")return i+1<w.length&&w.charAt(i+1)===`
`?`\r
`:"\r";if(P===`
`)return`
`}return f&&f.eol||`
`}e.getEOL=I;function n(f,w){return`\r
`.indexOf(f.charAt(w))!==-1}e.isEOL=n}),define(Z[77],x([0,1,40,104]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function M(w,i,P){return D(w,i,void 0,P)}e.removeProperty=M;function D(w,i,P,E,y){const d=i.slice(),m=[],b=(0,v.parseTree)(w,m);let S,c;for(;d.length>0&&(c=d.pop(),S=(0,v.findNodeAtLocation)(b,d),S===void 0&&P!==void 0);)typeof c=="string"?P={[c]:P}:P=[P];if(S)if(S.type==="object"&&typeof c=="string"&&Array.isArray(S.children)){const h=(0,v.findNodeAtLocation)(S,[c]);if(h!==void 0)if(P===void 0){if(!h.parent)throw new Error("Malformed AST");const o=S.children.indexOf(h.parent);let u,t=h.parent.offset+h.parent.length;if(o>0){const l=S.children[o-1];u=l.offset+l.length}else u=S.offset+1,S.children.length>1&&(t=S.children[1].offset);return I(w,{offset:u,length:t-u,content:""},E)}else return I(w,{offset:h.offset,length:h.length,content:JSON.stringify(P)},E);else{if(P===void 0)return[];const o=`${JSON.stringify(c)}: ${JSON.stringify(P)}`,u=y?y(S.children.map(l=>l.children[0].value)):S.children.length;let t;if(u>0){const l=S.children[u-1];t={offset:l.offset+l.length,length:0,content:","+o}}else S.children.length===0?t={offset:S.offset+1,length:0,content:o}:t={offset:S.offset+1,length:0,content:o+","};return I(w,t,E)}}else if(S.type==="array"&&typeof c=="number"&&Array.isArray(S.children))if(P!==void 0){const h=`${JSON.stringify(P)}`;let o;if(S.children.length===0||c===0)o={offset:S.offset+1,length:0,content:S.children.length===0?h:h+","};else{const u=c===-1||c>S.children.length?S.children.length:c,t=S.children[u-1];o={offset:t.offset+t.length,length:0,content:","+h}}return I(w,o,E)}else{const h=c,o=S.children[h];let u;if(S.children.length===1)u={offset:S.offset+1,length:S.length-2,content:""};else if(S.children.length-1===h){const t=S.children[h-1],l=t.offset+t.length,s=S.offset+S.length;u={offset:l,length:s-2-l,content:""}}else u={offset:o.offset,length:S.children[h+1].offset-o.offset,content:""};return I(w,u,E)}else throw new Error(`Can not add ${typeof c!="number"?"index":"property"} to parent of type ${S.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return I(w,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(P)},E)}}e.setProperty=D;function I(w,i,P){let E=n(w,i),y=i.offset,d=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;y>0&&!(0,L.isEOL)(E,y-1);)y--;for(;d<E.length&&!(0,L.isEOL)(E,d);)d++}const m=(0,L.format)(E,{offset:y,length:d-y},P);for(let S=m.length-1;S>=0;S--){const c=m[S];E=n(E,c),y=Math.min(y,c.offset),d=Math.max(d,c.offset+c.length),d+=c.content.length-c.length}const b=w.length-(E.length-d)-y;return[{offset:y,length:b,content:E.substring(y,d)}]}e.withFormatting=I;function n(w,i){return w.substring(0,i.offset)+i.content+w.substring(i.offset+i.length)}e.applyEdit=n;function f(w,i){let P=i.slice(0).sort((y,d)=>{const m=y.offset-d.offset;return m===0?y.length-d.length:m}),E=w.length;for(let y=P.length-1;y>=0;y--){let d=P[y];if(d.offset+d.length<=E)w=n(w,d);else throw new Error("Overlapping edit");E=d.offset}return w}e.applyEdits=f}),define(Z[57],x([0,1,17]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var L;(function(c){c[c.DependsOnKbLayout=-1]="DependsOnKbLayout",c[c.Unknown=0]="Unknown",c[c.Backspace=1]="Backspace",c[c.Tab=2]="Tab",c[c.Enter=3]="Enter",c[c.Shift=4]="Shift",c[c.Ctrl=5]="Ctrl",c[c.Alt=6]="Alt",c[c.PauseBreak=7]="PauseBreak",c[c.CapsLock=8]="CapsLock",c[c.Escape=9]="Escape",c[c.Space=10]="Space",c[c.PageUp=11]="PageUp",c[c.PageDown=12]="PageDown",c[c.End=13]="End",c[c.Home=14]="Home",c[c.LeftArrow=15]="LeftArrow",c[c.UpArrow=16]="UpArrow",c[c.RightArrow=17]="RightArrow",c[c.DownArrow=18]="DownArrow",c[c.Insert=19]="Insert",c[c.Delete=20]="Delete",c[c.KEY_0=21]="KEY_0",c[c.KEY_1=22]="KEY_1",c[c.KEY_2=23]="KEY_2",c[c.KEY_3=24]="KEY_3",c[c.KEY_4=25]="KEY_4",c[c.KEY_5=26]="KEY_5",c[c.KEY_6=27]="KEY_6",c[c.KEY_7=28]="KEY_7",c[c.KEY_8=29]="KEY_8",c[c.KEY_9=30]="KEY_9",c[c.KEY_A=31]="KEY_A",c[c.KEY_B=32]="KEY_B",c[c.KEY_C=33]="KEY_C",c[c.KEY_D=34]="KEY_D",c[c.KEY_E=35]="KEY_E",c[c.KEY_F=36]="KEY_F",c[c.KEY_G=37]="KEY_G",c[c.KEY_H=38]="KEY_H",c[c.KEY_I=39]="KEY_I",c[c.KEY_J=40]="KEY_J",c[c.KEY_K=41]="KEY_K",c[c.KEY_L=42]="KEY_L",c[c.KEY_M=43]="KEY_M",c[c.KEY_N=44]="KEY_N",c[c.KEY_O=45]="KEY_O",c[c.KEY_P=46]="KEY_P",c[c.KEY_Q=47]="KEY_Q",c[c.KEY_R=48]="KEY_R",c[c.KEY_S=49]="KEY_S",c[c.KEY_T=50]="KEY_T",c[c.KEY_U=51]="KEY_U",c[c.KEY_V=52]="KEY_V",c[c.KEY_W=53]="KEY_W",c[c.KEY_X=54]="KEY_X",c[c.KEY_Y=55]="KEY_Y",c[c.KEY_Z=56]="KEY_Z",c[c.Meta=57]="Meta",c[c.ContextMenu=58]="ContextMenu",c[c.F1=59]="F1",c[c.F2=60]="F2",c[c.F3=61]="F3",c[c.F4=62]="F4",c[c.F5=63]="F5",c[c.F6=64]="F6",c[c.F7=65]="F7",c[c.F8=66]="F8",c[c.F9=67]="F9",c[c.F10=68]="F10",c[c.F11=69]="F11",c[c.F12=70]="F12",c[c.F13=71]="F13",c[c.F14=72]="F14",c[c.F15=73]="F15",c[c.F16=74]="F16",c[c.F17=75]="F17",c[c.F18=76]="F18",c[c.F19=77]="F19",c[c.NumLock=78]="NumLock",c[c.ScrollLock=79]="ScrollLock",c[c.US_SEMICOLON=80]="US_SEMICOLON",c[c.US_EQUAL=81]="US_EQUAL",c[c.US_COMMA=82]="US_COMMA",c[c.US_MINUS=83]="US_MINUS",c[c.US_DOT=84]="US_DOT",c[c.US_SLASH=85]="US_SLASH",c[c.US_BACKTICK=86]="US_BACKTICK",c[c.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",c[c.US_BACKSLASH=88]="US_BACKSLASH",c[c.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",c[c.US_QUOTE=90]="US_QUOTE",c[c.OEM_8=91]="OEM_8",c[c.OEM_102=92]="OEM_102",c[c.NUMPAD_0=93]="NUMPAD_0",c[c.NUMPAD_1=94]="NUMPAD_1",c[c.NUMPAD_2=95]="NUMPAD_2",c[c.NUMPAD_3=96]="NUMPAD_3",c[c.NUMPAD_4=97]="NUMPAD_4",c[c.NUMPAD_5=98]="NUMPAD_5",c[c.NUMPAD_6=99]="NUMPAD_6",c[c.NUMPAD_7=100]="NUMPAD_7",c[c.NUMPAD_8=101]="NUMPAD_8",c[c.NUMPAD_9=102]="NUMPAD_9",c[c.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",c[c.NUMPAD_ADD=104]="NUMPAD_ADD",c[c.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",c[c.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",c[c.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",c[c.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",c[c.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",c[c.ABNT_C1=110]="ABNT_C1",c[c.ABNT_C2=111]="ABNT_C2",c[c.MAX_VALUE=112]="MAX_VALUE"})(L=e.KeyCode||(e.KeyCode={}));class M{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(h,o){this._keyCodeToStr[h]=o,this._strToKeyCode[o.toLowerCase()]=h}keyCodeToStr(h){return this._keyCodeToStr[h]}strToKeyCode(h){return this._strToKeyCode[h.toLowerCase()]||0}}const D=new M,I=new M,n=new M;(function(){function c(h,o,u=o,t=u){D.define(h,o),I.define(h,u),n.define(h,t)}c(0,"unknown"),c(1,"Backspace"),c(2,"Tab"),c(3,"Enter"),c(4,"Shift"),c(5,"Ctrl"),c(6,"Alt"),c(7,"PauseBreak"),c(8,"CapsLock"),c(9,"Escape"),c(10,"Space"),c(11,"PageUp"),c(12,"PageDown"),c(13,"End"),c(14,"Home"),c(15,"LeftArrow","Left"),c(16,"UpArrow","Up"),c(17,"RightArrow","Right"),c(18,"DownArrow","Down"),c(19,"Insert"),c(20,"Delete"),c(21,"0"),c(22,"1"),c(23,"2"),c(24,"3"),c(25,"4"),c(26,"5"),c(27,"6"),c(28,"7"),c(29,"8"),c(30,"9"),c(31,"A"),c(32,"B"),c(33,"C"),c(34,"D"),c(35,"E"),c(36,"F"),c(37,"G"),c(38,"H"),c(39,"I"),c(40,"J"),c(41,"K"),c(42,"L"),c(43,"M"),c(44,"N"),c(45,"O"),c(46,"P"),c(47,"Q"),c(48,"R"),c(49,"S"),c(50,"T"),c(51,"U"),c(52,"V"),c(53,"W"),c(54,"X"),c(55,"Y"),c(56,"Z"),c(57,"Meta"),c(58,"ContextMenu"),c(59,"F1"),c(60,"F2"),c(61,"F3"),c(62,"F4"),c(63,"F5"),c(64,"F6"),c(65,"F7"),c(66,"F8"),c(67,"F9"),c(68,"F10"),c(69,"F11"),c(70,"F12"),c(71,"F13"),c(72,"F14"),c(73,"F15"),c(74,"F16"),c(75,"F17"),c(76,"F18"),c(77,"F19"),c(78,"NumLock"),c(79,"ScrollLock"),c(80,";",";","OEM_1"),c(81,"=","=","OEM_PLUS"),c(82,",",",","OEM_COMMA"),c(83,"-","-","OEM_MINUS"),c(84,".",".","OEM_PERIOD"),c(85,"/","/","OEM_2"),c(86,"`","`","OEM_3"),c(110,"ABNT_C1"),c(111,"ABNT_C2"),c(87,"[","[","OEM_4"),c(88,"\\","\\","OEM_5"),c(89,"]","]","OEM_6"),c(90,"'","'","OEM_7"),c(91,"OEM_8"),c(92,"OEM_102"),c(93,"NumPad0"),c(94,"NumPad1"),c(95,"NumPad2"),c(96,"NumPad3"),c(97,"NumPad4"),c(98,"NumPad5"),c(99,"NumPad6"),c(100,"NumPad7"),c(101,"NumPad8"),c(102,"NumPad9"),c(103,"NumPad_Multiply"),c(104,"NumPad_Add"),c(105,"NumPad_Separator"),c(106,"NumPad_Subtract"),c(107,"NumPad_Decimal"),c(108,"NumPad_Divide")})();var f;(function(c){function h(s){return D.keyCodeToStr(s)}c.toString=h;function o(s){return D.strToKeyCode(s)}c.fromString=o;function u(s){return I.keyCodeToStr(s)}c.toUserSettingsUS=u;function t(s){return n.keyCodeToStr(s)}c.toUserSettingsGeneral=t;function l(s){return I.strToKeyCode(s)||n.strToKeyCode(s)}c.fromUserSettings=l})(f=e.KeyCodeUtils||(e.KeyCodeUtils={}));var w;(function(c){c[c.CtrlCmd=2048]="CtrlCmd",c[c.Shift=1024]="Shift",c[c.Alt=512]="Alt",c[c.WinCtrl=256]="WinCtrl",c[c.KeyCode=255]="KeyCode"})(w||(w={}));var i;(function(c){c[c.CtrlCmd=2048]="CtrlCmd",c[c.Shift=1024]="Shift",c[c.Alt=512]="Alt",c[c.WinCtrl=256]="WinCtrl"})(i=e.KeyMod||(e.KeyMod={}));function P(c,h){const o=(h&65535)<<16>>>0;return(c|o)>>>0}e.KeyChord=P;function E(c,h){if(c===0)return null;const o=(c&65535)>>>0,u=(c&4294901760)>>>16;return u!==0?new m([y(o,h),y(u,h)]):new m([y(o,h)])}e.createKeybinding=E;function y(c,h){const o=!!(c&2048),u=!!(c&256),t=h===2?u:o,l=!!(c&1024),s=!!(c&512),r=h===2?o:u,a=c&255;return new d(t,l,s,r,a)}e.createSimpleKeybinding=y;class d{constructor(h,o,u,t,l){this.ctrlKey=h,this.shiftKey=o,this.altKey=u,this.metaKey=t,this.keyCode=l}equals(h){return this.ctrlKey===h.ctrlKey&&this.shiftKey===h.shiftKey&&this.altKey===h.altKey&&this.metaKey===h.metaKey&&this.keyCode===h.keyCode}getHashCode(){const h=this.ctrlKey?"1":"0",o=this.shiftKey?"1":"0",u=this.altKey?"1":"0",t=this.metaKey?"1":"0";return`${h}${o}${u}${t}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new m([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=d;class m{constructor(h){if(h.length===0)throw(0,v.illegalArgument)("parts");this.parts=h}getHashCode(){let h="";for(let o=0,u=this.parts.length;o<u;o++)o!==0&&(h+=";"),h+=this.parts[o].getHashCode();return h}equals(h){if(h===null||this.parts.length!==h.parts.length)return!1;for(let o=0;o<this.parts.length;o++)if(!this.parts[o].equals(h.parts[o]))return!1;return!0}}e.ChordKeybinding=m;class b{constructor(h,o,u,t,l,s){this.ctrlKey=h,this.shiftKey=o,this.altKey=u,this.metaKey=t,this.keyLabel=l,this.keyAriaLabel=s}}e.ResolvedKeybindingPart=b;class S{}e.ResolvedKeybinding=S}),define(Z[2],x([0,1,43,66]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const M=!1;let D=null;function I(r){D=r}if(e.setDisposableTracker=I,M){const r="__is_disposable_tracked__";I(new class{trackDisposable(a){const g=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[r]||console.log(g)},3e3)}setParent(a,g){if(a&&a!==c.None)try{a[r]=!0}catch{}}markAsDisposed(a){if(a&&a!==c.None)try{a[r]=!0}catch{}}markAsSingleton(a){}})}function n(r){return D?.trackDisposable(r),r}function f(r){D?.markAsDisposed(r)}function w(r,a){D?.setParent(r,a)}function i(r,a){if(!!D)for(const g of r)D.setParent(g,a)}function P(r){return D?.markAsSingleton(r),r}e.markAsSingleton=P;class E extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=E;function y(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=y;function d(r){if(L.Iterable.is(r)){let a=[];for(const g of r)if(g)try{g.dispose()}catch(p){a.push(p)}if(a.length===1)throw a[0];if(a.length>1)throw new E(a);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=d;function m(...r){const a=b(()=>d(r));return i(r,a),a}e.combinedDisposable=m;function b(r){const a=n({dispose:(0,v.once)(()=>{f(a),r()})});return a}e.toDisposable=b;class S{constructor(){this._toDispose=new Set,this._isDisposed=!1,n(this)}dispose(){this._isDisposed||(f(this),this._isDisposed=!0,this.clear())}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return w(a,this),this._isDisposed?S.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=S,S.DISABLE_DISPOSED_WARNING=!1;class c{constructor(){this._store=new S,n(this),w(this._store,this)}dispose(){f(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=c,c.None=Object.freeze({dispose(){}});class h{constructor(){this._isDisposed=!1,n(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&w(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,f(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&w(a,null),a}}e.MutableDisposable=h;class o{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=o;class u{constructor(){this.references=new Map}acquire(a,...g){let p=this.references.get(a);p||(p={counter:0,object:this.createReferencedObject(a,...g)},this.references.set(a,p));const{object:k}=p,R=(0,v.once)(()=>{--p.counter==0&&(this.destroyReferencedObject(a,p.object),this.references.delete(a))});return p.counter++,{object:k,dispose:R}}}e.ReferenceCollection=u;class t{constructor(a){this.referenceCollection=a}async acquire(a,...g){const p=this.referenceCollection.acquire(a,...g);try{return{object:await p.object,dispose:()=>p.dispose()}}catch(k){throw p.dispose(),k}}}e.AsyncReferenceCollection=t;class l{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=l;function s(r){const a=new S;try{r(a)}finally{a.dispose()}}e.disposeOnReturn=s}),define(Z[105],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(D){this.element=D,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class L{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let D=this._first;for(;D!==v.Undefined;){const I=D.next;D.prev=v.Undefined,D.next=v.Undefined,D=I}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(D){return this._insert(D,!1)}push(D){return this._insert(D,!0)}_insert(D,I){const n=new v(D);if(this._first===v.Undefined)this._first=n,this._last=n;else if(I){const w=this._last;this._last=n,n.prev=w,w.next=n}else{const w=this._first;this._first=n,n.next=w,w.prev=n}this._size+=1;let f=!1;return()=>{f||(f=!0,this._remove(n))}}shift(){if(this._first!==v.Undefined){const D=this._first.element;return this._remove(this._first),D}}pop(){if(this._last!==v.Undefined){const D=this._last.element;return this._remove(this._last),D}}_remove(D){if(D.prev!==v.Undefined&&D.next!==v.Undefined){const I=D.prev;I.next=D.next,D.next.prev=I}else D.prev===v.Undefined&&D.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):D.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):D.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let D=this._first;for(;D!==v.Undefined;)yield D.element,D=D.next}}e.LinkedList=L}),function(){function K(M){const D=[];typeof M=="number"&&D.push("code/timeOrigin",M);function I(f){D.push(f,Date.now())}function n(){const f=[];for(let w=0;w<D.length;w+=2)f.push({name:D[w],startTime:D[w+1]});return f}return{mark:I,getMarks:n}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(M){performance.mark(M)},getMarks(){let M=performance.timeOrigin;typeof M!="number"&&(M=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(M)}];for(const I of performance.getEntriesByType("mark"))D.push({name:I.name,startTime:Math.round(M+I.startTime)});return D}};if(typeof process=="object"){const M=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(M)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function v(M){return M.MonacoPerformanceMarks||(M.MonacoPerformanceMarks=e()),M.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=v(L))}(),define(Z[3],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const v="en";let L=!1,M=!1,D=!1,I=!1,n=!1,f=!1,w=!1,i,P=v,E,y;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const m=typeof d?.versions?.electron=="string"&&d.type==="renderer";if(e.isElectronSandboxed=m&&d?.sandboxed,typeof navigator=="object"&&!m)y=navigator.userAgent,L=y.indexOf("Windows")>=0,M=y.indexOf("Macintosh")>=0,w=(y.indexOf("Macintosh")>=0||y.indexOf("iPad")>=0||y.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=y.indexOf("Linux")>=0,f=!0,i=navigator.language,P=i;else if(typeof d=="object"){L=d.platform==="win32",M=d.platform==="darwin",D=d.platform==="linux",I=D&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,i=v,P=v;const s=d.env.VSCODE_NLS_CONFIG;if(s)try{const r=JSON.parse(s),a=r.availableLanguages["*"];i=r.locale,P=a||v,E=r._translationsConfigFile}catch(r){}n=!0}else console.error("Unable to resolve platform.");var b;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function S(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=S;let c=0;M?c=1:L?c=3:D&&(c=2),e.isWindows=L,e.isMacintosh=M,e.isLinux=D,e.isLinuxSnap=I,e.isNative=n,e.isWeb=f,e.isIOS=w,e.platform=c,e.userAgent=y,e.language=P;var h;(function(s){function r(){return e.language}s.value=r;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=a;function g(){return e.language==="en"}s.isDefault=g})(h=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=E,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let a=[];e.globals.addEventListener("message",p=>{if(p.data&&p.data.vscodeSetImmediateId)for(let k=0,R=a.length;k<R;k++){const T=a[k];if(T.id===p.data.vscodeSetImmediateId){a.splice(k,1),T.callback();return}}});let g=0;return p=>{const k=++g;a.push({id:k,callback:p}),e.globals.postMessage({vscodeSetImmediateId:k},"*")}}if(typeof d?.nextTick=="function")return d.nextTick.bind(d);const r=Promise.resolve();return a=>r.then(a)}();var o;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(o=e.OperatingSystem||(e.OperatingSystem={})),e.OS=M||w?2:L?1:3;let u=!0,t=!1;function l(){if(!t){t=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,u=new Uint16Array(s.buffer)[0]===(2<<8)+1}return u}e.isLittleEndian=l}),define(Z[33],x([0,1,3]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const M=v.globals.vscode.process;L={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()},nextTick(D){return(0,v.setImmediate)(D)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(M){return process.nextTick(M)}}:L={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},get arch(){},nextTick(M){return(0,v.setImmediate)(M)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(Z[7],x([0,1,33]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,M=97,D=90,I=122,n=46,f=47,w=92,i=58,P=63;class E extends Error{constructor(o,u,t){let l;typeof u=="string"&&u.indexOf("not ")===0?(l="must not be",u=u.replace(/^not /,"")):l="must be";const s=o.indexOf(".")!==-1?"property":"argument";let r=`The "${o}" ${s} ${l} of type ${u}`;r+=`. Received type ${typeof t}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function y(h,o){if(typeof h!="string")throw new E(o,"string",h)}function d(h){return h===f||h===w}function m(h){return h===f}function b(h){return h>=L&&h<=D||h>=M&&h<=I}function S(h,o,u,t){let l="",s=0,r=-1,a=0,g=0;for(let p=0;p<=h.length;++p){if(p<h.length)g=h.charCodeAt(p);else{if(t(g))break;g=f}if(t(g)){if(!(r===p-1||a===1))if(a===2){if(l.length<2||s!==2||l.charCodeAt(l.length-1)!==n||l.charCodeAt(l.length-2)!==n){if(l.length>2){const k=l.lastIndexOf(u);k===-1?(l="",s=0):(l=l.slice(0,k),s=l.length-1-l.lastIndexOf(u)),r=p,a=0;continue}else if(l.length!==0){l="",s=0,r=p,a=0;continue}}o&&(l+=l.length>0?`${u}..`:"..",s=2)}else l.length>0?l+=`${u}${h.slice(r+1,p)}`:l=h.slice(r+1,p),s=p-r-1;r=p,a=0}else g===n&&a!==-1?++a:a=-1}return l}function c(h,o){if(o===null||typeof o!="object")throw new E("pathObject","Object",o);const u=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return u?u===o.root?`${u}${t}`:`${u}${h}${t}`:t}e.win32={resolve(...h){let o="",u="",t=!1;for(let l=h.length-1;l>=-1;l--){let s;if(l>=0){if(s=h[l],y(s,"path"),s.length===0)continue}else o.length===0?s=v.cwd():(s=v.env[`=${o}`]||v.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==o.toLowerCase()&&s.charCodeAt(2)===w)&&(s=`${o}\\`));const r=s.length;let a=0,g="",p=!1;const k=s.charCodeAt(0);if(r===1)d(k)&&(a=1,p=!0);else if(d(k))if(p=!0,d(s.charCodeAt(1))){let R=2,T=R;for(;R<r&&!d(s.charCodeAt(R));)R++;if(R<r&&R!==T){const O=s.slice(T,R);for(T=R;R<r&&d(s.charCodeAt(R));)R++;if(R<r&&R!==T){for(T=R;R<r&&!d(s.charCodeAt(R));)R++;(R===r||R!==T)&&(g=`\\\\${O}\\${s.slice(T,R)}`,a=R)}}}else a=1;else b(k)&&s.charCodeAt(1)===i&&(g=s.slice(0,2),a=2,r>2&&d(s.charCodeAt(2))&&(p=!0,a=3));if(g.length>0)if(o.length>0){if(g.toLowerCase()!==o.toLowerCase())continue}else o=g;if(t){if(o.length>0)break}else if(u=`${s.slice(a)}\\${u}`,t=p,p&&o.length>0)break}return u=S(u,!t,"\\",d),t?`${o}\\${u}`:`${o}${u}`||"."},normalize(h){y(h,"path");const o=h.length;if(o===0)return".";let u=0,t,l=!1;const s=h.charCodeAt(0);if(o===1)return m(s)?"\\":h;if(d(s))if(l=!0,d(h.charCodeAt(1))){let a=2,g=a;for(;a<o&&!d(h.charCodeAt(a));)a++;if(a<o&&a!==g){const p=h.slice(g,a);for(g=a;a<o&&d(h.charCodeAt(a));)a++;if(a<o&&a!==g){for(g=a;a<o&&!d(h.charCodeAt(a));)a++;if(a===o)return`\\\\${p}\\${h.slice(g)}\\`;a!==g&&(t=`\\\\${p}\\${h.slice(g,a)}`,u=a)}}}else u=1;else b(s)&&h.charCodeAt(1)===i&&(t=h.slice(0,2),u=2,o>2&&d(h.charCodeAt(2))&&(l=!0,u=3));let r=u<o?S(h.slice(u),!l,"\\",d):"";return r.length===0&&!l&&(r="."),r.length>0&&d(h.charCodeAt(o-1))&&(r+="\\"),t===void 0?l?`\\${r}`:r:l?`${t}\\${r}`:`${t}${r}`},isAbsolute(h){y(h,"path");const o=h.length;if(o===0)return!1;const u=h.charCodeAt(0);return d(u)||o>2&&b(u)&&h.charCodeAt(1)===i&&d(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let o,u;for(let s=0;s<h.length;++s){const r=h[s];y(r,"path"),r.length>0&&(o===void 0?o=u=r:o+=`\\${r}`)}if(o===void 0)return".";let t=!0,l=0;if(typeof u=="string"&&d(u.charCodeAt(0))){++l;const s=u.length;s>1&&d(u.charCodeAt(1))&&(++l,s>2&&(d(u.charCodeAt(2))?++l:t=!1))}if(t){for(;l<o.length&&d(o.charCodeAt(l));)l++;l>=2&&(o=`\\${o.slice(l)}`)}return e.win32.normalize(o)},relative(h,o){if(y(h,"from"),y(o,"to"),h===o)return"";const u=e.win32.resolve(h),t=e.win32.resolve(o);if(u===t||(h=u.toLowerCase(),o=t.toLowerCase(),h===o))return"";let l=0;for(;l<h.length&&h.charCodeAt(l)===w;)l++;let s=h.length;for(;s-1>l&&h.charCodeAt(s-1)===w;)s--;const r=s-l;let a=0;for(;a<o.length&&o.charCodeAt(a)===w;)a++;let g=o.length;for(;g-1>a&&o.charCodeAt(g-1)===w;)g--;const p=g-a,k=r<p?r:p;let R=-1,T=0;for(;T<k;T++){const V=h.charCodeAt(l+T);if(V!==o.charCodeAt(a+T))break;V===w&&(R=T)}if(T!==k){if(R===-1)return t}else{if(p>k){if(o.charCodeAt(a+T)===w)return t.slice(a+T+1);if(T===2)return t.slice(a+T)}r>k&&(h.charCodeAt(l+T)===w?R=T:T===2&&(R=3)),R===-1&&(R=0)}let O="";for(T=l+R+1;T<=s;++T)(T===s||h.charCodeAt(T)===w)&&(O+=O.length===0?"..":"\\..");return a+=R,O.length>0?`${O}${t.slice(a,g)}`:(t.charCodeAt(a)===w&&++a,t.slice(a,g))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const o=e.win32.resolve(h);if(o.length<=2)return h;if(o.charCodeAt(0)===w){if(o.charCodeAt(1)===w){const u=o.charCodeAt(2);if(u!==P&&u!==n)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(b(o.charCodeAt(0))&&o.charCodeAt(1)===i&&o.charCodeAt(2)===w)return`\\\\?\\${o}`;return h},dirname(h){y(h,"path");const o=h.length;if(o===0)return".";let u=-1,t=0;const l=h.charCodeAt(0);if(o===1)return d(l)?h:".";if(d(l)){if(u=t=1,d(h.charCodeAt(1))){let a=2,g=a;for(;a<o&&!d(h.charCodeAt(a));)a++;if(a<o&&a!==g){for(g=a;a<o&&d(h.charCodeAt(a));)a++;if(a<o&&a!==g){for(g=a;a<o&&!d(h.charCodeAt(a));)a++;if(a===o)return h;a!==g&&(u=t=a+1)}}}}else b(l)&&h.charCodeAt(1)===i&&(u=o>2&&d(h.charCodeAt(2))?3:2,t=u);let s=-1,r=!0;for(let a=o-1;a>=t;--a)if(d(h.charCodeAt(a))){if(!r){s=a;break}}else r=!1;if(s===-1){if(u===-1)return".";s=u}return h.slice(0,s)},basename(h,o){o!==void 0&&y(o,"ext"),y(h,"path");let u=0,t=-1,l=!0,s;if(h.length>=2&&b(h.charCodeAt(0))&&h.charCodeAt(1)===i&&(u=2),o!==void 0&&o.length>0&&o.length<=h.length){if(o===h)return"";let r=o.length-1,a=-1;for(s=h.length-1;s>=u;--s){const g=h.charCodeAt(s);if(d(g)){if(!l){u=s+1;break}}else a===-1&&(l=!1,a=s+1),r>=0&&(g===o.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=a))}return u===t?t=a:t===-1&&(t=h.length),h.slice(u,t)}for(s=h.length-1;s>=u;--s)if(d(h.charCodeAt(s))){if(!l){u=s+1;break}}else t===-1&&(l=!1,t=s+1);return t===-1?"":h.slice(u,t)},extname(h){y(h,"path");let o=0,u=-1,t=0,l=-1,s=!0,r=0;h.length>=2&&h.charCodeAt(1)===i&&b(h.charCodeAt(0))&&(o=t=2);for(let a=h.length-1;a>=o;--a){const g=h.charCodeAt(a);if(d(g)){if(!s){t=a+1;break}continue}l===-1&&(s=!1,l=a+1),g===n?u===-1?u=a:r!==1&&(r=1):u!==-1&&(r=-1)}return u===-1||l===-1||r===0||r===1&&u===l-1&&u===t+1?"":h.slice(u,l)},format:c.bind(null,"\\"),parse(h){y(h,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return o;const u=h.length;let t=0,l=h.charCodeAt(0);if(u===1)return d(l)?(o.root=o.dir=h,o):(o.base=o.name=h,o);if(d(l)){if(t=1,d(h.charCodeAt(1))){let R=2,T=R;for(;R<u&&!d(h.charCodeAt(R));)R++;if(R<u&&R!==T){for(T=R;R<u&&d(h.charCodeAt(R));)R++;if(R<u&&R!==T){for(T=R;R<u&&!d(h.charCodeAt(R));)R++;R===u?t=R:R!==T&&(t=R+1)}}}}else if(b(l)&&h.charCodeAt(1)===i){if(u<=2)return o.root=o.dir=h,o;if(t=2,d(h.charCodeAt(2))){if(u===3)return o.root=o.dir=h,o;t=3}}t>0&&(o.root=h.slice(0,t));let s=-1,r=t,a=-1,g=!0,p=h.length-1,k=0;for(;p>=t;--p){if(l=h.charCodeAt(p),d(l)){if(!g){r=p+1;break}continue}a===-1&&(g=!1,a=p+1),l===n?s===-1?s=p:k!==1&&(k=1):s!==-1&&(k=-1)}return a!==-1&&(s===-1||k===0||k===1&&s===a-1&&s===r+1?o.base=o.name=h.slice(r,a):(o.name=h.slice(r,s),o.base=h.slice(r,a),o.ext=h.slice(s,a))),r>0&&r!==t?o.dir=h.slice(0,r-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let o="",u=!1;for(let t=h.length-1;t>=-1&&!u;t--){const l=t>=0?h[t]:v.cwd();y(l,"path"),l.length!==0&&(o=`${l}/${o}`,u=l.charCodeAt(0)===f)}return o=S(o,!u,"/",m),u?`/${o}`:o.length>0?o:"."},normalize(h){if(y(h,"path"),h.length===0)return".";const o=h.charCodeAt(0)===f,u=h.charCodeAt(h.length-1)===f;return h=S(h,!o,"/",m),h.length===0?o?"/":u?"./":".":(u&&(h+="/"),o?`/${h}`:h)},isAbsolute(h){return y(h,"path"),h.length>0&&h.charCodeAt(0)===f},join(...h){if(h.length===0)return".";let o;for(let u=0;u<h.length;++u){const t=h[u];y(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(h,o){if(y(h,"from"),y(o,"to"),h===o||(h=e.posix.resolve(h),o=e.posix.resolve(o),h===o))return"";const u=1,t=h.length,l=t-u,s=1,r=o.length-s,a=l<r?l:r;let g=-1,p=0;for(;p<a;p++){const R=h.charCodeAt(u+p);if(R!==o.charCodeAt(s+p))break;R===f&&(g=p)}if(p===a)if(r>a){if(o.charCodeAt(s+p)===f)return o.slice(s+p+1);if(p===0)return o.slice(s+p)}else l>a&&(h.charCodeAt(u+p)===f?g=p:p===0&&(g=0));let k="";for(p=u+g+1;p<=t;++p)(p===t||h.charCodeAt(p)===f)&&(k+=k.length===0?"..":"/..");return`${k}${o.slice(s+g)}`},toNamespacedPath(h){return h},dirname(h){if(y(h,"path"),h.length===0)return".";const o=h.charCodeAt(0)===f;let u=-1,t=!0;for(let l=h.length-1;l>=1;--l)if(h.charCodeAt(l)===f){if(!t){u=l;break}}else t=!1;return u===-1?o?"/":".":o&&u===1?"//":h.slice(0,u)},basename(h,o){o!==void 0&&y(o,"ext"),y(h,"path");let u=0,t=-1,l=!0,s;if(o!==void 0&&o.length>0&&o.length<=h.length){if(o===h)return"";let r=o.length-1,a=-1;for(s=h.length-1;s>=0;--s){const g=h.charCodeAt(s);if(g===f){if(!l){u=s+1;break}}else a===-1&&(l=!1,a=s+1),r>=0&&(g===o.charCodeAt(r)?--r==-1&&(t=s):(r=-1,t=a))}return u===t?t=a:t===-1&&(t=h.length),h.slice(u,t)}for(s=h.length-1;s>=0;--s)if(h.charCodeAt(s)===f){if(!l){u=s+1;break}}else t===-1&&(l=!1,t=s+1);return t===-1?"":h.slice(u,t)},extname(h){y(h,"path");let o=-1,u=0,t=-1,l=!0,s=0;for(let r=h.length-1;r>=0;--r){const a=h.charCodeAt(r);if(a===f){if(!l){u=r+1;break}continue}t===-1&&(l=!1,t=r+1),a===n?o===-1?o=r:s!==1&&(s=1):o!==-1&&(s=-1)}return o===-1||t===-1||s===0||s===1&&o===t-1&&o===u+1?"":h.slice(o,t)},format:c.bind(null,"/"),parse(h){y(h,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return o;const u=h.charCodeAt(0)===f;let t;u?(o.root="/",t=1):t=0;let l=-1,s=0,r=-1,a=!0,g=h.length-1,p=0;for(;g>=t;--g){const k=h.charCodeAt(g);if(k===f){if(!a){s=g+1;break}continue}r===-1&&(a=!1,r=g+1),k===n?l===-1?l=g:p!==1&&(p=1):l!==-1&&(p=-1)}if(r!==-1){const k=s===0&&u?1:s;l===-1||p===0||p===1&&l===r-1&&l===s+1?o.base=o.name=h.slice(k,r):(o.name=h.slice(k,l),o.base=h.slice(k,r),o.ext=h.slice(l,r))}return s>0?o.dir=h.slice(0,s-1):u&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Z[78],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var v;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(v=e.Source||(e.Source={}));var L;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function M(D,...I){const n=I.reduce((i,P)=>(i[P]=!0,i),{}),f=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(i=>!n[i]).forEach(i=>{for(let P=0;P<f.length;P++)if(i.search(f[P])!==-1){delete D[i];break}})}e.sanitizeProcessEnvironment=M}),define(Z[79],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var v;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(v=e.ScanCode||(e.ScanCode={}));const L=[],M=Object.create(null),D=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>D[n]||0,toEnum:n=>M[n]||0,toString:n=>L[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class I{constructor(f,w,i,P,E){this.ctrlKey=f,this.shiftKey=w,this.altKey=i,this.metaKey=P,this.scanCode=E}equals(f){return this.ctrlKey===f.ctrlKey&&this.shiftKey===f.shiftKey&&this.altKey===f.altKey&&this.metaKey===f.metaKey&&this.scanCode===f.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=I,function(){function n(f,w){L[f]=w,M[w]=f,D[w.toLowerCase()]=f}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let f=0;f<=193;f++)e.IMMUTABLE_CODE_TO_KEY_CODE[f]=-1;for(let f=0;f<=112;f++)e.IMMUTABLE_KEY_CODE_TO_CODE[f]=-1;function n(f,w){e.IMMUTABLE_CODE_TO_KEY_CODE[f]=w,w!==0&&w!==3&&w!==5&&w!==4&&w!==6&&w!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[w]=f)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(Z[106],x([0,1,57,79]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class M{static _readModifiers(I){I=I.toLowerCase().trim();let n=!1,f=!1,w=!1,i=!1,P;do P=!1,/^ctrl(\+|\-)/.test(I)&&(n=!0,I=I.substr("ctrl-".length),P=!0),/^shift(\+|\-)/.test(I)&&(f=!0,I=I.substr("shift-".length),P=!0),/^alt(\+|\-)/.test(I)&&(w=!0,I=I.substr("alt-".length),P=!0),/^meta(\+|\-)/.test(I)&&(i=!0,I=I.substr("meta-".length),P=!0),/^win(\+|\-)/.test(I)&&(i=!0,I=I.substr("win-".length),P=!0),/^cmd(\+|\-)/.test(I)&&(i=!0,I=I.substr("cmd-".length),P=!0);while(P);let E;const y=I.indexOf(" ");return y>0?(E=I.substring(0,y),I=I.substring(y)):(E=I,I=""),{remains:I,ctrl:n,shift:f,alt:w,meta:i,key:E}}static parseSimpleKeybinding(I){const n=this._readModifiers(I),f=v.KeyCodeUtils.fromUserSettings(n.key);return[new v.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,f),n.remains]}static parseKeybinding(I,n){if(!I)return null;const f=[];let w;do[w,I]=this.parseSimpleKeybinding(I),f.push(w);while(I.length>0);return new v.ChordKeybinding(f)}static parseSimpleUserBinding(I){const n=this._readModifiers(I),f=n.key.match(/^\[([^\]]+)\]$/);if(f){const i=f[1],P=L.ScanCodeUtils.lowerCaseToEnum(i);return[new L.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,P),n.remains]}const w=v.KeyCodeUtils.fromUserSettings(n.key);return[new v.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,w),n.remains]}static parseUserBinding(I){if(!I)return[];const n=[];let f;for(;I.length>0;)[f,I]=this.parseSimpleUserBinding(I),n.push(f);return n}}e.KeybindingParser=M}),define(Z[107],x([0,1,3]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=v.globals.performance&&typeof v.globals.performance.now=="function";class M{constructor(I){this._highResolution=L&&I,this._startTime=this._now(),this._stopTime=-1}static create(I=!0){return new M(I)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=M}),define(Z[4],x([0,1,17,43,2,105,107]),function(K,e,v,L,M,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(o){o.None=()=>M.Disposable.None;function u(F){return(j,q=null,$)=>{let H=!1,_;return _=F(z=>{if(!H)return _?_.dispose():H=!0,j.call(q,z)},null,$),H&&_.dispose(),_}}o.once=u;function t(F,j){return p((q,$=null,H)=>F(_=>q.call($,j(_)),null,H))}o.map=t;function l(F,j){return p((q,$=null,H)=>F(_=>{j(_),q.call($,_)},null,H))}o.forEach=l;function s(F,j){return p((q,$=null,H)=>F(_=>j(_)&&q.call($,_),null,H))}o.filter=s;function r(F){return F}o.signal=r;function a(...F){return(j,q=null,$)=>(0,M.combinedDisposable)(...F.map(H=>H(_=>j.call(q,_),null,$)))}o.any=a;function g(F,j,q){let $=q;return t(F,H=>($=j($,H),$))}o.reduce=g;function p(F){let j;const q=new E({onFirstListenerAdd(){j=F(q.fire,q)},onLastListenerRemove(){j.dispose()}});return q.event}function k(F,j,q=100,$=!1,H){let _,z,C,A=0;const W=new E({leakWarningThreshold:H,onFirstListenerAdd(){_=F(B=>{A++,z=j(z,B),$&&!C&&(W.fire(z),z=void 0),clearTimeout(C),C=setTimeout(()=>{const Y=z;z=void 0,C=void 0,(!$||A>1)&&W.fire(Y),A=0},q)})},onLastListenerRemove(){_.dispose()}});return W.event}o.debounce=k;function R(F,j=(q,$)=>q===$){let q=!0,$;return s(F,H=>{const _=q||!j(H,$);return q=!1,$=H,_})}o.latch=R;function T(F,j){return[o.filter(F,j),o.filter(F,q=>!j(q))]}o.split=T;function O(F,j=!1,q=[]){let $=q.slice(),H=F(C=>{$?$.push(C):z.fire(C)});const _=()=>{$&&$.forEach(C=>z.fire(C)),$=null},z=new E({onFirstListenerAdd(){H||(H=F(C=>z.fire(C)))},onFirstListenerDidAdd(){$&&(j?setTimeout(_):_())},onLastListenerRemove(){H&&H.dispose(),H=null}});return z.event}o.buffer=O;class V{constructor(j){this.event=j}map(j){return new V(t(this.event,j))}forEach(j){return new V(l(this.event,j))}filter(j){return new V(s(this.event,j))}reduce(j,q){return new V(g(this.event,j,q))}latch(){return new V(R(this.event))}debounce(j,q=100,$=!1,H){return new V(k(this.event,j,q,$,H))}on(j,q,$){return this.event(j,q,$)}once(j,q,$){return u(this.event)(j,q,$)}}function ne(F){return new V(F)}o.chain=ne;function se(F,j,q=$=>$){const $=(...C)=>z.fire(q(...C)),H=()=>F.on(j,$),_=()=>F.removeListener(j,$),z=new E({onFirstListenerAdd:H,onLastListenerRemove:_});return z.event}o.fromNodeEventEmitter=se;function G(F,j,q=$=>$){const $=(...C)=>z.fire(q(...C)),H=()=>F.addEventListener(j,$),_=()=>F.removeEventListener(j,$),z=new E({onFirstListenerAdd:H,onLastListenerRemove:_});return z.event}o.fromDOMEventEmitter=G;function te(F){return new Promise(j=>u(F)(j))}o.toPromise=te})(n=e.Event||(e.Event={}));class f{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${f._idPool++}`}start(u){this._stopWatch=new I.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}f._idPool=0;let w=-1;function i(o){const u=w;return w=o,{dispose(){w=u}}}e.setGlobalLeakWarningThreshold=i;class P{constructor(u,t=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let t=w;if(typeof this.customThreshold=="number"&&(t=this.customThreshold),t<=0||u<t)return;this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(l)||0;if(this._stacks.set(l,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=t*.5;let r,a=0;for(const[g,p]of this._stacks)(!r||a<p)&&(r=g,a=p);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${a}):`),console.warn(r)}return()=>{const r=this._stacks.get(l)||0;this._stacks.set(l,r-1)}}}class E{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=w>0?new P(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new f(this._options._profName):void 0}get event(){return this._event||(this._event=(u,t,l)=>{this._listeners||(this._listeners=new D.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(t?[u,t]:u);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,t);const a=this._leakageMon?.check(this._listeners.size),g=(0,M.toDisposable)(()=>{a&&a(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return l instanceof M.DisposableStore?l.add(g):Array.isArray(l)&&l.push(g),g}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new D.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,u]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[t,l]=this._deliveryQueue.shift();try{typeof t=="function"?t.call(void 0,l):t[0].call(t[1],l)}catch(s){(0,v.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=E;class y extends E{async fireAsync(u,t,l){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new D.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,u]);for(;this._asyncDeliveryQueue.size>0&&!t.isCancellationRequested;){const[s,r]=this._asyncDeliveryQueue.shift(),a=[],g={...r,waitUntil:p=>{if(Object.isFrozen(a))throw new Error("waitUntil can NOT be called asynchronous");l&&(p=l(p,typeof s=="function"?s:s[0])),a.push(p)}};try{typeof s=="function"?s.call(void 0,g):s[0].call(s[1],g)}catch(p){(0,v.onUnexpectedError)(p);continue}Object.freeze(a),await Promise.allSettled(a).then(p=>{for(const k of p)k.status==="rejected"&&(0,v.onUnexpectedError)(k.reason)})}}}}e.AsyncEmitter=y;class d extends E{constructor(u){super(u);this._isPaused=0,this._eventQueue=new D.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=d;class m extends d{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=m;class b extends E{constructor(u){super(u);this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(t=>super.fire(t)),this._queuedEvents=[]})}}e.MicrotaskEmitter=b;class S{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new E({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const t={event:u,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);const l=()=>{this.hasListeners&&this.unhook(t);const s=this.events.indexOf(t);this.events.splice(s,1)};return(0,M.toDisposable)((0,L.once)(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(t=>this.emitter.fire(t))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=S;class c{constructor(){this.buffers=[]}wrapEvent(u){return(t,l,s)=>u(r=>{const a=this.buffers[this.buffers.length-1];a?a.push(()=>t.call(l,r)):t.call(l,r)},void 0,s)}bufferEvents(u){const t=[];this.buffers.push(t);const l=u();return this.buffers.pop(),t.forEach(s=>s()),l}}e.EventBufferer=c;class h{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=M.Disposable.None,this.emitter=new E({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=h}),define(Z[23],x([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(n,f){const w=setTimeout(n.bind(f),0);return{dispose(){clearTimeout(w)}}});var M;(function(n){function f(w){return w===n.None||w===n.Cancelled||w instanceof D?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}n.isCancellationToken=f,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(M=e.CancellationToken||(e.CancellationToken={}));class D{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class I{constructor(f){this._token=void 0,this._parentListener=void 0,this._parentListener=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new D),this._token}cancel(){this._token?this._token instanceof D&&this._token.cancel():this._token=M.Cancelled}dispose(f=!1){f&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof D&&this._token.dispose():this._token=M.None}}e.CancellationTokenSource=I}),define(Z[108],x([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(P){const E=this._icons.get(P.id);E?P.description?E.description=P.description:console.error(`Duplicate registration of codicon ${P.id}`):(this._icons.set(P.id,P),this._onDidRegister.fire(P))}get(P){return this._icons.get(P)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const M=new L;e.iconRegistry=M;function D(i,P){return new n(i,P)}e.registerCodicon=D;function I(i){return i?i.replace(/\$\((.*?)\)/g,(P,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=I;class n{constructor(P,E,y){this.id=P,this.definition=E,this.description=y,M.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n;function f(i,P){const E=["codicon","codicon-"+i];return P&&E.push("codicon-modifier-"+P),E}e.getClassNamesArray=f;var w;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const P=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function E(m){if(m instanceof n)return["codicon","codicon-"+m.id];const b=P.exec(m.id);if(!b)return E(n.error);let[,S,c]=b;const h=["codicon","codicon-"+S];return c&&h.push("codicon-modifier-"+c.substr(1)),h}i.asClassNameArray=E;function y(m){return E(m).join(" ")}i.asClassName=y;function d(m){return"."+E(m).join(".")}i.asCSSSelector=d})(w=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",{fontCharacter:"\\eb0f"}),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(n=e.Codicon||(e.Codicon={}))}),define(Z[67],x([0,1,17,2]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function M(h){const o=h;return o?[o.on,o.pause,o.resume,o.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=M;function D(h){const o=h;return o?M(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=D;function I(h,o){return new n(h,o)}e.newWriteableStream=I;class n{constructor(o,u){this.reducer=o,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(u=>u(o))}emitError(o){this.listeners.error.length===0?(0,v.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(u=>u(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,u){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(o,u){if(this.state.destroyed)return;let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const l=t.indexOf(u);l>=0&&t.splice(l,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(h,o){const u=[];let t;for(;(t=h.read())!==null;)u.push(t);return o(u)}e.consumeReadable=f;function w(h,o,u){const t=[];let l;for(;(l=h.read())!==null&&t.length<u;)t.push(l);return l===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof l!="undefined"){const s=l;return l=void 0,s}return h.read()}}}e.peekReadable=w;function i(h,o){return new Promise((u,t)=>{const l=[];P(h,{onData:s=>{o&&l.push(s)},onError:s=>{o?t(s):u(void 0)},onEnd:()=>{u(o?o(l):void 0)}})})}e.consumeStream=i;function P(h,o){h.on("error",u=>o.onError(u)),h.on("end",()=>o.onEnd()),h.on("data",u=>o.onData(u))}e.listenStream=P;function E(h,o){return new Promise((u,t)=>{const l=new L.DisposableStore,s=[],r=p=>{if(s.push(p),s.length>o)return l.dispose(),h.pause(),u({stream:h,buffer:s,ended:!1})},a=p=>t(p),g=()=>u({stream:h,buffer:s,ended:!0});l.add((0,L.toDisposable)(()=>h.removeListener("error",a))),h.on("error",a),l.add((0,L.toDisposable)(()=>h.removeListener("end",g))),h.on("end",g),l.add((0,L.toDisposable)(()=>h.removeListener("data",r))),h.on("data",r)})}e.peekStream=E;function y(h,o){const u=I(o);return u.end(h),u}e.toStream=y;function d(){const h=I(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=d;function m(h){let o=!1;return{read:()=>o?null:(o=!0,h)}}e.toReadable=m;function b(h,o,u){const t=I(u);return P(h,{onData:l=>t.write(o.data(l)),onError:l=>t.error(o.error?o.error(l):l),onEnd:()=>t.end()}),t}e.transform=b;function S(h,o,u){let t=!1;return{read:()=>{const l=o.read();return t?l:(t=!0,l!==null?u([h,l]):h)}}}e.prefixedReadable=S;function c(h,o,u){let t=!1;const l=I(u);return P(o,{onData:s=>t?l.write(s):(t=!0,l.write(u([h,s]))),onError:s=>l.error(s),onEnd:()=>{t||(t=!0,l.write(h)),l.end()}}),l}e.prefixedStream=c}),define(Z[18],x([0,1,67]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let M,D;class I{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return L?new I(Buffer.allocUnsafe(r)):new I(new Uint8Array(r))}static wrap(r){return L&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new I(r)}static fromString(r,a){return!(a?.dontUseNodeBuffer||!1)&&L?new I(Buffer.from(r)):(M||(M=new TextEncoder),new I(M.encode(r)))}static concat(r,a){if(typeof a=="undefined"){a=0;for(let k=0,R=r.length;k<R;k++)a+=r[k].byteLength}const g=I.alloc(a);let p=0;for(let k=0,R=r.length;k<R;k++){const T=r[k];g.set(T,p),p+=T.byteLength}return g}toString(){return L?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(r,a){return new I(this.buffer.subarray(r,a))}set(r,a){r instanceof I?this.buffer.set(r.buffer,a):this.buffer.set(r,a)}readUInt32BE(r){return w(this.buffer,r)}writeUInt32BE(r,a){i(this.buffer,r,a)}readUInt32LE(r){return P(this.buffer,r)}writeUInt32LE(r,a){E(this.buffer,r,a)}readUInt8(r){return y(this.buffer,r)}writeUInt8(r,a){d(this.buffer,r,a)}}e.VSBuffer=I;function n(s,r){return s[r+0]<<0>>>0|s[r+1]<<8>>>0}e.readUInt16LE=n;function f(s,r,a){s[a+0]=r&255,r=r>>>8,s[a+1]=r&255}e.writeUInt16LE=f;function w(s,r){return s[r]*2**24+s[r+1]*2**16+s[r+2]*2**8+s[r+3]}e.readUInt32BE=w;function i(s,r,a){s[a+3]=r,r=r>>>8,s[a+2]=r,r=r>>>8,s[a+1]=r,r=r>>>8,s[a]=r}e.writeUInt32BE=i;function P(s,r){return s[r+0]<<0>>>0|s[r+1]<<8>>>0|s[r+2]<<16>>>0|s[r+3]<<24>>>0}e.readUInt32LE=P;function E(s,r,a){s[a+0]=r&255,r=r>>>8,s[a+1]=r&255,r=r>>>8,s[a+2]=r&255,r=r>>>8,s[a+3]=r&255}e.writeUInt32LE=E;function y(s,r){return s[r]}e.readUInt8=y;function d(s,r,a){s[a]=r}e.writeUInt8=d;function m(s){return v.consumeReadable(s,r=>I.concat(r))}e.readableToBuffer=m;function b(s){return v.toReadable(s)}e.bufferToReadable=b;function S(s){return v.consumeStream(s,r=>I.concat(r))}e.streamToBuffer=S;async function c(s){return s.ended?I.concat(s.buffer):I.concat([...s.buffer,await S(s.stream)])}e.bufferedStreamToBuffer=c;function h(s){return v.toStream(s,r=>I.concat(r))}e.bufferToStream=h;function o(s){return v.transform(s,{data:r=>typeof r=="string"?I.fromString(r):I.wrap(r)},r=>I.concat(r))}e.streamToBufferReadableStream=o;function u(s){return v.newWriteableStream(r=>I.concat(r),s)}e.newWriteableBufferStream=u;function t(s,r){return v.prefixedReadable(s,r,a=>I.concat(a))}e.prefixedBufferReadable=t;function l(s,r){return v.prefixedStream(s,r,a=>I.concat(a))}e.prefixedBufferStream=l}),define(Z[25],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function v(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=v;const L=/{(\d+)}/g;function M(X,...oe){return oe.length===0?X:X.replace(L,function(ce,we){const be=parseInt(we,10);return isNaN(be)||be<0||be>=oe.length?ce:oe[be]})}e.format=M;const D=/{([^}]+)}/g;function I(X,oe){return X.replace(D,(ce,we)=>oe[we]??ce)}e.format2=I;function n(X){return X.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=n;function f(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=f;function w(X,oe){let ce=0;const we=oe.charCodeAt(0);for(let be=X.length-1;be>=0;be--)X.charCodeAt(be)===we&&ce++;return ce}e.count=w;function i(X,oe,ce="\u2026"){return X.length<=oe?X:`${X.substr(0,oe)}${ce}`}e.truncate=i;function P(X,oe=" "){const ce=E(X,oe);return y(ce,oe)}e.trim=P;function E(X,oe){if(!X||!oe)return X;const ce=oe.length;if(ce===0||X.length===0)return X;let we=0;for(;X.indexOf(oe,we)===we;)we=we+ce;return X.substring(we)}e.ltrim=E;function y(X,oe){if(!X||!oe)return X;const ce=oe.length,we=X.length;if(ce===0||we===0)return X;let be=we,Le=-1;for(;Le=X.lastIndexOf(oe,be-1),!(Le===-1||Le+ce!==be);){if(Le===0)return"";be=Le}return X.substring(0,be)}e.rtrim=y;function d(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function m(X){return X.replace(/\*/g,"")}e.stripWildcards=m;function b(X,oe,ce={}){if(!X)throw new Error("Cannot create regex from empty string");oe||(X=f(X)),ce.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let we="";return ce.global&&(we+="g"),ce.matchCase||(we+="i"),ce.multiline&&(we+="m"),ce.unicode&&(we+="u"),new RegExp(X,we)}e.createRegExp=b;function S(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function c(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function h(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.regExpFlags=h;function o(X){return X.split(/\r\n|\r|\n/)}e.splitLines=o;function u(X){for(let oe=0,ce=X.length;oe<ce;oe++){const we=X.charCodeAt(oe);if(we!==32&&we!==9)return oe}return-1}e.firstNonWhitespaceIndex=u;function t(X,oe=0,ce=X.length){for(let we=oe;we<ce;we++){const be=X.charCodeAt(we);if(be!==32&&be!==9)return X.substring(oe,we)}return X.substring(oe,ce)}e.getLeadingWhitespace=t;function l(X,oe=X.length-1){for(let ce=oe;ce>=0;ce--){const we=X.charCodeAt(ce);if(we!==32&&we!==9)return ce}return-1}e.lastNonWhitespaceIndex=l;function s(X,oe){return X<oe?-1:X>oe?1:0}e.compare=s;function r(X,oe,ce=0,we=X.length,be=0,Le=oe.length){for(;ce<we&&be<Le;ce++,be++){let Ne=X.charCodeAt(ce),Be=oe.charCodeAt(be);if(Ne<Be)return-1;if(Ne>Be)return 1}const Ue=we-ce,Fe=Le-be;return Ue<Fe?-1:Ue>Fe?1:0}e.compareSubstring=r;function a(X,oe){return g(X,oe,0,X.length,0,oe.length)}e.compareIgnoreCase=a;function g(X,oe,ce=0,we=X.length,be=0,Le=oe.length){for(;ce<we&&be<Le;ce++,be++){let Ne=X.charCodeAt(ce),Be=oe.charCodeAt(be);if(Ne===Be)continue;if(Ne>=128||Be>=128)return r(X.toLowerCase(),oe.toLowerCase(),ce,we,be,Le);p(Ne)&&(Ne-=32),p(Be)&&(Be-=32);const ze=Ne-Be;if(ze!==0)return ze}const Ue=we-ce,Fe=Le-be;return Ue<Fe?-1:Ue>Fe?1:0}e.compareSubstringIgnoreCase=g;function p(X){return X>=97&&X<=122}e.isLowerAsciiLetter=p;function k(X){return X>=65&&X<=90}e.isUpperAsciiLetter=k;function R(X,oe){return X.length===oe.length&&g(X,oe)===0}e.equalsIgnoreCase=R;function T(X,oe){const ce=oe.length;return oe.length>X.length?!1:g(X,oe,0,ce)===0}e.startsWithIgnoreCase=T;function O(X,oe){let ce,we=Math.min(X.length,oe.length);for(ce=0;ce<we;ce++)if(X.charCodeAt(ce)!==oe.charCodeAt(ce))return ce;return we}e.commonPrefixLength=O;function V(X,oe){let ce,we=Math.min(X.length,oe.length);const be=X.length-1,Le=oe.length-1;for(ce=0;ce<we;ce++)if(X.charCodeAt(be-ce)!==oe.charCodeAt(Le-ce))return ce;return we}e.commonSuffixLength=V;function ne(X){return 55296<=X&&X<=56319}e.isHighSurrogate=ne;function se(X){return 56320<=X&&X<=57343}e.isLowSurrogate=se;function G(X,oe){return(X-55296<<10)+(oe-56320)+65536}e.computeCodePoint=G;function te(X,oe,ce){const we=X.charCodeAt(ce);if(ne(we)&&ce+1<oe){const be=X.charCodeAt(ce+1);if(se(be))return G(we,be)}return we}e.getNextCodePoint=te;function F(X,oe){const ce=X.charCodeAt(oe-1);if(se(ce)&&oe>1){const we=X.charCodeAt(oe-2);if(ne(we))return G(we,ce)}return ce}function j(X,oe){const ce=Oe.getInstance(),we=oe,be=X.length,Le=te(X,be,oe);oe+=Le>=65536?2:1;let Ue=ce.getGraphemeBreakType(Le);for(;oe<be;){const Fe=te(X,be,oe),Ne=ce.getGraphemeBreakType(Fe);if(Ae(Ue,Ne))break;oe+=Fe>=65536?2:1,Ue=Ne}return oe-we}e.nextCharLength=j;function q(X,oe){const ce=Oe.getInstance(),we=oe,be=F(X,oe);oe-=be>=65536?2:1;let Le=ce.getGraphemeBreakType(be);for(;oe>0;){const Ue=F(X,oe),Fe=ce.getGraphemeBreakType(Ue);if(Ae(Fe,Le))break;oe-=Ue>=65536?2:1,Le=Fe}return we-oe}e.prevCharLength=q;function $(X,oe){const ce=Oe.getInstance(),we=X.length,be=oe,Le=te(X,we,oe),Ue=ce.getGraphemeBreakType(Le);oe+=Le>=65536?2:1;let Fe=Ue;for(;oe<we;){const Be=te(X,we,oe),ze=ce.getGraphemeBreakType(Be);if(Ae(Fe,ze))break;oe+=Be>=65536?2:1,Fe=ze}const Ne=oe;for(oe=be,Fe=Ue;oe>0;){const Be=F(X,oe),ze=ce.getGraphemeBreakType(Be);if(Ae(ze,Fe))break;oe-=Be>=65536?2:1,Fe=ze}return[oe,Ne]}function H(X,oe){return oe>0&&se(X.charCodeAt(oe))?$(X,oe-1):$(X,oe)}e.getCharContainingOffset=H;const _=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function z(X){return _.test(X)}e.containsRTL=z;const C=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function A(X){return C.test(X)}e.containsEmoji=A;const W=/^[\t\n\r\x20-\x7E]*$/;function B(X){return W.test(X)}e.isBasicASCII=B,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Y(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=Y;function U(X){for(let oe=0,ce=X.length;oe<ce;oe++)if(N(X.charCodeAt(oe)))return!0;return!1}e.containsFullWidthCharacter=U;function N(X){return X=+X,X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=N;function Q(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129003||X>=129280&&X<=129535||X>=129648&&X<=129750}e.isEmojiImprecise=Q;function J(X,oe){if(X.length<oe)return X;const ce=/\b/g;let we=0;for(;ce.test(X)&&!(X.length-ce.lastIndex<oe);)we=ce.lastIndex,ce.lastIndex+=1;return X.substring(we).replace(/^\s/,"")}e.lcut=J;const re=/\x1B\x5B[12]?K/g,le=/\x1b\[\d+m/g,ee=/\x1b\[0?m/g;function ae(X){return X&&(X=X.replace(re,""),X=X.replace(le,""),X=X.replace(ee,"")),X}e.removeAnsiEscapeCodes=ae,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ue(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ue;function de(X){return ue(X)?X.substr(1):X}e.stripUTF8BOM=de;function ve(X,oe){if(!X||!oe||X.length<oe.length)return!1;const ce=oe.length,we=X.toLowerCase();let be=0,Le=-1;for(;be<ce;){const Ue=we.indexOf(oe[be],Le+1);if(Ue<0)return!1;Le=Ue,be++}return!0}e.fuzzyContains=ve;function Ie(X,oe=!1){return X?(oe&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=Ie;function me(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=me;function ge(X,oe=1){if(oe===0)return"";let ce=-1;do ce=X.indexOf(`
`,ce+1),oe--;while(oe>0&&ce>=0);return ce===-1?X:(X[ce-1]==="\r"&&ce--,X.substr(0,ce))}e.getNLines=ge;function Ee(X){const oe=90-65+1;return X=X%(2*oe),X<oe?String.fromCharCode(97+X):String.fromCharCode(65+X-oe)}e.singleLetterHash=Ee;function ke(X){return Oe.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=ke;function Ae(X,oe){return X===0?oe!==5&&oe!==7:X===2&&oe===3?!1:X===4||X===2||X===3||oe===4||oe===2||oe===3?!0:!(X===8&&(oe===8||oe===9||oe===11||oe===12)||(X===11||X===9)&&(oe===9||oe===10)||(X===12||X===10)&&oe===10||oe===5||oe===13||oe===7||X===1||X===13&&oe===14||X===6&&oe===6)}e.breakBetweenGraphemeBreakType=Ae;var We;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(We=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Oe{constructor(){this._data=Ye()}static getInstance(){return Oe._INSTANCE||(Oe._INSTANCE=new Oe),Oe._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const ce=this._data,we=ce.length/3;let be=1;for(;be<=we;)if(oe<ce[3*be])be=2*be;else if(oe>ce[3*be+1])be=2*be+1;else return ce[3*be+2];return 0}}Oe._INSTANCE=null;function Ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Xe(X,oe){if(X===0)return 0;const ce=ut(X,oe);if(ce!==void 0)return ce;const we=F(oe,X);return X-=Ge(we),X}e.getLeftDeleteOffset=Xe;function ut(X,oe){let ce=F(oe,X);for(X-=Ge(ce);xe(ce)||ce===65039||ce===8419;){if(X===0)return;ce=F(oe,X),X-=Ge(ce)}if(!!Q(ce)){if(X>=0){const we=F(oe,X);we===8205&&(X-=Ge(we))}return X}}function Ge(X){return X>=65536?2:1}function xe(X){return 127995<=X&&X<=127999}var et;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(et||(et={}))}),define(Z[80],x([0,1,25]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(S){return M(S,0)}e.hash=L;function M(S,c){switch(typeof S){case"object":return S===null?D(349,c):Array.isArray(S)?f(S,c):w(S,c);case"string":return n(S,c);case"boolean":return I(S,c);case"number":return D(S,c);case"undefined":return D(937,c);default:return D(617,c)}}e.doHash=M;function D(S,c){return(c<<5)-c+S|0}e.numberHash=D;function I(S,c){return D(S?433:863,c)}function n(S,c){c=D(149417,c);for(let h=0,o=S.length;h<o;h++)c=D(S.charCodeAt(h),c);return c}e.stringHash=n;function f(S,c){return c=D(104579,c),S.reduce((h,o)=>M(o,h),c)}function w(S,c){return c=D(181387,c),Object.keys(S).sort().reduce((h,o)=>(h=n(o,h),M(S[o],h)),c)}class i{constructor(){this._value=0}get value(){return this._value}hash(c){return this._value=M(c,this._value),this._value}}e.Hasher=i;var P;(function(S){S[S.BLOCK_SIZE=64]="BLOCK_SIZE",S[S.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function E(S,c,h=32){const o=h-c,u=~((1<<o)-1);return(S<<c|(u&S)>>>o)>>>0}function y(S,c=0,h=S.byteLength,o=0){for(let u=0;u<h;u++)S[c+u]=o}function d(S,c,h="0"){for(;S.length<c;)S=h+S;return S}function m(S,c=32){return S instanceof ArrayBuffer?Array.from(new Uint8Array(S)).map(h=>h.toString(16).padStart(2,"0")).join(""):d((S>>>0).toString(16),c/4)}e.toHexString=m;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(c){const h=c.length;if(h===0)return;const o=this._buff;let u=this._buffLen,t=this._leftoverHighSurrogate,l,s;for(t!==0?(l=t,s=-1,t=0):(l=c.charCodeAt(0),s=0);;){let r=l;if(v.isHighSurrogate(l))if(s+1<h){const a=c.charCodeAt(s+1);v.isLowSurrogate(a)?(s++,r=v.computeCodePoint(l,a)):r=65533}else{t=l;break}else v.isLowSurrogate(l)&&(r=65533);if(u=this._push(o,u,r),s++,s<h)l=c.charCodeAt(s);else break}this._buffLen=u,this._leftoverHighSurrogate=t}_push(c,h,o){return o<128?c[h++]=o:o<2048?(c[h++]=192|(o&1984)>>>6,c[h++]=128|(o&63)>>>0):o<65536?(c[h++]=224|(o&61440)>>>12,c[h++]=128|(o&4032)>>>6,c[h++]=128|(o&63)>>>0):(c[h++]=240|(o&1835008)>>>18,c[h++]=128|(o&258048)>>>12,c[h++]=128|(o&4032)>>>6,c[h++]=128|(o&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const c=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(c/4294967296),!1),this._buffDV.setUint32(60,c%4294967296,!1),this._step()}_step(){const c=b._bigBlock32,h=this._buffDV;for(let p=0;p<64;p+=4)c.setUint32(p,h.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)c.setUint32(p,E(c.getUint32(p-12,!1)^c.getUint32(p-32,!1)^c.getUint32(p-56,!1)^c.getUint32(p-64,!1),1),!1);let o=this._h0,u=this._h1,t=this._h2,l=this._h3,s=this._h4,r,a,g;for(let p=0;p<80;p++)p<20?(r=u&t|~u&l,a=1518500249):p<40?(r=u^t^l,a=1859775393):p<60?(r=u&t|u&l|t&l,a=2400959708):(r=u^t^l,a=3395469782),g=E(o,5)+r+s+a+c.getUint32(p*4,!1)&4294967295,s=l,l=t,t=E(u,30),u=o,o=g;this._h0=this._h0+o&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+l&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Z[13],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(k){return Array.isArray(k)}e.isArray=v;function L(k){return typeof k=="string"}e.isString=L;function M(k){return Array.isArray(k)&&k.every(R=>L(R))}e.isStringArray=M;function D(k){return typeof k=="object"&&k!==null&&!Array.isArray(k)&&!(k instanceof RegExp)&&!(k instanceof Date)}e.isObject=D;function I(k){return typeof k=="number"&&!isNaN(k)}e.isNumber=I;function n(k){return!!k&&typeof k[Symbol.iterator]=="function"}e.isIterable=n;function f(k){return k===!0||k===!1}e.isBoolean=f;function w(k){return typeof k=="undefined"}e.isUndefined=w;function i(k){return!P(k)}e.isDefined=i;function P(k){return w(k)||k===null}e.isUndefinedOrNull=P;function E(k,R){if(!k)throw new Error(R?`Unexpected type, expected '${R}'`:"Unexpected type")}e.assertType=E;function y(k){if(P(k))throw new Error("Assertion Failed: argument is undefined or null");return k}e.assertIsDefined=y;function d(...k){const R=[];for(let T=0;T<k.length;T++){const O=k[T];if(P(O))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);R.push(O)}return R}e.assertAllDefined=d;const m=Object.prototype.hasOwnProperty;function b(k){if(!D(k))return!1;for(let R in k)if(m.call(k,R))return!1;return!0}e.isEmptyObject=b;function S(k){return typeof k=="function"}e.isFunction=S;function c(...k){return k.length>0&&k.every(S)}e.areFunctions=c;function h(k,R){const T=Math.min(k.length,R.length);for(let O=0;O<T;O++)o(k[O],R[O])}e.validateConstraints=h;function o(k,R){if(L(R)){if(typeof k!==R)throw new Error(`argument does not match constraint: typeof ${R}`)}else if(S(R)){try{if(k instanceof R)return}catch{}if(!P(k)&&k.constructor===R||R.length===1&&R.call(void 0,k)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function u(k){let R=[],T=Object.getPrototypeOf(k);for(;Object.prototype!==T;)R=R.concat(Object.getOwnPropertyNames(T)),T=Object.getPrototypeOf(T);return R}e.getAllPropertyNames=u;function t(k){const R=[];for(const T of u(k))typeof k[T]=="function"&&R.push(T);return R}e.getAllMethodNames=t;function l(k,R){const T=V=>function(){const ne=Array.prototype.slice.call(arguments,0);return R(V,ne)};let O={};for(const V of k)O[V]=T(V);return O}e.createProxyObject=l;function s(k){return k===null?void 0:k}e.withNullAsUndefined=s;function r(k){return typeof k=="undefined"?null:k}e.withUndefinedAsNull=r;function a(k){return class{constructor(){return new Proxy({},{get(R,T){if(R[T])return R[T];throw new Error(`Not Implemented: ${k}->${String(T)}`)}})}}}e.NotImplementedProxy=a;function g(k,R="Unreachable"){throw new Error(R)}e.assertNever=g;function p(k){return!!k&&typeof k.then=="function"&&typeof k.catch=="function"}e.isPromise=p}),define(Z[31],x([0,1,7,3,25,13]),function(K,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(s){return s===47||s===92}e.isPathSeparator=I;function n(s){return s.replace(/[\\/]/g,v.posix.sep)}e.toSlashes=n;function f(s){return s.indexOf("/")===-1&&(s=n(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=f;function w(s,r=v.posix.sep){if(!s)return"";const a=s.length,g=s.charCodeAt(0);if(I(g)){if(I(s.charCodeAt(1))&&!I(s.charCodeAt(2))){let k=3;const R=k;for(;k<a&&!I(s.charCodeAt(k));k++);if(R!==k&&!I(s.charCodeAt(k+1))){for(k+=1;k<a;k++)if(I(s.charCodeAt(k)))return s.slice(0,k+1).replace(/[\\/]/g,r)}}return r}else if(S(g)&&s.charCodeAt(1)===58)return I(s.charCodeAt(2))?s.slice(0,2)+r:s.slice(0,2);let p=s.indexOf("://");if(p!==-1){for(p+=3;p<a;p++)if(I(s.charCodeAt(p)))return s.slice(0,p+1)}return""}e.getRoot=w;function i(s){if(!L.isWindows||!s||s.length<5)return!1;let r=s.charCodeAt(0);if(r!==92||(r=s.charCodeAt(1),r!==92))return!1;let a=2;const g=a;for(;a<s.length&&(r=s.charCodeAt(a),r!==92);a++);return!(g===a||(r=s.charCodeAt(a+1),isNaN(r)||r===92))}e.isUNC=i;const P=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(s,r=L.isWindows){const a=r?P:E;return!(!s||s.length===0||/^\s+$/.test(s)||(a.lastIndex=0,a.test(s))||r&&y.test(s)||s==="."||s===".."||r&&s[s.length-1]==="."||r&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=d;function m(s,r,a){const g=s===r;return!a||g?g:!s||!r?!1:(0,M.equalsIgnoreCase)(s,r)}e.isEqual=m;function b(s,r,a,g=v.sep){if(s===r)return!0;if(!s||!r||r.length>s.length)return!1;if(a){if(!(0,M.startsWithIgnoreCase)(s,r))return!1;if(r.length===s.length)return!0;let k=r.length;return r.charAt(r.length-1)===g&&k--,s.charAt(k)===g}return r.charAt(r.length-1)!==g&&(r+=g),s.indexOf(r)===0}e.isEqualOrParent=b;function S(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=S;function c(s,r){return L.isWindows&&s.endsWith(":")&&(s+=v.sep),(0,v.isAbsolute)(s)||(s=(0,v.join)(r,s)),s=(0,v.normalize)(s),L.isWindows?(s=(0,M.rtrim)(s,v.sep),s.endsWith(":")&&(s+=v.sep)):(s=(0,M.rtrim)(s,v.sep),s||(s=v.sep)),s}e.sanitizeFilePath=c;function h(s){const r=(0,v.normalize)(s);return L.isWindows?s.length>3?!1:o(r)&&(s.length===2||r.charCodeAt(2)===92):r===v.posix.sep}e.isRootOrDriveLetter=h;function o(s){return L.isWindows?S(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=o;function u(s){return o(s)?s[0]:void 0}e.getDriveLetter=u;function t(s,r,a){return r.length>s.length?-1:s===r?0:(a&&(s=s.toLowerCase(),r=r.toLowerCase()),s.indexOf(r))}e.indexOfPath=t;function l(s){const r=s.split(":");let a,g,p;if(r.forEach(k=>{const R=Number(k);(0,D.isNumber)(R)?g===void 0?g=R:p===void 0&&(p=R):a=a?[a,k].join(":"):k}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:g!==void 0?g:void 0,column:p!==void 0?p:g!==void 0?1:void 0}}e.parseLineAndColumnAware=l}),define(Z[44],x([0,1,13]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const b=Array.isArray(m)?[]:{};return Object.keys(m).forEach(S=>{m[S]&&typeof m[S]=="object"?b[S]=L(m[S]):b[S]=m[S]}),b}e.deepClone=L;function M(m){if(!m||typeof m!="object")return m;const b=[m];for(;b.length>0;){const S=b.shift();Object.freeze(S);for(const c in S)if(D.call(S,c)){const h=S[c];typeof h=="object"&&!Object.isFrozen(h)&&b.push(h)}}return m}e.deepFreeze=M;const D=Object.prototype.hasOwnProperty;function I(m,b){return n(m,b,new Set)}e.cloneAndChange=I;function n(m,b,S){if((0,v.isUndefinedOrNull)(m))return m;const c=b(m);if(typeof c!="undefined")return c;if((0,v.isArray)(m)){const h=[];for(const o of m)h.push(n(o,b,S));return h}if((0,v.isObject)(m)){if(S.has(m))throw new Error("Cannot clone recursive data-structure");S.add(m);const h={};for(let o in m)D.call(m,o)&&(h[o]=n(m[o],b,S));return S.delete(m),h}return m}function f(m,b,S=!0){return(0,v.isObject)(m)?((0,v.isObject)(b)&&Object.keys(b).forEach(c=>{c in m?S&&((0,v.isObject)(m[c])&&(0,v.isObject)(b[c])?f(m[c],b[c],S):m[c]=b[c]):m[c]=b[c]}),m):b}e.mixin=f;function w(m,b){if(m===b)return!0;if(m==null||b===null||b===void 0||typeof m!=typeof b||typeof m!="object"||Array.isArray(m)!==Array.isArray(b))return!1;let S,c;if(Array.isArray(m)){if(m.length!==b.length)return!1;for(S=0;S<m.length;S++)if(!w(m[S],b[S]))return!1}else{const h=[];for(c in m)h.push(c);h.sort();const o=[];for(c in b)o.push(c);if(o.sort(),!w(h,o))return!1;for(S=0;S<h.length;S++)if(!w(m[h[S]],b[h[S]]))return!1}return!0}e.equals=w;function i(m){const b=new Set;return JSON.stringify(m,(S,c)=>{if((0,v.isObject)(c)||Array.isArray(c)){if(b.has(c))return"[Circular]";b.add(c)}return c})}e.safeStringify=i;function P(m,b,S){const c=b(m);return typeof c=="undefined"?S:c}e.getOrDefault=P;function E(m,b){const S=Object.create(null);return!m||!b||Object.keys(b).forEach(h=>{const o=m[h],u=b[h];w(o,u)||(S[h]=u)}),S}e.distinct=E;function y(m,b){const S=b.toLowerCase(),c=Object.keys(m).find(h=>h.toLowerCase()===S);return c?m[c]:m[b]}e.getCaseInsensitive=y;function d(m,b){const S=Object.create(null);for(const c of Object.keys(m))b(c,m[c])&&(S[c]=m[c]);return S}e.filter=d}),define(Z[8],x([0,1,7,3]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const M=/^\w[\w\d+.-]*$/,D=/^\//,I=/^\/\//;function n(s,r){if(!s.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!M.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!D.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(s,r){return!s&&!r?"file":s}function w(s,r){switch(s){case"https":case"http":case"file":r?r[0]!==P&&(r=P+r):r=P;break}return r}const i="",P="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(r,a,g,p,k,R=!1){typeof r=="object"?(this.scheme=r.scheme||i,this.authority=r.authority||i,this.path=r.path||i,this.query=r.query||i,this.fragment=r.fragment||i):(this.scheme=f(r,R),this.authority=a||i,this.path=w(this.scheme,g||i),this.query=p||i,this.fragment=k||i,n(this,R))}static isUri(r){return r instanceof y?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return h(this,!1)}with(r){if(!r)return this;let{scheme:a,authority:g,path:p,query:k,fragment:R}=r;return a===void 0?a=this.scheme:a===null&&(a=i),g===void 0?g=this.authority:g===null&&(g=i),p===void 0?p=this.path:p===null&&(p=i),k===void 0?k=this.query:k===null&&(k=i),R===void 0?R=this.fragment:R===null&&(R=i),a===this.scheme&&g===this.authority&&p===this.path&&k===this.query&&R===this.fragment?this:new m(a,g,p,k,R)}static parse(r,a=!1){const g=E.exec(r);return g?new m(g[2]||i,l(g[4]||i),l(g[5]||i),l(g[7]||i),l(g[9]||i),a):new m(i,i,i,i,i)}static file(r){let a=i;if(L.isWindows&&(r=r.replace(/\\/g,P)),r[0]===P&&r[1]===P){const g=r.indexOf(P,2);g===-1?(a=r.substring(2),r=P):(a=r.substring(2,g),r=r.substring(g)||P)}return new m("file",a,r,i,i)}static from(r){const a=new m(r.scheme,r.authority,r.path,r.query,r.fragment);return n(a,!0),a}static joinPath(r,...a){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return L.isWindows&&r.scheme==="file"?g=y.file(v.win32.join(h(r,!0),...a)).path:g=v.posix.join(r.path,...a),r.with({path:g})}toString(r=!1){return o(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof y)return r;{const a=new m(r);return a._formatted=r.external,a._fsPath=r._sep===d?r.fsPath:null,a}}else return r}}e.URI=y;const d=L.isWindows?1:void 0;class m extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(r=!1){return r?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=d),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function S(s,r){let a,g=-1;for(let p=0;p<s.length;p++){const k=s.charCodeAt(p);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||r&&k===47)g!==-1&&(a+=encodeURIComponent(s.substring(g,p)),g=-1),a!==void 0&&(a+=s.charAt(p));else{a===void 0&&(a=s.substr(0,p));const R=b[k];R!==void 0?(g!==-1&&(a+=encodeURIComponent(s.substring(g,p)),g=-1),a+=R):g===-1&&(g=p)}}return g!==-1&&(a+=encodeURIComponent(s.substring(g))),a!==void 0?a:s}function c(s){let r;for(let a=0;a<s.length;a++){const g=s.charCodeAt(a);g===35||g===63?(r===void 0&&(r=s.substr(0,a)),r+=b[g]):r!==void 0&&(r+=s[a])}return r!==void 0?r:s}function h(s,r){let a;return s.authority&&s.path.length>1&&s.scheme==="file"?a=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?r?a=s.path.substr(1):a=s.path[1].toLowerCase()+s.path.substr(2):a=s.path,L.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=h;function o(s,r){const a=r?c:S;let g="",{scheme:p,authority:k,path:R,query:T,fragment:O}=s;if(p&&(g+=p,g+=":"),(k||p==="file")&&(g+=P,g+=P),k){let V=k.indexOf("@");if(V!==-1){const ne=k.substr(0,V);k=k.substr(V+1),V=ne.indexOf(":"),V===-1?g+=a(ne,!1):(g+=a(ne.substr(0,V),!1),g+=":",g+=a(ne.substr(V+1),!1)),g+="@"}k=k.toLowerCase(),V=k.indexOf(":"),V===-1?g+=a(k,!1):(g+=a(k.substr(0,V),!1),g+=k.substr(V))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const V=R.charCodeAt(1);V>=65&&V<=90&&(R=`/${String.fromCharCode(V+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const V=R.charCodeAt(0);V>=65&&V<=90&&(R=`${String.fromCharCode(V+32)}:${R.substr(2)}`)}g+=a(R,!0)}return T&&(g+="?",g+=a(T,!1)),O&&(g+="#",g+=r?O:S(O,!1)),g}function u(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+u(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(s){return s.match(t)?s.replace(t,r=>u(r)):s}}),define(Z[109],x([0,1,8]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(w){const i=w;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=L;function M(w){const i=[];let P;try{const E=JSON.parse(w.arguments),y=E[E.length-1];y&&y.__$stack&&(E.pop(),P=y.__$stack),i.push(...E)}catch(E){i.push("Unable to log remote console arguments",w.arguments)}return{args:i,stack:P}}e.parse=M;function D(w){if(typeof w!="string")return D(M(w).stack);const i=w;if(i){const P=I(i),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(E&&E.length===4)return{uri:v.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=D;function I(w){if(!w)return w;const i=w.indexOf(`
`);return i===-1?w:w.substring(0,i)}function n(w,i){const{args:P,stack:E}=M(w),y=typeof P[0]=="string"&&P.length===1;let d=I(E);d&&(d=`(${d.trim()})`);let m=[];if(typeof P[0]=="string"?d&&y?m=[`%c[${i}] %c${P[0]} %c${d}`,f("blue"),f(""),f("grey")]:m=[`%c[${i}] %c${P[0]}`,f("blue"),f(""),...P.slice(1)]:m=[`%c[${i}]%`,f("blue"),...P],d&&!y&&m.push(d),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,m)}e.log=n;function f(w){return`color: ${w}`}});var bt=this&&this.__classPrivateFieldSet||function(K,e,v,L,M){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!M)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!M:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?M.call(K,v):M?M.value=v:e.set(K,v),v},je=this&&this.__classPrivateFieldGet||function(K,e,v,L){if(v==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!L:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?L:v==="a"?L.call(K):L?L.value:e.get(K)};define(Z[37],x([0,1,30,25,8]),function(K,e,v,L,M){"use strict";var D,I,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function f(s,r,a){let g=s.get(r);return g===void 0&&(g=a,s.set(r,g)),g}e.getOrSet=f;function w(s){const r=[];return s.forEach((a,g)=>{r.push(`${g} => ${a}`)}),`Map(${s.size}) {${r.join(", ")}}`}e.mapToString=w;function i(s){const r=[];return s.forEach(a=>{r.push(a)}),`Set(${s.size}) {${r.join(", ")}}`}e.setToString=i;class P{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const a=r.charCodeAt(0),g=this._value.charCodeAt(this._pos);return a-g}value(){return this._value[this._pos]}}e.StringIterator=P;class E{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class y{constructor(r=!0,a=!0){this._splitOnBackslash=r,this._caseSensitive=a}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const a=this._value.charCodeAt(this._to);if(a===47||this._splitOnBackslash&&a===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=y;var d;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(d||(d={}));class m{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new y(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,L.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=m;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var S;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(S||(S={}));class c{constructor(r){this._iter=r}static forUris(r=()=>!1){return new c(new m(r))}static forPaths(){return new c(new y)}static forStrings(){return new c(new P)}static forConfigKeys(){return new c(new E)}clear(){this._root=void 0}fill(r,a){if(a){const g=a.slice(0);(0,v.shuffle)(g);for(let p of g)this.set(p,r)}else{const g=r.slice(0);(0,v.shuffle)(g);for(let p of g)this.set(p[0],p[1])}}set(r,a){const g=this._iter.reset(r);let p;this._root||(this._root=new b,this._root.segment=g.value());const k=[];for(p=this._root;;){const T=g.cmp(p.segment);if(T>0)p.left||(p.left=new b,p.left.segment=g.value()),k.push([-1,p]),p=p.left;else if(T<0)p.right||(p.right=new b,p.right.segment=g.value()),k.push([1,p]),p=p.right;else if(g.hasNext())g.next(),p.mid||(p.mid=new b,p.mid.segment=g.value()),k.push([0,p]),p=p.mid;else break}const R=p.value;p.value=a,p.key=r;for(let T=k.length-1;T>=0;T--){const O=k[T][1];O.updateHeight();const V=O.balanceFactor();if(V<-1||V>1){const ne=k[T][0],se=k[T+1][0];if(ne===1&&se===1)k[T][1]=O.rotateLeft();else if(ne===-1&&se===-1)k[T][1]=O.rotateRight();else if(ne===1&&se===-1)O.right=k[T+1][1]=k[T+1][1].rotateRight(),k[T][1]=O.rotateLeft();else if(ne===-1&&se===1)O.left=k[T+1][1]=k[T+1][1].rotateLeft(),k[T][1]=O.rotateRight();else throw new Error;if(T>0)switch(k[T-1][0]){case-1:k[T-1][1].left=k[T][1];break;case 1:k[T-1][1].right=k[T][1];break;case 0:k[T-1][1].mid=k[T][1];break}else this._root=k[0][1]}}return R}get(r){return this._getNode(r)?.value}_getNode(r){const a=this._iter.reset(r);let g=this._root;for(;g;){const p=a.cmp(g.segment);if(p>0)g=g.left;else if(p<0)g=g.right;else if(a.hasNext())a.next(),g=g.mid;else break}return g}has(r){const a=this._getNode(r);return!(a?.value===void 0&&a?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,a){const g=this._iter.reset(r),p=[];let k=this._root;for(;k;){const R=g.cmp(k.segment);if(R>0)p.push([-1,k]),k=k.left;else if(R<0)p.push([1,k]),k=k.right;else if(g.hasNext())g.next(),p.push([0,k]),k=k.mid;else break}if(!!k){if(a?(k.left=void 0,k.mid=void 0,k.right=void 0,k.height=1):(k.key=void 0,k.value=void 0),!k.mid&&!k.value)if(k.left&&k.right){const R=this._min(k.right),{key:T,value:O,segment:V}=R;this._delete(R.key,!1),k.key=T,k.value=O,k.segment=V}else{const R=k.left??k.right;if(p.length>0){const[T,O]=p[p.length-1];switch(T){case-1:O.left=R;break;case 0:O.mid=R;break;case 1:O.right=R;break}}else this._root=R}for(let R=p.length-1;R>=0;R--){const T=p[R][1];T.updateHeight();const O=T.balanceFactor();if(O>1?(T.right.balanceFactor()>=0||(T.right=p[R+1][1]=p[R+1][1].rotateRight()),p[R][1]=T.rotateLeft()):O<-1&&(T.left.balanceFactor()<=0||(T.left=p[R+1][1]=p[R+1][1].rotateLeft()),p[R][1]=T.rotateRight()),R>0)switch(p[R-1][0]){case-1:p[R-1][1].left=p[R][1];break;case 1:p[R-1][1].right=p[R][1];break;case 0:p[R-1][1].mid=p[R][1];break}else this._root=p[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const a=this._iter.reset(r);let g=this._root,p;for(;g;){const k=a.cmp(g.segment);if(k>0)g=g.left;else if(k<0)g=g.right;else if(a.hasNext())a.next(),p=g.value||p,g=g.mid;else break}return g&&g.value||p}findSuperstr(r){const a=this._iter.reset(r);let g=this._root;for(;g;){const p=a.cmp(g.segment);if(p>0)g=g.left;else if(p<0)g=g.right;else if(a.hasNext())a.next(),g=g.mid;else return g.mid?this._entries(g.mid):void 0}}forEach(r){for(const[a,g]of this)r(g,a)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){!r||(r.left&&(yield*this._entries(r.left)),r.value&&(yield[r.key,r.value]),r.mid&&(yield*this._entries(r.mid)),r.right&&(yield*this._entries(r.right)))}_isBalanced(){const r=a=>{if(!a)return!0;const g=a.balanceFactor();return g<-1||g>1?!1:r(a.left)&&r(a.right)};return r(this._root)}}e.TernarySearchTree=c;class h{constructor(r,a){this[D]="ResourceMap",r instanceof h?(this.map=new Map(r.map),this.toKey=a??h.defaultToKey):(this.map=new Map,this.toKey=r??h.defaultToKey)}set(r,a){return this.map.set(this.toKey(r),a),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,a){typeof a!="undefined"&&(r=r.bind(a));for(let[g,p]of this.map)r(p,M.URI.parse(g),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield M.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[M.URI.parse(r[0]),r[1]]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[M.URI.parse(r[0]),r[1]]}}e.ResourceMap=h,h.defaultToKey=s=>s.toString();var o;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class u{constructor(){this[I]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,a=0){const g=this._map.get(r);if(!!g)return a!==0&&this.touch(g,a),g.value}set(r,a,g=0){let p=this._map.get(r);if(p)p.value=a,g!==0&&this.touch(p,g);else{switch(p={key:r,value:a,next:void 0,previous:void 0},g){case 0:this.addItemLast(p);break;case 1:this.addItemFirst(p);break;case 2:this.addItemLast(p);break;default:this.addItemLast(p);break}this._map.set(r,p),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const a=this._map.get(r);if(!!a)return this._map.delete(r),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,a){const g=this._state;let p=this._head;for(;p;){if(a?r.bind(a)(p.value,p.key,this):r(p.value,p.key,this),this._state!==g)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const r=this,a=this._state;let g=this._head;const p={[Symbol.iterator](){return p},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(g){const k={value:g.key,done:!1};return g=g.next,k}else return{value:void 0,done:!0}}};return p}values(){const r=this,a=this._state;let g=this._head;const p={[Symbol.iterator](){return p},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(g){const k={value:g.value,done:!1};return g=g.next,k}else return{value:void 0,done:!0}}};return p}entries(){const r=this,a=this._state;let g=this._head;const p={[Symbol.iterator](){return p},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(g){const k={value:[g.key,g.value],done:!1};return g=g.next,k}else return{value:void 0,done:!0}}};return p}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let a=this._head,g=this.size;for(;a&&g>r;)this._map.delete(a.key),a=a.next,g--;this._head=a,this._size=g,a&&(a.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const a=r.next,g=r.previous;if(!a||!g)throw new Error("Invalid list");a.previous=g,g.next=a}r.next=void 0,r.previous=void 0,this._state++}touch(r,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(r===this._head)return;const g=r.next,p=r.previous;r===this._tail?(p.next=void 0,this._tail=p):(g.previous=p,p.next=g),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(a===2){if(r===this._tail)return;const g=r.next,p=r.previous;r===this._head?(g.previous=void 0,this._head=g):(g.previous=p,p.next=g),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((a,g)=>{r.push([g,a])}),r}fromJSON(r){this.clear();for(const[a,g]of r)this.set(a,g)}}e.LinkedMap=u;class t extends u{constructor(r,a=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,a=2){return super.get(r,a)}peek(r){return super.get(r,0)}set(r,a){return super.set(r,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=t;class l{constructor(r){n.set(this,void 0),bt(this,n,r,"f")}get size(){return je(this,n,"f").size}forEach(r,a){je(this,n,"f").forEach(r,a)}get(r){return je(this,n,"f").get(r)}has(r){return je(this,n,"f").has(r)}entries(){return je(this,n,"f").entries()}keys(){return je(this,n,"f").keys()}values(){return je(this,n,"f").values()}[(n=new WeakMap,Symbol.iterator)](){return je(this,n,"f").entries()}}e.ReadonlyMapView=l}),define(Z[110],x([0,1,18,25,8]),function(K,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function D(i){return JSON.stringify(i,f)}e.stringify=D;function I(i){let P=JSON.parse(i);return P=w(P),P}e.parse=I;var n;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(n=e.MarshalledId||(e.MarshalledId={}));function f(i,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,L.regExpFlags)(P)}:P}function w(i,P=0){if(!i||P>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return M.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof v.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let E=0;E<i.length;++E)i[E]=w(i[E],P+1);else for(const E in i)Object.hasOwnProperty.call(i,E)&&(i[E]=w(i[E],P+1))}return i}e.revive=w}),define(Z[10],x([0,1,3,8]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var M;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeNotebookCellOutput="vscode-notebook-cell-output",n.vscodeInteractive="vscode-interactive",n.vscodeInteractiveInput="vscode-interactive-input",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.vscodeTerminal="vscode-terminal",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.extension="extension",n.vscodeFileResource="vscode-file",n.tmp="tmp"})(M=e.Schemas||(e.Schemas={}));class D{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(f){this._preferredWebSchema=f}setDelegate(f){this._delegate=f}set(f,w,i){this._hosts[f]=w,this._ports[f]=i}setConnectionToken(f,w){this._connectionTokens[f]=w}rewrite(f){if(this._delegate)return this._delegate(f);const w=f.authority;let i=this._hosts[w];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const P=this._ports[w],E=this._connectionTokens[w];let y=`path=${encodeURIComponent(f.path)}`;return typeof E=="string"&&(y+=`&tkn=${encodeURIComponent(E)}`),L.URI.from({scheme:v.isWeb?this._preferredWebSchema:M.vscodeRemoteResource,authority:`${i}:${P}`,path:"/vscode-remote-resource",query:y})}}e.RemoteAuthorities=new D;class I{asBrowserUri(f,w){const i=this.toUri(f,w);return i.scheme===M.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===M.file&&(v.isNative||typeof v.globals.importScripts=="function"&&v.globals.origin===`${M.vscodeFileResource}://${I.FALLBACK_AUTHORITY}`)?i.with({scheme:M.vscodeFileResource,authority:i.authority||I.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(f,w){const i=this.toUri(f,w);return i.scheme===M.vscodeFileResource?i.with({scheme:M.file,authority:i.authority!==I.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(f,w){return L.URI.isUri(f)?f:L.URI.parse(w.toUrl(f))}}I.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new I}),define(Z[68],x([0,1,37]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new v.LRUCache(1e4);function M(w){return f(w,"NFC",L)}e.normalizeNFC=M;const D=new v.LRUCache(1e4);function I(w){return f(w,"NFD",D)}e.normalizeNFD=I;const n=/[^\u0000-\u0080]/;function f(w,i,P){if(!w)return w;const E=P.get(w);if(E)return E;let y;return n.test(w)?y=w.normalize(i):y=w,P.set(w,y),y}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(i){return I(i).replace(w,"")}}()}),define(Z[15],x([0,1,31,10,7,3,25,8]),function(K,e,v,L,M,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function f(y){return(0,n.uriToFsPath)(y,!0)}e.originalFSPath=f;class w{constructor(d){this._ignorePathCasing=d}compare(d,m,b=!1){return d===m?0:(0,I.compare)(this.getComparisonKey(d,b),this.getComparisonKey(m,b))}isEqual(d,m,b=!1){return d===m?!0:!d||!m?!1:this.getComparisonKey(d,b)===this.getComparisonKey(m,b)}getComparisonKey(d,m=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,m,b=!1){if(d.scheme===m.scheme){if(d.scheme===L.Schemas.file)return v.isEqualOrParent(f(d),f(m),this._ignorePathCasing(d))&&d.query===m.query&&(b||d.fragment===m.fragment);if((0,e.isEqualAuthority)(d.authority,m.authority))return v.isEqualOrParent(d.path,m.path,this._ignorePathCasing(d),"/")&&d.query===m.query&&(b||d.fragment===m.fragment)}return!1}joinPath(d,...m){return n.URI.joinPath(d,...m)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return M.posix.basename(d.path)}extname(d){return M.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let m;return d.scheme===L.Schemas.file?m=n.URI.file(M.dirname(f(d))).path:(m=M.posix.dirname(d.path),d.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),m="/")),d.with({path:m})}normalizePath(d){if(!d.path.length)return d;let m;return d.scheme===L.Schemas.file?m=n.URI.file(M.normalize(f(d))).path:m=M.posix.normalize(d.path),d.with({path:m})}relativePath(d,m){if(d.scheme!==m.scheme||!(0,e.isEqualAuthority)(d.authority,m.authority))return;if(d.scheme===L.Schemas.file){const c=M.relative(f(d),f(m));return D.isWindows?v.toSlashes(c):c}let b=d.path||"/",S=m.path||"/";if(this._ignorePathCasing(d)){let c=0;for(const h=Math.min(b.length,S.length);c<h&&!(b.charCodeAt(c)!==S.charCodeAt(c)&&b.charAt(c).toLowerCase()!==S.charAt(c).toLowerCase());c++);b=S.substr(0,c)+b.substr(c)}return M.posix.relative(b,S)}resolvePath(d,m){if(d.scheme===L.Schemas.file){const b=n.URI.file(M.resolve(f(d),m));return d.with({authority:b.authority,path:b.path})}return m=v.toPosixPath(m),d.with({path:M.posix.resolve(d.path,m)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,m){return d===m||(0,I.equalsIgnoreCase)(d,m)}hasTrailingPathSeparator(d,m=M.sep){if(d.scheme===L.Schemas.file){const b=f(d);return b.length>v.getRoot(b).length&&b[b.length-1]===m}else{const b=d.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,m=M.sep){return(0,e.hasTrailingPathSeparator)(d,m)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,m=M.sep){let b=!1;if(d.scheme===L.Schemas.file){const S=f(d);b=S!==void 0&&S.length===v.getRoot(S).length&&S[S.length-1]===m}else{m="/";const S=d.path;b=S.length===1&&S.charCodeAt(S.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(d,m)?d.with({path:d.path+"/"}):d}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(y=>y.scheme===L.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new w(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(y,d){const m=[];for(let b=0;b<y.length;b++){const S=d(y[b]);y.some((c,h)=>h===b?!1:(0,e.isEqualOrParent)(S,d(c)))||m.push(y[b])}return m}e.distinctParents=i;var P;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function d(m){const b=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(h=>{const[o,u]=h.split(":");o&&u&&b.set(o,u)});const c=m.path.substring(0,m.path.indexOf(";"));return c&&b.set(y.META_DATA_MIME,c),b}y.parseMetaData=d})(P=e.DataUri||(e.DataUri={}));function E(y,d,m){if(d){let b=y.path;return b&&b[0]!==M.posix.sep&&(b=M.posix.sep+b),y.with({scheme:m,authority:d,path:b})}return y.with({scheme:m})}e.toLocalResource=E}),define(Z[9],x([0,1,23,17,4,2,15]),function(K,e,v,L,M,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function n(q){return!!q&&typeof q.then=="function"}e.isThenable=n;function f(q){const $=new v.CancellationTokenSource,H=q($.token),_=new Promise((z,C)=>{const A=$.token.onCancellationRequested(()=>{A.dispose(),$.dispose(),C((0,L.canceled)())});Promise.resolve(H).then(W=>{A.dispose(),$.dispose(),z(W)},W=>{A.dispose(),$.dispose(),C(W)})});return new class{cancel(){$.cancel()}then(z,C){return _.then(z,C)}catch(z){return this.then(void 0,z)}finally(z){return _.finally(z)}}}e.createCancelablePromise=f;function w(q,$,H){return Promise.race([q,new Promise(_=>$.onCancellationRequested(()=>_(H)))])}e.raceCancellation=w;async function i(q){let $=-1;const H=q.map((z,C)=>z.then(A=>($=C,A))),_=await Promise.race(H);return q.forEach((z,C)=>{C!==$&&z.cancel()}),_}e.raceCancellablePromises=i;function P(q,$,H){let _;const z=setTimeout(()=>{_?.(void 0),H?.()},$);return Promise.race([q.finally(()=>clearTimeout(z)),new Promise(C=>_=C)])}e.raceTimeout=P;function E(q){return new Promise(($,H)=>{const _=q();n(_)?_.then($,H):$(_)})}e.asPromise=E;class y{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue($){if(this.activePromise){if(this.queuedPromiseFactory=$,!this.queuedPromise){const H=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(H,H).then(_)})}return new Promise((H,_)=>{this.queuedPromise.then(H,_)})}return this.activePromise=$(),new Promise((H,_)=>{this.activePromise.then(z=>{this.activePromise=null,H(z)},z=>{this.activePromise=null,_(z)})})}}e.Throttler=y;class d{constructor(){this.current=Promise.resolve(null)}queue($){return this.current=this.current.then(()=>$(),()=>$())}}e.Sequencer=d;class m{constructor(){this.promiseMap=new Map}queue($,H){const z=(this.promiseMap.get($)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.promiseMap.get($)===z&&this.promiseMap.delete($)});return this.promiseMap.set($,z),z}}e.SequencerByKey=m;class b{constructor($){this.defaultDelay=$,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger($,H=this.defaultDelay){return this.task=$,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((_,z)=>{this.doResolve=_,this.doReject=z}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const _=this.task;return this.task=null,_()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},H),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=b;class S{constructor($){this.delayer=new b($),this.throttler=new y}trigger($,H){return this.delayer.trigger(()=>this.throttler.queue($),H)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=S;class c{constructor(){this._isOpen=!1,this._promise=new Promise(($,H)=>{this._completePromise=$})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class h extends c{constructor($){super();this._timeout=setTimeout(()=>this.open(),$)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=h;function o(q,$){return $?new Promise((H,_)=>{const z=setTimeout(()=>{C.dispose(),H()},q),C=$.onCancellationRequested(()=>{clearTimeout(z),C.dispose(),_((0,L.canceled)())})}):f(H=>o(q,H))}e.timeout=o;function u(q,$=0){const H=setTimeout(q,$);return(0,D.toDisposable)(()=>clearTimeout(H))}e.disposableTimeout=u;function t(q){const $=[];let H=0;const _=q.length;function z(){return H<_?q[H++]():null}function C(A){A!=null&&$.push(A);const W=z();return W?W.then(C):Promise.resolve($)}return Promise.resolve(null).then(C)}e.sequence=t;function l(q,$=_=>!!_,H=null){let _=0;const z=q.length,C=()=>{if(_>=z)return Promise.resolve(H);const A=q[_++];return Promise.resolve(A()).then(B=>$(B)?Promise.resolve(B):C())};return C()}e.first=l;function s(q,$=_=>!!_,H=null){if(q.length===0)return Promise.resolve(H);let _=q.length;const z=()=>{_=-1;for(const C of q)C.cancel?.()};return new Promise((C,A)=>{for(const W of q)W.then(B=>{--_>=0&&$(B)?(z(),C(B)):_===0&&C(H)}).catch(B=>{--_>=0&&(z(),A(B))})})}e.firstParallel=s;class r{constructor($){this._size=0,this.maxDegreeOfParalellism=$,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new M.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue($){return this._size++,new Promise((H,_)=>{this.outstandingPromises.push({factory:$,c:H,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const $=this.outstandingPromises.shift();this.runningPromises++;const H=$.factory();H.then($.c,$.e),H.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=r;class a extends r{constructor(){super(1)}}e.Queue=a;class g{constructor(){this.queues=new Map}queueFor($,H=I.extUri){const _=H.getComparisonKey($);let z=this.queues.get(_);return z||(z=new a,M.Event.once(z.onFinished)(()=>{z?.dispose(),this.queues.delete(_)}),this.queues.set(_,z)),z}dispose(){this.queues.forEach($=>$.dispose()),this.queues.clear()}}e.ResourceQueue=g;class p{constructor($,H){this._token=-1,typeof $=="function"&&typeof H=="number"&&this.setIfNotSet($,H)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet($,H){this.cancel(),this._token=setTimeout(()=>{this._token=-1,$()},H)}setIfNotSet($,H){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,$()},H))}}e.TimeoutTimer=p;class k{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet($,H){this.cancel(),this._token=setInterval(()=>{$()},H)}}e.IntervalTimer=k;class R{constructor($,H){this.timeoutToken=-1,this.runner=$,this.timeout=H,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule($=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,$)}get delay(){return this.timeout}set delay($){this.timeout=$}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class T{constructor($,H){H%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.runner=$,this.timeout=H,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule($=this.timeout){$%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${$}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil($/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=T;class O extends R{constructor($,H){super($,H);this.units=[]}work($){this.units.push($),this.isScheduled()||this.schedule()}doRun(){const $=this.units;this.units=[],this.runner&&this.runner($)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O;class V extends D.Disposable{constructor($,H,_,z){super();this.maxWorkChunkSize=$,this.maxPendingWork=H,this.throttleDelay=_,this.handler=z,this.pendingWork=[],this.throttler=this._register(new D.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work($){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+$.length>this.maxPendingWork)return!1}else if(this.pending+$.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...$),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=V,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=q=>{const $=setTimeout(()=>{const _=Date.now()+15;q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,_-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0,clearTimeout($))}}}:e.runWhenIdle=(q,$)=>{const H=requestIdleCallback(q,typeof $=="number"?{timeout:$}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(H))}}}}();class ne{constructor($){this._didRun=!1,this._executor=()=>{try{this._value=$()}catch(H){this._error=H}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ne;async function se(q,$,H){let _;for(let z=0;z<H;z++)try{return await q()}catch(C){_=C,await o($)}throw _}e.retry=se;class G{hasPending($){return this._pending?typeof $=="number"?this._pending.taskId===$:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending($,H,_){return this._pending={taskId:$,cancel:()=>_?.(),promise:H},H.then(()=>this.donePending($),()=>this.donePending($)),H}donePending($){this._pending&&$===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const $=this._next;this._next=void 0,$.run().then($.promiseResolve,$.promiseReject)}}setNext($){if(this._next)this._next.run=$;else{let H,_;const z=new Promise((C,A)=>{H=C,_=A});this._next={run:$,promise:z,promiseResolve:H,promiseReject:_}}return this._next.promise}}e.TaskSequentializer=G;class te{constructor($){this.interval=$,this.lastIncrementTime=0,this.value=0}increment(){const $=Date.now();return $-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=$,this.value=0),this.value++,this.value}}e.IntervalCounter=te;class F{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise(($,H)=>{this.completeCallback=$,this.errorCallback=H})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete($){return new Promise(H=>{this.completeCallback($),this.resolved=!0,H()})}error($){return new Promise(H=>{this.errorCallback($),this.rejected=!0,H()})}cancel(){new Promise($=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,$()})}}e.DeferredPromise=F;var j;(function(q){async function $(H){let _;const z=await Promise.all(H.map(C=>C.then(A=>A,A=>{_||(_=A)})));if(typeof _!="undefined")throw _;return z}q.settled=$})(j=e.Promises||(e.Promises={}))}),define(Z[111],x([0,1,9,31,37,7,25]),function(K,e,v,L,M,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function n(){return Object.create(null)}e.getEmptyExpression=n;const f="**",w="/",i="[/\\\\]",P="[^/\\\\]",E=/\//g;function y(_){switch(_){case 0:return"";case 1:return`${P}*?`;default:return`(?:${i}|${P}+${i}|${i}${P}+)*?`}}function d(_,z){if(!_)return[];const C=[];let A=!1,W=!1,B="";for(const Y of _){switch(Y){case z:if(!A&&!W){C.push(B),B="";continue}break;case"{":A=!0;break;case"}":A=!1;break;case"[":W=!0;break;case"]":W=!1;break}B+=Y}return B&&C.push(B),C}e.splitGlobAware=d;function m(_){if(!_)return"";let z="";const C=d(_,w);if(C.every(A=>A===f))z=".*";else{let A=!1;C.forEach((W,B)=>{if(W===f){A||(z+=y(2),A=!0);return}let Y=!1,U="",N=!1,Q="";for(const J of W){if(J!=="}"&&Y){U+=J;continue}if(N&&(J!=="]"||!Q)){let re;J==="-"?re=J:(J==="^"||J==="!")&&!Q?re="^":J===w?re="":re=I.escapeRegExpCharacters(J),Q+=re;continue}switch(J){case"{":Y=!0;continue;case"[":N=!0;continue;case"}":z+=`(?:${d(U,",").map(ee=>m(ee)).join("|")})`,Y=!1,U="";break;case"]":z+="["+Q+"]",N=!1,Q="";break;case"?":z+=P;continue;case"*":z+=y(1);continue;default:z+=I.escapeRegExpCharacters(J)}}B<C.length-1&&(C[B+1]!==f||B+2<C.length)&&(z+=i),A=!1})}return z}const b=/^\*\*\/\*\.[\w\.-]+$/,S=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.LRUCache(1e4),l=function(){return!1},s=function(){return null};function r(_,z){if(!_)return s;let C;typeof _!="string"?C=_.pattern:C=_,C=C.trim();const A=`${C}_${!!z.trimForExclusions}`;let W=t.get(A);if(W)return a(W,_);let B;if(b.test(C)){const Y=C.substr(4);W=function(U,N){return typeof U=="string"&&U.endsWith(Y)?C:null}}else(B=S.exec(g(C,z)))?W=p(B[1],C):(z.trimForExclusions?h:c).test(C)?W=k(C,z):(B=o.exec(g(C,z)))?W=R(B[1].substr(1),C,!0):(B=u.exec(g(C,z)))?W=R(B[1],C,!1):W=T(C);return t.set(A,W),a(W,_)}function a(_,z){return typeof z=="string"?_:function(C,A){return L.isEqualOrParent(C,z.base)?_(D.relative(z.base,C),A):null}}function g(_,z){return z.trimForExclusions&&_.endsWith("/**")?_.substr(0,_.length-2):_}function p(_,z){const C=`/${_}`,A=`\\${_}`,W=function(Y,U){return typeof Y!="string"?null:U?U===_?z:null:Y===_||Y.endsWith(C)||Y.endsWith(A)?z:null},B=[_];return W.basenames=B,W.patterns=[z],W.allBasenames=B,W}function k(_,z){const C=H(_.slice(1,-1).split(",").map(U=>r(U,z)).filter(U=>U!==s),_),A=C.length;if(!A)return s;if(A===1)return C[0];const W=function(U,N){for(let Q=0,J=C.length;Q<J;Q++)if(C[Q](U,N))return _;return null},B=C.find(U=>!!U.allBasenames);B&&(W.allBasenames=B.allBasenames);const Y=C.reduce((U,N)=>N.allPaths?U.concat(N.allPaths):U,[]);return Y.length&&(W.allPaths=Y),W}function R(_,z,C){const A=D.sep===D.posix.sep,W=A?_:_.replace(E,D.sep),B=D.sep+W,Y=D.posix.sep+_,U=C?function(N,Q){return typeof N=="string"&&(N===W||N.endsWith(B)||!A&&(N===_||N.endsWith(Y)))?z:null}:function(N,Q){return typeof N=="string"&&(N===W||!A&&N===_)?z:null};return U.allPaths=[(C?"*/":"./")+_],U}function T(_){try{const z=new RegExp(`^${m(_)}$`);return function(C){return z.lastIndex=0,typeof C=="string"&&z.test(C)?_:null}}catch(z){return s}}function O(_,z,C){return!_||typeof z!="string"?!1:V(_)(z,void 0,C)}e.match=O;function V(_,z={}){if(!_)return l;if(typeof _=="string"||te(_)){const C=r(_,z);if(C===s)return l;const A=function(W,B){return!!C(W,B)};return C.allBasenames&&(A.allBasenames=C.allBasenames),C.allPaths&&(A.allPaths=C.allPaths),A}return q(_,z)}e.parse=V;function ne(_){if(!_)return;let z;return C=>(z||(z=(_()||Promise.resolve([])).then(A=>A?G(A):{})),z.then(A=>!!A[C]))}e.hasSiblingPromiseFn=ne;function se(_){if(!_)return;let z;return C=>{if(!z){const A=_();z=A?G(A):{}}return!!z[C]}}e.hasSiblingFn=se;function G(_){const z={};for(const C of _)z[C]=!0;return z}function te(_){const z=_;return z&&typeof z.base=="string"&&typeof z.pattern=="string"}e.isRelativePattern=te;function F(_){return _.allBasenames||[]}e.getBasenameTerms=F;function j(_){return _.allPaths||[]}e.getPathTerms=j;function q(_,z){const C=H(Object.getOwnPropertyNames(_).map(U=>$(U,_[U],z)).filter(U=>U!==s)),A=C.length;if(!A)return s;if(!C.some(U=>!!U.requiresSiblings)){if(A===1)return C[0];const U=function(J,re){for(let le=0,ee=C.length;le<ee;le++){const ae=C[le](J,re);if(ae)return ae}return null},N=C.find(J=>!!J.allBasenames);N&&(U.allBasenames=N.allBasenames);const Q=C.reduce((J,re)=>re.allPaths?J.concat(re.allPaths):J,[]);return Q.length&&(U.allPaths=Q),U}const W=function(U,N,Q){let J;for(let re=0,le=C.length;re<le;re++){const ee=C[re];ee.requiresSiblings&&Q&&(N||(N=D.basename(U)),J||(J=N.substr(0,N.length-D.extname(U).length)));const ae=ee(U,N,J,Q);if(ae)return ae}return null},B=C.find(U=>!!U.allBasenames);B&&(W.allBasenames=B.allBasenames);const Y=C.reduce((U,N)=>N.allPaths?U.concat(N.allPaths):U,[]);return Y.length&&(W.allPaths=Y),W}function $(_,z,C){if(z===!1)return s;const A=r(_,C);if(A===s)return s;if(typeof z=="boolean")return A;if(z){const W=z.when;if(typeof W=="string"){const B=(Y,U,N,Q)=>{if(!Q||!A(Y,U))return null;const J=W.replace("$(basename)",N),re=Q(J);return(0,v.isThenable)(re)?re.then(le=>le?_:null):re?_:null};return B.requiresSiblings=!0,B}}return A}function H(_,z){const C=_.filter(U=>!!U.basenames);if(C.length<2)return _;const A=C.reduce((U,N)=>{const Q=N.basenames;return Q?U.concat(Q):U},[]);let W;if(z){W=[];for(let U=0,N=A.length;U<N;U++)W.push(z)}else W=C.reduce((U,N)=>{const Q=N.patterns;return Q?U.concat(Q):U},[]);const B=function(U,N){if(typeof U!="string")return null;if(!N){let J;for(J=U.length;J>0;J--){const re=U.charCodeAt(J-1);if(re===47||re===92)break}N=U.substr(J)}const Q=A.indexOf(N);return Q!==-1?W[Q]:null};B.basenames=A,B.patterns=W,B.allBasenames=A;const Y=_.filter(U=>!U.basenames);return Y.push(B),Y}}),define(Z[34],x([0,1,31,10,7,3,15,25,8]),function(K,e,v,L,M,D,I,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function w(r,a,g){if(typeof r=="string"&&(r=f.URI.file(r)),g){const k=g.getWorkspaceFolder(r);if(k){const R=g.getWorkspace().folders.length>1;let T;if((0,I.isEqual)(k.uri,r)?T="":T=(0,I.relativePath)(k.uri,r),R){const O=k.name?k.name:(0,I.basename)(k.uri);T=T?O+" \u2022 "+T:O}return T}}if(r.scheme!==L.Schemas.file&&r.scheme!==L.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,v.hasDriveLetter)(r.fsPath))return(0,M.normalize)(P(r.fsPath));let p=(0,M.normalize)(r.fsPath);return!D.isWindows&&a?.userHome&&(p=y(p,a.userHome.fsPath)),p}e.getPathLabel=w;function i(r){if(!r)return;typeof r=="string"&&(r=f.URI.file(r));const a=(0,I.basename)(r)||(r.scheme===L.Schemas.file?r.fsPath:r.path);return D.isWindows&&(0,v.isRootOrDriveLetter)(a)?P(a):a}e.getBaseLabel=i;function P(r){return(0,v.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=P;let E=Object.create(null);function y(r,a){if(D.isWindows||!r||!a)return r;let g=E.original===a?E.normalized:void 0;return g||(g=`${(0,n.rtrim)(a,M.posix.sep)}${M.posix.sep}`,E={original:a,normalized:g}),(D.isLinux?r.startsWith(g):(0,n.startsWithIgnoreCase)(r,g))&&(r=`~/${r.substr(g.length)}`),r}e.tildify=y;function d(r,a){return r.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=d;const m="\u2026",b="\\\\",S="~";function c(r,a=M.sep){const g=new Array(r.length);let p=!1;for(let k=0;k<r.length;k++){let R=r[k];if(R===""){g[k]=`.${a}`;continue}if(!R){g[k]=R;continue}p=!0;let T="";R.indexOf(b)===0?(T=R.substr(0,R.indexOf(b)+b.length),R=R.substr(R.indexOf(b)+b.length)):R.indexOf(a)===0?(T=R.substr(0,R.indexOf(a)+a.length),R=R.substr(R.indexOf(a)+a.length)):R.indexOf(S)===0&&(T=R.substr(0,R.indexOf(S)+S.length),R=R.substr(R.indexOf(S)+S.length));const O=R.split(a);for(let V=1;p&&V<=O.length;V++)for(let ne=O.length-V;p&&ne>=0;ne--){p=!1;let se=O.slice(ne,ne+V).join(a);for(let G=0;!p&&G<r.length;G++)if(G!==k&&r[G]&&r[G].indexOf(se)>-1){const te=ne+V===O.length,F=ne>0&&r[G].indexOf(a)>-1?a+se:se,j=r[G].endsWith(F);p=!te||j}if(!p){let G="";(O[0].endsWith(":")||T!=="")&&(ne===1&&(ne=0,V++,se=O[0]+a+se),ne>0&&(G=O[0]+a),G=T+G),ne>0&&(G=G+m+a),G=G+se,ne+V<O.length&&(G=G+a+m),g[k]=G}}p&&(g[k]=R)}return g}e.shorten=c;var h;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function o(r,a=Object.create(null)){const g=[];let p=!1,k="";for(const R of r)if(R==="$"||p&&R==="{")k&&g.push({value:k,type:h.TEXT}),k="",p=!0;else if(R==="}"&&p){const T=a[k];if(typeof T=="string")T.length&&g.push({value:T,type:h.VARIABLE});else if(T){const O=g[g.length-1];(!O||O.type!==h.SEPARATOR)&&g.push({value:T.label,type:h.SEPARATOR})}k="",p=!1}else k+=R;return k&&!p&&g.push({value:k,type:h.TEXT}),g.filter((R,T)=>{if(R.type===h.SEPARATOR){const O=g[T-1],V=g[T+1];return[O,V].every(ne=>ne&&(ne.type===h.VARIABLE||ne.type===h.TEXT)&&ne.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=o;function u(r,a){return D.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):r.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function t(r,a){return D.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,""):D.isWindows?r.replace(/&&|&/g,g=>g==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function l(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=l;function s(r){const a=r.indexOf("/")!==-1?M.posix:M.win32,g=a.basename(r),p=a.dirname(r);return g.length?{name:g,parentPath:p}:{name:p,parentPath:""}}e.splitName=s}),define(Z[28],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(f){return v.test(f)}e.isUUID=L;const M=new Uint8Array(16),D=[];for(let f=0;f<256;f++)D.push(f.toString(16).padStart(2,"0"));let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(f){for(let w=0;w<f.length;w++)f[w]=Math.floor(Math.random()*256);return f};function n(){I(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let f=0,w="";return w+=D[M[f++]],w+=D[M[f++]],w+=D[M[f++]],w+=D[M[f++]],w+="-",w+=D[M[f++]],w+=D[M[f++]],w+="-",w+=D[M[f++]],w+=D[M[f++]],w+="-",w+=D[M[f++]],w+=D[M[f++]],w+="-",w+=D[M[f++]],w+=D[M[f++]],w+=D[M[f++]],w+=D[M[f++]],w+=D[M[f++]],w+=D[M[f++]],w}e.generateUuid=n}),define(Z[112],x([0,1,58,32,43]),function(K,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function D(I,n){if(await new Promise((i,P)=>{const E=L.createReadStream(I),y=v.createHash("sha1");E.pipe(y);const d=(0,M.once)((m,b)=>{E.removeAllListeners(),y.removeAllListeners(),m?P(m):i(b)});E.once("error",d),E.once("end",d),y.once("error",d),y.once("data",m=>d(void 0,m.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=D}),define(Z[81],x([0,1,239]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(D="utf8"){this.stringDecoder=new v.StringDecoder(D),this.remaining=null}write(D){const I=[],n=this.remaining?this.remaining+this.stringDecoder.write(D):this.stringDecoder.write(D);if(n.length<1)return I;let f=0,w,i=f;for(;i<n.length;)if(w=n.charCodeAt(i),w===13||w===10){if(I.push(n.substring(f,i)),i++,i<n.length){const P=w;w=n.charCodeAt(i),(P===13&&w===10||P===10&&w===13)&&i++}f=i}else i++;return this.remaining=f<n.length?n.substr(f):null,I}end(){return this.remaining}}e.LineDecoder=L}),define(Z[113],x([0,1,26]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function M(n){const f=n.replace(/\-/g,":").toLowerCase();return!L.has(f)}function D(){return new Promise(async(n,f)=>{const w=setTimeout(()=>f("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await I())}catch(i){f(i)}finally{clearTimeout(w)}})}e.getMac=D;function I(){return new Promise((n,f)=>{try{const w=(0,v.networkInterfaces)();for(let i in w){const P=w[i];if(P){for(const{mac:E}of P)if(M(E))return n(E)}}f("Unable to retrieve mac address (unexpected format)")}catch(w){f(w)}})}}),define(Z[69],x([0,1,26,17,37,28,113]),function(K,e,v,L,M,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=M.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,P=0;const E=(0,v.networkInterfaces)();for(let y in E){const d=E[y];if(d)for(const{mac:m,internal:b}of d)b||(P+=1,this._isVirtualMachineMacAddress(m.toUpperCase())&&(i+=1))}this._value=P>0?i/P:0}return this._value}};let n;async function f(){return n||(n=(async()=>await w()||D.generateUuid())()),n}e.getMachineId=f;async function w(){try{const i=await new Promise((E,y)=>{K(["crypto"],E,y)}),P=await(0,I.getMac)();return i.createHash("sha256").update(P,"utf8").digest("hex")}catch(i){L.onUnexpectedError(i);return}}}),define(Z[19],x([0,1,32,26,114,9,31,68,7,3,15,8,28]),function(K,e,v,L,M,D,I,n,f,w,i,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function d(F,j=y.UNLINK){if((0,I.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return j===y.UNLINK?b(F):m(F)}async function m(F){try{const j=(0,f.join)((0,L.tmpdir)(),(0,E.generateUuid)());try{await e.Promises.rename(F,j)}catch(q){return b(F)}b(j).catch(q=>{})}catch(j){if(j.code!=="ENOENT")throw j}}async function b(F){return e.Promises.rmdir(F,{recursive:!0,maxRetries:3})}function S(F){if((0,I.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(F,{recursive:!0})}e.rimrafSync=S;async function c(F,j){return u(await(j?h(F):(0,M.promisify)(v.readdir)(F)))}async function h(F){try{return await(0,M.promisify)(v.readdir)(F,{withFileTypes:!0})}catch($){console.warn("[node.js fs] readdir with filetypes failed with error: ",$)}const j=[],q=await c(F);for(const $ of q){let H=!1,_=!1,z=!1;try{const C=await e.Promises.lstat((0,f.join)(F,$));H=C.isFile(),_=C.isDirectory(),z=C.isSymbolicLink()}catch(C){console.warn("[node.js fs] unexpected error from lstat after readdir: ",C)}j.push({name:$,isFile:()=>H,isDirectory:()=>_,isSymbolicLink:()=>z})}return j}function o(F){return u(v.readdirSync(F))}e.readdirSync=o;function u(F){return F.map(j=>typeof j=="string"?w.isMacintosh?(0,n.normalizeNFC)(j):j:(j.name=w.isMacintosh?(0,n.normalizeNFC)(j.name):j.name,j))}async function t(F){const j=await c(F),q=[];for(const $ of j)await s.existsDirectory((0,f.join)(F,$))&&q.push($);return q}function l(F,j=1e3){return new Promise(q=>{let $=!1;const H=setInterval(()=>{$||($=!0,v.access(F,_=>{$=!1,_&&(clearInterval(H),q(void 0))}))},j)})}e.whenDeleted=l;var s;(function(F){async function j(H){let _;try{if(_=await e.Promises.lstat(H),!_.isSymbolicLink())return{stat:_}}catch(z){}try{return{stat:await e.Promises.stat(H),symbolicLink:_?.isSymbolicLink()?{dangling:!1}:void 0}}catch(z){if(z.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};if(w.isWindows&&z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(C){if(C.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};throw C}throw z}}F.stat=j;async function q(H){try{const{stat:_,symbolicLink:z}=await F.stat(H);return _.isFile()&&z?.dangling!==!0}catch(_){}return!1}F.existsFile=q;async function $(H){try{const{stat:_,symbolicLink:z}=await F.stat(H);return _.isDirectory()&&z?.dangling!==!0}catch(_){}return!1}F.existsDirectory=$})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new D.ResourceQueue;function a(F,j,q){return r.queueFor(P.URI.file(F),i.extUriBiasedIgnorePathCase).queue(()=>{const $=R(q);return new Promise((H,_)=>p(F,j,$,z=>z?_(z):H()))})}let g=!0;function p(F,j,q,$){if(!g)return v.writeFile(F,j,{mode:q.mode,flag:q.flag},$);v.open(F,q.flag,q.mode,(H,_)=>{if(H)return $(H);v.writeFile(_,j,z=>{if(z)return v.close(_,()=>$(z));v.fdatasync(_,C=>(C&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",C),g=!1),v.close(_,A=>$(A))))})})}function k(F,j,q){const $=R(q);if(!g)return v.writeFileSync(F,j,{mode:$.mode,flag:$.flag});const H=v.openSync(F,$.flag,$.mode);try{v.writeFileSync(H,j);try{v.fdatasyncSync(H)}catch(_){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",_),g=!1}}finally{v.closeSync(H)}}e.writeFileSync=k;function R(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function T(F,j){if(F===j)return;async function q($){try{const H=await e.Promises.lstat($);if(H.isDirectory()||H.isSymbolicLink())return;await e.Promises.utimes($,H.atime,new Date)}catch(H){}}try{await e.Promises.rename(F,j),await q(j)}catch($){if(F.toLowerCase()!==j.toLowerCase()&&$.code==="EXDEV"||F.endsWith("."))await O(F,j,{preserveSymlinks:!1}),await d(F,y.MOVE),await q(j);else throw $}}async function O(F,j,q){return ne(F,j,{root:{source:F,target:j},options:q,handledSourcePaths:new Set})}const V=511;async function ne(F,j,q){if(q.handledSourcePaths.has(F))return;q.handledSourcePaths.add(F);const{stat:$,symbolicLink:H}=await s.stat(F);if(H){if(q.options.preserveSymlinks)try{return await te(F,j,q)}catch(_){console.warn("[node.js fs] copy of symlink failed: ",_)}if(H.dangling)return}return $.isDirectory()?se(F,j,$.mode&V,q):G(F,j,$.mode&V)}async function se(F,j,q,$){await e.Promises.mkdir(j,{recursive:!0,mode:q});const H=await c(F);for(const _ of H)await ne((0,f.join)(F,_),(0,f.join)(j,_),$)}async function G(F,j,q){await e.Promises.copyFile(F,j),await e.Promises.chmod(j,q)}async function te(F,j,q){let $=await e.Promises.readlink(F);(0,I.isEqualOrParent)($,q.root.source,!w.isLinux)&&($=(0,f.join)(q.root.target,$.substr(q.root.source.length+1))),await e.Promises.symlink($,j)}e.Promises=new class{get access(){return(0,M.promisify)(v.access)}get stat(){return(0,M.promisify)(v.stat)}get lstat(){return(0,M.promisify)(v.lstat)}get utimes(){return(0,M.promisify)(v.utimes)}get read(){return(0,M.promisify)(v.read)}get readFile(){return(0,M.promisify)(v.readFile)}get write(){return(0,M.promisify)(v.write)}get appendFile(){return(0,M.promisify)(v.appendFile)}get fdatasync(){return(0,M.promisify)(v.fdatasync)}get truncate(){return(0,M.promisify)(v.truncate)}get rename(){return(0,M.promisify)(v.rename)}get copyFile(){return(0,M.promisify)(v.copyFile)}get open(){return(0,M.promisify)(v.open)}get close(){return(0,M.promisify)(v.close)}get symlink(){return(0,M.promisify)(v.symlink)}get readlink(){return(0,M.promisify)(v.readlink)}get chmod(){return(0,M.promisify)(v.chmod)}get mkdir(){return(0,M.promisify)(v.mkdir)}get unlink(){return(0,M.promisify)(v.unlink)}get rmdir(){return(0,M.promisify)(v.rmdir)}get realpath(){return(0,M.promisify)(v.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return t}get writeFile(){return a}get rm(){return d}get move(){return T}get copy(){return O}}}),define(Z[82],x([0,1,32,7,25,19]),function(K,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function I(i){const P=(0,L.dirname)(i);if(i===P)return i;const E=((0,L.basename)(i)||i).toLowerCase();try{const d=(0,D.readdirSync)(P).filter(m=>m.toLowerCase()===E);if(d.length===1){const m=I(P);if(m)return(0,L.join)(m,d[0])}else if(d.length>1){const m=d.indexOf(E);if(m>=0){const b=I(P);if(b)return(0,L.join)(b,d[m])}}}catch(y){}return null}e.realcaseSync=I;async function n(i){try{return await D.Promises.realpath(i)}catch(P){const E=w(i);return await D.Promises.access(E,v.constants.R_OK),E}}e.realpath=n;function f(i){try{return v.realpathSync(i)}catch(P){const E=w(i);return v.accessSync(E,v.constants.R_OK),E}}e.realpathSync=f;function w(i){return(0,M.rtrim)((0,L.normalize)(i),L.sep)}}),define(Z[115],x([0,1,59]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function L(n,f,w,i=1){let P=!1;return new Promise(E=>{const y=setTimeout(()=>{if(!P)return P=!0,E(0)},w);M(n,f,i,d=>{if(!P)return P=!0,clearTimeout(y),E(d)})})}e.findFreePort=L;function M(n,f,w,i){if(f===0)return i(0);const P=new v.Socket;P.once("connect",()=>(I(P),M(n+w,f-1,w,i))),P.once("data",()=>{}),P.once("error",E=>(I(P),E.code!=="ECONNREFUSED"?M(n+w,f-1,w,i):i(n))),P.connect(n,"127.0.0.1")}function D(n,f,w){let i=!1,P,E=1;const y=v.createServer({pauseOnConnect:!0});function d(m,b){i||(i=!0,y.removeAllListeners(),y.close(),P&&clearTimeout(P),b(m))}return new Promise(m=>{P=setTimeout(()=>{d(0,m)},w),y.on("listening",()=>{d(n,m)}),y.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&E<f?(n++,E++,y.listen(n,"127.0.0.1")):d(0,m)}),y.on("close",()=>{d(0,m)}),y.listen(n,"127.0.0.1")})}e.findFreePortFaster=D;function I(n){try{n.removeAllListeners("connect"),n.removeAllListeners("error"),n.end(),n.destroy(),n.unref()}catch(f){console.error(f)}}}),define(Z[116],x([0,1,26,7,19]),function(K,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,I=/^Microsoft.PowerShell_.*/,n=/^Microsoft.PowerShellPreview_.*/;var f;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(f||(f={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class P{constructor(u,t,l){this.exePath=u,this.displayName=t,this.knownToExist=l}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await M.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function E({useAlternateBitness:o=!1}={}){return o?w===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:o=!1,findPreview:u=!1}={}){const t=E({useAlternateBitness:o});if(!t)return null;const l=L.join(t,"PowerShell");if(!await M.SymlinkSupport.existsDirectory(l))return null;let s=-1,r=null;for(const p of await M.Promises.readdir(l)){let k=-1;if(u){const T=p.indexOf("-");if(T<0)continue;const O=p.substring(0,T);if(!D.test(O)||p.substring(T+1)!=="preview")continue;k=parseInt(O,10)}else{if(!D.test(p))continue;k=parseInt(p,10)}if(k<=s)continue;const R=L.join(l,p,"pwsh.exe");!await M.SymlinkSupport.existsFile(R)||(r=R,s=k)}if(!r)return null;const a=t.includes("x86")?" (x86)":"",g=u?" Preview":"";return new P(r,`PowerShell${g}${a}`,!0)}async function d({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const u=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await M.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:t,pwshMsixName:l}=o?{pwshMsixDirRegex:n,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:I,pwshMsixName:"PowerShell (Store)"};for(const s of await M.Promises.readdir(u))if(t.test(s)){const r=L.join(u,s,"pwsh.exe");return new P(r,l)}return null}function m(){const o=L.join(v.homedir(),".dotnet","tools","pwsh.exe");return new P(o,".NET Core PowerShell Global Tool")}function b(){const o=L.join(process.env.windir,w===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new P(o,"Windows PowerShell",!0)}async function*S(){let o=await y();o&&(yield o),o=await y({useAlternateBitness:!0}),o&&(yield o),o=await d(),o&&(yield o),o=m(),o&&(yield o),o=await y({findPreview:!0}),o&&(yield o),o=await d({findPreview:!0}),o&&(yield o),o=await y({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=b(),o&&(yield o)}async function*c(){for await(const o of S())await o.exists()&&(yield o)}e.enumeratePowerShellInstallations=c;async function h(){for await(const o of c())return o;return null}e.getFirstAvailablePowerShellInstallation=h}),define(Z[83],x([0,1,41,10]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function M(I){return new Promise((n,f)=>{let w;const i=new Map;function P(y,d,m,b,S){const c=i.get(d);if(y===I||c){const h={name:E(m),cmd:m,pid:y,ppid:d,load:b,mem:S};i.set(y,h),y===I&&(w=h),c&&(c.children||(c.children=[]),c.children.push(h),c.children.length>1&&(c.children=c.children.sort((o,u)=>o.pid-u.pid)))}}function E(y){const d=/--disable-blink-features=Auxclick/,m=/\\watcher\\win32\\CodeHelper\.exe/,b=/--crashes-directory/,S=/\\pipe\\winpty-control/,c=/conhost\.exe/,h=/--type=([a-zA-Z-]+)/;if(m.exec(y))return"watcherService ";if(b.exec(y))return"electron-crash-reporter";if(S.exec(y))return"winpty-process";if(c.exec(y))return"console-window-host (Windows internal process)";let o=h.exec(y);if(o&&o.length===2)return o[1]==="renderer"?d.exec(y)?"shared-process":"window":o[1];const u=/[a-zA-Z-]+\.js/g;let t="";do o=u.exec(y),o&&(t+=o+" ");while(o);return t&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${t}`:y}if(process.platform==="win32"){const y=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,m)=>{K(["windows-process-tree"],d,m)}).then(d=>{d.getProcessList(I,m=>{d.getProcessCpuUsage(m,b=>{const S=new Map;b.forEach(c=>{const h=y(c.commandLine||"");S.set(c.pid,{name:E(h),cmd:h,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),w=S.get(I),w?(S.forEach(c=>{const h=S.get(c.ppid);h&&(h.children||(h.children=[]),h.children.push(c))}),S.forEach(c=>{c.children&&(c.children=c.children.sort((h,o)=>h.pid-o.pid))}),n(w)):f(new Error(`Root process ${I} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let y=function(){let d=[w];const m=[];for(;d.length;){const S=d.shift();S&&(m.push(S.pid),S.children&&(d=d.concat(S.children)))}let b=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);b+=" "+m.join(" "),(0,v.exec)(b,{},(S,c,h)=>{if(S||h)f(S||new Error(h.toString()));else{const o=c.toString().split(`
`);for(let u=0;u<m.length;u++){const t=i.get(m[u]);t.load=parseFloat(o[u])}if(!w){f(new Error(`Root process ${I} not found`));return}n(w)}})};(0,v.exec)("which ps",{},(d,m,b)=>{if(d||b)if(process.platform!=="linux")f(d||new Error(b.toString()));else{const S=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);(0,v.exec)(S,{},(c,h,o)=>{c||o?f(c||new Error(o.toString())):(D(h,P),y())})}else{const S=m.toString().trim(),c="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${S} ${c}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,o,u)=>{h||u&&!u.includes("screen size is bogus")?f(h||new Error(u.toString())):(D(o,P),process.platform==="linux"?y():w?n(w):f(new Error(`Root process ${I} not found`)))})}})}})}e.listProcesses=M;function D(I,n){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=I.toString().split(`
`);for(const i of w){const P=f.exec(i.trim());P&&P.length===6&&n(parseInt(P[1]),parseInt(P[2]),P[5],parseFloat(P[3]),parseFloat(P[4]))}}}),define(Z[117],x([0,1,32,23,31,2,68,7,3,19]),function(K,e,v,L,M,D,I,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function i(d,m,b){return E({path:d,isDirectory:!1},m,b)}e.watchFile=i;function P(d,m,b){return E({path:d,isDirectory:!0},m,b)}e.watchFolder=P,e.CHANGE_BUFFER_DELAY=100;function E(d,m,b){if(f.isMacintosh&&(0,M.isEqualOrParent)(d.path,"/Volumes/"))return b(`Refusing to watch ${d.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.Disposable.None;const S=(0,n.basename)(d.path),c=new Map;let h=!1,o=[(0,D.toDisposable)(()=>{c.forEach(u=>(0,D.dispose)(u)),c.clear()})];try{const u=(0,v.watch)(d.path);o.push((0,D.toDisposable)(()=>{u.removeAllListeners(),u.close()}));const t=new Set;d.isDirectory&&w.Promises.readdir(d.path).then(l=>l.forEach(s=>t.add(s))),u.on("error",(l,s)=>{h||b(`Failed to watch ${d.path} for changes using fs.watch() (${l}, ${s})`)}),u.on("change",(l,s)=>{if(h)return;let r="";if(s&&(r=s.toString(),f.isMacintosh&&(r=(0,I.normalizeNFC)(r))),!r||l!=="change"&&l!=="rename")return;const a=d.isDirectory?(0,n.join)(d.path,r):d.path;if(d.isDirectory)if(l==="rename"){const g=c.get(a);g&&(0,D.dispose)(g);const p=setTimeout(async()=>{c.delete(a);const k=await w.Promises.exists(a);if(h)return;let R;k?t.has(r)?R="changed":(R="added",t.add(r)):(t.delete(r),R="deleted"),m(R,a)},e.CHANGE_BUFFER_DELAY);c.set(a,(0,D.toDisposable)(()=>clearTimeout(p)))}else{let g;t.has(r)?g="changed":(g="added",t.add(r)),m(g,a)}else if(l==="rename"||r!==S){const g=setTimeout(async()=>{const p=await w.Promises.exists(a);h||(p?(m("changed",a),o=[E(d,m,b)]):m("deleted",a))},e.CHANGE_BUFFER_DELAY);(0,D.dispose)(o),o=[(0,D.toDisposable)(()=>clearTimeout(g))]}else m("changed",a)})}catch(u){w.Promises.exists(d.path).then(t=>{t&&!h&&b(`Failed to watch ${d.path} for changes using fs.watch() (${u.toString()})`)})}return(0,D.toDisposable)(()=>{h=!0,o=(0,D.dispose)(o)})}async function y(d,m,b,S=512){const c=await w.Promises.open(d,"r"),h=Buffer.allocUnsafe(S),o=new L.CancellationTokenSource(b);let u,t=!1;const l=i(d,async s=>{if(s==="changed"){if(t)return;t=!0;try{for(;!o.token.isCancellationRequested;){const{bytesRead:r}=await w.Promises.read(c,h,0,S,null);if(!r||o.token.isCancellationRequested)break;m(h.slice(0,r))}}catch(r){u=new Error(r),o.dispose(!0)}finally{t=!1}}},s=>{u=new Error(s),o.dispose(!0)});return new Promise((s,r)=>{o.token.onCancellationRequested(async()=>{l.dispose(),await w.Promises.close(c),u?r(u):s()})})}e.watchFileContents=y}),define(Z[118],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[119],x([0,1,14,13,118]),function(K,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function D(){v.ipcMain.on(M.CONTEXT_MENU_CHANNEL,(n,f,w,i,P)=>{const E=I(n,i,w);E.popup({window:(0,L.withNullAsUndefined)(v.BrowserWindow.fromWebContents(n.sender)),x:P?P.x:void 0,y:P?P.y:void 0,positioningItem:P?P.positioningItem:void 0,callback:()=>{E&&n.sender.send(M.CONTEXT_MENU_CLOSE_CHANNEL,f)}})})}e.registerContextMenuListener=D;function I(n,f,w){const i=new v.Menu;return w.forEach(P=>{let E;P.type==="separator"?E=new v.MenuItem({type:P.type}):Array.isArray(P.submenu)?E=new v.MenuItem({submenu:I(n,f,P.submenu),label:P.label}):E=new v.MenuItem({label:P.label,type:P.type,accelerator:P.accelerator,checked:P.checked,enabled:P.enabled,visible:P.visible,click:(y,d,m)=>n.sender.send(f,P.id,m)}),i.append(E)}),i}});var he=this&&this.__decorate||function(K,e,v,L){var M=arguments.length,D=M<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,v):L,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(K,e,v,L);else for(var n=K.length-1;n>=0;n--)(I=K[n])&&(D=(M<3?I(D):M>3?I(e,v,D):I(e,v))||D);return M>3&&D&&Object.defineProperty(e,v,D),D};define(Z[35],x([0,1,30,9,18,23,47,17,4,2,110,25,13]),function(K,e,v,L,M,D,I,n,f,w,i,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function d(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(m=e.ResponseType||(e.ResponseType={}));function b(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var S;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(S||(S={}));class c{constructor(_){this.buffer=_,this.pos=0}read(_){const z=this.buffer.slice(this.pos,this.pos+_);return this.pos+=z.byteLength,z}}class h{constructor(){this.buffers=[]}get buffer(){return M.VSBuffer.concat(this.buffers)}write(_){this.buffers.push(_)}}var o;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object"})(o||(o={}));function u(H){const _=M.VSBuffer.alloc(4);return _.writeUInt32BE(H,0),_}function t(H){return H.read(4).readUInt32BE(0)}function l(H){const _=M.VSBuffer.alloc(1);return _.writeUInt8(H,0),_}const s={Undefined:l(o.Undefined),String:l(o.String),Buffer:l(o.Buffer),VSBuffer:l(o.VSBuffer),Array:l(o.Array),Object:l(o.Object)},r=typeof Buffer!="undefined";function a(H,_){if(typeof _=="undefined")H.write(s.Undefined);else if(typeof _=="string"){const z=M.VSBuffer.fromString(_);H.write(s.String),H.write(u(z.byteLength)),H.write(z)}else if(r&&Buffer.isBuffer(_)){const z=M.VSBuffer.wrap(_);H.write(s.Buffer),H.write(u(z.byteLength)),H.write(z)}else if(_ instanceof M.VSBuffer)H.write(s.VSBuffer),H.write(u(_.byteLength)),H.write(_);else if(Array.isArray(_)){H.write(s.Array),H.write(u(_.length));for(const z of _)a(H,z)}else{const z=M.VSBuffer.fromString(JSON.stringify(_));H.write(s.Object),H.write(u(z.byteLength)),H.write(z)}}function g(H){switch(H.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return H.read(t(H)).toString();case o.Buffer:return H.read(t(H)).buffer;case o.VSBuffer:return H.read(t(H));case o.Array:{const z=t(H),C=[];for(let A=0;A<z;A++)C.push(g(H));return C}case o.Object:return JSON.parse(H.read(t(H)).toString())}}class p{constructor(_,z,C=null,A=1e3){this.protocol=_,this.ctx=z,this.logger=C,this.timeoutDelay=A,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:200})}registerChannel(_,z){this.channels.set(_,z),setTimeout(()=>this.flushPendingRequests(_),0)}sendResponse(_){switch(_.type){case 200:{const z=this.send([_.type]);this.logger&&this.logger.logOutgoing(z,0,1,b(_.type));return}case 201:case 202:case 204:case 203:{const z=this.send([_.type,_.id],_.data);this.logger&&this.logger.logOutgoing(z,_.id,1,b(_.type),_.data);return}}}send(_,z=void 0){const C=new h;return a(C,_),a(C,z),this.sendBuffer(C.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch(z){return 0}}onRawMessage(_){const z=new c(_),C=g(z),A=g(z),W=C[0];switch(W){case 100:return this.logger&&this.logger.logIncoming(_.byteLength,C[1],1,`${d(W)}: ${C[2]}.${C[3]}`,A),this.onPromise({type:W,id:C[1],channelName:C[2],name:C[3],arg:A});case 102:return this.logger&&this.logger.logIncoming(_.byteLength,C[1],1,`${d(W)}: ${C[2]}.${C[3]}`,A),this.onEventListen({type:W,id:C[1],channelName:C[2],name:C[3],arg:A});case 101:return this.logger&&this.logger.logIncoming(_.byteLength,C[1],1,`${d(W)}`),this.disposeActiveRequest({type:W,id:C[1]});case 103:return this.logger&&this.logger.logIncoming(_.byteLength,C[1],1,`${d(W)}`),this.disposeActiveRequest({type:W,id:C[1]})}}onPromise(_){const z=this.channels.get(_.channelName);if(!z){this.collectPendingRequest(_);return}const C=new D.CancellationTokenSource;let A;try{A=z.call(this.ctx,_.name,_.arg,C.token)}catch(Y){A=Promise.reject(Y)}const W=_.id;A.then(Y=>{this.sendResponse({id:W,data:Y,type:201}),this.activeRequests.delete(_.id)},Y=>{Y instanceof Error?this.sendResponse({id:W,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.sendResponse({id:W,data:Y,type:203}),this.activeRequests.delete(_.id)});const B=(0,w.toDisposable)(()=>C.cancel());this.activeRequests.set(_.id,B)}onEventListen(_){const z=this.channels.get(_.channelName);if(!z){this.collectPendingRequest(_);return}const C=_.id,W=z.listen(this.ctx,_.name,_.arg)(B=>this.sendResponse({id:C,data:B,type:204}));this.activeRequests.set(_.id,W)}disposeActiveRequest(_){const z=this.activeRequests.get(_.id);z&&(z.dispose(),this.activeRequests.delete(_.id))}collectPendingRequest(_){let z=this.pendingRequests.get(_.channelName);z||(z=[],this.pendingRequests.set(_.channelName,z));const C=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.sendResponse({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);z.push({request:_,timeoutTimer:C})}flushPendingRequests(_){const z=this.pendingRequests.get(_);if(z){for(const C of z)switch(clearTimeout(C.timeoutTimer),C.request.type){case 100:this.onPromise(C.request);break;case 102:this.onEventListen(C.request);break}this.pendingRequests.delete(_)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(_=>_.dispose()),this.activeRequests.clear()}}e.ChannelServer=p;var k;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(k=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(_,z=null){this.protocol=_,this.isDisposed=!1,this.state=S.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new f.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(C=>this.onBuffer(C)),this.logger=z}getChannel(_){const z=this;return{call(C,A,W){return z.isDisposed?Promise.reject(n.canceled()):z.requestPromise(_,C,A,W)},listen(C,A){return z.isDisposed?Promise.reject(n.canceled()):z.requestEvent(_,C,A)}}}requestPromise(_,z,C,A=D.CancellationToken.None){const W=this.lastRequestId++,Y={id:W,type:100,channelName:_,name:z,arg:C};if(A.isCancellationRequested)return Promise.reject(n.canceled());let U;return new Promise((Q,J)=>{if(A.isCancellationRequested)return J(n.canceled());const re=()=>{const ue=de=>{switch(de.type){case 201:this.handlers.delete(W),Q(de.data);break;case 202:this.handlers.delete(W);const ve=new Error(de.data.message);ve.stack=de.data.stack,ve.name=de.data.name,J(ve);break;case 203:this.handlers.delete(W),J(de.data);break}};this.handlers.set(W,ue),this.sendRequest(Y)};let le=null;this.state===S.Idle?re():(le=(0,L.createCancelablePromise)(ue=>this.whenInitialized()),le.then(()=>{le=null,re()}));const ee=()=>{le?(le.cancel(),le=null):this.sendRequest({id:W,type:101}),J(n.canceled())},ae=A.onCancellationRequested(ee);U=(0,w.combinedDisposable)((0,w.toDisposable)(ee),ae),this.activeRequests.add(U)}).finally(()=>{this.activeRequests.delete(U)})}requestEvent(_,z,C){const A=this.lastRequestId++,B={id:A,type:102,channelName:_,name:z,arg:C};let Y=null;const U=new f.Emitter({onFirstListenerAdd:()=>{Y=(0,L.createCancelablePromise)(Q=>this.whenInitialized()),Y.then(()=>{Y=null,this.activeRequests.add(U),this.sendRequest(B)})},onLastListenerRemove:()=>{Y?(Y.cancel(),Y=null):(this.activeRequests.delete(U),this.sendRequest({id:A,type:103}))}}),N=Q=>U.fire(Q.data);return this.handlers.set(A,N),U.event}sendRequest(_){switch(_.type){case 100:case 102:{const z=this.send([_.type,_.id,_.channelName,_.name],_.arg);this.logger&&this.logger.logOutgoing(z,_.id,0,`${d(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const z=this.send([_.type,_.id]);this.logger&&this.logger.logOutgoing(z,_.id,0,d(_.type));return}}}send(_,z=void 0){const C=new h;return a(C,_),a(C,z),this.sendBuffer(C.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch(z){return 0}}onBuffer(_){const z=new c(_),C=g(z),A=g(z),W=C[0];switch(W){case 200:return this.logger&&this.logger.logIncoming(_.byteLength,0,0,b(W)),this.onResponse({type:C[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(_.byteLength,C[1],0,b(W),A),this.onResponse({type:C[0],id:C[1],data:A})}}onResponse(_){if(_.type===200){this.state=S.Idle,this._onDidInitialize.fire();return}const z=this.handlers.get(_.id);z&&z(_)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===S.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(_=>_.dispose()),this.activeRequests.clear()}}he([I.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class T{constructor(_){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new f.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new f.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,_(({protocol:z,onDidClientDisconnect:C})=>{f.Event.once(z.onMessage)(W=>{const B=new c(W),Y=g(B),U=new p(z,Y),N=new R(z);this.channels.forEach((J,re)=>U.registerChannel(re,J));const Q={channelServer:U,channelClient:N,ctx:Y};this._connections.add(Q),this._onDidAddConnection.fire(Q),C(()=>{U.dispose(),N.dispose(),this._connections.delete(Q),this._onDidRemoveConnection.fire(Q)})})})}get connections(){const _=[];return this._connections.forEach(z=>_.push(z)),_}getChannel(_,z){const C=this;return{call(A,W,B){let Y;if((0,E.isFunction)(z)){let N=(0,v.getRandomElement)(C.connections.filter(z));Y=N?Promise.resolve(N):f.Event.toPromise(f.Event.filter(C.onDidAddConnection,z))}else Y=z.routeCall(C,A,W);const U=Y.then(N=>N.channelClient.getChannel(_));return V(U).call(A,W,B)},listen(A,W){if((0,E.isFunction)(z))return C.getMulticastEvent(_,z,A,W);const B=z.routeEvent(C,A,W).then(Y=>Y.channelClient.getChannel(_));return V(B).listen(A,W)}}}getMulticastEvent(_,z,C,A){const W=this;let B=new w.DisposableStore;const Y=new f.Emitter({onFirstListenerAdd:()=>{B=new w.DisposableStore;const U=new f.EventMultiplexer,N=new Map,Q=re=>{const ee=re.channelClient.getChannel(_).listen(C,A),ae=U.add(ee);N.set(re,ae)},J=re=>{const le=N.get(re);!le||(le.dispose(),N.delete(re))};W.connections.filter(z).forEach(Q),f.Event.filter(W.onDidAddConnection,z)(Q,void 0,B),W.onDidRemoveConnection(J,void 0,B),U.event(Y.fire,Y,B),B.add(U)},onLastListenerRemove:()=>{B.dispose()}});return Y.event}registerChannel(_,z){this.channels.set(_,z),this._connections.forEach(C=>{C.channelServer.registerChannel(_,z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class O{constructor(_,z,C=null){const A=new h;a(A,z),_.send(A.buffer),this.channelClient=new R(_,C),this.channelServer=new p(_,z,C)}getChannel(_){return this.channelClient.getChannel(_)}registerChannel(_,z){this.channelServer.registerChannel(_,z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function V(H){return{call(_,z,C){return H.then(A=>A.call(_,z,C))},listen(_,z){const C=new f.Relay;return H.then(A=>C.input=A.listen(_,z)),C.event}}}e.getDelayedChannel=V;function ne(H){let _=!1;return{call(z,C,A){return _?H.call(z,C,A):(0,L.timeout)(0).then(()=>_=!0).then(()=>H.call(z,C,A))},listen(z,C){if(_)return H.listen(z,C);const A=new f.Relay;return(0,L.timeout)(0).then(()=>_=!0).then(()=>A.input=H.listen(z,C)),A.event}}}e.getNextTickChannel=ne;class se{constructor(_){this.fn=_}routeCall(_){return this.route(_)}routeEvent(_){return this.route(_)}async route(_){for(const z of _.connections)if(await Promise.resolve(this.fn(z.ctx)))return Promise.resolve(z);return await f.Event.toPromise(_.onDidAddConnection),await this.route(_)}}e.StaticRouter=se;var G;(function(H){function _(W,B){const Y=W,U=B&&B.disableMarshalling,N=new Map;for(const Q in Y)C(Q)&&N.set(Q,f.Event.buffer(Y[Q],!0));return new class{listen(Q,J,re){const le=N.get(J);if(le)return le;if(A(J)){const ee=Y[J];if(typeof ee=="function")return ee.call(Y,re)}throw new Error(`Event not found: ${J}`)}call(Q,J,re){const le=Y[J];if(typeof le=="function"){if(!U&&Array.isArray(re))for(let ee=0;ee<re.length;ee++)re[ee]=(0,i.revive)(re[ee]);return le.apply(Y,re)}throw new Error(`Method not found: ${J}`)}}}H.fromService=_;function z(W,B){const Y=B&&B.disableMarshalling;return new Proxy({},{get(U,N){if(typeof N=="string")return B?.properties?.has(N)?B.properties.get(N):A(N)?function(Q){return W.listen(N,Q)}:C(N)?W.listen(N):async function(...Q){let J;B&&!(0,E.isUndefinedOrNull)(B.context)?J=[B.context,...Q]:J=Q;const re=await W.call(N,J);return Y?re:(0,i.revive)(re)};throw new Error(`Property not found: ${String(N)}`)}})}H.toService=z;function C(W){return W[0]==="o"&&W[1]==="n"&&P.isUpperAsciiLetter(W.charCodeAt(2))}function A(W){return/^onDynamic/.test(W)&&P.isUpperAsciiLetter(W.charCodeAt(9))}})(G=e.ProxyChannel||(e.ProxyChannel={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){let _=H.toString();if(_!=="[object Object]")return _}return H}function j(H){return Array.isArray(H)?H.map(F):F(H)}function q(H,_,z,C,A,W,B){B=j(B);const Y=te[A],U=Y[C%Y.length];let N=[`%c[${H}]%c[${String(_).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(C).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(W)?(N=N.concat(B),N.push(")")):N.push(B),console.log.apply(console,N)}e.logWithColors=q;class ${constructor(_,z){this._outgoingPrefix=_,this._incomingPrefix=z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(_,z,C,A,W){this._totalOutgoing+=_,q(this._outgoingPrefix,this._totalOutgoing,_,z,C,A,W)}logIncoming(_,z,C,A,W){this._totalIncoming+=_,q(this._incomingPrefix,this._totalIncoming,_,z,C,A,W)}}e.IPCLogger=$}),define(Z[120],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(M,D){this.sender=M,this.onMessage=D}send(M){try{this.sender.send("vscode:message",M.buffer)}catch(D){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(Z[121],x([0,1,18,4,35]),function(K,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class D{constructor(f){this.port=f,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",w=>v.VSBuffer.wrap(w.data)),f.start()}send(f){this.port.postMessage(f.buffer)}disconnect(){this.port.close()}}e.Protocol=D;class I extends M.IPCClient{constructor(f,w){const i=new D(f);super(i,w);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=I}),define(Z[84],x([0,1,18,4,2,3,33,35]),function(K,e,v,L,M,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var f;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f=e.SocketCloseEventType||(e.SocketCloseEventType={}));let w=null;function i(){return w||(w=v.VSBuffer.alloc(0)),w}class P{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,a){if(r===0)return i();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const R=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=r),R}if(this._chunks[0].byteLength>r){const R=this._chunks[0].slice(0,r);return a&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),R}let g=v.VSBuffer.alloc(r),p=0,k=0;for(;r>0;){const R=this._chunks[k];if(R.byteLength>r){const T=R.slice(0,r);g.set(T,p),p+=r,a&&(this._chunks[k]=R.slice(r),this._totalLength-=r),r-=r}else g.set(R,p),p+=R.byteLength,a?(this._chunks.shift(),this._totalLength-=R.byteLength):k++,r-=R.byteLength}return g}}e.ChunkStream=P;var E;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.KeepAlive=4]="KeepAlive",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest"})(E||(E={}));var y;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",s[s.KeepAliveTime=5e3]="KeepAliveTime",s[s.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(y=e.ProtocolConstants||(e.ProtocolConstants={}));class d{constructor(r,a,g,p){this.type=r,this.id=a,this.ack=g,this.data=p,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends M.Disposable{constructor(r){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new P,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5);else{const g=this._state.messageType,p=this._state.id,k=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(g,p,k,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class b{constructor(r){this._isDisposed=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(r){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=v.VSBuffer.alloc(13);a.writeUInt8(r.type,0),a.writeUInt32BE(r.id,1),a.writeUInt32BE(r.ack,5),a.writeUInt32BE(r.data.byteLength,9),this._writeSoon(a,r.data)}_bufferAdd(r,a){const g=this._totalLength===0;return this._data.push(r,a),this._totalLength+=r.byteLength+a.byteLength,g}_bufferTake(){const r=v.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,a){this._bufferAdd(r,a)&&D.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class S extends M.Disposable{constructor(r){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new b(this._socket)),this._socketReader=this._register(new m(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new d(1,0,0,r))}}e.Protocol=S;class c extends n.IPCClient{constructor(r,a,g=null){super(r,a,g);this.protocol=r}static fromSocket(r,a){return new c(new S(r),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=c;class h{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,I.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=h;class o{constructor(r){this.data=r,this.next=null}}class u{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],a=0,g=this._first;for(;g;)r[a++]=g.data,g=g.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const a=new o(r);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class t{constructor(){this.lastRuns=[];const r=Date.now();for(let a=0;a<t._HISTORY_LENGTH;a++)this.lastRuns[a]=r-1e3*a;setInterval(()=>{for(let a=t._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const r=Date.now(),a=(1+t._HISTORY_LENGTH)*1e3;let g=0;for(let p=0;p<t._HISTORY_LENGTH;p++)r-this.lastRuns[p]<=a&&g++;return 1-g/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class l{constructor(r,a=null,g=t.getInstance()){this._onControlMessage=new h,this.onControlMessage=this._onControlMessage.event,this._onMessage=new h,this.onMessage=this._onMessage.event,this._onDidDispose=new h,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new h,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new h,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=g,this._isReconnecting=!1,this._outgoingUnackMsg=new u,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=r,this._socketWriter=new b(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(p=>this._receiveMessage(p))),this._socketDisposables.push(this._socket.onClose(p=>this._onSocketClose.fire(p))),a&&this._socketReader.acceptChunk(a),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,M.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new d(5,0,0,i());this._socketWriter.write(r),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const r=Date.now()-this._socketWriter.lastWriteTime;if(r>=5e3){const a=new d(4,0,0,i());this._socketWriter.write(a),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-r+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const r=Date.now()-this._socketReader.lastReadTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-r,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,a){this._isReconnecting=!0,this._socketDisposables=(0,M.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=r,this._socketWriter=new b(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(g=>this._receiveMessage(g))),this._socketDisposables.push(this._socket.onClose(g=>this._onSocketClose.fire(g))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1;const r=this._outgoingUnackMsg.toArray();for(let a=0,g=r.length;a<g;a++)this._socketWriter.write(r[a]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(r.type===1){if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new d(6,0,0,i())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data)}else if(r.type===2)this._onControlMessage.fire(r.data);else if(r.type===5)this._onDidDispose.fire();else if(r.type===6){const a=this._outgoingUnackMsg.toArray();for(let g=0,p=a.length;g<p;g++)this._socketWriter.write(a[g]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const g=new d(1,a,this._incomingAckId,r);this._outgoingUnackMsg.push(g),this._isReconnecting||(this._socketWriter.write(g),this._recvAckCheck())}sendControl(r){const a=new d(2,0,0,r);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),a=Date.now()-r.writtenTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-a,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new d(3,0,this._incomingAckId,i());this._socketWriter.write(r)}}e.PersistentProtocol=l}),define(Z[122],x([0,1,14,18,4,2,35,120]),function(K,e,v,L,M,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function f(i,P){const E=M.Event.fromNodeEventEmitter(v.ipcMain,P,(d,m)=>({event:d,message:m})),y=M.Event.filter(E,({event:d})=>d.sender.id===i);return M.Event.map(y,({message:d})=>d&&L.VSBuffer.wrap(d))}class w extends I.IPCServer{constructor(){super(w.getOnDidClientConnect())}static getOnDidClientConnect(){const P=M.Event.fromNodeEventEmitter(v.ipcMain,"vscode:hello",({sender:E})=>E);return M.Event.map(P,E=>{const y=E.id,d=w.Clients.get(y);d&&d.dispose();const m=new M.Emitter;w.Clients.set(y,(0,D.toDisposable)(()=>m.fire()));const b=f(y,"vscode:message"),S=M.Event.any(M.Event.signal(f(y,"vscode:disconnect")),m.event);return{protocol:new n.Protocol(E,b),onDidClientDisconnect:S}})}}e.Server=w,w.Clients=new Map}),define(Z[85],x([0,1,14,4,28,121]),function(K,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class I extends D.Client{constructor(w,i){super({addEventListener:(P,E)=>w.addListener(P,E),removeEventListener:(P,E)=>w.removeListener(P,E),postMessage:P=>w.postMessage(P),start:()=>w.start(),close:()=>w.close()},i)}}e.Client=I;async function n(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const w=(0,M.generateUuid)();f.webContents.send("vscode:createMessageChannel",w);const i=L.Event.fromNodeEventEmitter(v.ipcMain,"vscode:createMessageChannelResult",(E,y)=>({nonce:y,port:E.ports[0]})),{port:P}=await L.Event.toPromise(L.Event.once(L.Event.filter(i,E=>E.nonce===w)));return P}e.connect=n}),define(Z[86],x([0,1,9,4,2,13]),function(K,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var I;(function(P){P[P.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(I=e.StorageHint||(e.StorageHint={}));function n(P){const E=P;return E?.changed instanceof Map||E?.deleted instanceof Set}e.isStorageItemsChangeEvent=n;var f;(function(P){P[P.None=0]="None",P[P.Initialized=1]="Initialized",P[P.Closed=2]="Closed"})(f||(f={}));class w extends M.Disposable{constructor(E,y=Object.create(null)){super();this.database=E,this.options=y,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=f.None,this.cache=new Map,this.flushDelayer=new v.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(E=>this.onDidChangeItemsExternal(E)))}onDidChangeItemsExternal(E){E.changed?.forEach((y,d)=>this.accept(d,y)),E.deleted?.forEach(y=>this.accept(y,void 0))}accept(E,y){if(this.state===f.Closed)return;let d=!1;(0,D.isUndefinedOrNull)(y)?d=this.cache.delete(E):this.cache.get(E)!==y&&(this.cache.set(E,y),d=!0),d&&this._onDidChangeStorage.fire(E)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===f.None&&(this.state=f.Initialized,this.options.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(E,y){const d=this.cache.get(E);return(0,D.isUndefinedOrNull)(d)?y:d}getBoolean(E,y){const d=this.get(E);return(0,D.isUndefinedOrNull)(d)?y:d==="true"}getNumber(E,y){const d=this.get(E);return(0,D.isUndefinedOrNull)(d)?y:parseInt(d,10)}async set(E,y){if(this.state===f.Closed)return;if((0,D.isUndefinedOrNull)(y))return this.delete(E);const d=String(y);if(this.cache.get(E)!==d)return this.cache.set(E,d),this.pendingInserts.set(E,d),this.pendingDeletes.delete(E),this._onDidChangeStorage.fire(E),this.flushDelayer.trigger(()=>this.flushPending())}async delete(E){if(!(this.state===f.Closed||!this.cache.delete(E)))return this.pendingDeletes.has(E)||this.pendingDeletes.add(E),this.pendingInserts.delete(E),this._onDidChangeStorage.fire(E),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=f.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(E){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const E={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(E).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(E=>this.whenFlushedCallbacks.push(E))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class i{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(E){E.insert&&E.insert.forEach((y,d)=>this.items.set(d,y)),E.delete&&E.delete.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=i}),define(Z[123],x([0,1,9,4,37,7,19]),function(K,e,v,L,M,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class n{constructor(i,P=Object.create(null)){this.path=i,this.options=P,this.name=(0,D.basename)(this.path),this.logger=new f(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return L.Event.None}async getItems(){const i=await this.whenConnected,P=new Map;return(await this.all(i,"SELECT * FROM ItemTable")).forEach(y=>P.set(y.key,y.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${P.size} rows`),P}async updateItems(i){const P=await this.whenConnected;return this.doUpdateItems(P,i)}doUpdateItems(i,P){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${P.insert?(0,M.mapToString)(P.insert):"0"}), delete(${P.delete?(0,M.setToString)(P.delete):"0"})`),this.transaction(i,()=>{const E=P.insert,y=P.delete;if(E&&E.size>0){const d=[];d.push([]);let m=0;E.forEach((b,S)=>{let c=d[m];c.length>n.MAX_HOST_PARAMETERS&&(m++,c=[],d.push(c)),c.push(S,b)}),d.forEach(b=>{this.prepare(i,`INSERT INTO ItemTable VALUES ${new Array(b.length/2).fill("(?,?)").join(",")}`,S=>S.run(b),()=>{const S=[];let c=0;return E.forEach((h,o)=>{S.push(o),c+=h.length}),`Keys: ${S.join(", ")} Length: ${c}`})})}if(y&&y.size){const d=[];d.push([]);let m=0;y.forEach(b=>{let S=d[m];S.length>n.MAX_HOST_PARAMETERS&&(m++,S=[],d.push(S)),S.push(b)}),d.forEach(b=>{this.prepare(i,`DELETE FROM ItemTable WHERE key IN (${new Array(b.length).fill("?").join(",")})`,S=>S.run(b),()=>{const S=[];return y.forEach(c=>{S.push(c)}),`Keys: ${S.join(", ")}`})})}})}async close(i){this.logger.trace(`[storage ${this.name}] close()`);const P=await this.whenConnected;return this.doClose(P,i)}doClose(i,P){return new Promise((E,y)=>{i.db.close(d=>(d&&this.handleSQLiteError(i,`[storage ${this.name}] close(): ${d}`),this.path===n.IN_MEMORY_PATH?E():!i.isErroneous&&!i.isInMemory?this.backup().then(E,m=>(this.logger.error(`[storage ${this.name}] backup(): ${m}`),E())):typeof P=="function"?I.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(m=>{const b=()=>this.doClose(m,void 0);return this.doUpdateItems(m,{insert:P()}).then(()=>b(),S=>(b(),Promise.reject(S)))})).then(E,y):y(d||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const i=this.toBackupPath(this.path);return I.Promises.copy(this.path,i,{preserveSymlinks:!1})}toBackupPath(i){return`${i}.backup`}async checkIntegrity(i){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${i})`);const P=await this.whenConnected,E=await this.get(P,i?"PRAGMA integrity_check":"PRAGMA quick_check"),y=i?E.integrity_check:E.quick_check;return P.isErroneous?`${y} (last error: ${P.lastError})`:P.isInMemory?`${y} (in-memory!)`:y}async connect(i,P=!0){this.logger.trace(`[storage ${this.name}] open(${i}, retryOnBusy: ${P})`);try{return await this.doConnect(i)}catch(E){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${E}`),E.code==="SQLITE_BUSY"&&P)return await(0,v.timeout)(n.BUSY_OPEN_TIMEOUT),this.connect(i,!1);try{await I.Promises.unlink(i);try{await I.Promises.rename(this.toBackupPath(i),i)}catch(y){}return await this.doConnect(i)}catch(y){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${y}`),this.doConnect(n.IN_MEMORY_PATH)}}}handleSQLiteError(i,P){i.isErroneous=!0,i.lastError=P,this.logger.error(P)}doConnect(i){return new Promise((P,E)=>{new Promise((y,d)=>{K(["@vscode/sqlite3"],y,d)}).then(y=>{const d={db:new(this.logger.isTracing?y.verbose().Database:y.Database)(i,m=>m?d.db?d.db.close(()=>E(m)):E(m):this.exec(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>P(d),b=>d.db.close(()=>E(b)))),isInMemory:i===n.IN_MEMORY_PATH};d.db.on("error",m=>this.handleSQLiteError(d,`[storage ${this.name}] Error (event): ${m}`)),this.logger.isTracing&&d.db.on("trace",m=>this.logger.trace(`[storage ${this.name}] Trace (event): ${m}`))},E)})}exec(i,P){return new Promise((E,y)=>{i.db.exec(P,d=>d?(this.handleSQLiteError(i,`[storage ${this.name}] exec(): ${d}`),y(d)):E())})}get(i,P){return new Promise((E,y)=>{i.db.get(P,(d,m)=>d?(this.handleSQLiteError(i,`[storage ${this.name}] get(): ${d}`),y(d)):E(m))})}all(i,P){return new Promise((E,y)=>{i.db.all(P,(d,m)=>d?(this.handleSQLiteError(i,`[storage ${this.name}] all(): ${d}`),y(d)):E(m))})}transaction(i,P){return new Promise((E,y)=>{i.db.serialize(()=>{i.db.run("BEGIN TRANSACTION"),P(),i.db.run("END TRANSACTION",d=>d?(this.handleSQLiteError(i,`[storage ${this.name}] transaction(): ${d}`),y(d)):E())})})}prepare(i,P,E,y){const d=i.db.prepare(P),m=b=>{this.handleSQLiteError(i,`[storage ${this.name}] prepare(): ${b} (${P}). Details: ${y()}`)};d.on("error",m),E(d),d.finalize(b=>{b&&m(b),d.removeListener("error",m)})}}e.SQLiteStorageDatabase=n,n.IN_MEMORY_PATH=":memory:",n.BUSY_OPEN_TIMEOUT=2e3,n.MAX_HOST_PARAMETERS=256;class f{constructor(i){i&&typeof i.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.logTrace=i.logTrace),i&&typeof i.logError=="function"&&(this.logError=i.logError)}get isTracing(){return!!this.logTrace}trace(i){this.logTrace&&this.logTrace(i)}error(i){this.logError&&this.logError(i)}}f.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[124],x([12,11]),function(K,e){return K.create("vs/base/common/date",e)}),define(Z[125],x([0,1,124]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,M=L*60,D=M*24,I=D*7,n=D*30,f=D*365;function w(P,E){typeof P!="number"&&(P=P.getTime());const y=Math.round((new Date().getTime()-P)/1e3);if(y<-30)return(0,v.localize)(0,null,w(new Date().getTime()+y*1e3,!1));if(y<30)return(0,v.localize)(1,null);let d;return y<L?(d=y,E?d===1?(0,v.localize)(2,null,d):(0,v.localize)(3,null,d):d===1?(0,v.localize)(4,null,d):(0,v.localize)(5,null,d)):y<M?(d=Math.floor(y/L),E?d===1?(0,v.localize)(6,null,d):(0,v.localize)(7,null,d):d===1?(0,v.localize)(8,null,d):(0,v.localize)(9,null,d)):y<D?(d=Math.floor(y/M),E?d===1?(0,v.localize)(10,null,d):(0,v.localize)(11,null,d):d===1?(0,v.localize)(12,null,d):(0,v.localize)(13,null,d)):y<I?(d=Math.floor(y/D),E?d===1?(0,v.localize)(14,null,d):(0,v.localize)(15,null,d):d===1?(0,v.localize)(16,null,d):(0,v.localize)(17,null,d)):y<n?(d=Math.floor(y/I),E?d===1?(0,v.localize)(18,null,d):(0,v.localize)(19,null,d):d===1?(0,v.localize)(20,null,d):(0,v.localize)(21,null,d)):y<f?(d=Math.floor(y/n),E?d===1?(0,v.localize)(22,null,d):(0,v.localize)(23,null,d):d===1?(0,v.localize)(24,null,d):(0,v.localize)(25,null,d)):(d=Math.floor(y/f),E?d===1?(0,v.localize)(26,null,d):(0,v.localize)(27,null,d):d===1?(0,v.localize)(28,null,d):(0,v.localize)(29,null,d))}e.fromNow=w;function i(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(Z[126],x([12,11]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(Z[60],x([0,1,30,13,126]),function(K,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function D(w,i){return i&&(w.stack||w.stacktrace)?M.localize(0,null,n(w),I(w.stack)||I(w.stacktrace)):n(w)}function I(w){return Array.isArray(w)?w.join(`
`):w}function n(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?M.localize(1,null,w.message):w.message||M.localize(2,null)}function f(w=null,i=!1){if(!w)return M.localize(3,null);if(Array.isArray(w)){const P=v.coalesce(w),E=f(P[0],i);return P.length>1?M.localize(4,null,E,P.length):E}if(L.isString(w))return w;if(w.detail){const P=w.detail;if(P.error)return D(P.error,i);if(P.exception)return D(P.exception,i)}return w.stack?D(w,i):w.message?w.message:M.localize(5,null)}e.toErrorMessage=f}),define(Z[127],x([12,11]),function(K,e){return K.create("vs/base/common/keybindingLabels",e)}),define(Z[128],x([0,1,127]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class L{constructor(I,n,f=n){this.modifierLabels=[null],this.modifierLabels[2]=I,this.modifierLabels[1]=n,this.modifierLabels[3]=f}toLabel(I,n,f){if(n.length===0)return null;const w=[];for(let i=0,P=n.length;i<P;i++){const E=n[i],y=f(E);if(y===null)return null;w[i]=M(E,y,this.modifierLabels[I])}return w.join(" ")}}e.ModifierLabelProvider=L,e.UILabelProvider=new L({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:v.localize(0,null),shiftKey:v.localize(1,null),altKey:v.localize(2,null),metaKey:v.localize(3,null),separator:"+"},{ctrlKey:v.localize(4,null),shiftKey:v.localize(5,null),altKey:v.localize(6,null),metaKey:v.localize(7,null),separator:"+"}),e.AriaLabelProvider=new L({ctrlKey:v.localize(8,null),shiftKey:v.localize(9,null),altKey:v.localize(10,null),metaKey:v.localize(11,null),separator:"+"},{ctrlKey:v.localize(12,null),shiftKey:v.localize(13,null),altKey:v.localize(14,null),metaKey:v.localize(15,null),separator:"+"},{ctrlKey:v.localize(16,null),shiftKey:v.localize(17,null),altKey:v.localize(18,null),metaKey:v.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new L({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new L({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function M(D,I,n){if(I===null)return"";const f=[];return D.ctrlKey&&f.push(n.ctrlKey),D.shiftKey&&f.push(n.shiftKey),D.altKey&&f.push(n.altKey),D.metaKey&&f.push(n.metaKey),I!==""&&f.push(I),f.join(n.separator)}}),define(Z[129],x([12,11]),function(K,e){return K.create("vs/base/node/processes",e)}),define(Z[70],x([0,1,41,31,10,44,7,3,33,78,13,81,19,129]),function(K,e,v,L,M,D,I,n,f,w,i,P,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return w.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return w.TerminateResponseCode}});function d(u){switch(u){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function m(u,t){if(n.isWindows)try{const l={stdio:["pipe","pipe","ignore"]};t&&(l.cwd=t);const s=v.execFile("taskkill",["/T","/F","/PID",u.pid.toString()],l);return new Promise(r=>{s.once("error",a=>{r({success:!1,error:a})}),s.once("exit",(a,g)=>{r(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(l){return Promise.resolve({success:!1,error:l,code:l.status?d(l.status):1})}else if(n.isLinux||n.isMacintosh)try{const l=M.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(s=>{v.execFile(l,[u.pid.toString()],{encoding:"utf8",shell:!0},(r,a,g)=>{s(r?{success:!1,error:r}:{success:!0})})})}catch(l){return Promise.resolve({success:!1,error:l})}else u.kill("SIGKILL");return Promise.resolve({success:!0})}function b(u=f.env){return u.comspec||"cmd.exe"}e.getWindowsShell=b;class S{constructor(t,l,s,r){if(l!==void 0&&s!==void 0&&r!==void 0)this.cmd=t,this.args=l,this.shell=s,this.options=r;else{const a=t;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(f.env).forEach(g=>{a[g]=f.env[g]}),Object.keys(this.options.env).forEach(g=>{a[g]=this.options.env[g]}),this.options.env=a}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const l=t.lastIndexOf(I.sep);return l!==-1&&(t=t.substring(l+1)),S.WellKnowCommands[t]?t:"other"}start(t){return n.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(f.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(l=>{let s,r;const a=new Promise((g,p)=>{s=g,r=p});if(l){let g=this.cmd;this.args&&(g=g+" "+this.args.join(" ")),this.childProcess=v.exec(g,this.options,(p,k,R)=>{this.childProcess=null;const T=p;T&&T.killed?r({killed:this.terminateRequested,stdout:k.toString(),stderr:R.toString()}):this.handleExec(s,t,p,k,R)})}else{let g=null;const p=k=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(k,s,t,r);const R={terminated:this.terminateRequested};i.isNumber(k)&&(R.cmdCode=k),s(R)};if(this.shell&&n.isWindows){const k=D.deepClone(this.options);k.windowsVerbatimArguments=!0,k.detached=!1;let R=!1,T=!1;const O=[];let V=this.ensureQuotes(this.cmd);O.push(V.value),R=V.quoted,this.args&&this.args.forEach(se=>{V=this.ensureQuotes(se),O.push(V.value),T=T&&V.quoted});const ne=["/s","/c"];R?T?ne.push('"'+O.join(" ")+'"'):O.length>1?ne.push('"'+O[0]+'" '+O.slice(1).join(" ")):ne.push('"'+O[0]+'"'):ne.push(O.join(" ")),g=v.spawn(b(),ne,k)}else this.cmd&&(g=v.spawn(this.cmd,this.args,this.options));g&&(this.childProcess=g,this.childProcessPromise=Promise.resolve(g),this.pidResolve&&(this.pidResolve(i.isNumber(g.pid)?g.pid:-1),this.pidResolve=void 0),g.on("error",k=>{this.childProcess=null,r({terminated:this.terminateRequested,error:k})}),g.pid&&(this.childProcess.on("close",p),this.handleSpawn(g,s,t,r,!0)))}return a})}handleClose(t,l,s,r){}ensureQuotes(t){return S.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,m(t,this.options.cwd).then(l=>(l.success&&(this.childProcess=null),l))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!n.isWindows)return t(!1);const l=v.spawn(b(),["/s","/c"]);l.on("error",s=>t(!0)),l.on("exit",s=>t(!1))})}}e.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class c extends S{constructor(t,l,s,r){super(t,l,s,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,l,s,r,a){[r,a].forEach((g,p)=>{const k=new P.LineDecoder;k.write(g).forEach(O=>{l({line:O,source:p===0?0:1})});const T=k.end();T&&l({line:T,source:p===0?0:1})}),t({terminated:this.terminateRequested,error:s})}handleSpawn(t,l,s,r,a){const g=new P.LineDecoder,p=new P.LineDecoder;t.stdout.on("data",k=>{g.write(k).forEach(T=>s({line:T,source:0}))}),t.stderr.on("data",k=>{p.write(k).forEach(T=>s({line:T,source:1}))}),this.stdoutLineDecoder=g,this.stderrLineDecoder=p}handleClose(t,l,s,r){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&s({line:a,source:0});const g=this.stderrLineDecoder?this.stderrLineDecoder.end():null;g&&s({line:g,source:1})}}e.LineProcess=c;function h(u){let t=[],l=!1;const s=function(r){if(l){t.push(r);return}(!u.send(r,g=>{if(g&&console.error(g),l=!1,t.length>0){const p=t.slice(0);t=[],p.forEach(k=>s(k))}})||n.isWindows)&&(l=!0)};return{send:s}}e.createQueuedSender=h;var o;(function(u){async function t(l,s,r){if(I.isAbsolute(l))return l;if(s===void 0&&(s=f.cwd()),I.dirname(l)!=="."||(r===void 0&&i.isString(f.env.PATH)&&(r=f.env.PATH.split(I.delimiter)),r===void 0||r.length===0))return I.join(s,l);async function g(p){if(await E.Promises.exists(p)){let k;try{k=await E.Promises.stat(p)}catch(R){R.message.startsWith("EACCES")&&(k=await E.Promises.lstat(p))}return k?!k.isDirectory():!1}return!1}for(let p of r){let k;if(I.isAbsolute(p)?k=I.join(p,l):k=I.join(s,p,l),await g(k))return k;let R=k+".com";if(await g(R)||(R=k+".exe",await g(R)))return R}return I.join(s,l)}u.findExecutable=t})(o=e.win32||(e.win32={}))}),define(Z[130],x([0,1,26,3,116,70]),function(K,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function I(y,d){return y===1?L.isWindows?P():D.getWindowsShell(d):w(y,d)}e.getSystemShell=I;function n(y,d){return y===1?L.isWindows?E(d):D.getWindowsShell(d):w(y,d)}e.getSystemShellSync=n;let f=null;function w(y,d){if(L.isLinux&&y===2||L.isMacintosh&&y===3)return"/bin/bash";if(!f){let m;if(L.isWindows)m="/bin/bash";else{if(m=d.SHELL,!m)try{m=(0,v.userInfo)().shell}catch(b){}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}f=m}return f}let i=null;async function P(){return i||(i=(await(0,M.getFirstAvailablePowerShellInstallation)()).exePath),i}function E(y){if(i)return i;const d=L.isWindows&&parseFloat((0,v.release)())>=10,m=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${y.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?b:D.getWindowsShell(y)}}),define(Z[87],x([0,1,41,9,18,23,109,17,4,2,44,3,70,35]),function(K,e,v,L,M,D,I,n,f,w,i,P,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends y.ChannelServer{constructor(S){super({send:c=>{try{process.send&&process.send(c.buffer.toString("base64"))}catch(h){}},onMessage:f.Event.fromNodeEventEmitter(process,"message",c=>M.VSBuffer.wrap(Buffer.from(c,"base64")))},S);process.once("disconnect",()=>this.dispose())}}e.Server=d;class m{constructor(S,c){this.modulePath=S,this.options=c,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new f.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=c&&c.timeout?c.timeout:6e4;this.disposeDelayer=new L.Delayer(h),this.child=null,this._client=null}getChannel(S){const c=this;return{call(h,o,u){return c.requestPromise(S,h,o,u)},listen(h,o){return c.requestEvent(S,h,o)}}}requestPromise(S,c,h,o=D.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(n.canceled());this.disposeDelayer.cancel();const u=this.getCachedChannel(S),t=(0,L.createCancelablePromise)(r=>u.call(c,h,r)),l=o.onCancellationRequested(()=>t.cancel()),s=(0,w.toDisposable)(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{l.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(S,c,h){if(!this.disposeDelayer)return f.Event.None;this.disposeDelayer.cancel();let o;const u=new f.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(S).listen(c,h)(u.fire,u),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return u.event}get client(){if(!this._client){const S=this.options&&this.options.args?this.options.args:[],c=Object.create(null);c.env={...(0,i.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(c.env={...c.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(c.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),P.isMacintosh&&c.env&&delete c.env.DYLD_LIBRARY_PATH,this.child=(0,v.fork)(this.modulePath,S,c);const h=new f.Emitter;f.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,I.isRemoteConsoleLog)(a)){(0,I.log)(a,`IPC Library: ${this.options.serverName}`);return}h.fire(M.VSBuffer.wrap(Buffer.from(a,"base64")))});const u=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,t=a=>this.child&&this.child.connected&&u.send(a.buffer.toString("base64")),l=h.event,s={send:t,onMessage:l};this._client=new y.ChannelClient(s);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,g)=>{process.removeListener("exit",r),this.activeRequests.forEach(p=>(0,w.dispose)(p)),this.activeRequests.clear(),a!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+g),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:g})})}return this._client}getCachedChannel(S){let c=this.channels.get(S);return c||(c=this.client.getChannel(S),this.channels.set(S,c)),c}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=m}),define(Z[131],x([12,11]),function(K,e){return K.create("vs/code/electron-main/app",e)}),define(Z[132],x([12,11]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[133],x([12,11]),function(K,e){return K.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[134],x([12,11]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(Z[135],x([12,11]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(Z[136],x([12,11]),function(K,e){return K.create("vs/platform/environment/node/shellEnv",e)}),define(Z[137],x([12,11]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[138],x([12,11]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[139],x([12,11]),function(K,e){return K.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[140],x([12,11]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(Z[141],x([12,11]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(Z[142],x([12,11]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(Z[143],x([12,11]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[144],x([12,11]),function(K,e){return K.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[145],x([12,11]),function(K,e){return K.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[146],x([12,11]),function(K,e){return K.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[147],x([12,11]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(Z[148],x([12,11]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[149],x([12,11]),function(K,e){return K.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[150],x([12,11]),function(K,e){return K.create("vs/platform/windows/electron-main/window",e)}),define(Z[151],x([12,11]),function(K,e){return K.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[152],x([12,11]),function(K,e){return K.create("vs/platform/workspaces/common/workspaces",e)}),define(Z[153],x([12,11]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[154],x([12,11]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[155],x([0,1,4,2]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class M{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(n,f,w){switch(f){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:w[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:w[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:w[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:w[0],port:w[1],subId:w[2]}))}throw new Error("Method not implemented.")}listen(n,f,w){switch(f){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=M,M.ChannelName="extensionhostdebugservice";class D extends L.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,f,w){this.channel.call("attach",[n,f,w])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,f){this.channel.call("terminate",[n,f])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,f){return this.channel.call("openExtensionDevelopmentHostWindow",[n,f])}}e.ExtensionHostDebugChannelClient=D}),define(Z[156],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class v{constructor(I){this.driver=I}listen(I,n){throw new Error(`No event found: ${n}`)}call(I,n,f){switch(n){case"click":return this.driver.click(f[0],f[1],f[2]);case"doubleClick":return this.driver.doubleClick(f);case"setValue":return this.driver.setValue(f[0],f[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(f);case"getElements":return this.driver.getElements(f[0],f[1]);case"getElementXY":return this.driver.getElementXY(f[0],f[1],f[2]);case"typeInEditor":return this.driver.typeInEditor(f[0],f[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(f);case"writeInTerminal":return this.driver.writeInTerminal(f[0],f[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${n}`)}}e.WindowDriverChannel=v;class L{constructor(I){this.channel=I}click(I,n,f){return this.channel.call("click",[I,n,f])}doubleClick(I){return this.channel.call("doubleClick",I)}setValue(I,n){return this.channel.call("setValue",[I,n])}getTitle(){return this.channel.call("getTitle")}isActiveElement(I){return this.channel.call("isActiveElement",I)}getElements(I,n){return this.channel.call("getElements",[I,n])}getElementXY(I,n,f){return this.channel.call("getElementXY",[I,n,f])}typeInEditor(I,n){return this.channel.call("typeInEditor",[I,n])}getTerminalBuffer(I){return this.channel.call("getTerminalBuffer",I)}writeInTerminal(I,n){return this.channel.call("writeInTerminal",[I,n])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=L;class M{constructor(I){this.channel=I}registerWindowDriver(I){return this.channel.call("registerWindowDriver",I)}reloadWindowDriver(I){return this.channel.call("reloadWindowDriver",I)}}e.WindowDriverRegistryChannelClient=M}),define(Z[157],x([0,1,125,47,10,7,33,15,8]),function(K,e,v,L,M,D,I,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class w{constructor(m,b,S){this._args=m,this.paths=b,this.productService=S}get appRoot(){return(0,D.dirname)(M.FileAccess.asFileUri("",K).fsPath)}get userHome(){return f.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return f.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,n.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,n.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const m=(0,v.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",m)}return this.args.logsPath}get userDataSyncLogResource(){return f.URI.file((0,D.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,n.joinPath)(f.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return f.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return f.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,n.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,n.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=I.env.VSCODE_PORTABLE;return m?f.URI.file((0,D.join)(m,"argv.json")):(0,n.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,n.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,D.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,D.resolve)(m):(0,D.normalize)((0,D.join)(M.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const m=this.args["extensions-download-dir"];return m?(0,D.resolve)(m):(0,D.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,D.resolve)(m);const b=I.env.VSCODE_EXTENSIONS;if(b)return b;const S=I.env.VSCODE_PORTABLE;return S?(0,D.join)(S,"extensions"):(0,n.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(b=>/^[^:/?#]+?:\/\//.test(b)?f.URI.parse(b):f.URI.file((0,D.normalize)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?f.URI.parse(m):f.URI.file((0,D.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!I.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,n.joinPath)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return f.URI.file((0,D.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([L.memoize],w.prototype,"appRoot",null),he([L.memoize],w.prototype,"userHome",null),he([L.memoize],w.prototype,"userDataPath",null),he([L.memoize],w.prototype,"appSettingsHome",null),he([L.memoize],w.prototype,"tmpDir",null),he([L.memoize],w.prototype,"userRoamingDataHome",null),he([L.memoize],w.prototype,"settingsResource",null),he([L.memoize],w.prototype,"userDataSyncHome",null),he([L.memoize],w.prototype,"userDataSyncLogResource",null),he([L.memoize],w.prototype,"sync",null),he([L.memoize],w.prototype,"machineSettingsResource",null),he([L.memoize],w.prototype,"globalStorageHome",null),he([L.memoize],w.prototype,"workspaceStorageHome",null),he([L.memoize],w.prototype,"keybindingsResource",null),he([L.memoize],w.prototype,"keyboardLayoutResource",null),he([L.memoize],w.prototype,"argvResource",null),he([L.memoize],w.prototype,"snippetsHome",null),he([L.memoize],w.prototype,"isExtensionDevelopment",null),he([L.memoize],w.prototype,"untitledWorkspacesHome",null),he([L.memoize],w.prototype,"installSourcePath",null),he([L.memoize],w.prototype,"builtinExtensionsPath",null),he([L.memoize],w.prototype,"extensionsPath",null),he([L.memoize],w.prototype,"extensionDevelopmentLocationURI",null),he([L.memoize],w.prototype,"extensionDevelopmentKind",null),he([L.memoize],w.prototype,"extensionTestsLocationURI",null),he([L.memoize],w.prototype,"debugExtensionHost",null),he([L.memoize],w.prototype,"serviceMachineIdResource",null),he([L.memoize],w.prototype,"telemetryLogResource",null),he([L.memoize],w.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=w;function i(d,m){return y(d["inspect-extensions"],d["inspect-brk-extensions"],5870,m,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=i;function P(d,m){return y(d["inspect-search"],d["inspect-brk-search"],5876,m,d.extensionEnvironment)}e.parseSearchPort=P;function E(d,m){return y(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,m,d.extensionEnvironment)}e.parsePtyHostPort=E;function y(d,m,b,S,c,h){const u=Number(m||d)||(S?null:b),t=u?Boolean(!!m):!1;let l;if(h)try{l=JSON.parse(h)}catch{}return{port:u,break:t,debugId:c,env:l}}}),define(Z[88],x([0,1,240,3,134]),function(K,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const D={o:(0,M.localize)(0,null),e:(0,M.localize)(1,null),t:(0,M.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,M.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,M.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,M.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,M.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,M.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,M.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,M.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,M.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,M.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,M.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,M.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,M.localize)(14,null)},category:{type:"string",cat:"e",description:(0,M.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,M.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,M.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,M.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,M.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,M.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,M.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,M.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,M.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,M.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,M.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,M.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,M.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,M.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,M.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,M.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,M.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const I={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(d,m,b=I){const S={},c=[],h=[];for(let l in m){const s=m[l];s.alias&&(S[l]=s.alias),s.type==="string"||s.type==="string[]"?(c.push(l),s.deprecates&&c.push(s.deprecates)):s.type==="boolean"&&(h.push(l),s.deprecates&&h.push(s.deprecates))}const o=v(d,{string:c,boolean:h,alias:S}),u={},t=o;u._=o._.map(l=>String(l)).filter(l=>l.length>0),delete t._;for(let l in m){const s=m[l];s.alias&&delete t[s.alias];let r=t[l];s.deprecates&&t.hasOwnProperty(s.deprecates)&&(r||(r=t[s.deprecates]),delete t[s.deprecates]),typeof r!="undefined"&&(s.type==="string[]"?r&&!Array.isArray(r)&&(r=[r]):s.type==="string"&&Array.isArray(r)&&(r=r.pop(),b.onMultipleValues(l,r)),u[l]=r),delete t[l]}for(let l in t)b.onUnknownOption(l);return u}e.parseArgs=n;function f(d,m){let b="";return m.args&&(Array.isArray(m.args)?b=` <${m.args.join("> <")}>`:b=` <${m.args}>`),m.alias?`-${m.alias} --${d}${b}`:`--${d}${b}`}function w(d,m){let b=0,S=[];for(const u in d){const t=d[u],l=f(u,t);b=Math.max(b,l.length),S.push([l,t.description])}let c=b+2+1;if(m-c<25)return S.reduce((u,t)=>u.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let h=m-c-1,o=[];for(const u of S){let t=u[0],l=P(u[1],h),s=i(c-t.length-2);o.push("  "+t+s+l[0]);for(let r=1;r<l.length;r++)o.push(i(c)+l[r])}return o}e.formatOptions=w;function i(d){return" ".repeat(d)}function P(d,m){let b=[];for(;d.length;){let S=d.length<m?d.length:d.lastIndexOf(" ",m),c=d.slice(0,S).trim();d=d.slice(S),b.push(c)}return b}function E(d,m,b,S,c=!0){const h=process.stdout.isTTY&&process.stdout.columns||80;let o=[`${d} ${b}`];o.push(""),o.push(`${(0,M.localize)(32,null)}: ${m} [${(0,M.localize)(33,null)}][${(0,M.localize)(34,null)}...]`),o.push(""),c&&(L.isWindows?o.push((0,M.localize)(35,null,m)):o.push((0,M.localize)(36,null,m)),o.push(""));const u={};for(const t in S){const l=S[t];if(l.description&&l.cat){let s=u[l.cat];s||(u[l.cat]=s={}),s[t]=l}}for(let t in u){const l=t;let s=u[l];s&&(o.push(D[l]),o.push(...w(s,h)),o.push(""))}return o.join(`
`)}e.buildHelpMessage=E;function y(d,m){return`${d||(0,M.localize)(37,null)}
${m||(0,M.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=y}),define(Z[158],x([0,1,59,155,88]),function(K,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class D extends L.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,f,w){return f==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(w[0],w[1]):super.call(n,f,w)}async openExtensionDevelopmentHostWindow(n,f){const w=(0,M.parseArgs)(n,M.OPTIONS);w.debugRenderer=f;const i=w.extensionDevelopmentPath;if(!i)return{success:!1};const[P]=this.windowsMainService.openExtensionDevelopmentHostWindow(i,{context:5,cli:w});if(!f)return{success:!0};const E=P.win;if(!E)return{success:!0};const y=E.webContents.debugger;let d=y.isAttached()?Infinity:0;const m=(0,v.createServer)(b=>{d++==0&&y.attach();let S=!1;const c=u=>{S||b.write(JSON.stringify(u)+"\0")},h=(u,t,l,s)=>c({method:t,params:l,sessionId:s});E.on("close",()=>{y.removeListener("message",h),b.end(),S=!0}),y.addListener("message",h);let o=Buffer.alloc(0);b.on("data",u=>{o=Buffer.concat([o,u]);for(let t=o.indexOf(0);t!==-1;t=o.indexOf(0)){let l;try{const s=o.slice(0,t).toString("utf8");o=o.slice(t+1),l=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}y.sendCommand(l.method,l.params,l.sessionId).then(s=>c({id:l.id,sessionId:l.sessionId,result:s})).catch(s=>c({id:l.id,sessionId:l.sessionId,error:{code:0,message:s.message}}))}}),b.on("error",u=>{console.error("error on cdp pipe:",u)}),b.on("close",()=>{S=!0,--d==0&&y.detach()})});return await new Promise(b=>m.listen(0,b)),E.on("close",()=>m.close()),{rendererDebugPort:m.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=D}),function(){"use strict";function K(e,v,L,M){function D(n){const f=I(n),w=[f];return e.isAbsolute(f)||w.unshift(M),e.resolve(...w)}function I(n){const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,L);const i=n["user-data-dir"];if(i)return i;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const P=process.env.USERPROFILE;if(typeof P!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(P,"AppData","Roaming")}break;case"darwin":w=e.join(v.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,L)}return{getUserDataPath:D}}if(typeof define=="function")define(Z[159],x([0,241,26,10,15,33]),function(e,v,L,M,D,I){const n=D.dirname(M.FileAccess.asFileUri("",e)),f=e.__$__nodeRequire(D.joinPath(n,"package.json").fsPath);return K(v,L,f.name,I.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),L=require("os");module.exports=K(v,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[160],x([0,1,26,157,159]),function(K,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class D extends L.AbstractNativeEnvironmentService{constructor(n,f){super(n,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,M.getUserDataPath)(n)},f)}}e.NativeEnvironmentService=D}),define(Z[161],x([0,1,32,26,7]),function(K,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function D(I){const n=(0,M.join)((0,L.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return v.writeFileSync(n,""),I&&console.log(`Marker file for --wait created: ${n}`),n}catch(f){I&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.createWaitMarkerFile=D}),define(Z[162],x([0,1,138]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,M=/^-(\d{4})(\d{2})(\d{2})$/;function D(E){return E=E.trim(),E==="*"||L.test(E)}e.isValidVersionStr=D;function I(E){if(!D(E))return null;if(E=E.trim(),E==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=E.match(L);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=I;function n(E){if(!E)return null;let y=E.majorBase,d=E.majorMustEqual,m=E.minorBase,b=E.minorMustEqual,S=E.patchBase,c=E.patchMustEqual;E.hasCaret&&(y===0||(b=!1),c=!1);let h=0;if(E.preRelease){const o=M.exec(E.preRelease);if(o){const[,u,t,l]=o;h=Date.UTC(Number(u),Number(t)-1,Number(l))}}return{majorBase:y,majorMustEqual:d,minorBase:m,minorMustEqual:b,patchBase:S,patchMustEqual:c,isMinimum:E.hasGreaterEquals,notBefore:h}}e.normalizeVersion=n;function f(E,y,d){let m;typeof E=="string"?m=n(I(E)):m=E;let b;y instanceof Date?b=y.getTime():typeof y=="string"&&(b=new Date(y).getTime());let S;if(typeof d=="string"?S=n(I(d)):S=d,!m||!S)return!1;let c=m.majorBase,h=m.minorBase,o=m.patchBase,u=S.majorBase,t=S.minorBase,l=S.patchBase,s=S.notBefore,r=S.majorMustEqual,a=S.minorMustEqual,g=S.patchMustEqual;return S.isMinimum?c>u?!0:c<u?!1:h>t?!0:h<t||b&&b<s?!1:o>=l:(c===1&&u===0&&(!r||!a||!g)&&(u=1,t=0,l=0,r=!0,a=!1,g=!1),c<u?!1:c>u?!r:h<t?!1:h>t?!a:o<l?!1:o>l?!g:!(b&&b<s))}e.isValidVersion=f;function w(E,y,d,m){return d.isBuiltin||typeof d.main=="undefined"?!0:P(E,y,d.engines.vscode,m)}e.isValidExtensionVersion=w;function i(E,y,d){return E==="*"||P(y,d,E)}e.isEngineValid=i;function P(E,y,d,m=[]){let b=n(I(d));if(!b)return m.push(v.localize(0,null,d)),!1;if(b.majorBase===0){if(!b.majorMustEqual||!b.minorMustEqual)return m.push(v.localize(1,null,d)),!1}else if(!b.majorMustEqual)return m.push(v.localize(2,null,d)),!1;return f(E,y,b)?!0:(m.push(v.localize(3,null,E,d)),!1)}}),define(Z[163],x([0,1,2,10,35,87]),function(K,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class I extends v.Disposable{constructor(f,w,i,P){super();this.requests=f,this.onDidFilesChange=w,this.onLogMessage=i,this.verboseLogging=P,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new D.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=I.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=M.ProxyChannel.toService((0,M.getNextTickChannel)(f.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.watch(this.requests)}setVerboseLogging(f){this.verboseLogging=f,this.isDisposed||this.service?.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${f}`})}watch(f){this.requests=f,this.service?.watch(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=I,I.MAX_RESTARTS=5}),define(Z[164],x([0,1,2,10,35,87]),function(K,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class I extends v.Disposable{constructor(f,w,i,P,E={}){super();this.folders=f,this.onDidFilesChange=w,this.onLogMessage=i,this.verboseLogging=P,this.watcherOptions=E,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new D.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=I.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=M.ProxyChannel.toService((0,M.getNextTickChannel)(f.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.service.watch(this.folders)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${f}`})}setVerboseLogging(f){this.verboseLogging=f,this.service&&this.service.setVerboseLogging(f)}watch(f){this.folders=f,this.service&&this.service.watch(f)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=I,I.MAX_RESTARTS=5}),define(Z[165],x([0,1,41,111,10,81]),function(K,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class I{constructor(f,w,i,P,E){this.watchedFolder=f,this.eventCallback=i,this.logCallback=P,this.verboseLogging=E,this.restartCounter=0,Array.isArray(w)?this.ignored=w.map(y=>(0,L.parse)(y)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${f}, excludes: ${w.join(",")}`),this.startWatcher()}startWatcher(){const f=[this.watchedFolder];this.verboseLogging&&f.push("-verbose"),this.handle=(0,v.spawn)(M.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",K).fsPath,f);const w=new D.LineDecoder;this.handle.stdout.on("data",i=>{const P=[];for(const E of w.write(i)){const y=E.split("|");if(y.length===2){const d=Number(y[0]),m=y[1];if(d>=0&&d<3){if(this.ignored&&this.ignored.some(b=>b(m))){this.verboseLogging&&this.log(m);continue}P.push({type:I.changeTypeMap[d],path:m})}else this.log(y[1])}}P.length>0&&this.eventCallback(P)}),this.handle.on("error",i=>this.onError(i)),this.handle.stderr.on("data",i=>this.onError(i)),this.handle.on("exit",(i,P)=>this.onExit(i,P))}onError(f){this.error("process error: "+f.toString())}onExit(f,w){this.handle&&(this.error(`terminated unexpectedly (code: ${f}, signal: ${w})`),this.restartCounter<=I.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(f){this.logCallback({type:"error",message:`[File Watcher (C#)] ${f}`})}log(f){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${f}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=I,I.MAX_RESTARTS=5,I.changeTypeMap=[0,1,2]}),define(Z[166],x([0,1,7,25,165]),function(K,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class D{constructor(n,f,w,i){this.onDidFilesChange=f,this.onLogMessage=w,this.verboseLogging=i,this.service=void 0,this.folder=n[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(v.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,v.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new M.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,n=>this.onFileEvents(n),n=>this.onLogMessage(n),this.verboseLogging)}setVerboseLogging(n){this.verboseLogging=n,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(n){this.isDisposed||n.length>0&&this.onDidFilesChange(n)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=D}),define(Z[71],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class v{constructor(M,D=[],I=!1){this.ctor=M,this.staticArguments=D,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=v}),define(Z[167],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(D){this.incoming=new Map,this.outgoing=new Map,this.data=D}}e.Node=v;class L{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(let I of this._nodes.values())I.outgoing.size===0&&D.push(I);return D}insertEdge(D,I){const n=this.lookupOrInsertNode(D),f=this.lookupOrInsertNode(I);n.outgoing.set(this._hashFn(I),f),f.incoming.set(this._hashFn(D),n)}removeNode(D){const I=this._hashFn(D);this._nodes.delete(I);for(let n of this._nodes.values())n.outgoing.delete(I),n.incoming.delete(I)}lookupOrInsertNode(D){const I=this._hashFn(D);let n=this._nodes.get(I);return n||(n=new v(D),this._nodes.set(I,n)),n}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){let D=[];for(let[I,n]of this._nodes)D.push(`${I}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return D.join(`
`)}findCycleSlow(){for(let[D,I]of this._nodes){const n=new Set([D]),f=this._findCycle(I,n);if(f)return f}}_findCycle(D,I){for(let[n,f]of D.outgoing){if(I.has(n))return[...I,n].join(" -> ");I.add(n);const w=this._findCycle(f,I);if(w)return w;I.delete(n)}}}e.Graph=L}),define(Z[5],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function f(w){return w[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=f})(v=e._util||(e._util={})),e.IInstantiationService=M("instantiationService");function L(n,f,w,i){f[v.DI_TARGET]===f?f[v.DI_DEPENDENCIES].push({id:n,index:w,optional:i}):(f[v.DI_DEPENDENCIES]=[{id:n,index:w,optional:i}],f[v.DI_TARGET]=f)}function M(n){if(v.serviceIds.has(n))return v.serviceIds.get(n);const f=function(w,i,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(f,w,P,!1)};return f.toString=()=>n,v.serviceIds.set(n,f),f}e.createDecorator=M;function D(n){return n}e.refineServiceDecorator=D;function I(n){return function(f,w,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(n,f,i,!0)}}e.optional=I}),define(Z[72],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function L(M){return!!M.hostName&&!!M.errorMessage}e.isRemoteDiagnosticError=L}),define(Z[89],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService");class L{constructor(D){this.machineId=D}encryption(){return new Promise((D,I)=>K(["vscode-encrypt"],D,I))}async encrypt(D){try{return(await this.encryption()).encrypt(this.machineId,D)}catch(I){return D}}async decrypt(D){try{return(await this.encryption()).decrypt(this.machineId,D)}catch(I){return D}}}e.EncryptionMainService=L}),define(Z[48],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[168],x([0,1,10,137,5]),function(K,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var D;(function(c){c.WIN32_X64="win32-x64",c.WIN32_IA32="win32-ia32",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(D=e.TargetPlatform||(e.TargetPlatform={}));function I(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=I;function n(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=n;function f(c,h){switch(c){case 3:return h==="x64"?"win32-x64":h==="ia32"?"win32-ia32":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=f;function w(c,h){return h==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=w;function i(c,h,o){return w(h,o)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===o?!0:P(o).includes(c)}e.isTargetPlatformCompatible=i;function P(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function E(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=E;var y;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var d;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(d=e.SortOrder||(e.SortOrder={}));var m;(function(c){c.Install="install",c.Uninstall="uninstall"})(m=e.StatisticType||(e.StatisticType={}));var b;(function(c){c[c.None=0]="None",c[c.Install=1]="Install",c[c.Update=2]="Update"})(b=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,M.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class S extends Error{constructor(h,o){super(h);this.code=o,this.name=o}}e.ExtensionManagementError=S,e.IExtensionManagementService=(0,M.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,M.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,M.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=v.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,M.createDecorator)("IExtensionManagementCLIService")}),define(Z[169],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,v.createDecorator)("extensionUrlTrustService")}),define(Z[90],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,v.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,v.createDecorator)("externalTerminal")}),define(Z[170],x([0,1,41,10,7,3,78,19,70,139,90]),function(K,e,v,L,M,D,I,n,f,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=w.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends E{openTerminal(o,u){return this.spawnTerminal(v,o,f.getWindowsShell(),u)}spawnTerminal(o,u,t,l){const s=u.windowsExec||y.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const r=M.basename(s).toLowerCase();if(r==="cmder"||r==="cmder.exe")return o.spawn(s,l?[l]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return s.indexOf(" ")>=0&&a.push('""'),a.push(s),(r==="wt"||r==="wt.exe")&&a.push("-d ."),new Promise((g,p)=>{const k=b(process),R=o.spawn(t,a,{cwd:l,env:k});R.on("error",p),R.on("exit",()=>g())})}runInTerminal(o,u,t,l,s){const r="windowsExec"in s&&s.windowsExec?s.windowsExec:y.getDefaultTerminalWindows();return new Promise((a,g)=>{const p=`"${u} - ${P}"`,k=`""${t.join('" "')}" & pause"`,R=["/c","start",p,"/wait",r,"/c",k],T=Object.assign({},b(process),l);Object.keys(T).filter(ne=>T[ne]===null).forEach(ne=>delete T[ne]);const O={cwd:u,env:T,windowsVerbatimArguments:!0};v.spawn(y.CMD,R,O).on("error",ne=>{g(S(ne))}),a(void 0)})}static getDefaultTerminalWindows(){if(!y._DEFAULT_TERMINAL_WINDOWS){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return y._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=y,y.CMD="cmd.exe";class d extends E{openTerminal(o,u){return this.spawnTerminal(v,o,u)}runInTerminal(o,u,t,l,s){const r=s.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((a,g)=>{if(r===i.DEFAULT_TERMINAL_OSX||r==="iTerm.app"){const p=r===i.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${p}.scpt`,K).fsPath,"-t",o||P,"-w",u];for(let V of t)R.push("-a"),R.push(V);if(l){const V=Object.assign({},b(process),l);for(let ne in V){const se=V[ne];se===null?(R.push("-u"),R.push(ne)):(R.push("-e"),R.push(`${ne}=${se}`))}}let T="";const O=v.spawn(d.OSASCRIPT,R);O.on("error",V=>{g(S(V))}),O.stderr.on("data",V=>{T+=V.toString()}),O.on("exit",V=>{if(V===0)a(void 0);else if(T){const ne=T.split(`
`,1);g(new Error(ne[0]))}else g(new Error(w.localize(1,null,p,V)))})}else g(new Error(w.localize(2,null,r)))})}spawnTerminal(o,u,t){const l=u.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((s,r)=>{const a=["-a",l];t&&a.push(t);const g=b(process),p=o.spawn("/usr/bin/open",a,{cwd:t,env:g});p.on("error",r),p.on("exit",()=>s())})}}e.MacExternalTerminalService=d,d.OSASCRIPT="/usr/bin/osascript";class m extends E{openTerminal(o,u){return this.spawnTerminal(v,o,u)}runInTerminal(o,u,t,l,s){const r=s.linuxExec?Promise.resolve(s.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((a,g)=>{let p=[];r.then(k=>{k.indexOf("gnome-terminal")>=0?p.push("-x"):p.push("-e"),p.push("bash"),p.push("-c");const R=`${c(t)}; echo; read -p "${m.WAIT_MESSAGE}" -n1;`;p.push(`''${R}''`);const T=Object.assign({},b(process),l);Object.keys(T).filter(se=>T[se]===null).forEach(se=>delete T[se]);const O={cwd:u,env:T};let V="";const ne=v.spawn(k,p,O);ne.on("error",se=>{g(S(se))}),ne.stderr.on("data",se=>{V+=se.toString()}),ne.on("exit",se=>{if(se===0)a(void 0);else if(V){const G=V.split(`
`,1);g(new Error(G[0]))}else g(new Error(w.localize(4,null,k,se)))})})})}static async getDefaultTerminalLinuxReady(){return m._DEFAULT_TERMINAL_LINUX_READY||(m._DEFAULT_TERMINAL_LINUX_READY=new Promise(async o=>{D.isLinux?await n.Promises.exists("/etc/debian_version")?o("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?o("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?o("konsole"):process.env.COLORTERM?o(process.env.COLORTERM):process.env.TERM?o(process.env.TERM):o("xterm"):o("xterm")})),m._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(o,u,t){const l=u.linuxExec?Promise.resolve(u.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((s,r)=>{l.then(a=>{const g=b(process),p=o.spawn(a,[],{cwd:t,env:g});p.on("error",r),p.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=m,m.WAIT_MESSAGE=w.localize(3,null);function b(h){const o={...h.env};return(0,I.sanitizeProcessEnvironment)(o),o}function S(h){return"errno"in h&&h.errno==="ENOENT"&&"path"in h&&typeof h.path=="string"?new Error(w.localize(5,null,h.path)):h}function c(h){let o="";for(let u of h)u.indexOf(" ")>=0?o+='"'+u+'"':o+=u,o+=" ";return o}}),define(Z[20],x([0,1,37,7,25,13,8,141,5]),function(K,e,v,L,M,D,I,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,f.createDecorator)("fileService");function w(F){return F.create===!0}e.isFileOpenForWriteOptions=w;var i;(function(F){F[F.Unknown=0]="Unknown",F[F.File=1]="File",F[F.Directory=2]="Directory",F[F.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var P;(function(F){F[F.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var E;(function(F){F[F.FileReadWrite=2]="FileReadWrite",F[F.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",F[F.FileReadStream=16]="FileReadStream",F[F.FileFolderCopy=8]="FileFolderCopy",F[F.PathCaseSensitive=1024]="PathCaseSensitive",F[F.Readonly=2048]="Readonly",F[F.Trash=4096]="Trash",F[F.FileWriteUnlock=8192]="FileWriteUnlock"})(E=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(F){return!!(F.capabilities&2)}e.hasReadWriteCapability=y;function d(F){return!!(F.capabilities&8)}e.hasFileFolderCopyCapability=d;function m(F){return!!(F.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function b(F){return!!(F.capabilities&16)}e.hasFileReadStreamCapability=b;var S;(function(F){F.FileExists="EntryExists",F.FileNotFound="EntryNotFound",F.FileNotADirectory="EntryNotADirectory",F.FileIsADirectory="EntryIsADirectory",F.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",F.FileTooLarge="EntryTooLarge",F.FileWriteLocked="EntryWriteLocked",F.NoPermissions="NoPermissions",F.Unavailable="Unavailable",F.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class c extends Error{constructor(j,q){super(j);this.code=q}}e.FileSystemProviderError=c;function h(F,j){const q=new c(F.toString(),j);return u(q,j),q}e.createFileSystemProviderError=h;function o(F){return F||h((0,n.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=o;function u(F,j){return F.name=j?`${j} (FileSystemError)`:"FileSystemError",F}e.markAsFileSystemProviderError=u;function t(F){if(!F)return S.Unknown;if(F instanceof c)return F.code;const j=/^(.+) \(FileSystemError\)$/.exec(F.name);if(!j)return S.Unknown;switch(j[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=t;function l(F){if(F instanceof k)return F.fileOperationResult;switch(t(F)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=l;var s;(function(F){F[F.CREATE=0]="CREATE",F[F.DELETE=1]="DELETE",F[F.MOVE=2]="MOVE",F[F.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class r{constructor(j,q,$){this.resource=j,this.operation=q,this.target=$}isOperation(j){return this.operation===j}}e.FileOperationEvent=r;var a;(function(F){F[F.UPDATED=0]="UPDATED",F[F.ADDED=1]="ADDED",F[F.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class g{constructor(j,q){this.added=void 0,this.updated=void 0,this.deleted=void 0;const $=new Map;for(const H of j){const _=$.get(H.type);_?_.push([H.resource,H]):$.set(H.type,[[H.resource,H]])}for(const[H,_]of $)switch(H){case 1:this.added=v.TernarySearchTree.forUris(()=>q),this.added.fill(_);break;case 0:this.updated=v.TernarySearchTree.forUris(()=>q),this.updated.fill(_);break;case 2:this.deleted=v.TernarySearchTree.forUris(()=>q),this.deleted.fill(_);break}}contains(j,...q){return this.doContains(j,{includeChildren:!1},...q)}affects(j,...q){return this.doContains(j,{includeChildren:!0},...q)}doContains(j,q,...$){if(!j)return!1;const H=$.length>0;return!!((!H||$.includes(1))&&(this.added?.get(j)||q.includeChildren&&this.added?.findSuperstr(j))||(!H||$.includes(0))&&(this.updated?.get(j)||q.includeChildren&&this.updated?.findSuperstr(j))||(!H||$.includes(2))&&(this.deleted?.findSubstr(j)||q.includeChildren&&this.deleted?.findSuperstr(j)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=g;function p(F,j,q){return!F||!j||F===j||j.length>F.length?!1:(j.charAt(j.length-1)!==L.sep&&(j+=L.sep),q?(0,M.startsWithIgnoreCase)(F,j):F.indexOf(j)===0)}e.isParent=p;class k extends Error{constructor(j,q,$){super(j);this.fileOperationResult=q,this.options=$}}e.FileOperationError=k;class R extends k{constructor(j,q,$){super(j,2,$);this.stat=q}}e.NotModifiedSinceFileOperationError=R;var T;(function(F){F[F.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",F[F.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",F[F.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",F[F.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",F[F.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",F[F.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",F[F.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",F[F.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",F[F.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",F[F.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",F[F.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",F[F.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(T=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(F){F[F.FILE=0]="FILE",F[F.FOLDER=1]="FOLDER",F[F.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function V(F){if(!(typeof F.size!="number"||typeof F.mtime!="number"))return F.mtime.toString(29)+F.size.toString(31)}e.etag=V;async function ne(F,j){if(!j.hasProvider(I.URI.from({scheme:F.scheme})))return new Promise(q=>{const $=j.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===F.scheme&&H.added&&($.dispose(),q())})})}e.whenProviderRegistered=ne,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class se{static formatSize(j){return(0,D.isNumber)(j)||(j=0),j<se.KB?(0,n.localize)(1,null,j.toFixed(0)):j<se.MB?(0,n.localize)(2,null,(j/se.KB).toFixed(2)):j<se.GB?(0,n.localize)(3,null,(j/se.MB).toFixed(2)):j<se.TB?(0,n.localize)(4,null,(j/se.GB).toFixed(2)):(0,n.localize)(5,null,(j/se.TB).toFixed(2))}}e.ByteSize=se,se.KB=1024,se.MB=se.KB*se.KB,se.GB=se.MB*se.KB,se.TB=se.GB*se.KB;var G;(function(F){F[F.IA32=0]="IA32",F[F.OTHER=1]="OTHER"})(G=e.Arch||(e.Arch={}));function te(F){return{maxFileSize:F===0?300*se.MB:16*se.GB,maxHeapSize:F===0?700*se.MB:2*700*se.MB}}e.getPlatformLimits=te}),define(Z[54],x([0,1,242,135,88,20]),function(K,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function I(E,y){const d={onUnknownOption:b=>{console.warn((0,L.localize)(0,null,b))},onMultipleValues:(b,S)=>{console.warn((0,L.localize)(1,null,b,S))}},m=(0,M.parseArgs)(E,M.OPTIONS,y?d:void 0);return m.goto&&m._.forEach(b=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(b),(0,L.localize)(2,null))),m["max-memory"]&&v(parseInt(m["max-memory"])>=D.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${D.MIN_MAX_MEMORY_SIZE_MB} MB.`),m}function n(E){const y=E.findIndex(d=>!/^-/.test(d));if(y>-1)return[...E.slice(0,y),...E.slice(y+1)]}function f(E){let[,...y]=E;process.env.VSCODE_DEV&&(y=n(y)||[]);const d=!P(process.env);return I(y,d)}e.parseMainProcessArgv=f;function w(E){const[,,...y]=E;return I(y,!0)}e.parseCLIProcessArgv=w;function i(E,...y){const d=E.indexOf("--");return d===-1?E.push(...y):E.splice(d,0,...y),E}e.addArg=i;function P(E){return E.VSCODE_CLI==="1"}e.isLaunchedFromCli=P}),define(Z[91],x([0,1,41,7,136,23,60,17,3,28,130,54]),function(K,e,v,L,M,D,I,n,f,w,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const E=1e4;let y;async function d(b,S,c){return S["force-disable-user-env"]?(b.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.isWindows?(b.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,P.isLaunchedFromCli)(c)&&!S["force-user-env"]?(b.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,P.isLaunchedFromCli)(c)?b.trace("resolveShellEnv(): running (--force-user-env)"):b.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=new Promise(async(h,o)=>{const u=new D.CancellationTokenSource,t=setTimeout(()=>{u.dispose(!0),o((0,M.localize)(0,null))},E);try{h(await m(b,u.token))}catch(l){!(0,n.isPromiseCanceledError)(l)&&!u.token.isCancellationRequested&&o((0,M.localize)(1,null,(0,I.toErrorMessage)(l))),h({})}finally{clearTimeout(t),u.dispose()}})),y)}e.resolveShellEnv=d;async function m(b,S){return new Promise(async(c,h)=>{const o=process.env.ELECTRON_RUN_AS_NODE;b.trace("getUnixShellEnvironment#runAsNode",o);const u=process.env.ELECTRON_NO_ATTACH_CONSOLE;b.trace("getUnixShellEnvironment#noAttach",u);const t=(0,w.generateUuid)().replace(/-/g,"").substr(0,12),l=new RegExp(t+"(.*)"+t),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};b.trace("getUnixShellEnvironment#env",s);const r=await(0,i.getSystemShell)(f.OS,s);if(b.trace("getUnixShellEnvironment#shell",r),S.isCancellationRequested)return h(n.canceled);const a=(0,L.basename)(r);let g,p;/^pwsh(-preview)?$/.test(a)?(g=`& '${process.execPath}' -p '''${t}'' + JSON.stringify(process.env) + ''${t}'''`,p=["-Login","-Command"]):(g=`'${process.execPath}' -p '"${t}" + JSON.stringify(process.env) + "${t}"'`,p=["-ilc"]),b.trace("getUnixShellEnvironment#spawn",JSON.stringify(p),g);const k=(0,v.spawn)(r,[...p,g],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});S.onCancellationRequested(()=>(k.kill(),h(n.canceled))),k.on("error",O=>{b.error("getUnixShellEnvironment#errorChildProcess",(0,I.toErrorMessage)(O)),h(O)});const R=[];k.stdout.on("data",O=>R.push(O));const T=[];k.stderr.on("data",O=>T.push(O)),k.on("close",(O,V)=>{const ne=Buffer.concat(R).toString("utf8");b.trace("getUnixShellEnvironment#raw",ne);const se=Buffer.concat(T).toString("utf8");if(se.trim()&&b.trace("getUnixShellEnvironment#stderr",se),O||V)return h(new Error((0,M.localize)(2,null,O,V)));const G=l.exec(ne),te=G?G[1]:"{}";try{const F=JSON.parse(te);o?F.ELECTRON_RUN_AS_NODE=o:delete F.ELECTRON_RUN_AS_NODE,u?F.ELECTRON_NO_ATTACH_CONSOLE=u:delete F.ELECTRON_NO_ATTACH_CONSOLE,delete F.XDG_RUNTIME_DIR,b.trace("getUnixShellEnvironment#result",F),c(F)}catch(F){b.error("getUnixShellEnvironment#errorCaught",(0,I.toErrorMessage)(F)),h(F)}})})}}),define(Z[92],x([0,1,3,8,20]),function(K,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function D(f){return f.map(w=>({type:w.type,resource:L.URI.file(w.path)}))}e.toFileChanges=D;function I(f){const w=new n;for(const i of f)w.processEvent(i);return w.normalize()}e.normalizeFileChanges=I;class n{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(w){return v.isLinux?w.path:w.path.toLowerCase()}processEvent(w){const i=this.mapPathToChange.get(this.toKey(w));let P=!1;if(i){const E=i.type,y=w.type;i.path!==w.path&&(y===1||y===0)?(i.type=2,P=!0):E===1&&y===2?(this.mapPathToChange.delete(this.toKey(w)),this.normalized.delete(i)):E===2&&y===1?i.type=0:E===1&&y===0||(i.type=y)}else P=!0;P&&(this.normalized.add(w),this.mapPathToChange.set(this.toKey(w),w))}normalize(){const w=[],i=[];return Array.from(this.normalized).filter(P=>P.type!==2?(w.push(P),!1):!0).sort((P,E)=>P.path.length-E.path.length).filter(P=>i.some(E=>(0,M.isParent)(P.path,E,!v.isLinux))?!1:(i.push(P.path),!0)).concat(w)}}}),define(Z[171],x([0,1,9,2,7,82,19,117,92]),function(K,e,v,L,M,D,I,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class w extends L.Disposable{constructor(P,E,y,d){super();this.path=P,this.onDidFilesChange=E,this.onLogMessage=y,this.verboseLogging=d,this.fileChangesDelayer=this._register(new v.ThrottledDelayer(n.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(P){this.verboseLogging=P}async startWatching(){try{const{stat:P,symbolicLink:E}=await I.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let y=this.path;if(E)try{y=await(0,D.realpath)(y)}catch(d){if(this.onError(d),E.dangling)return}P.isDirectory()?this._register((0,n.watchFolder)(y,(d,m)=>{this.onFileChange({type:d==="changed"?0:d==="added"?1:2,path:(0,M.join)(this.path,(0,M.basename)(m))})},d=>this.onError(d))):this._register((0,n.watchFile)(y,d=>{this.onFileChange({type:d==="changed"?0:2,path:this.path})},d=>this.onError(d)))}catch(P){P.code!=="ENOENT"&&this.onError(P)}}onFileChange(P){this.fileChangesBuffer.push(P),this.verboseLogging&&this.onVerbose(`${P.type===1?"[ADDED]":P.type===2?"[DELETED]":"[CHANGED]"} ${P.path}`),this.fileChangesDelayer.trigger(async()=>{const E=this.fileChangesBuffer;this.fileChangesBuffer=[];const y=(0,f.normalizeFileChanges)(E);if(this.verboseLogging)for(const d of y)this.onVerbose(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`);y.length>0&&this.onDidFilesChange(y)})}onError(P){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${P}`})}onVerbose(P){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${P}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=w}),define(Z[73],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...M){this._entries=new Map;for(let[D,I]of M)this.set(D,I)}set(M,D){const I=this._entries.get(M);return this._entries.set(M,D),I}has(M){return this._entries.has(M)}get(M){return this._entries.get(M)}}e.ServiceCollection=v}),define(Z[172],x([0,1,9,17,71,167,5,73]),function(K,e,v,L,M,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const f=!1;class w extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class i{constructor(d=new n.ServiceCollection,m=!1,b){this._activeInstantiations=new Set,this._services=d,this._strict=m,this._parent=b,this._services.set(I.IInstantiationService,this)}createChild(d){return new i(d,this._strict,this)}invokeFunction(d,...m){let b=E.traceInvocation(d),S=!1;try{return d({get:(h,o)=>{if(S)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(h,b);if(!u&&o!==I.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return u}},...m)}finally{S=!0,b.stop()}}createInstance(d,...m){let b,S;return d instanceof M.SyncDescriptor?(b=E.traceCreation(d.ctor),S=this._createInstance(d.ctor,d.staticArguments.concat(m),b)):(b=E.traceCreation(d),S=this._createInstance(d,m,b)),b.stop(),S}_createInstance(d,m=[],b){let S=I._util.getServiceDependencies(d).sort((o,u)=>o.index-u.index),c=[];for(const o of S){let u=this._getOrCreateServiceInstance(o.id,b);if(!u&&this._strict&&!o.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${o.id}.`);c.push(u)}let h=S.length>0?S[0].index:m.length;if(m.length!==h){console.warn(`[createInstance] First service dependency of ${d.name} at position ${h+1} conflicts with ${m.length} static arguments`);let o=h-m.length;o>0?m=m.concat(new Array(o)):m=m.slice(0,h)}return new d(...[...m,...c])}_setServiceInstance(d,m){if(this._services.get(d)instanceof M.SyncDescriptor)this._services.set(d,m);else if(this._parent)this._parent._setServiceInstance(d,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let m=this._services.get(d);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):m}_getOrCreateServiceInstance(d,m){let b=this._getServiceInstanceOrDescriptor(d);return b instanceof M.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,b,m.branch(d,!0)):(m.branch(d,!1),b)}_safeCreateAndCacheServiceInstance(d,m,b){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,m,b)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,m,b){const S=new D.Graph(o=>o.id.toString());let c=0;const h=[{id:d,desc:m,_trace:b}];for(;h.length;){const o=h.pop();if(S.lookupOrInsertNode(o),c++>1e3)throw new w(S);for(let u of I._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(u.id);if(!t&&!u.optional&&console.warn(`[createInstance] ${d} depends on ${u.id} which is NOT registered.`),t instanceof M.SyncDescriptor){const l={id:u.id,desc:t,_trace:o._trace.branch(u.id,!0)};S.insertEdge(o,l),h.push(l)}}}for(;;){const o=S.roots();if(o.length===0){if(!S.isEmpty())throw new w(S);break}for(const{data:u}of o){if(this._getServiceInstanceOrDescriptor(u.id)instanceof M.SyncDescriptor){const l=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,l)}S.removeNode(u)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,m,b=[],S,c){if(this._services.get(d)instanceof M.SyncDescriptor)return this._createServiceInstance(m,b,S,c);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,m,b,S,c);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(d,m=[],b,S){if(b){const c=new v.IdleValue(()=>this._createInstance(d,m,S));return new Proxy(Object.create(null),{get(h,o){if(o in h)return h[o];let u=c.value,t=u[o];return typeof t!="function"||(t=t.bind(u),h[o]=t),t},set(h,o,u){return c.value[o]=u,!0}})}else return this._createInstance(d,m,S)}}e.InstantiationService=i;var P;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(P||(P={}));class E{constructor(d,m){this.type=d,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return f?new E(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):E._None}static traceCreation(d){return f?new E(0,d.name):E._None}branch(d,m){let b=new E(2,d.toString());return this._dep.push([d,m,b]),b}stop(){let d=Date.now()-this._start;E._totals+=d;let m=!1;function b(c,h){let o=[],u=new Array(c+1).join("	");for(const[t,l,s]of h._dep)if(l&&s){m=!0,o.push(`${u}CREATES -> ${t}`);let r=b(c+1,s);r&&o.push(r)}else o.push(`${u}uses -> ${t}`);return o.join(`
`)}let S=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(d>2||m)&&console.log(S.join(`
`))}}E._None=new class extends E{constructor(){super(-1,null)}stop(){}branch(){return this}},E._totals=0}),define(Z[173],x([0,1,17,128,57]),function(K,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class D extends M.ResolvedKeybinding{constructor(n,f){super();if(f.length===0)throw(0,v.illegalArgument)("parts");this._os=n,this._parts=f}getLabel(){return L.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return L.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1?null:L.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return L.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new M.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}getSingleModifierDispatchParts(){return this._parts.map(n=>this._getSingleModifierDispatchPart(n))}}e.BaseResolvedKeybinding=D}),define(Z[174],x([0,1,57,173]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class M extends L.BaseResolvedKeybinding{constructor(I,n){super(n,I.parts)}_keyCodeToUILabel(I){if(this._os===2)switch(I){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return v.KeyCodeUtils.toString(I)}_getLabel(I){return I.isDuplicateModifierCase()?"":this._keyCodeToUILabel(I.keyCode)}_getAriaLabel(I){return I.isDuplicateModifierCase()?"":v.KeyCodeUtils.toString(I.keyCode)}_keyCodeToElectronAccelerator(I){if(I>=93&&I<=108)return null;switch(I){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return v.KeyCodeUtils.toString(I)}_getElectronAccelerator(I){return I.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(I.keyCode)}_getUserSettingsLabel(I){if(I.isDuplicateModifierCase())return"";const n=v.KeyCodeUtils.toUserSettingsUS(I.keyCode);return n&&n.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(I){return M.getDispatchStr(I)}static getDispatchStr(I){if(I.isModifierKey())return null;let n="";return I.ctrlKey&&(n+="ctrl+"),I.shiftKey&&(n+="shift+"),I.altKey&&(n+="alt+"),I.metaKey&&(n+="meta+"),n+=v.KeyCodeUtils.toString(I.keyCode),n}_getSingleModifierDispatchPart(I){return I.keyCode===5&&!I.shiftKey&&!I.altKey&&!I.metaKey?"ctrl":I.keyCode===4&&!I.ctrlKey&&!I.altKey&&!I.metaKey?"shift":I.keyCode===6&&!I.ctrlKey&&!I.shiftKey&&!I.metaKey?"alt":I.keyCode===57&&!I.ctrlKey&&!I.shiftKey&&!I.altKey?"meta":null}}e.USLayoutResolvedKeybinding=M}),define(Z[175],x([0,1,9]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function L(M,D){if(M.length===0)return Promise.resolve(!1);const I=[];let n=!1;for(let f of M){if(f===!0)return Promise.resolve(!0);(0,v.isThenable)(f)&&I.push(f.then(w=>{w&&(n=!0)},w=>{D(w),n=!0}))}return v.Promises.settled(I).then(()=>n)}e.handleVetos=L}),define(Z[6],x([0,1,60,4,2,3,5]),function(K,e,v,L,M,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,I.createDecorator)("logService"),e.ILoggerService=(0,I.createDecorator)("loggerService");function n(){return new Date().toISOString()}var f;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(f=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=f.Info;class w extends M.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class i extends w{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...l){this.checkLogLevel(f.Trace)&&this.log(f.Trace,this.format([t,...l]))}debug(t,...l){this.checkLogLevel(f.Debug)&&this.log(f.Debug,this.format([t,...l]))}info(t,...l){this.checkLogLevel(f.Info)&&this.log(f.Info,this.format([t,...l]))}warn(t,...l){this.checkLogLevel(f.Warning)&&this.log(f.Warning,this.format([t,...l]))}error(t,...l){if(this.checkLogLevel(f.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(f.Error,this.format(s))}else this.log(f.Error,this.format([t,...l]))}critical(t,...l){this.checkLogLevel(f.Critical)&&this.log(f.Critical,this.format([t,...l]))}flush(){}format(t){let l="";for(let s=0;s<t.length;s++){let r=t[s];if(typeof r=="object")try{r=JSON.stringify(r)}catch(a){}l+=(s>0?" ":"")+r}return l}}e.AbstractMessageLogger=i;class P extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!D.isWindows}trace(t,...l){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...l):console.log(`[main ${n()}]`,t,...l))}debug(t,...l){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...l):console.log(`[main ${n()}]`,t,...l))}info(t,...l){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,t,...l):console.log(`[main ${n()}]`,t,...l))}warn(t,...l){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,t,...l):console.warn(`[main ${n()}]`,t,...l))}error(t,...l){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,t,...l):console.error(`[main ${n()}]`,t,...l))}critical(t,...l){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,t,...l):console.error(`[main ${n()}]`,t,...l))}dispose(){}flush(){}}e.ConsoleMainLogger=P;class E extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...l){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",t,...l)}debug(t,...l){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...l)}info(t,...l){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",t,...l)}warn(t,...l){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",t,...l)}error(t,...l){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",t,...l)}critical(t,...l){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...l)}dispose(){}flush(){}}e.ConsoleLogger=E;class y extends w{constructor(t,l=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(l)}trace(t,...l){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(t),...l])}debug(t,...l){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(t),...l])}info(t,...l){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(t),...l])}warn(t,...l){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(t),...l])}error(t,...l){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(t),...l])}critical(t,...l){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(t),...l])}extractMessage(t){return typeof t=="string"?t:(0,v.toErrorMessage)(t,this.getLevel()<=f.Trace)}dispose(){}flush(){}}e.AdapterLogger=y;class d extends w{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const l of this.logServices)l.setLevel(t);super.setLevel(t)}trace(t,...l){for(const s of this.logServices)s.trace(t,...l)}debug(t,...l){for(const s of this.logServices)s.debug(t,...l)}info(t,...l){for(const s of this.logServices)s.info(t,...l)}warn(t,...l){for(const s of this.logServices)s.warn(t,...l)}error(t,...l){for(const s of this.logServices)s.error(t,...l)}critical(t,...l){for(const s of this.logServices)s.critical(t,...l)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=d;class m extends M.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...l){this.logger.trace(t,...l)}debug(t,...l){this.logger.debug(t,...l)}info(t,...l){this.logger.info(t,...l)}warn(t,...l){this.logger.warn(t,...l)}error(t,...l){this.logger.error(t,...l)}critical(t,...l){this.logger.critical(t,...l)}flush(){this.logger.flush()}}e.LogService=m;class b extends M.Disposable{constructor(t,l){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(l(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(s))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,l){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,l?.always?f.Trace:this.logLevel,l),this.loggers.set(t.toString(),s),l?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=b;class S{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return f.Info}trace(t,...l){}debug(t,...l){}info(t,...l){}warn(t,...l){}error(t,...l){}critical(t,...l){}dispose(){}flush(){}}e.NullLogService=S;function c(u){if(u.verbose)return f.Trace;if(typeof u.logLevel=="string"){const t=h(u.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function h(u){switch(u){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}e.parseLogLevel=h;function o(u){switch(u){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}e.LogLevelToString=o});var ie=this&&this.__param||function(K,e){return function(v,L){e(v,L,K)}};define(Z[176],x([0,1,9,18,40,77,48,20,5,6]),function(K,e,v,L,M,D,I,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var i;(function(E){E.ERROR_INVALID_FILE="ERROR_INVALID_FILE",E.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(i=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,f.createDecorator)(e.UserConfigurationFileServiceId);let P=class{constructor(y,d,m){this.environmentService=y,this.fileService=d,this.logService=m,this.queue=new v.Queue}async updateSettings(y,d){return this.queue.queue(()=>this.doWrite(this.environmentService.settingsResource,y,d))}async doWrite(y,d,m){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,y.toString(),d);const{value:b,mtime:S,etag:c}=await this.fileService.readFile(y,{atomic:!0});let h=b.toString();const o=[];if((0,M.parse)(h,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length)throw new Error("ERROR_INVALID_FILE");const u=this.getEdits(d,h,m)[0];if(u){h=h.substring(0,u.offset)+u.content+h.substring(u.offset+u.length);try{await this.fileService.writeFile(y,L.VSBuffer.fromString(h),{etag:c,mtime:S})}catch(t){if(t.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}getEdits({value:y,path:d},m,b){return d.length?(0,D.setProperty)(m,d,y,b):[{content:JSON.stringify(y,null,b.insertSpaces&&b.tabSize?" ".repeat(b.tabSize):"	"),length:m.length,offset:0}]}};P=he([ie(0,I.IEnvironmentService),ie(1,n.IFileService),ie(2,w.ILogService)],P),e.UserConfigurationFileService=P}),define(Z[93],x([0,1,6]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function L(D,I){switch(I){case v.LogLevel.Trace:return D.trace;case v.LogLevel.Debug:return D.debug;case v.LogLevel.Info:return D.info;case v.LogLevel.Warning:return D.warn;case v.LogLevel.Error:return D.error;case v.LogLevel.Critical:return D.critical;default:throw new Error("Invalid log level")}}class M extends v.AbstractLogger{constructor(I=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(I),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(I){this._logger=I;for(const{level:n,args:f}of this.buffer)L(I,n).apply(I,f);this.buffer=[]}_log(I,...n){this._logger?L(this._logger,I).apply(this._logger,n):this.getLevel()<=I&&this.buffer.push({level:I,args:n})}trace(I,...n){this._log(v.LogLevel.Trace,I,...n)}debug(I,...n){this._log(v.LogLevel.Debug,I,...n)}info(I,...n){this._log(v.LogLevel.Info,I,...n)}warn(I,...n){this._log(v.LogLevel.Warning,I,...n)}error(I,...n){this._log(v.LogLevel.Error,I,...n)}critical(I,...n){this._log(v.LogLevel.Critical,I,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=M}),define(Z[177],x([0,1,9,18,15,20,5,93,6]),function(K,e,v,L,M,D,I,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const w=5*D.ByteSize.MB;let i=class extends f.AbstractLogger{constructor(y,d,m,b,S){super();this.name=y,this.resource=d,this.donotUseFormatters=b,this.fileService=S,this.backupIndex=1,this.setLevel(m),this.queue=this._register(new v.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=f.LogLevel.Trace&&this._log(f.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=f.LogLevel.Debug&&this._log(f.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=f.LogLevel.Info&&this._log(f.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=f.LogLevel.Warning&&this._log(f.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=f.LogLevel.Error){const y=arguments[0];if(y instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=y.stack,this._log(f.LogLevel.Error,this.format(d))}else this._log(f.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=f.LogLevel.Critical&&this._log(f.LogLevel.Critical,this.format(arguments))}flush(){}log(y,d){this._log(y,this.format(d))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(y){if(y.fileOperationResult!==3)throw y}}_log(y,d){this.queue.queue(async()=>{await this.initializePromise;let m=await this.loadContent();m.length>w&&(await this.fileService.writeFile(this.getBackupResource(),L.VSBuffer.fromString(m)),m=""),this.donotUseFormatters?m+=d:m+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(y)}] ${d}
`,await this.fileService.writeFile(this.resource,L.VSBuffer.fromString(m))})}getCurrentTimestamp(){const y=b=>b<10?`0${b}`:b,d=b=>b<10?`00${b}`:b<100?`0${b}`:b,m=new Date;return`${m.getFullYear()}-${y(m.getMonth()+1)}-${y(m.getDate())} ${y(m.getHours())}:${y(m.getMinutes())}:${y(m.getSeconds())}.${d(m.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,M.joinPath)((0,M.dirname)(this.resource),`${(0,M.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(y){return""}}stringifyLogLevel(y){switch(y){case f.LogLevel.Critical:return"critical";case f.LogLevel.Debug:return"debug";case f.LogLevel.Error:return"error";case f.LogLevel.Info:return"info";case f.LogLevel.Trace:return"trace";case f.LogLevel.Warning:return"warning"}return""}format(y){let d="";for(let m=0;m<y.length;m++){let b=y[m];if(typeof b=="object")try{b=JSON.stringify(b)}catch(S){}d+=(m>0?" ":"")+b}return d}};i=he([ie(4,D.IFileService)],i),e.FileLogger=i;let P=class extends f.AbstractLoggerService{constructor(y,d,m){super(y.getLevel(),y.onDidChangeLogLevel);this.instantiationService=d,this.fileService=m}doCreateLogger(y,d,m){const b=new n.BufferLogService(d);return(0,D.whenProviderRegistered)(y,this.fileService).then(()=>b.logger=this.instantiationService.createInstance(i,(0,M.basename)(y),y,b.getLevel(),!!m?.donotUseFormatters)),b}};P=he([ie(0,f.ILogService),ie(1,I.IInstantiationService),ie(2,D.IFileService)],P),e.FileLoggerService=P}),define(Z[178],x([0,1,4,8,6]),function(K,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class D{constructor(E){this.service=E,this.onDidChangeLogLevel=v.Event.buffer(E.onDidChangeLogLevel,!0)}listen(E,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(E,y,d){switch(y){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=D;class I{constructor(E){this.channel=E}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(E){I.setLevel(this.channel,E)}static setLevel(E,y){return E.call("setLevel",y)}}e.LogLevelChannelClient=I;class n{constructor(E){this.loggerService=E,this.loggers=new Map}listen(E,y){throw new Error(`Event not found: ${y}`)}async call(E,y,d){switch(y){case"createLogger":this.createLogger(L.URI.revive(d[0]),d[1]);return;case"log":return this.log(L.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${y}`)}createLogger(E,y){this.loggers.set(E.toString(),this.loggerService.createLogger(E,y))}consoleLog(E,y){let d=console.log;switch(E){case M.LogLevel.Error:d=console.error;break;case M.LogLevel.Warning:d=console.warn;break;case M.LogLevel.Info:d=console.info;break}d.call(console,...y)}log(E,y){const d=this.loggers.get(E.toString());if(!d)throw new Error("Create the logger before logging");for(const[m,b]of y)switch(m){case M.LogLevel.Trace:d.trace(b);break;case M.LogLevel.Debug:d.debug(b);break;case M.LogLevel.Info:d.info(b);break;case M.LogLevel.Warning:d.warn(b);break;case M.LogLevel.Error:d.error(b);break;case M.LogLevel.Critical:d.critical(b);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=n;class f extends M.AbstractLoggerService{constructor(E,y,d){super(E,y);this.channel=d}createConsoleMainLogger(){return new M.AdapterLogger({log:(E,y)=>{this.channel.call("consoleLog",[E,y])}})}doCreateLogger(E,y,d){return new w(this.channel,E,y,d)}}e.LoggerChannelClient=f;class w extends M.AbstractMessageLogger{constructor(E,y,d,m){super(m?.always);this.channel=E,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[y,m]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(E,y){const d=[[E,y]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(E){this.channel.call("log",[this.file,E])}}class i extends M.LogService{constructor(E,y){super(y);this.parent=E,this._register(E.onDidChangeLogLevel(d=>y.setLevel(d)))}setLevel(E){super.setLevel(E),this.parent.setLevel(E)}}e.FollowerLogService=i}),define(Z[94],x([0,1,20,6]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function M(f,w,i,P){try{const E=await new Promise((y,d)=>{K(["spdlog"],y,d)});return E.setFlushOn(L.LogLevel.Trace),E.createAsyncRotatingLogger(f,w,i,P)}catch(E){console.error(E)}return null}function D(f,w,i,P){const E=K.__$__nodeRequire("spdlog");return E.setFlushOn(L.LogLevel.Trace),E.createRotatingLogger(f,w,i,P)}e.createRotatingLogger=D;function I(f,w,i){switch(w){case L.LogLevel.Trace:f.trace(i);break;case L.LogLevel.Debug:f.debug(i);break;case L.LogLevel.Info:f.info(i);break;case L.LogLevel.Warning:f.warn(i);break;case L.LogLevel.Error:f.error(i);break;case L.LogLevel.Critical:f.critical(i);break;default:throw new Error("Invalid log level")}}class n extends L.AbstractMessageLogger{constructor(w,i,P,E){super();this.name=w,this.filepath=i,this.rotating=P,this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(y=>{this._logger&&this._logger.setLevel(y)}))}_createSpdLogLogger(){const w=this.rotating?6:1,i=30/w*v.ByteSize.MB;return M(this.name,this.filepath,i,w).then(P=>{if(P){this._logger=P,this._logger.setLevel(this.getLevel());for(const{level:E,message:y}of this.buffer)I(this._logger,E,y);this.buffer=[]}})}log(w,i){this._logger?I(this._logger,w,i):this.getLevel()<=w&&this.buffer.push({level:w,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(Z[179],x([0,1,10,15,28,20,177,6,94]),function(K,e,v,L,M,D,I,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let w=class extends n.AbstractLoggerService{constructor(P,E){super(P.getLevel(),P.onDidChangeLogLevel);this.fileService=E}doCreateLogger(P,E,y){if(P.scheme===v.Schemas.file){const d=new f.SpdLogLogger(y?.name||(0,M.generateUuid)(),P.fsPath,!y?.donotRotate,E);return y?.donotUseFormatters&&d.clearFormatters(),d}else return new I.FileLogger(y?.name??(0,L.basename)(P),P,E,!!y?.donotUseFormatters,this.fileService)}};w=he([ie(0,n.ILogService),ie(1,D.IFileService)],w),e.LoggerService=w}),define(Z[180],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(I){return I.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function L(I){return I.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function M(I){return I.uri!==void 0}e.isMenubarMenuItemRecentAction=M;function D(I){return!v(I)&&!L(I)&&!M(I)}e.isMenubarMenuItemAction=D}),define(Z[45],x([0,1,10,3,33,15]),function(K,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let I;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const n=L.globals.vscode.context.configuration();if(n)I=n.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof K?.__$__nodeRequire=="function"){const n=(0,D.dirname)(v.FileAccess.asFileUri("",K));I=K.__$__nodeRequire((0,D.joinPath)(n,"product.json").fsPath);const f=K.__$__nodeRequire((0,D.joinPath)(n,"package.json").fsPath);M.env.VSCODE_DEV&&Object.assign(I,{nameShort:`${I.nameShort} Dev`,nameLong:`${I.nameLong} Dev`,dataFolderName:`${I.dataFolderName}-dev`}),Object.assign(I,{version:f.version})}else I={},Object.keys(I).length===0&&Object.assign(I,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=I}),define(Z[95],x([0,1,18,17,142,20,45]),function(K,e,v,L,M,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(P,E,y,d,m,b){let S;try{await f(P,E,y,d,m,b)}catch(c){S=c}finally{S&&m.errorTransformer&&(S=m.errorTransformer(S)),typeof S!="undefined"&&y.error(S),y.end()}}e.readFileIntoStream=n;async function f(P,E,y,d,m,b){w(b);const S=await P.open(E,{create:!1});try{w(b);let c=0,h=0,o=m&&typeof m.length=="number"?m.length:void 0,u=v.VSBuffer.alloc(Math.min(m.bufferSize,typeof o=="number"?o:m.bufferSize)),t=m&&typeof m.position=="number"?m.position:0,l=0;do h=await P.read(S,t,u.buffer,l,u.byteLength-l),t+=h,l+=h,c+=h,typeof o=="number"&&(o-=h),l===u.byteLength&&(await y.write(d(u)),u=v.VSBuffer.alloc(Math.min(m.bufferSize,typeof o=="number"?o:m.bufferSize)),l=0);while(h>0&&(typeof o!="number"||o>0)&&w(b)&&i(c,m));if(l>0){let s=l;typeof o=="number"&&(s=Math.min(l,o)),y.write(d(u.slice(0,s)))}}catch(c){throw(0,D.ensureFileSystemProviderError)(c)}finally{await P.close(S)}}function w(P){if(P.isCancellationRequested)throw(0,L.canceled)();return!0}function i(P,E){if(E?.limits){if(typeof E.limits.memory=="number"&&P>E.limits.memory)throw(0,D.createFileSystemProviderError)((0,M.localize)(0,null,I.default.nameShort),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&P>E.limits.size)throw(0,D.createFileSystemProviderError)((0,M.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[181],x([0,1,30,9,18,23,4,66,2,37,10,74,15,67,140,20,95,6]),function(K,e,v,L,M,D,I,n,f,w,i,P,E,y,d,m,b,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let c=class Ke extends f.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new I.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new I.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new I.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new I.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new I.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new I.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new m.FileChangesEvent(u,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new m.FileChangesEvent(u,!0)))),this.watchedResources=w.TernarySearchTree.forUris(u=>{const t=this.getProvider(u.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(o,u){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,P.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,u),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:u});const t=new f.DisposableStore;return t.add(u.onDidChangeFile(l=>this.onDidChangeFile(l,this.isPathCaseSensitive(u)))),t.add(u.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:u,scheme:o}))),typeof u.onDidErrorOccur=="function"&&t.add(u.onDidErrorOccur(l=>this._onError.fire(new Error(l)))),(0,f.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:u}),this.provider.delete(o),(0,f.dispose)(t)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const u=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){u.push(t)}}),!this.provider.has(o)&&await L.Promises.settled(u)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,u){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&u)}listCapabilities(){return n.Iterable.map(this.provider,([o,u])=>({scheme:o,capabilities:u.capabilities}))}async withProvider(o){if(!(0,E.isAbsolutePath)(o))throw new m.FileOperationError((0,d.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const u=this.provider.get(o.scheme);if(!u){const t=new Error;throw t.name="ENOPRO",t.message=(0,d.localize)(1,null,o.toString()),t}return u}async withReadProvider(o){const u=await this.withProvider(o);if((0,m.hasOpenReadWriteCloseCapability)(u)||(0,m.hasReadWriteCapability)(u)||(0,m.hasFileReadStreamCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const u=await this.withProvider(o);if((0,m.hasOpenReadWriteCloseCapability)(u)||(0,m.hasReadWriteCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,u){try{return await this.doResolveFile(o,u)}catch(t){throw(0,m.toFileSystemProviderErrorCode)(t)===m.FileSystemProviderErrorCode.FileNotFound?new m.FileOperationError((0,d.localize)(2,null,this.resourceForError(o)),1):(0,m.ensureFileSystemProviderError)(t)}}async doResolveFile(o,u){const t=await this.withProvider(o),l=this.isPathCaseSensitive(t),s=u?.resolveTo,r=u?.resolveSingleChildDescendants,a=u?.resolveMetadata,g=await t.stat(o);let p;return this.toFileStat(t,o,g,void 0,!!a,(k,R)=>(p||(p=w.TernarySearchTree.forUris(()=>!l),p.set(o,!0),s&&p.fill(!0,s)),p.get(k.resource)||p.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&r?R===1:!1))}async toFileStat(o,u,t,l,s,r){const{providerExtUri:a}=this.getExtUri(o),g={resource:u,name:a.basename(u),isFile:(t.type&m.FileType.File)!=0,isDirectory:(t.type&m.FileType.Directory)!=0,isSymbolicLink:(t.type&m.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&m.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,m.etag)({mtime:t.mtime,size:t.size})};if(g.isDirectory&&r(g,l)){try{const p=await o.readdir(u),k=await L.Promises.settled(p.map(async([R,T])=>{try{const O=a.joinPath(u,R),V=s?await o.stat(O):{type:T};return await this.toFileStat(o,O,V,p.length,s,r)}catch(O){return this.logService.trace(O),null}}));g.children=(0,v.coalesce)(k)}catch(p){this.logService.trace(p),g.children=[]}return g}return g}async resolveAll(o){return L.Promises.settled(o.map(async u=>{try{return{stat:await this.doResolveFile(u.resource,u.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const u=await this.withProvider(o);try{return!!await u.stat(o)}catch(t){return!1}}async canCreateFile(o,u){try{await this.doValidateCreateFile(o,u)}catch(t){return t}return!0}async doValidateCreateFile(o,u){if(!u?.overwrite&&await this.exists(o))throw new m.FileOperationError((0,d.localize)(3,null,this.resourceForError(o)),3,u)}async createFile(o,u=M.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const l=await this.writeFile(o,u);return this._onDidRunOperation.fire(new m.FileOperationEvent(o,0,l)),l}async writeFile(o,u,t){const l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:s}=this.getExtUri(l);try{await this.validateWriteFile(l,o,t)||await this.mkdirp(l,s.dirname(o));let a;if((0,m.hasReadWriteCapability)(l)&&!(u instanceof M.VSBuffer))if((0,y.isReadableStream)(u)){const g=await(0,y.peekStream)(u,3);g.ended?a=M.VSBuffer.concat(g.buffer):a=g}else a=(0,y.peekReadable)(u,g=>M.VSBuffer.concat(g),3);else a=u;!(0,m.hasOpenReadWriteCloseCapability)(l)||(0,m.hasReadWriteCapability)(l)&&a instanceof M.VSBuffer?await this.doWriteUnbuffered(l,o,t,a):await this.doWriteBuffered(l,o,t,a instanceof M.VSBuffer?(0,M.bufferToReadable)(a):a)}catch(r){throw new m.FileOperationError((0,d.localize)(4,null,this.resourceForError(o),(0,m.ensureFileSystemProviderError)(r).toString()),(0,m.toFileOperationResult)(r),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,u,t){if(!!t?.unlock&&!(o.capabilities&8192))throw new Error((0,d.localize)(5,null,this.resourceForError(u)));let s;try{s=await o.stat(u)}catch(r){return}if((s.type&m.FileType.Directory)!=0)throw new m.FileOperationError((0,d.localize)(6,null,this.resourceForError(u)),0,t);if(this.throwIfFileIsReadonly(u,s),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==m.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&t.mtime<s.mtime&&t.etag!==(0,m.etag)({mtime:t.mtime,size:s.size}))throw new m.FileOperationError((0,d.localize)(7,null),3,t);return s}async readFile(o,u){const t=await this.withReadProvider(o);return u?.atomic?this.doReadFileAtomic(t,o,u):this.doReadFile(t,o,u)}async doReadFileAtomic(o,u,t){return new Promise((l,s)=>{this.writeQueue.queueFor(u,this.getExtUri(o).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(o,u,t);l(r)}catch(r){s(r)}})})}async doReadFile(o,u,t){const l=await this.doReadFileStream(o,u,{...t,preferUnbuffered:!0});return{...l,value:await(0,M.streamToBuffer)(l.value)}}async readFileStream(o,u){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,u)}async doReadFileStream(o,u,t){const l=new D.CancellationTokenSource,s=this.validateReadFile(u,t).then(a=>a,a=>{throw l.cancel(),a});let r;try{return typeof t?.etag=="string"&&t.etag!==m.ETAG_DISABLED&&await s,!((0,m.hasOpenReadWriteCloseCapability)(o)||(0,m.hasFileReadStreamCapability)(o))||(0,m.hasReadWriteCapability)(o)&&t?.preferUnbuffered?r=this.readFileUnbuffered(o,u,t):(0,m.hasFileReadStreamCapability)(o)?r=this.readFileStreamed(o,u,l.token,t):r=this.readFileBuffered(o,u,l.token,t),{...await s,value:r}}catch(a){r&&await(0,y.consumeStream)(r);const g=(0,d.localize)(8,null,this.resourceForError(u),(0,m.ensureFileSystemProviderError)(a).toString());throw a instanceof m.NotModifiedSinceFileOperationError?new m.NotModifiedSinceFileOperationError(g,a.stat,t):new m.FileOperationError(g,(0,m.toFileOperationResult)(a),t)}}readFileStreamed(o,u,t,l=Object.create(null)){const s=o.readFileStream(u,l,t);return(0,y.transform)(s,{data:r=>r instanceof M.VSBuffer?r:M.VSBuffer.wrap(r),error:r=>new m.FileOperationError((0,d.localize)(9,null,this.resourceForError(u),(0,m.ensureFileSystemProviderError)(r).toString()),(0,m.toFileOperationResult)(r),l)},r=>M.VSBuffer.concat(r))}readFileBuffered(o,u,t,l=Object.create(null)){const s=(0,M.newWriteableBufferStream)();return(0,b.readFileIntoStream)(o,u,s,r=>r,{...l,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new m.FileOperationError((0,d.localize)(10,null,this.resourceForError(u),(0,m.ensureFileSystemProviderError)(r).toString()),(0,m.toFileOperationResult)(r),l)},t),s}readFileUnbuffered(o,u,t){const l=(0,y.newWriteableStream)(s=>M.VSBuffer.concat(s));return(async()=>{try{let s=await o.readFile(u);typeof t?.position=="number"&&(s=s.slice(t.position)),typeof t?.length=="number"&&(s=s.slice(0,t.length)),this.validateReadFileLimits(u,s.byteLength,t),l.end(M.VSBuffer.wrap(s))}catch(s){l.error(s),l.end()}})(),l}async validateReadFile(o,u){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new m.FileOperationError((0,d.localize)(11,null,this.resourceForError(o)),0,u);if(typeof u?.etag=="string"&&u.etag!==m.ETAG_DISABLED&&u.etag===t.etag)throw new m.NotModifiedSinceFileOperationError((0,d.localize)(12,null),t,u);return this.validateReadFileLimits(o,t.size,u),t}validateReadFileLimits(o,u,t){if(t?.limits){let l;if(typeof t.limits.memory=="number"&&u>t.limits.memory&&(l=9),typeof t.limits.size=="number"&&u>t.limits.size&&(l=7),typeof l=="number")throw new m.FileOperationError((0,d.localize)(13,null,this.resourceForError(o)),l)}}async canMove(o,u,t){return this.doCanMoveCopy(o,u,"move",t)}async canCopy(o,u,t){return this.doCanMoveCopy(o,u,"copy",t)}async doCanMoveCopy(o,u,t,l){if(o.toString()!==u.toString())try{const s=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u);await this.doValidateMoveCopy(s,o,r,u,t,l)}catch(s){return s}return!0}async move(o,u,t){const l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),r=await this.doMoveCopy(l,o,s,u,"move",!!t),a=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(o,r==="move"?2:3,a)),a}async copy(o,u,t){const l=await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),r=await this.doMoveCopy(l,o,s,u,"copy",!!t),a=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(o,r==="copy"?3:2,a)),a}async doMoveCopy(o,u,t,l,s,r){if(u.toString()===l.toString())return s;const{exists:a,isSameResourceWithDifferentPathCase:g}=await this.doValidateMoveCopy(o,u,t,l,s,r);if(a&&!g&&r&&await this.del(l,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(l)),s==="copy"){if(o===t&&(0,m.hasFileFolderCopyCapability)(o))await o.copy(u,l,{overwrite:r});else{const p=await this.resolve(u);p.isDirectory?await this.doCopyFolder(o,p,t,l):await this.doCopyFile(o,u,t,l)}return s}else return o===t?(await o.rename(u,l,{overwrite:r}),s):(await this.doMoveCopy(o,u,t,l,"copy",r),await this.del(u,{recursive:!0}),"copy")}async doCopyFile(o,u,t,l){if((0,m.hasOpenReadWriteCloseCapability)(o)&&(0,m.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(o,u,t,l);if((0,m.hasOpenReadWriteCloseCapability)(o)&&(0,m.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(o,u,t,l);if((0,m.hasReadWriteCapability)(o)&&(0,m.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(o,u,t,l);if((0,m.hasReadWriteCapability)(o)&&(0,m.hasReadWriteCapability)(t))return this.doPipeUnbuffered(o,u,t,l)}async doCopyFolder(o,u,t,l){await t.mkdir(l),Array.isArray(u.children)&&await L.Promises.settled(u.children.map(async s=>{const r=this.getExtUri(t).providerExtUri.joinPath(l,s.name);return s.isDirectory?this.doCopyFolder(o,await this.resolve(s.resource),t,r):this.doCopyFile(o,s.resource,t,r)}))}async doValidateMoveCopy(o,u,t,l,s,r){let a=!1;if(o===t){const{providerExtUri:p,isPathCaseSensitive:k}=this.getExtUri(o);if(k||(a=p.isEqual(u,l)),a&&s==="copy")throw new Error((0,d.localize)(14,null,this.resourceForError(u),this.resourceForError(l)));if(!a&&p.isEqualOrParent(l,u))throw new Error((0,d.localize)(15,null,this.resourceForError(u),this.resourceForError(l)))}const g=await this.exists(l);if(g&&!a){if(!r)throw new m.FileOperationError((0,d.localize)(16,null,this.resourceForError(u),this.resourceForError(l)),4);if(o===t){const{providerExtUri:p}=this.getExtUri(o);if(p.isEqualOrParent(u,l))throw new Error((0,d.localize)(17,null,this.resourceForError(u),this.resourceForError(l)))}}return{exists:g,isSameResourceWithDifferentPathCase:a}}getExtUri(o){const u=this.isPathCaseSensitive(o);return{providerExtUri:u?E.extUri:E.extUriIgnorePathCase,isPathCaseSensitive:u}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const u=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(u,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(o,0,t)),t}async mkdirp(o,u){const t=[],{providerExtUri:l}=this.getExtUri(o);for(;!l.isEqual(u,l.dirname(u));)try{if(((await o.stat(u)).type&m.FileType.Directory)==0)throw new Error((0,d.localize)(18,null,this.resourceForError(u)));break}catch(s){if((0,m.toFileSystemProviderErrorCode)(s)!==m.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(l.basename(u)),u=l.dirname(u)}for(let s=t.length-1;s>=0;s--){u=l.joinPath(u,t[s]);try{await o.mkdir(u)}catch(r){if((0,m.toFileSystemProviderErrorCode)(r)!==m.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(o,u){try{await this.doValidateDelete(o,u)}catch(t){return t}return!0}async doValidateDelete(o,u){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!u?.useTrash&&!(t.capabilities&4096))throw new Error((0,d.localize)(19,null,this.resourceForError(o)));let s;try{s=await t.stat(o)}catch(a){}if(s)this.throwIfFileIsReadonly(o,s);else throw new m.FileOperationError((0,d.localize)(20,null,this.resourceForError(o)),1);if(!!!u?.recursive){const a=await this.resolve(o);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,d.localize)(21,null,this.resourceForError(o)))}return t}async del(o,u){const t=await this.doValidateDelete(o,u),l=!!u?.useTrash,s=!!u?.recursive;await t.delete(o,{recursive:s,useTrash:l}),this._onDidRunOperation.fire(new m.FileOperationEvent(o,1))}onDidChangeFile(o,u){this._onDidChangeFilesRaw.fire({changes:o});let t,l;{for(const s of o)this.watchedResources.has(s.resource)?(t||(t=[]),t.push(s)):(l||(l=[]),l.push(s));t&&this._onDidFilesChange.fire(new m.FileChangesEvent(t,!u))}if(l){const s=u?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!s.work(l)&&Ke.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),s.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${s.pending}, most recent change: ${l[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,u={recursive:!1,excludes:[]}){const t=new f.DisposableStore;{let l=!1,s=()=>{l=!0};t.add((0,f.toDisposable)(()=>s())),this.doWatch(o,u).then(r=>{l?(0,f.dispose)(r):s=()=>(0,f.dispose)(r)},r=>this.logService.error(r))}return u.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),t.add((0,f.toDisposable)(()=>{const l=this.watchedResources.get(o);typeof l=="number"&&(l<=1?this.watchedResources.delete(o):this.watchedResources.set(o,l-1))}))),t}async doWatch(o,u){const t=await this.withProvider(o),l=this.toWatchKey(t,o,u),s=this.activeWatchers.get(l)||{count:0,disposable:t.watch(o,u)};return this.activeWatchers.has(l)||this.activeWatchers.set(l,s),s.count+=1,(0,f.toDisposable)(()=>{s.count--,s.count===0&&((0,f.dispose)(s.disposable),this.activeWatchers.delete(l))})}toWatchKey(o,u,t){const{providerExtUri:l}=this.getExtUri(o);return[l.getComparisonKey(u),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,f.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,u,t,l){return this.writeQueue.queueFor(u,this.getExtUri(o).providerExtUri).queue(async()=>{const s=await o.open(u,{create:!0,unlock:t?.unlock??!1});try{(0,y.isReadableStream)(l)||(0,y.isReadableBufferedStream)(l)?await this.doWriteStreamBufferedQueued(o,s,l):await this.doWriteReadableBufferedQueued(o,s,l)}catch(r){throw(0,m.ensureFileSystemProviderError)(r)}finally{await o.close(s)}})}async doWriteStreamBufferedQueued(o,u,t){let l=0,s;if((0,y.isReadableBufferedStream)(t)){if(t.buffer.length>0){const r=M.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,u,r,r.byteLength,l,0),l+=r.byteLength}if(t.ended)return;s=t.stream}else s=t;return new Promise(async(r,a)=>{(0,y.listenStream)(s,{onData:async g=>{s.pause();try{await this.doWriteBuffer(o,u,g,g.byteLength,l,0)}catch(p){return a(p)}l+=g.byteLength,setTimeout(()=>s.resume())},onError:g=>a(g),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(o,u,t){let l=0,s;for(;(s=t.read())!==null;)await this.doWriteBuffer(o,u,s,s.byteLength,l,0),l+=s.byteLength}async doWriteBuffer(o,u,t,l,s,r){let a=0;for(;a<l;)a+=await o.write(u,s+a,t.buffer,r+a,l-a)}async doWriteUnbuffered(o,u,t,l){return this.writeQueue.queueFor(u,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,u,t,l))}async doWriteUnbufferedQueued(o,u,t,l){let s;l instanceof M.VSBuffer?s=l:(0,y.isReadableStream)(l)?s=await(0,M.streamToBuffer)(l):(0,y.isReadableBufferedStream)(l)?s=await(0,M.bufferedStreamToBuffer)(l):s=(0,M.readableToBuffer)(l),await o.writeFile(u,s.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(o,u,t,l){return this.writeQueue.queueFor(l,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,u,t,l))}async doPipeBufferedQueued(o,u,t,l){let s,r;try{s=await o.open(u,{create:!1}),r=await t.open(l,{create:!0,unlock:!1});const a=M.VSBuffer.alloc(this.BUFFER_SIZE);let g=0,p=0,k=0;do k=await o.read(s,g,a.buffer,p,a.byteLength-p),await this.doWriteBuffer(t,r,a,k,g,p),g+=k,p+=k,p===a.byteLength&&(p=0);while(k>0)}catch(a){throw(0,m.ensureFileSystemProviderError)(a)}finally{await L.Promises.settled([typeof s=="number"?o.close(s):Promise.resolve(),typeof r=="number"?t.close(r):Promise.resolve()])}}async doPipeUnbuffered(o,u,t,l){return this.writeQueue.queueFor(l,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,u,t,l))}async doPipeUnbufferedQueued(o,u,t,l){return t.writeFile(l,await o.readFile(u),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,u,t,l){return this.writeQueue.queueFor(l,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,u,t,l))}async doPipeUnbufferedToBufferedQueued(o,u,t,l){const s=await t.open(l,{create:!0,unlock:!1});try{const r=await o.readFile(u);await this.doWriteBuffer(t,s,M.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,m.ensureFileSystemProviderError)(r)}finally{await t.close(s)}}async doPipeBufferedToUnbuffered(o,u,t,l){const s=await(0,M.streamToBuffer)(this.readFileBuffered(o,u,D.CancellationToken.None));await this.doWriteUnbuffered(t,l,void 0,s)}throwIfFileSystemIsReadonly(o,u){if(o.capabilities&2048)throw new m.FileOperationError((0,d.localize)(22,null,this.resourceForError(u)),6);return o}throwIfFileIsReadonly(o,u){if((u.permissions??0)&m.FilePermission.Readonly)throw new m.FileOperationError((0,d.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===i.Schemas.file?o.fsPath:o.toString(!0)}};c.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},c=he([ie(0,S.ILogService)],c),e.FileService=c}),define(Z[182],x([0,1,30,9,18,4,31,2,7,3,15,67,19,143,20,95,171,163,164,92,166,6,45]),function(K,e,v,L,M,D,I,n,f,w,i,P,E,y,d,m,b,S,c,h,o,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class l extends n.Disposable{constructor(r,a){super();this.logService=r,this.options=a,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=D.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new D.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:a,symbolicLink:g}=await E.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(a,g),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(r){try{const a=await E.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),g=[];return await Promise.all(a.map(async p=>{try{let k;p.isSymbolicLink()?k=(await this.stat((0,i.joinPath)(r,p.name))).type:k=this.toType(p),g.push([p.name,k])}catch(k){this.logService.trace(k)}})),g}catch(a){throw this.toFileSystemProviderError(a)}}toType(r,a){let g;return a?.dangling?g=d.FileType.Unknown:r.isFile()?g=d.FileType.File:r.isDirectory()?g=d.FileType.Directory:g=d.FileType.Unknown,a&&(g|=d.FileType.SymbolicLink),g}async readFile(r){try{const a=this.toFilePath(r);return await E.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(r,a,g){const p=(0,P.newWriteableStream)(k=>M.VSBuffer.concat(k.map(R=>M.VSBuffer.wrap(R))).buffer);return(0,m.readFileIntoStream)(this,r,p,k=>k.buffer,{...a,bufferSize:this.BUFFER_SIZE},g),p}async writeFile(r,a,g){let p;try{const k=this.toFilePath(r);if(!g.create||!g.overwrite){if(await E.Promises.exists(k)){if(!g.overwrite)throw(0,d.createFileSystemProviderError)((0,y.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!g.create)throw(0,d.createFileSystemProviderError)((0,y.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(r,{create:!0,unlock:g.unlock}),await this.write(p,0,a,0,a.byteLength)}catch(k){throw await this.toFileSystemProviderWriteError(r,k)}finally{typeof p=="number"&&await this.close(p)}}async open(r,a){try{const g=this.toFilePath(r);if((0,d.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:R}=await E.SymlinkSupport.stat(g);R.mode&128||await E.Promises.chmod(g,R.mode|128)}catch(R){this.logService.trace(R)}let p;if((0,d.isFileOpenForWriteOptions)(a)){if(w.isWindows)try{await E.Promises.truncate(g,0),p="r+"}catch(R){R.code!=="ENOENT"&&this.logService.trace(R)}p||(p="w")}else p="r";const k=await E.Promises.open(g,p);return this.mapHandleToPos.set(k,0),(0,d.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(k,r),k}catch(g){throw(0,d.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(r,g):this.toFileSystemProviderError(g)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await E.Promises.fdatasync(r)}catch(a){this.canFlush=!1,this.logService.error(a)}return await E.Promises.close(r)}catch(a){throw this.toFileSystemProviderError(a)}}async read(r,a,g,p,k){const R=this.normalizePos(r,a);let T=null;try{const O=await E.Promises.read(r,g,p,k,R);return typeof O=="number"?T=O:T=O.bytesRead,T}catch(O){throw this.toFileSystemProviderError(O)}finally{this.updatePos(r,R,T)}}normalizePos(r,a){return a===this.mapHandleToPos.get(r)?null:a}updatePos(r,a,g){const p=this.mapHandleToPos.get(r);typeof p=="number"&&(typeof a=="number"||(typeof g=="number"?this.mapHandleToPos.set(r,p+g):this.mapHandleToPos.delete(r)))}async write(r,a,g,p,k){return(0,L.retry)(()=>this.doWrite(r,a,g,p,k),100,3)}async doWrite(r,a,g,p,k){const R=this.normalizePos(r,a);let T=null;try{const O=await E.Promises.write(r,g,p,k,R);return typeof O=="number"?T=O:T=O.bytesWritten,T}catch(O){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),O)}finally{this.updatePos(r,R,T)}}async mkdir(r){try{await E.Promises.mkdir(this.toFilePath(r))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(r,a){try{const g=this.toFilePath(r);await this.doDelete(g,a)}catch(g){throw this.toFileSystemProviderError(g)}}async doDelete(r,a){a.recursive?await E.Promises.rm(r,E.RimRafMode.MOVE):await E.Promises.unlink(r)}async rename(r,a,g){const p=this.toFilePath(r),k=this.toFilePath(a);if(p!==k)try{await this.validateTargetDeleted(r,a,"move",g.overwrite),await E.Promises.move(p,k)}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,y.localize)(2,null,(0,f.basename)(p),(0,f.basename)((0,f.dirname)(k)),R.toString()))),this.toFileSystemProviderError(R)}}async copy(r,a,g){const p=this.toFilePath(r),k=this.toFilePath(a);if(p!==k)try{await this.validateTargetDeleted(r,a,"copy",g.overwrite),await E.Promises.copy(p,k,{preserveSymlinks:!0})}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,y.localize)(3,null,(0,f.basename)(p),(0,f.basename)((0,f.dirname)(k)),R.toString()))),this.toFileSystemProviderError(R)}}async validateTargetDeleted(r,a,g,p){const k=this.toFilePath(r),R=this.toFilePath(a);let T=!1;if(!!(this.capabilities&1024)||(T=(0,I.isEqual)(k,R,!0)),T&&g==="copy")throw(0,d.createFileSystemProviderError)((0,y.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(!T&&await E.Promises.exists(R)){if(!p)throw(0,d.createFileSystemProviderError)((0,y.localize)(5,null),d.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(r,a){return a.recursive?this.watchRecursive(r,a):this.watchNonRecursive(r)}watchRecursive(r,a){const g={path:this.toFilePath(r),excludes:a.excludes},p=(0,v.insert)(this.recursiveFoldersToWatch,g);return this.refreshRecursiveWatchers(),(0,n.toDisposable)(()=>{p(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof S.FileWatcher)this.recursiveWatcher.watch(this.recursiveFoldersToWatch);else if((0,n.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let r,a;if(this.options?.watcher?.usePolling)r=c.FileWatcher,a=this.options?.watcher;else{let g;this.options?.enableLegacyRecursiveWatcher?g=!0:g=t.default.quality==="stable"&&w.isLinux,g&&this.recursiveFoldersToWatch.length===1?w.isWindows?r=o.FileWatcher:r=c.FileWatcher:r=S.FileWatcher}this.recursiveWatcher=new r(this.recursiveFoldersToWatch,g=>this._onDidChangeFile.fire((0,h.toFileChanges)(g)),g=>{g.type==="error"&&this._onDidWatchErrorOccur.fire(g.message),this.logService[g.type](g.message)},this.logService.getLevel()===u.LogLevel.Trace,a),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===u.LogLevel.Trace)}))}}watchNonRecursive(r){const a=new b.FileWatcher(this.toFilePath(r),p=>this._onDidChangeFile.fire((0,h.toFileChanges)(p)),p=>{p.type==="error"&&this._onDidWatchErrorOccur.fire(p.message),this.logService[p.type](p.message)},this.logService.getLevel()===u.LogLevel.Trace),g=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===u.LogLevel.Trace)});return(0,n.combinedDisposable)(a,g)}toFilePath(r){return(0,f.normalize)(r.fsPath)}toFileSystemProviderError(r){if(r instanceof d.FileSystemProviderError)return r;let a;switch(r.code){case"ENOENT":a=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=d.FileSystemProviderErrorCode.NoPermissions;break;default:a=d.FileSystemProviderErrorCode.Unknown}return(0,d.createFileSystemProviderError)(r,a)}async toFileSystemProviderWriteError(r,a){let g=this.toFileSystemProviderError(a);if(r&&g.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:p}=await E.SymlinkSupport.stat(this.toFilePath(r));p.mode&128||(g=(0,d.createFileSystemProviderError)(a,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(p){this.logService.trace(p)}return g}dispose(){super.dispose(),(0,n.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,n.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=l}),define(Z[21],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService")}),define(Z[183],x([0,1,58,6,21]),function(K,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let D=class{constructor(n,f){this.productService=n,this.logService=f,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,f){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const w=/^(.*)#([^#]+)$/.exec(f);if(!w)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,i,P]=w;let E=this.trustedExtensionUrlPublicKeys.get(n);if(!E){if(E=this.productService.trustedExtensionUrlPublicKeys[n],!E||E.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...E])}const y=Buffer.from(decodeURIComponent(P),"base64");if(y.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const d=y.slice(0,6),m=y.readUIntBE(0,6),b=Date.now()-m;if(b<0||b>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const S=y.slice(6),c=v.createVerify("SHA256");c.write(d),c.write(Buffer.from(i)),c.end();for(let h=0;h<E.length;h++){let o=E[h];if(o!==null){if(typeof o=="string")try{o=v.createPublicKey({key:Buffer.from(o,"base64"),format:"der",type:"spki"}),E[h]=o}catch(u){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${h+1} for ${n}:`,u),E[h]=null;continue}if(c.verify(o,S))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};D=he([ie(0,M.IProductService),ie(1,L.ILogService)],D),e.ExtensionUrlTrustService=D}),define(Z[55],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,v.createDecorator)("protocolMainService")}),define(Z[184],x([0,1,14,2,37,10,3,15,8,28,48,6]),function(K,e,v,L,M,D,I,n,f,w,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let E=class extends L.Disposable{constructor(d,m){super();this.logService=m,this.validRoots=M.TernarySearchTree.forUris(()=>!I.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(f.URI.file(d.appRoot)),this.addValidFileRoot(f.URI.file(d.extensionsPath)),this.addValidFileRoot(d.globalStorageHome),this.addValidFileRoot(d.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:d}=v.session;d.protocol.registerFileProtocol(D.Schemas.vscodeFileResource,(m,b)=>this.handleResourceRequest(m,b)),d.protocol.interceptFileProtocol(D.Schemas.file,(m,b)=>this.handleFileRequest(m,b)),this._register((0,L.toDisposable)(()=>{d.protocol.unregisterProtocol(D.Schemas.vscodeFileResource),d.protocol.uninterceptProtocol(D.Schemas.file)}))}addValidFileRoot(d){return this.validRoots.get(d)?L.Disposable.None:(this.validRoots.set(d,!0),(0,L.toDisposable)(()=>this.validRoots.delete(d)))}handleFileRequest(d,m){const b=f.URI.parse(d.url);return this.logService.error(`Refused to load resource ${b.fsPath} from ${D.Schemas.file}: protocol (original URL: ${d.url})`),m({error:-3})}handleResourceRequest(d,m){const b=f.URI.parse(d.url),S=D.FileAccess.asFileUri(b);return this.validRoots.findSubstr(S)?m({path:S.fsPath}):this.validExtensions.has((0,n.extname)(S))?m({path:S.fsPath}):(this.logService.error(`${D.Schemas.vscodeFileResource}: Refused to load resource ${S.fsPath} from ${D.Schemas.vscodeFileResource}: protocol (original URL: ${d.url})`),m({error:-3}))}createIPCObjectUrl(){let d;const m=f.URI.from({scheme:"vscode",path:(0,w.generateUuid)()}),b=m.toString(),S=async()=>d;return v.ipcMain.handle(b,S),this.logService.trace(`IPC Object URL: Registered new channel ${b}.`),{resource:m,update:c=>d=c,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${b}.`),v.ipcMain.removeHandler(b)}}}};E=he([ie(0,i.INativeEnvironmentService),ie(1,P.ILogService)],E),e.ProtocolMainService=E}),define(Z[38],x([0,1,103,13]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class M{constructor(){this.data=new Map}add(I,n){v.ok(L.isString(I)),v.ok(L.isObject(n)),v.ok(!this.data.has(I),"There is already an extension with this id"),this.data.set(I,n)}knows(I){return this.data.has(I)}as(I){return this.data.get(I)||null}}e.Registry=new M}),define(Z[185],x([0,1,4,38]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function M(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class D{constructor(){this._onDidChangeSchema=new v.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,w){this.schemasById[M(f)]=w,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const I=new D;L.Registry.add(e.Extensions.JSONContribution,I)}),define(Z[49],x([0,1,30,4,13,132,185,38]),function(K,e,v,L,M,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var f;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(f=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var w;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(w=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const i=n.Registry.as(I.Extensions.JSONContribution);class P{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(h,o=!0){this.registerConfigurations([h],o)}registerConfigurations(h,o=!0){const u=this.doRegisterConfigurations(h,o);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(h){const o=this.doDeregisterConfigurations(h);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}updateConfigurations({add:h,remove:o}){const u=[];u.push(...this.doDeregisterConfigurations(o)),u.push(...this.doRegisterConfigurations(h,!1)),i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,v.distinct)(u))}registerDefaultConfigurations(h){const o=[],u=[];for(const t of h)for(const l in t)if(o.push(l),e.OVERRIDE_PROPERTY_PATTERN.test(l)){this.defaultValues[l]={...this.defaultValues[l]||{},...t[l]};const s={type:"object",default:this.defaultValues[l],description:D.localize(1,null,l),$ref:e.resourceLanguageSettingsSchemaId};u.push(y(l)),this.configurationProperties[l]=s,this.defaultLanguageConfigurationOverridesNode.properties[l]=s}else{this.defaultValues[l]=t[l];const s=this.configurationProperties[l];s&&(this.updatePropertyDefaultValue(l,s),this.updateSchema(l,s))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(h){const o=[];for(const u of h)for(const t in u)if(o.push(t),delete this.defaultValues[t],e.OVERRIDE_PROPERTY_PATTERN.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const l=this.configurationProperties[t];l&&(this.updatePropertyDefaultValue(t,l),this.updateSchema(t,l))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...h){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(h){for(const o of h)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(h,o){const u=[];return h.forEach(t=>{u.push(...this.validateAndRegisterProperties(t,o,t.extensionInfo)),this.configurationContributors.push(t),this.registerJSONConfiguration(t)}),u}doDeregisterConfigurations(h){const o=[],u=t=>{if(t.properties)for(const l in t.properties)o.push(l),delete this.configurationProperties[l],this.removeFromSchema(l,t.properties[l]);t.allOf&&t.allOf.forEach(l=>u(l))};for(const t of h){u(t);const l=this.configurationContributors.indexOf(t);l!==-1&&this.configurationContributors.splice(l,1)}return o}validateAndRegisterProperties(h,o=!0,u,t=3){t=M.isUndefinedOrNull(h.scope)?t:h.scope;let l=[],s=h.properties;if(s)for(let a in s){if(o&&b(a)){delete s[a];continue}const g=s[a];if(this.updatePropertyDefaultValue(a,g),e.OVERRIDE_PROPERTY_PATTERN.test(a)?g.scope=void 0:(g.scope=M.isUndefinedOrNull(g.scope)?t:g.scope,g.restricted=M.isUndefinedOrNull(g.restricted)?!!u?.restrictedConfigurations?.includes(a):g.restricted),s[a].hasOwnProperty("included")&&!s[a].included){this.excludedConfigurationProperties[a]=s[a],delete s[a];continue}else this.configurationProperties[a]=s[a];!s[a].deprecationMessage&&s[a].markdownDeprecationMessage&&(s[a].deprecationMessage=s[a].markdownDeprecationMessage),l.push(a)}let r=h.allOf;if(r)for(let a of r)l.push(...this.validateAndRegisterProperties(a,o,u,t));return l}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(h){const o=u=>{let t=u.properties;if(t)for(const s in t)this.updateSchema(s,t[s]);let l=u.allOf;l&&l.forEach(o)};o(h)}updateSchema(h,o){switch(e.allSettings.properties[h]=o,o.scope){case 1:e.applicationSettings.properties[h]=o;break;case 2:e.machineSettings.properties[h]=o;break;case 6:e.machineOverridableSettings.properties[h]=o;break;case 3:e.windowSettings.properties[h]=o;break;case 4:e.resourceSettings.properties[h]=o;break;case 5:e.resourceSettings.properties[h]=o,this.resourceLanguageSettingsSchema.properties[h]=o;break}}removeFromSchema(h,o){switch(delete e.allSettings.properties[h],o.scope){case 1:delete e.applicationSettings.properties[h];break;case 2:delete e.machineSettings.properties[h];break;case 6:delete e.machineOverridableSettings.properties[h];break;case 3:delete e.windowSettings.properties[h];break;case 4:case 5:delete e.resourceSettings.properties[h];break}}updateOverridePropertyPatternKey(){for(const h of this.overrideIdentifiers.values()){const o=`[${h}]`,u={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,u),e.allSettings.properties[o]=u,e.applicationSettings.properties[o]=u,e.machineSettings.properties[o]=u,e.machineOverridableSettings.properties[o]=u,e.windowSettings.properties[o]=u,e.resourceSettings.properties[o]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(h,o){let u=this.defaultValues[h];M.isUndefined(u)&&(u=o.default),M.isUndefined(u)&&(u=d(o.type)),o.default=u}}const E="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(E);function y(c){return c.substring(1,c.length-1)}e.overrideIdentifierFromKey=y;function d(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const m=new P;n.Registry.add(e.Extensions.Configuration,m);function b(c){return c.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(c)?D.localize(5,null,c):m.getConfigurationProperties()[c]!==void 0?D.localize(6,null,c):null:D.localize(4,null)}e.validateProperty=b;function S(){const c=[],h=m.getConfigurationProperties();for(const o of Object.keys(h))c.push([o,h[o].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=S}),define(Z[16],x([0,1,44,13,8,49,5,38]),function(K,e,v,L,M,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function f(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof M.URI)}e.isConfigurationOverrides=f;var w;(function(l){l[l.USER=1]="USER",l[l.USER_LOCAL=2]="USER_LOCAL",l[l.USER_REMOTE=3]="USER_REMOTE",l[l.WORKSPACE=4]="WORKSPACE",l[l.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",l[l.DEFAULT=6]="DEFAULT",l[l.MEMORY=7]="MEMORY"})(w=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(l){switch(l){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function P(l,s){const r=s?l?s.keys.filter(O=>l.keys.indexOf(O)===-1):[...s.keys]:[],a=l?s?l.keys.filter(O=>s.keys.indexOf(O)===-1):[...l.keys]:[],g=[];if(s&&l){for(const O of l.keys)if(s.keys.indexOf(O)!==-1){const V=S(l.contents,O),ne=S(s.contents,O);v.equals(V,ne)||g.push(O)}}const p=[],k=O=>{const V={};for(const ne of O)for(const se of ne.identifiers)V[u(se)]=ne;return V},R=s?k(s.overrides):{},T=l?k(l.overrides):{};if(Object.keys(R).length)for(const O of r){const V=R[O];V&&p.push([(0,D.overrideIdentifierFromKey)(O),V.keys])}if(Object.keys(T).length)for(const O of a){const V=T[O];V&&p.push([(0,D.overrideIdentifierFromKey)(O),V.keys])}if(Object.keys(R).length&&Object.keys(T).length)for(const O of g){const V=T[O],ne=R[O];if(V&&ne){const se=P({contents:V.contents,keys:V.keys,overrides:[]},{contents:ne.contents,keys:ne.keys,overrides:[]});p.push([(0,D.overrideIdentifierFromKey)(O),[...se.added,...se.removed,...se.updated]])}}return{added:r,removed:a,updated:g,overrides:p}}e.compare=P;function E(l,s){const r=[];for(const a of Object.keys(l))if(D.OVERRIDE_PROPERTY_PATTERN.test(a)){const g={};for(const p in l[a])g[p]=l[a][p];r.push({identifiers:[(0,D.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(g),contents:y(g,s)})}return r}e.toOverrides=E;function y(l,s){const r=Object.create(null);for(let a in l)d(r,a,l[a],s);return r}e.toValuesTree=y;function d(l,s,r,a){const g=s.split("."),p=g.pop();let k=l;for(let R=0;R<g.length;R++){let T=g[R],O=k[T];switch(typeof O){case"undefined":O=k[T]=Object.create(null);break;case"object":break;default:a(`Ignoring ${s} as ${g.slice(0,R+1).join(".")} is ${JSON.stringify(O)}`);return}k=O}if(typeof k=="object"&&k!==null)try{k[p]=r}catch(R){a(`Ignoring ${s} as ${g.join(".")} is ${JSON.stringify(k)}`)}else a(`Ignoring ${s} as ${g.join(".")} is ${JSON.stringify(k)}`)}e.addToValueTree=d;function m(l,s){const r=s.split(".");b(l,r)}e.removeFromValueTree=m;function b(l,s){const r=s.shift();if(s.length===0){delete l[r];return}if(Object.keys(l).indexOf(r)!==-1){const a=l[r];typeof a=="object"&&!Array.isArray(a)&&(b(a,s),Object.keys(a).length===0&&delete l[r])}}function S(l,s,r){function a(k,R){let T=k;for(const O of R){if(typeof T!="object"||T===null)return;T=T[O]}return T}const g=s.split("."),p=a(l,g);return typeof p=="undefined"?r:p}e.getConfigurationValue=S;function c(l,s,r){Object.keys(s).forEach(a=>{a!=="__proto__"&&(a in l?L.isObject(l[a])&&L.isObject(s[a])?c(l[a],s[a],r):r&&(l[a]=s[a]):l[a]=s[a])})}e.merge=c;function h(){const l=n.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(l)}e.getConfigurationKeys=h;function o(){const l=Object.create(null),s=n.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let r in s){let a=s[r].default;d(l,r,a,g=>console.error(`Conflict in default settings: ${g}`))}return l}e.getDefaultValues=o;function u(l){return`[${l}]`}e.keyFromOverrideIdentifier=u;function t(l,s,r){const a=l.inspect(s),g=l.inspect(r);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:a.defaultValue}e.getMigratedSettingValue=t}),define(Z[186],x([0,1,30,4,40,2,37,44,13,8,16,49,38]),function(K,e,v,L,M,D,I,n,f,w,i,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class y{constructor(t={},l=[],s=[]){this._contents=t,this._keys=l,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,l){const s=this.getContentsForOverrideIdentifer(l);return s?t?(0,i.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const l of this.overrides)if(l.identifiers.indexOf(t)!==-1)return l.keys;return[]}override(t){let l=this.overrideConfigurations.get(t);return l||(l=this.createOverrideConfigurationModel(t),this.overrideConfigurations.set(t,l)),l}merge(...t){const l=n.deepClone(this.contents),s=n.deepClone(this.overrides),r=[...this.keys];for(const a of t){this.mergeContents(l,a.contents);for(const g of a.overrides){const[p]=s.filter(k=>v.equals(k.identifiers,g.identifiers));p?this.mergeContents(p.contents,g.contents):s.push(n.deepClone(g))}for(const g of a.keys)r.indexOf(g)===-1&&r.push(g)}return new y(l,r,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(t){const l=this.getContentsForOverrideIdentifer(t);if(!l||typeof l!="object"||!Object.keys(l).length)return this;let s={};for(const r of v.distinct([...Object.keys(this.contents),...Object.keys(l)])){let a=this.contents[r],g=l[r];g&&(typeof a=="object"&&typeof g=="object"?(a=n.deepClone(a),this.mergeContents(a,g)):a=g),s[r]=a}return new y(s,this.keys,this.overrides)}mergeContents(t,l){for(const s of Object.keys(l)){if(s in t&&f.isObject(t[s])&&f.isObject(l[s])){this.mergeContents(t[s],l[s]);continue}t[s]=n.deepClone(l[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?n.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const l of this.overrides)if(l.identifiers.indexOf(t)!==-1)return l.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,l){this.addKey(t),(0,i.addToValueTree)(this.contents,t,l,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let l=this.keys.length;for(let s=0;s<l;s++)t.indexOf(this.keys[s])===0&&(l=s);this.keys.splice(l,1,t)}removeKey(t){let l=this.keys.indexOf(t);return l!==-1?(this.keys.splice(l,1),!0):!1}}e.ConfigurationModel=y;class d extends y{constructor(){const t=(0,i.getDefaultValues)(),l=(0,i.getConfigurationKeys)(),s=[];for(const r of Object.keys(t))P.OVERRIDE_PROPERTY_PATTERN.test(r)&&s.push({identifiers:[(0,P.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(t[r]),contents:(0,i.toValuesTree)(t[r],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,l,s)}}e.DefaultConfigurationModel=d;class m{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,l){if(!f.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,l)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,l){this._raw=t;const{contents:s,keys:r,overrides:a,restricted:g}=this.doParseRaw(t,l);this._configurationModel=new y(s,r,a),this._restrictedConfigurations=g||[]}doParseContent(t){let l={},s=null,r=[],a=[],g=[];function p(R){Array.isArray(r)?r.push(R):s!==null&&(r[s]=R)}let k={onObjectBegin:()=>{let R={};p(R),a.push(r),r=R,s=null},onObjectProperty:R=>{s=R},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{let R=[];p(R),a.push(r),r=R,s=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:p,onError:(R,T,O)=>{g.push({error:R,offset:T,length:O})}};if(t)try{M.visit(t,k),l=r[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return l}doParseRaw(t,l){const s=E.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),r=this.filter(t,s,!0,l);t=r.raw;const a=(0,i.toValuesTree)(t,k=>console.error(`Conflict in settings file ${this._name}: ${k}`)),g=Object.keys(t),p=(0,i.toOverrides)(t,k=>console.error(`Conflict in settings file ${this._name}: ${k}`));return{contents:a,keys:g,overrides:p,restricted:r.restricted}}filter(t,l,s,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:t,restricted:[]};const a={},g=[];for(let p in t)if(P.OVERRIDE_PROPERTY_PATTERN.test(p)&&s){const k=this.filter(t[p],l,!1,r);a[p]=k.raw,g.push(...k.restricted)}else{const k=l[p],R=k?typeof k.scope!="undefined"?k.scope:3:void 0;k?.restricted&&g.push(p),(R===void 0||r.scopes===void 0||r.scopes.includes(R))&&(r.skipRestricted&&k?.restricted||(a[p]=t[p]))}return{raw:a,restricted:g}}}e.ConfigurationModelParser=m;class b extends D.Disposable{constructor(t,l,s,r){super();this.userSettingsResource=t,this.scopes=l,this.fileService=r,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=b;class S{constructor(t,l,s=new y,r=new y,a=new I.ResourceMap,g=new y,p=new I.ResourceMap,k=!0){this._defaultConfiguration=t,this._localUserConfiguration=l,this._remoteUserConfiguration=s,this._workspaceConfiguration=r,this._folderConfigurations=a,this._memoryConfiguration=g,this._memoryConfigurationByResource=p,this._freeze=k,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(t,l,s){return this.getConsolidateConfigurationModel(l,s).getValue(t)}updateValue(t,l,s={}){let r;s.resource?(r=this._memoryConfigurationByResource.get(s.resource),r||(r=new y,this._memoryConfigurationByResource.set(s.resource,r))):r=this._memoryConfiguration,l===void 0?r.removeValue(t):r.setValue(t,l),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,l,s){const r=this.getConsolidateConfigurationModel(l,s),a=this.getFolderConfigurationModelForResource(l.resource,s),g=l.resource?this._memoryConfigurationByResource.get(l.resource)||this._memoryConfiguration:this._memoryConfiguration,p=l.overrideIdentifier?this._defaultConfiguration.freeze().override(l.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),k=l.overrideIdentifier?this.userConfiguration.freeze().override(l.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),R=l.overrideIdentifier?this.localUserConfiguration.freeze().override(l.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),T=l.overrideIdentifier?this.remoteUserConfiguration.freeze().override(l.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),O=s?l.overrideIdentifier?this._workspaceConfiguration.freeze().override(l.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,V=a?l.overrideIdentifier?a.freeze().override(l.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,ne=l.overrideIdentifier?g.override(l.overrideIdentifier).getValue(t):g.getValue(t),se=r.getValue(t),G=v.distinct(v.flatten(r.overrides.map(te=>te.identifiers))).filter(te=>r.getOverrideValue(t,te)!==void 0);return{defaultValue:p,userValue:k,userLocalValue:R,userRemoteValue:T,workspaceValue:O,workspaceFolderValue:V,memoryValue:ne,value:se,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:l.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,l.overrideIdentifier):void 0}:void 0,user:k!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:l.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,l.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:l.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,l.overrideIdentifier):void 0}:void 0,userRemote:T!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:l.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,l.overrideIdentifier):void 0}:void 0,workspace:O!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:l.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,l.overrideIdentifier):void 0}:void 0,workspaceFolder:V!==void 0?{value:a?.freeze().getValue(t),override:l.overrideIdentifier?a?.freeze().getOverrideValue(t,l.overrideIdentifier):void 0}:void 0,memory:ne!==void 0?{value:g.getValue(t),override:l.overrideIdentifier?g.getOverrideValue(t,l.overrideIdentifier):void 0}:void 0,overrideIdentifiers:G.length?G:void 0}}keys(t){const l=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:l?l.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,l){this._folderConfigurations.set(t,l),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,l){const s=l.filter(r=>P.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const a=(0,P.overrideIdentifierFromKey)(r),g=this._defaultConfiguration.getKeysForOverrideIdentifier(a),p=t.getKeysForOverrideIdentifier(a),k=[...p.filter(R=>g.indexOf(R)===-1),...g.filter(R=>p.indexOf(R)===-1),...g.filter(R=>!n.equals(this._defaultConfiguration.override(a).getValue(R),t.override(a).getValue(R)))];return[a,k]});return this.updateDefaultConfiguration(t),{keys:l,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:l,updated:s,removed:r,overrides:a}=(0,i.compare)(this.localUserConfiguration,t),g=[...l,...s,...r];return g.length&&this.updateLocalUserConfiguration(t),{keys:g,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:l,updated:s,removed:r,overrides:a}=(0,i.compare)(this.remoteUserConfiguration,t);let g=[...l,...s,...r];return g.length&&this.updateRemoteUserConfiguration(t),{keys:g,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:l,updated:s,removed:r,overrides:a}=(0,i.compare)(this.workspaceConfiguration,t);let g=[...l,...s,...r];return g.length&&this.updateWorkspaceConfiguration(t),{keys:g,overrides:a}}compareAndUpdateFolderConfiguration(t,l){const s=this.folderConfigurations.get(t),{added:r,updated:a,removed:g,overrides:p}=(0,i.compare)(s,l);let k=[...r,...a,...g];return(k.length||!s)&&this.updateFolderConfiguration(t,l),{keys:k,overrides:p}}compareAndDeleteFolderConfiguration(t){const l=this.folderConfigurations.get(t);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:r,removed:a,overrides:g}=(0,i.compare)(l,void 0);return{keys:[...s,...r,...a],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,l){let s=this.getConsolidatedConfigurationModelForResource(t,l);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},l){let s=this.getWorkspaceConsolidatedConfiguration();if(l&&t){const r=l.getFolder(t);r&&(s=this.getFolderConsolidatedConfiguration(r.uri)||s);const a=this._memoryConfigurationByResource.get(t);a&&(s=s.merge(a))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let l=this._foldersConsolidatedConfigurations.get(t);if(!l){const s=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(t);r?(l=s.merge(r),this._freeze&&(l=l.freeze()),this._foldersConsolidatedConfigurations.set(t,l)):l=s}return l}getFolderConfigurationModelForResource(t,l){if(l&&t){const s=l.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,l)=>{const{contents:s,overrides:r,keys:a}=this._folderConfigurations.get(l);return t.push([l,{contents:s,overrides:r,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(l=>t.add(l)),this.userConfiguration.freeze().keys.forEach(l=>t.add(l)),this._workspaceConfiguration.freeze().keys.forEach(l=>t.add(l)),this._folderConfigurations.forEach(l=>l.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const l=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>l.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>l.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>l.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(r=>l.add(r))),[...l.values()]}static parse(t){const l=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),r=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((g,p)=>(g.set(w.URI.revive(p[0]),this.parseConfigurationModel(p[1])),g),new I.ResourceMap);return new S(l,s,new y,r,a,new y,new I.ResourceMap,!1)}static parseConfigurationModel(t){return new y(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=S;function c(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const t=new Set,l=new Map;for(const r of u)r.keys.forEach(a=>t.add(a)),r.overrides.forEach(([a,g])=>{const p=(0,I.getOrSet)(l,a,new Set);g.forEach(k=>p.add(k))});const s=[];return l.forEach((r,a)=>s.push([a,[...r.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=c;class h{constructor(t,l,s,r){this.change=t,this.previous=l,this.currentConfiguraiton=s,this.currentWorkspace=r,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(p=>a.add(p)),t.overrides.forEach(([,p])=>p.forEach(k=>a.add(k))),this.affectedKeys=[...a.values()];const g=new y;this.affectedKeys.forEach(p=>g.setValue(p,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=S.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,l){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(l){const s=this.previousConfiguration?this.previousConfiguration.getValue(t,l,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(t,l,this.currentWorkspace);return!n.equals(s,r)}return!0}return!1}doesAffectedKeysTreeContains(t,l){let s=(0,i.toValuesTree)({[l]:!0},()=>{}),r;for(;typeof s=="object"&&(r=Object.keys(s)[0]);){if(t=t[r],!t)return!1;s=s[r]}return!0}}e.ConfigurationChangeEvent=h;class o extends h{constructor(t,l,s,r){super({keys:t.allKeys(),overrides:[]},void 0,t,l);this.source=s,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=o}),define(Z[187],x([0,1,9,4,2,15,16,186,49,38]),function(K,e,v,L,M,D,I,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends M.Disposable{constructor(E,y){super();this.settingsResource=E,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new n.UserSettings(this.settingsResource,void 0,D.extUriBiasedIgnorePathCase,y)),this.configuration=new n.Configuration(new n.DefaultConfigurationModel,new n.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new v.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(w.Registry.as(f.Extensions.Configuration).onDidUpdateConfiguration(d=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const E=await this.userConfiguration.loadConfiguration();this.configuration=new n.Configuration(new n.DefaultConfigurationModel,E)}getConfigurationData(){return this.configuration.toData()}getValue(E,y){const d=typeof E=="string"?E:void 0,m=(0,I.isConfigurationOverrides)(E)?E:(0,I.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(d,m,void 0)}updateValue(E,y,d,m){return Promise.reject(new Error("not supported"))}inspect(E){return this.configuration.inspect(E,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const E=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(E)}onDidChangeUserConfiguration(E){const y=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(E);this.trigger(d,y,1)}onDidDefaultConfigurationChange(E){const y=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new n.DefaultConfigurationModel,E);this.trigger(d,y,6)}trigger(E,y,d){const m=new n.ConfigurationChangeEvent(E,{data:y},this.configuration);m.source=d,m.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(E){switch(E){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(Z[188],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,v.createDecorator)("remoteAuthorityResolverService");var L;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class M extends Error{constructor(I,n=L.Unknown,f){super(I);this._message=I,this._code=n,this._detail=f,this.isHandled=n===L.NotAvailable&&f===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,M.prototype)}static isTemporarilyNotAvailable(I){return I instanceof M&&I._code===L.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof M&&I._code===L.NoResolverFound}static isHandled(I){return I instanceof M&&I.isHandled}}e.RemoteAuthorityResolverError=M}),define(Z[189],x([0,1,9,18,23,17,4,2,28,84,188]),function(K,e,v,L,M,D,I,n,f,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const P=30*1e3;var E;(function(C){C[C.Management=1]="Management",C[C.ExtensionHost=2]="ExtensionHost",C[C.Tunnel=3]="Tunnel"})(E=e.ConnectionType||(e.ConnectionType={}));function y(C){switch(C){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(C){const A=new M.CancellationTokenSource;return setTimeout(()=>A.cancel(),C),A.token}function m(C,A){if(C.isCancellationRequested||A.isCancellationRequested)return M.CancellationToken.Cancelled;const W=new M.CancellationTokenSource;return C.onCancellationRequested(()=>W.cancel()),A.onCancellationRequested(()=>W.cancel()),W.token}class b{constructor(A){this._state="pending",this._disposables=new n.DisposableStore,this.promise=new Promise((W,B)=>{this._resolvePromise=W,this._rejectPromise=B}),A.isCancellationRequested?this._timeout():this._disposables.add(A.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(A){this._state==="pending"?this._disposables.add(A):A.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(A))}reject(A){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(A))}}function S(C,A){const W=new b(A);return W.registerDisposable(C.onControlMessage(B=>{const Y=JSON.parse(B.toString()),U=q(Y);U?W.reject(U):W.resolve(Y)})),W.promise}function c(C,A,W,B,Y,U){const N=new b(U);return A.connect(W,B,Y,(Q,J)=>{N.didTimeout?(Q&&C.error(Q),J?.dispose()):Q||!J?N.reject(Q):N.resolve(J)}),N.promise}function h(C,A){const W=new b(A);return C.then(B=>{W.didTimeout||W.resolve(B)},B=>{W.didTimeout||W.reject(B)}),W.promise}async function o(C,A,W,B){const Y=_(C,A);C.logService.trace(`${Y} 1/6. invoking socketFactory.connect().`);let U;try{U=await c(C.logService,C.socketFactory,C.host,C.port,`reconnectionToken=${C.reconnectionToken}&reconnection=${C.reconnectionProtocol?"true":"false"}`,B)}catch(re){throw C.logService.error(`${Y} socketFactory.connect() failed or timed out. Error:`),C.logService.error(re),re}C.logService.trace(`${Y} 2/6. socketFactory.connect() was successful.`);let N,Q;C.reconnectionProtocol?(C.reconnectionProtocol.beginAcceptReconnection(U,null),N=C.reconnectionProtocol,Q=!1):(N=new w.PersistentProtocol(U,null),Q=!0),C.logService.trace(`${Y} 3/6. sending AuthRequest control message.`);const J={type:"auth",auth:C.connectionToken||"00000000000000000000"};N.sendControl(L.VSBuffer.fromString(JSON.stringify(J)));try{const re=await S(N,m(B,d(1e4)));if(re.type!=="sign"||typeof re.data!="string"){const ae=new Error("Unexpected handshake message");throw ae.code="VSCODE_CONNECTION_ERROR",ae}C.logService.trace(`${Y} 4/6. received SignRequest control message.`);const le=await h(C.signService.sign(re.data),B),ee={type:"connectionType",commit:C.commit,signedData:le,desiredConnectionType:A};return W&&(ee.args=W),C.logService.trace(`${Y} 5/6. sending ConnectionTypeRequest control message.`),N.sendControl(L.VSBuffer.fromString(JSON.stringify(ee))),{protocol:N,ownsProtocol:Q}}catch(re){throw re&&re.code==="ETIMEDOUT"&&(C.logService.error(`${Y} the handshake timed out. Error:`),C.logService.error(re)),re&&re.code==="VSCODE_CONNECTION_ERROR"&&(C.logService.error(`${Y} received error control message when negotiating connection. Error:`),C.logService.error(re)),Q&&j(N),re}}async function u(C,A,W,B){const Y=Date.now(),U=_(C,A),{protocol:N,ownsProtocol:Q}=await o(C,A,W,B),J=new b(B);return J.registerDisposable(N.onControlMessage(re=>{const le=JSON.parse(re.toString()),ee=q(le);ee?(C.logService.error(`${U} received error control message when negotiating connection. Error:`),C.logService.error(ee),Q&&j(N),J.reject(ee)):(C.reconnectionProtocol&&C.reconnectionProtocol.endAcceptReconnection(),C.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${z(Y)}!`),J.resolve({protocol:N,firstMessage:le}))})),J.promise}async function t(C,A){const{protocol:W}=await u(C,1,void 0,A);return{protocol:W}}async function l(C,A,W){const{protocol:B,firstMessage:Y}=await u(C,2,A,W),U=Y&&Y.debugPort;return{protocol:B,debugPort:U}}async function s(C,A,W){const B=Date.now(),Y=_(C,3),{protocol:U}=await o(C,3,A,W);return C.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${z(B)}!`),U}async function r(C,A,W){const{host:B,port:Y,connectionToken:U}=await C.addressProvider.getAddress();return{commit:C.commit,host:B,port:Y,connectionToken:U,reconnectionToken:A,reconnectionProtocol:W,socketFactory:C.socketFactory,signService:C.signService,logService:C.logService}}async function a(C,A,W){try{const B=(0,f.generateUuid)(),Y=await r(C,B,null),{protocol:U}=await t(Y,M.CancellationToken.None);return new te(C,A,W,B,U)}catch(B){throw C.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),C.logService.error(B),G.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(B)),B}}e.connectRemoteAgentManagement=a;async function g(C,A){try{const W=(0,f.generateUuid)(),B=await r(C,W,null),{protocol:Y,debugPort:U}=await l(B,A,M.CancellationToken.None);return new F(C,A,W,Y,U)}catch(W){throw C.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),C.logService.error(W),G.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(W)),W}}e.connectRemoteAgentExtensionHost=g;async function p(C,A,W){const B=await r(C,(0,f.generateUuid)(),null);return await s(B,{host:A,port:W},M.CancellationToken.None)}e.connectRemoteAgentTunnel=p;function k(C){return(0,v.createCancelablePromise)(A=>new Promise((W,B)=>{const Y=setTimeout(W,C*1e3);A.onCancellationRequested(()=>{clearTimeout(Y),W()})}))}var R;(function(C){C[C.ConnectionLost=0]="ConnectionLost",C[C.ReconnectionWait=1]="ReconnectionWait",C[C.ReconnectionRunning=2]="ReconnectionRunning",C[C.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",C[C.ConnectionGain=4]="ConnectionGain"})(R=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class T{constructor(A,W){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.type=0}}e.ConnectionLostEvent=T;class O{constructor(A,W,B,Y){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.durationSeconds=B,this.cancellableTimer=Y,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=O;class V{constructor(A,W,B){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.attempt=B,this.type=2}}e.ReconnectionRunningEvent=V;class ne{constructor(A,W,B){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.attempt=B,this.type=4}}e.ConnectionGainEvent=ne;class se{constructor(A,W,B,Y){this.reconnectionToken=A,this.millisSinceLastIncomingData=W,this.attempt=B,this.handled=Y,this.type=3}}e.ReconnectionPermanentFailureEvent=se;class G extends n.Disposable{constructor(A,W,B,Y){super();this._connectionType=A,this._onDidStateChange=this._register(new I.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=W,this.reconnectionToken=B,this.protocol=Y,this._isReconnecting=!1,this._onDidStateChange.fire(new ne(this.reconnectionToken,0,0)),this._register(Y.onSocketClose(U=>{const N=H(this._connectionType,this.reconnectionToken,!0);U?U.type===0?(this._options.logService.info(`${N} received socket close event (hadError: ${U.hadError}).`),U.error&&this._options.logService.error(U.error)):(this._options.logService.info(`${N} received socket close event (wasClean: ${U.wasClean}, code: ${U.code}, reason: ${U.reason}).`),U.event&&this._options.logService.error(U.event)):this._options.logService.info(`${N} received socket close event.`),this._beginReconnecting()})),this._register(Y.onSocketTimeout(()=>{const U=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${U} received socket timeout event.`),this._beginReconnecting()})),G._instances.push(this),G._permanentFailure&&this._gotoPermanentFailure(G._permanentFailureMillisSinceLastIncomingData,G._permanentFailureAttempt,G._permanentFailureHandled)}static triggerPermanentFailure(A,W,B){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=A,this._permanentFailureAttempt=W,this._permanentFailureHandled=B,this._instances.forEach(Y=>Y._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(G._permanentFailure)return;const A=H(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const Y=B<W.length?W[B]:W[W.length-1];try{if(Y>0){const N=k(Y);this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y,N)),this._options.logService.info(`${A} waiting for ${Y} seconds before reconnecting...`);try{await N}catch{}}if(G._permanentFailure){this._options.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this._options.logService.info(`${A} resolving connection...`);const U=await r(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${A} connecting to ${U.host}:${U.port}...`),await this._reconnect(U,d(P)),this._options.logService.info(`${A} reconnected!`),this._onDidStateChange.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(U){if(U.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(U),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this._options.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(U),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(i.RemoteAuthorityResolverError.isTemporarilyNotAvailable(U)){this._options.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(U);continue}if((U.code==="ETIMEDOUT"||U.code==="ENETUNREACH"||U.code==="ECONNREFUSED"||U.code==="ECONNRESET")&&U.syscall==="connect"){this._options.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(U);continue}if((0,D.isPromiseCanceledError)(U)){this._options.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(U);continue}if(U instanceof i.RemoteAuthorityResolverError){this._options.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(U),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,i.RemoteAuthorityResolverError.isHandled(U));break}this._options.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(U),G.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!G._permanentFailure)}_gotoPermanentFailure(A,W,B){this._onDidStateChange.fire(new se(this.reconnectionToken,A,W,B)),j(this.protocol)}}G._permanentFailure=!1,G._permanentFailureMillisSinceLastIncomingData=0,G._permanentFailureAttempt=0,G._permanentFailureHandled=!1,G._instances=[];class te extends G{constructor(A,W,B,Y,U){super(1,A,Y,U);this.client=this._register(new w.Client(U,{remoteAuthority:W,clientId:B},A.ipcLogger))}async _reconnect(A,W){await t(A,W)}}e.ManagementPersistentConnection=te;class F extends G{constructor(A,W,B,Y,U){super(2,A,B,Y);this._startArguments=W,this.debugPort=U}async _reconnect(A,W){await l(A,this._startArguments,W)}}e.ExtensionHostPersistentConnection=F;function j(C){try{C.acceptDisconnect();const A=C.getSocket();C.dispose(),A.dispose()}catch(A){(0,D.onUnexpectedError)(A)}}function q(C){if(C&&C.type==="error"){const A=new Error(`Connection error: ${C.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function $(C,A){for(;C.length<A;)C+=" ";return C}function H(C,A,W){return`[remote-connection][${$(y(C),13)}][${A.substr(0,5)}\u2026][${W?"reconnect":"initial"}]`}function _(C,A){return`${H(A,C.reconnectionToken,!!C.reconnectionProtocol)}[${C.host}:${C.port}]`}function z(C){return`${Date.now()-C} ms`}}),define(Z[61],x([0,1,10]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(w){return w.scheme===v.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=L;function M(w){if(!w)return;const i=w.indexOf("+");return i<0?w:w.substr(0,i)}e.getRemoteName=M;function D(w){return w.scheme!==v.Schemas.file&&w.scheme!==v.Schemas.vscodeRemote}e.isVirtualResource=D;function I(w){if(w.folders.length)return w.folders.every(i=>D(i.uri))?w.folders[0].uri:void 0;if(w.configuration&&D(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=I;function n(w){return I(w)?.scheme}e.getVirtualWorkspaceScheme=n;function f(w){return I(w)!==void 0}e.isVirtualWorkspace=f}),define(Z[190],x([0,1,25,5,61]),function(K,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=D;function I(E){return E&&typeof E=="object"&&typeof E.id=="string"&&(!E.uuid||typeof E.uuid=="string")}e.isIExtensionIdentifier=I,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var n;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(n=e.ExtensionType||(e.ExtensionType={}));class f{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,d){if(typeof y=="undefined"||y===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof y=="string"||typeof d=="string"){let m=typeof y=="string"?y:y.value,b=typeof d=="string"?d:d.value;return v.equalsIgnoreCase(m,b)}return y._lower===d._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=f;function w(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function i(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=i;function P(E,y){if(y&&E.enableProposedApi){const d=`onResolveRemoteAuthority:${(0,M.getRemoteName)(y)}`;return E.activationEvents?.indexOf(d)!==-1}return!1}e.isResolverExtension=P,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[191],x([0,1,25,190]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function M(d,m){return d.uuid&&m.uuid?d.uuid===m.uuid:d.id===m.id?!0:(0,v.compareIgnoreCase)(d.id,m.id)===0}e.areSameExtensions=M;class D{constructor(m,b){this.version=b,this.id=m.id,this.uuid=m.uuid}key(){return`${this.id}-${this.version}`}equals(m){return m instanceof D?M(this,m)&&this.version===m.version:!1}}e.ExtensionIdentifierWithVersion=D;function I(d,m){return`${d}.${m}`}e.getExtensionId=I;function n(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function f(d,m){return n(I(d,m))}e.getGalleryExtensionId=f;function w(d,m){const b=[],S=c=>{for(const h of b)if(h.some(o=>M(m(o),m(c))))return h;return null};for(const c of d){const h=S(c);h?h.push(c):b.push([c])}return b}e.groupByExtension=w;function i(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function P(d){return{id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),...d.telemetryData}}e.getGalleryExtensionTelemetryData=P,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function E(d){const m=new Set;for(const b of d)b.malicious&&m.add(b.id.id);return m}e.getMaliciousExtensionsSet=E;function y(d,m){const b=[],S=m.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const c=S.shift();if(c&&b.every(h=>!M(h.identifier,{id:c}))){const h=d.filter(o=>M(o.identifier,{id:c}));h.length===1&&(b.push(h[0]),S.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.getExtensionDependencies=y}),define(Z[96],x([0,1,4,3,5,6]),function(K,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,M.createDecorator)("tunnelService");var I;(function(d){d.Http="http",d.Https="https"})(I=e.TunnelProtocol||(e.TunnelProtocol={}));var n;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(n=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var f;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(f=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function w(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const m=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(!!m)return{address:m[1],port:+m[2]}}e.extractLocalHostUriMetaDataForPortMapping=w,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function i(d){return e.LOCALHOST_ADDRESSES.indexOf(d)>=0}e.isLocalhost=i,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(d){return e.ALL_INTERFACES_ADDRESSES.indexOf(d)>=0}e.isAllInterfaces=P;function E(d,m){return m?m!==1&&d<1024:!L.isWindows&&d<1024}e.isPortPrivileged=E;let y=class{constructor(m){this.logService=m,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new v.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(m,b){return this._tunnelProvider=m,m?(this._canElevate=b.elevation,this._privacyOptions=b.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return new Promise(async m=>{const b=[],S=Array.from(this._tunnels.values());for(let c of S){const h=Array.from(c.values());for(let o of h){const u=await o.value;u&&b.push(u)}}m(b)})}async dispose(){for(const m of this._tunnels.values()){for(const{value:b}of m.values())await b.then(S=>S?.dispose());m.clear()}this._tunnels.clear()}openTunnel(m,b,S,c,h=!1,o=n.Private,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${b}:${S} on local port ${c}.`),!m)return;b||(b="localhost");const t=this.retainOrCreateTunnel(m,b,S,c,h,o,u);return t?t.then(l=>{if(!l){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(b,S);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(l);return(l.tunnelRemoteHost!==b||l.tunnelRemotePort!==S)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}makeTunnel(m){return{tunnelRemotePort:m.tunnelRemotePort,tunnelRemoteHost:m.tunnelRemoteHost,tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress,privacy:m.privacy,protocol:m.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${m.tunnelRemoteHost}:${m.tunnelRemotePort} `);const b=this._tunnels.get(m.tunnelRemoteHost);if(b){const S=b.get(m.tunnelRemotePort);S&&(S.refcount--,await this.tryDisposeTunnel(m.tunnelRemoteHost,m.tunnelRemotePort,S))}}}}async tryDisposeTunnel(m,b,S){if(S.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${m}:${b}.`);const c=S.value.then(async h=>{h&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(m)&&this._tunnels.get(m).delete(b),c}}async closeTunnel(m,b){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${m}:${b} `);const S=this._tunnels.get(m);if(S&&S.has(b)){const c=S.get(b);c.refcount=0,await this.tryDisposeTunnel(m,b,c)}}addTunnelToMap(m,b,S){this._tunnels.has(m)||this._tunnels.set(m,new Map),this._tunnels.get(m).set(b,{refcount:1,value:S})}async removeEmptyTunnelFromMap(m,b){const S=this._tunnels.get(m);S&&(await S.get(b)||S.delete(b),S.size===0&&this._tunnels.delete(m))}getTunnelFromMap(m,b){let S=[m];i(m)?(S.push(...e.LOCALHOST_ADDRESSES),S.push(...e.ALL_INTERFACES_ADDRESSES)):P(m)&&S.push(...e.ALL_INTERFACES_ADDRESSES);const c=S.map(h=>this._tunnels.get(h));for(const h of c){const o=h?.get(b);if(o)return o}}canTunnel(m){return!!w(m)}createWithProvider(m,b,S,c,h,o,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${b}:${S} on local port ${c}.`);const l={elevationRequired:h?E(c===void 0?S:c):!1},s={remoteAddress:{host:b,port:S},localAddressPort:c,privacy:o,public:o!==n.Private,protocol:u},r=m.forwardPort(s,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(b,S,r),r}};y=he([ie(0,D.ILogService)],y),e.AbstractTunnelService=y}),define(Z[50],x([0,1,18,147,49,5,38]),function(K,e,v,L,M,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,D.createDecorator)("requestService");function n(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=n;function f(d){return d.res.statusCode===204}async function w(d){if(!n(d))throw new Error("Server returned "+d.res.statusCode);return f(d)?null:(await(0,v.streamToBuffer)(d.stream)).toString()}e.asText=w;async function i(d){if(!n(d))throw new Error("Server returned "+d.res.statusCode);if(f(d))return null;const b=(await(0,v.streamToBuffer)(d.stream)).toString();try{return JSON.parse(b)}catch(S){throw S.message+=`:
`+b,S}}e.asJson=i;function P(d){y(d)}e.updateProxyConfigurationsScope=P;let E;function y(d){const m=I.Registry.as(M.Extensions.Configuration),b=E;E={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},m.updateConfigurations({add:[E],remove:b?[b]:[]})}y(2)}),define(Z[192],x([0,1,193,13]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function M(I,n){return I.protocol==="http:"?n.HTTP_PROXY||n.http_proxy||null:I.protocol==="https:"&&(n.HTTPS_PROXY||n.https_proxy||n.HTTP_PROXY||n.http_proxy)||null}async function D(I,n,f={}){const w=(0,v.parse)(I),i=f.proxyUrl||M(w,n);if(!i)return null;const P=(0,v.parse)(i);if(!/^https?:$/.test(P.protocol||""))return null;const E={host:P.hostname||"",port:P.port||(P.protocol==="https"?"443":"80"),auth:P.auth,rejectUnauthorized:(0,L.isBoolean)(f.strictSSL)?f.strictSSL:!0};return w.protocol==="http:"?new(await new Promise((y,d)=>{K(["http-proxy-agent"],y,d)}))(E):new(await new Promise((y,d)=>{K(["https-proxy-agent"],y,d)}))(E)}e.getProxyAgent=D}),define(Z[194],x([0,1,18,28]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function M(D,I,n){let f=n&&n.get("storage.serviceMachineId",0)||null;if(f)return f;try{const i=(await I.readFile(D.serviceMachineIdResource)).value.toString();f=(0,L.isUUID)(i)?i:null}catch(w){f=null}if(!f){f=(0,L.generateUuid)();try{await I.writeFile(D.serviceMachineIdResource,v.VSBuffer.fromString(f))}catch(w){}}return n&&n.store("storage.serviceMachineId",f,0,1),f}e.getServiceMachineId=M}),define(Z[75],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,v.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[195],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{vsda(){return new Promise((M,D)=>K(["vsda"],M,D))}async sign(M){try{const D=await this.vsda(),I=new D.signer;if(I)return I.sign(M)}catch(D){}return M}}e.SignService=v}),define(Z[39],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,v.createDecorator)("stateMainService")}),define(Z[22],x([0,1,14,9,4,2,3,33,13,5,175,6,39]),function(K,e,v,L,M,D,I,n,f,w,i,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,w.createDecorator)("lifecycleMainService");var y;(function(m){m[m.Starting=1]="Starting",m[m.Ready=2]="Ready",m[m.AfterWindowOpen=3]="AfterWindowOpen"})(y=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let d=class lt extends D.Disposable{constructor(b,S){super();this.logService=b,this.stateMainService=S,this._onBeforeShutdown=this._register(new M.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new M.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new M.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new M.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new M.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(lt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(lt.QUIT_AND_RESTART_KEY)}registerListeners(){const b=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),I.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};v.app.addListener("before-quit",b);const S=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!I.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",S),v.app.once("will-quit",c=>{this.logService.trace("Lifecycle#app.on(will-quit)"),c.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",b),v.app.removeListener("window-all-closed",S),v.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const b=[];return this._onWillShutdown.fire({join(S){b.push(S)}}),this.pendingWillShutdownPromise=(async()=>{try{await L.Promises.settled(b)}catch(S){this.logService.error(S)}try{await this.stateMainService.close()}catch(S){this.logService.error(S)}})(),this.pendingWillShutdownPromise}set phase(b){if(b<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===b)return;this.logService.trace(`lifecycle (main): phase changed (value: ${b})`),this._phase=b;const S=this.phaseWhen.get(this._phase);S&&(S.open(),this.phaseWhen.delete(this._phase))}async when(b){if(b<=this._phase)return;let S=this.phaseWhen.get(b);S||(S=new L.Barrier,this.phaseWhen.set(b,S)),await S.wait()}registerWindow(b){const S=new D.DisposableStore;this.windowCounter++,S.add(b.onWillLoad(h=>this._onWillLoadWindow.fire({window:b,workspace:h.workspace,reason:h.reason})));const c=(0,f.assertIsDefined)(b.win);c.on("close",h=>{const o=b.id;if(this.windowToCloseRequest.has(o)){this.windowToCloseRequest.delete(o);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${b.id}`),h.preventDefault(),this.unload(b,1).then(u=>{if(u){this.windowToCloseRequest.delete(o);return}this.windowToCloseRequest.add(o),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this._onBeforeCloseWindow.fire(b),b.close()})}),c.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${b.id}`),this.windowCounter--,S.dispose(),this.windowCounter===0&&(!I.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(b,S){await this.unload(b,3)||b.reload(S)}async unload(b,S){if(!b.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${b.id}`);const c=this._quitRequested?2:S;let h=await this.onBeforeUnloadWindowInRenderer(b,c);return h?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${b.id})`),this.handleWindowUnloadVeto(h)):(h=await this.onBeforeUnloadWindowInMain(b,c),h?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${b.id})`),this.handleWindowUnloadVeto(h)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${b.id})`),await this.onWillUnloadWindowInRenderer(b,c),!1))}handleWindowUnloadVeto(b){return b?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(b){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(b),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(b,S){return new Promise(c=>{const h=this.oneTimeListenerTokenGenerator++,o=`vscode:ok${h}`,u=`vscode:cancel${h}`;v.ipcMain.once(o,()=>{c(!1)}),v.ipcMain.once(u,()=>{c(!0)}),b.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:u,reason:S})})}onBeforeUnloadWindowInMain(b,S){const c=[];return this._onBeforeUnloadWindow.fire({reason:S,window:b,veto(h){c.push(h)}}),(0,i.handleVetos)(c,h=>this.logService.error(h))}onWillUnloadWindowInRenderer(b,S){return new Promise(c=>{const o=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;v.ipcMain.once(o,()=>c()),b.send("vscode:onWillUnload",{replyChannel:o,reason:S})})}quit(b){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${b}`),b&&this.stateMainService.setItem(lt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(S=>{this.pendingQuitPromiseResolve=S,this.logService.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}async relaunch(b){this.logService.trace("Lifecycle#relaunch()");const S=process.argv.slice(1);if(b?.addArgs&&S.push(...b.addArgs),b?.removeArgs)for(const o of b.removeArgs){const u=S.indexOf(o);u>=0&&S.splice(u,1)}const c=()=>{try{if(I.isWindows){const o=(0,n.cwd)();o!==process.cwd()&&process.chdir(o)}}catch(o){this.logService.error(o)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:S})};v.app.once("quit",c),await this.quit(!0)&&v.app.removeListener("quit",c)}async kill(b){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,L.timeout)(1e3),(async()=>{for(const S of v.BrowserWindow.getAllWindows())if(S&&!S.isDestroyed()){let c;S.webContents&&!S.webContents.isDestroyed()?c=new Promise(h=>S.once("closed",h)):c=Promise.resolve(),S.destroy(),await c}})()]),v.app.exit(b)}};d.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",d=he([ie(0,P.ILogService),ie(1,E.IStateMainService)],d),e.LifecycleMainService=d}),define(Z[196],x([0,1,4,2,5,22]),function(K,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,M.createDecorator)("keyboardLayoutMainService");let I=class extends L.Disposable{constructor(w){super();this._onDidChangeKeyboardLayout=this._register(new v.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,w.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const w=await new Promise((i,P)=>{K(["native-keymap"],i,P)});this._keyboardLayoutData=n(w),w.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=n(w),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};I=he([ie(0,D.ILifecycleMainService)],I),e.KeyboardLayoutMainService=I;function n(f){const w=f.getKeyMap(),i=f.getCurrentKeyboardLayout();return{keyboardMapping:w,keyboardLayoutInfo:i}}}),define(Z[97],x([0,1,9,4,2,13,86,5]),function(K,e,v,L,M,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";e.IStorageService=(0,n.createDecorator)("storageService");var w;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(m){m[m.GLOBAL=0]="GLOBAL",m[m.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var P;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(P=e.StorageTarget||(e.StorageTarget={}));class E extends M.Disposable{constructor(b={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super();this.options=b,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new v.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new M.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,v.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,M.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,S){S===f?(b===0?this._globalKeyTargets=void 0:b===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:b})):this._onDidChangeValue.fire({scope:b,key:S,target:this.getKeyTargets(b)[S]})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,S,c){return this.getStorage(S)?.get(b,c)}getBoolean(b,S,c){return this.getStorage(S)?.getBoolean(b,c)}getNumber(b,S,c){return this.getStorage(S)?.getNumber(b,c)}store(b,S,c,h){if((0,D.isUndefinedOrNull)(S)){this.remove(b,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(b,c,h),this.getStorage(c)?.set(b,S)})}remove(b,S){this.withPausedEmitters(()=>{this.updateKeyTarget(b,S,void 0),this.getStorage(S)?.delete(b)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,S){const c=[],h=this.getKeyTargets(b);for(const o of Object.keys(h))h[o]===S&&c.push(o);return c}updateKeyTarget(b,S,c){const h=this.getKeyTargets(S);typeof c=="number"?h[b]!==c&&(h[b]=c,this.getStorage(S)?.set(f,JSON.stringify(h))):typeof h[b]=="number"&&(delete h[b],this.getStorage(S)?.set(f,JSON.stringify(h)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(b){return b===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(b){const S=this.get(f,b);if(S)try{return JSON.parse(S)}catch(c){}return Object.create(null)}isNew(b){return this.getBoolean(e.IS_NEW_KEY,b)===!0}async flush(b=w.NONE){this._onWillSaveState.fire({reason:b}),await v.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const b=this.getStorage(0)?.items??new Map,S=this.getStorage(1)?.items??new Map;return d(b,S,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=E,E.DEFAULT_FLUSH_INTERVAL=60*1e3;class y extends E{constructor(){super();this.globalStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(1,b))),this._register(this.globalStorage.onDidChangeStorage(b=>this.emitDidChangeValue(0,b)))}getStorage(b){return b===0?this.globalStorage:this.workspaceStorage}getLogDetails(b){return b===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(b){}}e.InMemoryStorageService=y;async function d(m,b,S,c){const h=a=>{try{return JSON.parse(a)}catch(g){return a}},o=new Map,u=new Map;m.forEach((a,g)=>{o.set(g,a),u.set(g,h(a))});const t=new Map,l=new Map;b.forEach((a,g)=>{t.set(g,a),l.set(g,h(a))}),console.group(`Storage: Global (path: ${S})`);let s=[];o.forEach((a,g)=>{s.push({key:g,value:a})}),console.table(s),console.groupEnd(),console.log(u),console.group(`Storage: Workspace (path: ${c})`);let r=[];t.forEach((a,g)=>{r.push({key:g,value:a})}),console.table(r),console.groupEnd(),console.log(l)}e.logStorage=d}),define(Z[197],x([0,1,3,33,8,28]),function(K,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function I(w){if(v.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function n(w,i,P,E,y,d,m,b,S,c){const h=Object.create(null);h["common.machineId"]=m,h.sessionID=(0,D.generateUuid)()+Date.now(),h.commitHash=y,h.version=d,h["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,v.PlatformToString)(v.platform),h["common.nodePlatform"]=L.platform,h["common.nodeArch"]=E,h["common.product"]=c||"desktop";const o=f(b||[]);o&&(h["common.msftInternal"]=o);let u=0;const t=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),v.isLinuxSnap&&(h["common.snap"]="true");const l=I(P);l&&(h["common.platformDetail"]=l);try{const s=await w.readFile(M.URI.file(S));h["common.source"]=s.value.toString().slice(0,30)}catch(s){}return h}e.resolveCommonProperties=n;function f(w){const i=L.env.USERDNSDOMAIN;if(!i)return!1;const P=i.toLowerCase();return w.some(E=>P===E)}e.verifyMicrosoftInternalDomain=f}),define(Z[29],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(D){D[D.NONE=0]="NONE",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var M;(function(D){D.OFF="off",D.ERROR="error",D.ON="on"})(M=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[198],x([0,1,26,66,40,10,7,3,8,69,19,83,72,20,21,29]),function(K,e,v,L,M,D,I,n,f,w,i,P,E,y,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function b(u,t){const l=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],s=new Map,r=new Map,a=2e4;function g(R,T,O,V){const ne=T.substring(R.length+1);return new Promise(async se=>{let G;try{G=await i.Promises.readdir(T,{withFileTypes:!0})}catch(j){se();return}if(V.count>=a){V.count+=G.length,V.maxReached=!0,se();return}let te=G.length;if(te===0){se();return}let F=G;V.count+G.length>a&&(V.maxReached=!0,te=a-V.count,F=G.slice(0,te)),V.count+=G.length;for(const j of F)if(j.isDirectory()){if(O.includes(j.name)||await g(R,(0,I.join)(T,j.name),O,V),--te==0){se();return}}else{const q=j.name.lastIndexOf(".");if(q>=0){const $=j.name.substring(q+1);$&&s.set($,(s.get($)??0)+1)}for(const $ of l)$.relativePathPattern?.test(ne)!==!1&&$.filePattern.test(j.name)&&r.set($.tag,(r.get($.tag)??0)+1);if(--te==0){se();return}}})}const p={count:0,maxReached:!1};await g(u,u,t,p);const k=await h(u);return{configFiles:S(r),fileTypes:S(s),fileCount:p.count,maxFilesReached:p.maxReached,launchConfigFiles:k}}e.collectWorkspaceStats=b;function S(u){return[...L.Iterable.map(u.entries(),([t,l])=>({name:t,count:l}))].sort((t,l)=>l.count-t.count)}function c(){const u={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/y.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/y.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(w.virtualMachineHint.value()*100)}%`},t=v.cpus();return t&&t.length>0&&(u.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),u}e.getMachineInfo=c;async function h(u){try{const t=new Map,l=(0,I.join)(u,".vscode","launch.json"),s=await i.Promises.readFile(l),r=[],a=(0,M.parse)(s.toString(),r);if(r.length)return console.log(`Unable to parse ${l}`),[];if((0,M.getNodeType)(a)==="object"&&a.configurations)for(const g of a.configurations){const p=g.type;p&&(t.has(p)?t.set(p,t.get(p)+1):t.set(p,1))}return S(t)}catch(t){return[]}}e.collectLaunchConfigs=h;let o=class{constructor(t,l){this.telemetryService=t,this.productService=l}formatMachineInfo(t){const l=[];return l.push(`OS Version:       ${t.os}`),l.push(`CPUs:             ${t.cpus}`),l.push(`Memory (System):  ${t.memory}`),l.push(`VM:               ${t.vmHint}`),l.join(`
`)}formatEnvironment(t){const l=[];l.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),l.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const s=v.cpus();return s&&s.length>0&&l.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),l.push(`Memory (System):  ${(v.totalmem()/y.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/y.ByteSize.GB).toFixed(2)}GB free)`),n.isWindows||l.push(`Load (avg):       ${v.loadavg().map(r=>Math.round(r)).join(", ")}`),l.push(`VM:               ${Math.round(w.virtualMachineHint.value()*100)}%`),l.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),l.push(`Process Argv:     ${t.mainArguments.join(" ")}`),l.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),l.join(`
`)}async getPerformanceInfo(t,l){return Promise.all([(0,P.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async s=>{let[r,a]=s,g=this.formatProcessList(t,r);return l.forEach(p=>{if((0,E.isRemoteDiagnosticError)(p))g+=`
${p.errorMessage}`,a+=`
${p.errorMessage}`;else if(g+=`

Remote: ${p.hostName}`,p.processes&&(g+=`
${this.formatProcessList(t,p.processes)}`),p.workspaceMetadata){a+=`
|  Remote: ${p.hostName}`;for(const k of Object.keys(p.workspaceMetadata)){const R=p.workspaceMetadata[k];let T=`${R.fileCount} files`;R.maxFilesReached&&(T=`more than ${T}`),a+=`|    Folder (${k}): ${T}`,a+=this.formatWorkspaceStats(R)}}}),{processInfo:g,workspaceInfo:a}})}async getSystemInfo(t,l){const{memory:s,vmHint:r,os:a,cpus:g}=c(),p={os:a,memory:s,cpus:g,vmHint:r,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:l};return n.isWindows||(p.load=`${v.loadavg().map(k=>Math.round(k)).join(", ")}`),n.isLinux&&(p.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(p)}async getDiagnostics(t,l){const s=[];return(0,P.listProcesses)(t.mainPID).then(async r=>(s.push(""),s.push(this.formatEnvironment(t)),s.push(""),s.push(this.formatProcessList(t,r)),t.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(t))),l.forEach(a=>{if((0,E.isRemoteDiagnosticError)(a))s.push(`
${a.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${a.hostName}`),s.push(this.formatMachineInfo(a.machineInfo)),a.processes&&s.push(this.formatProcessList(t,a.processes)),a.workspaceMetadata)for(const g of Object.keys(a.workspaceMetadata)){const p=a.workspaceMetadata[g];let k=`${p.fileCount} files`;p.maxFilesReached&&(k=`more than ${k}`),s.push(`Folder (${g}): ${k}`),s.push(this.formatWorkspaceStats(p))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(t){const l=[],s=60;let r=0;const a=(R,T)=>{const O=` ${R}(${T})`;r+O.length>s?(l.push(g),g="|                 ",r=g.length):r+=O.length,g+=O};let g="|      File types:";const p=10;let k=t.fileTypes.length>p?p:t.fileTypes.length;for(let R=0;R<k;R++){const T=t.fileTypes[R];a(T.name,T.count)}if(l.push(g),t.configFiles.length>=0&&(g="|      Conf files:",r=0,t.configFiles.forEach(R=>{a(R.name,R.count)}),l.push(g)),t.launchConfigFiles.length>0){let R="|      Launch Configs:";t.launchConfigFiles.forEach(T=>{R+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),l.push(R)}return l.join(`
`)}expandGPUFeatures(t){const l=Math.max(...Object.keys(t).map(s=>s.length));return Object.keys(t).map(s=>`${s}:  ${" ".repeat(l-s.length)}  ${t[s]}`).join(`
                  `)}formatWorkspaceMetadata(t){const l=[],s=[];return t.windows.forEach(r=>{r.folderURIs.length===0||!!r.remoteAuthority||(l.push(`|  Window (${r.title})`),r.folderURIs.forEach(a=>{const g=f.URI.revive(a);if(g.scheme===D.Schemas.file){const p=g.fsPath;s.push(b(p,["node_modules",".git"]).then(k=>{let R=`${k.fileCount} files`;k.maxFilesReached&&(R=`more than ${R}`),l.push(`|    Folder (${(0,I.basename)(p)}): ${R}`),l.push(this.formatWorkspaceStats(k))}).catch(k=>{l.push(`|      Error: Unable to collect workspace stats for folder ${p} (${k.toString()})`)}))}else l.push(`|    Folder (${g.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(r=>l.join(`
`)).catch(r=>`Unable to collect workspace stats: ${r}`)}formatProcessList(t,l){const s=new Map;t.windows.forEach(a=>s.set(a.pid,a.title));const r=[];return r.push("CPU %	Mem MB	   PID	Process"),l&&this.formatProcessItem(t.mainPID,s,r,l,0),r.join(`
`)}formatProcessItem(t,l,s,r,a){const g=a===0;let p;g?p=r.pid===t?`${this.productService.applicationName} main`:"remote agent":(p=`${"  ".repeat(a)} ${r.name}`,r.name==="window"&&(p=`${p} (${l.get(r.pid)})`));const k=process.platform==="win32"?r.mem:v.totalmem()*(r.mem/100);s.push(`${r.load.toFixed(0).padStart(5," ")}	${(k/y.ByteSize.MB).toFixed(0).padStart(6," ")}	${r.pid.toFixed(0).padStart(6," ")}	${p}`),Array.isArray(r.children)&&r.children.forEach(R=>this.formatProcessItem(t,l,s,R,a+1))}async reportWorkspaceStats(t){for(const{uri:l}of t.folders){const s=f.URI.revive(l);if(s.scheme!==D.Schemas.file)continue;const r=s.fsPath;try{const a=await b(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),a.fileTypes.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:g.name,count:g.count})}),a.launchConfigFiles.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:g.name,count:g.count})}),a.configFiles.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:g.name,count:g.count})})}catch{}}}};o=he([ie(0,m.ITelemetryService),ie(1,d.IProductService)],o),e.DiagnosticsService=o}),define(Z[199],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(D){this.appenders=D}listen(D,I){throw new Error(`Event not found: ${I}`)}call(D,I,{eventName:n,data:f}){return this.appenders.forEach(w=>w.log(n,f)),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class L{constructor(D){this.channel=D}log(D,I){return this.channel.call("log",{eventName:D,data:I}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(Z[62],x([0,1,44,13,16,29]),function(K,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class I{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(S,c){return Promise.resolve(void 0)}publicLog2(S,c){return this.publicLog(S,c)}publicLogError(S,c){return Promise.resolve(void 0)}publicLogError2(S,c){return this.publicLogError(S,c)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=I,e.NullTelemetryService=new I;class n{async publicLog(S,c,h){}async publicLogError(S,c,h){}}e.NullEndpointTelemetryService=n,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(b,S){return S.onDidChangeConfiguration(c=>{c.source!==6&&b.publicLog2("updateConfiguration",{configurationSource:(0,M.ConfigurationTargetToString)(c.source),configurationKeys:d(c.sourceConfig)})})}e.configurationTelemetry=f;function w(b,S){return!(S.disableTelemetry||!b.enableTelemetry)}e.supportsTelemetry=w;function i(b){const S=b.getValue(D.TELEMETRY_SETTING_ID),c=b.getValue(D.TELEMETRY_OLD_SETTING_ID);if(c!==void 0&&c===!1)return 0;switch(S??"on"){case"on":return 3;case"error":return 2;case"off":return 0}}e.getTelemetryLevel=i;function P(b){const S=Object.create(null),c=Object.create(null),h=Object.create(null);y(b,h);for(let o in h){o=o.length>150?o.substr(o.length-149):o;const u=h[o];typeof u=="number"?c[o]=u:typeof u=="boolean"?c[o]=u?1:0:typeof u=="string"?S[o]=u.substring(0,1023):typeof u!="undefined"&&u!==null&&(S[o]=u)}return{properties:S,measurements:c}}e.validateTelemetryData=P;function E(b){if(!b)return"none";let S="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(h=>{b.indexOf(`${h}+`)===0&&(S=h)}),S}e.cleanRemoteAuthority=E;function y(b,S,c=0,h){if(!!b)for(let o of Object.getOwnPropertyNames(b)){const u=b[o],t=h?h+o:o;Array.isArray(u)?S[t]=(0,v.safeStringify)(u):u instanceof Date?S[t]=u.toISOString():(0,L.isObject)(u)?c<2?y(u,S,c+1,t+"."):S[t]=(0,v.safeStringify)(u):S[t]=u}}function d(b){if(!b)return[];const S=[];return m(S,"",b),S}function m(b,S,c){c&&typeof c=="object"&&!Array.isArray(c)?Object.keys(c).forEach(h=>m(b,S?`${S}.${h}`:h,c[h])):b.push(S)}}),define(Z[200],x([0,1,30,23,17,44,3,33,8,16,48,168,191,162,20,6,21,50,194,97,29,62]),function(K,e,v,L,M,D,I,n,f,w,i,P,E,y,d,m,b,S,c,h,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const t=I.isWeb?"web":(0,P.getTargetPlatform)(I.platform,n.arch);var l;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished"})(l||(l={}));function s(...U){return String(U.reduce((N,Q)=>N|Q,0))}var r;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},g={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},k={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:l.None,criteria:[],assetTypes:[]};class R{constructor(N=k){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,Q=this.state.pageSize){return new R({...this.state,pageNumber:N,pageSize:Q})}withFilter(N,...Q){const J=[...this.state.criteria,...Q.length?Q.map(re=>({filterType:N,value:re})):[{filterType:N}]];return new R({...this.state,criteria:J})}withSortBy(N){return new R({...this.state,sortBy:N})}withSortOrder(N){return new R({...this.state,sortOrder:N})}withFlags(...N){return new R({...this.state,flags:N.reduce((Q,J)=>Q|J,0)})}withAssetTypes(...N){return new R({...this.state,assetTypes:N})}get raw(){const{criteria:N,pageNumber:Q,pageSize:J,sortBy:re,sortOrder:le,flags:ee,assetTypes:ae}=this.state;return{filters:[{criteria:N,pageNumber:Q,pageSize:J,sortBy:re,sortOrder:le}],assetTypes:ae,flags:ee}}get searchText(){const N=this.state.criteria.filter(Q=>Q.filterType===r.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function T(U,N){const Q=(U||[]).filter(J=>J.statisticName===N)[0];return Q?Q.value:0}function O(U){const N="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(J=>J.assetType.indexOf(N)===0).reduce((J,re)=>{const le=G(U,re.assetType);return le&&J.push([re.assetType.substring(N.length),le]),J},[])}function V(U){if(U.properties){const N=U.properties.filter(re=>re.key===a.Repository),Q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),J=N.filter(re=>Q.test(re.value))[0];return J?{uri:J.value,fallbackUri:J.value}:null}return G(U,a.Repository)}function ne(U){return{uri:`${U.fallbackAssetUri}/${a.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${a.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function se(U){const N=G(U,a.Icon);if(N)return N;const Q=P.DefaultIconPath;return{uri:Q,fallbackUri:Q}}function G(U,N){return U.files.filter(J=>J.assetType===N)[0]?{uri:`${U.assetUri}/${N}`,fallbackUri:`${U.fallbackAssetUri}/${N}`}:null}function te(U,N){const Q=U.properties?U.properties.filter(re=>re.key===N):[],J=Q.length>0&&Q[0].value;return J?J.split(",").map(re=>(0,E.adoptToGalleryExtensionId)(re)):[]}function F(U){const N=U.properties?U.properties.filter(Q=>Q.key===g.Engine):[];return N.length>0&&N[0].value||""}function j(U){const N=U.properties?U.properties.filter(J=>J.key===g.LocalizedLanguages):[],Q=N.length>0&&N[0].value||"";return Q?Q.split(","):[]}function q(U){return U.indexOf("preview")!==-1}function $(U){return U.targetPlatform?(0,P.toTargetPlatform)(U.targetPlatform):"undefined"}function H(U){const N=(0,v.distinct)(U.versions.map($)),Q=!!U.tags?.includes(P.WEB_EXTENSION_TAG),J=N.indexOf("web");return Q?J===-1&&N.push("web"):J!==-1&&N.splice(J,1),N}function _(U,N){const Q=(0,P.getFallbackTargetPlarforms)(N);for(let J=0;J<U.length;J++){const re=U[J];if(re.version===U[J-1]?.version){let le=J;const ee=$(re);if(ee===N)for(;le>0&&U[le-1].version===re.version;)le--;else if(Q.includes(ee))for(;le>0&&U[le-1].version===re.version&&$(U[le-1])!==N;)le--;le!==J&&(U.splice(J,1),U.splice(le,0,re))}}return U}e.sortExtensionVersions=_;function z(U,N,Q,J,re){const le=H(U);let ee=U.versions[0];return ee=U.versions.find(ae=>ae.version===ee.version&&(0,P.isTargetPlatformCompatible)($(ae),le,re))||ee,C(U,ee,le,N,Q,J)}function C(U,N,Q,J,re,le){const ee={manifest:G(N,a.Manifest),readme:G(N,a.Details),changelog:G(N,a.Changelog),license:G(N,a.License),repository:V(N),download:ne(N),icon:se(N),coreTranslations:O(N)};return{identifier:{id:(0,E.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:N.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,description:U.shortDescription||"",installCount:T(U.statistics,"install"),rating:T(U.statistics,"averagerating"),ratingCount:T(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:Q,assets:ee,properties:{dependencies:te(N,g.Dependency),extensionPack:te(N,g.ExtensionPack),engine:F(N),localizedLanguages:j(N),targetPlatform:$(N)},preview:q(U.flags),telemetryData:{index:(re.pageNumber-1)*re.pageSize+J,querySource:le}}}let A=class{constructor(N,Q,J,re,le,ee,ae,ue){this.requestService=Q,this.logService=J,this.environmentService=re,this.telemetryService=le,this.fileService=ee,this.productService=ae,this.configurationService=ue;const de=ae.extensionsGallery;this.extensionsGalleryUrl=de&&de.serviceUrl,this.extensionsControlUrl=de&&de.controlUrl,this.commonHeadersPromise=Y(ae.version,ae,this.environmentService,this.configurationService,this.fileService,N)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,Q){const J=[];let re=new R().withFlags(l.IncludeAssetUri,l.IncludeStatistics,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,N.length).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionName,...N.map(({id:ee})=>ee.toLowerCase()));N.every(ee=>!ee.version)&&(re=re.withFlags(l.IncludeAssetUri,l.IncludeStatistics,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties,l.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(re,t,L.CancellationToken.None);for(let ee=0;ee<le.length;ee++){const ae=le[ee];if(!ae.versions.length)continue;const ue=(0,E.getGalleryExtensionId)(ae.publisher.publisherName,ae.extensionName),de=N.find(ve=>(0,E.areSameExtensions)(ve,{id:ue}))?.version;if(de){const ve=ae.versions.find(Ie=>Ie.version===de);ve&&J.push(C(ae,ve,H(ae),ee,re))}else J.push(z(ae,ee,re,void 0,t))}return J}async getCompatibleExtension(N,Q){const J=(0,P.isIExtensionIdentifier)(N)?null:N;if(J){if((0,P.isNotWebExtensionInWebTargetPlatform)(J.allTargetPlatforms,Q))return null;if(await this.isExtensionCompatible(J,Q))return J}const{id:re,uuid:le}=J?J.identifier:N;let ee=new R().withFlags(l.IncludeAssetUri,l.IncludeStatistics,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");le?ee=ee.withFilter(r.ExtensionId,le):ee=ee.withFilter(r.ExtensionName,re);const{galleryExtensions:ae}=await this.queryGallery(ee,Q,L.CancellationToken.None),[ue]=ae;if(!ue||!ue.versions.length)return null;const de=H(ue);if((0,P.isNotWebExtensionInWebTargetPlatform)(de,Q))return null;for(let ve of ue.versions){if(!F(ve)){const Ie=await this.getEngine(ve);ve={...ve,properties:[...ve.properties||[],{key:g.Engine,value:Ie}]}}if(await this.isRawExtensionVersionCompatible(ve,de,Q))return C(ue,ve,de,0,ee)}return null}async isExtensionCompatible(N,Q){if(!(0,P.isTargetPlatformCompatible)(N.properties.targetPlatform,N.allTargetPlatforms,Q))return!1;let J=N.properties.engine;if(!J){const re=await this.getManifest(N,L.CancellationToken.None);if(!re)throw new Error("Manifest was not found");J=re.engines.vscode}return(0,y.isEngineValid)(J,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(N,Q,J){if(!(0,P.isTargetPlatformCompatible)($(N),Q,J))return!1;const re=await this.getEngine(N);return(0,y.isEngineValid)(re,this.productService.version,this.productService.date)}async query(N,Q){const J=L.CancellationToken.isCancellationToken(N)?{}:N,re=L.CancellationToken.isCancellationToken(N)?N:Q;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let le=J.text||"";const ee=(0,D.getOrDefault)(J,me=>me.pageSize,50);let ae=new R().withFlags(l.IncludeLatestVersionOnly,l.IncludeAssetUri,l.IncludeStatistics,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,ee).withFilter(r.Target,"Microsoft.VisualStudio.Code");le?(le=le.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,ge,Ee)=>(ae=ae.withFilter(r.Category,Ee||ge),"")),le=le.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,ge,Ee)=>(ae=ae.withFilter(r.Tag,Ee||ge),"")),le=le.replace(/\bfeatured(\s+|\b|$)/g,()=>(ae=ae.withFilter(r.Featured),"")),le=le.trim(),le&&(le=le.length<200?le:le.substring(0,200),ae=ae.withFilter(r.SearchText,le)),ae=ae.withSortBy(0)):J.ids?ae=ae.withFilter(r.ExtensionId,...J.ids):J.names?ae=ae.withFilter(r.ExtensionName,...J.names):ae=ae.withSortBy(4),typeof J.sortBy=="number"&&(ae=ae.withSortBy(J.sortBy)),typeof J.sortOrder=="number"&&(ae=ae.withSortOrder(J.sortOrder));const{galleryExtensions:ue,total:de}=await this.queryGallery(ae,t,re),ve=ue.map((me,ge)=>z(me,ge,ae,J.source,t)),Ie=async(me,ge)=>{if(ge.isCancellationRequested)throw(0,M.canceled)();const Ee=ae.withPage(me+1),{galleryExtensions:ke}=await this.queryGallery(Ee,t,ge);return ke.map((Ae,We)=>z(Ae,We,Ee,J.source,t))};return{firstPage:ve,total:de,pageSize:ae.pageSize,getPage:Ie}}async queryGallery(N,Q,J){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,l.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,s(l.Unpublished));const re=await this.commonHeadersPromise,le=JSON.stringify(N.raw),ee={...re,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(le.length)},ae=new Date().getTime();let ue,de,ve=0;try{if(ue=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:le,headers:ee},J),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:ve};const Ie=await(0,S.asJson)(ue);if(Ie){const me=Ie.results[0],ge=me.extensions;ge.forEach(ke=>_(ke.versions,Q));const Ee=me.resultMetadata&&me.resultMetadata.filter(ke=>ke.metadataType==="ResultCount")[0];return ve=Ee&&Ee.metadataItems.filter(ke=>ke.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:ve}}return{galleryExtensions:[],total:ve}}catch(Ie){throw de=Ie,Ie}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(le.length),duration:new Date().getTime()-ae,success:!!ue&&(0,S.isSuccess)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:de?(0,M.isPromiseCanceledError)(de)?"canceled":(0,M.getErrorMessage)(de).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ve)})}}async reportStatistic(N,Q,J,re){if(!this.isEnabled())return;const le=I.isWeb?this.api(`/itemName/${N}.${Q}/version/${J}/statType/${re==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${Q}/${J}/stats?statType=${re}`),ee=I.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.commonHeadersPromise,Accept:ee};try{await this.requestService.request({type:"POST",url:le,headers:ue},L.CancellationToken.None)}catch(de){}}async download(N,Q,J){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const re=(0,E.getGalleryExtensionTelemetryData)(N),le=new Date().getTime(),ee=ve=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...re,duration:ve}),ae=J===1?"install":J===2?"update":"",ue=ae?{uri:`${N.assets.download.uri}${f.URI.parse(N.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${N.assets.download.fallbackUri}${f.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:N.assets.download,de=await this.getAsset(ue);await this.fileService.writeFile(Q,de.stream),ee(new Date().getTime()-le)}async getReadme(N,Q){if(N.assets.readme){const J=await this.getAsset(N.assets.readme,{},Q);return await(0,S.asText)(J)||""}return""}async getManifest(N,Q){if(N.assets.manifest){const J=await this.getAsset(N.assets.manifest,{},Q),re=await(0,S.asText)(J);return re?JSON.parse(re):null}return null}async getManifestFromRawExtensionVersion(N,Q){const J=G(N,a.Manifest);if(!J)throw new Error("Manifest was not found");const re={"Accept-Encoding":"gzip"},le=await this.getAsset(J,{headers:re});return await(0,S.asJson)(le)}async getCoreTranslation(N,Q){const J=N.assets.coreTranslations.filter(re=>re[0]===Q.toUpperCase())[0];if(J){const re=await this.getAsset(J[1]),le=await(0,S.asText)(re);return le?JSON.parse(le):null}return null}async getChangelog(N,Q){if(N.assets.changelog){const J=await this.getAsset(N.assets.changelog,{},Q);return await(0,S.asText)(J)||""}return""}async getAllCompatibleVersions(N,Q){let J=new R().withFlags(l.IncludeVersions,l.IncludeCategoryAndTags,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");N.identifier.uuid?J=J.withFilter(r.ExtensionId,N.identifier.uuid):J=J.withFilter(r.ExtensionName,N.identifier.id);const{galleryExtensions:re}=await this.queryGallery(J,Q,L.CancellationToken.None);if(!re.length)return[];const le=H(re[0]);if((0,P.isNotWebExtensionInWebTargetPlatform)(le,Q))return[];const ee=[];for(const ae of re[0].versions)try{ee[ee.length-1]?.version!==ae.version&&await this.isRawExtensionVersionCompatible(ae,le,Q)&&ee.push({version:ae.version,date:ae.lastUpdated})}catch(ue){}return ee}async getAsset(N,Q={},J=L.CancellationToken.None){const re=await this.commonHeadersPromise,le={type:"GET"},ee={...re,...Q.headers||{}};Q={...Q,...le,headers:ee};const ae=N.uri,ue=N.fallbackUri,de={...Q,url:ae};try{const ve=await this.requestService.request(de,J);if(ve.res.statusCode===200)return ve;const Ie=await(0,S.asText)(ve);throw new Error(`Expected 200, got back ${ve.res.statusCode} instead.

${Ie}`)}catch(ve){if((0,M.isPromiseCanceledError)(ve))throw ve;const Ie=(0,M.getErrorMessage)(ve);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ae,message:Ie});const me={...Q,url:ue};return this.requestService.request(me,J)}}async getEngine(N){let Q=F(N);if(!Q){const J=await this.getManifestFromRawExtensionVersion(N,L.CancellationToken.None);if(!J)throw new Error("Manifest was not found");Q=J.engines.vscode}return Q}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const Q=await(0,S.asJson)(N),J=new Map;if(Q)for(const re of Q.malicious){const le=J.get(re)||{id:{id:re},malicious:!0,slow:!1};le.malicious=!0,J.set(re,le)}return[...J.values()]}};A=he([ie(1,S.IRequestService),ie(2,m.ILogService),ie(3,i.IEnvironmentService),ie(4,o.ITelemetryService),ie(5,d.IFileService),ie(6,b.IProductService),ie(7,w.IConfigurationService)],A);let W=class extends A{constructor(N,Q,J,re,le,ee,ae,ue){super(N,Q,J,re,le,ee,ae,ue)}};W=he([ie(0,h.IStorageService),ie(1,S.IRequestService),ie(2,m.ILogService),ie(3,i.IEnvironmentService),ie(4,o.ITelemetryService),ie(5,d.IFileService),ie(6,b.IProductService),ie(7,w.IConfigurationService)],W),e.ExtensionGalleryService=W;let B=class extends A{constructor(N,Q,J,re,le,ee,ae){super(void 0,N,Q,J,re,le,ee,ae)}};B=he([ie(0,S.IRequestService),ie(1,m.ILogService),ie(2,i.IEnvironmentService),ie(3,o.ITelemetryService),ie(4,d.IFileService),ie(5,b.IProductService),ie(6,w.IConfigurationService)],B),e.ExtensionGalleryServiceWithNoStorageService=B;async function Y(U,N,Q,J,re,le){const ee={"X-Market-Client-Id":`VSCode ${U}`,"User-Agent":`VSCode ${U}`},ae=await(0,c.getServiceMachineId)(Q,re,le);return(0,u.supportsTelemetry)(N,Q)&&(0,u.getTelemetryLevel)(J)===3&&(ee["X-Market-User-Id"]=ae),ee}e.resolveMarketplaceHeaders=Y}),define(Z[201],x([0,1,2,44,3,25,148,16,49,45,38,29,62]),function(K,e,v,L,M,D,I,n,f,w,i,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(b,S){this._configurationService=S,this._experimentProperties={},this._disposables=new v.DisposableStore,this._cleanupPatterns=[],this._appenders=b.appenders,this._commonProperties=b.commonProperties||Promise.resolve({}),this._piiPaths=b.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!b.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let c of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(c),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(c=>{const h=/^[a-f0-9]+$/i.test(c["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!h})})}setExperimentProperty(b,S){this._experimentProperties[b]=S}_updateTelemetryLevel(){this._telemetryLevel=(0,E.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const b=await this._commonProperties;let S=b.sessionID,c=b["common.instanceId"],h=b["common.machineId"],o=b["common.firstSessionDate"],u=b["common.msftInternal"];return{sessionId:S,instanceId:c,machineId:h,firstSessionDate:o,msftInternal:u}}dispose(){this._disposables.dispose()}_log(b,S,c,h){return this.telemetryLevel<S?Promise.resolve(void 0):this._commonProperties.then(o=>{c=(0,L.mixin)(c,o),c=(0,L.mixin)(c,this._experimentProperties),c=(0,L.cloneAndChange)(c,u=>{if(typeof u=="string")return this._cleanupInfo(u,h)}),this._appenders.forEach(u=>u.log(b,c))},o=>{console.error(o)})}publicLog(b,S,c){return this._log(b,3,S,c)}publicLog2(b,S,c){return this.publicLog(b,S,c)}publicLogError(b,S){return this.sendErrorTelemetry?this._log(b,2,S,!0):Promise.resolve(void 0)}publicLogError2(b,S){return this.publicLogError(b,S)}_anonymizeFilePaths(b){let S=b;const c=[];for(let t of this._cleanupPatterns)for(;;){const l=t.exec(b);if(!l)break;c.push([l.index,t.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(S="";;){const t=o.exec(b);if(!t)break;!h.test(t[0])&&c.every(([l,s])=>t.index<l||t.index>=s)&&(S+=b.substring(u,t.index)+"<REDACTED: user-file-path>",u=o.lastIndex)}return u<b.length&&(S+=b.substr(u)),S}_removePropertiesWithPossibleUserInfo(b){if(!b)return b;const S=b.toLowerCase(),c=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(S)?"<REDACTED: secret>":c.test(S)?"<REDACTED: email>":b}_cleanupInfo(b,S){let c=b;S&&(c=this._anonymizeFilePaths(c));for(let h of this._cleanupPatterns)c=c.replace(h,"");return c=this._removePropertiesWithPossibleUserInfo(c),c}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=he([ie(1,n.IConfigurationService)],y),e.TelemetryService=y;const d=M.isWeb?"":" "+(0,I.localize)(0,null);i.Registry.as(f.Extensions.Configuration).registerConfiguration({id:P.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(1,null),properties:{[P.TELEMETRY_SETTING_ID]:{type:"string",enum:["on","error","off"],enumDescriptions:[(0,I.localize)(2,null),(0,I.localize)(3,null),(0,I.localize)(4,null)],markdownDescription:w.default.privacyStatementUrl?(0,I.localize)(6,null,w.default.nameLong,w.default.privacyStatementUrl)+d:(0,I.localize)(5,null,w.default.nameLong)+d,default:"on",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),i.Registry.as(f.Extensions.Configuration).registerConfiguration({id:P.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,I.localize)(7,null),properties:{[P.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:w.default.privacyStatementUrl?(0,I.localize)(9,null,w.default.nameLong,w.default.privacyStatementUrl):(0,I.localize)(8,null,w.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(10,null,`\`#${P.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[202],x([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(Z[203],x([0,1,108,4,2,5,38,202]),function(K,e,v,L,M,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,D.createDecorator)("themeService");var f;(function(b){function S(c){return c&&typeof c=="object"&&typeof c.id=="string"}b.isThemeColor=S})(f=e.ThemeColor||(e.ThemeColor={}));function w(b){return{id:b}}e.themeColorFromId=w;var i;(function(b){function S(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color=="undefined"||f.isThemeColor(l.color))}b.isThemeIcon=S;const c=new RegExp(`^\\$\\((${v.CSSIcon.iconNameExpression}(?:${v.CSSIcon.iconModifierExpression})?)\\)$`);function h(l){const s=c.exec(l);if(!s)return;let[,r]=s;return{id:r}}b.fromString=h;function o(l,s){let r=l.id;const a=r.lastIndexOf("~");return a!==-1&&(r=r.substring(0,a)),s&&(r=`${r}~${s}`),{id:r}}b.modify=o;function u(l,s){return l.id===s.id&&l.color?.id===s.color?.id}b.isEqual=u;function t(l,s){return{id:l.id,color:s?w(s):void 0}}b.asThemeIcon=t,b.asClassNameArray=v.CSSIcon.asClassNameArray,b.asClassName=v.CSSIcon.asClassName,b.asCSSSelector=v.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=v.Codicon.file,e.FolderThemeIcon=v.Codicon.folder;function P(b){switch(b){case n.ColorScheme.DARK:return"vs-dark";case n.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(S){return this.themingParticipants.push(S),this.onThemingParticipantAddedEmitter.fire(S),(0,M.toDisposable)(()=>{const c=this.themingParticipants.indexOf(S);this.themingParticipants.splice(c,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let y=new E;I.Registry.add(e.Extensions.ThemingContribution,y);function d(b){return y.onColorThemeChange(b)}e.registerThemingParticipant=d;class m extends M.Disposable{constructor(S){super();this.themeService=S,this.theme=S.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(c=>this.onThemeChange(c)))}onThemeChange(S){this.theme=S,this.updateStyles()}updateStyles(){}getColor(S,c){let h=this.theme.getColor(S);return h&&c&&(h=c(h,this.theme)),h?h.toString():null}}e.Themable=m}),define(Z[63],x([0,1,14,3,5,39]),function(K,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const I="#FFFFFF",n="#1E1E1E",f="#000000",w="theme",i="themeBackground",P="windowSplash";e.IThemeMainService=(0,M.createDecorator)("themeMainService");let E=class{constructor(d){this.stateMainService=d}getBackgroundColor(){if((L.isWindows||L.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme)return f;let d=this.stateMainService.getItem(i,null);if(!d){let m;(L.isWindows||L.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme?m="hc-black":m=this.stateMainService.getItem(w,"vs-dark").split(" ")[0],d=m==="hc-black"?f:m==="vs"?I:n}return L.isMacintosh&&d.toUpperCase()===n&&(d="#171717"),d}saveWindowSplash(d,m){this.stateMainService.setItems([{key:w,data:m.baseTheme},{key:i,data:m.colorInfo.background},{key:P,data:m}]),typeof d=="number"&&this.updateBackgroundColor(d,m)}updateBackgroundColor(d,m){for(const b of v.BrowserWindow.getAllWindows())if(b.id===d){b.setBackgroundColor(m.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(P)}};E=he([ie(0,D.IStateMainService)],E),e.ThemeMainService=E}),define(Z[42],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(D){D.Uninitialized="uninitialized",D.Idle="idle",D.CheckingForUpdates="checking for updates",D.AvailableForDownload="available for download",D.Downloading="downloading",D.Downloaded="downloaded",D.Updating="updating",D.Ready="ready"})(L=e.StateType||(e.StateType={}));var M;(function(D){D[D.Setup=0]="Setup",D[D.Archive=1]="Archive",D[D.Snap=2]="Snap"})(M=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(D,I)=>({type:"idle",updateType:D,error:I}),CheckingForUpdates:D=>({type:"checking for updates",explicit:D}),AvailableForDownload:D=>({type:"available for download",update:D}),Downloading:D=>({type:"downloading",update:D}),Downloaded:D=>({type:"downloaded",update:D}),Updating:D=>({type:"updating",update:D}),Ready:D=>({type:"ready",update:D})},e.IUpdateService=(0,v.createDecorator)("updateService")}),define(Z[204],x([0,1,3,149,49,38]),function(K,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),D.Registry.as(M.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:v.isWindows&&!v.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[205],x([0,1,4,42]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class M{constructor(n){this.service=n}listen(n,f){switch(f){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${f}`)}call(n,f,w){switch(f){case"checkForUpdates":return this.service.checkForUpdates(w);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${f}`)}}e.UpdateChannel=M;class D{constructor(n){this.channel=n,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(f=>this.state=f),this.channel.call("_getInitialState").then(f=>this.state=f)}get state(){return this._state}set state(n){this._state=n,this._onStateChange.fire(n)}checkForUpdates(n){return this.channel.call("checkForUpdates",n)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=D}),define(Z[98],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,v.createDecorator)("urlService")}),define(Z[206],x([0,1,8]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(n){this.handler=n}listen(n,f){throw new Error(`Event not found: ${f}`)}call(n,f,w){switch(f){case"handleURL":return this.handler.handleURL(v.URI.revive(w[0]),w[1])}throw new Error(`Call not found: ${f}`)}}e.URLHandlerChannel=L;class M{constructor(n){this.channel=n}handleURL(n,f){return this.channel.call("handleURL",[n.toJSON(),f])}}e.URLHandlerChannelClient=M;class D{constructor(n){this.next=n}async routeCall(n,f,w,i){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(w){const P=v.URI.revive(w);if(P&&P.query){const E=/\bwindowId=(\d+)/.exec(P.query);if(E){const y=E[1],d=new RegExp(`window:${y}`),m=n.connections.find(b=>d.test(b.ctx));if(m)return m}}}return this.next.routeCall(n,f,w,i)}routeEvent(n,f){throw new Error(`Event not found: ${f}`)}}e.URLHandlerRouter=D}),define(Z[207],x([0,1,9,2,8,21]),function(K,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class I extends L.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(w,i){const P=[...this.handlers.values()];return(0,v.first)(P.map(E=>()=>E.handleURL(w,i)),void 0,!1).then(E=>E||!1)}registerHandler(w){return this.handlers.add(w),(0,L.toDisposable)(()=>this.handlers.delete(w))}}e.AbstractURLService=I;let n=class extends I{constructor(w){super();this.productService=w}create(w){let{authority:i,path:P,query:E,fragment:y}=w||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return i&&P&&P.indexOf("/")!==0&&(P=`/${P}`),M.URI.from({scheme:this.productService.urlProtocol,authority:i,path:P,query:E,fragment:y})}};n=he([ie(0,D.IProductService)],n),e.NativeURLService=n}),define(Z[208],x([0,1,14,9,4,2,3,8]),function(K,e,v,L,M,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function f(i){try{return n.URI.parse(i)}catch(P){return null}}class w{constructor(P,E,y,d,m){if(this.urlService=E,this.uris=[],this.retryCount=0,this.flushDisposable=D.Disposable.None,this.disposables=new D.DisposableStore,this.uris=P,I.isWindows){const c=d.isBuilt?[]:[`"${d.appRoot}"`];c.push("--open-url","--"),v.app.setAsDefaultProtocolClient(m.urlProtocol,process.execPath,c)}const b=M.Event.map(M.Event.fromNodeEventEmitter(v.app,"open-url",(c,h)=>({event:c,url:h})),({event:c,url:h})=>(c.preventDefault(),h));this.disposables.add(b(c=>{const h=f(c);!h||this.urlService.open(h,{originalUrl:c})})),y.getWindows().filter(c=>c.isReady).length>0?this.flush():M.Event.once(y.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const P=[];for(const E of this.uris)await this.urlService.open(E.uri,{originalUrl:E.url})||P.push(E);P.length!==0&&(this.uris=P,this.flushDisposable=(0,L.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=w}),define(Z[209],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,v.createDecorator)("webviewManagerService")}),define(Z[210],x([0,1,14,2,10,8]),function(K,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class I extends L.Disposable{constructor(){super();const f=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(M.Schemas.vscodeWebview,f)}handleWebviewRequest(f,w){try{const i=D.URI.parse(f.url),P=I.validWebviewFilePaths.get(i.path);if(typeof P=="string"){const E=`vs/workbench/contrib/webview/browser/pre/${P}`,y=M.FileAccess.asFileUri(E,K);return w(decodeURIComponent(y.fsPath))}else return w({error:-10})}catch{}return w({error:-2})}}e.WebviewProtocolProvider=I,I.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(Z[64],x([0,1,3]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(w){return!!w.workspaceUri}e.isWorkspaceToOpen=L;function M(w){return!!w.folderUri}e.isFolderToOpen=M;function D(w){return!!w.fileUri}e.isFileToOpen=D;function I(w){const i=n(w),P=w.getValue("window.menuBarVisibility");return P==="default"||i==="native"&&P==="compact"||v.isMacintosh&&v.isNative?"classic":P}e.getMenuBarVisibility=I;function n(w){if(v.isWeb)return"custom";const i=w.getValue("window");if(i){if(v.isMacintosh&&i.nativeTabs===!0||v.isMacintosh&&i.nativeFullScreen===!1)return"native";const y=i.titleBarStyle;if(y==="native"||y==="custom")return y}return v.isLinux?"native":"custom"}e.getTitleBarStyle=n;function f(w=0){return Math.pow(1.2,w)}e.zoomLevelToZoomFactor=f}),define(Z[36],x([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var L;(function(w){w[w.INITIAL=1]="INITIAL",w[w.LOAD=2]="LOAD",w[w.RELOAD=3]="RELOAD"})(L=e.LoadReason||(e.LoadReason={}));var M;(function(w){w[w.CLOSE=1]="CLOSE",w[w.QUIT=2]="QUIT",w[w.RELOAD=3]="RELOAD",w[w.LOAD=4]="LOAD"})(M=e.UnloadReason||(e.UnloadReason={}));var D;(function(w){w[w.CLI=0]="CLI",w[w.DOCK=1]="DOCK",w[w.MENU=2]="MENU",w[w.DIALOG=3]="DIALOG",w[w.DESKTOP=4]="DESKTOP",w[w.API=5]="API"})(D=e.OpenContext||(e.OpenContext={}));const I=function(w=1){return{width:1024,height:768,mode:w}};e.defaultWindowState=I;var n;(function(w){w[w.Maximized=0]="Maximized",w[w.Normal=1]="Normal",w[w.Minimized=2]="Minimized",w[w.Fullscreen=3]="Fullscreen"})(n=e.WindowMode||(e.WindowMode={}));var f;(function(w){w[w.UNRESPONSIVE=1]="UNRESPONSIVE",w[w.CRASHED=2]="CRASHED",w[w.LOAD=3]="LOAD"})(f=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,v.createDecorator)("windowsMainService")}),define(Z[211],x([0,1,14,4,2,210,36]),function(K,e,v,L,M,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let n=class extends M.Disposable{constructor(w){super();this.windowsMainService=w,this._onFoundInFrame=this._register(new L.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new D.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(w,i){let P;if(typeof w.windowId=="number"){const{windowId:E}=w,y=this.windowsMainService.getWindowById(E);if(!y?.win)throw new Error(`Invalid windowId: ${E}`);P=y.win.webContents}else{const{webContentsId:E}=w;if(P=v.webContents.fromId(E),!P)throw new Error(`Invalid webContentsId: ${E}`)}P.isDestroyed()||P.setIgnoreMenuShortcuts(i)}async findInFrame(w,i,P,E){const y=this.getFrameByName(w,i),d=y;if(typeof d.findInFrame=="function"){d.findInFrame(P,{findNext:E.findNext,forward:E.forward});const m=(b,S)=>{S.finalUpdate&&(this._onFoundInFrame.fire(S),y.removeListener("found-in-frame",m))};y.on("found-in-frame",m)}}async stopFindInFrame(w,i,P){const y=this.getFrameByName(w,i);typeof y.stopFindInFrame=="function"&&y.stopFindInFrame(P.keepSelection?"keepSelection":"clearSelection")}getFrameByName(w,i){const P=this.windowsMainService.getWindowById(w.windowId);if(!P?.win)throw new Error(`Invalid windowId: ${w}`);const E=P.win.webContents.mainFrame.framesInSubtree.find(y=>y.name===i);if(!E)throw new Error(`Unknown frame: ${i}`);return E}};n=he([ie(0,I.IWindowsMainService)],n),e.WebviewMainService=n}),define(Z[212],x([0,1,9,4,2]),function(K,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class D extends M.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:f,getActiveWindowId:w}){super();this.disposables=this._register(new M.DisposableStore),L.Event.latch(L.Event.any(n,f))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,v.createCancelablePromise)(()=>w()),(async()=>{try{const P=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:P}catch(P){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=D}),define(Z[213],x([0,1,37,15,8,5]),function(K,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");var I;(function(E){E[E.EMPTY=1]="EMPTY",E[E.FOLDER=2]="FOLDER",E[E.WORKSPACE=3]="WORKSPACE"})(I=e.WorkbenchState||(e.WorkbenchState={}));function n(E){const y=E;return!!(y&&typeof y=="object"&&typeof y.id=="string"&&Array.isArray(y.folders))}e.isWorkspace=n;function f(E){const y=E;return!!(y&&typeof y=="object"&&M.URI.isUri(y.uri)&&typeof y.name=="string"&&typeof y.toResource=="function")}e.isWorkspaceFolder=f;class w{constructor(y,d,m,b,S){this._id=y,this._transient=m,this._configuration=b,this._ignorePathCasing=S,this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(y){this._id=y.id,this._configuration=y.configuration,this._transient=y.transient,this._ignorePathCasing=y._ignorePathCasing,this.folders=y.folders}get folders(){return this._folders}set folders(y){this._folders=y,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(y){this._configuration=y}getFolder(y){return y&&this._foldersMap.findSubstr(y.with({scheme:y.scheme,authority:y.authority,path:y.path}))||null}updateFoldersMap(){this._foldersMap=v.TernarySearchTree.forUris(this._ignorePathCasing);for(const y of this.folders)this._foldersMap.set(y.uri,y)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=w;class i{constructor(y,d){this.raw=d,this.uri=y.uri,this.index=y.index,this.name=y.name}toResource(y){return(0,L.joinPath)(this.uri,y)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function P(E){return new i({uri:E,index:0,name:(0,L.basenameOrAuthority)(E)},{uri:E.toString()})}e.toWorkspaceFolder=P}),define(Z[27],x([0,1,31,40,77,34,10,7,3,15,8,152,5,61,213]),function(K,e,v,L,M,D,I,n,f,w,i,P,E,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const m=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,P.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function b(F){return(typeof F=="string"?(0,n.extname)(F):(0,w.extname)(F))===m}e.hasWorkspaceFileExtension=b,e.IWorkspacesService=(0,E.createDecorator)("workspacesService");function S(F){return F.hasOwnProperty("workspace")}e.isRecentWorkspace=S;function c(F){return F.hasOwnProperty("folderUri")}e.isRecentFolder=c;function h(F){return F.hasOwnProperty("fileUri")}e.isRecentFile=h;function o(F){const j=F;return typeof j?.id=="string"&&i.URI.isUri(j.uri)}e.isSingleFolderWorkspaceIdentifier=o;function u(F){if(F.configuration)return{id:F.id,configPath:F.configuration};if(F.folders.length===1)return{id:F.id,uri:F.folders[0].uri}}e.toWorkspaceIdentifier=u;function t(F){const j=F;return typeof j?.id=="string"&&i.URI.isUri(j.configPath)}e.isWorkspaceIdentifier=t;function l(F){const j=F;if(j?.uri)return{id:j.id,uri:i.URI.revive(j.uri)};const q=F;if(q?.configPath)return{id:q.id,configPath:i.URI.revive(q.configPath)};if(F?.id)return{id:F.id}}e.reviveIdentifier=l;function s(F,j){return w.extUriBiasedIgnorePathCase.isEqualOrParent(F,j.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function r(F){return a(F)||g(F)}e.isStoredWorkspaceFolder=r;function a(F){const j=F;return typeof j?.path=="string"&&(!j.name||typeof j.name=="string")}e.isRawFileWorkspaceFolder=a;function g(F){const j=F;return typeof j?.uri=="string"&&(!j.name||typeof j.name=="string")}e.isRawUriWorkspaceFolder=g;function p(F,j,q,$,H=!f.isWindows,_){if(F.scheme!==$.scheme)return{name:q,uri:F.toString(!0)};let z=j?void 0:_.relativePath($,F);if(z!==void 0)z.length===0?z=".":f.isWindows&&F.scheme===I.Schemas.file&&!H&&(z=z.replace(/\//g,"\\"));else if(F.scheme===I.Schemas.file)z=F.fsPath,f.isWindows&&(z=(0,D.normalizeDriveLetter)(z),H&&(z=(0,v.toSlashes)(z)));else{if(!_.isEqualAuthority(F.authority,$.authority))return{name:q,uri:F.toString(!0)};z=F.path}return{name:q,path:z}}e.getStoredWorkspaceFolder=p;function k(F,j,q){let $=[],H=new Set;const _=q.dirname(j);for(let z of F){let C;if(a(z))z.path&&(C=q.resolvePath(_,z.path));else if(g(z))try{C=i.URI.parse(z.uri),C.path[0]!=="/"&&(C=C.with({path:"/"+C.path}))}catch(A){console.warn(A)}if(C){let A=q.getComparisonKey(C);if(!H.has(A)){H.add(A);const W=z.name||q.basenameOrAuthority(C);$.push(new d.WorkspaceFolder({uri:C,name:W,index:$.length},z))}}}return $}e.toWorkspaceFolders=k;function R(F,j,q,$,H){let _=T(j,F);const z=H.dirname(j),C=H.dirname($),A=[],W=O(_.folders);for(const N of _.folders){const Q=a(N)?H.resolvePath(z,N.path):i.URI.parse(N.uri);let J;q?J=!1:J=!a(N)||(0,n.isAbsolute)(N.path),A.push(p(Q,J,N.name,C,W,H))}const B={insertSpaces:!1,tabSize:4,eol:f.isLinux||f.isMacintosh?`
`:`\r
`},Y=M.setProperty(F,["folders"],A,B);let U=M.applyEdits(F,Y);return _.remoteAuthority===(0,y.getRemoteAuthority)($)&&(U=M.applyEdits(U,M.removeProperty(U,["remoteAuthority"],B))),U}e.rewriteWorkspaceFileForNewLocation=R;function T(F,j){let q=L.parse(j);if(q&&Array.isArray(q.folders))q.folders=q.folders.filter($=>r($));else throw new Error(`${F} looks like an invalid workspace file.`);return q}function O(F){return f.isWindows?F.some(j=>a(j)&&j.path.indexOf("/")>=0):!0}e.useSlashForPath=O;function V(F){return F.workspace&&typeof F.workspace=="object"&&typeof F.workspace.id=="string"&&typeof F.workspace.configPath=="string"}function ne(F){return typeof F.folderUri=="string"}function se(F){return typeof F.fileUri=="string"}function G(F,j){const q={workspaces:[],files:[]};if(F){const $=function(_,z){for(let C=0;C<_.length;C++)try{z(_[C],C)}catch(A){j.warn(`Error restoring recent entry ${JSON.stringify(_[C])}: ${A.toString()}. Skip entry.`)}},H=F;if(Array.isArray(H.entries))$(H.entries,_=>{const z=_.label,C=_.remoteAuthority;V(_)?q.workspaces.push({label:z,remoteAuthority:C,workspace:{id:_.workspace.id,configPath:i.URI.parse(_.workspace.configPath)}}):ne(_)?q.workspaces.push({label:z,remoteAuthority:C,folderUri:i.URI.parse(_.folderUri)}):se(_)&&q.files.push({label:z,remoteAuthority:C,fileUri:i.URI.parse(_.fileUri)})});else{const _=F;Array.isArray(_.workspaces3)&&$(_.workspaces3,(z,C)=>{const A=Array.isArray(_.workspaceLabels)&&_.workspaceLabels[C]||void 0;typeof z=="object"&&typeof z.id=="string"&&typeof z.configURIPath=="string"?q.workspaces.push({label:A,workspace:{id:z.id,configPath:i.URI.parse(z.configURIPath)}}):typeof z=="string"&&q.workspaces.push({label:A,folderUri:i.URI.parse(z)})}),Array.isArray(_.files2)&&$(_.files2,(z,C)=>{const A=Array.isArray(_.fileLabels)&&_.fileLabels[C]||void 0;typeof z=="string"&&q.files.push({label:A,fileUri:i.URI.parse(z)})})}}return q}e.restoreRecentlyOpened=G;function te(F){const j={entries:[]};for(const q of F.workspaces)c(q)?j.entries.push({folderUri:q.folderUri.toString(),label:q.label,remoteAuthority:q.remoteAuthority}):j.entries.push({workspace:{id:q.workspace.id,configPath:q.workspace.configPath.toString()},label:q.label,remoteAuthority:q.remoteAuthority});for(const q of F.files)j.entries.push({fileUri:q.fileUri.toString(),label:q.label,remoteAuthority:q.remoteAuthority});return j}e.toStoreData=te}),define(Z[51],x([0,1,5,27]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,v.createDecorator)("backupMainService");function M(D){const I=D;return I&&(0,L.isWorkspaceIdentifier)(I.workspace)}e.isWorkspaceBackupInfo=M}),define(Z[52],x([0,1,14,9,80,34,2,68,7,3,13,19,133,5,6,39,27]),function(K,e,v,L,M,D,I,n,f,w,i,P,E,y,d,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,y.createDecorator)("dialogMainService");let S=class gt{constructor(h,o){this.stateMainService=h,this.logService=o,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(h,o){return this.doPick({...h,pickFolders:!0,pickFiles:!0,title:(0,E.localize)(0,null)},o)}pickFolder(h,o){return this.doPick({...h,pickFolders:!0,title:(0,E.localize)(1,null)},o)}pickFile(h,o){return this.doPick({...h,pickFiles:!0,title:(0,E.localize)(2,null)},o)}pickWorkspace(h,o){const u=(0,E.localize)(3,null),t=(0,D.mnemonicButtonLabel)((0,E.localize)(4,null)),l=b.WORKSPACE_FILTER;return this.doPick({...h,pickFiles:!0,title:u,filters:l,buttonLabel:t},o)}async doPick(h,o){const u={title:h.title,buttonLabel:h.buttonLabel,filters:h.filters};u.defaultPath=h.defaultPath||this.stateMainService.getItem(gt.workingDirPickerStorageKey),(typeof h.pickFiles=="boolean"||typeof h.pickFolders=="boolean")&&(u.properties=void 0,h.pickFiles&&h.pickFolders&&(u.properties=["multiSelections","openDirectory","openFile","createDirectory"])),u.properties||(u.properties=["multiSelections",h.pickFolders?"openDirectory":"openFile","createDirectory"]),w.isMacintosh&&u.properties.push("treatPackageAsDirectory");const t=o||v.BrowserWindow.getFocusedWindow(),l=await this.showOpenDialog(u,(0,i.withNullAsUndefined)(t));if(l&&l.filePaths&&l.filePaths.length>0)return this.stateMainService.setItem(gt.workingDirPickerStorageKey,(0,f.dirname)(l.filePaths[0])),l.filePaths}getWindowDialogQueue(h){if(h){let o=this.windowDialogQueues.get(h.id);return o||(o=new L.Queue,this.windowDialogQueues.set(h.id,o)),o}else return this.noWindowDialogueQueue}showMessageBox(h,o){return this.getWindowDialogQueue(o).queue(async()=>o?v.dialog.showMessageBox(o,h):v.dialog.showMessageBox(h))}async showSaveDialog(h,o){const u=this.acquireFileDialogLock(h,o);if(!u)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(o).queue(async()=>{let t;return o?t=await v.dialog.showSaveDialog(o,h):t=await v.dialog.showSaveDialog(h),t.filePath=this.normalizePath(t.filePath),t})}finally{(0,I.dispose)(u)}}normalizePath(h){return h&&w.isMacintosh&&(h=(0,n.normalizeNFC)(h)),h}normalizePaths(h){return h.map(o=>this.normalizePath(o))}async showOpenDialog(h,o){h.defaultPath&&(await P.Promises.exists(h.defaultPath)||(h.defaultPath=void 0));const u=this.acquireFileDialogLock(h,o);if(!u)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(o).queue(async()=>{let t;return o?t=await v.dialog.showOpenDialog(o,h):t=await v.dialog.showOpenDialog(h),t.filePaths=this.normalizePaths(t.filePaths),t})}finally{(0,I.dispose)(u)}}acquireFileDialogLock(h,o){if(!o)return I.Disposable.None;let u=this.windowFileDialogLocks.get(o.id);u||(u=new Set,this.windowFileDialogLocks.set(o.id,u));const t=(0,M.hash)(h);if(!u.has(t))return u.add(t),(0,I.toDisposable)(()=>{u?.delete(t),u?.size===0&&this.windowFileDialogLocks.delete(o.id)})}};S.workingDirPickerStorageKey="pickerWorkingDir",S=he([ie(0,m.IStateMainService),ie(1,d.ILogService)],S),e.DialogMainService=S}),define(Z[214],x([0,1,4,2,27]),function(K,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class D extends L.Disposable{constructor(n,f){super();this.logService=n,this.storageMainService=f,this._onDidChangeGlobalStorage=this._register(new v.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(v.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(n,f)=>(n?n.push(f):n=[f],n),D.STORAGE_CHANGE_DEBOUNCE_TIME)(n=>{n.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(n))}))}serializeGlobalStorageEvents(n){const f=new Map,w=new Set;return n.forEach(i=>{const P=this.storageMainService.globalStorage.get(i.key);typeof P=="string"?f.set(i.key,P):w.add(i.key)}),{changed:Array.from(f.entries()),deleted:Array.from(w.values())}}listen(n,f){switch(f){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${f}`)}async call(n,f,w){const i=(0,M.reviveIdentifier)(w.workspace),P=await this.withStorageInitialized(i);switch(f){case"getItems":return Array.from(P.items.entries());case"updateItems":{const E=w;if(E.insert)for(const[y,d]of E.insert)P.set(y,d);E.delete&&E.delete.forEach(y=>P.delete(y));break}case"close":{if(i)return P.close();break}default:throw new Error(`Call not found: ${f}`)}}async withStorageInitialized(n){const f=n?this.storageMainService.workspaceStorage(n):this.storageMainService.globalStorage;try{await f.init()}catch(w){this.logService.error(`StorageIPC#init: Unable to init ${n?"workspace":"global"} storage due to ${w}`)}return f}}e.StorageDatabaseChannel=D,D.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Z[215],x([0,1,4,2,7,28,19,86,123,6,97,29,27]),function(K,e,v,L,M,D,I,n,f,w,i,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class y extends L.Disposable{constructor(S){super();this.logService=S,this._onDidChangeStorage=this._register(new v.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new v.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new n.Storage(new n.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const S=await this.doCreate();this.storage.dispose(),this.storage=S,this._register(S.onDidChangeStorage(h=>this._onDidChangeStorage.fire({key:h}))),await this.doInit(S);const c=S.getBoolean(i.IS_NEW_KEY);c===void 0?S.set(i.IS_NEW_KEY,!0):c&&S.set(i.IS_NEW_KEY,!1)}catch(S){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${S}`)}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===w.LogLevel.Trace?S=>this.logService.trace(S):void 0,logError:S=>this.logService.error(S)}}doInit(S){return S.init()}get items(){return this.storage.items}get(S,c){return this.storage.get(S,c)}set(S,c){return this.storage.set(S,c)}delete(S){return this.storage.delete(S)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class d extends y{constructor(S,c,h){super(c);this.options=S,this.environmentService=h}async doCreate(){let S;return this.options.useInMemoryStorage?S=f.SQLiteStorageDatabase.IN_MEMORY_PATH:S=(0,M.join)(this.environmentService.globalStorageHome.fsPath,d.STORAGE_NAME),new n.Storage(new f.SQLiteStorageDatabase(S,{logging:this.createLoggingOptions()}))}async doInit(S){await super.doInit(S),this.updateTelemetryState(S)}updateTelemetryState(S){S.get(P.instanceStorageKey,void 0)===void 0&&S.set(P.instanceStorageKey,(0,D.generateUuid)()),S.get(P.firstSessionDateStorageKey,void 0)===void 0&&S.set(P.firstSessionDateStorageKey,new Date().toUTCString());const o=S.get(P.currentSessionDateStorageKey,void 0),u=new Date().toUTCString();S.set(P.lastSessionDateStorageKey,typeof o=="undefined"?null:o),S.set(P.currentSessionDateStorageKey,u)}}e.GlobalStorageMain=d,d.STORAGE_NAME="state.vscdb";class m extends y{constructor(S,c,h,o){super(h);this.workspace=S,this.options=c,this.environmentService=o}async doCreate(){const{storageFilePath:S,wasCreated:c}=await this.prepareWorkspaceStorageFolder();return new n.Storage(new f.SQLiteStorageDatabase(S,{logging:this.createLoggingOptions()}),{hint:c?n.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:f.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const S=(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),c=(0,M.join)(S,m.WORKSPACE_STORAGE_NAME);return await I.Promises.exists(S)?{storageFilePath:c,wasCreated:!1}:(await I.Promises.mkdir(S,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(S),{storageFilePath:c,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(S){let c;if((0,E.isSingleFolderWorkspaceIdentifier)(this.workspace)?c={folder:this.workspace.uri.toString()}:(0,E.isWorkspaceIdentifier)(this.workspace)&&(c={workspace:this.workspace.configPath.toString()}),c)try{const h=(0,M.join)(S,m.WORKSPACE_META_NAME);await I.Promises.exists(h)||await I.Promises.writeFile(h,JSON.stringify(c,void 0,2))}catch(h){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${h}`)}}}e.WorkspaceStorageMain=m,m.WORKSPACE_STORAGE_NAME="state.vscdb",m.WORKSPACE_META_NAME="workspace.json"}),define(Z[99],x([0,1,43,2,48,5,22,6,215]),function(K,e,v,L,M,D,I,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,D.createDecorator)("storageMainService");let w=class extends L.Disposable{constructor(P,E,y){super();this.logService=P,this.environmentService=E,this.lifecycleMainService=y,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async P=>{P.workspace&&this.workspaceStorage(P.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(P=>{P.join(this.globalStorage.close());for(const[,E]of this.mapWorkspaceToStorage)P.join(E.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const P=new f.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,v.once)(P.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),P}createWorkspaceStorage(P){return new f.WorkspaceStorageMain(P,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(P){let E=this.mapWorkspaceToStorage.get(P.id);return E||(this.logService.trace(`StorageMainService: creating workspace storage (${P.id})`),E=this.createWorkspaceStorage(P),this.mapWorkspaceToStorage.set(P.id,E),(0,v.once)(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${P.id})`),this.mapWorkspaceToStorage.delete(P.id)})),E}};w=he([ie(0,n.ILogService),ie(1,M.IEnvironmentService),ie(2,I.ILifecycleMainService)],w),e.StorageMainService=w}),define(Z[100],x([0,1,15,8,27]),function(K,e,v,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function D(f,w,i){for(const E of f){const y=E.openedWorkspace;if((0,M.isWorkspaceIdentifier)(y)){const d=i(y);if(d){if(d.folders.some(m=>v.extUriBiasedIgnorePathCase.isEqualOrParent(w,m.uri)))return E}else if(v.extUriBiasedIgnorePathCase.isEqualOrParent(w,y.configPath))return E}}const P=f.filter(E=>(0,M.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqualOrParent(w,E.openedWorkspace.uri));if(P.length)return P.sort((E,y)=>-(E.openedWorkspace.uri.path.length-y.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=D;function I(f,w){for(const i of f)if((0,M.isWorkspaceIdentifier)(i.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,w)||(0,M.isSingleFolderWorkspaceIdentifier)(i.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.uri,w))return i}e.findWindowOnWorkspaceOrFolder=I;function n(f,w){const i=P=>w.some(E=>v.extUriBiasedIgnorePathCase.isEqual(L.URI.file(E),L.URI.file(P)));for(const P of f)if(P.config?.extensionDevelopmentPath?.some(E=>i(E)))return P}e.findWindowOnExtensionDevelopmentPath=n}),define(Z[216],x([0,1,14,2,3,15,8,16,22,6,39,36,27]),function(K,e,v,L,M,D,I,n,f,w,i,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let y=class mt extends L.Disposable{constructor(h,o,u,t,l){super();this.windowsMainService=h,this.stateMainService=o,this.lifecycleMainService=u,this.logService=t,this.configurationService=l,this._state=d(this.stateMainService.getItem(mt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(h=>this.onBeforeCloseWindow(h)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(h=>this.onBeforeCloseWindow(h))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const h={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!h.lastActiveWindow){let t=this.windowsMainService.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.windowsMainService.getWindows().find(l=>!l.isExtensionDevelopmentHost)),t&&(h.lastActiveWindow=this.toWindowState(t))}const o=this.windowsMainService.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);o&&(h.lastPluginDevelopmentHostWindow=this.toWindowState(o)),this.windowsMainService.getWindowCount()>1&&(h.openedWindows=this.windowsMainService.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>this.toWindowState(t)));const u=b(h);this.stateMainService.setItem(mt.windowsStateStorageKey,u),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",u)}onBeforeCloseWindow(h){if(this.lifecycleMainService.quitRequested)return;const o=this.toWindowState(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=o:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this._state.openedWindows.forEach(u=>{const t=(0,E.isWorkspaceIdentifier)(h.openedWorkspace)&&u.workspace?.id===h.openedWorkspace.id,l=(0,E.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)&&u.folderUri&&D.extUriBiasedIgnorePathCase.isEqual(u.folderUri,h.openedWorkspace.uri);(t||l)&&(u.uiState=o.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=o)}toWindowState(h){return{workspace:(0,E.isWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:(0,E.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const o=this.doGetNewWindowState(h),u=this.configurationService.getValue("window");let t;return o.hasDefaultState?t=!!(u?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(u.newWindowDimensions)>=0):(t=!!(this.lifecycleMainService.wasRestarted||u?.restoreFullscreen),t&&M.isMacintosh&&this.windowsMainService.getWindows().some(l=>l.isFullScreen)&&(t=!1)),o.mode===3&&!t&&(o.mode=1),o}doGetNewWindowState(h){const o=this.windowsMainService.getLastActiveWindow();if(!h.extensionTestsPath){if(!!h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const a=h.workspace;if((0,E.isWorkspaceIdentifier)(a)){const p=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===a.id).map(k=>k.uiState);if(p.length)return p[0]}if((0,E.isSingleFolderWorkspaceIdentifier)(a)){const p=this.state.openedWindows.filter(k=>k.folderUri&&D.extUriBiasedIgnorePathCase.isEqual(k.folderUri,a.uri)).map(k=>k.uiState);if(p.length)return p[0]}else if(h.backupPath){const p=this.state.openedWindows.filter(k=>k.backupPath===h.backupPath).map(k=>k.uiState);if(p.length)return p[0]}const g=this.lastClosedState||this.state.lastActiveWindow;if(!o&&g)return g.uiState}let u;const t=v.screen.getAllDisplays();if(t.length===1)u=t[0];else{if(M.isMacintosh){const a=v.screen.getCursorScreenPoint();u=v.screen.getDisplayNearestPoint(a)}!u&&o&&(u=v.screen.getDisplayMatching(o.getBounds())),u||(u=v.screen.getPrimaryDisplay()||t[0])}let l=(0,P.defaultWindowState)();l.x=Math.round(u.bounds.x+u.bounds.width/2-l.width/2),l.y=Math.round(u.bounds.y+u.bounds.height/2-l.height/2);const s=this.configurationService.getValue("window");let r=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")l.mode=0,r=!1;else if(s.newWindowDimensions==="fullscreen")l.mode=3,r=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&o){const a=o.serializeWindowState();a.mode===3?l.mode=3:l=a,r=l.mode!==3&&s.newWindowDimensions==="offset"}}return r&&(l=this.ensureNoOverlap(l)),l.hasDefaultState=!0,l}ensureNoOverlap(h){if(this.windowsMainService.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const o=this.windowsMainService.getWindows().map(u=>u.getBounds());for(;o.some(u=>u.x===h.x||u.y===h.y);)h.x+=30,h.y+=30;return h}};y.windowsStateStorageKey="windowsState",y=he([ie(0,P.IWindowsMainService),ie(1,i.IStateMainService),ie(2,f.ILifecycleMainService),ie(3,w.ILogService),ie(4,n.IConfigurationService)],y),e.WindowsStateHandler=y;function d(c){const h={openedWindows:[]},o=c||{openedWindows:[]};return o.lastActiveWindow&&(h.lastActiveWindow=m(o.lastActiveWindow)),o.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=m(o.lastPluginDevelopmentHostWindow)),Array.isArray(o.openedWindows)&&(h.openedWindows=o.openedWindows.map(u=>m(u))),h}e.restoreWindowsState=d;function m(c){const h={uiState:c.uiState};return c.backupPath&&(h.backupPath=c.backupPath),c.remoteAuthority&&(h.remoteAuthority=c.remoteAuthority),c.folder&&(h.folderUri=I.URI.parse(c.folder)),c.workspaceIdentifier&&(h.workspace={id:c.workspaceIdentifier.id,configPath:I.URI.parse(c.workspaceIdentifier.configURIPath)}),h}function b(c){return{lastActiveWindow:c.lastActiveWindow&&S(c.lastActiveWindow),lastPluginDevelopmentHostWindow:c.lastPluginDevelopmentHostWindow&&S(c.lastPluginDevelopmentHostWindow),openedWindows:c.openedWindows.map(h=>S(h))}}e.getWindowsStateStoreData=b;function S(c){return{workspaceIdentifier:c.workspace&&{id:c.workspace.id,configURIPath:c.workspace.configPath.toString()},folder:c.folderUri&&c.folderUri.toString(),backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.uiState}}}),define(Z[101],x([0,1,58,32,10,3,15]),function(K,e,v,L,M,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function n(w){function i(){let P=w.scheme===M.Schemas.file?(0,I.originalFSPath)(w):w.toString();return D.isLinux||(P=P.toLowerCase()),(0,v.createHash)("md5").update(P).digest("hex")}return{id:i(),configPath:w}}e.getWorkspaceIdentifier=n;function f(w,i){function P(){if(w.scheme!==M.Schemas.file)return(0,v.createHash)("md5").update(w.toString()).digest("hex");if(!i)try{i=(0,L.statSync)(w.fsPath)}catch(d){return}let y;return D.isLinux?y=i.ino:D.isMacintosh?y=i.birthtime.getTime():D.isWindows&&(typeof i.birthtimeMs=="number"?y=Math.floor(i.birthtimeMs):y=i.birthtime.getTime()),(0,v.createHash)("md5").update(w.fsPath).update(y?String(y):"").digest("hex")}const E=P();if(typeof E=="string")return{id:E,uri:w}}e.getSingleFolderWorkspaceIdentifier=f}),define(Z[56],x([0,1,58,59,26,18,17,4,2,7,3,28,35,84,217]),function(K,e,v,L,M,D,I,n,f,w,i,P,E,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class m{constructor(p){this.socket=p,this._errorListener=k=>{if(k){if(k.code==="EPIPE")return;(0,I.onUnexpectedError)(k)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(p){const k=R=>p(D.VSBuffer.wrap(R));return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(p){const k=R=>{p({type:0,hadError:R,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(p){return this.socket.on("end",p),{dispose:()=>this.socket.off("end",p)}}write(p){if(!this.socket.destroyed)try{this.socket.write(p.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,I.onUnexpectedError)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,I.onUnexpectedError)(k)}}end(){this.socket.end()}drain(){return new Promise((p,k)=>{if(this.socket.bufferSize===0){p();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),p()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.NodeSocket=m;var b;(function(g){g[g.MinHeaderByteSize=2]="MinHeaderByteSize"})(b||(b={}));var S;(function(g){g[g.PeekHeader=1]="PeekHeader",g[g.ReadHeader=2]="ReadHeader",g[g.ReadBody=3]="ReadBody",g[g.Fin=4]="Fin"})(S||(S={}));class c extends f.Disposable{constructor(p,k,R,T){super();this._onDidZlibFlush=this._register(new n.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new n.Emitter),this._onClose=this._register(new n.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=p,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=k,this._recordInflateBytes=T,k?(this._zlibInflate=d.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",O=>{console.error(O),(0,I.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})}),this._zlibInflate.on("data",O=>{this._pendingInflateData.push(O)}),R&&(this._zlibInflate.write(R.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=d.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{console.error(O),(0,I.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})}),this._zlibDeflate.on("data",O=>{this._pendingDeflateData.push(O)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new y.ChunkStream,this._register(this.socket.onData(O=>this._acceptChunk(O))),this._register(this.socket.onClose(O=>this._onClose.fire(O)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):D.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this._onData.event(p)}onClose(p){return this._onClose.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){this._totalOutgoingDataBytes+=p.byteLength,this._zlibDeflate?(this._zlibDeflate.write(p.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let k=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,k=k.slice(0,k.length-4),this._isEnded||this._write(D.VSBuffer.wrap(k),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(p,!1)}_write(p,k){let R=2;p.byteLength<126?R+=0:p.byteLength<2**16?R+=2:R+=8;const T=D.VSBuffer.alloc(R);if(k?T.writeUInt8(194,0):T.writeUInt8(130,0),p.byteLength<126)T.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){T.writeUInt8(126,1);let O=1;T.writeUInt8(p.byteLength>>>8&255,++O),T.writeUInt8(p.byteLength>>>0&255,++O)}else{T.writeUInt8(127,1);let O=1;T.writeUInt8(0,++O),T.writeUInt8(0,++O),T.writeUInt8(0,++O),T.writeUInt8(0,++O),T.writeUInt8(p.byteLength>>>24&255,++O),T.writeUInt8(p.byteLength>>>16&255,++O),T.writeUInt8(p.byteLength>>>8&255,++O),T.writeUInt8(p.byteLength>>>0&255,++O)}this._totalOutgoingWireBytes+=T.byteLength+p.byteLength,this.socket.write(D.VSBuffer.concat([T,p]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(p){if(p.byteLength!==0){for(this._totalIncomingWireBytes+=p.byteLength,this._incomingData.acceptChunk(p);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const k=this._incomingData.peek(this._state.readLen),R=k.readUInt8(0),T=(R&128)>>>7,O=(R&64)>>>6,V=k.readUInt8(1),ne=(V&128)>>>7,se=V&127;this._state.state=2,this._state.readLen=2+(ne?4:0)+(se===126?2:0)+(se===127?8:0),this._state.fin=T,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(O)),this._state.firstFrameOfMessage=Boolean(T),this._state.mask=0}else if(this._state.state===2){const k=this._incomingData.read(this._state.readLen),R=k.readUInt8(1),T=(R&128)>>>7;let O=R&127,V=1;O===126?O=k.readUInt8(++V)*2**8+k.readUInt8(++V):O===127&&(O=k.readUInt8(++V)*0+k.readUInt8(++V)*0+k.readUInt8(++V)*0+k.readUInt8(++V)*0+k.readUInt8(++V)*2**24+k.readUInt8(++V)*2**16+k.readUInt8(++V)*2**8+k.readUInt8(++V));let ne=0;T&&(ne=k.readUInt8(++V)*2**24+k.readUInt8(++V)*2**16+k.readUInt8(++V)*2**8+k.readUInt8(++V)),this._state.state=3,this._state.readLen=O,this._state.mask=ne}else if(this._state.state===3){const k=this._incomingData.read(this._state.readLen);h(k,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(k.buffer)),this._zlibInflate.write(k.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const R=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=R.length,this._onData.fire(D.VSBuffer.wrap(R))})):(this._totalIncomingDataBytes+=k.byteLength,this._onData.fire(k))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await n.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=c;function h(g,p){if(p===0)return;let k=g.byteLength>>>2;for(let se=0;se<k;se++){const G=g.readUInt32BE(se*4);g.writeUInt32BE(G^p,se*4)}let R=k*4,T=g.byteLength-R;const O=p>>>24&255,V=p>>>16&255,ne=p>>>8&255;T>=1&&g.writeUInt8(g.readUInt8(R)^O,R),T>=2&&g.writeUInt8(g.readUInt8(R+1)^V,R+1),T>=3&&g.writeUInt8(g.readUInt8(R+2)^ne,R+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function u(){const g=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${g}-sock`;let p;return e.XDG_RUNTIME_DIR?p=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${g}.sock`):p=(0,w.join)((0,M.tmpdir)(),`vscode-ipc-${g}.sock`),l(p),p}e.createRandomIPCHandle=u;function t(g,p,k){const R=(0,v.createHash)("md5").update(g).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${k}-${p}-sock`;let T;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?T=(0,w.join)(e.XDG_RUNTIME_DIR,`vscode-${R.substr(0,8)}-${k}-${p}.sock`):T=(0,w.join)(g,`${k}-${p}.sock`),l(T),T}e.createStaticIPCHandle=t;function l(g){const p=o[i.platform];typeof p=="number"&&g.length>=p&&console.warn(`WARNING: IPC handle "${g}" is longer than ${p} chars, try a shorter --user-data-dir`)}class s extends E.IPCServer{constructor(p){super(s.toClientConnectionEvent(p));this.server=p}static toClientConnectionEvent(p){const k=n.Event.fromNodeEventEmitter(p,"connection");return n.Event.map(k,R=>({protocol:new y.Protocol(new m(R)),onDidClientDisconnect:n.Event.once(n.Event.fromNodeEventEmitter(R,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function r(g){return new Promise((p,k)=>{const R=(0,L.createServer)();R.on("error",k),R.listen(g,()=>{R.removeListener("error",k),p(new s(R))})})}e.serve=r;function a(g,p){return new Promise((k,R)=>{const T=(0,L.createConnection)(g,()=>{T.removeListener("error",R),k(y.Client.fromSocket(new m(T),p))});T.once("error",R)})}e.connect=a}),define(Z[218],x([0,1,56]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class L{constructor(f){this.driver=f}listen(f,w){throw new Error("No event found")}call(f,w,i){switch(w){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(i);case"reloadWindow":return this.driver.reloadWindow(i);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(i[0],i[1]);case"click":return this.driver.click(i[0],i[1],i[2],i[3]);case"doubleClick":return this.driver.doubleClick(i[0],i[1]);case"setValue":return this.driver.setValue(i[0],i[1],i[2]);case"getTitle":return this.driver.getTitle(i[0]);case"isActiveElement":return this.driver.isActiveElement(i[0],i[1]);case"getElements":return this.driver.getElements(i[0],i[1],i[2]);case"getElementXY":return this.driver.getElementXY(i[0],i[1],i[2]);case"typeInEditor":return this.driver.typeInEditor(i[0],i[1],i[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(i[0],i[1]);case"writeInTerminal":return this.driver.writeInTerminal(i[0],i[1],i[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(i);case"getLocalizedStrings":return this.driver.getLocalizedStrings(i)}throw new Error(`Call not found: ${w}`)}}e.DriverChannel=L;class M{constructor(f){this.channel=f}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(f){return this.channel.call("capturePage",f)}reloadWindow(f){return this.channel.call("reloadWindow",f)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(f,w){return this.channel.call("dispatchKeybinding",[f,w])}click(f,w,i,P){return this.channel.call("click",[f,w,i,P])}doubleClick(f,w){return this.channel.call("doubleClick",[f,w])}setValue(f,w,i){return this.channel.call("setValue",[f,w,i])}getTitle(f){return this.channel.call("getTitle",[f])}isActiveElement(f,w){return this.channel.call("isActiveElement",[f,w])}getElements(f,w,i){return this.channel.call("getElements",[f,w,i])}getElementXY(f,w,i,P){return this.channel.call("getElementXY",[f,w,i,P])}typeInEditor(f,w,i){return this.channel.call("typeInEditor",[f,w,i])}getTerminalBuffer(f,w){return this.channel.call("getTerminalBuffer",[f,w])}writeInTerminal(f,w,i){return this.channel.call("writeInTerminal",[f,w,i])}getLocaleInfo(f){return this.channel.call("getLocaleInfo",f)}getLocalizedStrings(f){return this.channel.call("getLocalizedStrings",f)}}e.DriverChannelClient=M;class D{constructor(f){this.registry=f}listen(f,w){throw new Error(`Event not found: ${w}`)}call(f,w,i){switch(w){case"registerWindowDriver":return this.registry.registerWindowDriver(i);case"reloadWindowDriver":return this.registry.reloadWindowDriver(i)}throw new Error(`Call not found: ${w}`)}}e.WindowDriverRegistryChannel=D;async function I(n){const f=await(0,v.connect)(n,"driverClient"),w=f.getChannel("driver"),i=new M(w);return{client:f,driver:i}}e.connect=I}),define(Z[219],x([0,1,9,4,106,57,2,3,79,35,56,156,218,174,22,36]),function(K,e,v,L,M,D,I,n,f,w,i,P,E,y,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function b(h){return h<21}let S=class{constructor(o,u,t,l){this.windowServer=o,this.options=u,this.windowsMainService=t,this.lifecycleMainService=l,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new L.Emitter}async registerWindowDriver(o){return this.registeredWindowIds.add(o),this.reloadingWindowIds.delete(o),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(o){this.reloadingWindowIds.add(o)}async getWindowIds(){return this.windowsMainService.getWindows().map(o=>o.id).filter(o=>this.registeredWindowIds.has(o)&&!this.reloadingWindowIds.has(o))}async capturePage(o){await this.whenUnfrozen(o);const u=this.windowsMainService.getWindowById(o);if(!u?.win)throw new Error("Invalid window");return(await u.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(o){await this.whenUnfrozen(o);const u=this.windowsMainService.getWindowById(o);if(!u)throw new Error("Invalid window");this.reloadingWindowIds.add(o),this.lifecycleMainService.reload(u)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(o,u){await this.whenUnfrozen(o);const t=M.KeybindingParser.parseUserBinding(u);for(let l of t)await this._dispatchKeybinding(o,l)}async _dispatchKeybinding(o,u){if(u instanceof f.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const t=this.windowsMainService.getWindowById(o);if(!t?.win)throw new Error("Invalid window");const l=t.win.webContents,s=new D.SimpleKeybinding(!1,!1,!1,!1,u.keyCode),a=new y.USLayoutResolvedKeybinding(s.toChord(),n.OS).getElectronAccelerator(),g=[];u.ctrlKey&&g.push("ctrl"),u.metaKey&&g.push("meta"),u.shiftKey&&g.push("shift"),u.altKey&&g.push("alt"),l.sendInputEvent({type:"keyDown",keyCode:a,modifiers:g}),b(u.keyCode)||l.sendInputEvent({type:"char",keyCode:a,modifiers:g}),l.sendInputEvent({type:"keyUp",keyCode:a,modifiers:g}),await(0,v.timeout)(100)}async click(o,u,t,l){await(await this.getWindowDriver(o)).click(u,t,l)}async doubleClick(o,u){await(await this.getWindowDriver(o)).doubleClick(u)}async setValue(o,u,t){await(await this.getWindowDriver(o)).setValue(u,t)}async getTitle(o){return await(await this.getWindowDriver(o)).getTitle()}async isActiveElement(o,u){return await(await this.getWindowDriver(o)).isActiveElement(u)}async getElements(o,u,t){return await(await this.getWindowDriver(o)).getElements(u,t)}async getElementXY(o,u,t,l){return await(await this.getWindowDriver(o)).getElementXY(u,t,l)}async typeInEditor(o,u,t){await(await this.getWindowDriver(o)).typeInEditor(u,t)}async getTerminalBuffer(o,u){return await(await this.getWindowDriver(o)).getTerminalBuffer(u)}async writeInTerminal(o,u,t){await(await this.getWindowDriver(o)).writeInTerminal(u,t)}async getLocaleInfo(o){return await(await this.getWindowDriver(o)).getLocaleInfo()}async getLocalizedStrings(o){return await(await this.getWindowDriver(o)).getLocalizedStrings()}async getWindowDriver(o){await this.whenUnfrozen(o);const u=`window:${o}`,t=new w.StaticRouter(s=>s===u),l=this.windowServer.getChannel("windowDriver",t);return new P.WindowDriverChannelClient(l)}async whenUnfrozen(o){for(;this.reloadingWindowIds.has(o);)await L.Event.toPromise(this.onDidReloadingChange.event)}};S=he([ie(2,m.IWindowsMainService),ie(3,d.ILifecycleMainService)],S),e.Driver=S;async function c(h,o,u,t){const l=u.driverVerbose,s=t.createInstance(S,h,{verbose:l}),r=new E.WindowDriverRegistryChannel(s);h.registerChannel("windowDriverRegistry",r);const a=await(0,i.serve)(o),g=new E.DriverChannel(s);return a.registerChannel("driver",g),(0,I.combinedDisposable)(a,h)}e.serve=c}),define(Z[24],x([0,1,47,7,56,48,160,5]),function(K,e,v,L,M,D,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,n.refineServiceDecorator)(D.IEnvironmentService);class f extends I.NativeEnvironmentService{get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,L.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,M.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}he([v.memoize],f.prototype,"cachedLanguagesPath",null),he([v.memoize],f.prototype,"backupHome",null),he([v.memoize],f.prototype,"backupWorkspacesPath",null),he([v.memoize],f.prototype,"mainIPCHandle",null),he([v.memoize],f.prototype,"mainLockfile",null),he([v.memoize],f.prototype,"sandbox",null),he([v.memoize],f.prototype,"driverVerbose",null),he([v.memoize],f.prototype,"disableUpdates",null),he([v.memoize],f.prototype,"disableKeytar",null),he([v.memoize],f.prototype,"codeCachePath",null),he([v.memoize],f.prototype,"useCodeCache",null),e.EnvironmentMainService=f}),define(Z[220],x([0,1,58,32,31,10,7,3,15,8,19,51,16,24,20,6,27]),function(K,e,v,L,M,D,I,n,f,w,i,P,E,y,d,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let S=class{constructor(h,o,u){this.configurationService=o,this.logService=u,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=f.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,l)=>(0,M.isEqual)(t,l,!n.isLinux)},this.backupHome=h.backupHome,this.workspacesJsonPath=h.backupWorkspacesPath}async initialize(){let h;try{h=JSON.parse(await i.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(t){h=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(h.emptyWorkspaceInfos);let o=[];try{Array.isArray(h.rootURIWorkspaces)&&(o=h.rootURIWorkspaces.map(t=>({workspace:{id:t.id,configPath:w.URI.parse(t.configURIPath)},remoteAuthority:t.remoteAuthority})))}catch(t){}this.workspaces=await this.validateWorkspaces(o);let u=[];try{Array.isArray(h.folderURIWorkspaces)&&(u=h.folderURIWorkspaces.map(t=>w.URI.parse(t)))}catch(t){}this.folders=await this.validateFolders(u),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==d.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(h,o){this.workspaces.some(t=>h.workspace.id===t.workspace.id)||(this.workspaces.push(h),this.saveSync());const u=this.getBackupPath(h.workspace.id);return o&&this.moveBackupFolderSync(u,o),u}moveBackupFolderSync(h,o){if(L.existsSync(h)&&this.convertToEmptyWindowBackupSync(h),L.existsSync(o))try{L.renameSync(o,h)}catch(u){this.logService.error(`Backup: Could not move backup folder to new location: ${u.toString()}`)}}unregisterWorkspaceBackupSync(h){const o=h.id,u=this.workspaces.findIndex(t=>t.workspace.id===o);u!==-1&&(this.workspaces.splice(u,1),this.saveSync())}registerFolderBackupSync(h){return this.folders.some(o=>this.backupUriComparer.isEqual(h,o))||(this.folders.push(h),this.saveSync()),this.getBackupPath(this.getFolderHash(h))}unregisterFolderBackupSync(h){const o=this.folders.findIndex(u=>this.backupUriComparer.isEqual(h,u));o!==-1&&(this.folders.splice(o,1),this.saveSync())}registerEmptyWindowBackupSync(h,o){const u=h||this.getRandomEmptyWindowId();return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,u))||(this.emptyWindows.push({backupFolder:u,remoteAuthority:o}),this.saveSync()),this.getBackupPath(u)}unregisterEmptyWindowBackupSync(h){const o=this.emptyWindows.findIndex(u=>!!u.backupFolder&&this.backupPathComparer.isEqual(u.backupFolder,h));o!==-1&&(this.emptyWindows.splice(o,1),this.saveSync())}getBackupPath(h){return(0,I.join)(this.backupHome,h)}async validateWorkspaces(h){if(!Array.isArray(h))return[];const o=new Set,u=[];for(let t of h){const l=t.workspace;if(!(0,b.isWorkspaceIdentifier)(l))return[];if(!o.has(l.id)){o.add(l.id);const s=this.getBackupPath(l.id);await this.doHasBackups(s)?l.configPath.scheme!==D.Schemas.file||await i.Promises.exists(l.configPath.fsPath)?u.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return u}async validateFolders(h){if(!Array.isArray(h))return[];const o=[],u=new Set;for(let t of h){const l=this.backupUriComparer.getComparisonKey(t);if(!u.has(l)){u.add(l);const s=this.getBackupPath(this.getFolderHash(t));await this.doHasBackups(s)?t.scheme!==D.Schemas.file||await i.Promises.exists(t.fsPath)?o.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return o}async validateEmptyWorkspaces(h){if(!Array.isArray(h))return[];const o=[],u=new Set;for(let t of h){const l=t.backupFolder;if(typeof l!="string")return[];if(!u.has(l)){u.add(l);const s=this.getBackupPath(l);await this.doHasBackups(s)?o.push(t):await this.deleteStaleBackup(s)}}return o}async deleteStaleBackup(h){try{await i.Promises.exists(h)&&await i.Promises.rm(h,i.RimRafMode.MOVE)}catch(o){this.logService.error(`Backup: Could not delete stale backup: ${o.toString()}`)}}async convertToEmptyWindowBackup(h){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,o));)o=this.getRandomEmptyWindowId();const u=this.getBackupPath(o);try{await i.Promises.rename(h,u)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}convertToEmptyWindowBackupSync(h){let o=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,o));)o=this.getRandomEmptyWindowId();const u=this.getBackupPath(o);try{L.renameSync(h,u)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:o}),!0}async getDirtyWorkspaces(){const h=[];for(const o of this.workspaces)await this.hasBackups(o)&&h.push(o.workspace);for(const o of this.folders)await this.hasBackups(o)&&h.push(o);return h}hasBackups(h){let o;return w.URI.isUri(h)?o=this.getBackupPath(this.getFolderHash(h)):(0,P.isWorkspaceBackupInfo)(h)?o=this.getBackupPath(h.workspace.id):o=h.backupFolder,this.doHasBackups(o)}async doHasBackups(h){try{const o=await i.Promises.readdir(h);for(const u of o)try{if((await i.Promises.readdir((0,I.join)(h,u))).length>0)return!0}catch(t){}}catch(o){}return!1}saveSync(){try{(0,i.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}async save(){try{await i.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(h=>({id:h.workspace.id,configURIPath:h.workspace.configPath.toString(),remoteAuthority:h.remoteAuthority})),folderURIWorkspaces:this.folders.map(h=>h.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(h){let o;return h.scheme===D.Schemas.file?o=n.isLinux?h.fsPath:h.fsPath.toLowerCase():o=h.toString().toLowerCase(),(0,v.createHash)("md5").update(o).digest("hex")}};S=he([ie(0,y.IEnvironmentMainService),ie(1,E.IConfigurationService),ie(2,m.ILogService)],S),e.BackupMainService=S}),define(Z[221],x([0,1,59,56]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(M,D,I,n){const f=i=>n(i,void 0),w=v.createConnection({host:M,port:D},()=>{w.removeListener("error",f);const i=Buffer.alloc(16);for(let d=0;d<16;d++)i[d]=Math.round(Math.random()*256);const P=i.toString("base64");let E=[`GET ws://${/:/.test(M)?`[${M}]`:M}:${D}/?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${P}`];w.write(E.join(`\r
`)+`\r
\r
`);const y=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",y),n(void 0,new L.NodeSocket(w)))};w.on("data",y)});w.once("error",f)}}}),define(Z[222],x([0,1,59,115,221,9,2,16,6,21,189,96,75]),function(K,e,v,L,M,D,I,n,f,w,i,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function y(S,c,h,o,u){return new d(S,c,h,o,u).waitForReady()}class d extends I.Disposable{constructor(c,h,o,u,t){super();this.defaultTunnelHost=h,this.suggestedLocalPort=t,this.privacy=P.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=c,this._server=v.createServer(),this._barrier=new D.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=l=>this._onConnection(l),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=u,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(h=>{h()})}async waitForReady(){let c=await(0,L.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),h=null;return this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address(),h||(c=0,this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address()),this.tunnelLocalPort=h.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${h.port}`,this}async _onConnection(c){c.pause();const h=(0,P.isLocalhost)(this.tunnelRemoteHost)||(0,P.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,o=await(0,i.connectRemoteAgentTunnel)(this._options,h,this.tunnelRemotePort),u=o.getSocket().socket,t=o.readEntireBuffer();o.dispose(),t.byteLength>0&&c.write(t.buffer),c.on("end",()=>{this._socketsDispose.delete(c.localAddress),u.end()}),c.on("close",()=>u.end()),c.on("error",()=>{this._socketsDispose.delete(c.localAddress),u.destroy()}),u.on("end",()=>c.end()),u.on("close",()=>c.end()),u.on("error",()=>{c.destroy()}),c.pipe(u),u.pipe(c),this._socketsDispose.set(c.localAddress,()=>{c.end(),u.end()})}}let m=class extends P.AbstractTunnelService{constructor(c,h,o,u,t){super(h);this.socketFactory=c,this.signService=o,this.productService=u,this.configurationService=t}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(c,h,o,u,t,l,s){const r=this.getTunnelFromMap(h,o);if(r)return++r.refcount,r.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,h,o,u,t,l,s);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${o} on local port ${u}.`);const a={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:c,signService:this.signService,logService:this.logService,ipcLogger:null},g=y(a,this.defaultTunnelHost,h,o,u);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(h,o,g),g}}};m=he([ie(1,f.ILogService),ie(2,E.ISignService),ie(3,w.IProductService),ie(4,n.IConfigurationService)],m),e.BaseTunnelService=m;let b=class extends m{constructor(c,h,o,u){super(M.nodeSocketFactory,c,h,o,u)}};b=he([ie(0,f.ILogService),ie(1,E.ISignService),ie(2,w.IProductService),ie(3,n.IConfigurationService)],b),e.TunnelService=b}),define(Z[223],x([0,1,193,18,17,2,13,16,48,91,6,192,217]),function(K,e,v,L,M,D,I,n,f,w,i,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let y=class extends D.Disposable{constructor(m,b,S){super();this.environmentService=b,this.logService=S,this.configure(m.getValue()),this._register(m.onDidChangeConfiguration(()=>this.configure(m.getValue()),this))}configure(m){this.proxyUrl=m.http&&m.http.proxy,this.strictSSL=!!(m.http&&m.http.proxyStrictSSL),this.authorization=m.http&&m.http.proxyAuthorization}async request(m,b){this.logService.trace("RequestService#request",m.url);const{proxyUrl:S,strictSSL:c}=this;let h;try{h=await(0,w.resolveShellEnv)(this.logService,this.environmentService.args,process.env)}catch(t){this.logService.error("RequestService#request resolving shell environment failed",t)}const o={...process.env,...h},u=m.agent?m.agent:await(0,P.getProxyAgent)(m.url||"",o,{proxyUrl:S,strictSSL:c});return m.agent=u,m.strictSSL=c,this.authorization&&(m.headers={...m.headers||{},"Proxy-Authorization":this.authorization}),this._request(m,b)}async getNodeRequest(m){return((0,v.parse)(m.url).protocol==="https:"?await new Promise((c,h)=>{K(["https"],c,h)}):await new Promise((c,h)=>{K(["http"],c,h)})).request}_request(m,b){return new Promise(async(S,c)=>{let h;const o=(0,v.parse)(m.url),u=m.getRawRequest?m.getRawRequest(m):await this.getNodeRequest(m),t={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,I.isBoolean)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(t.auth=m.user+":"+m.password),h=u(t,l=>{const s=(0,I.isNumber)(m.followRedirects)?m.followRedirects:3;if(l.statusCode&&l.statusCode>=300&&l.statusCode<400&&s>0&&l.headers.location)this._request({...m,url:l.headers.location,followRedirects:s-1},b).then(S,c);else{let r=l;l.headers["content-encoding"]==="gzip"&&(r=l.pipe((0,E.createGunzip)())),S({res:l,stream:(0,L.streamToBufferReadableStream)(r)})}}),h.on("error",c),m.timeout&&h.setTimeout(m.timeout),m.data&&typeof m.data=="string"&&h.write(m.data),h.end(),b.onCancellationRequested(()=>{h.abort(),c((0,M.canceled)())})})}async resolveProxy(m){}};y=he([ie(0,n.IConfigurationService),ie(1,f.INativeEnvironmentService),ie(2,i.ILogService)],y),e.RequestService=y}),define(Z[224],x([0,1,14,223]),function(K,e,v,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function M(I){return v.net.request}class D extends L.RequestService{request(n,f){return super.request({...n||{},getRawRequest:M},f)}}e.RequestMainService=D}),define(Z[225],x([0,1,14,9,4,2,10,13,85,24,22,6,45,55,63]),function(K,e,v,L,M,D,I,n,f,w,i,P,E,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let m=class extends D.Disposable{constructor(S,c,h,o,u,t,l){super();this.machineId=S,this.userEnv=c,this.environmentMainService=h,this.lifecycleMainService=o,this.logService=u,this.themeMainService=t,this.protocolMainService=l,this.firstWindowConnectionBarrier=new L.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new M.Emitter),this.onDidError=M.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),v.ipcMain.on("vscode:createSharedProcessMessageChannel",async(S,c)=>this.onWindowConnection(S,c))}async onWindowConnection(S,c){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const h=await this.connect();if(S.sender.isDestroyed())return h.close();S.sender.postMessage("vscode:createSharedProcessMessageChannelResult",c,[h])}onWillShutdown(){const S=this.window;!S||(!S.isDestroyed()&&!S.webContents.isDestroyed()&&S.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(S.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{S.close()}catch(c){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(S=>v.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),S()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(S=>v.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),S()}))})()),this._whenIpcReady}createWindow(){const S=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new v.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:I.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",K).fsPath,additionalArguments:[`--vscode-window-config=${S.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),S.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:E.default}),this.window.loadURL(I.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",K).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=S=>{this.logService.trace("SharedProcess#close prevented"),S.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(S,c)=>this._onDidError.fire({type:2,details:c})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(S,c,h)=>this._onDidError.fire({type:3,details:{reason:h,exitCode:c}})))}async connect(){await this.whenIpcReady;const S=(0,n.assertIsDefined)(this.window);return(0,f.connect)(S)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}};m=he([ie(2,w.IEnvironmentMainService),ie(3,i.ILifecycleMainService),ie(4,P.ILogService),ie(5,d.IThemeMainService),ie(6,y.IProtocolMainService)],m),e.SharedProcess=m}),define(Z[226],x([0,1,9,18,7,13,8,24,20,6]),function(K,e,v,L,M,D,I,n,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class i{constructor(y,d,m){this.storagePath=y,this.logService=d,this.fileService=m,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new v.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}}getItem(y,d){const m=this.storage[y];return(0,D.isUndefinedOrNull)(m)?d:m}setItem(y,d){this.setItems([{key:y,data:d}])}setItems(y){let d=!1;for(const{key:m,data:b}of y)this.storage[m]!==b&&((0,D.isUndefinedOrNull)(b)?(0,D.isUndefined)(this.storage[m])||(this.storage[m]=void 0,d=!0):(this.storage[m]=b,d=!0));d&&this.save()}removeItem(y){(0,D.isUndefined)(this.storage[y])||(this.storage[y]=void 0,this.save())}async save(y){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),y)}async doSave(){if(!this.initializing)return;await this.initializing;const y=JSON.stringify(this.storage,null,4);if(y!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(y)),this.lastSavedStorageContents=y}catch(d){this.logService.error(d)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=i;let P=class yt{constructor(y,d,m){this.fileStorage=new i(I.URI.file((0,M.join)(y.userDataPath,yt.STATE_FILE)),d,m)}async init(){return this.fileStorage.init()}getItem(y,d){return this.fileStorage.getItem(y,d)}setItem(y,d){this.fileStorage.setItem(y,d)}setItems(y){this.fileStorage.setItems(y)}removeItem(y){this.fileStorage.removeItem(y)}close(){return this.fileStorage.close()}};P.STATE_FILE="storage.json",P=he([ie(0,n.IEnvironmentMainService),ie(1,w.ILogService),ie(2,f.IFileService)],P),e.StateMainService=P}),define(Z[76],x([0,1,9,23,4,16,24,22,6,21,50,42]),function(K,e,v,L,M,D,I,n,f,w,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function E(d,m,b){return`${b.updateUrl}/api/update/${d}/${m}/${b.commit}`}e.createUpdateURL=E;let y=class{constructor(m,b,S,c,h,o){this.lifecycleMainService=m,this.configurationService=b,this.environmentMainService=S,this.requestService=c,this.logService=h,this.productService=o,this._state=P.State.Uninitialized,this._onStateChange=new M.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const m=this.getUpdateMode(),b=this.getProductQuality(m);if(!b){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(b),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(P.State.Idle(this.getUpdateType())),m==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}m==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,S=>this.logService.error(S))}getUpdateMode(){return(0,D.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(m){return m==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(m=60*60*1e3){return(0,v.timeout)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(m){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},L.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};y=he([ie(0,n.ILifecycleMainService),ie(1,D.IConfigurationService),ie(2,I.IEnvironmentMainService),ie(3,i.IRequestService),ie(4,f.ILogService),ie(5,w.IProductService)],y),e.AbstractUpdateService=y}),define(Z[227],x([0,1,14,47,4,2,16,24,22,6,21,50,29,42,76]),function(K,e,v,L,M,D,I,n,f,w,i,P,E,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let m=class extends d.AbstractUpdateService{constructor(S,c,h,o,u,t,l){super(S,c,o,u,t,l);this.telemetryService=h,this.disposables=new D.DisposableStore}get onRawError(){return M.Event.fromNodeEventEmitter(v.autoUpdater,"error",(S,c)=>c)}get onRawUpdateNotAvailable(){return M.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return M.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(S,c,h)=>({url:c,version:h,productVersion:h}))}get onRawUpdateDownloaded(){return M.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(S,c,h,o)=>({releaseNotes:c,version:h,productVersion:h,date:o}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(S){this.logService.error("UpdateService error:",S);const h=(this.state.type==="checking for updates"?this.state.explicit:!0)?S:void 0;this.setState(y.State.Idle(1,h))}buildUpdateFeedUrl(S){let c;this.productService.darwinUniversalAssetId?c=this.productService.darwinUniversalAssetId:c=process.arch==="x64"?"darwin":"darwin-arm64";const h=(0,d.createUpdateURL)(c,S,this.productService);try{v.autoUpdater.setFeedURL({url:h})}catch(o){this.logService.error("Failed to set update feed URL",o);return}return h}doCheckForUpdates(S){this.setState(y.State.CheckingForUpdates(S)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(S){this.state.type==="checking for updates"&&this.setState(y.State.Downloading(S))}onUpdateDownloaded(S){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:S.version}),this.setState(y.State.Ready(S)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(y.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};he([L.memoize],m.prototype,"onRawError",null),he([L.memoize],m.prototype,"onRawUpdateNotAvailable",null),he([L.memoize],m.prototype,"onRawUpdateAvailable",null),he([L.memoize],m.prototype,"onRawUpdateDownloaded",null),m=he([ie(0,f.ILifecycleMainService),ie(1,I.IConfigurationService),ie(2,E.ITelemetryService),ie(3,n.IEnvironmentMainService),ie(4,P.IRequestService),ie(5,w.ILogService),ie(6,i.IProductService)],m),e.DarwinUpdateService=m}),define(Z[228],x([0,1,41,32,9,4,7,24,22,6,29,42]),function(K,e,v,L,M,D,I,n,f,w,i,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let E=class{constructor(m,b,S){if(this.lifecycleMainService=m,this.logService=S,this._state=P.State.Uninitialized,this._onStateChange=new D.Emitter,this.onStateChange=this._onStateChange.event,b.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(P.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,c=>this.logService.error(c))}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}scheduleCheckForUpdates(m=60*60*1e3){return(0,M.timeout)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(m){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};E=he([ie(0,f.ILifecycleMainService),ie(1,n.IEnvironmentMainService),ie(2,w.ILogService)],E);let y=class extends E{constructor(m,b,S,c,h,o){super(S,c,h);this.snap=m,this.snapRevision=b,this.telemetryService=o;const u=(0,L.watch)(I.dirname(this.snap)),t=D.Event.fromNodeEventEmitter(u,"change",(a,g)=>g),l=D.Event.filter(t,a=>a==="current"),r=D.Event.debounce(l,(a,g)=>g,2e3)(()=>this.checkForUpdates(!1));S.onWillShutdown(()=>{r.dispose(),u.close()})}doCheckForUpdates(){this.setState(P.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(m=>{m?this.setState(P.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(P.State.Idle(2)))},m=>{this.logService.error(m),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(P.State.Idle(2,m.message||m))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,v.spawn)("sleep 3 && "+I.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const m=await new Promise((S,c)=>(0,L.realpath)(`${I.dirname(this.snap)}/current`,(h,o)=>h?c(h):S(o))),b=I.basename(m);return this.snapRevision!==b}isLatestVersion(){return this.isUpdateAvailable().then(void 0,m=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};y=he([ie(2,f.ILifecycleMainService),ie(3,n.IEnvironmentMainService),ie(4,w.ILogService),ie(5,i.ITelemetryService)],y),e.SnapUpdateService=y}),define(Z[46],x([0,1,14,32,4,40,34,2,10,7,3,15,13,19,154,51,52,24,5,6,21,100,27,101]),function(K,e,v,L,M,D,I,n,f,w,i,P,E,y,d,m,b,S,c,h,o,u,t,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,c.createDecorator)("workspacesManagementMainService");let s=class extends n.Disposable{constructor(a,g,p,k,R){super();this.environmentMainService=a,this.logService=g,this.backupMainService=p,this.dialogMainService=k,this.productService=R,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new M.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new M.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(a){return this.doResolveLocalWorkspace(a,g=>(0,L.readFileSync)(g,"utf8"))}resolveLocalWorkspace(a){return this.doResolveLocalWorkspace(a,g=>y.Promises.readFile(g,"utf8"))}doResolveLocalWorkspace(a,g){if(!!this.isWorkspacePath(a)&&a.scheme===f.Schemas.file)try{const p=g(a.fsPath);return p instanceof Promise?p.then(k=>this.doResolveWorkspace(a,k),k=>{}):this.doResolveWorkspace(a,p)}catch{return}}isWorkspacePath(a){return(0,t.isUntitledWorkspace)(a,this.environmentMainService)||(0,t.hasWorkspaceFileExtension)(a)}doResolveWorkspace(a,g){try{const p=this.doParseStoredWorkspace(a,g),k=(0,l.getWorkspaceIdentifier)(a);return{id:k.id,configPath:k.configPath,folders:(0,t.toWorkspaceFolders)(p.folders,k.configPath,P.extUriBiasedIgnorePathCase),remoteAuthority:p.remoteAuthority,transient:p.transient}}catch(p){this.logService.warn(p.toString())}}doParseStoredWorkspace(a,g){const p=(0,D.parse)(g);if(p&&Array.isArray(p.folders))p.folders=p.folders.filter(k=>(0,t.isStoredWorkspaceFolder)(k));else throw new Error(`${a.toString(!0)} looks like an invalid workspace file.`);return p}async createUntitledWorkspace(a,g){const{workspace:p,storedWorkspace:k}=this.newUntitledWorkspace(a,g),R=p.configPath.fsPath;return await y.Promises.mkdir((0,w.dirname)(R),{recursive:!0}),await y.Promises.writeFile(R,JSON.stringify(k,null,"	")),p}createUntitledWorkspaceSync(a,g){const{workspace:p,storedWorkspace:k}=this.newUntitledWorkspace(a,g),R=p.configPath.fsPath;return(0,L.mkdirSync)((0,w.dirname)(R),{recursive:!0}),(0,y.writeFileSync)(R,JSON.stringify(k,null,"	")),p}newUntitledWorkspace(a=[],g){const p=(Date.now()+Math.round(Math.random()*1e3)).toString(),k=(0,P.joinPath)(this.untitledWorkspacesHome,p),R=(0,P.joinPath)(k,t.UNTITLED_WORKSPACE_NAME),T=[];for(const O of a)T.push((0,t.getStoredWorkspaceFolder)(O.uri,!0,O.name,k,!i.isWindows,P.extUriBiasedIgnorePathCase));return{workspace:(0,l.getWorkspaceIdentifier)(R),storedWorkspace:{folders:T,remoteAuthority:g}}}async getWorkspaceIdentifier(a){return(0,l.getWorkspaceIdentifier)(a)}isUntitledWorkspace(a){return(0,t.isUntitledWorkspace)(a.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(a){!this.isUntitledWorkspace(a)||(this.doDeleteUntitledWorkspaceSync(a),this._onDidDeleteUntitledWorkspace.fire(a))}async deleteUntitledWorkspace(a){this.deleteUntitledWorkspaceSync(a)}doDeleteUntitledWorkspaceSync(a){const g=(0,P.originalFSPath)(a.configPath);try{(0,y.rimrafSync)((0,w.dirname)(g));const p=(0,w.join)(this.environmentMainService.workspaceStorageHome.fsPath,a.id);(0,L.existsSync)(p)&&(0,y.writeFileSync)((0,w.join)(p,"obsolete"),"")}catch(p){this.logService.warn(`Unable to delete untitled workspace ${g} (${p}).`)}}getUntitledWorkspacesSync(){const a=[];try{const g=(0,y.readdirSync)(this.untitledWorkspacesHome.fsPath).map(p=>(0,P.joinPath)(this.untitledWorkspacesHome,p,t.UNTITLED_WORKSPACE_NAME));for(const p of g){const k=(0,l.getWorkspaceIdentifier)(p),R=this.resolveLocalWorkspaceSync(p);R?a.push({workspace:k,remoteAuthority:R.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(k)}}catch(g){g.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${g}).`)}return a}async enterWorkspace(a,g,p){if(!a||!a.win||!a.isReady||!await this.isValidTargetWorkspacePath(a,g,p))return;const R=this.doEnterWorkspace(a,(0,l.getWorkspaceIdentifier)(p));if(!!R)return this._onDidEnterWorkspace.fire({window:a,workspace:R.workspace}),R}async isValidTargetWorkspacePath(a,g,p){if(!p)return!0;if((0,t.isWorkspaceIdentifier)(a.openedWorkspace)&&P.extUriBiasedIgnorePathCase.isEqual(a.openedWorkspace.configPath,p))return!1;if((0,u.findWindowOnWorkspaceOrFolder)(g,p)){const k={title:this.productService.nameLong,type:"info",buttons:[(0,I.mnemonicButtonLabel)((0,d.localize)(0,null))],message:(0,d.localize)(1,null,(0,P.basename)(p)),detail:(0,d.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(k,(0,E.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(a,g){if(!a.config)return;a.focus();let p;return a.config.extensionDevelopmentPath||(p=this.backupMainService.registerWorkspaceBackupSync({workspace:g,remoteAuthority:a.remoteAuthority},a.config.backupPath)),(0,t.isWorkspaceIdentifier)(a.openedWorkspace)&&this.isUntitledWorkspace(a.openedWorkspace)&&this.deleteUntitledWorkspaceSync(a.openedWorkspace),a.config.workspace=g,a.config.backupPath=p,{workspace:g,backupPath:p}}};s=he([ie(0,S.IEnvironmentMainService),ie(1,h.ILogService),ie(2,m.IBackupMainService),ie(3,b.IDialogMainService),ie(4,o.IProductService)],s),e.WorkspacesManagementMainService=s}),define(Z[102],x([0,1,14,30,23,3,13,8,19,16,54,5,6,98,36,27,46]),function(K,e,v,L,M,D,I,n,f,w,i,P,E,y,d,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,P.createDecorator)(e.ID);let S=class{constructor(h,o,u,t,l){this.logService=h,this.windowsMainService=o,this.urlService=u,this.workspacesManagementMainService=t,this.configurationService=l}async start(h,o){this.logService.trace("Received data from other instance: ",h,o),D.isMacintosh&&v.app.focus({steal:!0});const u=this.parseOpenUrl(h);if(u.length){let t=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(t=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),t.then(()=>{for(const{uri:l,url:s}of u)this.urlService.open(l,{originalUrl:s})})}else return this.startOpenWindow(h,o)}parseOpenUrl(h){return h["open-url"]&&h._urls&&h._urls.length>0?(0,L.coalesce)(h._urls.map(o=>{try{return{uri:n.URI.parse(o),url:o}}catch(u){return null}})):[]}async startOpenWindow(h,o){const u=(0,i.isLaunchedFromCli)(o)?0:4;let t=[];const l=h.wait&&h.waitMarkerFilePath?n.URI.file(h.waitMarkerFilePath):void 0,s=h.remote||void 0,r={context:u,cli:h,userEnv:o,waitMarkerFileURI:l,remoteAuthority:s};if(h.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(h.extensionDevelopmentPath,r);else if(!h._.length&&!h["folder-uri"]&&!h["file-uri"]){let a=!1;if(h["new-window"]||h["unity-launch"])a=!0;else if(h["reuse-window"])a=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":a=!0;break;case"off":a=!1;break;default:a=!D.isMacintosh}if(a)t=this.windowsMainService.open({...r,forceNewWindow:!0,forceEmpty:!0});else{const g=this.windowsMainService.getLastActiveWindow();g?(this.windowsMainService.openExistingWindow(g,r),t=[g]):t=this.windowsMainService.open({...r,forceEmpty:!0})}}else t=this.windowsMainService.open({...r,forceNewWindow:h["new-window"],preferNewWindow:!h["reuse-window"]&&!h.wait,forceReuseWindow:h["reuse-window"],diffMode:h.diff,addMode:h.add,noRecentEntry:!!h["skip-add-to-recently-opened"],gotoLineMode:h.goto});if(l&&t.length===1&&t[0])return Promise.race([t[0].whenClosedOrLoaded,(0,f.whenDeleted)(l.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const h=[];return v.BrowserWindow.getAllWindows().forEach(o=>{const u=this.windowsMainService.getWindowById(o.id);u?h.push(this.codeWindowToInfo(u)):h.push(this.browserWindowToInfo(o))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:h,screenReader:!!v.app.accessibilitySupportEnabled,gpuFeatureStatus:v.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(h){const o=this.windowsMainService.getWindows();return(await Promise.all(o.map(t=>new Promise(l=>{const s=t.remoteAuthority;if(s){const r=`vscode:getDiagnosticInfoResponse${t.id}`,a={includeProcesses:h.includeProcesses,folders:h.includeWorkspaceMetadata?this.getFolderURIs(t):void 0};t.sendWhenReady("vscode:getDiagnosticInfo",M.CancellationToken.None,{replyChannel:r,args:a}),v.ipcMain.once(r,(g,p)=>{p||l({hostName:s,errorMessage:`Unable to resolve connection to '${s}'.`}),l(p)}),setTimeout(()=>{l({hostName:s,errorMessage:`Fetching remote diagnostics for '${s}' timed out.`})},5e3)}else l(void 0)})))).filter(t=>!!t)}getFolderURIs(h){const o=[],u=h.openedWorkspace;if((0,m.isSingleFolderWorkspaceIdentifier)(u))o.push(u.uri);else if((0,m.isWorkspaceIdentifier)(u)){const t=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.configPath);t&&t.folders.forEach(s=>{o.push(s.uri)})}return o}codeWindowToInfo(h){const o=this.getFolderURIs(h),u=(0,I.assertIsDefined)(h.win);return this.browserWindowToInfo(u,o,h.remoteAuthority)}browserWindowToInfo(h,o=[],u){return{pid:h.webContents.getOSProcessId(),title:h.getTitle(),folderURIs:o,remoteAuthority:u}}};S=he([ie(0,E.ILogService),ie(1,d.IWindowsMainService),ie(2,y.IURLService),ie(3,b.IWorkspacesManagementMainService),ie(4,w.IConfigurationService)],S),e.LaunchMainService=S}),define(Z[53],x([0,1,41,14,26,114,47,4,34,2,10,7,3,8,82,69,19,146,52,24,5,22,6,21,29,63,36,27,46]),function(K,e,v,L,M,D,I,n,f,w,i,P,E,y,d,m,b,S,c,h,o,u,t,l,s,r,a,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,o.createDecorator)("nativeHostMainService");let k=class ct extends w.Disposable{constructor(T,O,V,ne,se,G,te,F,j,q){super();this.sharedProcess=T,this.windowsMainService=O,this.dialogMainService=V,this.lifecycleMainService=ne,this.environmentMainService=se,this.telemetryService=G,this.logService=te,this.productService=F,this.themeMainService=j,this.workspacesManagementMainService=q,this.onDidOpenWindow=n.Event.map(this.windowsMainService.onDidOpenWindow,$=>$.id),this.onDidMaximizeWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",($,H)=>H.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidUnmaximizeWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",($,H)=>H.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidBlurWindow=n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-blur",($,H)=>H.id),$=>!!this.windowsMainService.getWindowById($)),this.onDidFocusWindow=n.Event.any(n.Event.map(n.Event.filter(n.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),$=>!!$),$=>$.id),n.Event.filter(n.Event.fromNodeEventEmitter(L.app,"browser-window-focus",($,H)=>H.id),$=>!!this.windowsMainService.getWindowById($))),this.onDidResumeOS=n.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new n.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new n.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=n.Event.debounce(n.Event.any(n.Event.filter(n.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",($,H,_)=>_),$=>!(Array.isArray($)&&$.length===1&&$[0]==="workArea")),n.Event.fromNodeEventEmitter(L.screen,"display-added"),n.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){L.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:L.nativeTheme.shouldUseInvertedColorScheme||L.nativeTheme.shouldUseHighContrastColors,dark:L.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(O=>({id:O.id,workspace:O.openedWorkspace,title:O.win?.getTitle()??"",filename:O.getRepresentedFilename(),dirty:O.isDocumentEdited()}))}async getWindowCount(T){return this.windowsMainService.getWindowCount()}async getActiveWindowId(T){const O=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(O)return O.id}openWindow(T,O,V){return Array.isArray(O)?this.doOpenWindow(T,O,V):this.doOpenEmptyWindow(T,O)}async doOpenWindow(T,O,V=Object.create(null)){O.length>0&&this.windowsMainService.open({context:5,contextWindowId:T,urisToOpen:O,cli:this.environmentMainService.args,forceNewWindow:V.forceNewWindow,forceReuseWindow:V.forceReuseWindow,preferNewWindow:V.preferNewWindow,diffMode:V.diffMode,addMode:V.addMode,gotoLineMode:V.gotoLineMode,noRecentEntry:V.noRecentEntry,waitMarkerFileURI:V.waitMarkerFileURI,remoteAuthority:V.remoteAuthority||void 0})}async doOpenEmptyWindow(T,O){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:T},O)}async toggleFullScreen(T){const O=this.windowById(T);O&&O.toggleFullScreen()}async handleTitleDoubleClick(T){const O=this.windowById(T);O&&O.handleTitleDoubleClick()}async isMaximized(T){const O=this.windowById(T);return O?.win?O.win.isMaximized():!1}async maximizeWindow(T){const O=this.windowById(T);O?.win&&O.win.maximize()}async unmaximizeWindow(T){const O=this.windowById(T);O?.win&&O.win.unmaximize()}async minimizeWindow(T){const O=this.windowById(T);O?.win&&O.win.minimize()}async focusWindow(T,O){O&&typeof O.windowId=="number"&&(T=O.windowId);const V=this.windowById(T);V&&V.focus({force:O?.force??!1})}async setMinimumSize(T,O,V){const ne=this.windowById(T);if(ne?.win){const[se,G]=ne.win.getSize(),[te,F]=ne.win.getMinimumSize(),[j,q]=[O??te,V??F],[$,H]=[Math.max(se,j),Math.max(G,q)];(te!==j||F!==q)&&ne.win.setMinimumSize(j,q),(se!==$||G!==H)&&ne.win.setSize($,H)}}async saveWindowSplash(T,O){this.themeMainService.saveWindowSplash(T,O)}async installShellCommand(T){const{source:O,target:V}=await this.getShellCommandLink();try{const{symbolicLink:ne}=await b.SymlinkSupport.stat(O);if(ne&&!ne.dangling){const se=await(0,d.realpath)(O);if(V===se)return}await b.Promises.unlink(O)}catch(ne){if(ne.code!=="ENOENT")throw ne}try{await b.Promises.symlink(V,O)}catch(ne){if(ne.code!=="EACCES"&&ne.code!=="ENOENT")throw ne;const{response:se}=await this.showMessageBox(T,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(0,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,S.localize)(1,null)),(0,f.mnemonicButtonLabel)((0,S.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(se===0)try{const G=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${V}' '${O}'\\" with administrator privileges"`;await(0,D.promisify)(v.exec)(G)}catch(G){throw new Error((0,S.localize)(3,null,O))}}}async uninstallShellCommand(T){const{source:O}=await this.getShellCommandLink();try{await b.Promises.unlink(O)}catch(V){switch(V.code){case"EACCES":const{response:ne}=await this.showMessageBox(T,{title:this.productService.nameLong,type:"info",message:(0,S.localize)(4,null,this.productService.nameShort),buttons:[(0,f.mnemonicButtonLabel)((0,S.localize)(5,null)),(0,f.mnemonicButtonLabel)((0,S.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(ne===0)try{const se=`osascript -e "do shell script \\"rm '${O}'\\" with administrator privileges"`;await(0,D.promisify)(v.exec)(se)}catch(se){throw new Error((0,S.localize)(7,null,O))}break;case"ENOENT":break;default:throw V}}}async getShellCommandLink(){const T=(0,P.resolve)(this.environmentMainService.appRoot,"bin","code"),O=`/usr/local/bin/${this.productService.applicationName}`;if(!await b.Promises.exists(T))throw new Error((0,S.localize)(8,null,T));return{source:O,target:T}}async showMessageBox(T,O){return this.dialogMainService.showMessageBox(O,this.toBrowserWindow(T))}async showSaveDialog(T,O){return this.dialogMainService.showSaveDialog(O,this.toBrowserWindow(T))}async showOpenDialog(T,O){return this.dialogMainService.showOpenDialog(O,this.toBrowserWindow(T))}toBrowserWindow(T){const O=this.windowById(T);if(O?.win)return O.win}async pickFileFolderAndOpen(T,O){const V=await this.dialogMainService.pickFileFolder(O);V&&(this.sendPickerTelemetry(V,O.telemetryEventName||"openFileFolder",O.telemetryExtraData),this.doOpenPicked(await Promise.all(V.map(async ne=>await b.SymlinkSupport.existsDirectory(ne)?{folderUri:y.URI.file(ne)}:{fileUri:y.URI.file(ne)})),O,T))}async pickFolderAndOpen(T,O){const V=await this.dialogMainService.pickFolder(O);V&&(this.sendPickerTelemetry(V,O.telemetryEventName||"openFolder",O.telemetryExtraData),this.doOpenPicked(V.map(ne=>({folderUri:y.URI.file(ne)})),O,T))}async pickFileAndOpen(T,O){const V=await this.dialogMainService.pickFile(O);V&&(this.sendPickerTelemetry(V,O.telemetryEventName||"openFile",O.telemetryExtraData),this.doOpenPicked(V.map(ne=>({fileUri:y.URI.file(ne)})),O,T))}async pickWorkspaceAndOpen(T,O){const V=await this.dialogMainService.pickWorkspace(O);V&&(this.sendPickerTelemetry(V,O.telemetryEventName||"openWorkspace",O.telemetryExtraData),this.doOpenPicked(V.map(ne=>({workspaceUri:y.URI.file(ne)})),O,T))}doOpenPicked(T,O,V){this.windowsMainService.open({context:3,contextWindowId:V,cli:this.environmentMainService.args,urisToOpen:T,forceNewWindow:O.forceNewWindow})}sendPickerTelemetry(T,O,V){const ne=T?T.length:0;this.telemetryService.publicLog(O,{...V,outcome:ne?"success":"canceled",numberOfPaths:ne})}async showItemInFolder(T,O){L.shell.showItemInFolder(O)}async setRepresentedFilename(T,O){const V=this.windowById(T);V&&V.setRepresentedFilename(O)}async setDocumentEdited(T,O){const V=this.windowById(T);V&&V.setDocumentEdited(O)}async openExternal(T,O){return E.isLinuxSnap?this.safeSnapOpenExternal(O):L.shell.openExternal(O),!0}safeSnapOpenExternal(T){const O=process.env.GDK_PIXBUF_MODULE_FILE,V=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,L.shell.openExternal(T),process.env.GDK_PIXBUF_MODULE_FILE=O,process.env.GDK_PIXBUF_MODULEDIR=V}moveItemToTrash(T,O){return L.shell.trashItem(O)}async isAdmin(){let T;return E.isWindows?T=(await new Promise((O,V)=>{K(["native-is-elevated"],O,V)}))():T=process.getuid()===0,T}async writeElevated(T,O,V,ne){const se=await new Promise((G,te)=>{K(["sudo-prompt"],G,te)});return new Promise((G,te)=>{const F=[`"${this.cliPath}"`];ne?.unlock&&F.push("--file-chmod"),F.push("--file-write",`"${O.fsPath}"`,`"${V.fsPath}"`);const j={name:this.productService.nameLong.replace("-",""),icns:E.isMacintosh&&this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};se.exec(F.join(" "),j,(q,$,H)=>{$&&this.logService.trace(`[sudo-prompt] received stdout: ${$}`),H&&this.logService.trace(`[sudo-prompt] received stderr: ${H}`),q?te(q):G(void 0)})})}get cliPath(){return E.isWindows?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):E.isLinux?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,P.join)(this.environmentMainService.appRoot,"bin","code"):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,M.totalmem)(),freemem:(0,M.freemem)(),loadavg:(0,M.loadavg)()}}async getOSProperties(){return{arch:(0,M.arch)(),platform:(0,M.platform)(),release:(0,M.release)(),type:(0,M.type)(),cpus:(0,M.cpus)()}}async getOSVirtualMachineHint(){return m.virtualMachineHint.value()}async killProcess(T,O,V){process.kill(O,V)}async readClipboardText(T,O){return L.clipboard.readText(O)}async writeClipboardText(T,O,V){return L.clipboard.writeText(O,V)}async readClipboardFindText(T){return L.clipboard.readFindText()}async writeClipboardFindText(T,O){return L.clipboard.writeFindText(O)}async writeClipboardBuffer(T,O,V,ne){return L.clipboard.writeBuffer(O,Buffer.from(V),ne)}async readClipboardBuffer(T,O){return L.clipboard.readBuffer(O)}async hasClipboard(T,O,V){return L.clipboard.has(O,V)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(T,O){const V=this.windowById(T);V&&V.updateTouchBar(O)}async notifyReady(T){const O=this.windowById(T);O&&O.setReady()}async relaunch(T,O){return this.lifecycleMainService.relaunch(O)}async reload(T,O){const V=this.windowById(T);if(V){if((0,g.isWorkspaceIdentifier)(V.openedWorkspace)){const ne=V.openedWorkspace.configPath;if(ne.scheme===i.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(ne))?.transient)return this.openWindow(V.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(V,O?.disableExtensions!==void 0?{_:[],"disable-extensions":O.disableExtensions}:void 0)}}async closeWindow(T){this.closeWindowById(T,T)}async closeWindowById(T,O){const V=this.windowById(O);if(V?.win)return V.win.close()}async quit(T){const O=this.windowsMainService.getLastActiveWindow();O?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&O.win?O.win.close():this.lifecycleMainService.quit()}async exit(T,O){await this.lifecycleMainService.kill(O)}async resolveProxy(T,O){const ne=this.windowById(T)?.win?.webContents?.session;if(ne)return ne.resolveProxy(O)}async openDevTools(T,O){const V=this.windowById(T);V?.win&&V.win.webContents.openDevTools(O)}async toggleDevTools(T){const O=this.windowById(T);O?.win&&O.win.webContents.toggleDevTools()}async sendInputEvent(T,O){const V=this.windowById(T);V?.win&&(O.type==="mouseDown"||O.type==="mouseUp")&&V.win.webContents.sendInputEvent(O)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(T,O,V,ne){if(!E.isWindows)return;const se=await new Promise((G,te)=>{K(["vscode-windows-registry"],G,te)});try{return se.GetStringRegKey(O,V,ne)}catch{return}}async getPassword(T,O,V){const ne=await this.withKeytar(),se=await ne.getPassword(O,V);if(se)try{let{content:G,hasNextChunk:te}=JSON.parse(se);if(!G||!te)return se;let F=1;for(;te;){const j=await ne.getPassword(O,`${V}-${F}`),q=JSON.parse(j);G+=q.content,te=q.hasNextChunk,F++}return G}catch{return se}return se}async setPassword(T,O,V,ne){const se=await this.withKeytar(),G=3,te=async(F,j,q)=>{let $=0,H;for(;$<G;)try{await se.setPassword(F,j,q);return}catch(_){H=_,this.logService.warn("Error attempting to set a password: ",_),$++,await new Promise(z=>setTimeout(z,200))}throw H};if(E.isWindows&&ne.length>ct.MAX_PASSWORD_LENGTH){let F=0,j=0,q=!0;for(;q;){const $=ne.substring(F,F+ct.PASSWORD_CHUNK_SIZE);F+=ct.PASSWORD_CHUNK_SIZE,q=ne.length-F>0;const H={content:$,hasNextChunk:q};await te(O,j?`${V}-${j}`:V,JSON.stringify(H)),j++}}else await te(O,V,ne);this._onDidChangePassword.fire({service:O,account:V})}async deletePassword(T,O,V){const se=await(await this.withKeytar()).deletePassword(O,V);return se&&this._onDidChangePassword.fire({service:O,account:V}),se}async findPassword(T,O){return(await this.withKeytar()).findPassword(O)}async findCredentials(T,O){return(await this.withKeytar()).findCredentials(O)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((T,O)=>{K(["keytar"],T,O)})}windowById(T){if(typeof T=="number")return this.windowsMainService.getWindowById(T)}};k.MAX_PASSWORD_LENGTH=2500,k.PASSWORD_CHUNK_SIZE=k.MAX_PASSWORD_LENGTH-100,he([I.memoize],k.prototype,"cliPath",null),k=he([ie(1,a.IWindowsMainService),ie(2,c.IDialogMainService),ie(3,u.ILifecycleMainService),ie(4,h.IEnvironmentMainService),ie(5,s.ITelemetryService),ie(6,t.ILogService),ie(7,l.IProductService),ie(8,r.IThemeMainService),ie(9,p.IWorkspacesManagementMainService)],k),e.NativeHostMainService=k}),define(Z[229],x([0,1,14,23,4,80,2,28,89,6,53,21,36]),function(K,e,v,L,M,D,I,n,f,w,i,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var y;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let d=class extends I.Disposable{constructor(b,S,c,h,o){super();this.logService=b,this.windowsMainService=S,this.nativeHostMainService=c,this.encryptionMainService=h,this.productService=o,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=y.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const b=M.Event.fromNodeEventEmitter(v.app,"login",(S,c,h,o,u)=>({event:S,webContents:c,req:h,authInfo:o,callback:u}));this._register(b(this.onLogin,this))}async onLogin({event:b,authInfo:S,req:c,callback:h}){if(!S.isProxy)return;if(!this.pendingProxyResolve&&this.state===y.LoginDialogShown&&c.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let o;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),o=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(S);try{o=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}h(o?.username,o?.password)}async resolveProxyCredentials(b){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const S=await this.doResolveProxyCredentials(b);if(S)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),S;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(b){this.logService.trace("auth#doResolveProxyCredentials - enter",b);const S=String((0,D.hash)({scheme:b.scheme,host:b.host,port:b.port}));let c,h;try{const l=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,S);if(l){const s=JSON.parse(await this.encryptionMainService.decrypt(l));c=s.username,h=s.password}}catch(l){this.logService.error(l)}if(this.state!==y.StoredCredentialsUsed&&typeof c=="string"&&typeof h=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=y.StoredCredentialsUsed,{username:c,password:h};const o=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!o){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${o.id} to handle proxy login`);const u={authInfo:b,username:this.sessionCredentials?.username??c,password:this.sessionCredentials?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,n.generateUuid)()}`};o.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,u),this.state=y.LoginDialogShown;const t=await new Promise(l=>{const s=async(r,a,g)=>{if(a===u.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${o.id}`),o.win?.webContents.off("ipc-message",s),g){const p={username:g.username,password:g.password};try{if(g.remember){const k=await this.encryptionMainService.encrypt(JSON.stringify(p));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,S,k)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,S)}catch(k){this.logService.error(k)}l({username:p.username,password:p.password})}else l(void 0)};o.win?.webContents.on("ipc-message",s)});return this.sessionCredentials=t,t}};d=he([ie(0,w.ILogService),ie(1,E.IWindowsMainService),ie(2,i.INativeHostMainService),ie(3,f.IEncryptionMainService),ie(4,P.IProductService)],d),e.ProxyAuthHandler=d}),define(Z[230],x([0,1,14,26,34,2,10,3,83,144,72,52,24,5,102,6,53,45,21,55,64]),function(K,e,v,L,M,D,I,n,f,w,i,P,E,y,d,m,b,S,c,h,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,y.createDecorator)("issueMainService");let u=class St{constructor(l,s,r,a,g,p,k,R,T){this.userEnv=l,this.environmentMainService=s,this.launchMainService=r,this.logService=a,this.diagnosticsService=g,this.dialogMainService=p,this.nativeHostMainService=k,this.protocolMainService=R,this.productService=T,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){v.ipcMain.on("vscode:issueSystemInfoRequest",async l=>{const[s,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),a=await this.diagnosticsService.getSystemInfo(s,r);this.safeSend(l,"vscode:issueSystemInfoResponse",a)}),v.ipcMain.on("vscode:listProcesses",async l=>{const s=[];try{const r=await this.launchMainService.getMainProcessId();s.push({name:(0,w.localize)(0,null),rootProcess:await(0,f.listProcesses)(r)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(g=>{(0,i.isRemoteDiagnosticError)(g)?s.push({name:g.hostName,rootProcess:g}):g.processes&&s.push({name:g.hostName,rootProcess:g.processes})})}catch(r){this.logService.error(`Listing processes failed: ${r}`)}this.safeSend(l,"vscode:listProcessesResponse",s)}),v.ipcMain.on("vscode:issueReporterClipboard",async l=>{const s={title:this.productService.nameLong,message:(0,w.localize)(1,null),type:"warning",buttons:[(0,M.mnemonicButtonLabel)((0,w.localize)(2,null)),(0,M.mnemonicButtonLabel)((0,w.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const r=await this.dialogMainService.showMessageBox(s,this.issueReporterWindow);this.safeSend(l,"vscode:issueReporterClipboardResponse",r.response===0)}}),v.ipcMain.on("vscode:issuePerformanceInfoRequest",async l=>{const s=await this.getPerformanceInfo();this.safeSend(l,"vscode:issuePerformanceInfoResponse",s)}),v.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const l={title:this.productService.nameLong,message:(0,w.localize)(4,null),type:"warning",buttons:[(0,M.mnemonicButtonLabel)((0,w.localize)(5,null)),(0,M.mnemonicButtonLabel)((0,w.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(l,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),v.ipcMain.on("vscode:workbenchCommand",(l,s)=>{const{id:r,from:a,args:g}=s;let p;switch(a){case"issueReporter":p=this.issueReporterParentWindow;break;case"processExplorer":p=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${a}`)}p&&p.webContents.send("vscode:runAction",{id:r,from:a,args:g})}),v.ipcMain.on("vscode:openExternal",(l,s)=>{this.nativeHostMainService.openExternal(void 0,s)}),v.ipcMain.on("vscode:closeIssueReporter",l=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),v.ipcMain.on("vscode:closeProcessExplorer",l=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),v.ipcMain.on("vscode:windowsInfoRequest",async l=>{const s=await this.launchMainService.getMainProcessInfo();this.safeSend(l,"vscode:windowsInfoResponse",s.windows)})}safeSend(l,s,...r){l.sender.isDestroyed()||l.sender.send(s,...r)}async openReporter(l){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=v.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const s=new D.DisposableStore,r=s.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(a,r,{backgroundColor:l.styles.backgroundColor,title:(0,w.localize)(7,null),zoomLevel:l.zoomLevel,alwaysOnTop:!1}),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:l,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,L.type)(),arch:(0,L.arch)(),release:(0,L.release)()},product:S.default}),this.issueReporterWindow.loadURL(I.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",K).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,s.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,s.dispose())})}this.issueReporterWindow?.focus()}async openProcessExplorer(l){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=v.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const s=new D.DisposableStore,r=s.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(a,r,{backgroundColor:l.styles.backgroundColor,title:(0,w.localize)(8,null),zoomLevel:l.zoomLevel,alwaysOnTop:!0}),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:l,product:S.default}),this.processExplorerWindow.loadURL(I.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",K).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,s.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,s.dispose())})}this.processExplorerWindow?.focus()}createBrowserWindow(l,s,r){const a=new v.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:l.width,height:l.height,minWidth:300,minHeight:200,x:l.x,y:l.y,title:r.title,backgroundColor:r.backgroundColor||St.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:I.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",K).fsPath,additionalArguments:[`--vscode-window-config=${s.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,o.zoomLevelToZoomFactor)(r.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:r.alwaysOnTop});return a.setMenuBarVisibility(!1),a}async getSystemStatus(){const[l,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(l,s)}getWindowPosition(l,s,r){let a;const g=v.screen.getAllDisplays();if(g.length===1)a=g[0];else{if(n.isMacintosh){const R=v.screen.getCursorScreenPoint();a=v.screen.getDisplayNearestPoint(R)}!a&&l&&(a=v.screen.getDisplayMatching(l.getBounds())),a||(a=v.screen.getPrimaryDisplay()||g[0])}const p={width:s,height:r},k=a.bounds;return p.x=k.x+k.width/2-p.width/2,p.y=k.y+k.height/2-p.height/2,k.width>0&&k.height>0&&(p.x<k.x&&(p.x=k.x),p.y<k.y&&(p.y=k.y),p.x>k.x+k.width&&(p.x=k.x),p.y>k.y+k.height&&(p.y=k.y),p.width>k.width&&(p.width=k.width),p.height>k.height&&(p.height=k.height)),p}async getPerformanceInfo(){try{const[l,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(l,s)}catch(l){throw this.logService.warn("issueService#getPerformanceInfo ",l.message),l}}};u.DEFAULT_BACKGROUND_COLOR="#1E1E1E",u=he([ie(1,E.IEnvironmentMainService),ie(2,d.ILaunchMainService),ie(3,m.ILogService),ie(4,i.IDiagnosticsService),ie(5,P.IDialogMainService),ie(6,b.INativeHostMainService),ie(7,h.IProtocolMainService),ie(8,c.IProductService)],u),e.IssueMainService=u}),define(Z[231],x([0,1,23,16,24,22,6,53,21,50,29,42,76]),function(K,e,v,L,M,D,I,n,f,w,i,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let y=class extends E.AbstractUpdateService{constructor(m,b,S,c,h,o,u,t){super(m,b,c,h,o,t);this.telemetryService=S,this.nativeHostMainService=u}buildUpdateFeedUrl(m){return(0,E.createUpdateURL)(`linux-${process.arch}`,m,this.productService)}doCheckForUpdates(m){!this.url||(this.setState(P.State.CheckingForUpdates(m)),this.requestService.request({url:this.url},v.CancellationToken.None).then(w.asJson).then(b=>{!b||!b.url||!b.version||!b.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m}),this.setState(P.State.Idle(1))):this.setState(P.State.AvailableForDownload(b))}).then(void 0,b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m});const S=m?b.message||b:void 0;this.setState(P.State.Idle(1,S))}))}async doDownloadUpdate(m){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):m.update.url&&this.nativeHostMainService.openExternal(void 0,m.update.url),this.setState(P.State.Idle(1))}};y=he([ie(0,D.ILifecycleMainService),ie(1,L.IConfigurationService),ie(2,i.ITelemetryService),ie(3,M.IEnvironmentMainService),ie(4,w.IRequestService),ie(5,I.ILogService),ie(6,n.INativeHostMainService),ie(7,f.IProductService)],y),e.LinuxUpdateService=y}),define(Z[232],x([0,1,41,32,26,9,23,47,7,8,112,19,16,24,20,22,6,53,21,50,29,42,76]),function(K,e,v,L,M,D,I,n,f,w,i,P,E,y,d,m,b,S,c,h,o,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function l(g,p=1e3){for(;!g();)await(0,D.timeout)(p)}let s;function r(){return typeof s=="undefined"&&(s=L.existsSync(f.join(f.dirname(process.execPath),"unins000.exe"))?0:1),s}let a=class extends t.AbstractUpdateService{constructor(p,k,R,T,O,V,ne,se,G){super(p,k,T,O,V,G);this.telemetryService=R,this.fileService=ne,this.nativeHostMainService=se}get cachePath(){const p=f.join((0,M.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return P.Promises.mkdir(p,{recursive:!0}).then(()=>p)}initialize(){super.initialize(),r()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(p){let k="win32";return process.arch!=="ia32"&&(k+=`-${process.arch}`),r()===1?k+="-archive":this.productService.target==="user"&&(k+="-user"),(0,t.createUpdateURL)(k,p,this.productService)}doCheckForUpdates(p){!this.url||(this.setState(u.State.CheckingForUpdates(p)),this.requestService.request({url:this.url},I.CancellationToken.None).then(h.asJson).then(k=>{const R=r();return!k||!k.url||!k.version||!k.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!p}),this.setState(u.State.Idle(R)),Promise.resolve(null)):R===1?(this.setState(u.State.AvailableForDownload(k)),Promise.resolve(null)):(this.setState(u.State.Downloading(k)),this.cleanup(k.version).then(()=>this.getUpdatePackagePath(k.version).then(T=>P.Promises.exists(T).then(O=>{if(O)return Promise.resolve(T);const V=k.url,ne=k.hash,se=`${T}.tmp`;return this.requestService.request({url:V},I.CancellationToken.None).then(G=>this.fileService.writeFile(w.URI.file(se),G.stream)).then(ne?()=>(0,i.checksum)(se,k.hash):()=>{}).then(()=>P.Promises.rename(se,T)).then(()=>T)})).then(T=>{const O=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:T},O&&k.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(u.State.Downloaded(k)):this.setState(u.State.Ready(k))})))}).then(void 0,k=>{this.logService.error(k),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!p});const R=p?k.message||k:void 0;this.setState(u.State.Idle(r(),R))}))}async doDownloadUpdate(p){p.update.url&&this.nativeHostMainService.openExternal(void 0,p.update.url),this.setState(u.State.Idle(r()))}async getUpdatePackagePath(p){const k=await this.cachePath;return f.join(k,`CodeSetup-${this.productService.quality}-${p}.exe`)}async cleanup(p=null){const k=p?V=>!new RegExp(`${this.productService.quality}-${p}\\.exe$`).test(V):()=>!0,R=await this.cachePath,O=(await P.Promises.readdir(R)).filter(k).map(async V=>{try{await P.Promises.unlink(f.join(R,V))}catch(ne){}});await Promise.all(O)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const p=this.state.update;this.setState(u.State.Updating(p));const k=await this.cachePath;this.availableUpdate.updateFilePath=f.join(k,`CodeSetup-${this.productService.quality}-${p.version}.flag`),await P.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,v.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(u.State.Idle(r()))});const T=`${this.productService.win32MutexName}-ready`,O=await new Promise((V,ne)=>{K(["windows-mutex"],V,ne)});l(()=>O.isActive(T)).then(()=>this.setState(u.State.Ready(p)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?L.unlinkSync(this.availableUpdate.updateFilePath):(0,v.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return r()}};he([n.memoize],a.prototype,"cachePath",null),a=he([ie(0,m.ILifecycleMainService),ie(1,E.IConfigurationService),ie(2,o.ITelemetryService),ie(3,y.IEnvironmentMainService),ie(4,h.IRequestService),ie(5,b.ILogService),ie(6,d.IFileService),ie(7,S.INativeHostMainService),ie(8,c.IProductService)],a),e.Win32UpdateService=a}),define(Z[233],x([0,1,14,9,23,4,34,2,10,7,74,3,8,150,51,16,52,24,54,200,20,22,6,21,55,99,29,203,63,64,36,27,46]),function(K,e,v,L,M,D,I,n,f,w,i,P,E,y,d,m,b,S,c,h,o,u,t,l,s,r,a,g,p,k,R,T,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var V;(function(se){se[se.NONE=0]="NONE",se[se.LOADING=1]="LOADING",se[se.NAVIGATING=2]="NAVIGATING",se[se.READY=3]="READY"})(V||(V={}));let ne=class extends n.Disposable{constructor(G,te,F,j,q,$,H,_,z,C,A,W,B,Y){super();this.logService=te,this.environmentMainService=F,this.fileService=j,this.configurationService=$,this.themeMainService=H,this.workspacesManagementMainService=_,this.backupMainService=z,this.telemetryService=C,this.dialogMainService=A,this.lifecycleMainService=W,this.productService=B,this.protocolMainService=Y,this._onWillLoad=this._register(new D.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new D.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new D.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new D.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[U,N]=this.restoreWindowState(G.state);this.windowState=U,this.logService.trace("window#ctor: using window state",U);const Q=this.windowState.mode===0||this.windowState.mode===3,J=this.configurationService.getValue("window"),re={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:k.WindowMinimumSize.WIDTH,minHeight:k.WindowMinimumSize.HEIGHT,show:!Q,title:this.productService.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",K).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,k.zoomLevelToZoomFactor)(J?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};P.isLinux?re.icon=(0,w.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):P.isWindows&&!this.environmentMainService.isBuilt&&(re.icon=(0,w.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),P.isMacintosh&&!this.useNativeFullScreen()&&(re.fullscreenable=!1),P.isMacintosh&&(re.acceptFirstMouse=!0,J?.clickThroughInactive===!1&&(re.acceptFirstMouse=!1));const le=P.isMacintosh&&J?.nativeTabs===!0;le&&(re.tabbingIdentifier=this.productService.nameShort);const ee=(0,k.getTitleBarStyle)(this.configurationService)==="custom";if(ee&&(re.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,P.isMacintosh||(re.frame=!1)),(0,i.mark)("code/willCreateCodeBrowserWindow"),this._win=new v.BrowserWindow(re),(0,i.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),P.isMacintosh&&ee&&this._win.setSheetOffset(22),P.isMacintosh&&N&&(!le||v.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(ae=>typeof ae=="number")){const ae=this.windowState;this._win.setBounds({width:ae.width,height:ae.height,x:ae.x,y:ae.y})}Q&&((0,i.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,i.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,h.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,{get:U=>q.globalStorage.get(U),store:(U,N)=>q.globalStorage.set(U,N)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(G){P.isMacintosh?this._win.setRepresentedFilename(G):this.representedFilename=G}getRepresentedFilename(){return P.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(G){P.isMacintosh&&this._win.setDocumentEdited(G),this.documentEdited=G}isDocumentEdited(){return P.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(G){P.isMacintosh&&G?.force&&v.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(G=>{if(this.isReady)return G(this);this.whenReadyCallbacks.push(G)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(G=>{function te(){F.dispose(),j.dispose(),G()}const F=this.onDidClose(()=>te()),j=this.onWillLoad(()=>te())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(q,$)=>this.onWindowError(2,$)),this._win.webContents.on("did-fail-load",(q,$,H)=>this.onWindowError(3,{reason:H,exitCode:$})),this._win.webContents.on("will-prevent-unload",q=>{q.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const G=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),te=q=>{for(let $=q;$;$=$.parent)if($.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},F=q=>q.resourceType==="xhr"||te(q.frame);this._win.webContents.session.webRequest.onBeforeRequest((q,$)=>{const H=E.URI.parse(q.url);return H.path.endsWith(".svg")&&!G.has(H.scheme)?$({cancel:!F(q)}):$({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((q,$)=>{const H=q.responseHeaders,_=H["content-type"]||H["Content-Type"];if(_&&Array.isArray(_)){const z=E.URI.parse(q.url);if(z.path.endsWith(".svg")&&G.has(z.scheme))return H["Content-Type"]=["image/svg+xml"],$({cancel:!1,responseHeaders:H});if(!z.path.includes(f.Schemas.vscodeRemoteResource)&&_.some(C=>C.toLowerCase().includes("image/svg")))return $({cancel:!F(q)})}return $({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",q=>{this.currentConfig&&(this.currentConfig.maximized=!0),v.app.emit("browser-window-maximize",q,this._win)}),this._win.on("unmaximize",q=>{this.currentConfig&&(this.currentConfig.maximized=!1),v.app.emit("browser-window-unmaximize",q,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",M.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",M.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(q=>this.onDidDeleteUntitledWorkspace(q)));const j=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:j},async(q,$)=>{const H=await this.marketplaceHeadersPromise;$({cancel:!1,requestHeaders:Object.assign(q.requestHeaders,H)})})}async onWindowError(G,te){switch(G){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${te?.reason||"<unknown>"}, code: ${te?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${te?.reason||"<unknown>"}, code: ${te?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:G,reason:te?.reason,code:te?.exitCode}),G){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(G===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const F=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,y.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,y.localize)(1,null)),(0,I.mnemonicButtonLabel)((0,y.localize)(2,null))],message:(0,y.localize)(3,null),detail:(0,y.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(!this._win)return;F.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):F.response===2&&this.destroyWindow()}else if(G===2){let F;te?F=(0,y.localize)(6,null,te.reason,te.exitCode??"<unknown>"):F=(0,y.localize)(5,null);const j=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,y.localize)(7,null)),(0,I.mnemonicButtonLabel)((0,y.localize)(8,null))],message:F,detail:(0,y.localize)(9,null),noLink:!0,defaultId:0},this._win);if(!this._win)return;j.response===0?this.reload():j.response===1&&this.destroyWindow()}break}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(G){this.openedWorkspace?.id===G.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const G=this.getMenuBarVisibility();G!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=G,this.setMenuBarVisibility(G));let te=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;te?.endsWith("/")&&(te=te.substr(0,te.length-1));const F=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((te||"").indexOf("@")===-1&&(te!==this.currentHttpProxy||F!==this.currentNoProxy)){this.currentHttpProxy=te,this.currentNoProxy=F;const j=te||"",q=F?`${F},<local>`:"<local>";this.logService.trace(`Setting proxy to '${j}', bypassing '${q}'`),this._win.webContents.session.setProxy({proxyRules:j,proxyBypassRules:q,pacScript:""})}}addTabbedWindow(G){P.isMacintosh&&G.win&&this._win.addTabbedWindow(G.win)}load(G,te=Object.create(null)){this.isDocumentEdited()&&(!te.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),te.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(G,te),this.readyState===0?this.currentConfig=G:(this.pendingLoadConfig=G,this.readyState=2),this._win.loadURL(f.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",K).toString(!0));const F=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new L.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:G.workspace,reason:te.isReload?3:F?2:1})}updateConfiguration(G,te){const F=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(F){const j=(0,c.isLaunchedFromCli)(F)&&!(0,c.isLaunchedFromCli)(G.userEnv),q=this.isExtensionDevelopmentHost;(j||q)&&(G.userEnv={...F,...G.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(G.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),te.disableExtensions!==void 0&&(G["disable-extensions"]=te.disableExtensions),G.fullscreen=this.isFullScreen,G.maximized=this._win.isMaximized(),G.partsSplash=this.themeMainService.getWindowSplash(),(0,i.mark)("code/willOpenNewWindow"),G.perfMarks=(0,i.getMarks)(),this.configObjectUrl.update(G)}async reload(G){const te=Object.assign({},this.currentConfig);te.workspace=await this.validateWorkspaceBeforeReload(te),delete te.filesToOpenOrCreate,delete te.filesToDiff,delete te.filesToWait,this.isExtensionDevelopmentHost&&G&&(te.verbose=G.verbose,te.debugId=G.debugId,te.extensionEnvironment=G.extensionEnvironment,te["inspect-extensions"]=G["inspect-extensions"],te["inspect-brk-extensions"]=G["inspect-brk-extensions"],te["extensions-dir"]=G["extensions-dir"]),te.isInitialStartup=!1,this.load(te,{isReload:!0,disableExtensions:G?.["disable-extensions"]})}async validateWorkspaceBeforeReload(G){if((0,T.isWorkspaceIdentifier)(G.workspace)){const te=G.workspace.configPath;if(te.scheme===f.Schemas.file&&!await this.fileService.exists(te))return}else if((0,T.isSingleFolderWorkspaceIdentifier)(G.workspace)){const te=G.workspace.uri;if(te.scheme===f.Schemas.file&&!await this.fileService.exists(te))return}return G.workspace}serializeWindowState(){if(!this._win)return(0,R.defaultWindowState)();if(this.isFullScreen){let F;try{F=v.screen.getDisplayMatching(this.getBounds())}catch($){}const j=(0,R.defaultWindowState)();return{mode:3,display:F?F.id:void 0,width:this.windowState.width||j.width,height:this.windowState.height||j.height,x:this.windowState.x||0,y:this.windowState.y||0}}const G=Object.create(null);let te;if(!P.isMacintosh&&this._win.isMaximized()?te=0:te=1,te===0?G.mode=0:G.mode=1,te===1||te===0){let F;te===1?F=this.getBounds():F=this._win.getNormalBounds(),G.x=F.x,G.y=F.y,G.width=F.width,G.height=F.height}return G}restoreWindowState(G){(0,i.mark)("code/willRestoreCodeWindowState");let te=!1;if(G)try{const F=v.screen.getAllDisplays();te=F.length>1,G=this.validateWindowState(G,F)}catch(F){this.logService.warn(`Unexpected error validating window state: ${F}
${F.stack}`)}return(0,i.mark)("code/didRestoreCodeWindowState"),[G||(0,R.defaultWindowState)(),te]}validateWindowState(G,te){if(this.logService.trace(`window#validateWindowState: validating window state on ${te.length} display(s)`,G),typeof G.x!="number"||typeof G.y!="number"||typeof G.width!="number"||typeof G.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(G.width<=0||G.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(te.length===1){const q=this.getWorkingArea(te[0]);if(q){let $=function(){!G||typeof G.x!="number"||typeof G.y!="number"||!q||(G.x<q.x&&(G.x=q.x),G.y<q.y&&(G.y=q.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",q),$(),G.width>q.width&&(G.width=q.width),G.height>q.height&&(G.height=q.height),G.x>q.x+q.width-128&&(G.x=q.x+q.width-G.width),G.y>q.y+q.height-128&&(G.y=q.y+q.height-G.height),$()}return G}if(G.display&&G.mode===3){const q=te.find($=>$.id===G.display);if(q&&typeof q.bounds?.x=="number"&&typeof q.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const $=(0,R.defaultWindowState)(3);return $.x=q.bounds.x,$.y=q.bounds.y,$}}let F,j;try{F=v.screen.getDisplayMatching({x:G.x,y:G.y,width:G.width,height:G.height}),j=this.getWorkingArea(F)}catch(q){}if(F&&j&&G.x+G.width>j.x&&G.y+G.height>j.y&&G.x<j.x+j.width&&G.y<j.y+j.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",j),G}getWorkingArea(G){if(G.workArea.width>0&&G.workArea.height>0)return G.workArea;if(G.bounds.width>0&&G.bounds.height>0)return G.bounds}getBounds(){const[G,te]=this._win.getPosition(),[F,j]=this._win.getSize();return{x:G,y:te,width:F,height:j}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(G){this.useNativeFullScreen()?this.setNativeFullScreen(G):this.setSimpleFullScreen(G),this.sendWhenReady(G?"vscode:enterFullScreen":"vscode:leaveFullScreen",M.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(G){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(G)}setSimpleFullScreen(G){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(G),this._win.webContents.focus()}useNativeFullScreen(){const G=this.configurationService.getValue("window");return!G||typeof G.nativeFullScreen!="boolean"||G.nativeTabs?!0:G.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let G=(0,k.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(G)<0&&(G="classic"),G}setMenuBarVisibility(G,te=!0){P.isMacintosh||(G==="toggle"&&te&&this.send("vscode:showInfoMessage",(0,y.localize)(10,null)),G==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(G)}):this.doSetMenuBarVisibility(G))}doSetMenuBarVisibility(G){const te=this.isFullScreen;switch(G){case"classic":this._win.setMenuBarVisibility(!te),this._win.autoHideMenuBar=te;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(P.isMacintosh)switch(v.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(G,te,...F){this.isReady?this.send(G,...F):this.ready().then(()=>{te.isCancellationRequested||this.send(G,...F)})}send(G,...te){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${G} for window that is destroyed`);return}this._win.webContents.send(G,...te)}}updateTouchBar(G){!P.isMacintosh||this.touchBarGroups.forEach((te,F)=>{const j=G[F];te.segments=this.createTouchBarGroupSegments(j)})}createTouchBar(){if(!!P.isMacintosh){for(let G=0;G<10;G++){const te=this.createTouchBarGroup();this.touchBarGroups.push(te)}this._win.setTouchBar(new v.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(G=[]){const te=this.createTouchBarGroupSegments(G),F=new v.TouchBar.TouchBarSegmentedControl({segments:te,mode:"buttons",segmentStyle:"automatic",change:j=>{this.sendWhenReady("vscode:runAction",M.CancellationToken.None,{id:F.segments[j].id,from:"touchbar"})}});return F}createTouchBarGroupSegments(G=[]){return G.map(F=>{let j;F.icon&&!g.ThemeIcon.isThemeIcon(F.icon)&&F.icon?.dark?.scheme===f.Schemas.file&&(j=v.nativeImage.createFromPath(E.URI.revive(F.icon.dark).fsPath),j.isEmpty()&&(j=void 0));let q;return typeof F.title=="string"?q=F.title:q=F.title.value,{id:F.id,label:j?void 0:q,icon:j}})}dispose(){super.dispose(),this._win=null}};ne=he([ie(1,t.ILogService),ie(2,S.IEnvironmentMainService),ie(3,o.IFileService),ie(4,r.IStorageMainService),ie(5,m.IConfigurationService),ie(6,p.IThemeMainService),ie(7,O.IWorkspacesManagementMainService),ie(8,d.IBackupMainService),ie(9,a.ITelemetryService),ie(10,b.IDialogMainService),ie(11,u.ILifecycleMainService),ie(12,l.IProductService),ie(13,s.IProtocolMainService)],ne),e.CodeWindow=ne}),define(Z[65],x([0,1,14,30,9,4,34,2,10,3,15,8,19,153,5,22,6,39,27,46]),function(K,e,v,L,M,D,I,n,f,w,i,P,E,y,d,m,b,S,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,d.createDecorator)("workspacesHistoryMainService");let o=class He extends n.Disposable{constructor(g,p,k,R){super();this.stateMainService=g,this.logService=p,this.workspacesManagementMainService=k,this.lifecycleMainService=R,this._onDidChangeRecentlyOpened=this._register(new D.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new M.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(g=>this.addRecentlyOpened([{workspace:g.workspace}])))}handleWindowsJumpList(){!w.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(g){const p=[],k=[];for(let R of g)if((0,c.isRecentWorkspace)(R))!this.workspacesManagementMainService.isUntitledWorkspace(R.workspace)&&l(p,R.workspace)===-1&&p.push(R);else if((0,c.isRecentFolder)(R))s(p,R.folderUri)===-1&&p.push(R);else{const T=r(k,R.fileUri)>=0,O=R.fileUri.scheme===f.Schemas.file&&He.COMMON_FILES_FILTER.indexOf((0,i.basename)(R.fileUri))>=0;!T&&!O&&(k.push(R),w.isWindows&&R.fileUri.scheme===f.Schemas.file&&v.app.addRecentDocument(R.fileUri.fsPath))}this.addEntriesFromStorage(p,k),p.length>He.MAX_TOTAL_RECENT_ENTRIES&&(p.length=He.MAX_TOTAL_RECENT_ENTRIES),k.length>He.MAX_TOTAL_RECENT_ENTRIES&&(k.length=He.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:p,files:k}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(g){const p=O=>{const V=t(O);for(const ne of g)if(i.extUriBiasedIgnorePathCase.isEqual(ne,V))return!1;return!0},k=this.getRecentlyOpened(),R=k.workspaces.filter(p),T=k.files.filter(p);(R.length!==k.workspaces.length||T.length!==k.files.length)&&(this.saveRecentlyOpened({files:T,workspaces:R}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!w.isMacintosh)return;v.app.clearRecentDocuments();const g=this.getRecentlyOpened(),p=[];let k=0;for(let T=0;T<g.workspaces.length&&k<He.MAX_MACOS_DOCK_RECENT_WORKSPACES;T++){const O=t(g.workspaces[T]);if(O.scheme===f.Schemas.file){const V=(0,i.originalFSPath)(O);await E.Promises.exists(V)&&(p.push(V),k++)}}const R=[];for(let T=0;T<g.files.length&&k<He.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;T++){const O=t(g.files[T]);if(O.scheme===f.Schemas.file){const V=(0,i.originalFSPath)(O);if(He.COMMON_FILES_FILTER.includes((0,i.basename)(O))||p.includes(V))continue;await E.Promises.exists(V)&&(R.push(V),k++)}}R.reverse().forEach(T=>v.app.addRecentDocument(T)),p.reverse().forEach(T=>v.app.addRecentDocument(T))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),v.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(g){const p=[],k=[],R=g?.config?.workspace;(0,c.isWorkspaceIdentifier)(R)&&!this.workspacesManagementMainService.isUntitledWorkspace(R)?p.push({workspace:R}):(0,c.isSingleFolderWorkspaceIdentifier)(R)&&p.push({folderUri:R.uri});const T=g?.config?.filesToOpenOrCreate;if(T)for(let O of T){const V=O.fileUri;V&&r(k,V)===-1&&k.push({fileUri:V})}return this.addEntriesFromStorage(p,k),{workspaces:p,files:k}}addEntriesFromStorage(g,p){let k=this.getRecentlyOpenedFromStorage();for(let R of k.workspaces){let T=(0,c.isRecentFolder)(R)?s(g,R.folderUri):l(g,R.workspace);T>=0?g[T].label=g[T].label||R.label:g.push(R)}for(let R of k.files){let T=r(p,R.fileUri);T>=0?p[T].label=p[T].label||R.label:p.push(R)}}getRecentlyOpenedFromStorage(){const g=this.stateMainService.getItem(He.recentlyOpenedStorageKey);return(0,c.restoreRecentlyOpened)(g,this.logService)}saveRecentlyOpened(g){const p=(0,c.toStoreData)(g);this.stateMainService.setItem(He.recentlyOpenedStorageKey,p)}updateWindowsJumpList(){if(!w.isWindows)return;const g=[];if(g.push({type:"tasks",items:[{type:"task",title:(0,y.localize)(0,null),description:(0,y.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let p=[];for(let T of v.app.getJumpListSettings().removedItems){const O=T.args;if(O){const V=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(O);V&&p.push(P.URI.parse(V[2]))}}this.removeRecentlyOpened(p);let k=!1;const R=(0,L.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(T=>{const O=(0,c.isRecentWorkspace)(T)?T.workspace:T.folderUri,{title:V,description:ne}=this.getWindowsJumpListLabel(O,T.label);let se;return P.URI.isUri(O)?se=`--folder-uri "${O.toString()}"`:(k=!0,se=`--file-uri "${O.configPath.toString()}"`),{type:"task",title:V.substr(0,255),description:ne.substr(0,255),program:process.execPath,args:se,iconPath:"explorer.exe",iconIndex:0}}));R.length>0&&g.push({type:"custom",name:k?(0,y.localize)(2,null):(0,y.localize)(3,null),items:R})}g.push({type:"recent"});try{v.app.setJumpList(g)}catch(p){this.logService.warn("updateWindowsJumpList#setJumpList",p)}}getWindowsJumpListLabel(g,p){if(p)return{title:(0,I.splitName)(p).name,description:p};if(P.URI.isUri(g))return{title:(0,i.basename)(g),description:u(g)};if(this.workspacesManagementMainService.isUntitledWorkspace(g))return{title:(0,y.localize)(4,null),description:""};let k=(0,i.basename)(g.configPath);return k.endsWith(c.WORKSPACE_EXTENSION)&&(k=k.substr(0,k.length-c.WORKSPACE_EXTENSION.length-1)),{title:(0,y.localize)(5,null,k),description:u(g.configPath)}}};o.MAX_TOTAL_RECENT_ENTRIES=100,o.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,o.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,o.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],o.recentlyOpenedStorageKey="openedPathsList",o=he([ie(0,S.IStateMainService),ie(1,b.ILogService),ie(2,h.IWorkspacesManagementMainService),ie(3,m.ILifecycleMainService)],o),e.WorkspacesHistoryMainService=o;function u(a){return a.scheme==="file"?(0,I.normalizeDriveLetter)(a.fsPath):a.toString()}function t(a){return(0,c.isRecentFolder)(a)?a.folderUri:(0,c.isRecentFile)(a)?a.fileUri:a.workspace.configPath}function l(a,g){return a.findIndex(p=>(0,c.isRecentWorkspace)(p)&&p.workspace.id===g.id)}function s(a,g){return a.findIndex(p=>(0,c.isRecentFolder)(p)&&i.extUriBiasedIgnorePathCase.isEqual(p.folderUri,g))}function r(a,g){return a.findIndex(p=>i.extUriBiasedIgnorePathCase.isEqual(p.fileUri,g))}}),define(Z[234],x([0,1,14,9,23,34,3,8,145,16,24,22,6,180,53,21,39,29,42,64,36,65]),function(K,e,v,L,M,D,I,n,f,w,i,P,E,y,d,m,b,S,c,h,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let l=class wt{constructor(a,g,p,k,R,T,O,V,ne,se,G){this.updateService=a,this.configurationService=g,this.windowsMainService=p,this.environmentMainService=k,this.telemetryService=R,this.workspacesHistoryMainService=T,this.stateMainService=O,this.lifecycleMainService=V,this.logService=ne,this.nativeHostMainService=se,this.productService=G,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new L.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new L.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(I.isMacintosh||(0,h.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const a=this.stateMainService.getItem(wt.lastKnownMenubarStorageKey);a&&(a.menus&&(this.menubarMenus=a.menus),a.keybindings&&(this.keybindings=a.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(T,O,V)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:O?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(T,O,V)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:O?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(T,O,V)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(V),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(T,O,V)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(V),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const a=this.productService.twitterUrl;a&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(a,"openTwitterUrl"));const g=this.productService.requestFeatureUrl;g&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(g,"openUserVoiceUrl"));const p=this.productService.reportIssueUrl;p&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(p,"openReportIssues"));const k=this.productService.licenseUrl;k&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(I.language){const T=k.indexOf("?")>0?"&":"?";this.openUrl(`${k}${T}lang=${I.language}`,"openLicenseUrl")}else this.openUrl(k,"openLicenseUrl")});const R=this.productService.privacyStatementUrl;R&&k&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(R,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(a=>this.onDidChangeWindowsCount(a)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let a=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof a!="boolean"?!0:a}get currentEnableNativeTabs(){if(!I.isMacintosh)return!1;let a=this.configurationService.getValue("window.nativeTabs");return typeof a!="boolean"?!1:a}updateMenu(a,g){this.menubarMenus=a.menus,this.keybindings=a.keybindings,this.stateMainService.setItem(wt.lastKnownMenubarStorageKey,a),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(a){!I.isMacintosh||(a.oldCount===0&&a.newCount>0||a.oldCount>0&&a.newCount===0)&&(this.closedLastWindow=a.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!I.isMacintosh||(this.noActiveWindow=!v.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const a=v.Menu.getApplicationMenu();if(a&&this.oldMenus.push(a),Object.keys(this.menubarMenus).length===0){v.Menu.setApplicationMenu(I.isMacintosh?new v.Menu:null);return}const g=new v.Menu;let p;if(I.isMacintosh){const R=new v.Menu;p=new v.MenuItem({label:this.productService.nameShort,submenu:R}),this.setMacApplicationMenu(R),g.append(p)}if(I.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const R=new v.Menu;R.append(new v.MenuItem({label:this.mnemonicLabel(f.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),v.app.dock.setMenu(R)}if(this.shouldDrawMenu("File")){const R=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(f.localize(1,null)),submenu:R});this.setMenuById(R,"File"),g.append(T)}if(this.shouldDrawMenu("Edit")){const R=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(f.localize(2,null)),submenu:R});this.setMenuById(R,"Edit"),g.append(T)}if(this.shouldDrawMenu("Selection")){const R=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(f.localize(3,null)),submenu:R});this.setMenuById(R,"Selection"),g.append(T)}if(this.shouldDrawMenu("View")){const R=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(f.localize(4,null)),submenu:R});this.setMenuById(R,"View"),g.append(T)}if(this.shouldDrawMenu("Go")){const R=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(f.localize(5,null)),submenu:R});this.setMenuById(R,"Go"),g.append(T)}if(this.shouldDrawMenu("Run")){const R=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(f.localize(6,null)),submenu:R});this.setMenuById(R,"Run"),g.append(T)}if(this.shouldDrawMenu("Terminal")){const R=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(f.localize(7,null)),submenu:R});this.setMenuById(R,"Terminal"),g.append(T)}let k;if(this.shouldDrawMenu("Window")){const R=new v.Menu;k=new v.MenuItem({label:this.mnemonicLabel(f.localize(8,null)),submenu:R,role:"window"}),this.setMacWindowMenu(R)}if(k&&g.append(k),this.shouldDrawMenu("Help")){const R=new v.Menu,T=new v.MenuItem({label:this.mnemonicLabel(f.localize(9,null)),submenu:R,role:"help"});this.setMenuById(R,"Help"),g.append(T)}g.items&&g.items.length>0?v.Menu.setApplicationMenu(g):v.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(a){const g=this.createMenuItem(f.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),p=this.getUpdateMenuItems();let k;if(this.shouldDrawMenu("Preferences")){const te=new v.Menu;this.setMenuById(te,"Preferences"),k=new v.MenuItem({label:this.mnemonicLabel(f.localize(11,null)),submenu:te})}const R=new v.Menu,T=new v.MenuItem({label:f.localize(12,null),role:"services",submenu:R}),O=new v.MenuItem({label:f.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),V=new v.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ne=new v.MenuItem({label:f.localize(15,null),role:"unhide"}),se=new v.MenuItem(this.likeAction("workbench.action.quit",{label:f.localize(16,null,this.productService.nameLong),click:()=>{const te=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!v.BrowserWindow.getFocusedWindow()||te?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),G=[g];G.push(...p),k&&G.push(s(),k),G.push(s(),T,s(),O,V,ne,s(),se),G.forEach(te=>a.append(te))}shouldDrawMenu(a){if(!I.isMacintosh&&(0,h.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(a){case"File":case"Help":if(I.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[a];case"Window":if(I.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[a]}}setMenu(a,g){g.forEach(p=>{if((0,y.isMenubarMenuItemSeparator)(p))a.append(s());else if((0,y.isMenubarMenuItemSubmenu)(p)){const k=new v.Menu,R=new v.MenuItem({label:this.mnemonicLabel(p.label),submenu:k});this.setMenu(k,p.submenu.items),a.append(R)}else(0,y.isMenubarMenuItemRecentAction)(p)?a.append(this.createOpenRecentMenuItem(p)):(0,y.isMenubarMenuItemAction)(p)&&(p.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(a),I.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[p.id]?a.append(new v.MenuItem(this.likeAction(p.id,{label:this.mnemonicLabel(p.label),click:this.fallbackMenuHandlers[p.id]}))):a.append(this.createMenuItem(p.label,p.id,!1,p.checked)):a.append(this.createMenuItem(p.label,p.id,p.enabled!==!1,!!p.checked)):a.append(this.createMenuItem(p.label,p.id,p.enabled!==!1,!!p.checked)))})}setMenuById(a,g){this.menubarMenus&&this.menubarMenus[g]&&this.setMenu(a,this.menubarMenus[g].items)}insertCheckForUpdatesItems(a){const g=this.getUpdateMenuItems();g.length&&(g.forEach(p=>a.append(p)),a.append(s()))}createOpenRecentMenuItem(a){const g=n.URI.revive(a.uri),p=a.id,k=p==="openRecentFile"?{fileUri:g}:p==="openRecentWorkspace"?{workspaceUri:g}:{folderUri:g};return new v.MenuItem(this.likeAction(p,{label:a.label,click:(R,T,O)=>{const V=this.isOptionClick(O);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[k],forceNewWindow:V,gotoLineMode:!1,remoteAuthority:a.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([g])}},!1))}isOptionClick(a){return!!(a&&(!I.isMacintosh&&(a.ctrlKey||a.shiftKey)||I.isMacintosh&&(a.metaKey||a.altKey)))}createRoleMenuItem(a,g,p){const k={label:this.mnemonicLabel(a),role:p,enabled:!0};return new v.MenuItem(this.withKeybinding(g,k))}setMacWindowMenu(a){const g=new v.MenuItem({label:f.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),p=new v.MenuItem({label:f.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),k=new v.MenuItem({label:f.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),R=this.createMenuItem(f.localize(20,null),"workbench.action.switchWindow"),T=[];this.currentEnableNativeTabs&&(T.push(s()),T.push(this.createMenuItem(f.localize(21,null),"workbench.action.newWindowTab")),T.push(this.createRoleMenuItem(f.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),T.push(this.createRoleMenuItem(f.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),T.push(this.createRoleMenuItem(f.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),T.push(this.createRoleMenuItem(f.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[g,p,s(),R,...T,s(),k].forEach(O=>a.append(O))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new v.MenuItem({label:f.localize(27,null),enabled:!1})];case"available for download":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new v.MenuItem({label:f.localize(29,null),enabled:!1})];case"downloaded":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new v.MenuItem({label:f.localize(31,null),enabled:!1})];case"ready":return[new v.MenuItem({label:this.mnemonicLabel(f.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(a,g,p,k){const R=this.mnemonicLabel(a),T=typeof g=="function"?g:(G,te,F)=>{const j=G?G.userSettingsLabel:null;let q=g;Array.isArray(g)&&(q=this.isOptionClick(F)?g[1]:g[0]),j&&F.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:j}):this.runActionInRenderer({type:"commandId",commandId:q})},O=typeof p=="boolean"?p:this.windowsMainService.getWindowCount()>0,V=typeof k=="boolean"?k:!1,ne={label:R,click:T,enabled:O};V&&(ne.type="checkbox",ne.checked=V);let se;return typeof g=="string"?se=g:Array.isArray(g)&&(se=g[0]),I.isMacintosh&&(se==="editor.action.clipboardCutAction"?ne.role="cut":se==="editor.action.clipboardCopyAction"?ne.role="copy":se==="editor.action.clipboardPasteAction"&&(ne.role="paste"),se==="undo"?ne.click=this.makeContextAwareClickHandler(T,{inDevTools:G=>G.undo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("undo:")}):se==="redo"?ne.click=this.makeContextAwareClickHandler(T,{inDevTools:G=>G.redo(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("redo:")}):se==="editor.action.selectAll"&&(ne.click=this.makeContextAwareClickHandler(T,{inDevTools:G=>G.selectAll(),inNoWindow:()=>v.Menu.sendActionToFirstResponder("selectAll:")}))),new v.MenuItem(this.withKeybinding(se,ne))}makeContextAwareClickHandler(a,g){return(p,k,R)=>{const T=v.BrowserWindow.getFocusedWindow();if(!T)return g.inNoWindow();if(T.webContents.isDevToolsFocused()&&T.webContents.devToolsWebContents)return g.inDevTools(T.webContents.devToolsWebContents);a(p,k||T,R)}}runActionInRenderer(a){let g=v.BrowserWindow.getFocusedWindow();if(!g){const k=this.windowsMainService.getLastActiveWindow();k?.isMinimized()&&(g=k.win)}const p=g?this.windowsMainService.getWindowById(g.id):void 0;if(p){if(this.logService.trace("menubar#runActionInRenderer",a),I.isMacintosh&&!this.environmentMainService.isBuilt&&!p.isReady&&(a.type==="commandId"&&a.commandId==="workbench.action.toggleDevTools"||a.type!=="commandId"&&a.userSettingsLabel==="alt+cmd+i"))return;if(a.type==="commandId"){const k={id:a.commandId,from:"menu"};p.sendWhenReady("vscode:runAction",M.CancellationToken.None,k)}else{const k={userSettingsLabel:a.userSettingsLabel};p.sendWhenReady("vscode:runKeybinding",M.CancellationToken.None,k)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",a)}withKeybinding(a,g){const p=typeof a=="string"?this.keybindings[a]:void 0;if(p?.label){if(p.isNative!==!1)g.accelerator=p.label,g.userSettingsLabel=p.userSettingsLabel;else if(typeof g.label=="string"){const k=g.label.indexOf("[");k>=0?g.label=`${g.label.substr(0,k)} [${p.label}]`:g.label=`${g.label} [${p.label}]`}}else g.accelerator=void 0;return g}likeAction(a,g,p=!g.accelerator){p&&(g=this.withKeybinding(a,g));const k=g.click;return g.click=(R,T,O)=>{this.reportMenuActionTelemetry(a),k&&k(R,T,O)},g}openUrl(a,g){this.nativeHostMainService.openExternal(void 0,a),this.reportMenuActionTelemetry(g)}reportMenuActionTelemetry(a){this.telemetryService.publicLog2("workbenchActionExecuted",{id:a,from:t})}mnemonicLabel(a){return(0,D.mnemonicMenuLabel)(a,!this.currentEnableMenuBarMnemonics)}};l.lastKnownMenubarStorageKey="lastKnownMenubarData",l=he([ie(0,c.IUpdateService),ie(1,w.IConfigurationService),ie(2,o.IWindowsMainService),ie(3,i.IEnvironmentMainService),ie(4,S.ITelemetryService),ie(5,u.IWorkspacesHistoryMainService),ie(6,b.IStateMainService),ie(7,P.ILifecycleMainService),ie(8,E.ILogService),ie(9,d.INativeHostMainService),ie(10,m.IProductService)],l),e.Menubar=l;function s(){return new v.MenuItem({type:"separator"})}}),define(Z[235],x([0,1,5,22,6,234]),function(K,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,v.createDecorator)("menubarMainService");let I=class{constructor(f,w,i){this.instantiationService=f,this.lifecycleMainService=w,this.logService=i,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(D.Menubar)}async updateMenubar(f,w){this.logService.trace("menubarService#updateMenubar",f),(await this.menubar).updateMenu(w,f)}};I=he([ie(0,v.IInstantiationService),ie(1,L.ILifecycleMainService),ie(2,M.ILogService)],I),e.MenubarMainService=I}),define(Z[236],x([0,1,14,32,26,30,23,4,31,43,34,2,10,7,74,3,33,15,13,8,151,51,16,52,24,20,5,22,6,45,21,55,61,39,64,233,100,216,27,101,65,46]),function(K,e,v,L,M,D,I,n,f,w,i,P,E,y,d,m,b,S,c,h,o,u,t,l,s,r,a,g,p,k,R,T,O,V,ne,se,G,te,F,j,q,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function H(C){return(0,F.isWorkspaceIdentifier)(C?.workspace)}function _(C){return(0,F.isSingleFolderWorkspaceIdentifier)(C?.workspace)}let z=class Ze extends P.Disposable{constructor(A,W,B,Y,U,N,Q,J,re,le,ee,ae,ue,de,ve){super();this.machineId=A,this.initialUserEnv=W,this.logService=B,this.stateMainService=Y,this.environmentMainService=U,this.lifecycleMainService=N,this.backupMainService=Q,this.configurationService=J,this.workspacesHistoryMainService=re,this.workspacesManagementMainService=le,this.instantiationService=ee,this.dialogMainService=ae,this.fileService=ue,this.productService=de,this.protocolMainService=ve,this._onDidOpenWindow=this._register(new n.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new n.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new n.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new n.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new te.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(A=>this._onDidSignalReadyWindow.fire(A.window))),this._register(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const W=new P.DisposableStore;if(W.add(n.Event.any(A.onDidClose,A.onDidDestroy)(()=>W.dispose())),A.config.extensionDevelopmentPath)for(const B of A.config.extensionDevelopmentPath)W.add(this.protocolMainService.addValidFileRoot(h.URI.file(B)));A.config.extensionTestsPath&&W.add(this.protocolMainService.addValidFileRoot(h.URI.file(A.config.extensionTestsPath)))}}))}openEmptyWindow(A,W){let B=this.environmentMainService.args;const Y=W?.remoteAuthority||void 0,U=!0,N=W?.forceReuseWindow,Q=!N;return this.open({...A,cli:B,forceEmpty:U,forceNewWindow:Q,forceReuseWindow:N,remoteAuthority:Y})}openExistingWindow(A,W){A.focus(),this.handleWaitMarkerFile(W,[A])}open(A){this.logService.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const W=[],B=[],Y=[],U=[],N=[];let Q,J=0;const re=this.getPathsToOpen(A);this.logService.trace("windowsManager#open pathsToOpen",re);for(const ue of re)_(ue)?A.addMode?W.push(ue):B.push(ue):H(ue)?Y.push(ue):ue.fileUri?(Q||(Q={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:ue.remoteAuthority}),Q.filesToOpenOrCreate.push(ue)):ue.backupPath?N.push({backupFolder:(0,y.basename)(ue.backupPath),remoteAuthority:ue.remoteAuthority}):J++;A.diffMode&&Q&&Q.filesToOpenOrCreate.length>=2&&(Q.filesToDiff=Q.filesToOpenOrCreate.slice(0,2),Q.filesToOpenOrCreate=[]),Q&&A.waitMarkerFileURI&&(Q.filesToWait={paths:[...Q.filesToDiff,...Q.filesToOpenOrCreate],waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(U.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),Y.push(...U),N.push(...this.backupMainService.getEmptyWindowBackupPaths())):N.length=0;const{windows:le,filesOpenedInWindow:ee}=this.doOpen(A,Y,B,N,J,Q,W);if(this.logService.trace(`windowsManager#open used window count ${le.length} (workspacesToOpen: ${Y.length}, foldersToOpen: ${B.length}, emptyToRestore: ${N.length}, emptyToOpen: ${J})`),le.length>1)if(ee)ee.focus();else{const ue=this.windowsStateHandler.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let de=!0,ve=!0;if(ue){const Ie=le.filter(me=>this.windowsStateHandler.state.lastActiveWindow&&me.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ie.length&&(Ie[0].focus(),de=!1,ve=!1)}if(de)for(let Ie=le.length-1;Ie>=0;Ie--){const me=le[Ie];if(!(me.openedWorkspace&&U.some(ge=>me.openedWorkspace&&ge.workspace.id===me.openedWorkspace.id)||me.backupPath&&N.some(ge=>me.backupPath&&ge.backupFolder===(0,y.basename)(me.backupPath)))){me.focus(),ve=!1;break}}ve&&le[le.length-1].focus()}const ae=Q&&Q.filesToDiff.length>0;if(!le.some(ue=>ue.isExtensionDevelopmentHost)&&!ae&&!A.noRecentEntry){const ue=[];for(const de of re)H(de)&&!de.transient?ue.push({label:de.label,workspace:de.workspace,remoteAuthority:de.remoteAuthority}):_(de)?ue.push({label:de.label,folderUri:de.workspace.uri,remoteAuthority:de.remoteAuthority}):de.fileUri&&ue.push({label:de.label,fileUri:de.fileUri,remoteAuthority:de.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ue)}return this.handleWaitMarkerFile(A,le),le}handleWaitMarkerFile(A,W){const B=A.waitMarkerFileURI;A.context===0&&B&&W.length===1&&W[0]&&(async()=>{await W[0].whenClosedOrLoaded;try{await this.fileService.del(B)}catch(Y){}})()}doOpen(A,W,B,Y,U,N,Q){const J=[];let re;function le(me,ge){J.push(me),ge&&(re=me,N=void 0)}let{openFolderInNewWindow:ee,openFilesInNewWindow:ae}=this.shouldOpenNewWindow(A);if(!A.initialStartup&&Q.length>0){const me=Q[0].remoteAuthority,ge=this.getLastActiveWindowForAuthority(me);ge&&le(this.doAddFoldersToExistingWindow(ge,Q.map(Ee=>Ee.workspace.uri)))}const ue=B.length+W.length+Y.length;if(N&&ue===0){const me=N.filesToOpenOrCreate[0]||N.filesToDiff[0],ge=this.getWindows().filter(ke=>N&&ke.remoteAuthority===N.remoteAuthority);let Ee;me?.fileUri&&!ae&&((A.context===4||A.context===0||A.context===1)&&(Ee=(0,G.findWindowOnFile)(ge,me.fileUri,ke=>ke.configPath.scheme===E.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(ke.configPath):void 0)),Ee||(Ee=this.doGetLastActiveWindow(ge))),Ee?(0,F.isWorkspaceIdentifier)(Ee.openedWorkspace)?W.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):(0,F.isSingleFolderWorkspaceIdentifier)(Ee.openedWorkspace)?B.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):le(this.doOpenFilesInExistingWindow(A,Ee,N),!0):le(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:N,forceNewWindow:!0,remoteAuthority:N.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow}),!0)}const de=(0,D.distinct)(W,me=>me.workspace.id);if(de.length>0){const me=(0,D.coalesce)(de.map(ge=>(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge.workspace.configPath)));if(me.length>0){const ge=me[0],Ee=N?.remoteAuthority===ge.remoteAuthority?N:void 0;le(this.doOpenFilesInExistingWindow(A,ge,Ee),!!Ee),ee=!0}de.forEach(ge=>{if(me.some(Ae=>Ae.openedWorkspace&&Ae.openedWorkspace.id===ge.workspace.id))return;const Ee=ge.remoteAuthority,ke=N?.remoteAuthority===Ee?N:void 0;le(this.doOpenFolderOrWorkspace(A,ge,ee,ke),!!ke),ee=!0})}const ve=(0,D.distinct)(B,me=>S.extUriBiasedIgnorePathCase.getComparisonKey(me.workspace.uri));if(ve.length>0){const me=(0,D.coalesce)(ve.map(ge=>(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge.workspace.uri)));if(me.length>0){const ge=me[0],Ee=N?.remoteAuthority===ge.remoteAuthority?N:void 0;le(this.doOpenFilesInExistingWindow(A,ge,Ee),!!Ee),ee=!0}ve.forEach(ge=>{if(me.some(Ae=>(0,F.isSingleFolderWorkspaceIdentifier)(Ae.openedWorkspace)&&S.extUriBiasedIgnorePathCase.isEqual(Ae.openedWorkspace.uri,ge.workspace.uri)))return;const Ee=ge.remoteAuthority,ke=N?.remoteAuthority===Ee?N:void 0;le(this.doOpenFolderOrWorkspace(A,ge,ee,ke),!!ke),ee=!0})}const Ie=(0,D.distinct)(Y,me=>me.backupFolder);if(Ie.length>0&&Ie.forEach(me=>{const ge=me.remoteAuthority,Ee=N?.remoteAuthority===ge?N:void 0;le(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:Ee,remoteAuthority:ge,forceNewWindow:!0,forceNewTabbedWindow:A.forceNewTabbedWindow,emptyWindowBackupInfo:me}),!!Ee),ee=!0}),J.length===0||N){N&&!U&&U++;const me=N?N.remoteAuthority:A.remoteAuthority;for(let ge=0;ge<U;ge++)le(this.doOpenEmpty(A,ee,me,N),!!N),ee=!0}return{windows:(0,D.distinct)(J),filesOpenedInWindow:re}}doOpenFilesInExistingWindow(A,W,B){this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),W.focus();const Y={filesToOpenOrCreate:B?.filesToOpenOrCreate,filesToDiff:B?.filesToDiff,filesToWait:B?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",I.CancellationToken.None,Y),W}doAddFoldersToExistingWindow(A,W){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),A.focus();const B={foldersToAdd:W};return A.sendWhenReady("vscode:addFolders",I.CancellationToken.None,B),A}doOpenEmpty(A,W,B,Y,U){return!W&&!U&&typeof A.contextWindowId=="number"&&(U=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:B,forceNewWindow:W,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:Y,windowToUse:U})}doOpenFolderOrWorkspace(A,W,B,Y,U){return!B&&!U&&typeof A.contextWindowId=="number"&&(U=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({workspace:W.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:B,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:Y,windowToUse:U})}getPathsToOpen(A){let W,B=!1,Y=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(W=this.doExtractPathsFromAPI(A),B=!0):A.forceEmpty?W=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(W=this.doExtractPathsFromCLI(A.cli),W.length===0&&W.push(Object.create(null)),B=!0):(W=this.doGetPathsFromLastSession(),W.length===0&&W.push(Object.create(null)),Y=!0),!A.addMode&&B){const U=W.filter(N=>_(N));if(U.length>1){const N=U[0].remoteAuthority;if(U.every(Q=>Q.remoteAuthority===N)){const Q=this.workspacesManagementMainService.createUntitledWorkspaceSync(U.map(J=>({uri:J.workspace.uri})));W.push({workspace:Q,remoteAuthority:N}),W=W.filter(J=>!_(J))}}}return A.initialStartup&&!Y&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&W.unshift(...this.doGetPathsFromLastSession().filter(U=>H(U)||_(U)||U.backupPath)),W}doExtractPathsFromAPI(A){const W=[],B={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority};for(const Y of(0,D.coalesce)(A.urisToOpen||[])){const U=this.resolveOpenable(Y,B);if(U)U.label=Y.label,W.push(U);else{const N=this.resourceFromOpenable(Y),Q={title:this.productService.nameLong,type:"info",buttons:[(0,i.mnemonicButtonLabel)((0,o.localize)(0,null))],defaultId:0,message:N.scheme===E.Schemas.file?(0,o.localize)(1,null):(0,o.localize)(2,null),detail:N.scheme===E.Schemas.file?(0,o.localize)(3,null,(0,i.getPathLabel)(N.fsPath,this.environmentMainService)):(0,o.localize)(4,null,N.toString()),noLink:!0};this.dialogMainService.showMessageBox(Q,(0,c.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))}}return W}doExtractPathsFromCLI(A){const W=[],B={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:!1},Y=A["folder-uri"];if(Y)for(const Q of Y){const J=this.cliArgToUri(Q);if(J){const re=this.resolveOpenable({folderUri:J},B);re&&W.push(re)}}const U=A["file-uri"];if(U)for(const Q of U){const J=this.cliArgToUri(Q);if(J){const re=this.resolveOpenable((0,F.hasWorkspaceFileExtension)(Q)?{workspaceUri:J}:{fileUri:J},B);re&&W.push(re)}}const N=A._;for(const Q of N){const J=B.remoteAuthority?this.doResolvePathRemote(Q,B):this.doResolveFilePath(Q,B);J&&W.push(J)}return W}cliArgToUri(A){try{const W=h.URI.parse(A);if(!W.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${A}`);return}return W}catch(W){this.logService.error(`Invalid URI input string: ${A}, ${W.message}`)}}doGetPathsFromLastSession(){const A=this.getRestoreWindowsSetting();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":const W=[];A!=="one"&&W.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&W.push(this.windowsStateHandler.state.lastActiveWindow);const B=[];for(const Y of W)if(Y.workspace){const U=this.resolveOpenable({workspaceUri:Y.workspace.configPath},{remoteAuthority:Y.remoteAuthority,rejectTransientWorkspaces:!0});H(U)&&B.push(U)}else if(Y.folderUri){const U=this.resolveOpenable({folderUri:Y.folderUri},{remoteAuthority:Y.remoteAuthority});_(U)&&B.push(U)}else A!=="folders"&&Y.backupPath&&B.push({backupPath:Y.backupPath,remoteAuthority:Y.remoteAuthority});return B}}getRestoreWindowsSetting(){let A;return this.lifecycleMainService.wasRestarted?A="all":(A=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}resolveOpenable(A,W=Object.create(null)){let B=this.resourceFromOpenable(A);return B.scheme===E.Schemas.file?((0,ne.isFileToOpen)(A)&&(W={...W,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(B.fsPath,W)):this.doResolveRemoteOpenable(A,W)}doResolveRemoteOpenable(A,W){let B=this.resourceFromOpenable(A);const Y=(0,O.getRemoteAuthority)(B)||W.remoteAuthority;if(B=(0,S.removeTrailingPathSeparator)((0,S.normalizePath)(B)),(0,ne.isFileToOpen)(A)){if(W.gotoLineMode){const{path:U,line:N,column:Q}=(0,f.parseLineAndColumnAware)(B.path);return{fileUri:B.with({path:U}),selection:N?{startLineNumber:N,startColumn:Q||1}:void 0,remoteAuthority:Y}}return{fileUri:B,remoteAuthority:Y}}else if((0,ne.isWorkspaceToOpen)(A))return{workspace:(0,j.getWorkspaceIdentifier)(B),remoteAuthority:Y};return{workspace:(0,j.getSingleFolderWorkspaceIdentifier)(B),remoteAuthority:Y}}resourceFromOpenable(A){return(0,ne.isWorkspaceToOpen)(A)?A.workspaceUri:(0,ne.isFolderToOpen)(A)?A.folderUri:A.fileUri}doResolveFilePath(A,W){let B,Y;W.gotoLineMode&&({path:A,line:B,column:Y}=(0,f.parseLineAndColumnAware)(A)),A=(0,f.sanitizeFilePath)((0,y.normalize)(A),(0,b.cwd)());try{const U=(0,L.statSync)(A);if(U.isFile()){if(!W.forceOpenWorkspaceAsFile){const N=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.URI.file(A));if(N)return N.transient&&W.rejectTransientWorkspaces?void 0:{workspace:{id:N.id,configPath:N.configPath},remoteAuthority:N.remoteAuthority,exists:!0,transient:N.transient}}return{fileUri:h.URI.file(A),selection:B?{startLineNumber:B,startColumn:Y||1}:void 0,exists:!0}}else if(U.isDirectory())return{workspace:(0,j.getSingleFolderWorkspaceIdentifier)(h.URI.file(A),U),exists:!0}}catch(U){const N=h.URI.file(A);if(this.workspacesHistoryMainService.removeRecentlyOpened([N]),W.ignoreFileNotFound)return{fileUri:N,exists:!1}}}doResolvePathRemote(A,W){const B=A.charCodeAt(0),Y=W.remoteAuthority;let U,N;W.gotoLineMode&&({path:A,line:U,column:N}=(0,f.parseLineAndColumnAware)(A)),B!==47&&((0,f.isWindowsDriveLetter)(B)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,f.toSlashes)(A)),A=`/${A}`);const Q=h.URI.from({scheme:E.Schemas.vscodeRemote,authority:Y,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,F.hasWorkspaceFileExtension)(A))return W.forceOpenWorkspaceAsFile?{fileUri:Q,selection:U?{startLineNumber:U,startColumn:N||1}:void 0,remoteAuthority:W.remoteAuthority}:{workspace:(0,j.getWorkspaceIdentifier)(Q),remoteAuthority:Y};if(W.gotoLineMode||y.posix.basename(A).indexOf(".")!==-1)return{fileUri:Q,selection:U?{startLineNumber:U,startColumn:N||1}:void 0,remoteAuthority:Y}}return{workspace:(0,j.getSingleFolderWorkspaceIdentifier)(Q),remoteAuthority:Y}}shouldOpenNewWindow(A){const W=this.configurationService.getValue("window"),B=W?.openFoldersInNewWindow||"default",Y=W?.openFilesInNewWindow||"off";let U=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(B==="on"||B==="off")&&(U=B==="on");let N=!1;return A.forceNewWindow||A.forceReuseWindow?N=!!A.forceNewWindow&&!A.forceReuseWindow:(m.isMacintosh?A.context===1&&(N=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(N=!0),!A.cli.extensionDevelopmentPath&&(Y==="on"||Y==="off")&&(N=Y==="on")),{openFolderInNewWindow:!!U,openFilesInNewWindow:N}}openExtensionDevelopmentHostWindow(A,W){const B=(0,G.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if(B)return this.lifecycleMainService.reload(B,W.cli),B.focus(),[B];let Y=W.cli["folder-uri"]||[],U=W.cli["file-uri"]||[],N=W.cli._;if(!N.length&&!Y.length&&!U.length&&!W.cli.extensionTestsPath){const le=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ee=le&&(le.workspace||le.folderUri);ee&&(h.URI.isUri(ee)?ee.scheme===E.Schemas.file?N=[ee.fsPath]:Y=[ee.toString()]:ee.configPath.scheme===E.Schemas.file?N=[(0,S.originalFSPath)(ee.configPath)]:U=[ee.configPath.toString()])}let Q=W.remoteAuthority;for(const le of A)if(le.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ee=h.URI.parse(le),ae=(0,O.getRemoteAuthority)(ee);ae&&(Q?ae!==Q&&this.logService.error("more than one extension development path authority"):Q=ae)}N=N.filter(le=>{const ee=h.URI.file(le);return(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ee)?!1:(0,O.getRemoteAuthority)(ee)===Q}),Y=Y.filter(le=>{const ee=this.cliArgToUri(le);return ee&&!!(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ee)?!1:ee?(0,O.getRemoteAuthority)(ee)===Q:!1}),U=U.filter(le=>{const ee=this.cliArgToUri(le);return ee&&!!(0,G.findWindowOnWorkspaceOrFolder)(this.getWindows(),ee)?!1:ee?(0,O.getRemoteAuthority)(ee)===Q:!1}),W.cli._=N,W.cli["folder-uri"]=Y,W.cli["file-uri"]=U;const J=!N.length&&!Y.length&&!U.length,re={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:J,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:Q};return this.open(re)}openInBrowserWindow(A){const W=this.configurationService.getValue("window"),B={...this.environmentMainService.args,...A.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,y.join)(this.environmentMainService.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.initialUserEnv,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:k.default,isInitialStartup:A.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)()},zoomLevel:typeof W?.zoomLevel=="number"?W.zoomLevel:void 0,enableLegacyRecursiveWatcher:this.configurationService.getValue("files.legacyWatcher"),autoDetectHighContrast:W?.autoDetectHighContrast??!0,accessibilitySupport:v.app.accessibilitySupportEnabled,colorScheme:{dark:v.nativeTheme.shouldUseDarkColors,highContrast:v.nativeTheme.shouldUseInvertedColorScheme||v.nativeTheme.shouldUseHighContrastColors}};let Y;if(!A.forceNewWindow&&!A.forceNewTabbedWindow&&(Y=A.windowToUse||this.getLastActiveWindow(),Y&&Y.focus()),Y){const U=Y.config;!B.extensionDevelopmentPath&&U&&!!U.extensionDevelopmentPath&&(B.extensionDevelopmentPath=U.extensionDevelopmentPath,B.verbose=U.verbose,B["inspect-brk-extensions"]=U["inspect-brk-extensions"],B.debugId=U.debugId,B.extensionEnvironment=U.extensionEnvironment,B["inspect-extensions"]=U["inspect-extensions"],B["extensions-dir"]=U["extensions-dir"])}else{const U=this.windowsStateHandler.getNewWindowState(B);(0,d.mark)("code/willCreateCodeWindow");const N=Y=this.instantiationService.createInstance(se.CodeWindow,{state:U,extensionDevelopmentPath:B.extensionDevelopmentPath,isExtensionTestHost:!!B.extensionTestsPath});if((0,d.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow){const J=this.getLastActiveWindow();J&&J.addTabbedWindow(N)}Ze.WINDOWS.push(N),this._onDidOpenWindow.fire(N),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,w.once)(N.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(N)),(0,w.once)(N.onDidClose)(()=>this.onWindowClosed(N)),(0,w.once)(N.onDidDestroy)(()=>this._onDidDestroyWindow.fire(N));const Q=(0,c.assertIsDefined)(N.win?.webContents);Q.removeAllListeners("devtools-reload-page"),Q.on("devtools-reload-page",()=>this.lifecycleMainService.reload(N)),this.lifecycleMainService.registerWindow(N)}return B.windowId=Y.id,Y.isReady?this.lifecycleMainService.unload(Y,4).then(U=>{U||this.doOpenInBrowserWindow(Y,B,A)}):this.doOpenInBrowserWindow(Y,B,A),Y}doOpenInBrowserWindow(A,W,B){if(!W.extensionDevelopmentPath)if((0,F.isWorkspaceIdentifier)(W.workspace))W.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:W.workspace,remoteAuthority:W.remoteAuthority});else if((0,F.isSingleFolderWorkspaceIdentifier)(W.workspace))W.backupPath=this.backupMainService.registerFolderBackupSync(W.workspace.uri);else{const Y=B.emptyWindowBackupInfo&&B.emptyWindowBackupInfo.backupFolder;W.backupPath=this.backupMainService.registerEmptyWindowBackupSync(Y,W.remoteAuthority)}A.load(W)}onWindowClosed(A){const W=Ze.WINDOWS.indexOf(A);Ze.WINDOWS.splice(W,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const A=v.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(A){return this.doGetLastActiveWindow(this.getWindows().filter(W=>W.remoteAuthority===A))}doGetLastActiveWindow(A){const W=Math.max.apply(Math,A.map(B=>B.lastFocusTime));return A.find(B=>B.lastFocusTime===W)}sendToFocused(A,...W){const B=this.getFocusedWindow()||this.getLastActiveWindow();B&&B.sendWhenReady(A,I.CancellationToken.None,...W)}sendToAll(A,W,B){for(const Y of this.getWindows())B&&B.indexOf(Y.id)>=0||Y.sendWhenReady(A,I.CancellationToken.None,W)}getWindows(){return Ze.WINDOWS}getWindowCount(){return Ze.WINDOWS.length}getWindowById(A){const W=this.getWindows().filter(B=>B.id===A);return(0,D.firstOrDefault)(W)}getWindowByWebContents(A){const W=v.BrowserWindow.fromWebContents(A);if(!!W)return this.getWindowById(W.id)}};z.WINDOWS=[],z=he([ie(2,p.ILogService),ie(3,V.IStateMainService),ie(4,s.IEnvironmentMainService),ie(5,g.ILifecycleMainService),ie(6,u.IBackupMainService),ie(7,t.IConfigurationService),ie(8,q.IWorkspacesHistoryMainService),ie(9,$.IWorkspacesManagementMainService),ie(10,a.IInstantiationService),ie(11,l.IDialogMainService),ie(12,r.IFileService),ie(13,R.IProductService),ie(14,T.IProtocolMainService)],z),e.WindowsMainService=z}),define(Z[237],x([0,1,51,36,65,46]),function(K,e,v,L,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let I=class{constructor(f,w,i,P){this.workspacesManagementMainService=f,this.windowsMainService=w,this.workspacesHistoryMainService=i,this.backupMainService=P,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(f,w){const i=this.windowsMainService.getWindowById(f);if(i)return this.workspacesManagementMainService.enterWorkspace(i,this.windowsMainService.getWindows(),w)}createUntitledWorkspace(f,w,i){return this.workspacesManagementMainService.createUntitledWorkspace(w,i)}deleteUntitledWorkspace(f,w){return this.workspacesManagementMainService.deleteUntitledWorkspace(w)}getWorkspaceIdentifier(f,w){return this.workspacesManagementMainService.getWorkspaceIdentifier(w)}async getRecentlyOpened(f){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(f))}async addRecentlyOpened(f,w){return this.workspacesHistoryMainService.addRecentlyOpened(w)}async removeRecentlyOpened(f,w){return this.workspacesHistoryMainService.removeRecentlyOpened(w)}async clearRecentlyOpened(f){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};I=he([ie(0,D.IWorkspacesManagementMainService),ie(1,L.IWindowsMainService),ie(2,M.IWorkspacesHistoryMainService),ie(3,v.IBackupMainService)],I),e.WorkspacesMainService=I}),define(Z[238],x([0,1,14,32,26,18,60,17,31,43,40,34,2,10,7,3,15,13,8,28,69,119,35,122,85,229,131,51,220,16,176,158,72,52,219,89,24,54,91,169,183,90,170,20,71,5,73,230,196,102,22,6,178,235,53,21,61,225,75,39,214,99,197,29,199,201,62,42,205,227,231,228,232,98,206,207,208,209,211,36,236,212,27,65,237,46]),function(K,e,v,L,M,D,I,n,f,w,i,P,E,y,d,m,b,S,c,h,o,u,t,l,s,r,a,g,p,k,R,T,O,V,ne,se,G,te,F,j,q,$,H,_,z,C,A,W,B,Y,U,N,Q,J,re,le,ee,ae,ue,de,ve,Ie,me,ge,Ee,ke,Ae,We,Oe,Ye,Xe,ut,Ge,xe,et,X,oe,ce,we,be,Le,Ue,Fe,Ne,Be,ze){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let ht=class extends E.Disposable{constructor(fe,ye,Se,pe,Pe,De,Me,Re,Te,qe){super();this.mainProcessNodeIpcServer=fe,this.userEnv=ye,this.mainInstantiationService=Se,this.logService=pe,this.environmentMainService=Pe,this.lifecycleMainService=De,this.configurationService=Me,this.stateMainService=Re,this.fileService=Te,this.productService=qe,this.configureSession(),this.registerListeners()}configureSession(){const fe=pe=>pe?.startsWith(`${y.Schemas.vscodeWebview}://`),ye=new Set(["clipboard-read","clipboard-sanitized-write"]);v.session.defaultSession.setPermissionRequestHandler((pe,Pe,De,Me)=>fe(Me.requestingUrl)?De(ye.has(Pe)):De(!1)),v.session.defaultSession.setPermissionCheckHandler((pe,Pe,De,Me)=>fe(Me.requestingUrl)?ye.has(Pe):!1);const Se=v.session.defaultSession;typeof Se.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Se.setCodeCachePath((0,d.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,n.setUnexpectedErrorHandler)(Se=>this.onUnexpectedError(Se)),process.on("uncaughtException",Se=>(0,n.onUnexpectedError)(Se)),process.on("unhandledRejection",Se=>(0,n.onUnexpectedError)(Se)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,u.registerContextMenuListener)(),v.app.on("accessibility-support-changed",(Se,pe)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",pe)}),v.app.on("activate",(Se,pe)=>{this.logService.trace("app#activate"),pe||this.windowsMainService?.openEmptyWindow({context:1})}),v.app.on("web-contents-created",(Se,pe)=>{pe.on("will-navigate",Pe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Pe.preventDefault()}),pe.setWindowOpenHandler(({url:Pe})=>(this.nativeHostMainService?.openExternal(void 0,Pe),{action:"deny"}))});let fe=[],ye;v.app.on("open-file",(Se,pe)=>{this.logService.trace("app#open-file: ",pe),Se.preventDefault(),fe.push(this.getWindowOpenableFromPathSync(pe)),ye!==void 0&&(clearTimeout(ye),ye=void 0),ye=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:fe,gotoLineMode:!1,preferNewWindow:!0}),fe=[],ye=void 0},100)}),v.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),v.ipcMain.handle("vscode:fetchShellEnv",Se=>{const pe=this.windowsMainService?.getWindowByWebContents(Se.sender);let Pe,De;return pe?.config?(Pe=pe.config,De={...process.env,...pe.config.userEnv}):(Pe=this.environmentMainService.args,De=process.env),this.resolveShellEnvironment(Pe,De)}),v.ipcMain.handle("vscode:writeNlsFile",(Se,pe,Pe)=>{const De=this.validateNlsPath([pe]);if(!De||typeof Pe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(De,D.VSBuffer.fromString(Pe))}),v.ipcMain.handle("vscode:readNlsFile",async(Se,...pe)=>{const Pe=this.validateNlsPath(pe);if(!Pe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Pe)).value.toString()}),v.ipcMain.on("vscode:toggleDevTools",Se=>Se.sender.toggleDevTools()),v.ipcMain.on("vscode:openDevTools",Se=>Se.sender.openDevTools()),v.ipcMain.on("vscode:reloadWindow",Se=>Se.sender.reload())}validateNlsPath(fe){let ye;for(const Se of fe)typeof Se=="string"&&(typeof ye!="string"?ye=Se:ye=(0,d.join)(ye,Se));if(!(typeof ye!="string"||!(0,d.isAbsolute)(ye)||!(0,f.isEqualOrParent)(ye,this.environmentMainService.cachedLanguagesPath,!m.isLinux)))return c.URI.file(ye)}onUnexpectedError(fe){if(fe){const ye={message:`[uncaught exception in main]: ${fe.message}`,stack:fe.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(ye))}this.logService.error(`[uncaught exception in main]: ${fe}`),fe.stack&&this.logService.error(fe.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const fe=this.productService.win32AppUserModelId;m.isWindows&&fe&&v.app.setAppUserModelId(fe);try{m.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!v.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&v.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Te){this.logService.error(Te)}const ye=new l.Server;this.logService.trace("Resolving machine identifier...");const Se=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Se}`);const{sharedProcess:pe,sharedProcessReady:Pe,sharedProcessClient:De}=this.setupSharedProcess(Se),Me=await this.initServices(Se,pe,Pe);if(this.environmentMainService.driverHandle){const Te=await(0,ne.serve)(ye,this.environmentMainService.driverHandle,this.environmentMainService,Me);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Te)}this._register(Me.createInstance(r.ProxyAuthHandler)),Me.invokeFunction(Te=>this.initChannels(Te,ye,De));const Re=Me.invokeFunction(Te=>this.openFirstWindow(Te,ye));Me.invokeFunction(Te=>this.afterWindowOpen(Te,pe)),this.environmentMainService.args.trace&&Me.invokeFunction(Te=>this.stopTracingEventually(Te,Re))}async resolveMachineId(){let fe=this.stateMainService.getItem(ge.machineIdKey);return(!fe||m.isMacintosh&&fe==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(fe=await(0,o.getMachineId)(),this.stateMainService.setItem(ge.machineIdKey,fe)),fe}setupSharedProcess(fe){const ye=this._register(this.mainInstantiationService.createInstance(ae.SharedProcess,fe,this.userEnv)),Se=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Pe=await ye.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new s.Client(Pe,"main")})(),pe=(async()=>(await ye.whenReady(),Se))();return{sharedProcess:ye,sharedProcessReady:pe,sharedProcessClient:Se}}async initServices(fe,ye,Se){const pe=new A.ServiceCollection;switch(process.platform){case"win32":pe.set(We.IUpdateService,new z.SyncDescriptor(Ge.Win32UpdateService));break;case"linux":m.isLinuxSnap?pe.set(We.IUpdateService,new z.SyncDescriptor(ut.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):pe.set(We.IUpdateService,new z.SyncDescriptor(Xe.LinuxUpdateService));break;case"darwin":pe.set(We.IUpdateService,new z.SyncDescriptor(Ye.DarwinUpdateService));break}pe.set(be.IWindowsMainService,new z.SyncDescriptor(Le.WindowsMainService,[fe,this.userEnv])),pe.set(V.IDialogMainService,new z.SyncDescriptor(V.DialogMainService)),pe.set(Y.ILaunchMainService,new z.SyncDescriptor(Y.LaunchMainService)),pe.set(O.IDiagnosticsService,t.ProxyChannel.toService((0,t.getDelayedChannel)(Se.then(De=>De.getChannel("diagnostics"))))),pe.set(W.IIssueMainService,new z.SyncDescriptor(W.IssueMainService,[this.userEnv])),pe.set(se.IEncryptionMainService,new z.SyncDescriptor(se.EncryptionMainService,[fe])),pe.set(B.IKeyboardLayoutMainService,new z.SyncDescriptor(B.KeyboardLayoutMainService)),pe.set(re.INativeHostMainService,new z.SyncDescriptor(re.NativeHostMainService,[ye])),pe.set(ce.IWebviewManagerService,new z.SyncDescriptor(we.WebviewMainService)),pe.set(Fe.IWorkspacesService,new z.SyncDescriptor(Be.WorkspacesMainService)),pe.set(ze.IWorkspacesManagementMainService,new z.SyncDescriptor(ze.WorkspacesManagementMainService)),pe.set(Ne.IWorkspacesHistoryMainService,new z.SyncDescriptor(Ne.WorkspacesHistoryMainService)),pe.set(J.IMenubarMainService,new z.SyncDescriptor(J.MenubarMainService)),pe.set(j.IExtensionUrlTrustService,new z.SyncDescriptor(q.ExtensionUrlTrustService)),pe.set(Ie.IStorageMainService,new z.SyncDescriptor(Ie.StorageMainService)),m.isWindows?pe.set($.IExternalTerminalMainService,new z.SyncDescriptor(H.WindowsExternalTerminalService)):m.isMacintosh?pe.set($.IExternalTerminalMainService,new z.SyncDescriptor(H.MacExternalTerminalService)):m.isLinux&&pe.set($.IExternalTerminalMainService,new z.SyncDescriptor(H.LinuxExternalTerminalService));const Pe=new p.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(pe.set(g.IBackupMainService,Pe),pe.set(xe.IURLService,new z.SyncDescriptor(X.NativeURLService)),(0,Ae.supportsTelemetry)(this.productService,this.environmentMainService)){const De=(0,t.getDelayedChannel)(Se.then(Ve=>Ve.getChannel("telemetryAppender"))),Me=new Ee.TelemetryAppenderClient(De),Re=(0,me.resolveCommonProperties)(this.fileService,(0,M.release)(),(0,M.hostname)(),process.arch,this.productService.commit,this.productService.version,fe,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Te=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],qe={appenders:[Me],commonProperties:Re,piiPaths:Te,sendErrorTelemetry:!0};pe.set(ge.ITelemetryService,new z.SyncDescriptor(ke.TelemetryService,[qe]))}else pe.set(ge.ITelemetryService,Ae.NullTelemetryService);return await Pe.initialize(),this.mainInstantiationService.createChild(pe)}initChannels(fe,ye,Se){const pe=t.ProxyChannel.fromService(fe.get(Y.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",pe),ye.registerChannel(R.UserConfigurationFileServiceId,t.ProxyChannel.fromService(new R.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService)));const Pe=new Oe.UpdateChannel(fe.get(We.IUpdateService));ye.registerChannel("update",Pe);const De=t.ProxyChannel.fromService(fe.get(W.IIssueMainService));ye.registerChannel("issue",De);const Me=t.ProxyChannel.fromService(fe.get(se.IEncryptionMainService));ye.registerChannel("encryption",Me);const Re=t.ProxyChannel.fromService(fe.get(ue.ISignService));ye.registerChannel("sign",Re);const Te=t.ProxyChannel.fromService(fe.get(B.IKeyboardLayoutMainService));ye.registerChannel("keyboardLayout",Te),this.nativeHostMainService=fe.get(re.INativeHostMainService);const qe=t.ProxyChannel.fromService(this.nativeHostMainService);ye.registerChannel("nativeHost",qe),Se.then($e=>$e.registerChannel("nativeHost",qe));const Ve=t.ProxyChannel.fromService(fe.get(Fe.IWorkspacesService));ye.registerChannel("workspaces",Ve);const tt=t.ProxyChannel.fromService(fe.get(J.IMenubarMainService));ye.registerChannel("menubar",tt);const it=t.ProxyChannel.fromService(fe.get(xe.IURLService));ye.registerChannel("url",it);const nt=t.ProxyChannel.fromService(fe.get(j.IExtensionUrlTrustService));ye.registerChannel("extensionUrlTrust",nt);const Ce=t.ProxyChannel.fromService(fe.get(ce.IWebviewManagerService));ye.registerChannel("webview",Ce);const rt=this._register(new ve.StorageDatabaseChannel(this.logService,fe.get(Ie.IStorageMainService)));ye.registerChannel("storage",rt),Se.then($e=>$e.registerChannel("storage",rt));const st=t.ProxyChannel.fromService(fe.get($.IExternalTerminalMainService));ye.registerChannel("externalTerminal",st);const Qe=new Q.LogLevelChannel(fe.get(N.ILogService));ye.registerChannel("logLevel",Qe),Se.then($e=>$e.registerChannel("logLevel",Qe));const ot=new Q.LoggerChannel(fe.get(N.ILoggerService));ye.registerChannel("logger",ot),Se.then($e=>$e.registerChannel("logger",ot));const at=new T.ElectronExtensionHostDebugBroadcastChannel(fe.get(be.IWindowsMainService));ye.registerChannel("extensionhostdebugservice",at)}openFirstWindow(fe,ye){const Se=this.windowsMainService=fe.get(be.IWindowsMainService),pe=fe.get(xe.IURLService),Pe=fe.get(re.INativeHostMainService);this.lifecycleMainService.phase=2;const De=[],Me=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(_e=>{try{return{uri:c.URI.parse(_e),url:_e}}catch{return}}).filter(_e=>{if(!_e||this.shouldBlockURI(_e.uri))return!1;const Je=this.getWindowOpenableFromProtocolLink(_e.uri);return Je?(De.push(Je),!1):!0}),Re=this,Te=this.environmentMainService,qe=this.productService;pe.registerHandler({async handleURL(_e,Je){if(_e.scheme===qe.urlProtocol&&_e.path==="workspace"&&(_e=_e.with({authority:"file",path:c.URI.parse(_e.query).path,query:""})),Re.shouldBlockURI(_e))return!0;const vt=Re.getWindowOpenableFromProtocolLink(_e);if(vt){const[ft]=Se.open({context:5,cli:{...Te.args},urisToOpen:[vt],gotoLineMode:!0});return ft.focus(),!0}if(m.isMacintosh&&Se.getWindowCount()===0){const[ft]=Se.open({context:5,cli:{...Te.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ee.getRemoteAuthority)(_e)});return await ft.ready(),pe.open(_e,Je)}return!1}});const Ve=this._register(new Ue.ActiveWindowManager({onDidOpenWindow:Pe.onDidOpenWindow,onDidFocusWindow:Pe.onDidFocusWindow,getActiveWindowId:()=>Pe.getActiveWindowId(-1)})),tt=new t.StaticRouter(_e=>Ve.getActiveClientId().then(Je=>_e===Je)),it=new et.URLHandlerRouter(tt),nt=ye.getChannel("urlHandler",it);pe.registerHandler(new et.URLHandlerChannelClient(nt)),this._register(new oe.ElectronURLListener(Me,pe,Se,this.environmentMainService,this.productService));const Ce=this.environmentMainService.args,rt=global.macOpenFiles,st=(0,te.isLaunchedFromCli)(process.env)?0:4,Qe=Ce._.length,ot=!!Ce["folder-uri"],at=!!Ce["file-uri"],$e=Ce["skip-add-to-recently-opened"]===!0,dt=Ce.wait&&Ce.waitMarkerFilePath?c.URI.file(Ce.waitMarkerFilePath):void 0,pt=Ce.remote||void 0;return De.length>0?Se.open({context:st,cli:Ce,urisToOpen:De,gotoLineMode:!0,initialStartup:!0}):Ce["new-window"]&&!Qe&&!ot&&!at?Se.open({context:st,cli:Ce,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:$e,waitMarkerFileURI:dt,initialStartup:!0,remoteAuthority:pt}):rt.length&&!Qe&&!ot&&!at?Se.open({context:1,cli:Ce,urisToOpen:rt.map(_e=>this.getWindowOpenableFromPathSync(_e)),noRecentEntry:$e,waitMarkerFileURI:dt,initialStartup:!0}):Se.open({context:st,cli:Ce,forceNewWindow:Ce["new-window"]||!Qe&&Ce["unity-launch"],diffMode:Ce.diff,noRecentEntry:$e,waitMarkerFileURI:dt,gotoLineMode:Ce.goto,initialStartup:!0,remoteAuthority:pt})}shouldBlockURI(fe){return!!(fe.authority===y.Schemas.file&&m.isWindows&&v.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,P.mnemonicButtonLabel)((0,a.localize)(0,null)),(0,P.mnemonicButtonLabel)((0,a.localize)(1,null))],defaultId:0,cancelId:1,message:(0,a.localize)(2,null,(0,P.getPathLabel)(fe.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,a.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(fe){if(!!fe.path){if(fe.authority===y.Schemas.file){const ye=c.URI.file(fe.fsPath);return(0,Fe.hasWorkspaceFileExtension)(ye)?{workspaceUri:ye}:{fileUri:ye}}else if(fe.authority===y.Schemas.vscodeRemote){const ye=fe.path.indexOf(d.posix.sep,1);if(ye!==-1){const Se=fe.path.substring(1,ye),pe=fe.path.substring(ye),Pe=c.URI.from({scheme:y.Schemas.vscodeRemote,authority:Se,path:pe,query:fe.query,fragment:fe.fragment});return(0,Fe.hasWorkspaceFileExtension)(pe)?{workspaceUri:Pe}:/:[\d]+$/.test(pe)?{fileUri:Pe}:{folderUri:Pe}}}}}getWindowOpenableFromPathSync(fe){try{if((0,L.statSync)(fe).isDirectory())return{folderUri:c.URI.file(fe)};if((0,Fe.hasWorkspaceFileExtension)(fe))return{workspaceUri:c.URI.file(fe)}}catch(ye){}return{fileUri:c.URI.file(fe)}}async afterWindowOpen(fe,ye){this.lifecycleMainService.phase=3;let Se=!1;(0,w.once)(this.lifecycleMainService.onWillShutdown)(()=>Se=!0);const pe=fe.get(ge.ITelemetryService);this._register(ye.onDidError(({type:Me,details:Re})=>{let Te;switch(Me){case 1:Te="SharedProcess: detected unresponsive window";break;case 2:Te=`SharedProcess: crashed (detail: ${Re?.reason??"<unknown>"}, code: ${Re?.exitCode??"<unknown>"})`;break;case 3:Te=`SharedProcess: failed to load (detail: ${Re?.reason??"<unknown>"}, code: ${Re?.exitCode??"<unknown>"})`;break}(0,n.onUnexpectedError)(new Error(Te)),pe.publicLog2("sharedprocesserror",{type:Me,reason:Re?.reason,code:Re?.exitCode,visible:ye.isVisible(),shuttingdown:Se})}));const Pe=this.productService.win32MutexName;if(m.isWindows&&Pe)try{const Me=K.__$__nodeRequire("windows-mutex").Mutex,Re=new Me(Pe);(0,w.once)(this.lifecycleMainService.onWillShutdown)(()=>Re.release())}catch(Me){this.logService.error(Me)}v.protocol.registerHttpProtocol(y.Schemas.vscodeRemoteResource,(Me,Re)=>{Re({url:Me.url.replace(/^vscode-remote-resource:/,"http:"),method:Me.method})});const De=fe.get(We.IUpdateService);(De instanceof Ge.Win32UpdateService||De instanceof Xe.LinuxUpdateService||De instanceof Ye.DarwinUpdateService)&&De.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env);try{const Re=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,i.stripComments)(Re))["enable-crash-reporter"]===void 0){const Ve=(0,Ae.getTelemetryLevel)(this.configurationService)>=2,tt=typeof Ve=="boolean"?Ve:!0,it=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${tt},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,h.generateUuid)()}"`,"}"],nt=Re.substring(0,Re.length-2).concat(`,
`,it.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,D.VSBuffer.fromString(nt))}}catch(Me){this.logService.error(Me)}}async resolveShellEnvironment(fe,ye){try{return await(0,F.resolveShellEnv)(this.logService,fe,ye)}catch(Se){this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",(0,I.toErrorMessage)(Se))}return{}}stopTracingEventually(fe,ye){this.logService.info("Tracing: waiting for windows to get ready...");const Se=fe.get(V.IDialogMainService);let pe=!1;const Pe=async Me=>{if(pe)return;pe=!0;const Re=await v.contentTracing.stopRecording((0,b.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Me?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Re}`):Se.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,a.localize)(4,null),detail:(0,a.localize)(5,null,Re),buttons:[(0,P.mnemonicButtonLabel)((0,a.localize)(6,null))],defaultId:0,noLink:!0},(0,S.withNullAsUndefined)(v.BrowserWindow.getFocusedWindow()))},De=setTimeout(()=>Pe(!0),3e4);Promise.all(ye.map(Me=>Me.ready())).then(()=>{clearTimeout(De),Pe(!1)})}};ht=he([ie(2,C.IInstantiationService),ie(3,N.ILogService),ie(4,G.IEnvironmentMainService),ie(5,U.ILifecycleMainService),ie(6,k.IConfigurationService),ie(7,de.IStateMainService),ie(8,_.IFileService),ie(9,le.IProductService)],ht),e.CodeApplication=ht}),define(Z[243],x([0,1,14,32,30,9,60,17,31,43,34,10,7,74,3,33,25,19,35,56,238,11,16,187,198,24,54,161,20,181,182,71,172,73,22,93,6,179,94,45,21,55,184,96,222,50,224,75,195,39,226,62,63,204]),function(K,e,v,L,M,D,I,n,f,w,i,P,E,y,d,m,b,S,c,h,o,u,t,l,s,r,a,g,p,k,R,T,O,V,ne,se,G,te,F,j,q,$,H,_,z,C,A,W,B,Y,U,N,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class J{main(){try{this.startup()}catch(ee){console.error(ee.message),v.app.exit(1)}}async startup(){(0,n.setUnexpectedErrorHandler)(ge=>console.error(ge));const[ee,ae,ue,de,ve,Ie,me]=this.createServices();try{try{await this.initServices(ue,de,ve)}catch(ge){throw this.handleStartupDataDirError(ue,me.nameLong,ge),ge}await ee.invokeFunction(async ge=>{const Ee=ge.get(G.ILogService),ke=ge.get(ne.ILifecycleMainService),Ae=ge.get(p.IFileService),We=await this.claimInstance(Ee,ue,ke,ee,me,!0);return S.Promises.writeFile(ue.mainLockfile,String(process.pid)).catch(Oe=>{Ee.warn(`Error writing main lockfile: ${Oe.stack}`)}),Ie.logger=new F.SpdLogLogger("main",(0,E.join)(ue.logsPath,"main.log"),!0,Ie.getLevel()),(0,w.once)(ke.onWillShutdown)(Oe=>{Ae.dispose(),de.dispose(),Oe.join(S.Promises.unlink(ue.mainLockfile).catch(()=>{}))}),ee.createInstance(o.CodeApplication,We,ae).startup()})}catch(ge){ee.invokeFunction(this.quit,ge)}}createServices(){const ee=new V.ServiceCollection,ae={_serviceBrand:void 0,...j.default};ee.set(q.IProductService,ae);const ue=new r.EnvironmentMainService(this.resolveArgs(),ae),de=this.patchEnvironment(ue);ee.set(r.IEnvironmentMainService,ue);const ve=new se.BufferLogService,Ie=new G.MultiplexLogService([new G.ConsoleMainLogger((0,G.getLogLevel)(ue)),ve]);process.once("exit",()=>Ie.dispose()),ee.set(G.ILogService,Ie);const me=new k.FileService(Ie);ee.set(p.IFileService,me);const ge=new R.DiskFileSystemProvider(Ie);me.registerProvider(P.Schemas.file,ge),ee.set(G.ILoggerService,new te.LoggerService(Ie,me));const Ee=new l.ConfigurationService(ue.settingsResource,me);ee.set(t.IConfigurationService,Ee),ee.set(ne.ILifecycleMainService,new T.SyncDescriptor(ne.LifecycleMainService));const ke=new U.StateMainService(ue,Ie,me);return ee.set(Y.IStateMainService,ke),ee.set(C.IRequestService,new T.SyncDescriptor(A.RequestMainService)),ee.set(Q.IThemeMainService,new T.SyncDescriptor(Q.ThemeMainService)),ee.set(W.ISignService,new T.SyncDescriptor(B.SignService)),ee.set(_.ITunnelService,new T.SyncDescriptor(z.TunnelService)),ee.set($.IProtocolMainService,new T.SyncDescriptor(H.ProtocolMainService)),[new O.InstantiationService(ee,!0),de,ue,Ee,ke,ve,ae]}patchEnvironment(ee){const ae={VSCODE_IPC_HOOK:ee.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ue=>{const de=process.env[ue];typeof de=="string"&&(ae[ue]=de)}),Object.assign(process.env,ae),ae}initServices(ee,ae,ue){return D.Promises.settled([Promise.all([ee.extensionsPath,ee.codeCachePath,ee.logsPath,ee.globalStorageHome.fsPath,ee.workspaceStorageHome.fsPath,ee.backupHome].map(de=>de?S.Promises.mkdir(de,{recursive:!0}):void 0)),ae.initialize(),ue.init()])}async claimInstance(ee,ae,ue,de,ve,Ie){let me;try{(0,y.mark)("code/willStartMainServer"),me=await(0,h.serve)(ae.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),(0,w.once)(ue.onWillShutdown)(()=>me.dispose())}catch(ge){if(ge.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ae,ve.nameLong,ge),ge;let Ee;try{Ee=await(0,h.connect)(ae.mainIPCHandle,"main")}catch(We){if(!Ie||d.isWindows||We.code!=="ECONNREFUSED")throw We.code==="EPERM"&&this.showStartupWarningDialog((0,u.localize)(0,null,ve.nameShort),(0,u.localize)(1,null),ve.nameLong),We;try{(0,L.unlinkSync)(ae.mainIPCHandle)}catch(Oe){throw ee.warn("Could not delete obsolete instance handle",Oe),Oe}return this.claimInstance(ee,ae,ue,de,ve,!1)}if(ae.extensionTestsLocationURI&&!ae.debugExtensionHost.break){const We="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ee.error(We),Ee.dispose(),new Error(We)}let ke;!ae.args.wait&&!ae.args.status&&(ke=setTimeout(()=>{this.showStartupWarningDialog((0,u.localize)(2,null,ve.nameShort),(0,u.localize)(3,null),ve.nameLong)},1e4));const Ae=c.ProxyChannel.toService(Ee.getChannel("launch"),{disableMarshalling:!0});if(ae.args.status)return de.invokeFunction(async()=>{const We=new s.DiagnosticsService(N.NullTelemetryService,ve),Oe=await Ae.getMainProcessInfo(),Ye=await Ae.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Xe=await We.getDiagnostics(Oe,Ye);throw console.log(Xe),new n.ExpectedError});throw d.isWindows&&await this.windowsAllowSetForegroundWindow(Ae,ee),ee.trace("Sending env to running instance..."),await Ae.start(ae.args,process.env),Ee.dispose(),ke&&clearTimeout(ke),new n.ExpectedError("Sent env to running instance. Terminating...")}if(ae.args.status)throw ee.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new n.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),me}handleStartupDataDirError(ee,ae,ue){if(ue.code==="EACCES"||ue.code==="EPERM"){const de=(0,M.coalesce)([ee.userDataPath,ee.extensionsPath,h.XDG_RUNTIME_DIR]).map(ve=>(0,i.getPathLabel)(ve,ee));this.showStartupWarningDialog((0,u.localize)(4,null),(0,u.localize)(5,null,(0,I.toErrorMessage)(ue),de.join(`
`)),ae)}}showStartupWarningDialog(ee,ae,ue){v.dialog.showMessageBoxSync({title:ue,type:"warning",buttons:[(0,i.mnemonicButtonLabel)((0,u.localize)(6,null))],message:ee,detail:ae,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ee,ae){if(d.isWindows){const ue=await ee.getMainProcessId();ae.trace("Sending some foreground love to the running instance:",ue);try{(await new Promise((de,ve)=>{K(["windows-foreground-love"],de,ve)})).allowSetForegroundWindow(ue)}catch(de){ae.error(de)}}}quit(ee,ae){const ue=ee.get(G.ILogService),de=ee.get(ne.ILifecycleMainService);let ve=0;ae&&(ae.isExpected?ae.message&&ue.trace(ae.message):(ve=1,ae.stack?ue.error(ae.stack):ue.error(`Startup error: ${ae.toString()}`))),de.kill(ve)}resolveArgs(){const ee=this.validatePaths((0,a.parseMainProcessArgv)(process.argv));if(ee.wait&&!ee.waitMarkerFilePath){const ae=(0,g.createWaitMarkerFile)(ee.verbose);ae&&((0,a.addArg)(process.argv,"--waitMarkerFilePath",ae),ee.waitMarkerFilePath=ae)}return ee}validatePaths(ee){if(ee["open-url"]&&(ee._urls=ee._,ee._=[]),!ee.remote){const ae=this.doValidatePaths(ee._,ee.goto);ee._=ae}return ee}doValidatePaths(ee,ae){const ue=(0,m.cwd)(),de=ee.map(me=>{let ge=String(me),Ee;ae&&(Ee=(0,f.parseLineAndColumnAware)(ge),ge=Ee.path),ge&&(ge=this.preparePath(ue,ge));const ke=(0,f.sanitizeFilePath)(ge,ue),Ae=(0,E.basename)(ke);return Ae&&!(0,f.isValidBasename)(Ae)?null:ae&&Ee?(Ee.path=ke,this.toPath(Ee)):ke}),ve=d.isWindows||d.isMacintosh,Ie=(0,M.distinct)(de,me=>me&&ve?me.toLowerCase():me||"");return(0,M.coalesce)(Ie)}preparePath(ee,ae){return d.isWindows&&(ae=(0,b.rtrim)(ae,'"')),ae=(0,b.trim)((0,b.trim)(ae," "),"	"),d.isWindows&&(ae=(0,E.resolve)(ee,ae),ae=(0,b.rtrim)(ae,".")),ae}toPath(ee){const ae=[ee.path];return typeof ee.line=="number"&&ae.push(String(ee.line)),typeof ee.column=="number"&&ae.push(String(ee.column)),ae.join(":")}}new J().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e96a97448aae1572246bf7c438b7c2ee68a964c0/core/vs/code/electron-main/main.js.map
