/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/path","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/async","vs/base/common/network","vs/base/common/uri","vs/base/common/errors","vs/base/common/platform","vs/base/common/types","vs/base/node/pfs","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/common/arrays","vs/platform/environment/common/environment","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/process","vs/platform/telemetry/common/telemetry","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","os","child_process","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/platform/product/common/productService","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","fs","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/download/common/download","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/platform/environment/node/argvHelper","vs/base/node/watcher","vs/base/common/iterator","vs/base/common/performance","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],ee=function($){for(var t=[],C=0,b=$.length;C<b;C++)t[C]=Z[$[C]];return t};define(Z[58],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function C(b,w){if(!b)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}t.ok=C}),define(Z[45],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function C(R){return(T,l,d)=>{let E=null,L=null;if(typeof d.value=="function"?(E="value",L=d.value):typeof d.get=="function"&&(E="get",L=d.get),!L)throw new Error("not supported");d[E]=R(L,l)}}t.createDecorator=C;function b(R,T,l){let d=null,E=null;if(typeof l.value=="function"?(d="value",E=l.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(d="get",E=l.get),!E)throw new Error("not supported");const L=`$memoize$${T}`;l[d]=function(...g){return this.hasOwnProperty(L)||Object.defineProperty(this,L,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,g)}),this[L]}}t.memoize=b;function w(R,T,l){return C((d,E)=>{const L=`$debounce$${E}`,g=`$debounce$result$${E}`;return function(...S){this[g]||(this[g]=l?l():void 0),clearTimeout(this[L]),T&&(this[g]=T(this[g],...S),S=[this[g]]),this[L]=setTimeout(()=>{d.apply(this,S),this[g]=l?l():void 0},R)}})}t.debounce=w;function I(R,T,l){return C((d,E)=>{const L=`$throttle$timer$${E}`,g=`$throttle$result$${E}`,S=`$throttle$lastRun$${E}`,u=`$throttle$pending$${E}`;return function(...c){if(this[g]||(this[g]=l?l():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),T&&(this[g]=T(this[g],...c)),this[u])return;const v=this[S]+R;v<=Date.now()?(this[S]=Date.now(),d.apply(this,[this[g]]),this[g]=l?l():void 0):(this[u]=!0,this[L]=setTimeout(()=>{this[u]=!1,this[S]=Date.now(),d.apply(this,[this[g]]),this[g]=l?l():void 0},v-Date.now()))}})}t.throttle=I}),define(Z[59],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var C;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(C=t.ScanError||(t.ScanError={}));var b;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(b=t.SyntaxKind||(t.SyntaxKind={}));var w;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(w=t.ParseErrorCode||(t.ParseErrorCode={}));var I;(function(e){e.DEFAULT={allowTrailingComma:!0}})(I=t.ParseOptions||(t.ParseOptions={}));function R(e,i=!1){let n=0,r=e.length,a="",m=0,P=16,F=0;function p(ie){let ae=0,ue=0;for(;ae<ie;){const G=e.charCodeAt(n);if(G>=48&&G<=57)ue=ue*16+G-48;else if(G>=65&&G<=70)ue=ue*16+G-65+10;else if(G>=97&&G<=102)ue=ue*16+G-97+10;else break;n++,ae++}return ae<ie&&(ue=-1),ue}function O(ie){n=ie,a="",m=0,P=16,F=0}function A(){const ie=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&d(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&d(e.charCodeAt(n)))for(n++;n<e.length&&d(e.charCodeAt(n));)n++;else return F=3,e.substring(ie,n);let ae=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&d(e.charCodeAt(n))){for(n++;n<e.length&&d(e.charCodeAt(n));)n++;ae=n}else F=3;return e.substring(ie,ae)}function W(){let ie="",ae=n;for(;;){if(n>=r){ie+=e.substring(ae,n),F=2;break}const ue=e.charCodeAt(n);if(ue===34){ie+=e.substring(ae,n),n++;break}if(ue===92){if(ie+=e.substring(ae,n),n++,n>=r){F=2;break}switch(e.charCodeAt(n++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:const ne=p(4);ne>=0?ie+=String.fromCharCode(ne):F=4;break;default:F=5}ae=n;continue}if(ue>=0&&ue<=31)if(l(ue)){ie+=e.substring(ae,n),F=2;break}else F=6;n++}return ie}function Y(){if(a="",F=0,m=n,n>=r)return m=r,P=17;let ie=e.charCodeAt(n);if(T(ie)){do n++,a+=String.fromCharCode(ie),ie=e.charCodeAt(n);while(T(ie));return P=15}if(l(ie))return n++,a+=String.fromCharCode(ie),ie===13&&e.charCodeAt(n)===10&&(n++,a+=`
`),P=14;switch(ie){case 123:return n++,P=1;case 125:return n++,P=2;case 91:return n++,P=3;case 93:return n++,P=4;case 58:return n++,P=6;case 44:return n++,P=5;case 34:return n++,a=W(),P=10;case 47:const ae=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<r&&!l(e.charCodeAt(n));)n++;return a=e.substring(ae,n),P=12}if(e.charCodeAt(n+1)===42){n+=2;const ue=r-1;let G=!1;for(;n<ue;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,G=!0;break}n++}return G||(n++,F=1),a=e.substring(ae,n),P=13}return a+=String.fromCharCode(ie),n++,P=16;case 45:if(a+=String.fromCharCode(ie),n++,n===r||!d(e.charCodeAt(n)))return P=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=A(),P=11;default:for(;n<r&&te(ie);)n++,ie=e.charCodeAt(n);if(m!==n){switch(a=e.substring(m,n),a){case"true":return P=8;case"false":return P=9;case"null":return P=7}return P=16}return a+=String.fromCharCode(ie),n++,P=16}}function te(ie){if(T(ie)||l(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let ie;do ie=Y();while(ie>=12&&ie<=15);return ie}return{setPosition:O,getPosition:()=>n,scan:i?oe:Y,getToken:()=>P,getTokenValue:()=>a,getTokenOffset:()=>m,getTokenLength:()=>n-m,getTokenError:()=>F}}t.createScanner=R;function T(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function l(e){return e===10||e===13||e===8232||e===8233}function d(e){return e>=48&&e<=57}var E;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(E||(E={}));function L(e,i){const n=[],r=new Object;let a;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let P=!1;function F(p,O,A,W){m.value=p,m.offset=O,m.length=A,m.type=W,m.colonOffset=void 0,a=m}try{h(e,{onObjectBegin:(p,O)=>{if(i<=p)throw r;a=void 0,P=i>p,n.push("")},onObjectProperty:(p,O,A)=>{if(i<O||(F(p,O,A,"property"),n[n.length-1]=p,i<=O+A))throw r},onObjectEnd:(p,O)=>{if(i<=p)throw r;a=void 0,n.pop()},onArrayBegin:(p,O)=>{if(i<=p)throw r;a=void 0,n.push(0)},onArrayEnd:(p,O)=>{if(i<=p)throw r;a=void 0,n.pop()},onLiteralValue:(p,O,A)=>{if(i<O||(F(p,O,A,s(p)),i<=O+A))throw r},onSeparator:(p,O,A)=>{if(i<=O)throw r;if(p===":"&&a&&a.type==="property")a.colonOffset=O,P=!1,a=void 0;else if(p===","){const W=n[n.length-1];typeof W=="number"?n[n.length-1]=W+1:(P=!0,n[n.length-1]=""),a=void 0}}})}catch(p){if(p!==r)throw p}return{path:n,previousNode:a,isAtPropertyKey:P,matches:p=>{let O=0;for(let A=0;O<p.length&&A<n.length;A++)if(p[O]===n[A]||p[O]==="*")O++;else if(p[O]!=="**")return!1;return O===p.length}}}t.getLocation=L;function g(e,i=[],n=I.DEFAULT){let r=null,a=[];const m=[];function P(p){Array.isArray(a)?a.push(p):r!==null&&(a[r]=p)}return h(e,{onObjectBegin:()=>{const p={};P(p),m.push(a),a=p,r=null},onObjectProperty:p=>{r=p},onObjectEnd:()=>{a=m.pop()},onArrayBegin:()=>{const p=[];P(p),m.push(a),a=p,r=null},onArrayEnd:()=>{a=m.pop()},onLiteralValue:P,onError:(p,O,A)=>{i.push({error:p,offset:O,length:A})}},n),a[0]}t.parse=g;function S(e,i=[],n=I.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(p){r.type==="property"&&(r.length=p-r.offset,r=r.parent)}function m(p){return r.children.push(p),p}h(e,{onObjectBegin:p=>{r=m({type:"object",offset:p,length:-1,parent:r,children:[]})},onObjectProperty:(p,O,A)=>{r=m({type:"property",offset:O,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:p,offset:O,length:A,parent:r})},onObjectEnd:(p,O)=>{r.length=p+O-r.offset,r=r.parent,a(p+O)},onArrayBegin:(p,O)=>{r=m({type:"array",offset:p,length:-1,parent:r,children:[]})},onArrayEnd:(p,O)=>{r.length=p+O-r.offset,r=r.parent,a(p+O)},onLiteralValue:(p,O,A)=>{m({type:s(p),offset:O,length:A,parent:r,value:p}),a(O+A)},onSeparator:(p,O,A)=>{r.type==="property"&&(p===":"?r.colonOffset=O:p===","&&a(O))},onError:(p,O,A)=>{i.push({error:p,offset:O,length:A})}},n);const F=r.children[0];return F&&delete F.parent,F}t.parseTree=S;function u(e,i){if(!e)return;let n=e;for(let r of i)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let a=!1;for(const m of n.children)if(Array.isArray(m.children)&&m.children[0].value===r){n=m.children[1],a=!0;break}if(!a)return}else{const a=r;if(n.type!=="array"||a<0||!Array.isArray(n.children)||a>=n.children.length)return;n=n.children[a]}return n}t.findNodeAtLocation=u;function c(e){if(!e.parent||!e.parent.children)return[];const i=c(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=c;function v(e){switch(e.type){case"array":return e.children.map(v);case"object":const i=Object.create(null);for(let n of e.children){const r=n.children[1];r&&(i[n.children[0].value]=v(r))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=v;function y(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=y;function f(e,i,n=!1){if(y(e,i,n)){const r=e.children;if(Array.isArray(r))for(let a=0;a<r.length&&r[a].offset<=i;a++){const m=f(r[a],i,n);if(m)return m}return e}}t.findNodeAtOffset=f;function h(e,i,n=I.DEFAULT){const r=R(e,!1);function a(B){return B?()=>B(r.getTokenOffset(),r.getTokenLength()):()=>!0}function m(B){return B?J=>B(J,r.getTokenOffset(),r.getTokenLength()):()=>!0}const P=a(i.onObjectBegin),F=m(i.onObjectProperty),p=a(i.onObjectEnd),O=a(i.onArrayBegin),A=a(i.onArrayEnd),W=m(i.onLiteralValue),Y=m(i.onSeparator),te=a(i.onComment),oe=m(i.onError),ie=n&&n.disallowComments,ae=n&&n.allowTrailingComma;function ue(){for(;;){const B=r.scan();switch(r.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:ie||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(B){case 12:case 13:ie?G(10):te();break;case 16:G(1);break;case 15:case 14:break;default:return B}}}function G(B,J=[],q=[]){if(oe(B),J.length+q.length>0){let N=r.getToken();for(;N!==17;){if(J.indexOf(N)!==-1){ue();break}else if(q.indexOf(N)!==-1)break;N=ue()}}}function ne(B){const J=r.getTokenValue();return B?W(J):F(J),ue(),!0}function z(){switch(r.getToken()){case 11:let B=0;try{B=JSON.parse(r.getTokenValue()),typeof B!="number"&&(G(2),B=0)}catch(J){G(2)}W(B);break;case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return ue(),!0}function D(){return r.getToken()!==10?(G(3,[],[2,5]),!1):(ne(!1),r.getToken()===6?(Y(":"),ue(),K()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function M(){P(),ue();let B=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(B||G(4,[],[]),Y(","),ue(),r.getToken()===2&&ae)break}else B&&G(6,[],[]);D()||G(4,[],[2,5]),B=!0}return p(),r.getToken()!==2?G(7,[2],[]):ue(),!0}function U(){O(),ue();let B=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(B||G(4,[],[]),Y(","),ue(),r.getToken()===4&&ae)break}else B&&G(6,[],[]);K()||G(4,[],[4,5]),B=!0}return A(),r.getToken()!==4?G(8,[4],[]):ue(),!0}function K(){switch(r.getToken()){case 3:return U();case 1:return M();case 10:return ne(!0);default:return z()}}return ue(),r.getToken()===17?n.allowEmptyContent?!0:(G(4,[],[]),!1):K()?(r.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}t.visit=h;function o(e,i){let n=R(e),r=[],a,m=0,P;do switch(P=n.getPosition(),a=n.scan(),a){case 12:case 13:case 17:m!==P&&r.push(e.substring(m,P)),i!==void 0&&r.push(n.getTokenValue().replace(/[^\r\n]/g,i)),m=n.getPosition();break}while(a!==17);return r.join("")}t.stripComments=o;function s(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=s}),function(){function $(w){const I=[];typeof w=="number"&&I.push("code/timeOrigin",w);function R(l){I.push(l,Date.now())}function T(){const l=[];for(let d=0;d<I.length;d+=2)l.push({name:I[d],startTime:I[d+1]});return l}return{mark:R,getMarks:T}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const R of performance.getEntriesByType("mark"))I.push({name:R.name,startTime:Math.round(w+R.startTime)});return I}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function C(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=t()),w.MonacoPerformanceMarks}var b;typeof global=="object"?b=global:typeof self=="object"?b=self:b={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(b)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(b):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),b.perf=C(b))}(),define(Z[60],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.sanitizeProcessEnvironment=t.TerminateResponseCode=t.Source=void 0;var C;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(C=t.Source||(t.Source={}));var b;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(b=t.TerminateResponseCode||(t.TerminateResponseCode={}));function w(I,...R){const T=R.reduce((E,L)=>(E[L]=!0,E),{}),l=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(E=>!T[E]).forEach(E=>{for(let L=0;L<l.length;L++)if(E.search(l[L])!==-1){delete I[E];break}})}t.sanitizeProcessEnvironment=w}),function($,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var C=t();for(var b in C)(typeof exports=="object"?exports:$)[b]=C[b]}}(typeof self!="undefined"?self:this,function(){return function($){var t={};function C(b){if(t[b])return t[b].exports;var w=t[b]={i:b,l:!1,exports:{}};return $[b].call(w.exports,w,w.exports,C),w.l=!0,w.exports}return C.m=$,C.c=t,C.d=function(b,w,I){C.o(b,w)||Object.defineProperty(b,w,{enumerable:!0,get:I})},C.r=function(b){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(b,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(b,"__esModule",{value:!0})},C.t=function(b,w){if(1&w&&(b=C(b)),8&w||4&w&&typeof b=="object"&&b&&b.__esModule)return b;var I=Object.create(null);if(C.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:b}),2&w&&typeof b!="string")for(var R in b)C.d(I,R,function(T){return b[T]}.bind(null,R));return I},C.n=function(b){var w=b&&b.__esModule?function(){return b.default}:function(){return b};return C.d(w,"a",w),w},C.o=function(b,w){return Object.prototype.hasOwnProperty.call(b,w)},C.p="",C(C.s=0)}([function($,t,C){(function(b){var w;t=$.exports=q,w=typeof b=="object"&&b.env&&b.env.NODE_DEBUG&&/\bsemver\b/i.test(b.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var I=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,T=t.re=[],l=t.src=[],d=0,E=d++;l[E]="0|[1-9]\\d*";var L=d++;l[L]="[0-9]+";var g=d++;l[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=d++;l[S]="("+l[E]+")\\.("+l[E]+")\\.("+l[E]+")";var u=d++;l[u]="("+l[L]+")\\.("+l[L]+")\\.("+l[L]+")";var c=d++;l[c]="(?:"+l[E]+"|"+l[g]+")";var v=d++;l[v]="(?:"+l[L]+"|"+l[g]+")";var y=d++;l[y]="(?:-("+l[c]+"(?:\\."+l[c]+")*))";var f=d++;l[f]="(?:-?("+l[v]+"(?:\\."+l[v]+")*))";var h=d++;l[h]="[0-9A-Za-z-]+";var o=d++;l[o]="(?:\\+("+l[h]+"(?:\\."+l[h]+")*))";var s=d++,e="v?"+l[S]+l[y]+"?"+l[o]+"?";l[s]="^"+e+"$";var i="[v=\\s]*"+l[u]+l[f]+"?"+l[o]+"?",n=d++;l[n]="^"+i+"$";var r=d++;l[r]="((?:<|>)?=?)";var a=d++;l[a]=l[L]+"|x|X|\\*";var m=d++;l[m]=l[E]+"|x|X|\\*";var P=d++;l[P]="[v=\\s]*("+l[m]+")(?:\\.("+l[m]+")(?:\\.("+l[m]+")(?:"+l[y]+")?"+l[o]+"?)?)?";var F=d++;l[F]="[v=\\s]*("+l[a]+")(?:\\.("+l[a]+")(?:\\.("+l[a]+")(?:"+l[f]+")?"+l[o]+"?)?)?";var p=d++;l[p]="^"+l[r]+"\\s*"+l[P]+"$";var O=d++;l[O]="^"+l[r]+"\\s*"+l[F]+"$";var A=d++;l[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=d++;l[W]="(?:~>?)";var Y=d++;l[Y]="(\\s*)"+l[W]+"\\s+",T[Y]=new RegExp(l[Y],"g");var te=d++;l[te]="^"+l[W]+l[P]+"$";var oe=d++;l[oe]="^"+l[W]+l[F]+"$";var ie=d++;l[ie]="(?:\\^)";var ae=d++;l[ae]="(\\s*)"+l[ie]+"\\s+",T[ae]=new RegExp(l[ae],"g");var ue=d++;l[ue]="^"+l[ie]+l[P]+"$";var G=d++;l[G]="^"+l[ie]+l[F]+"$";var ne=d++;l[ne]="^"+l[r]+"\\s*("+i+")$|^$";var z=d++;l[z]="^"+l[r]+"\\s*("+e+")$|^$";var D=d++;l[D]="(\\s*)"+l[r]+"\\s*("+i+"|"+l[P]+")",T[D]=new RegExp(l[D],"g");var M=d++;l[M]="^\\s*("+l[P]+")\\s+-\\s+("+l[P]+")\\s*$";var U=d++;l[U]="^\\s*("+l[F]+")\\s+-\\s+("+l[F]+")\\s*$";var K=d++;l[K]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)w(B,l[B]),T[B]||(T[B]=new RegExp(l[B]));function J(x,_){if(x instanceof q)return x;if(typeof x!="string"||x.length>I||!(_?T[n]:T[s]).test(x))return null;try{return new q(x,_)}catch(H){return null}}function q(x,_){if(x instanceof q){if(x.loose===_)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof q))return new q(x,_);w("SemVer",x,_),this.loose=_;var H=x.trim().match(_?T[n]:T[s]);if(!H)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(le){if(/^[0-9]+$/.test(le)){var he=+le;if(he>=0&&he<R)return he}return le}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}t.parse=J,t.valid=function(x,_){var H=J(x,_);return H?H.version:null},t.clean=function(x,_){var H=J(x.trim().replace(/^[=v]+/,""),_);return H?H.version:null},t.SemVer=q,q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},q.prototype.toString=function(){return this.version},q.prototype.compare=function(x){return w("SemVer.compare",this.version,this.loose,x),x instanceof q||(x=new q(x,this.loose)),this.compareMain(x)||this.comparePre(x)},q.prototype.compareMain=function(x){return x instanceof q||(x=new q(x,this.loose)),k(this.major,x.major)||k(this.minor,x.minor)||k(this.patch,x.patch)},q.prototype.comparePre=function(x){if(x instanceof q||(x=new q(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var _=0;do{var H=this.prerelease[_],le=x.prerelease[_];if(w("prerelease compare",_,H,le),H===void 0&&le===void 0)return 0;if(le===void 0)return 1;if(H===void 0)return-1;if(H!==le)return k(H,le)}while(++_)},q.prototype.inc=function(x,_){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",_);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",_);break;case"prepatch":this.prerelease.length=0,this.inc("patch",_),this.inc("pre",_);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",_),this.inc("pre",_);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}_&&(this.prerelease[0]===_?isNaN(this.prerelease[1])&&(this.prerelease=[_,0]):this.prerelease=[_,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},t.inc=function(x,_,H,le){typeof H=="string"&&(le=H,H=void 0);try{return new q(x,H).inc(_,le).version}catch(he){return null}},t.diff=function(x,_){if(Q(x,_))return null;var H=J(x),le=J(_);if(H.prerelease.length||le.prerelease.length){for(var he in H)if((he==="major"||he==="minor"||he==="patch")&&H[he]!==le[he])return"pre"+he;return"prerelease"}for(var he in H)if((he==="major"||he==="minor"||he==="patch")&&H[he]!==le[he])return he},t.compareIdentifiers=k;var N=/^[0-9]+$/;function k(x,_){var H=N.test(x),le=N.test(_);return H&&le&&(x=+x,_=+_),H&&!le?-1:le&&!H?1:x<_?-1:x>_?1:0}function j(x,_,H){return new q(x,H).compare(new q(_,H))}function V(x,_,H){return j(x,_,H)>0}function X(x,_,H){return j(x,_,H)<0}function Q(x,_,H){return j(x,_,H)===0}function se(x,_,H){return j(x,_,H)!==0}function re(x,_,H){return j(x,_,H)>=0}function me(x,_,H){return j(x,_,H)<=0}function ye(x,_,H,le){var he;switch(_){case"===":typeof x=="object"&&(x=x.version),typeof H=="object"&&(H=H.version),he=x===H;break;case"!==":typeof x=="object"&&(x=x.version),typeof H=="object"&&(H=H.version),he=x!==H;break;case"":case"=":case"==":he=Q(x,H,le);break;case"!=":he=se(x,H,le);break;case">":he=V(x,H,le);break;case">=":he=re(x,H,le);break;case"<":he=X(x,H,le);break;case"<=":he=me(x,H,le);break;default:throw new TypeError("Invalid operator: "+_)}return he}function fe(x,_){if(x instanceof fe){if(x.loose===_)return x;x=x.value}if(!(this instanceof fe))return new fe(x,_);w("comparator",x,_),this.loose=_,this.parse(x),this.semver===Pe?this.value="":this.value=this.operator+this.semver.version,w("comp",this)}t.rcompareIdentifiers=function(x,_){return k(_,x)},t.major=function(x,_){return new q(x,_).major},t.minor=function(x,_){return new q(x,_).minor},t.patch=function(x,_){return new q(x,_).patch},t.compare=j,t.compareLoose=function(x,_){return j(x,_,!0)},t.rcompare=function(x,_,H){return j(_,x,H)},t.sort=function(x,_){return x.sort(function(H,le){return t.compare(H,le,_)})},t.rsort=function(x,_){return x.sort(function(H,le){return t.rcompare(H,le,_)})},t.gt=V,t.lt=X,t.eq=Q,t.neq=se,t.gte=re,t.lte=me,t.cmp=ye,t.Comparator=fe;var Pe={};function pe(x,_){if(x instanceof pe)return x.loose===_?x:new pe(x.raw,_);if(x instanceof fe)return new pe(x.value,_);if(!(this instanceof pe))return new pe(x,_);if(this.loose=_,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function Ee(x){return!x||x.toLowerCase()==="x"||x==="*"}function Ae(x,_,H,le,he,Le,we,Oe,Ie,Ce,Ne,Re,Te){return((_=Ee(H)?"":Ee(le)?">="+H+".0.0":Ee(he)?">="+H+"."+le+".0":">="+_)+" "+(Oe=Ee(Ie)?"":Ee(Ce)?"<"+(+Ie+1)+".0.0":Ee(Ne)?"<"+Ie+"."+(+Ce+1)+".0":Re?"<="+Ie+"."+Ce+"."+Ne+"-"+Re:"<="+Oe)).trim()}function Me(x,_){for(var H=0;H<x.length;H++)if(!x[H].test(_))return!1;if(_.prerelease.length){for(H=0;H<x.length;H++)if(w(x[H].semver),x[H].semver!==Pe&&x[H].semver.prerelease.length>0){var le=x[H].semver;if(le.major===_.major&&le.minor===_.minor&&le.patch===_.patch)return!0}return!1}return!0}function Ue(x,_,H){try{_=new pe(_,H)}catch(le){return!1}return _.test(x)}function ze(x,_,H,le){var he,Le,we,Oe,Ie;switch(x=new q(x,le),_=new pe(_,le),H){case">":he=V,Le=me,we=X,Oe=">",Ie=">=";break;case"<":he=X,Le=re,we=V,Oe="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(x,_,le))return!1;for(var Ce=0;Ce<_.set.length;++Ce){var Ne=_.set[Ce],Re=null,Te=null;if(Ne.forEach(function(Fe){Fe.semver===Pe&&(Fe=new fe(">=0.0.0")),Re=Re||Fe,Te=Te||Fe,he(Fe.semver,Re.semver,le)?Re=Fe:we(Fe.semver,Te.semver,le)&&(Te=Fe)}),Re.operator===Oe||Re.operator===Ie||(!Te.operator||Te.operator===Oe)&&Le(x,Te.semver)||Te.operator===Ie&&we(x,Te.semver))return!1}return!0}fe.prototype.parse=function(x){var _=this.loose?T[ne]:T[z],H=x.match(_);if(!H)throw new TypeError("Invalid comparator: "+x);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new q(H[2],this.loose):this.semver=Pe},fe.prototype.toString=function(){return this.value},fe.prototype.test=function(x){return w("Comparator.test",x,this.loose),this.semver===Pe||(typeof x=="string"&&(x=new q(x,this.loose)),ye(x,this.operator,this.semver,this.loose))},fe.prototype.intersects=function(x,_){if(!(x instanceof fe))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new pe(x.value,_),Ue(this.value,H,_);if(x.operator==="")return H=new pe(this.value,_),Ue(x.semver,H,_);var le=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),he=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),Le=this.semver.version===x.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Oe=ye(this.semver,"<",x.semver,_)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),Ie=ye(this.semver,">",x.semver,_)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return le||he||Le&&we||Oe||Ie},t.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(x){var _=this.loose;x=x.trim(),w("range",x,_);var H=_?T[U]:T[M];x=x.replace(H,Ae),w("hyphen replace",x),x=x.replace(T[D],"$1$2$3"),w("comparator trim",x,T[D]),x=(x=(x=x.replace(T[Y],"$1~")).replace(T[ae],"$1^")).split(/\s+/).join(" ");var le=_?T[ne]:T[z],he=x.split(" ").map(function(Le){return function(we,Oe){return w("comp",we),we=function(Ie,Ce){return Ie.trim().split(/\s+/).map(function(Ne){return function(Re,Te){w("caret",Re,Te);var Fe=Te?T[G]:T[ue];return Re.replace(Fe,function(ke,ge,ve,Se,be){var De;return w("caret",Re,ke,ge,ve,Se,be),Ee(ge)?De="":Ee(ve)?De=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ee(Se)?De=ge==="0"?">="+ge+"."+ve+".0 <"+ge+"."+(+ve+1)+".0":">="+ge+"."+ve+".0 <"+(+ge+1)+".0.0":be?(w("replaceCaret pr",be),be.charAt(0)!=="-"&&(be="-"+be),De=ge==="0"?ve==="0"?">="+ge+"."+ve+"."+Se+be+" <"+ge+"."+ve+"."+(+Se+1):">="+ge+"."+ve+"."+Se+be+" <"+ge+"."+(+ve+1)+".0":">="+ge+"."+ve+"."+Se+be+" <"+(+ge+1)+".0.0"):(w("no pr"),De=ge==="0"?ve==="0"?">="+ge+"."+ve+"."+Se+" <"+ge+"."+ve+"."+(+Se+1):">="+ge+"."+ve+"."+Se+" <"+ge+"."+(+ve+1)+".0":">="+ge+"."+ve+"."+Se+" <"+(+ge+1)+".0.0"),w("caret return",De),De})}(Ne,Ce)}).join(" ")}(we,Oe),w("caret",we),we=function(Ie,Ce){return Ie.trim().split(/\s+/).map(function(Ne){return function(Re,Te){var Fe=Te?T[oe]:T[te];return Re.replace(Fe,function(ke,ge,ve,Se,be){var De;return w("tilde",Re,ke,ge,ve,Se,be),Ee(ge)?De="":Ee(ve)?De=">="+ge+".0.0 <"+(+ge+1)+".0.0":Ee(Se)?De=">="+ge+"."+ve+".0 <"+ge+"."+(+ve+1)+".0":be?(w("replaceTilde pr",be),be.charAt(0)!=="-"&&(be="-"+be),De=">="+ge+"."+ve+"."+Se+be+" <"+ge+"."+(+ve+1)+".0"):De=">="+ge+"."+ve+"."+Se+" <"+ge+"."+(+ve+1)+".0",w("tilde return",De),De})}(Ne,Ce)}).join(" ")}(we,Oe),w("tildes",we),we=function(Ie,Ce){return w("replaceXRanges",Ie,Ce),Ie.split(/\s+/).map(function(Ne){return function(Re,Te){Re=Re.trim();var Fe=Te?T[O]:T[p];return Re.replace(Fe,function(ke,ge,ve,Se,be,De){w("xRange",Re,ke,ge,ve,Se,be,De);var je=Ee(ve),Ve=je||Ee(Se),We=Ve||Ee(be);return ge==="="&&We&&(ge=""),je?ke=ge===">"||ge==="<"?"<0.0.0":"*":ge&&We?(Ve&&(Se=0),We&&(be=0),ge===">"?(ge=">=",Ve?(ve=+ve+1,Se=0,be=0):We&&(Se=+Se+1,be=0)):ge==="<="&&(ge="<",Ve?ve=+ve+1:Se=+Se+1),ke=ge+ve+"."+Se+"."+be):Ve?ke=">="+ve+".0.0 <"+(+ve+1)+".0.0":We&&(ke=">="+ve+"."+Se+".0 <"+ve+"."+(+Se+1)+".0"),w("xRange return",ke),ke})}(Ne,Ce)}).join(" ")}(we,Oe),w("xrange",we),we=function(Ie,Ce){return w("replaceStars",Ie,Ce),Ie.trim().replace(T[K],"")}(we,Oe),w("stars",we),we}(Le,_)}).join(" ").split(/\s+/);return this.loose&&(he=he.filter(function(Le){return!!Le.match(le)})),he=he.map(function(Le){return new fe(Le,_)})},pe.prototype.intersects=function(x,_){if(!(x instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(le){return x.set.some(function(he){return he.every(function(Le){return le.intersects(Le,_)})})})})},t.toComparators=function(x,_){return new pe(x,_).set.map(function(H){return H.map(function(le){return le.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new q(x,this.loose));for(var _=0;_<this.set.length;_++)if(Me(this.set[_],x))return!0;return!1},t.satisfies=Ue,t.maxSatisfying=function(x,_,H){var le=null,he=null;try{var Le=new pe(_,H)}catch(we){return null}return x.forEach(function(we){Le.test(we)&&(le&&he.compare(we)!==-1||(he=new q(le=we,H)))}),le},t.minSatisfying=function(x,_,H){var le=null,he=null;try{var Le=new pe(_,H)}catch(we){return null}return x.forEach(function(we){Le.test(we)&&(le&&he.compare(we)!==1||(he=new q(le=we,H)))}),le},t.validRange=function(x,_){try{return new pe(x,_).range||"*"}catch(H){return null}},t.ltr=function(x,_,H){return ze(x,_,"<",H)},t.gtr=function(x,_,H){return ze(x,_,">",H)},t.outside=ze,t.prerelease=function(x,_){var H=J(x,_);return H&&H.prerelease.length?H.prerelease:null},t.intersects=function(x,_,H){return x=new pe(x,H),_=new pe(_,H),x.intersects(_)},t.coerce=function(x){if(x instanceof q)return x;if(typeof x!="string")return null;var _=x.match(T[A]);return _==null?null:J((_[1]||"0")+"."+(_[2]||"0")+"."+(_[3]||"0"))}}).call(this,C(1))},function($,t){var C,b,w=$.exports={};function I(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function T(v){if(C===setTimeout)return setTimeout(v,0);if((C===I||!C)&&setTimeout)return C=setTimeout,setTimeout(v,0);try{return C(v,0)}catch(y){try{return C.call(null,v,0)}catch(f){return C.call(this,v,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:I}catch(v){C=I}try{b=typeof clearTimeout=="function"?clearTimeout:R}catch(v){b=R}})();var l,d=[],E=!1,L=-1;function g(){E&&l&&(E=!1,l.length?d=l.concat(d):L=-1,d.length&&S())}function S(){if(!E){var v=T(g);E=!0;for(var y=d.length;y;){for(l=d,d=[];++L<y;)l&&l[L].run();L=-1,y=d.length}l=null,E=!1,function(f){if(b===clearTimeout)return clearTimeout(f);if((b===R||!b)&&clearTimeout)return b=clearTimeout,clearTimeout(f);try{b(f)}catch(h){try{return b.call(null,f)}catch(o){return b.call(this,f)}}}(v)}}function u(v,y){this.fun=v,this.array=y}function c(){}w.nextTick=function(v){var y=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)y[f-1]=arguments[f];d.push(new u(v,y)),d.length!==1||E||T(S)},u.prototype.run=function(){this.fun.apply(null,this.array)},w.title="browser",w.browser=!0,w.env={},w.argv=[],w.version="",w.versions={},w.on=c,w.addListener=c,w.once=c,w.off=c,w.removeListener=c,w.removeAllListeners=c,w.emit=c,w.prependListener=c,w.prependOnceListener=c,w.listeners=function(v){return[]},w.binding=function(v){throw new Error("process.binding is not supported")},w.cwd=function(){return"/"},w.chdir=function(v){throw new Error("process.chdir is not supported")},w.umask=function(){return 0}}])}),define(Z[37],ee([0,1,9,2]),function($,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function w(h){const o=h;return o?[o.on,o.pause,o.resume,o.destroy].every(s=>typeof s=="function"):!1}t.isReadableStream=w;function I(h){const o=h;return o?w(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}t.isReadableBufferedStream=I;function R(h,o){return new T(h,o)}t.newWriteableStream=R;class T{constructor(o,s){this.reducer=o,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(s=>s(o))}emitError(o){this.listeners.error.length===0?(0,C.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(s=>s(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,s){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(o,s){if(this.state.destroyed)return;let e;switch(o){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(s);i>=0&&e.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(h,o){const s=[];let e;for(;(e=h.read())!==null;)s.push(e);return o(s)}t.consumeReadable=l;function d(h,o,s){const e=[];let i;for(;(i=h.read())!==null&&e.length<s;)e.push(i);return i===null&&e.length>0?o(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return h.read()}}}t.peekReadable=d;function E(h,o){return new Promise((s,e)=>{const i=[];L(h,{onData:n=>{o&&i.push(n)},onError:n=>{o?e(n):s(void 0)},onEnd:()=>{s(o?o(i):void 0)}})})}t.consumeStream=E;function L(h,o){h.on("error",s=>o.onError(s)),h.on("end",()=>o.onEnd()),h.on("data",s=>o.onData(s))}t.listenStream=L;function g(h,o){return new Promise((s,e)=>{const i=new b.DisposableStore,n=[],r=P=>{if(n.push(P),n.length>o)return i.dispose(),h.pause(),s({stream:h,buffer:n,ended:!1})},a=P=>e(P),m=()=>s({stream:h,buffer:n,ended:!0});i.add((0,b.toDisposable)(()=>h.removeListener("error",a))),h.on("error",a),i.add((0,b.toDisposable)(()=>h.removeListener("end",m))),h.on("end",m),i.add((0,b.toDisposable)(()=>h.removeListener("data",r))),h.on("data",r)})}t.peekStream=g;function S(h,o){const s=R(o);return s.end(h),s}t.toStream=S;function u(){const h=R(()=>{throw new Error("not supported")});return h.end(),h}t.emptyStream=u;function c(h){let o=!1;return{read:()=>o?null:(o=!0,h)}}t.toReadable=c;function v(h,o,s){const e=R(s);return L(h,{onData:i=>e.write(o.data(i)),onError:i=>e.error(o.error?o.error(i):i),onEnd:()=>e.end()}),e}t.transform=v;function y(h,o,s){let e=!1;return{read:()=>{const i=o.read();return e?i:(e=!0,i!==null?s([h,i]):h)}}}t.prefixedReadable=y;function f(h,o,s){let e=!1;const i=R(s);return L(o,{onData:n=>e?i.write(n):(e=!0,i.write(s([h,n]))),onError:n=>i.error(n),onEnd:()=>{e||(e=!0,i.write(h)),i.end()}}),i}t.prefixedStream=f}),define(Z[17],ee([0,1,37]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const b=typeof Buffer!="undefined";let w,I;class R{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return b?new R(Buffer.allocUnsafe(r)):new R(new Uint8Array(r))}static wrap(r){return b&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new R(r)}static fromString(r,a){return!(a?.dontUseNodeBuffer||!1)&&b?new R(Buffer.from(r)):(w||(w=new TextEncoder),new R(w.encode(r)))}static concat(r,a){if(typeof a=="undefined"){a=0;for(let F=0,p=r.length;F<p;F++)a+=r[F].byteLength}const m=R.alloc(a);let P=0;for(let F=0,p=r.length;F<p;F++){const O=r[F];m.set(O,P),P+=O.byteLength}return m}toString(){return b?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(r,a){return new R(this.buffer.subarray(r,a))}set(r,a){r instanceof R?this.buffer.set(r.buffer,a):this.buffer.set(r,a)}readUInt32BE(r){return d(this.buffer,r)}writeUInt32BE(r,a){E(this.buffer,r,a)}readUInt32LE(r){return L(this.buffer,r)}writeUInt32LE(r,a){g(this.buffer,r,a)}readUInt8(r){return S(this.buffer,r)}writeUInt8(r,a){u(this.buffer,r,a)}}t.VSBuffer=R;function T(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0}t.readUInt16LE=T;function l(n,r,a){n[a+0]=r&255,r=r>>>8,n[a+1]=r&255}t.writeUInt16LE=l;function d(n,r){return n[r]*2**24+n[r+1]*2**16+n[r+2]*2**8+n[r+3]}t.readUInt32BE=d;function E(n,r,a){n[a+3]=r,r=r>>>8,n[a+2]=r,r=r>>>8,n[a+1]=r,r=r>>>8,n[a]=r}t.writeUInt32BE=E;function L(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0|n[r+2]<<16>>>0|n[r+3]<<24>>>0}t.readUInt32LE=L;function g(n,r,a){n[a+0]=r&255,r=r>>>8,n[a+1]=r&255,r=r>>>8,n[a+2]=r&255,r=r>>>8,n[a+3]=r&255}t.writeUInt32LE=g;function S(n,r){return n[r]}t.readUInt8=S;function u(n,r,a){n[a]=r}t.writeUInt8=u;function c(n){return C.consumeReadable(n,r=>R.concat(r))}t.readableToBuffer=c;function v(n){return C.toReadable(n)}t.bufferToReadable=v;function y(n){return C.consumeStream(n,r=>R.concat(r))}t.streamToBuffer=y;async function f(n){return n.ended?R.concat(n.buffer):R.concat([...n.buffer,await y(n.stream)])}t.bufferedStreamToBuffer=f;function h(n){return C.toStream(n,r=>R.concat(r))}t.bufferToStream=h;function o(n){return C.transform(n,{data:r=>typeof r=="string"?R.fromString(r):R.wrap(r)},r=>R.concat(r))}t.streamToBufferReadableStream=o;function s(n){return C.newWriteableStream(r=>R.concat(r),n)}t.newWriteableBufferStream=s;function e(n,r){return C.prefixedReadable(n,r,a=>R.concat(a))}t.prefixedBufferReadable=e;function i(n,r){return C.prefixedStream(n,r,a=>R.concat(a))}t.prefixedBufferStream=i}),define(Z[18],ee([0,1,11]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function b(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const v=Array.isArray(c)?[]:{};return Object.keys(c).forEach(y=>{c[y]&&typeof c[y]=="object"?v[y]=b(c[y]):v[y]=c[y]}),v}t.deepClone=b;function w(c){if(!c||typeof c!="object")return c;const v=[c];for(;v.length>0;){const y=v.shift();Object.freeze(y);for(const f in y)if(I.call(y,f)){const h=y[f];typeof h=="object"&&!Object.isFrozen(h)&&v.push(h)}}return c}t.deepFreeze=w;const I=Object.prototype.hasOwnProperty;function R(c,v){return T(c,v,new Set)}t.cloneAndChange=R;function T(c,v,y){if((0,C.isUndefinedOrNull)(c))return c;const f=v(c);if(typeof f!="undefined")return f;if((0,C.isArray)(c)){const h=[];for(const o of c)h.push(T(o,v,y));return h}if((0,C.isObject)(c)){if(y.has(c))throw new Error("Cannot clone recursive data-structure");y.add(c);const h={};for(let o in c)I.call(c,o)&&(h[o]=T(c[o],v,y));return y.delete(c),h}return c}function l(c,v,y=!0){return(0,C.isObject)(c)?((0,C.isObject)(v)&&Object.keys(v).forEach(f=>{f in c?y&&((0,C.isObject)(c[f])&&(0,C.isObject)(v[f])?l(c[f],v[f],y):c[f]=v[f]):c[f]=v[f]}),c):v}t.mixin=l;function d(c,v){if(c===v)return!0;if(c==null||v===null||v===void 0||typeof c!=typeof v||typeof c!="object"||Array.isArray(c)!==Array.isArray(v))return!1;let y,f;if(Array.isArray(c)){if(c.length!==v.length)return!1;for(y=0;y<c.length;y++)if(!d(c[y],v[y]))return!1}else{const h=[];for(f in c)h.push(f);h.sort();const o=[];for(f in v)o.push(f);if(o.sort(),!d(h,o))return!1;for(y=0;y<h.length;y++)if(!d(c[h[y]],v[h[y]]))return!1}return!0}t.equals=d;function E(c){const v=new Set;return JSON.stringify(c,(y,f)=>{if((0,C.isObject)(f)||Array.isArray(f)){if(v.has(f))return"[Circular]";v.add(f)}return f})}t.safeStringify=E;function L(c,v,y){const f=v(c);return typeof f=="undefined"?y:f}t.getOrDefault=L;function g(c,v){const y=Object.create(null);return!c||!v||Object.keys(v).forEach(h=>{const o=c[h],s=v[h];d(o,s)||(y[h]=s)}),y}t.distinct=g;function S(c,v){const y=v.toLowerCase(),f=Object.keys(c).find(h=>h.toLowerCase()===y);return f?c[f]:c[v]}t.getCaseInsensitive=S;function u(c,v){const y=Object.create(null);for(const f of Object.keys(c))v(f,c[f])&&(y[f]=c[f]);return y}t.filter=u}),define(Z[61],ee([0,1,8]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function b(d){const E=d;return E&&typeof E.type=="string"&&typeof E.severity=="string"}t.isRemoteConsoleLog=b;function w(d){const E=[];let L;try{const g=JSON.parse(d.arguments),S=g[g.length-1];S&&S.__$stack&&(g.pop(),L=S.__$stack),E.push(...g)}catch(g){E.push("Unable to log remote console arguments",d.arguments)}return{args:E,stack:L}}t.parse=w;function I(d){if(typeof d!="string")return I(w(d).stack);const E=d;if(E){const L=R(E),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(L||"");if(g&&g.length===4)return{uri:C.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}t.getFirstFrame=I;function R(d){if(!d)return d;const E=d.indexOf(`
`);return E===-1?d:d.substring(0,E)}function T(d,E){const{args:L,stack:g}=w(d),S=typeof L[0]=="string"&&L.length===1;let u=R(g);u&&(u=`(${u.trim()})`);let c=[];if(typeof L[0]=="string"?u&&S?c=[`%c[${E}] %c${L[0]} %c${u}`,l("blue"),l(""),l("grey")]:c=[`%c[${E}] %c${L[0]}`,l("blue"),l(""),...L.slice(1)]:c=[`%c[${E}]%`,l("blue"),...L],u&&!S&&c.push(u),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,c)}t.log=T;function l(d){return`color: ${d}`}}),define(Z[62],ee([0,1,17,22,8]),function($,t,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function I(E){return JSON.stringify(E,l)}t.stringify=I;function R(E){let L=JSON.parse(E);return L=d(L),L}t.parse=R;var T;(function(E){E[E.Uri=1]="Uri",E[E.Regexp=2]="Regexp",E[E.ScmResource=3]="ScmResource",E[E.ScmResourceGroup=4]="ScmResourceGroup",E[E.ScmProvider=5]="ScmProvider",E[E.CommentController=6]="CommentController",E[E.CommentThread=7]="CommentThread",E[E.CommentThreadReply=8]="CommentThreadReply",E[E.CommentNode=9]="CommentNode",E[E.CommentThreadNode=10]="CommentThreadNode",E[E.TimelineActionContext=11]="TimelineActionContext",E[E.NotebookCellActionContext=12]="NotebookCellActionContext",E[E.TestItemContext=13]="TestItemContext"})(T=t.MarshalledId||(t.MarshalledId={}));function l(E,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,b.regExpFlags)(L)}:L}function d(E,L=0){if(!E||L>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return w.URI.revive(E);case 2:return new RegExp(E.source,E.flags)}if(E instanceof C.VSBuffer||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let g=0;g<E.length;++g)E[g]=d(E[g],L+1);else for(const g in E)Object.hasOwnProperty.call(E,g)&&(E[g]=d(E[g],L+1))}return E}t.revive=d}),define(Z[63],ee([0,1,6,38,46,3,22]),function($,t,C,b,w,I,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function T(){return Object.create(null)}t.getEmptyExpression=T;const l="**",d="/",E="[/\\\\]",L="[^/\\\\]",g=/\//g;function S(D){switch(D){case 0:return"";case 1:return`${L}*?`;default:return`(?:${E}|${L}+${E}|${E}${L}+)*?`}}function u(D,M){if(!D)return[];const U=[];let K=!1,B=!1,J="";for(const q of D){switch(q){case M:if(!K&&!B){U.push(J),J="";continue}break;case"{":K=!0;break;case"}":K=!1;break;case"[":B=!0;break;case"]":B=!1;break}J+=q}return J&&U.push(J),U}t.splitGlobAware=u;function c(D){if(!D)return"";let M="";const U=u(D,d);if(U.every(K=>K===l))M=".*";else{let K=!1;U.forEach((B,J)=>{if(B===l){K||(M+=S(2),K=!0);return}let q=!1,N="",k=!1,j="";for(const V of B){if(V!=="}"&&q){N+=V;continue}if(k&&(V!=="]"||!j)){let X;V==="-"?X=V:(V==="^"||V==="!")&&!j?X="^":V===d?X="":X=R.escapeRegExpCharacters(V),j+=X;continue}switch(V){case"{":q=!0;continue;case"[":k=!0;continue;case"}":M+=`(?:${u(N,",").map(se=>c(se)).join("|")})`,q=!1,N="";break;case"]":M+="["+j+"]",k=!1,j="";break;case"?":M+=L;continue;case"*":M+=S(1);continue;default:M+=R.escapeRegExpCharacters(V)}}J<U.length-1&&(U[J+1]!==l||J+2<U.length)&&(M+=E),K=!1})}return M}const v=/^\*\*\/\*\.[\w\.-]+$/,y=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new w.LRUCache(1e4),i=function(){return!1},n=function(){return null};function r(D,M){if(!D)return n;let U;typeof D!="string"?U=D.pattern:U=D,U=U.trim();const K=`${U}_${!!M.trimForExclusions}`;let B=e.get(K);if(B)return a(B,D);let J;if(v.test(U)){const q=U.substr(4);B=function(N,k){return typeof N=="string"&&N.endsWith(q)?U:null}}else(J=y.exec(m(U,M)))?B=P(J[1],U):(M.trimForExclusions?h:f).test(U)?B=F(U,M):(J=o.exec(m(U,M)))?B=p(J[1].substr(1),U,!0):(J=s.exec(m(U,M)))?B=p(J[1],U,!1):B=O(U);return e.set(K,B),a(B,D)}function a(D,M){return typeof M=="string"?D:function(U,K){return b.isEqualOrParent(U,M.base)?D(I.relative(M.base,U),K):null}}function m(D,M){return M.trimForExclusions&&D.endsWith("/**")?D.substr(0,D.length-2):D}function P(D,M){const U=`/${D}`,K=`\\${D}`,B=function(q,N){return typeof q!="string"?null:N?N===D?M:null:q===D||q.endsWith(U)||q.endsWith(K)?M:null},J=[D];return B.basenames=J,B.patterns=[M],B.allBasenames=J,B}function F(D,M){const U=z(D.slice(1,-1).split(",").map(N=>r(N,M)).filter(N=>N!==n),D),K=U.length;if(!K)return n;if(K===1)return U[0];const B=function(N,k){for(let j=0,V=U.length;j<V;j++)if(U[j](N,k))return D;return null},J=U.find(N=>!!N.allBasenames);J&&(B.allBasenames=J.allBasenames);const q=U.reduce((N,k)=>k.allPaths?N.concat(k.allPaths):N,[]);return q.length&&(B.allPaths=q),B}function p(D,M,U){const K=I.sep===I.posix.sep,B=K?D:D.replace(g,I.sep),J=I.sep+B,q=I.posix.sep+D,N=U?function(k,j){return typeof k=="string"&&(k===B||k.endsWith(J)||!K&&(k===D||k.endsWith(q)))?M:null}:function(k,j){return typeof k=="string"&&(k===B||!K&&k===D)?M:null};return N.allPaths=[(U?"*/":"./")+D],N}function O(D){try{const M=new RegExp(`^${c(D)}$`);return function(U){return M.lastIndex=0,typeof U=="string"&&M.test(U)?D:null}}catch(M){return n}}function A(D,M,U){return!D||typeof M!="string"?!1:W(D)(M,void 0,U)}t.match=A;function W(D,M={}){if(!D)return i;if(typeof D=="string"||ie(D)){const U=r(D,M);if(U===n)return i;const K=function(B,J){return!!U(B,J)};return U.allBasenames&&(K.allBasenames=U.allBasenames),U.allPaths&&(K.allPaths=U.allPaths),K}return G(D,M)}t.parse=W;function Y(D){if(!D)return;let M;return U=>(M||(M=(D()||Promise.resolve([])).then(K=>K?oe(K):{})),M.then(K=>!!K[U]))}t.hasSiblingPromiseFn=Y;function te(D){if(!D)return;let M;return U=>{if(!M){const K=D();M=K?oe(K):{}}return!!M[U]}}t.hasSiblingFn=te;function oe(D){const M={};for(const U of D)M[U]=!0;return M}function ie(D){const M=D;return M&&typeof M.base=="string"&&typeof M.pattern=="string"}t.isRelativePattern=ie;function ae(D){return D.allBasenames||[]}t.getBasenameTerms=ae;function ue(D){return D.allPaths||[]}t.getPathTerms=ue;function G(D,M){const U=z(Object.getOwnPropertyNames(D).map(N=>ne(N,D[N],M)).filter(N=>N!==n)),K=U.length;if(!K)return n;if(!U.some(N=>!!N.requiresSiblings)){if(K===1)return U[0];const N=function(V,X){for(let Q=0,se=U.length;Q<se;Q++){const re=U[Q](V,X);if(re)return re}return null},k=U.find(V=>!!V.allBasenames);k&&(N.allBasenames=k.allBasenames);const j=U.reduce((V,X)=>X.allPaths?V.concat(X.allPaths):V,[]);return j.length&&(N.allPaths=j),N}const B=function(N,k,j){let V;for(let X=0,Q=U.length;X<Q;X++){const se=U[X];se.requiresSiblings&&j&&(k||(k=I.basename(N)),V||(V=k.substr(0,k.length-I.extname(N).length)));const re=se(N,k,V,j);if(re)return re}return null},J=U.find(N=>!!N.allBasenames);J&&(B.allBasenames=J.allBasenames);const q=U.reduce((N,k)=>k.allPaths?N.concat(k.allPaths):N,[]);return q.length&&(B.allPaths=q),B}function ne(D,M,U){if(M===!1)return n;const K=r(D,U);if(K===n)return n;if(typeof M=="boolean")return K;if(M){const B=M.when;if(typeof B=="string"){const J=(q,N,k,j)=>{if(!j||!K(q,N))return null;const V=B.replace("$(basename)",k),X=j(V);return(0,C.isThenable)(X)?X.then(Q=>Q?D:null):X?D:null};return J.requiresSiblings=!0,J}}return K}function z(D,M){const U=D.filter(N=>!!N.basenames);if(U.length<2)return D;const K=U.reduce((N,k)=>{const j=k.basenames;return j?N.concat(j):N},[]);let B;if(M){B=[];for(let N=0,k=K.length;N<k;N++)B.push(M)}else B=U.reduce((N,k)=>{const j=k.patterns;return j?N.concat(j):N},[]);const J=function(N,k){if(typeof N!="string")return null;if(!k){let V;for(V=N.length;V>0;V--){const X=N.charCodeAt(V-1);if(X===47||X===92)break}k=N.substr(V)}const j=K.indexOf(k);return j!==-1?B[j]:null};J.basenames=K,J.patterns=B,J.allBasenames=K;const q=D.filter(N=>!N.basenames);return q.push(J),q}}),define(Z[64],ee([0,1,38,7,3,10,19,22,8]),function($,t,C,b,w,I,R,T,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function d(r,a,m){if(typeof r=="string"&&(r=l.URI.file(r)),m){const F=m.getWorkspaceFolder(r);if(F){const p=m.getWorkspace().folders.length>1;let O;if((0,R.isEqual)(F.uri,r)?O="":O=(0,R.relativePath)(F.uri,r),p){const A=F.name?F.name:(0,R.basename)(F.uri);O=O?A+" \u2022 "+O:A}return O}}if(r.scheme!==b.Schemas.file&&r.scheme!==b.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,C.hasDriveLetter)(r.fsPath))return(0,w.normalize)(L(r.fsPath));let P=(0,w.normalize)(r.fsPath);return!I.isWindows&&a?.userHome&&(P=S(P,a.userHome.fsPath)),P}t.getPathLabel=d;function E(r){if(!r)return;typeof r=="string"&&(r=l.URI.file(r));const a=(0,R.basename)(r)||(r.scheme===b.Schemas.file?r.fsPath:r.path);return I.isWindows&&(0,C.isRootOrDriveLetter)(a)?L(a):a}t.getBaseLabel=E;function L(r){return(0,C.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}t.normalizeDriveLetter=L;let g=Object.create(null);function S(r,a){if(I.isWindows||!r||!a)return r;let m=g.original===a?g.normalized:void 0;return m||(m=`${(0,T.rtrim)(a,w.posix.sep)}${w.posix.sep}`,g={original:a,normalized:m}),(I.isLinux?r.startsWith(m):(0,T.startsWithIgnoreCase)(r,m))&&(r=`~/${r.substr(m.length)}`),r}t.tildify=S;function u(r,a){return r.replace(/^~($|\/|\\)/,`${a}$1`)}t.untildify=u;const c="\u2026",v="\\\\",y="~";function f(r,a=w.sep){const m=new Array(r.length);let P=!1;for(let F=0;F<r.length;F++){let p=r[F];if(p===""){m[F]=`.${a}`;continue}if(!p){m[F]=p;continue}P=!0;let O="";p.indexOf(v)===0?(O=p.substr(0,p.indexOf(v)+v.length),p=p.substr(p.indexOf(v)+v.length)):p.indexOf(a)===0?(O=p.substr(0,p.indexOf(a)+a.length),p=p.substr(p.indexOf(a)+a.length)):p.indexOf(y)===0&&(O=p.substr(0,p.indexOf(y)+y.length),p=p.substr(p.indexOf(y)+y.length));const A=p.split(a);for(let W=1;P&&W<=A.length;W++)for(let Y=A.length-W;P&&Y>=0;Y--){P=!1;let te=A.slice(Y,Y+W).join(a);for(let oe=0;!P&&oe<r.length;oe++)if(oe!==F&&r[oe]&&r[oe].indexOf(te)>-1){const ie=Y+W===A.length,ae=Y>0&&r[oe].indexOf(a)>-1?a+te:te,ue=r[oe].endsWith(ae);P=!ie||ue}if(!P){let oe="";(A[0].endsWith(":")||O!=="")&&(Y===1&&(Y=0,W++,te=A[0]+a+te),Y>0&&(oe=A[0]+a),oe=O+oe),Y>0&&(oe=oe+c+a),oe=oe+te,Y+W<A.length&&(oe=oe+a+c),m[F]=oe}}P&&(m[F]=p)}return m}t.shorten=f;var h;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function o(r,a=Object.create(null)){const m=[];let P=!1,F="";for(const p of r)if(p==="$"||P&&p==="{")F&&m.push({value:F,type:h.TEXT}),F="",P=!0;else if(p==="}"&&P){const O=a[F];if(typeof O=="string")O.length&&m.push({value:O,type:h.VARIABLE});else if(O){const A=m[m.length-1];(!A||A.type!==h.SEPARATOR)&&m.push({value:O.label,type:h.SEPARATOR})}F="",P=!1}else F+=p;return F&&!P&&m.push({value:F,type:h.TEXT}),m.filter((p,O)=>{if(p.type===h.SEPARATOR){const A=m[O-1],W=m[O+1];return[A,W].every(Y=>Y&&(Y.type===h.VARIABLE||Y.type===h.TEXT)&&Y.value.length>0)}return!0}).map(p=>p.value).join("")}t.template=o;function s(r,a){return I.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):r.replace(/&&|&/g,m=>m==="&"?"&&":"&")}t.mnemonicMenuLabel=s;function e(r,a){return I.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,""):I.isWindows?r.replace(/&&|&/g,m=>m==="&"?"&&":"&"):r.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(r){return r.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(r){const a=r.indexOf("/")!==-1?w.posix:w.win32,m=a.basename(r),P=a.dirname(r);return m.length?{name:m,parentPath:P}:{name:P,parentPath:""}}t.splitName=n}),define(Z[47],ee([0,1,128]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class b{constructor(I="utf8"){this.stringDecoder=new C.StringDecoder(I),this.remaining=null}write(I){const R=[],T=this.remaining?this.remaining+this.stringDecoder.write(I):this.stringDecoder.write(I);if(T.length<1)return R;let l=0,d,E=l;for(;E<T.length;)if(d=T.charCodeAt(E),d===13||d===10){if(R.push(T.substring(l,E)),E++,E<T.length){const L=d;d=T.charCodeAt(E),(L===13&&d===10||L===10&&d===13)&&E++}l=E}else E++;return this.remaining=l<T.length?T.substr(l):null,R}end(){return this.remaining}}t.LineDecoder=b}),define(Z[65],ee([0,1,48,3,22,12]),function($,t,C,b,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function R(E){const L=(0,b.dirname)(E);if(E===L)return E;const g=((0,b.basename)(E)||E).toLowerCase();try{const u=(0,I.readdirSync)(L).filter(c=>c.toLowerCase()===g);if(u.length===1){const c=R(L);if(c)return(0,b.join)(c,u[0])}else if(u.length>1){const c=u.indexOf(g);if(c>=0){const v=R(L);if(v)return(0,b.join)(v,u[c])}}}catch(S){}return null}t.realcaseSync=R;async function T(E){try{return await I.Promises.realpath(E)}catch(L){const g=d(E);return await I.Promises.access(g,C.constants.R_OK),g}}t.realpath=T;function l(E){try{return C.realpathSync(E)}catch(L){const g=d(E);return C.accessSync(g,C.constants.R_OK),g}}t.realpathSync=l;function d(E){return(0,w.rtrim)((0,b.normalize)(E),b.sep)}}),define(Z[66],ee([0,1,34,3,12]),function($,t,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const I=/^\d+$/,R=/^Microsoft.PowerShell_.*/,T=/^Microsoft.PowerShellPreview_.*/;var l;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(l||(l={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let E;process.env.PROCESSOR_ARCHITEW6432?E=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?E=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?E=1:E=0;class L{constructor(s,e,i){this.exePath=s,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await w.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:o=!1}={}){return o?d===0?process.env["ProgramFiles(x86)"]||null:E===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:o=!1,findPreview:s=!1}={}){const e=g({useAlternateBitness:o});if(!e)return null;const i=b.join(e,"PowerShell");if(!await w.SymlinkSupport.existsDirectory(i))return null;let n=-1,r=null;for(const P of await w.Promises.readdir(i)){let F=-1;if(s){const O=P.indexOf("-");if(O<0)continue;const A=P.substring(0,O);if(!I.test(A)||P.substring(O+1)!=="preview")continue;F=parseInt(A,10)}else{if(!I.test(P))continue;F=parseInt(P,10)}if(F<=n)continue;const p=b.join(i,P,"pwsh.exe");!await w.SymlinkSupport.existsFile(p)||(r=p,n=F)}if(!r)return null;const a=e.includes("x86")?" (x86)":"",m=s?" Preview":"";return new L(r,`PowerShell${m}${a}`,!0)}async function u({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const s=b.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await w.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=o?{pwshMsixDirRegex:T,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const n of await w.Promises.readdir(s))if(e.test(n)){const r=b.join(s,n,"pwsh.exe");return new L(r,i)}return null}function c(){const o=b.join(C.homedir(),".dotnet","tools","pwsh.exe");return new L(o,".NET Core PowerShell Global Tool")}function v(){const o=b.join(process.env.windir,d===1&&E!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new L(o,"Windows PowerShell",!0)}async function*y(){let o=await S();o&&(yield o),o=await S({useAlternateBitness:!0}),o&&(yield o),o=await u(),o&&(yield o),o=c(),o&&(yield o),o=await S({findPreview:!0}),o&&(yield o),o=await u({findPreview:!0}),o&&(yield o),o=await S({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=v(),o&&(yield o)}async function*f(){for await(const o of y())await o.exists()&&(yield o)}t.enumeratePowerShellInstallations=f;async function h(){for await(const o of f())return o;return null}t.getFirstAvailablePowerShellInstallation=h});var de=this&&this.__decorate||function($,t,C,b){var w=arguments.length,I=w<3?t:b===null?b=Object.getOwnPropertyDescriptor(t,C):b,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate($,t,C,b);else for(var T=$.length-1;T>=0;T--)(R=$[T])&&(I=(w<3?R(I):w>3?R(t,C,I):R(t,C))||I);return w>3&&I&&Object.defineProperty(t,C,I),I};define(Z[39],ee([0,1,20,6,17,25,45,9,13,2,62,22,11]),function($,t,C,b,w,I,R,T,l,d,E,L,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var S;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(S=t.RequestType||(t.RequestType={}));function u(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(c=t.ResponseType||(t.ResponseType={}));function v(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var y;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(y||(y={}));class f{constructor(D){this.buffer=D,this.pos=0}read(D){const M=this.buffer.slice(this.pos,this.pos+D);return this.pos+=M.byteLength,M}}class h{constructor(){this.buffers=[]}get buffer(){return w.VSBuffer.concat(this.buffers)}write(D){this.buffers.push(D)}}var o;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object"})(o||(o={}));function s(z){const D=w.VSBuffer.alloc(4);return D.writeUInt32BE(z,0),D}function e(z){return z.read(4).readUInt32BE(0)}function i(z){const D=w.VSBuffer.alloc(1);return D.writeUInt8(z,0),D}const n={Undefined:i(o.Undefined),String:i(o.String),Buffer:i(o.Buffer),VSBuffer:i(o.VSBuffer),Array:i(o.Array),Object:i(o.Object)},r=typeof Buffer!="undefined";function a(z,D){if(typeof D=="undefined")z.write(n.Undefined);else if(typeof D=="string"){const M=w.VSBuffer.fromString(D);z.write(n.String),z.write(s(M.byteLength)),z.write(M)}else if(r&&Buffer.isBuffer(D)){const M=w.VSBuffer.wrap(D);z.write(n.Buffer),z.write(s(M.byteLength)),z.write(M)}else if(D instanceof w.VSBuffer)z.write(n.VSBuffer),z.write(s(D.byteLength)),z.write(D);else if(Array.isArray(D)){z.write(n.Array),z.write(s(D.length));for(const M of D)a(z,M)}else{const M=w.VSBuffer.fromString(JSON.stringify(D));z.write(n.Object),z.write(s(M.byteLength)),z.write(M)}}function m(z){switch(z.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return z.read(e(z)).toString();case o.Buffer:return z.read(e(z)).buffer;case o.VSBuffer:return z.read(e(z));case o.Array:{const M=e(z),U=[];for(let K=0;K<M;K++)U.push(m(z));return U}case o.Object:return JSON.parse(z.read(e(z)).toString())}}class P{constructor(D,M,U=null,K=1e3){this.protocol=D,this.ctx=M,this.logger=U,this.timeoutDelay=K,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(D,M){this.channels.set(D,M),setTimeout(()=>this.flushPendingRequests(D),0)}sendResponse(D){switch(D.type){case 200:{const M=this.send([D.type]);this.logger&&this.logger.logOutgoing(M,0,1,v(D.type));return}case 201:case 202:case 204:case 203:{const M=this.send([D.type,D.id],D.data);this.logger&&this.logger.logOutgoing(M,D.id,1,v(D.type),D.data);return}}}send(D,M=void 0){const U=new h;return a(U,D),a(U,M),this.sendBuffer(U.buffer)}sendBuffer(D){try{return this.protocol.send(D),D.byteLength}catch(M){return 0}}onRawMessage(D){const M=new f(D),U=m(M),K=m(M),B=U[0];switch(B){case 100:return this.logger&&this.logger.logIncoming(D.byteLength,U[1],1,`${u(B)}: ${U[2]}.${U[3]}`,K),this.onPromise({type:B,id:U[1],channelName:U[2],name:U[3],arg:K});case 102:return this.logger&&this.logger.logIncoming(D.byteLength,U[1],1,`${u(B)}: ${U[2]}.${U[3]}`,K),this.onEventListen({type:B,id:U[1],channelName:U[2],name:U[3],arg:K});case 101:return this.logger&&this.logger.logIncoming(D.byteLength,U[1],1,`${u(B)}`),this.disposeActiveRequest({type:B,id:U[1]});case 103:return this.logger&&this.logger.logIncoming(D.byteLength,U[1],1,`${u(B)}`),this.disposeActiveRequest({type:B,id:U[1]})}}onPromise(D){const M=this.channels.get(D.channelName);if(!M){this.collectPendingRequest(D);return}const U=new I.CancellationTokenSource;let K;try{K=M.call(this.ctx,D.name,D.arg,U.token)}catch(q){K=Promise.reject(q)}const B=D.id;K.then(q=>{this.sendResponse({id:B,data:q,type:201}),this.activeRequests.delete(D.id)},q=>{q instanceof Error?this.sendResponse({id:B,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.sendResponse({id:B,data:q,type:203}),this.activeRequests.delete(D.id)});const J=(0,d.toDisposable)(()=>U.cancel());this.activeRequests.set(D.id,J)}onEventListen(D){const M=this.channels.get(D.channelName);if(!M){this.collectPendingRequest(D);return}const U=D.id,B=M.listen(this.ctx,D.name,D.arg)(J=>this.sendResponse({id:U,data:J,type:204}));this.activeRequests.set(D.id,B)}disposeActiveRequest(D){const M=this.activeRequests.get(D.id);M&&(M.dispose(),this.activeRequests.delete(D.id))}collectPendingRequest(D){let M=this.pendingRequests.get(D.channelName);M||(M=[],this.pendingRequests.set(D.channelName,M));const U=setTimeout(()=>{console.error(`Unknown channel: ${D.channelName}`),D.type===100&&this.sendResponse({id:D.id,data:{name:"Unknown channel",message:`Channel name '${D.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);M.push({request:D,timeoutTimer:U})}flushPendingRequests(D){const M=this.pendingRequests.get(D);if(M){for(const U of M)switch(clearTimeout(U.timeoutTimer),U.request.type){case 100:this.onPromise(U.request);break;case 102:this.onEventListen(U.request);break}this.pendingRequests.delete(D)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(D=>D.dispose()),this.activeRequests.clear()}}t.ChannelServer=P;var F;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(F=t.RequestInitiator||(t.RequestInitiator={}));class p{constructor(D,M=null){this.protocol=D,this.isDisposed=!1,this.state=y.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(U=>this.onBuffer(U)),this.logger=M}getChannel(D){const M=this;return{call(U,K,B){return M.isDisposed?Promise.reject(T.canceled()):M.requestPromise(D,U,K,B)},listen(U,K){return M.isDisposed?Promise.reject(T.canceled()):M.requestEvent(D,U,K)}}}requestPromise(D,M,U,K=I.CancellationToken.None){const B=this.lastRequestId++,q={id:B,type:100,channelName:D,name:M,arg:U};if(K.isCancellationRequested)return Promise.reject(T.canceled());let N;return new Promise((j,V)=>{if(K.isCancellationRequested)return V(T.canceled());const X=()=>{const me=ye=>{switch(ye.type){case 201:this.handlers.delete(B),j(ye.data);break;case 202:this.handlers.delete(B);const fe=new Error(ye.data.message);fe.stack=ye.data.stack,fe.name=ye.data.name,V(fe);break;case 203:this.handlers.delete(B),V(ye.data);break}};this.handlers.set(B,me),this.sendRequest(q)};let Q=null;this.state===y.Idle?X():(Q=(0,b.createCancelablePromise)(me=>this.whenInitialized()),Q.then(()=>{Q=null,X()}));const se=()=>{Q?(Q.cancel(),Q=null):this.sendRequest({id:B,type:101}),V(T.canceled())},re=K.onCancellationRequested(se);N=(0,d.combinedDisposable)((0,d.toDisposable)(se),re),this.activeRequests.add(N)}).finally(()=>{this.activeRequests.delete(N)})}requestEvent(D,M,U){const K=this.lastRequestId++,J={id:K,type:102,channelName:D,name:M,arg:U};let q=null;const N=new l.Emitter({onFirstListenerAdd:()=>{q=(0,b.createCancelablePromise)(j=>this.whenInitialized()),q.then(()=>{q=null,this.activeRequests.add(N),this.sendRequest(J)})},onLastListenerRemove:()=>{q?(q.cancel(),q=null):(this.activeRequests.delete(N),this.sendRequest({id:K,type:103}))}}),k=j=>N.fire(j.data);return this.handlers.set(K,k),N.event}sendRequest(D){switch(D.type){case 100:case 102:{const M=this.send([D.type,D.id,D.channelName,D.name],D.arg);this.logger&&this.logger.logOutgoing(M,D.id,0,`${u(D.type)}: ${D.channelName}.${D.name}`,D.arg);return}case 101:case 103:{const M=this.send([D.type,D.id]);this.logger&&this.logger.logOutgoing(M,D.id,0,u(D.type));return}}}send(D,M=void 0){const U=new h;return a(U,D),a(U,M),this.sendBuffer(U.buffer)}sendBuffer(D){try{return this.protocol.send(D),D.byteLength}catch(M){return 0}}onBuffer(D){const M=new f(D),U=m(M),K=m(M),B=U[0];switch(B){case 200:return this.logger&&this.logger.logIncoming(D.byteLength,0,0,v(B)),this.onResponse({type:U[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(D.byteLength,U[1],0,v(B),K),this.onResponse({type:U[0],id:U[1],data:K})}}onResponse(D){if(D.type===200){this.state=y.Idle,this._onDidInitialize.fire();return}const M=this.handlers.get(D.id);M&&M(D)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===y.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(D=>D.dispose()),this.activeRequests.clear()}}de([R.memoize],p.prototype,"onDidInitializePromise",null),t.ChannelClient=p;class O{constructor(D){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,D(({protocol:M,onDidClientDisconnect:U})=>{l.Event.once(M.onMessage)(B=>{const J=new f(B),q=m(J),N=new P(M,q),k=new p(M);this.channels.forEach((V,X)=>N.registerChannel(X,V));const j={channelServer:N,channelClient:k,ctx:q};this._connections.add(j),this._onDidAddConnection.fire(j),U(()=>{N.dispose(),k.dispose(),this._connections.delete(j),this._onDidRemoveConnection.fire(j)})})})}get connections(){const D=[];return this._connections.forEach(M=>D.push(M)),D}getChannel(D,M){const U=this;return{call(K,B,J){let q;if((0,g.isFunction)(M)){let k=(0,C.getRandomElement)(U.connections.filter(M));q=k?Promise.resolve(k):l.Event.toPromise(l.Event.filter(U.onDidAddConnection,M))}else q=M.routeCall(U,K,B);const N=q.then(k=>k.channelClient.getChannel(D));return W(N).call(K,B,J)},listen(K,B){if((0,g.isFunction)(M))return U.getMulticastEvent(D,M,K,B);const J=M.routeEvent(U,K,B).then(q=>q.channelClient.getChannel(D));return W(J).listen(K,B)}}}getMulticastEvent(D,M,U,K){const B=this;let J=new d.DisposableStore;const q=new l.Emitter({onFirstListenerAdd:()=>{J=new d.DisposableStore;const N=new l.EventMultiplexer,k=new Map,j=X=>{const se=X.channelClient.getChannel(D).listen(U,K),re=N.add(se);k.set(X,re)},V=X=>{const Q=k.get(X);!Q||(Q.dispose(),k.delete(X))};B.connections.filter(M).forEach(j),l.Event.filter(B.onDidAddConnection,M)(j,void 0,J),B.onDidRemoveConnection(V,void 0,J),N.event(q.fire,q,J),J.add(N)},onLastListenerRemove:()=>{J.dispose()}});return q.event}registerChannel(D,M){this.channels.set(D,M),this._connections.forEach(U=>{U.channelServer.registerChannel(D,M)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=O;class A{constructor(D,M,U=null){const K=new h;a(K,M),D.send(K.buffer),this.channelClient=new p(D,U),this.channelServer=new P(D,M,U)}getChannel(D){return this.channelClient.getChannel(D)}registerChannel(D,M){this.channelServer.registerChannel(D,M)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=A;function W(z){return{call(D,M,U){return z.then(K=>K.call(D,M,U))},listen(D,M){const U=new l.Relay;return z.then(K=>U.input=K.listen(D,M)),U.event}}}t.getDelayedChannel=W;function Y(z){let D=!1;return{call(M,U,K){return D?z.call(M,U,K):(0,b.timeout)(0).then(()=>D=!0).then(()=>z.call(M,U,K))},listen(M,U){if(D)return z.listen(M,U);const K=new l.Relay;return(0,b.timeout)(0).then(()=>D=!0).then(()=>K.input=z.listen(M,U)),K.event}}}t.getNextTickChannel=Y;class te{constructor(D){this.fn=D}routeCall(D){return this.route(D)}routeEvent(D){return this.route(D)}async route(D){for(const M of D.connections)if(await Promise.resolve(this.fn(M.ctx)))return Promise.resolve(M);return await l.Event.toPromise(D.onDidAddConnection),await this.route(D)}}t.StaticRouter=te;var oe;(function(z){function D(B,J){const q=B,N=J&&J.disableMarshalling,k=new Map;for(const j in q)U(j)&&k.set(j,l.Event.buffer(q[j],!0));return new class{listen(j,V,X){const Q=k.get(V);if(Q)return Q;if(K(V)){const se=q[V];if(typeof se=="function")return se.call(q,X)}throw new Error(`Event not found: ${V}`)}call(j,V,X){const Q=q[V];if(typeof Q=="function"){if(!N&&Array.isArray(X))for(let se=0;se<X.length;se++)X[se]=(0,E.revive)(X[se]);return Q.apply(q,X)}throw new Error(`Method not found: ${V}`)}}}z.fromService=D;function M(B,J){const q=J&&J.disableMarshalling;return new Proxy({},{get(N,k){if(typeof k=="string")return J?.properties?.has(k)?J.properties.get(k):K(k)?function(j){return B.listen(k,j)}:U(k)?B.listen(k):async function(...j){let V;J&&!(0,g.isUndefinedOrNull)(J.context)?V=[J.context,...j]:V=j;const X=await B.call(k,V);return q?X:(0,E.revive)(X)};throw new Error(`Property not found: ${String(k)}`)}})}z.toService=M;function U(B){return B[0]==="o"&&B[1]==="n"&&L.isUpperAsciiLetter(B.charCodeAt(2))}function K(B){return/^onDynamic/.test(B)&&L.isUpperAsciiLetter(B.charCodeAt(9))}})(oe=t.ProxyChannel||(t.ProxyChannel={}));const ie=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ae(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){let D=z.toString();if(D!=="[object Object]")return D}return z}function ue(z){return Array.isArray(z)?z.map(ae):ae(z)}function G(z,D,M,U,K,B,J){J=ue(J);const q=ie[K],N=q[U%q.length];let k=[`%c[${z}]%c[${String(D).padStart(7," ")}]%c[len: ${String(M).padStart(5," ")}]%c${String(U).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${N}`];/\($/.test(B)?(k=k.concat(J),k.push(")")):k.push(J),console.log.apply(console,k)}t.logWithColors=G;class ne{constructor(D,M){this._outgoingPrefix=D,this._incomingPrefix=M,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(D,M,U,K,B){this._totalOutgoing+=D,G(this._outgoingPrefix,this._totalOutgoing,D,M,U,K,B)}logIncoming(D,M,U,K,B){this._totalIncoming+=D,G(this._incomingPrefix,this._totalIncoming,D,M,U,K,B)}}t.IPCLogger=ne}),define(Z[67],ee([0,1,6,13,2,11]),function($,t,C,b,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var R;(function(L){L[L.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(R=t.StorageHint||(t.StorageHint={}));function T(L){const g=L;return g?.changed instanceof Map||g?.deleted instanceof Set}t.isStorageItemsChangeEvent=T;var l;(function(L){L[L.None=0]="None",L[L.Initialized=1]="Initialized",L[L.Closed=2]="Closed"})(l||(l={}));class d extends w.Disposable{constructor(g,S=Object.create(null)){super();this.database=g,this.options=S,this._onDidChangeStorage=this._register(new b.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new C.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){g.changed?.forEach((S,u)=>this.accept(u,S)),g.deleted?.forEach(S=>this.accept(S,void 0))}accept(g,S){if(this.state===l.Closed)return;let u=!1;(0,I.isUndefinedOrNull)(S)?u=this.cache.delete(g):this.cache.get(g)!==S&&(this.cache.set(g,S),u=!0),u&&this._onDidChangeStorage.fire(g)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,S){const u=this.cache.get(g);return(0,I.isUndefinedOrNull)(u)?S:u}getBoolean(g,S){const u=this.get(g);return(0,I.isUndefinedOrNull)(u)?S:u==="true"}getNumber(g,S){const u=this.get(g);return(0,I.isUndefinedOrNull)(u)?S:parseInt(u,10)}async set(g,S){if(this.state===l.Closed)return;if((0,I.isUndefinedOrNull)(S))return this.delete(g);const u=String(S);if(this.cache.get(g)!==u)return this.cache.set(g,u),this.pendingInserts.set(g,u),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async delete(g){if(!(this.state===l.Closed||!this.cache.delete(g)))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(g){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=d,d.DEFAULT_FLUSH_DELAY=100;class E{constructor(){this.onDidChangeItemsExternal=b.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((S,u)=>this.items.set(u,S)),g.delete&&g.delete.forEach(S=>this.items.delete(S))}async close(){}}t.InMemoryStorageDatabase=E}),define(Z[68],ee([4,5]),function($,t){return $.create("vs/base/common/date",t)}),define(Z[69],ee([0,1,68]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const b=60,w=b*60,I=w*24,R=I*7,T=I*30,l=I*365;function d(L,g){typeof L!="number"&&(L=L.getTime());const S=Math.round((new Date().getTime()-L)/1e3);if(S<-30)return(0,C.localize)(0,null,d(new Date().getTime()+S*1e3,!1));if(S<30)return(0,C.localize)(1,null);let u;return S<b?(u=S,g?u===1?(0,C.localize)(2,null,u):(0,C.localize)(3,null,u):u===1?(0,C.localize)(4,null,u):(0,C.localize)(5,null,u)):S<w?(u=Math.floor(S/b),g?u===1?(0,C.localize)(6,null,u):(0,C.localize)(7,null,u):u===1?(0,C.localize)(8,null,u):(0,C.localize)(9,null,u)):S<I?(u=Math.floor(S/w),g?u===1?(0,C.localize)(10,null,u):(0,C.localize)(11,null,u):u===1?(0,C.localize)(12,null,u):(0,C.localize)(13,null,u)):S<R?(u=Math.floor(S/I),g?u===1?(0,C.localize)(14,null,u):(0,C.localize)(15,null,u):u===1?(0,C.localize)(16,null,u):(0,C.localize)(17,null,u)):S<T?(u=Math.floor(S/R),g?u===1?(0,C.localize)(18,null,u):(0,C.localize)(19,null,u):u===1?(0,C.localize)(20,null,u):(0,C.localize)(21,null,u)):S<l?(u=Math.floor(S/T),g?u===1?(0,C.localize)(22,null,u):(0,C.localize)(23,null,u):u===1?(0,C.localize)(24,null,u):(0,C.localize)(25,null,u)):(u=Math.floor(S/l),g?u===1?(0,C.localize)(26,null,u):(0,C.localize)(27,null,u):u===1?(0,C.localize)(28,null,u):(0,C.localize)(29,null,u))}t.fromNow=d;function E(L){return L.getFullYear()+"-"+String(L.getMonth()+1).padStart(2,"0")+"-"+String(L.getDate()).padStart(2,"0")+"T"+String(L.getHours()).padStart(2,"0")+":"+String(L.getMinutes()).padStart(2,"0")+":"+String(L.getSeconds()).padStart(2,"0")+"."+(L.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=E}),define(Z[70],ee([4,5]),function($,t){return $.create("vs/base/common/errorMessage",t)}),define(Z[30],ee([0,1,20,11,70]),function($,t,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function I(d,E){return E&&(d.stack||d.stacktrace)?w.localize(0,null,T(d),R(d.stack)||R(d.stacktrace)):T(d)}function R(d){return Array.isArray(d)?d.join(`
`):d}function T(d){return typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?w.localize(1,null,d.message):d.message||w.localize(2,null)}function l(d=null,E=!1){if(!d)return w.localize(3,null);if(Array.isArray(d)){const L=C.coalesce(d),g=l(L[0],E);return L.length>1?w.localize(4,null,g,L.length):g}if(b.isString(d))return d;if(d.detail){const L=d.detail;if(L.error)return I(L.error,E);if(L.exception)return I(L.exception,E)}return d.stack?I(d,E):d.message?d.message:w.localize(5,null)}t.toErrorMessage=l}),define(Z[71],ee([4,5]),function($,t){return $.create("vs/base/node/processes",t)}),define(Z[49],ee([0,1,35,38,7,18,3,10,28,60,11,47,12,71]),function($,t,C,b,w,I,R,T,l,d,E,L,g,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0,Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return d.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return d.TerminateResponseCode}});function u(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(s,e){if(T.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};e&&(i.cwd=e);const n=C.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],i);return new Promise(r=>{n.once("error",a=>{r({success:!1,error:a})}),n.once("exit",(a,m)=>{r(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?u(i.status):1})}else if(T.isLinux||T.isMacintosh)try{const i=w.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",$).fsPath;return new Promise(n=>{C.execFile(i,[s.pid.toString()],{encoding:"utf8",shell:!0},(r,a,m)=>{n(r?{success:!1,error:r}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function v(s=l.env){return s.comspec||"cmd.exe"}t.getWindowsShell=v;class y{constructor(e,i,n,r){if(i!==void 0&&n!==void 0&&r!==void 0)this.cmd=e,this.args=i,this.shell=n,this.options=r;else{const a=e;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(l.env).forEach(m=>{a[m]=l.env[m]}),Object.keys(this.options.env).forEach(m=>{a[m]=this.options.env[m]}),this.options.env=a}}getSanitizedCommand(){let e=this.cmd.toLowerCase();const i=e.lastIndexOf(R.sep);return i!==-1&&(e=e.substring(i+1)),y.WellKnowCommands[e]?e:"other"}start(e){return T.isWindows&&(this.options&&this.options.cwd&&b.isUNC(this.options.cwd)||!this.options&&b.isUNC(l.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(i=>{let n,r;const a=new Promise((m,P)=>{n=m,r=P});if(i){let m=this.cmd;this.args&&(m=m+" "+this.args.join(" ")),this.childProcess=C.exec(m,this.options,(P,F,p)=>{this.childProcess=null;const O=P;O&&O.killed?r({killed:this.terminateRequested,stdout:F.toString(),stderr:p.toString()}):this.handleExec(n,e,P,F,p)})}else{let m=null;const P=F=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(F,n,e,r);const p={terminated:this.terminateRequested};E.isNumber(F)&&(p.cmdCode=F),n(p)};if(this.shell&&T.isWindows){const F=I.deepClone(this.options);F.windowsVerbatimArguments=!0,F.detached=!1;let p=!1,O=!1;const A=[];let W=this.ensureQuotes(this.cmd);A.push(W.value),p=W.quoted,this.args&&this.args.forEach(te=>{W=this.ensureQuotes(te),A.push(W.value),O=O&&W.quoted});const Y=["/s","/c"];p?O?Y.push('"'+A.join(" ")+'"'):A.length>1?Y.push('"'+A[0]+'" '+A.slice(1).join(" ")):Y.push('"'+A[0]+'"'):Y.push(A.join(" ")),m=C.spawn(v(),Y,F)}else this.cmd&&(m=C.spawn(this.cmd,this.args,this.options));m&&(this.childProcess=m,this.childProcessPromise=Promise.resolve(m),this.pidResolve&&(this.pidResolve(E.isNumber(m.pid)?m.pid:-1),this.pidResolve=void 0),m.on("error",F=>{this.childProcess=null,r({terminated:this.terminateRequested,error:F})}),m.pid&&(this.childProcess.on("close",P),this.handleSpawn(m,n,e,r,!0)))}return a})}handleClose(e,i,n,r){}ensureQuotes(e){return y.regexp.test(e)?{value:'"'+e+'"',quoted:!0}:{value:e,quoted:e.length>0&&e[0]==='"'&&e[e.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(e=>e.pid,e=>-1):new Promise(e=>{this.pidResolve=e})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(e=>(this.terminateRequested=!0,c(e,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),e=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(e=>{if(!this.shell||!T.isWindows)return e(!1);const i=C.spawn(v(),["/s","/c"]);i.on("error",n=>e(!0)),i.on("exit",n=>e(!1))})}}t.AbstractProcess=y,y.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},y.regexp=/^[^"].* .*[^"]/;class f extends y{constructor(e,i,n,r){super(e,i,n,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(e,i,n,r,a){[r,a].forEach((m,P)=>{const F=new L.LineDecoder;F.write(m).forEach(A=>{i({line:A,source:P===0?0:1})});const O=F.end();O&&i({line:O,source:P===0?0:1})}),e({terminated:this.terminateRequested,error:n})}handleSpawn(e,i,n,r,a){const m=new L.LineDecoder,P=new L.LineDecoder;e.stdout.on("data",F=>{m.write(F).forEach(O=>n({line:O,source:0}))}),e.stderr.on("data",F=>{P.write(F).forEach(O=>n({line:O,source:1}))}),this.stdoutLineDecoder=m,this.stderrLineDecoder=P}handleClose(e,i,n,r){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&n({line:a,source:0});const m=this.stderrLineDecoder?this.stderrLineDecoder.end():null;m&&n({line:m,source:1})}}t.LineProcess=f;function h(s){let e=[],i=!1;const n=function(r){if(i){e.push(r);return}(!s.send(r,m=>{if(m&&console.error(m),i=!1,e.length>0){const P=e.slice(0);e=[],P.forEach(F=>n(F))}})||T.isWindows)&&(i=!0)};return{send:n}}t.createQueuedSender=h;var o;(function(s){async function e(i,n,r){if(R.isAbsolute(i))return i;if(n===void 0&&(n=l.cwd()),R.dirname(i)!=="."||(r===void 0&&E.isString(l.env.PATH)&&(r=l.env.PATH.split(R.delimiter)),r===void 0||r.length===0))return R.join(n,i);async function m(P){if(await g.Promises.exists(P)){let F;try{F=await g.Promises.stat(P)}catch(p){p.message.startsWith("EACCES")&&(F=await g.Promises.lstat(P))}return F?!F.isDirectory():!1}return!1}for(let P of r){let F;if(R.isAbsolute(P)?F=R.join(P,i):F=R.join(n,P,i),await m(F))return F;let p=F+".com";if(await m(p)||(p=F+".exe",await m(p)))return p}return R.join(n,i)}s.findExecutable=e})(o=t.win32||(t.win32={}))}),define(Z[72],ee([0,1,34,10,66,49]),function($,t,C,b,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function R(S,u){return S===1?b.isWindows?L():I.getWindowsShell(u):d(S,u)}t.getSystemShell=R;function T(S,u){return S===1?b.isWindows?g(u):I.getWindowsShell(u):d(S,u)}t.getSystemShellSync=T;let l=null;function d(S,u){if(b.isLinux&&S===2||b.isMacintosh&&S===3)return"/bin/bash";if(!l){let c;if(b.isWindows)c="/bin/bash";else{if(c=u.SHELL,!c)try{c=(0,C.userInfo)().shell}catch(v){}c||(c="sh"),c==="/bin/false"&&(c="/bin/bash")}l=c}return l}let E=null;async function L(){return E||(E=(await(0,w.getFirstAvailablePowerShellInstallation)()).exePath),E}function g(S){if(E)return E;const u=b.isWindows&&parseFloat((0,C.release)())>=10,c=S.hasOwnProperty("PROCESSOR_ARCHITEW6432"),v=`${S.windir}\\${c?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?v:I.getWindowsShell(S)}}),define(Z[50],ee([0,1,35,6,17,25,61,9,13,2,18,10,49,39]),function($,t,C,b,w,I,R,T,l,d,E,L,g,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class u extends S.ChannelServer{constructor(y){super({send:f=>{try{process.send&&process.send(f.buffer.toString("base64"))}catch(h){}},onMessage:l.Event.fromNodeEventEmitter(process,"message",f=>w.VSBuffer.wrap(Buffer.from(f,"base64")))},y);process.once("disconnect",()=>this.dispose())}}t.Server=u;class c{constructor(y,f){this.modulePath=y,this.options=f,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=f&&f.timeout?f.timeout:6e4;this.disposeDelayer=new b.Delayer(h),this.child=null,this._client=null}getChannel(y){const f=this;return{call(h,o,s){return f.requestPromise(y,h,o,s)},listen(h,o){return f.requestEvent(y,h,o)}}}requestPromise(y,f,h,o=I.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(T.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(y),e=(0,b.createCancelablePromise)(r=>s.call(f,h,r)),i=o.onCancellationRequested(()=>e.cancel()),n=(0,d.toDisposable)(()=>e.cancel());return this.activeRequests.add(n),e.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(y,f,h){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let o;const s=new l.Emitter({onFirstListenerAdd:()=>{o=this.getCachedChannel(y).listen(f,h)(s.fire,s),this.activeRequests.add(o)},onLastListenerRemove:()=>{this.activeRequests.delete(o),o.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const y=this.options&&this.options.args?this.options.args:[],f=Object.create(null);f.env={...(0,E.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(f.env={...f.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(f.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a))),L.isMacintosh&&f.env&&delete f.env.DYLD_LIBRARY_PATH,this.child=(0,C.fork)(this.modulePath,y,f);const h=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",a=>a)(a=>{if((0,R.isRemoteConsoleLog)(a)){(0,R.log)(a,`IPC Library: ${this.options.serverName}`);return}h.fire(w.VSBuffer.wrap(Buffer.from(a,"base64")))});const s=this.options.useQueue?(0,g.createQueuedSender)(this.child):this.child,e=a=>this.child&&this.child.connected&&s.send(a.buffer.toString("base64")),i=h.event,n={send:e,onMessage:i};this._client=new S.ChannelClient(n);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",a=>console.warn('IPC "'+this.options.serverName+'" errored with '+a)),this.child.on("exit",(a,m)=>{process.removeListener("exit",r),this.activeRequests.forEach(P=>(0,d.dispose)(P)),this.activeRequests.clear(),a!==0&&m!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+a+" and signal "+m),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:a,signal:m})})}return this._client}getCachedChannel(y){let f=this.channels.get(y);return f||(f=this.client.getChannel(y),this.channels.set(y,f)),f}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=c}),define(Z[73],ee([4,5]),function($,t){return $.create("vs/base/node/zip",t)}),define(Z[74],ee([4,5]),function($,t){return $.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Z[75],ee([4,5]),function($,t){return $.create("vs/platform/environment/node/shellEnv",t)}),define(Z[76],ee([4,5]),function($,t){return $.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(Z[77],ee([4,5]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Z[78],ee([4,5]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Z[79],ee([4,5]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Z[80],ee([4,5]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Z[81],ee([4,5]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Z[82],ee([4,5]),function($,t){return $.create("vs/platform/extensions/common/extensionValidator",t)}),define(Z[83],ee([4,5]),function($,t){return $.create("vs/platform/files/common/fileService",t)}),define(Z[84],ee([4,5]),function($,t){return $.create("vs/platform/files/common/io",t)}),define(Z[85],ee([4,5]),function($,t){return $.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Z[86],ee([4,5]),function($,t){return $.create("vs/platform/request/common/request",t)}),define(Z[87],ee([4,5]),function($,t){return $.create("vs/platform/telemetry/common/telemetryService",t)}),define(Z[88],ee([0,1,69,45,7,3,28,19,8]),function($,t,C,b,w,I,R,T,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parsePtyHostPort=t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class d{constructor(c,v,y){this._args=c,this.paths=v,this.productService=y}get appRoot(){return(0,I.dirname)(w.FileAccess.asFileUri("",$).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,I.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,T.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,T.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const c=(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,I.join)(this.userDataPath,"logs",c)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,I.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,T.joinPath)(l.URI.file((0,I.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return l.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return l.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=R.env.VSCODE_PORTABLE;return c?l.URI.file((0,I.join)(c,"argv.json")):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,T.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,I.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,I.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,I.resolve)(c):(0,I.normalize)((0,I.join)(w.FileAccess.asFileUri("",$).fsPath,"..","extensions"))}get extensionsDownloadPath(){const c=this.args["extensions-download-dir"];return c?(0,I.resolve)(c):(0,I.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,I.resolve)(c);const v=R.env.VSCODE_EXTENSIONS;if(v)return v;const y=R.env.VSCODE_PORTABLE;return y?(0,I.join)(y,"extensions"):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(v=>/^[^:/?#]+?:\/\//.test(v)?l.URI.parse(v):l.URI.file((0,I.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?l.URI.parse(c):l.URI.file((0,I.normalize)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,T.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return l.URI.file((0,I.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([b.memoize],d.prototype,"appRoot",null),de([b.memoize],d.prototype,"userHome",null),de([b.memoize],d.prototype,"userDataPath",null),de([b.memoize],d.prototype,"appSettingsHome",null),de([b.memoize],d.prototype,"tmpDir",null),de([b.memoize],d.prototype,"userRoamingDataHome",null),de([b.memoize],d.prototype,"settingsResource",null),de([b.memoize],d.prototype,"userDataSyncHome",null),de([b.memoize],d.prototype,"userDataSyncLogResource",null),de([b.memoize],d.prototype,"sync",null),de([b.memoize],d.prototype,"machineSettingsResource",null),de([b.memoize],d.prototype,"globalStorageHome",null),de([b.memoize],d.prototype,"workspaceStorageHome",null),de([b.memoize],d.prototype,"keybindingsResource",null),de([b.memoize],d.prototype,"keyboardLayoutResource",null),de([b.memoize],d.prototype,"argvResource",null),de([b.memoize],d.prototype,"snippetsHome",null),de([b.memoize],d.prototype,"isExtensionDevelopment",null),de([b.memoize],d.prototype,"untitledWorkspacesHome",null),de([b.memoize],d.prototype,"installSourcePath",null),de([b.memoize],d.prototype,"builtinExtensionsPath",null),de([b.memoize],d.prototype,"extensionsPath",null),de([b.memoize],d.prototype,"extensionDevelopmentLocationURI",null),de([b.memoize],d.prototype,"extensionDevelopmentKind",null),de([b.memoize],d.prototype,"extensionTestsLocationURI",null),de([b.memoize],d.prototype,"debugExtensionHost",null),de([b.memoize],d.prototype,"serviceMachineIdResource",null),de([b.memoize],d.prototype,"telemetryLogResource",null),de([b.memoize],d.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=d;function E(u,c){return S(u["inspect-extensions"],u["inspect-brk-extensions"],5870,c,u.debugId,u.extensionEnvironment)}t.parseExtensionHostPort=E;function L(u,c){return S(u["inspect-search"],u["inspect-brk-search"],5876,c,u.extensionEnvironment)}t.parseSearchPort=L;function g(u,c){return S(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,c,u.extensionEnvironment)}t.parsePtyHostPort=g;function S(u,c,v,y,f,h){const s=Number(c||u)||(y?null:v),e=s?Boolean(!!c):!1;let i;if(h)try{i=JSON.parse(h)}catch{}return{port:s,break:e,debugId:f,env:i}}}),function(){"use strict";function $(t,C,b,w){function I(T){const l=R(T),d=[l];return t.isAbsolute(l)||d.unshift(w),t.resolve(...d)}function R(T){const l=process.env.VSCODE_PORTABLE;if(l)return t.join(l,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return t.join(d,b);const E=T["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const L=process.env.USERPROFILE;if(typeof L!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=t.join(L,"AppData","Roaming")}break;case"darwin":d=t.join(C.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||t.join(C.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(d,b)}return{getUserDataPath:I}}if(typeof define=="function")define(Z[89],ee([0,129,34,7,19,28]),function(t,C,b,w,I,R){const T=I.dirname(w.FileAccess.asFileUri("",t)),l=t.__$__nodeRequire(I.joinPath(T,"package.json").fsPath);return $(C,b,l.name,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),C=require("path"),b=require("os");module.exports=$(C,b,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[90],ee([0,1,34,88,89]),function($,t,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class I extends b.AbstractNativeEnvironmentService{constructor(T,l){super(T,{homeDir:(0,C.homedir)(),tmpDir:(0,C.tmpdir)(),userDataDir:(0,w.getUserDataPath)(T)},l)}}t.NativeEnvironmentService=I}),define(Z[91],ee([0,1,18]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const b=/^%([\w\d.-]+)%$/i;function w(I,R){const T=l=>{if(typeof l!="string")return;const d=b.exec(l);if(!d)return;const E=R[d[1]]??l;return typeof E=="string"?E:typeof E.message=="string"?E.message:l};return(0,C.cloneAndChange)(I,T)}t.localizeManifest=w}),define(Z[51],ee([0,1,82]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const b=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function I(g){return g=g.trim(),g==="*"||b.test(g)}t.isValidVersionStr=I;function R(g){if(!I(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let S=g.match(b);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}t.parseVersion=R;function T(g){if(!g)return null;let S=g.majorBase,u=g.majorMustEqual,c=g.minorBase,v=g.minorMustEqual,y=g.patchBase,f=g.patchMustEqual;g.hasCaret&&(S===0||(v=!1),f=!1);let h=0;if(g.preRelease){const o=w.exec(g.preRelease);if(o){const[,s,e,i]=o;h=Date.UTC(Number(s),Number(e)-1,Number(i))}}return{majorBase:S,majorMustEqual:u,minorBase:c,minorMustEqual:v,patchBase:y,patchMustEqual:f,isMinimum:g.hasGreaterEquals,notBefore:h}}t.normalizeVersion=T;function l(g,S,u){let c;typeof g=="string"?c=T(R(g)):c=g;let v;S instanceof Date?v=S.getTime():typeof S=="string"&&(v=new Date(S).getTime());let y;if(typeof u=="string"?y=T(R(u)):y=u,!c||!y)return!1;let f=c.majorBase,h=c.minorBase,o=c.patchBase,s=y.majorBase,e=y.minorBase,i=y.patchBase,n=y.notBefore,r=y.majorMustEqual,a=y.minorMustEqual,m=y.patchMustEqual;return y.isMinimum?f>s?!0:f<s?!1:h>e?!0:h<e||v&&v<n?!1:o>=i:(f===1&&s===0&&(!r||!a||!m)&&(s=1,e=0,i=0,r=!0,a=!1,m=!1),f<s?!1:f>s?!r:h<e?!1:h>e?!a:o<i?!1:o>i?!m:!(v&&v<n))}t.isValidVersion=l;function d(g,S,u,c){return u.isBuiltin||typeof u.main=="undefined"?!0:L(g,S,u.engines.vscode,c)}t.isValidExtensionVersion=d;function E(g,S,u){return g==="*"||L(S,u,g)}t.isEngineValid=E;function L(g,S,u,c=[]){let v=T(R(u));if(!v)return c.push(C.localize(0,null,u)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return c.push(C.localize(1,null,u)),!1}else if(!v.majorMustEqual)return c.push(C.localize(2,null,u)),!1;return l(g,S,v)?!0:(c.push(C.localize(3,null,g,u)),!1)}}),define(Z[92],ee([0,1,2,7,39,50]),function($,t,C,b,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class R extends C.Disposable{constructor(l,d,E,L){super();this.requests=l,this.onDidFilesChange=d,this.onLogMessage=E,this.verboseLogging=L,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const l=this._register(new I.Client(b.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(l.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=R.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=w.ProxyChannel.toService((0,w.getNextTickChannel)(l.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d))),this.watch(this.requests)}setVerboseLogging(l){this.verboseLogging=l,this.isDisposed||this.service?.setVerboseLogging(l)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${l}`})}watch(l){this.requests=l,this.service?.watch(l)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=R,R.MAX_RESTARTS=5}),define(Z[93],ee([0,1,2,7,39,50]),function($,t,C,b,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class R extends C.Disposable{constructor(l,d,E,L,g={}){super();this.folders=l,this.onDidFilesChange=d,this.onLogMessage=E,this.verboseLogging=L,this.watcherOptions=g,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const l=this._register(new I.Client(b.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(l.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=R.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=w.ProxyChannel.toService((0,w.getNextTickChannel)(l.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(d=>!this.isDisposed&&this.onDidFilesChange(d))),this._register(this.service.onDidLogMessage(d=>this.onLogMessage(d))),this.service.watch(this.folders)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${l}`})}setVerboseLogging(l){this.verboseLogging=l,this.service&&this.service.setVerboseLogging(l)}watch(l){this.folders=l,this.service&&this.service.watch(l)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=R,R.MAX_RESTARTS=5}),define(Z[94],ee([0,1,35,63,7,47]),function($,t,C,b,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class R{constructor(l,d,E,L,g){this.watchedFolder=l,this.eventCallback=E,this.logCallback=L,this.verboseLogging=g,this.restartCounter=0,Array.isArray(d)?this.ignored=d.map(S=>(0,b.parse)(S)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${l}, excludes: ${d.join(",")}`),this.startWatcher()}startWatcher(){const l=[this.watchedFolder];this.verboseLogging&&l.push("-verbose"),this.handle=(0,C.spawn)(w.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",$).fsPath,l);const d=new I.LineDecoder;this.handle.stdout.on("data",E=>{const L=[];for(const g of d.write(E)){const S=g.split("|");if(S.length===2){const u=Number(S[0]),c=S[1];if(u>=0&&u<3){if(this.ignored&&this.ignored.some(v=>v(c))){this.verboseLogging&&this.log(c);continue}L.push({type:R.changeTypeMap[u],path:c})}else this.log(S[1])}}L.length>0&&this.eventCallback(L)}),this.handle.on("error",E=>this.onError(E)),this.handle.stderr.on("data",E=>this.onError(E)),this.handle.on("exit",(E,L)=>this.onExit(E,L))}onError(l){this.error("process error: "+l.toString())}onExit(l,d){this.handle&&(this.error(`terminated unexpectedly (code: ${l}, signal: ${d})`),this.restartCounter<=R.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(l){this.logCallback({type:"error",message:`[File Watcher (C#)] ${l}`})}log(l){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${l}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=R,R.MAX_RESTARTS=5,R.changeTypeMap=[0,1,2]}),define(Z[95],ee([0,1,3,22,94]),function($,t,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class I{constructor(T,l,d,E){this.onDidFilesChange=l,this.onLogMessage=d,this.verboseLogging=E,this.service=void 0,this.folder=T[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(C.posix.sep)&&(this.folder.path=(0,b.rtrim)(this.folder.path,C.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new w.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,T=>this.onFileEvents(T),T=>this.onLogMessage(T),this.verboseLogging)}setVerboseLogging(T){this.verboseLogging=T,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(T){this.isDisposed||T.length>0&&this.onDidFilesChange(T)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=I}),define(Z[52],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class C{constructor(w,I=[],R=!1){this.ctor=w,this.staticArguments=I,this.supportsDelayedInstantiation=R}}t.SyncDescriptor=C}),define(Z[96],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class C{constructor(I){this.incoming=new Map,this.outgoing=new Map,this.data=I}}t.Node=C;class b{constructor(I){this._hashFn=I,this._nodes=new Map}roots(){const I=[];for(let R of this._nodes.values())R.outgoing.size===0&&I.push(R);return I}insertEdge(I,R){const T=this.lookupOrInsertNode(I),l=this.lookupOrInsertNode(R);T.outgoing.set(this._hashFn(R),l),l.incoming.set(this._hashFn(I),T)}removeNode(I){const R=this._hashFn(I);this._nodes.delete(R);for(let T of this._nodes.values())T.outgoing.delete(R),T.incoming.delete(R)}lookupOrInsertNode(I){const R=this._hashFn(I);let T=this._nodes.get(R);return T||(T=new C(I),this._nodes.set(R,T)),T}lookup(I){return this._nodes.get(this._hashFn(I))}isEmpty(){return this._nodes.size===0}toString(){let I=[];for(let[R,T]of this._nodes)I.push(`${R}, (incoming)[${[...T.incoming.keys()].join(", ")}], (outgoing)[${[...T.outgoing.keys()].join(",")}]`);return I.join(`
`)}findCycleSlow(){for(let[I,R]of this._nodes){const T=new Set([I]),l=this._findCycle(R,T);if(l)return l}}_findCycle(I,R){for(let[T,l]of I.outgoing){if(R.has(T))return[...R,T].join(" -> ");R.add(T);const d=this._findCycle(l,R);if(d)return d;R.delete(T)}}}t.Graph=b}),define(Z[53],ee([0,1,15]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,C.createDecorator)("downloadService")}),define(Z[21],ee([0,1,15]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,C.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,C.refineServiceDecorator)(t.IEnvironmentService)}),define(Z[23],ee([0,1,7,77,15]),function($,t,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.getFallbackTargetPlarforms=t.isTargetPlatformCompatible=t.isNotWebExtensionInWebTargetPlatform=t.getTargetPlatform=t.toTargetPlatform=t.TargetPlatformToString=t.TargetPlatform=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";var I;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(I=t.TargetPlatform||(t.TargetPlatform={}));function R(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}t.TargetPlatformToString=R;function T(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=T;function l(f,h){switch(f){case 3:return h==="x64"?"win32-x64":h==="ia32"?"win32-ia32":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=l;function d(f,h){return h==="web"&&!f.includes("web")}t.isNotWebExtensionInWebTargetPlatform=d;function E(f,h,o){return d(h,o)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===o?!0:L(o).includes(f)}t.isTargetPlatformCompatible=E;function L(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}t.getFallbackTargetPlarforms=L;function g(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}t.isIExtensionIdentifier=g;var S;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(S=t.SortBy||(t.SortBy={}));var u;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(u=t.SortOrder||(t.SortOrder={}));var c;(function(f){f.Install="install",f.Uninstall="uninstall"})(c=t.StatisticType||(t.StatisticType={}));var v;(function(f){f[f.None=0]="None",f[f.Install=1]="Install",f[f.Update=2]="Update"})(v=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,w.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class y extends Error{constructor(h,o){super(h);this.code=o,this.name=o}}t.ExtensionManagementError=y,t.IExtensionManagementService=(0,w.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,w.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,w.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=C.FileAccess.asBrowserUri("./media/defaultIcon.png",$).toString(!0),t.ExtensionsLabel=(0,b.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,b.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,w.createDecorator)("IExtensionManagementCLIService")}),define(Z[97],ee([0,1,35,3,75,25,30,9,10,31,72,130]),function($,t,C,b,w,I,R,T,l,d,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;const g=1e4;let S;async function u(v,y,f){return y["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,L.isLaunchedFromCli)(f)&&!y["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,L.isLaunchedFromCli)(f)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),S||(S=new Promise(async(h,o)=>{const s=new I.CancellationTokenSource,e=setTimeout(()=>{s.dispose(!0),o((0,w.localize)(0,null))},g);try{h(await c(v,s.token))}catch(i){!(0,T.isPromiseCanceledError)(i)&&!s.token.isCancellationRequested&&o((0,w.localize)(1,null,(0,R.toErrorMessage)(i))),h({})}finally{clearTimeout(e),s.dispose()}})),S)}t.resolveShellEnv=u;async function c(v,y){return new Promise(async(f,h)=>{const o=process.env.ELECTRON_RUN_AS_NODE;v.trace("getUnixShellEnvironment#runAsNode",o);const s=process.env.ELECTRON_NO_ATTACH_CONSOLE;v.trace("getUnixShellEnvironment#noAttach",s);const e=(0,d.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(e+"(.*)"+e),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};v.trace("getUnixShellEnvironment#env",n);const r=await(0,E.getSystemShell)(l.OS,n);if(v.trace("getUnixShellEnvironment#shell",r),y.isCancellationRequested)return h(T.canceled);const a=(0,b.basename)(r);let m,P;/^pwsh(-preview)?$/.test(a)?(m=`& '${process.execPath}' -p '''${e}'' + JSON.stringify(process.env) + ''${e}'''`,P=["-Login","-Command"]):(m=`'${process.execPath}' -p '"${e}" + JSON.stringify(process.env) + "${e}"'`,P=["-ilc"]),v.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),m);const F=(0,C.spawn)(r,[...P,m],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});y.onCancellationRequested(()=>(F.kill(),h(T.canceled))),F.on("error",A=>{v.error("getUnixShellEnvironment#errorChildProcess",(0,R.toErrorMessage)(A)),h(A)});const p=[];F.stdout.on("data",A=>p.push(A));const O=[];F.stderr.on("data",A=>O.push(A)),F.on("close",(A,W)=>{const Y=Buffer.concat(p).toString("utf8");v.trace("getUnixShellEnvironment#raw",Y);const te=Buffer.concat(O).toString("utf8");if(te.trim()&&v.trace("getUnixShellEnvironment#stderr",te),A||W)return h(new Error((0,w.localize)(2,null,A,W)));const oe=i.exec(Y),ie=oe?oe[1]:"{}";try{const ae=JSON.parse(ie);o?ae.ELECTRON_RUN_AS_NODE=o:delete ae.ELECTRON_RUN_AS_NODE,s?ae.ELECTRON_NO_ATTACH_CONSOLE=s:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.XDG_RUNTIME_DIR,v.trace("getUnixShellEnvironment#result",ae),f(ae)}catch(ae){v.error("getUnixShellEnvironment#errorCaught",(0,R.toErrorMessage)(ae)),h(ae)}})})}}),define(Z[54],ee([0,1,10,8,16]),function($,t,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function I(l){return l.map(d=>({type:d.type,resource:b.URI.file(d.path)}))}t.toFileChanges=I;function R(l){const d=new T;for(const E of l)d.processEvent(E);return d.normalize()}t.normalizeFileChanges=R;class T{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(d){return C.isLinux?d.path:d.path.toLowerCase()}processEvent(d){const E=this.mapPathToChange.get(this.toKey(d));let L=!1;if(E){const g=E.type,S=d.type;E.path!==d.path&&(S===1||S===0)?(E.type=2,L=!0):g===1&&S===2?(this.mapPathToChange.delete(this.toKey(d)),this.normalized.delete(E)):g===2&&S===1?E.type=0:g===1&&S===0||(E.type=S)}else L=!0;L&&(this.normalized.add(d),this.mapPathToChange.set(this.toKey(d),d))}normalize(){const d=[],E=[];return Array.from(this.normalized).filter(L=>L.type!==2?(d.push(L),!1):!0).sort((L,g)=>L.path.length-g.path.length).filter(L=>E.some(g=>(0,w.isParent)(L.path,g,!C.isLinux))?!1:(E.push(L.path),!0)).concat(d)}}}),define(Z[98],ee([0,1,6,2,3,65,12,131,54]),function($,t,C,b,w,I,R,T,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class d extends b.Disposable{constructor(L,g,S,u){super();this.path=L,this.onDidFilesChange=g,this.onLogMessage=S,this.verboseLogging=u,this.fileChangesDelayer=this._register(new C.ThrottledDelayer(T.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(L){this.verboseLogging=L}async startWatching(){try{const{stat:L,symbolicLink:g}=await R.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let S=this.path;if(g)try{S=await(0,I.realpath)(S)}catch(u){if(this.onError(u),g.dangling)return}L.isDirectory()?this._register((0,T.watchFolder)(S,(u,c)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,w.join)(this.path,(0,w.basename)(c))})},u=>this.onError(u))):this._register((0,T.watchFile)(S,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(L){L.code!=="ENOENT"&&this.onError(L)}}onFileChange(L){this.fileChangesBuffer.push(L),this.verboseLogging&&this.onVerbose(`${L.type===1?"[ADDED]":L.type===2?"[DELETED]":"[CHANGED]"} ${L.path}`),this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const S=(0,l.normalizeFileChanges)(g);if(this.verboseLogging)for(const u of S)this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);S.length>0&&this.onDidFilesChange(S)})}onError(L){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${L}`})}onVerbose(L){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${L}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=d}),define(Z[55],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class C{constructor(...w){this._entries=new Map;for(let[I,R]of w)this.set(I,R)}set(w,I){const R=this._entries.get(w);return this._entries.set(w,I),R}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}t.ServiceCollection=C}),define(Z[99],ee([0,1,6,9,52,96,15,55]),function($,t,C,b,w,I,R,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const l=!1;class d extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class E{constructor(u=new T.ServiceCollection,c=!1,v){this._activeInstantiations=new Set,this._services=u,this._strict=c,this._parent=v,this._services.set(R.IInstantiationService,this)}createChild(u){return new E(u,this._strict,this)}invokeFunction(u,...c){let v=g.traceInvocation(u),y=!1;try{return u({get:(h,o)=>{if(y)throw(0,b.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(h,v);if(!s&&o!==R.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return s}},...c)}finally{y=!0,v.stop()}}createInstance(u,...c){let v,y;return u instanceof w.SyncDescriptor?(v=g.traceCreation(u.ctor),y=this._createInstance(u.ctor,u.staticArguments.concat(c),v)):(v=g.traceCreation(u),y=this._createInstance(u,c,v)),v.stop(),y}_createInstance(u,c=[],v){let y=R._util.getServiceDependencies(u).sort((o,s)=>o.index-s.index),f=[];for(const o of y){let s=this._getOrCreateServiceInstance(o.id,v);if(!s&&this._strict&&!o.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${o.id}.`);f.push(s)}let h=y.length>0?y[0].index:c.length;if(c.length!==h){console.warn(`[createInstance] First service dependency of ${u.name} at position ${h+1} conflicts with ${c.length} static arguments`);let o=h-c.length;o>0?c=c.concat(new Array(o)):c=c.slice(0,h)}return new u(...[...c,...f])}_setServiceInstance(u,c){if(this._services.get(u)instanceof w.SyncDescriptor)this._services.set(u,c);else if(this._parent)this._parent._setServiceInstance(u,c);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let c=this._services.get(u);return!c&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):c}_getOrCreateServiceInstance(u,c){let v=this._getServiceInstanceOrDescriptor(u);return v instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,v,c.branch(u,!0)):(c.branch(u,!1),v)}_safeCreateAndCacheServiceInstance(u,c,v){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,c,v)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,c,v){const y=new I.Graph(o=>o.id.toString());let f=0;const h=[{id:u,desc:c,_trace:v}];for(;h.length;){const o=h.pop();if(y.lookupOrInsertNode(o),f++>1e3)throw new d(y);for(let s of R._util.getServiceDependencies(o.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(s.id);if(!e&&!s.optional&&console.warn(`[createInstance] ${u} depends on ${s.id} which is NOT registered.`),e instanceof w.SyncDescriptor){const i={id:s.id,desc:e,_trace:o._trace.branch(s.id,!0)};y.insertEdge(o,i),h.push(i)}}}for(;;){const o=y.roots();if(o.length===0){if(!y.isEmpty())throw new d(y);break}for(const{data:s}of o){if(this._getServiceInstanceOrDescriptor(s.id)instanceof w.SyncDescriptor){const i=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,i)}y.removeNode(s)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,c,v=[],y,f){if(this._services.get(u)instanceof w.SyncDescriptor)return this._createServiceInstance(c,v,y,f);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,c,v,y,f);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}_createServiceInstance(u,c=[],v,y){if(v){const f=new C.IdleValue(()=>this._createInstance(u,c,y));return new Proxy(Object.create(null),{get(h,o){if(o in h)return h[o];let s=f.value,e=s[o];return typeof e!="function"||(e=e.bind(s),h[o]=e),e},set(h,o,s){return f.value[o]=s,!0}})}else return this._createInstance(u,c,y)}}t.InstantiationService=E;var L;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(L||(L={}));class g{constructor(u,c){this.type=u,this.name=c,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return l?new g(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(u){return l?new g(0,u.name):g._None}branch(u,c){let v=new g(2,u.toString());return this._dep.push([u,c,v]),v}stop(){let u=Date.now()-this._start;g._totals+=u;let c=!1;function v(f,h){let o=[],s=new Array(f+1).join("	");for(const[e,i,n]of h._dep)if(i&&n){c=!0,o.push(`${s}CREATES -> ${e}`);let r=v(f+1,n);r&&o.push(r)}else o.push(`${s}uses -> ${e}`);return o.join(`
`)}let y=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(u>2||c)&&console.log(y.join(`
`))}}g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(Z[56],ee([0,1,15]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,C.createDecorator)("localizationsService");function b(w){if(typeof w.languageId!="string"||!Array.isArray(w.translations)||w.translations.length===0)return!1;for(const I of w.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!(w.languageName&&typeof w.languageName!="string"||w.localizedLanguageName&&typeof w.localizedLanguageName!="string")}t.isValidLocalization=b}),define(Z[14],ee([0,1,30,13,2,10,15]),function($,t,C,b,w,I,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,R.createDecorator)("logService"),t.ILoggerService=(0,R.createDecorator)("loggerService");function T(){return new Date().toISOString()}var l;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(l=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=l.Info;class d extends w.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new b.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=d;class E extends d{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(l.Trace)&&this.log(l.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(l.Debug)&&this.log(l.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(l.Info)&&this.log(l.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(l.Warning)&&this.log(l.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(l.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(l.Error,this.format(n))}else this.log(l.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(l.Critical)&&this.log(l.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let r=e[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch(a){}i+=(n>0?" ":"")+r}return i}}t.AbstractMessageLogger=E;class L extends d{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!I.isWindows}trace(e,...i){this.getLevel()<=l.Trace&&(this.useColors?console.log(`[90m[main ${T()}][0m`,e,...i):console.log(`[main ${T()}]`,e,...i))}debug(e,...i){this.getLevel()<=l.Debug&&(this.useColors?console.log(`[90m[main ${T()}][0m`,e,...i):console.log(`[main ${T()}]`,e,...i))}info(e,...i){this.getLevel()<=l.Info&&(this.useColors?console.log(`[90m[main ${T()}][0m`,e,...i):console.log(`[main ${T()}]`,e,...i))}warn(e,...i){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`[93m[main ${T()}][0m`,e,...i):console.warn(`[main ${T()}]`,e,...i))}error(e,...i){this.getLevel()<=l.Error&&(this.useColors?console.error(`[91m[main ${T()}][0m`,e,...i):console.error(`[main ${T()}]`,e,...i))}critical(e,...i){this.getLevel()<=l.Critical&&(this.useColors?console.error(`[90m[main ${T()}][0m`,e,...i):console.error(`[main ${T()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=L;class g extends d{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=g;class S extends d{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,C.toErrorMessage)(e,this.getLevel()<=l.Trace)}dispose(){}flush(){}}t.AdapterLogger=S;class u extends d{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=u;class c extends w.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=c;class v extends w.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(n))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,i?.always?l.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),i?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=v;class y{constructor(){this.onDidChangeLogLevel=new b.Emitter().event}setLevel(e){}getLevel(){return l.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=y;function f(s){if(s.verbose)return l.Trace;if(typeof s.logLevel=="string"){const e=h(s.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=f;function h(s){switch(s){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}t.parseLogLevel=h;function o(s){switch(s){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}t.LogLevelToString=o});var ce=this&&this.__param||function($,t){return function(C,b){t(C,b,$)}};define(Z[100],ee([0,1,35,6,30,13,2,7,3,12,21,14]),function($,t,C,b,w,I,R,T,l,d,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let g=class extends R.Disposable{constructor(u,c){super();this.environmentService=u,this.logService=c,this.processesLimiter=new b.Limiter(5)}async postUninstall(u){const c=this.parseScript(u,"uninstall");return c&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(c.script,"uninstall",c.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),v=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${v}`)))),d.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,v=>this.logService.error("Error while removing extension storage path",v))}parseScript(u,c){const v=`vscode:${c}`;if(u.location.scheme===T.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[v]=="string"){const y=u.manifest.scripts[v].split(" ");return y.length<2||y[0]!=="node"||!y[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${v} should be a node script`),null):{script:(0,l.join)(u.location.fsPath,y[1]),args:y.slice(2)||[]}}return null}runLifecycleHook(u,c,v,y,f){return new Promise((h,o)=>{const s=this.start(u,c,v,f);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?o(n):h(void 0)};s.on("error",n=>{i((0,w.toErrorMessage)(n)||"Unknown")}),s.on("exit",(n,r)=>{i(n?`post-${c} process exited with code ${n}`:void 0)}),y&&(e=setTimeout(()=>{e=null,s.kill(),o("timed out")},5e3))})}start(u,c,v,y){const f={silent:!0,execArgv:void 0},h=(0,C.fork)(u,[`--type=extension-post-${c}`,...v],f);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const o=I.Event.fromNodeEventEmitter(h.stdout,"data"),s=I.Event.fromNodeEventEmitter(h.stderr,"data");o(n=>this.logService.info(y.identifier.id,y.manifest.version,`post-${c}`,n)),s(n=>this.logService.error(y.identifier.id,y.manifest.version,`post-${c}`,n));const e=I.Event.any(I.Event.map(o,n=>({data:`%c${n}`,format:[""]})),I.Event.map(s,n=>({data:`%c${n}`,format:["color: red"]})));return I.Event.debounce(e,(n,r)=>n?{data:n.data+r.data,format:[...n.format,...r.format]}:{data:r.data,format:r.format},100)(n=>{console.group(y.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),h}getExtensionStoragePath(u){return(0,l.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};g=de([ce(0,E.IEnvironmentService),ce(1,L.ILogService)],g),t.ExtensionsLifecycle=g}),define(Z[101],ee([0,1,16,14]),function($,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function w(l,d,E,L){try{const g=await new Promise((S,u)=>{$(["spdlog"],S,u)});return g.setFlushOn(b.LogLevel.Trace),g.createAsyncRotatingLogger(l,d,E,L)}catch(g){console.error(g)}return null}function I(l,d,E,L){const g=$.__$__nodeRequire("spdlog");return g.setFlushOn(b.LogLevel.Trace),g.createRotatingLogger(l,d,E,L)}t.createRotatingLogger=I;function R(l,d,E){switch(d){case b.LogLevel.Trace:l.trace(E);break;case b.LogLevel.Debug:l.debug(E);break;case b.LogLevel.Info:l.info(E);break;case b.LogLevel.Warning:l.warn(E);break;case b.LogLevel.Error:l.error(E);break;case b.LogLevel.Critical:l.critical(E);break;default:throw new Error("Invalid log level")}}class T extends b.AbstractMessageLogger{constructor(d,E,L,g){super();this.name=d,this.filepath=E,this.rotating=L,this.buffer=[],this.setLevel(g),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(S=>{this._logger&&this._logger.setLevel(S)}))}_createSpdLogLogger(){const d=this.rotating?6:1,E=30/d*C.ByteSize.MB;return w(this.name,this.filepath,E,d).then(L=>{if(L){this._logger=L,this._logger.setLevel(this.getLevel());for(const{level:g,message:S}of this.buffer)R(this._logger,g,S);this.buffer=[]}})}log(d,E){this._logger?R(this._logger,d,E):this.getLevel()<=d&&this.buffer.push({level:d,message:E})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=T}),define(Z[57],ee([0,1,17,9,84,16,32]),function($,t,C,b,w,I,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function T(L,g,S,u,c,v){let y;try{await l(L,g,S,u,c,v)}catch(f){y=f}finally{y&&c.errorTransformer&&(y=c.errorTransformer(y)),typeof y!="undefined"&&S.error(y),S.end()}}t.readFileIntoStream=T;async function l(L,g,S,u,c,v){d(v);const y=await L.open(g,{create:!1});try{d(v);let f=0,h=0,o=c&&typeof c.length=="number"?c.length:void 0,s=C.VSBuffer.alloc(Math.min(c.bufferSize,typeof o=="number"?o:c.bufferSize)),e=c&&typeof c.position=="number"?c.position:0,i=0;do h=await L.read(y,e,s.buffer,i,s.byteLength-i),e+=h,i+=h,f+=h,typeof o=="number"&&(o-=h),i===s.byteLength&&(await S.write(u(s)),s=C.VSBuffer.alloc(Math.min(c.bufferSize,typeof o=="number"?o:c.bufferSize)),i=0);while(h>0&&(typeof o!="number"||o>0)&&d(v)&&E(f,c));if(i>0){let n=i;typeof o=="number"&&(n=Math.min(i,o)),S.write(u(s.slice(0,n)))}}catch(f){throw(0,I.ensureFileSystemProviderError)(f)}finally{await L.close(y)}}function d(L){if(L.isCancellationRequested)throw(0,b.canceled)();return!0}function E(L,g){if(g?.limits){if(typeof g.limits.memory=="number"&&L>g.limits.memory)throw(0,I.createFileSystemProviderError)((0,w.localize)(0,null,R.default.nameShort),I.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof g.limits.size=="number"&&L>g.limits.size)throw(0,I.createFileSystemProviderError)((0,w.localize)(1,null),I.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[102],ee([0,1,20,6,17,25,13,132,2,46,7,133,19,37,83,16,57,14]),function($,t,C,b,w,I,R,T,l,d,E,L,g,S,u,c,v,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let f=class xe extends l.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new R.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new R.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new R.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new R.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new R.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new R.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new b.ThrottledWorker(xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,xe.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new c.FileChangesEvent(s,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new b.ThrottledWorker(xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,xe.FILE_EVENTS_THROTTLING.coolDownDelay,s=>this._onDidFilesChange.fire(new c.FileChangesEvent(s,!0)))),this.watchedResources=d.TernarySearchTree.forUris(s=>{const e=this.getProvider(s.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new b.ResourceQueue)}registerProvider(o,s){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,L.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:s});const e=new l.DisposableStore;return e.add(s.onDidChangeFile(i=>this.onDidChangeFile(i,this.isPathCaseSensitive(s)))),e.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:o}))),typeof s.onDidErrorOccur=="function"&&e.add(s.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:s}),this.provider.delete(o),(0,l.dispose)(e)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(e){s.push(e)}}),!this.provider.has(o)&&await b.Promises.settled(s)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,s){const e=this.provider.get(o.scheme);return!!(e&&e.capabilities&s)}listCapabilities(){return T.Iterable.map(this.provider,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async withProvider(o){if(!(0,g.isAbsolutePath)(o))throw new c.FileOperationError((0,u.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const s=this.provider.get(o.scheme);if(!s){const e=new Error;throw e.name="ENOPRO",e.message=(0,u.localize)(1,null,o.toString()),e}return s}async withReadProvider(o){const s=await this.withProvider(o);if((0,c.hasOpenReadWriteCloseCapability)(s)||(0,c.hasReadWriteCapability)(s)||(0,c.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const s=await this.withProvider(o);if((0,c.hasOpenReadWriteCloseCapability)(s)||(0,c.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.doResolveFile(o,s)}catch(e){throw(0,c.toFileSystemProviderErrorCode)(e)===c.FileSystemProviderErrorCode.FileNotFound?new c.FileOperationError((0,u.localize)(2,null,this.resourceForError(o)),1):(0,c.ensureFileSystemProviderError)(e)}}async doResolveFile(o,s){const e=await this.withProvider(o),i=this.isPathCaseSensitive(e),n=s?.resolveTo,r=s?.resolveSingleChildDescendants,a=s?.resolveMetadata,m=await e.stat(o);let P;return this.toFileStat(e,o,m,void 0,!!a,(F,p)=>(P||(P=d.TernarySearchTree.forUris(()=>!i),P.set(o,!0),n&&P.fill(!0,n)),P.get(F.resource)||P.findSuperstr(F.resource.with({query:null,fragment:null}))?!0:F.isDirectory&&r?p===1:!1))}async toFileStat(o,s,e,i,n,r){const{providerExtUri:a}=this.getExtUri(o),m={resource:s,name:a.basename(s),isFile:(e.type&c.FileType.File)!=0,isDirectory:(e.type&c.FileType.Directory)!=0,isSymbolicLink:(e.type&c.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&c.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,c.etag)({mtime:e.mtime,size:e.size})};if(m.isDirectory&&r(m,i)){try{const P=await o.readdir(s),F=await b.Promises.settled(P.map(async([p,O])=>{try{const A=a.joinPath(s,p),W=n?await o.stat(A):{type:O};return await this.toFileStat(o,A,W,P.length,n,r)}catch(A){return this.logService.trace(A),null}}));m.children=(0,C.coalesce)(F)}catch(P){this.logService.trace(P),m.children=[]}return m}return m}async resolveAll(o){return b.Promises.settled(o.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(o){const s=await this.withProvider(o);try{return!!await s.stat(o)}catch(e){return!1}}async canCreateFile(o,s){try{await this.doValidateCreateFile(o,s)}catch(e){return e}return!0}async doValidateCreateFile(o,s){if(!s?.overwrite&&await this.exists(o))throw new c.FileOperationError((0,u.localize)(3,null,this.resourceForError(o)),3,s)}async createFile(o,s=w.VSBuffer.fromString(""),e){await this.doValidateCreateFile(o,e);const i=await this.writeFile(o,s);return this._onDidRunOperation.fire(new c.FileOperationEvent(o,0,i)),i}async writeFile(o,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,o,e)||await this.mkdirp(i,n.dirname(o));let a;if((0,c.hasReadWriteCapability)(i)&&!(s instanceof w.VSBuffer))if((0,S.isReadableStream)(s)){const m=await(0,S.peekStream)(s,3);m.ended?a=w.VSBuffer.concat(m.buffer):a=m}else a=(0,S.peekReadable)(s,m=>w.VSBuffer.concat(m),3);else a=s;!(0,c.hasOpenReadWriteCloseCapability)(i)||(0,c.hasReadWriteCapability)(i)&&a instanceof w.VSBuffer?await this.doWriteUnbuffered(i,o,e,a):await this.doWriteBuffered(i,o,e,a instanceof w.VSBuffer?(0,w.bufferToReadable)(a):a)}catch(r){throw new c.FileOperationError((0,u.localize)(4,null,this.resourceForError(o),(0,c.ensureFileSystemProviderError)(r).toString()),(0,c.toFileOperationResult)(r),e)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,s,e){if(!!e?.unlock&&!(o.capabilities&8192))throw new Error((0,u.localize)(5,null,this.resourceForError(s)));let n;try{n=await o.stat(s)}catch(r){return}if((n.type&c.FileType.Directory)!=0)throw new c.FileOperationError((0,u.localize)(6,null,this.resourceForError(s)),0,e);if(this.throwIfFileIsReadonly(s,n),typeof e?.mtime=="number"&&typeof e.etag=="string"&&e.etag!==c.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==(0,c.etag)({mtime:e.mtime,size:n.size}))throw new c.FileOperationError((0,u.localize)(7,null),3,e);return n}async readFile(o,s){const e=await this.withReadProvider(o);return s?.atomic?this.doReadFileAtomic(e,o,s):this.doReadFile(e,o,s)}async doReadFileAtomic(o,s,e){return new Promise((i,n)=>{this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(o,s,e);i(r)}catch(r){n(r)}})})}async doReadFile(o,s,e){const i=await this.doReadFileStream(o,s,{...e,preferUnbuffered:!0});return{...i,value:await(0,w.streamToBuffer)(i.value)}}async readFileStream(o,s){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,s)}async doReadFileStream(o,s,e){const i=new I.CancellationTokenSource,n=this.validateReadFile(s,e).then(a=>a,a=>{throw i.cancel(),a});let r;try{return typeof e?.etag=="string"&&e.etag!==c.ETAG_DISABLED&&await n,!((0,c.hasOpenReadWriteCloseCapability)(o)||(0,c.hasFileReadStreamCapability)(o))||(0,c.hasReadWriteCapability)(o)&&e?.preferUnbuffered?r=this.readFileUnbuffered(o,s,e):(0,c.hasFileReadStreamCapability)(o)?r=this.readFileStreamed(o,s,i.token,e):r=this.readFileBuffered(o,s,i.token,e),{...await n,value:r}}catch(a){r&&await(0,S.consumeStream)(r);const m=(0,u.localize)(8,null,this.resourceForError(s),(0,c.ensureFileSystemProviderError)(a).toString());throw a instanceof c.NotModifiedSinceFileOperationError?new c.NotModifiedSinceFileOperationError(m,a.stat,e):new c.FileOperationError(m,(0,c.toFileOperationResult)(a),e)}}readFileStreamed(o,s,e,i=Object.create(null)){const n=o.readFileStream(s,i,e);return(0,S.transform)(n,{data:r=>r instanceof w.VSBuffer?r:w.VSBuffer.wrap(r),error:r=>new c.FileOperationError((0,u.localize)(9,null,this.resourceForError(s),(0,c.ensureFileSystemProviderError)(r).toString()),(0,c.toFileOperationResult)(r),i)},r=>w.VSBuffer.concat(r))}readFileBuffered(o,s,e,i=Object.create(null)){const n=(0,w.newWriteableBufferStream)();return(0,v.readFileIntoStream)(o,s,n,r=>r,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new c.FileOperationError((0,u.localize)(10,null,this.resourceForError(s),(0,c.ensureFileSystemProviderError)(r).toString()),(0,c.toFileOperationResult)(r),i)},e),n}readFileUnbuffered(o,s,e){const i=(0,S.newWriteableStream)(n=>w.VSBuffer.concat(n));return(async()=>{try{let n=await o.readFile(s);typeof e?.position=="number"&&(n=n.slice(e.position)),typeof e?.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(s,n.byteLength,e),i.end(w.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(o,s){const e=await this.resolve(o,{resolveMetadata:!0});if(e.isDirectory)throw new c.FileOperationError((0,u.localize)(11,null,this.resourceForError(o)),0,s);if(typeof s?.etag=="string"&&s.etag!==c.ETAG_DISABLED&&s.etag===e.etag)throw new c.NotModifiedSinceFileOperationError((0,u.localize)(12,null),e,s);return this.validateReadFileLimits(o,e.size,s),e}validateReadFileLimits(o,s,e){if(e?.limits){let i;if(typeof e.limits.memory=="number"&&s>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&s>e.limits.size&&(i=7),typeof i=="number")throw new c.FileOperationError((0,u.localize)(13,null,this.resourceForError(o)),i)}}async canMove(o,s,e){return this.doCanMoveCopy(o,s,"move",e)}async canCopy(o,s,e){return this.doCanMoveCopy(o,s,"copy",e)}async doCanMoveCopy(o,s,e,i){if(o.toString()!==s.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(n,o,r,s,e,i)}catch(n){return n}return!0}async move(o,s,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(i,o,n,s,"move",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(o,r==="move"?2:3,a)),a}async copy(o,s,e){const i=await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=await this.doMoveCopy(i,o,n,s,"copy",!!e),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(o,r==="copy"?3:2,a)),a}async doMoveCopy(o,s,e,i,n,r){if(s.toString()===i.toString())return n;const{exists:a,isSameResourceWithDifferentPathCase:m}=await this.doValidateMoveCopy(o,s,e,i,n,r);if(a&&!m&&r&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(o===e&&(0,c.hasFileFolderCopyCapability)(o))await o.copy(s,i,{overwrite:r});else{const P=await this.resolve(s);P.isDirectory?await this.doCopyFolder(o,P,e,i):await this.doCopyFile(o,s,e,i)}return n}else return o===e?(await o.rename(s,i,{overwrite:r}),n):(await this.doMoveCopy(o,s,e,i,"copy",r),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(o,s,e,i){if((0,c.hasOpenReadWriteCloseCapability)(o)&&(0,c.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(o,s,e,i);if((0,c.hasOpenReadWriteCloseCapability)(o)&&(0,c.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(o,s,e,i);if((0,c.hasReadWriteCapability)(o)&&(0,c.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(o,s,e,i);if((0,c.hasReadWriteCapability)(o)&&(0,c.hasReadWriteCapability)(e))return this.doPipeUnbuffered(o,s,e,i)}async doCopyFolder(o,s,e,i){await e.mkdir(i),Array.isArray(s.children)&&await b.Promises.settled(s.children.map(async n=>{const r=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(o,await this.resolve(n.resource),e,r):this.doCopyFile(o,n.resource,e,r)}))}async doValidateMoveCopy(o,s,e,i,n,r){let a=!1;if(o===e){const{providerExtUri:P,isPathCaseSensitive:F}=this.getExtUri(o);if(F||(a=P.isEqual(s,i)),a&&n==="copy")throw new Error((0,u.localize)(14,null,this.resourceForError(s),this.resourceForError(i)));if(!a&&P.isEqualOrParent(i,s))throw new Error((0,u.localize)(15,null,this.resourceForError(s),this.resourceForError(i)))}const m=await this.exists(i);if(m&&!a){if(!r)throw new c.FileOperationError((0,u.localize)(16,null,this.resourceForError(s),this.resourceForError(i)),4);if(o===e){const{providerExtUri:P}=this.getExtUri(o);if(P.isEqualOrParent(s,i))throw new Error((0,u.localize)(17,null,this.resourceForError(s),this.resourceForError(i)))}}return{exists:m,isSameResourceWithDifferentPathCase:a}}getExtUri(o){const s=this.isPathCaseSensitive(o);return{providerExtUri:s?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(s,o);const e=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(o,0,e)),e}async mkdirp(o,s){const e=[],{providerExtUri:i}=this.getExtUri(o);for(;!i.isEqual(s,i.dirname(s));)try{if(((await o.stat(s)).type&c.FileType.Directory)==0)throw new Error((0,u.localize)(18,null,this.resourceForError(s)));break}catch(n){if((0,c.toFileSystemProviderErrorCode)(n)!==c.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(s)),s=i.dirname(s)}for(let n=e.length-1;n>=0;n--){s=i.joinPath(s,e[n]);try{await o.mkdir(s)}catch(r){if((0,c.toFileSystemProviderErrorCode)(r)!==c.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(o,s){try{await this.doValidateDelete(o,s)}catch(e){return e}return!0}async doValidateDelete(o,s){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!s?.useTrash&&!(e.capabilities&4096))throw new Error((0,u.localize)(19,null,this.resourceForError(o)));let n;try{n=await e.stat(o)}catch(a){}if(n)this.throwIfFileIsReadonly(o,n);else throw new c.FileOperationError((0,u.localize)(20,null,this.resourceForError(o)),1);if(!!!s?.recursive){const a=await this.resolve(o);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,u.localize)(21,null,this.resourceForError(o)))}return e}async del(o,s){const e=await this.doValidateDelete(o,s),i=!!s?.useTrash,n=!!s?.recursive;await e.delete(o,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new c.FileOperationEvent(o,1))}onDidChangeFile(o,s){this._onDidChangeFilesRaw.fire({changes:o});let e,i;{for(const n of o)this.watchedResources.has(n.resource)?(e||(e=[]),e.push(n)):(i||(i=[]),i.push(n));e&&this._onDidFilesChange.fire(new c.FileChangesEvent(e,!s))}if(i){const n=s?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(i)&&xe.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,s={recursive:!1,excludes:[]}){const e=new l.DisposableStore;{let i=!1,n=()=>{i=!0};e.add((0,l.toDisposable)(()=>n())),this.doWatch(o,s).then(r=>{i?(0,l.dispose)(r):n=()=>(0,l.dispose)(r)},r=>this.logService.error(r))}return s.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),e.add((0,l.toDisposable)(()=>{const i=this.watchedResources.get(o);typeof i=="number"&&(i<=1?this.watchedResources.delete(o):this.watchedResources.set(o,i-1))}))),e}async doWatch(o,s){const e=await this.withProvider(o),i=this.toWatchKey(e,o,s),n=this.activeWatchers.get(i)||{count:0,disposable:e.watch(o,s)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,(0,l.toDisposable)(()=>{n.count--,n.count===0&&((0,l.dispose)(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(o,s,e){const{providerExtUri:i}=this.getExtUri(o);return[i.getComparisonKey(s),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,l.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(async()=>{const n=await o.open(s,{create:!0,unlock:e?.unlock??!1});try{(0,S.isReadableStream)(i)||(0,S.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(o,n,i):await this.doWriteReadableBufferedQueued(o,n,i)}catch(r){throw(0,c.ensureFileSystemProviderError)(r)}finally{await o.close(n)}})}async doWriteStreamBufferedQueued(o,s,e){let i=0,n;if((0,S.isReadableBufferedStream)(e)){if(e.buffer.length>0){const r=w.VSBuffer.concat(e.buffer);await this.doWriteBuffer(o,s,r,r.byteLength,i,0),i+=r.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise(async(r,a)=>{(0,S.listenStream)(n,{onData:async m=>{n.pause();try{await this.doWriteBuffer(o,s,m,m.byteLength,i,0)}catch(P){return a(P)}i+=m.byteLength,setTimeout(()=>n.resume())},onError:m=>a(m),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(o,s,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(o,s,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(o,s,e,i,n,r){let a=0;for(;a<i;)a+=await o.write(s,n+a,e.buffer,r+a,i-a)}async doWriteUnbuffered(o,s,e,i){return this.writeQueue.queueFor(s,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,s,e,i))}async doWriteUnbufferedQueued(o,s,e,i){let n;i instanceof w.VSBuffer?n=i:(0,S.isReadableStream)(i)?n=await(0,w.streamToBuffer)(i):(0,S.isReadableBufferedStream)(i)?n=await(0,w.bufferedStreamToBuffer)(i):n=(0,w.readableToBuffer)(i),await o.writeFile(s,n.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,s,e,i))}async doPipeBufferedQueued(o,s,e,i){let n,r;try{n=await o.open(s,{create:!1}),r=await e.open(i,{create:!0,unlock:!1});const a=w.VSBuffer.alloc(this.BUFFER_SIZE);let m=0,P=0,F=0;do F=await o.read(n,m,a.buffer,P,a.byteLength-P),await this.doWriteBuffer(e,r,a,F,m,P),m+=F,P+=F,P===a.byteLength&&(P=0);while(F>0)}catch(a){throw(0,c.ensureFileSystemProviderError)(a)}finally{await b.Promises.settled([typeof n=="number"?o.close(n):Promise.resolve(),typeof r=="number"?e.close(r):Promise.resolve()])}}async doPipeUnbuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,s,e,i))}async doPipeUnbufferedQueued(o,s,e,i){return e.writeFile(i,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,s,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,s,e,i))}async doPipeUnbufferedToBufferedQueued(o,s,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const r=await o.readFile(s);await this.doWriteBuffer(e,n,w.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,c.ensureFileSystemProviderError)(r)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(o,s,e,i){const n=await(0,w.streamToBuffer)(this.readFileBuffered(o,s,I.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(o,s){if(o.capabilities&2048)throw new c.FileOperationError((0,u.localize)(22,null,this.resourceForError(s)),6);return o}throwIfFileIsReadonly(o,s){if((s.permissions??0)&c.FilePermission.Readonly)throw new c.FileOperationError((0,u.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===E.Schemas.file?o.fsPath:o.toString(!0)}};f.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},f=de([ce(0,y.ILogService)],f),t.FileService=f}),define(Z[103],ee([0,1,20,6,17,13,38,2,3,10,19,37,12,85,16,57,98,92,93,54,95,14,32]),function($,t,C,b,w,I,R,T,l,d,E,L,g,S,u,c,v,y,f,h,o,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class i extends T.Disposable{constructor(r,a){super();this.logService=r,this.options=a,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=I.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new I.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new b.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,d.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:a,symbolicLink:m}=await g.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(a,m),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(r){try{const a=await g.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),m=[];return await Promise.all(a.map(async P=>{try{let F;P.isSymbolicLink()?F=(await this.stat((0,E.joinPath)(r,P.name))).type:F=this.toType(P),m.push([P.name,F])}catch(F){this.logService.trace(F)}})),m}catch(a){throw this.toFileSystemProviderError(a)}}toType(r,a){let m;return a?.dangling?m=u.FileType.Unknown:r.isFile()?m=u.FileType.File:r.isDirectory()?m=u.FileType.Directory:m=u.FileType.Unknown,a&&(m|=u.FileType.SymbolicLink),m}async readFile(r){try{const a=this.toFilePath(r);return await g.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(r,a,m){const P=(0,L.newWriteableStream)(F=>w.VSBuffer.concat(F.map(p=>w.VSBuffer.wrap(p))).buffer);return(0,c.readFileIntoStream)(this,r,P,F=>F.buffer,{...a,bufferSize:this.BUFFER_SIZE},m),P}async writeFile(r,a,m){let P;try{const F=this.toFilePath(r);if(!m.create||!m.overwrite){if(await g.Promises.exists(F)){if(!m.overwrite)throw(0,u.createFileSystemProviderError)((0,S.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!m.create)throw(0,u.createFileSystemProviderError)((0,S.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}P=await this.open(r,{create:!0,unlock:m.unlock}),await this.write(P,0,a,0,a.byteLength)}catch(F){throw await this.toFileSystemProviderWriteError(r,F)}finally{typeof P=="number"&&await this.close(P)}}async open(r,a){try{const m=this.toFilePath(r);if((0,u.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:p}=await g.SymlinkSupport.stat(m);p.mode&128||await g.Promises.chmod(m,p.mode|128)}catch(p){this.logService.trace(p)}let P;if((0,u.isFileOpenForWriteOptions)(a)){if(d.isWindows)try{await g.Promises.truncate(m,0),P="r+"}catch(p){p.code!=="ENOENT"&&this.logService.trace(p)}P||(P="w")}else P="r";const F=await g.Promises.open(m,P);return this.mapHandleToPos.set(F,0),(0,u.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(F,r),F}catch(m){throw(0,u.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(r,m):this.toFileSystemProviderError(m)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await g.Promises.fdatasync(r)}catch(a){this.canFlush=!1,this.logService.error(a)}return await g.Promises.close(r)}catch(a){throw this.toFileSystemProviderError(a)}}async read(r,a,m,P,F){const p=this.normalizePos(r,a);let O=null;try{const A=await g.Promises.read(r,m,P,F,p);return typeof A=="number"?O=A:O=A.bytesRead,O}catch(A){throw this.toFileSystemProviderError(A)}finally{this.updatePos(r,p,O)}}normalizePos(r,a){return a===this.mapHandleToPos.get(r)?null:a}updatePos(r,a,m){const P=this.mapHandleToPos.get(r);typeof P=="number"&&(typeof a=="number"||(typeof m=="number"?this.mapHandleToPos.set(r,P+m):this.mapHandleToPos.delete(r)))}async write(r,a,m,P,F){return(0,b.retry)(()=>this.doWrite(r,a,m,P,F),100,3)}async doWrite(r,a,m,P,F){const p=this.normalizePos(r,a);let O=null;try{const A=await g.Promises.write(r,m,P,F,p);return typeof A=="number"?O=A:O=A.bytesWritten,O}catch(A){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),A)}finally{this.updatePos(r,p,O)}}async mkdir(r){try{await g.Promises.mkdir(this.toFilePath(r))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(r,a){try{const m=this.toFilePath(r);await this.doDelete(m,a)}catch(m){throw this.toFileSystemProviderError(m)}}async doDelete(r,a){a.recursive?await g.Promises.rm(r,g.RimRafMode.MOVE):await g.Promises.unlink(r)}async rename(r,a,m){const P=this.toFilePath(r),F=this.toFilePath(a);if(P!==F)try{await this.validateTargetDeleted(r,a,"move",m.overwrite),await g.Promises.move(P,F)}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,S.localize)(2,null,(0,l.basename)(P),(0,l.basename)((0,l.dirname)(F)),p.toString()))),this.toFileSystemProviderError(p)}}async copy(r,a,m){const P=this.toFilePath(r),F=this.toFilePath(a);if(P!==F)try{await this.validateTargetDeleted(r,a,"copy",m.overwrite),await g.Promises.copy(P,F,{preserveSymlinks:!0})}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,S.localize)(3,null,(0,l.basename)(P),(0,l.basename)((0,l.dirname)(F)),p.toString()))),this.toFileSystemProviderError(p)}}async validateTargetDeleted(r,a,m,P){const F=this.toFilePath(r),p=this.toFilePath(a);let O=!1;if(!!(this.capabilities&1024)||(O=(0,R.isEqual)(F,p,!0)),O&&m==="copy")throw(0,u.createFileSystemProviderError)((0,S.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!O&&await g.Promises.exists(p)){if(!P)throw(0,u.createFileSystemProviderError)((0,S.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(r,a){return a.recursive?this.watchRecursive(r,a):this.watchNonRecursive(r)}watchRecursive(r,a){const m={path:this.toFilePath(r),excludes:a.excludes},P=(0,C.insert)(this.recursiveFoldersToWatch,m);return this.refreshRecursiveWatchers(),(0,T.toDisposable)(()=>{P(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof y.FileWatcher)this.recursiveWatcher.watch(this.recursiveFoldersToWatch);else if((0,T.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let r,a;if(this.options?.watcher?.usePolling)r=f.FileWatcher,a=this.options?.watcher;else{let m;this.options?.enableLegacyRecursiveWatcher?m=!0:m=e.default.quality==="stable"&&d.isLinux,m&&this.recursiveFoldersToWatch.length===1?d.isWindows?r=o.FileWatcher:r=f.FileWatcher:r=y.FileWatcher}this.recursiveWatcher=new r(this.recursiveFoldersToWatch,m=>this._onDidChangeFile.fire((0,h.toFileChanges)(m)),m=>{m.type==="error"&&this._onDidWatchErrorOccur.fire(m.message),this.logService[m.type](m.message)},this.logService.getLevel()===s.LogLevel.Trace,a),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)}))}}watchNonRecursive(r){const a=new v.FileWatcher(this.toFilePath(r),P=>this._onDidChangeFile.fire((0,h.toFileChanges)(P)),P=>{P.type==="error"&&this._onDidWatchErrorOccur.fire(P.message),this.logService[P.type](P.message)},this.logService.getLevel()===s.LogLevel.Trace),m=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===s.LogLevel.Trace)});return(0,T.combinedDisposable)(a,m)}toFilePath(r){return(0,l.normalize)(r.fsPath)}toFileSystemProviderError(r){if(r instanceof u.FileSystemProviderError)return r;let a;switch(r.code){case"ENOENT":a=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=u.FileSystemProviderErrorCode.NoPermissions;break;default:a=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(r,a)}async toFileSystemProviderWriteError(r,a){let m=this.toFileSystemProviderError(a);if(r&&m.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:P}=await g.SymlinkSupport.stat(this.toFilePath(r));P.mode&128||(m=(0,u.createFileSystemProviderError)(a,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(P){this.logService.trace(P)}return m}dispose(){super.dispose(),(0,T.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,T.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=i}),define(Z[40],ee([0,1,15]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,C.createDecorator)("productService")}),define(Z[26],ee([0,1,58,11]),function($,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class w{constructor(){this.data=new Map}add(R,T){C.ok(b.isString(R)),C.ok(b.isObject(T)),C.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,T)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}t.Registry=new w}),define(Z[104],ee([0,1,13,26]),function($,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function w(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class I{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,d){this.schemasById[w(l)]=d,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new I;b.Registry.add(t.Extensions.JSONContribution,R)}),define(Z[33],ee([0,1,20,13,11,74,104,26]),function($,t,C,b,w,I,R,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var l;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(l=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var d;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(d=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const E=T.Registry.as(R.Extensions.JSONContribution);class L{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new b.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new b.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},E.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(h,o=!0){this.registerConfigurations([h],o)}registerConfigurations(h,o=!0){const s=this.doRegisterConfigurations(h,o);E.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterConfigurations(h){const o=this.doDeregisterConfigurations(h);E.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}updateConfigurations({add:h,remove:o}){const s=[];s.push(...this.doDeregisterConfigurations(o)),s.push(...this.doRegisterConfigurations(h,!1)),E.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,C.distinct)(s))}registerDefaultConfigurations(h){const o=[],s=[];for(const e of h)for(const i in e)if(o.push(i),t.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...e[i]};const n={type:"object",default:this.defaultValues[i],description:I.localize(1,null,i),$ref:t.resourceLanguageSettingsSchemaId};s.push(S(i)),this.configurationProperties[i]=n,this.defaultLanguageConfigurationOverridesNode.properties[i]=n}else{this.defaultValues[i]=e[i];const n=this.configurationProperties[i];n&&(this.updatePropertyDefaultValue(i,n),this.updateSchema(i,n))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(h){const o=[];for(const s of h)for(const e in s)if(o.push(e),delete this.defaultValues[e],t.OVERRIDE_PROPERTY_PATTERN.test(e))delete this.configurationProperties[e],delete this.defaultLanguageConfigurationOverridesNode.properties[e];else{const i=this.configurationProperties[e];i&&(this.updatePropertyDefaultValue(e,i),this.updateSchema(e,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...h){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(h){for(const o of h)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(h,o){const s=[];return h.forEach(e=>{s.push(...this.validateAndRegisterProperties(e,o,e.extensionInfo)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),s}doDeregisterConfigurations(h){const o=[],s=e=>{if(e.properties)for(const i in e.properties)o.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,e.properties[i]);e.allOf&&e.allOf.forEach(i=>s(i))};for(const e of h){s(e);const i=this.configurationContributors.indexOf(e);i!==-1&&this.configurationContributors.splice(i,1)}return o}validateAndRegisterProperties(h,o=!0,s,e=3){e=w.isUndefinedOrNull(h.scope)?e:h.scope;let i=[],n=h.properties;if(n)for(let a in n){if(o&&v(a)){delete n[a];continue}const m=n[a];if(this.updatePropertyDefaultValue(a,m),t.OVERRIDE_PROPERTY_PATTERN.test(a)?m.scope=void 0:(m.scope=w.isUndefinedOrNull(m.scope)?e:m.scope,m.restricted=w.isUndefinedOrNull(m.restricted)?!!s?.restrictedConfigurations?.includes(a):m.restricted),n[a].hasOwnProperty("included")&&!n[a].included){this.excludedConfigurationProperties[a]=n[a],delete n[a];continue}else this.configurationProperties[a]=n[a];!n[a].deprecationMessage&&n[a].markdownDeprecationMessage&&(n[a].deprecationMessage=n[a].markdownDeprecationMessage),i.push(a)}let r=h.allOf;if(r)for(let a of r)i.push(...this.validateAndRegisterProperties(a,o,s,e));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(h){const o=s=>{let e=s.properties;if(e)for(const n in e)this.updateSchema(n,e[n]);let i=s.allOf;i&&i.forEach(o)};o(h)}updateSchema(h,o){switch(t.allSettings.properties[h]=o,o.scope){case 1:t.applicationSettings.properties[h]=o;break;case 2:t.machineSettings.properties[h]=o;break;case 6:t.machineOverridableSettings.properties[h]=o;break;case 3:t.windowSettings.properties[h]=o;break;case 4:t.resourceSettings.properties[h]=o;break;case 5:t.resourceSettings.properties[h]=o,this.resourceLanguageSettingsSchema.properties[h]=o;break}}removeFromSchema(h,o){switch(delete t.allSettings.properties[h],o.scope){case 1:delete t.applicationSettings.properties[h];break;case 2:delete t.machineSettings.properties[h];break;case 6:delete t.machineOverridableSettings.properties[h];break;case 3:delete t.windowSettings.properties[h];break;case 4:case 5:delete t.resourceSettings.properties[h];break}}updateOverridePropertyPatternKey(){for(const h of this.overrideIdentifiers.values()){const o=`[${h}]`,s={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,s),t.allSettings.properties[o]=s,t.applicationSettings.properties[o]=s,t.machineSettings.properties[o]=s,t.machineOverridableSettings.properties[o]=s,t.windowSettings.properties[o]=s,t.resourceSettings.properties[o]=s}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(h,o){let s=this.defaultValues[h];w.isUndefined(s)&&(s=o.default),w.isUndefined(s)&&(s=u(o.type)),o.default=s}}const g="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(g);function S(f){return f.substring(1,f.length-1)}t.overrideIdentifierFromKey=S;function u(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=u;const c=new L;T.Registry.add(t.Extensions.Configuration,c);function v(f){return f.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(f)?I.localize(5,null,f):c.getConfigurationProperties()[f]!==void 0?I.localize(6,null,f):null:I.localize(4,null)}t.validateProperty=v;function y(){const f=[],h=c.getConfigurationProperties();for(const o of Object.keys(h))f.push([o,h[o].scope]);return f.push(["launch",4]),f.push(["task",4]),f}t.getScopes=y}),define(Z[27],ee([0,1,18,11,8,33,15,26]),function($,t,C,b,w,I,R,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,R.createDecorator)("configurationService");function l(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof w.URI)}t.isConfigurationOverrides=l;var d;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(d=t.ConfigurationTarget||(t.ConfigurationTarget={}));function E(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=E;function L(i,n){const r=n?i?n.keys.filter(A=>i.keys.indexOf(A)===-1):[...n.keys]:[],a=i?n?i.keys.filter(A=>n.keys.indexOf(A)===-1):[...i.keys]:[],m=[];if(n&&i){for(const A of i.keys)if(n.keys.indexOf(A)!==-1){const W=y(i.contents,A),Y=y(n.contents,A);C.equals(W,Y)||m.push(A)}}const P=[],F=A=>{const W={};for(const Y of A)for(const te of Y.identifiers)W[s(te)]=Y;return W},p=n?F(n.overrides):{},O=i?F(i.overrides):{};if(Object.keys(p).length)for(const A of r){const W=p[A];W&&P.push([(0,I.overrideIdentifierFromKey)(A),W.keys])}if(Object.keys(O).length)for(const A of a){const W=O[A];W&&P.push([(0,I.overrideIdentifierFromKey)(A),W.keys])}if(Object.keys(p).length&&Object.keys(O).length)for(const A of m){const W=O[A],Y=p[A];if(W&&Y){const te=L({contents:W.contents,keys:W.keys,overrides:[]},{contents:Y.contents,keys:Y.keys,overrides:[]});P.push([(0,I.overrideIdentifierFromKey)(A),[...te.added,...te.removed,...te.updated]])}}return{added:r,removed:a,updated:m,overrides:P}}t.compare=L;function g(i,n){const r=[];for(const a of Object.keys(i))if(I.OVERRIDE_PROPERTY_PATTERN.test(a)){const m={};for(const P in i[a])m[P]=i[a][P];r.push({identifiers:[(0,I.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(m),contents:S(m,n)})}return r}t.toOverrides=g;function S(i,n){const r=Object.create(null);for(let a in i)u(r,a,i[a],n);return r}t.toValuesTree=S;function u(i,n,r,a){const m=n.split("."),P=m.pop();let F=i;for(let p=0;p<m.length;p++){let O=m[p],A=F[O];switch(typeof A){case"undefined":A=F[O]=Object.create(null);break;case"object":break;default:a(`Ignoring ${n} as ${m.slice(0,p+1).join(".")} is ${JSON.stringify(A)}`);return}F=A}if(typeof F=="object"&&F!==null)try{F[P]=r}catch(p){a(`Ignoring ${n} as ${m.join(".")} is ${JSON.stringify(F)}`)}else a(`Ignoring ${n} as ${m.join(".")} is ${JSON.stringify(F)}`)}t.addToValueTree=u;function c(i,n){const r=n.split(".");v(i,r)}t.removeFromValueTree=c;function v(i,n){const r=n.shift();if(n.length===0){delete i[r];return}if(Object.keys(i).indexOf(r)!==-1){const a=i[r];typeof a=="object"&&!Array.isArray(a)&&(v(a,n),Object.keys(a).length===0&&delete i[r])}}function y(i,n,r){function a(F,p){let O=F;for(const A of p){if(typeof O!="object"||O===null)return;O=O[A]}return O}const m=n.split("."),P=a(i,m);return typeof P=="undefined"?r:P}t.getConfigurationValue=y;function f(i,n,r){Object.keys(n).forEach(a=>{a!=="__proto__"&&(a in i?b.isObject(i[a])&&b.isObject(n[a])?f(i[a],n[a],r):r&&(i[a]=n[a]):i[a]=n[a])})}t.merge=f;function h(){const i=T.Registry.as(I.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=h;function o(){const i=Object.create(null),n=T.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(let r in n){let a=n[r].default;u(i,r,a,m=>console.error(`Conflict in default settings: ${m}`))}return i}t.getDefaultValues=o;function s(i){return`[${i}]`}t.keyFromOverrideIdentifier=s;function e(i,n,r){const a=i.inspect(n),m=i.inspect(r);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:a.defaultValue}t.getMigratedSettingValue=e}),define(Z[105],ee([0,1,20,13,59,2,46,18,11,8,27,33,26]),function($,t,C,b,w,I,R,T,l,d,E,L,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class S{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,E.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?(0,E.getConfigurationValue)(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){let i=this.overrideConfigurations.get(e);return i||(i=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,i)),i}merge(...e){const i=T.deepClone(this.contents),n=T.deepClone(this.overrides),r=[...this.keys];for(const a of e){this.mergeContents(i,a.contents);for(const m of a.overrides){const[P]=n.filter(F=>C.equals(F.identifiers,m.identifiers));P?this.mergeContents(P.contents,m.contents):n.push(T.deepClone(m))}for(const m of a.keys)r.indexOf(m)===-1&&r.push(m)}return new S(i,r,n)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const r of C.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[r],m=i[r];m&&(typeof a=="object"&&typeof m=="object"?(a=T.deepClone(a),this.mergeContents(a,m)):a=m),n[r]=a}return new S(n,this.keys,this.overrides)}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&l.isObject(e[n])&&l.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=T.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?T.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,E.addToValueTree)(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&(0,E.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=S;class u extends S{constructor(){const e=(0,E.getDefaultValues)(),i=(0,E.getConfigurationKeys)(),n=[];for(const r of Object.keys(e))L.OVERRIDE_PROPERTY_PATTERN.test(r)&&n.push({identifiers:[(0,L.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(e[r]),contents:(0,E.toValuesTree)(e[r],a=>console.error(`Conflict in default settings file: ${a}`))});super(e,i,n)}}t.DefaultConfigurationModel=u;class c{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!l.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:r,overrides:a,restricted:m}=this.doParseRaw(e,i);this._configurationModel=new S(n,r,a),this._restrictedConfigurations=m||[]}doParseContent(e){let i={},n=null,r=[],a=[],m=[];function P(p){Array.isArray(r)?r.push(p):n!==null&&(r[n]=p)}let F={onObjectBegin:()=>{let p={};P(p),a.push(r),r=p,n=null},onObjectProperty:p=>{n=p},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{let p=[];P(p),a.push(r),r=p,n=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:P,onError:(p,O,A)=>{m.push({error:p,offset:O,length:A})}};if(e)try{w.visit(e,F),i=r[0]||{}}catch(p){console.error(`Error while parsing settings file ${this._name}: ${p}`),this._parseErrors=[p]}return i}doParseRaw(e,i){const n=g.Registry.as(L.Extensions.Configuration).getConfigurationProperties(),r=this.filter(e,n,!0,i);e=r.raw;const a=(0,E.toValuesTree)(e,F=>console.error(`Conflict in settings file ${this._name}: ${F}`)),m=Object.keys(e),P=(0,E.toOverrides)(e,F=>console.error(`Conflict in settings file ${this._name}: ${F}`));return{contents:a,keys:m,overrides:P,restricted:r.restricted}}filter(e,i,n,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:e,restricted:[]};const a={},m=[];for(let P in e)if(L.OVERRIDE_PROPERTY_PATTERN.test(P)&&n){const F=this.filter(e[P],i,!1,r);a[P]=F.raw,m.push(...F.restricted)}else{const F=i[P],p=F?typeof F.scope!="undefined"?F.scope:3:void 0;F?.restricted&&m.push(P),(p===void 0||r.scopes===void 0||r.scopes.includes(p))&&(r.skipRestricted&&F?.restricted||(a[P]=e[P]))}return{raw:a,restricted:m}}}t.ConfigurationModelParser=c;class v extends I.Disposable{constructor(e,i,n,r){super();this.userSettingsResource=e,this.scopes=i,this.fileService=r,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new c(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(b.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=v;class y{constructor(e,i,n=new S,r=new S,a=new R.ResourceMap,m=new S,P=new R.ResourceMap,F=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=r,this._folderConfigurations=a,this._memoryConfiguration=m,this._memoryConfigurationByResource=P,this._freeze=F,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let r;n.resource?(r=this._memoryConfigurationByResource.get(n.resource),r||(r=new S,this._memoryConfigurationByResource.set(n.resource,r))):r=this._memoryConfiguration,i===void 0?r.removeValue(e):r.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const r=this.getConsolidateConfigurationModel(i,n),a=this.getFolderConfigurationModelForResource(i.resource,n),m=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,P=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),F=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),p=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),O=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),A=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,W=a?i.overrideIdentifier?a.freeze().override(i.overrideIdentifier).getValue(e):a.freeze().getValue(e):void 0,Y=i.overrideIdentifier?m.override(i.overrideIdentifier).getValue(e):m.getValue(e),te=r.getValue(e),oe=C.distinct(C.flatten(r.overrides.map(ie=>ie.identifiers))).filter(ie=>r.getOverrideValue(e,ie)!==void 0);return{defaultValue:P,userValue:F,userLocalValue:p,userRemoteValue:O,workspaceValue:A,workspaceFolderValue:W,memoryValue:Y,value:te,default:P!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:F!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:p!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:A!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:W!==void 0?{value:a?.freeze().getValue(e),override:i.overrideIdentifier?a?.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:Y!==void 0?{value:m.getValue(e),override:i.overrideIdentifier?m.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:oe.length?oe:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(r=>L.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const a=(0,L.overrideIdentifierFromKey)(r),m=this._defaultConfiguration.getKeysForOverrideIdentifier(a),P=e.getKeysForOverrideIdentifier(a),F=[...P.filter(p=>m.indexOf(p)===-1),...m.filter(p=>P.indexOf(p)===-1),...m.filter(p=>!T.equals(this._defaultConfiguration.override(a).getValue(p),e.override(a).getValue(p)))];return[a,F]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:r,overrides:a}=(0,E.compare)(this.localUserConfiguration,e),m=[...i,...n,...r];return m.length&&this.updateLocalUserConfiguration(e),{keys:m,overrides:a}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:r,overrides:a}=(0,E.compare)(this.remoteUserConfiguration,e);let m=[...i,...n,...r];return m.length&&this.updateRemoteUserConfiguration(e),{keys:m,overrides:a}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:r,overrides:a}=(0,E.compare)(this.workspaceConfiguration,e);let m=[...i,...n,...r];return m.length&&this.updateWorkspaceConfiguration(e),{keys:m,overrides:a}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:r,updated:a,removed:m,overrides:P}=(0,E.compare)(n,i);let F=[...r,...a,...m];return(F.length||!n)&&this.updateFolderConfiguration(e,i),{keys:F,overrides:P}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:r,removed:a,overrides:m}=(0,E.compare)(i,void 0);return{keys:[...n,...r,...a],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const r=i.getFolder(e);r&&(n=this.getFolderConsolidatedConfiguration(r.uri)||n);const a=this._memoryConfigurationByResource.get(e);a&&(n=n.merge(a))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(e);r?(i=n.merge(r),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:r,keys:a}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:r,keys:a}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(r=>i.add(r))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),r=this.parseConfigurationModel(e.workspace),a=e.folders.reduce((m,P)=>(m.set(d.URI.revive(P[0]),this.parseConfigurationModel(P[1])),m),new R.ResourceMap);return new y(i,n,new S,r,a,new S,new R.ResourceMap,!1)}static parseConfigurationModel(e){return new S(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=y;function f(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,i=new Map;for(const r of s)r.keys.forEach(a=>e.add(a)),r.overrides.forEach(([a,m])=>{const P=(0,R.getOrSet)(i,a,new Set);m.forEach(F=>P.add(F))});const n=[];return i.forEach((r,a)=>n.push([a,[...r.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=f;class h{constructor(e,i,n,r){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=r,this._previousConfiguration=void 0;const a=new Set;e.keys.forEach(P=>a.add(P)),e.overrides.forEach(([,P])=>P.forEach(F=>a.add(F))),this.affectedKeys=[...a.values()];const m=new S;this.affectedKeys.forEach(P=>m.setValue(P,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=y.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(e,i,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!T.equals(n,r)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=(0,E.toValuesTree)({[i]:!0},()=>{}),r;for(;typeof n=="object"&&(r=Object.keys(n)[0]);){if(e=e[r],!e)return!1;n=n[r]}return!0}}t.ConfigurationChangeEvent=h;class o extends h{constructor(e,i,n,r){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=r}}t.AllKeysConfigurationChangeEvent=o}),define(Z[106],ee([0,1,6,13,2,19,27,105,33,26]),function($,t,C,b,w,I,R,T,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class E extends w.Disposable{constructor(g,S){super();this.settingsResource=g,this._onDidChangeConfiguration=this._register(new b.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new T.UserSettings(this.settingsResource,void 0,I.extUriBiasedIgnorePathCase,S)),this.configuration=new T.Configuration(new T.DefaultConfigurationModel,new T.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new C.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(d.Registry.as(l.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const g=await this.userConfiguration.loadConfiguration();this.configuration=new T.Configuration(new T.DefaultConfigurationModel,g)}getConfigurationData(){return this.configuration.toData()}getValue(g,S){const u=typeof g=="string"?g:void 0,c=(0,R.isConfigurationOverrides)(g)?g:(0,R.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(u,c,void 0)}updateValue(g,S,u,c){return Promise.reject(new Error("not supported"))}inspect(g){return this.configuration.inspect(g,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const g=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(g)}onDidChangeUserConfiguration(g){const S=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(g);this.trigger(u,S,1)}onDidDefaultConfigurationChange(g){const S=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new T.DefaultConfigurationModel,g);this.trigger(u,S,6)}trigger(g,S,u){const c=new T.ConfigurationChangeEvent(g,{data:S},this.configuration);c.source=u,c.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(c)}getTargetConfiguration(g){switch(g){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=E}),define(Z[107],ee([0,1,7]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isVirtualWorkspace=t.getVirtualWorkspaceScheme=t.getVirtualWorkspaceLocation=t.isVirtualResource=t.getRemoteName=t.getRemoteAuthority=void 0;function b(d){return d.scheme===C.Schemas.vscodeRemote?d.authority:void 0}t.getRemoteAuthority=b;function w(d){if(!d)return;const E=d.indexOf("+");return E<0?d:d.substr(0,E)}t.getRemoteName=w;function I(d){return d.scheme!==C.Schemas.file&&d.scheme!==C.Schemas.vscodeRemote}t.isVirtualResource=I;function R(d){if(d.folders.length)return d.folders.every(E=>I(E.uri))?d.folders[0].uri:void 0;if(d.configuration&&I(d.configuration))return d.configuration}t.getVirtualWorkspaceLocation=R;function T(d){return R(d)?.scheme}t.getVirtualWorkspaceScheme=T;function l(d){return R(d)!==void 0}t.isVirtualWorkspace=l}),define(Z[41],ee([0,1,22,15,107]),function($,t,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isResolverExtension=t.isAuthenticationProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function I(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}t.getWorkspaceSupportTypeMessage=I;function R(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}t.isIExtensionIdentifier=R,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(T=t.ExtensionType||(t.ExtensionType={}));class l{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,u){if(typeof S=="undefined"||S===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof S=="string"||typeof u=="string"){let c=typeof S=="string"?S:S.value,v=typeof u=="string"?u:u.value;return C.equalsIgnoreCase(c,v)}return S._lower===u._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}t.ExtensionIdentifier=l;function d(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}t.isLanguagePackExtension=d;function E(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}t.isAuthenticationProviderExtension=E;function L(g,S){if(S&&g.enableProposedApi){const u=`onResolveRemoteAuthority:${(0,w.getRemoteName)(S)}`;return g.activationEvents?.indexOf(u)!==-1}return!1}t.isResolverExtension=L,t.IBuiltinExtensionsScannerService=(0,b.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[24],ee([0,1,22,41]),function($,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function w(u,c){return u.uuid&&c.uuid?u.uuid===c.uuid:u.id===c.id?!0:(0,C.compareIgnoreCase)(u.id,c.id)===0}t.areSameExtensions=w;class I{constructor(c,v){this.version=v,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof I?w(this,c)&&this.version===c.version:!1}}t.ExtensionIdentifierWithVersion=I;function R(u,c){return`${u}.${c}`}t.getExtensionId=R;function T(u){return u.toLocaleLowerCase()}t.adoptToGalleryExtensionId=T;function l(u,c){return T(R(u,c))}t.getGalleryExtensionId=l;function d(u,c){const v=[],y=f=>{for(const h of v)if(h.some(o=>w(c(o),c(f))))return h;return null};for(const f of u){const h=y(f);h?h.push(f):v.push([f])}return v}t.groupByExtension=d;function E(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=E;function L(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}t.getGalleryExtensionTelemetryData=L,t.BetterMergeId=new b.ExtensionIdentifier("pprice.better-merge");function g(u){const c=new Set;for(const v of u)v.malicious&&c.add(v.id.id);return c}t.getMaliciousExtensionsSet=g;function S(u,c){const v=[],y=c.manifest.extensionDependencies?.slice(0)??[];for(;y.length;){const f=y.shift();if(f&&v.every(h=>!w(h.identifier,{id:f}))){const h=u.filter(o=>w(o.identifier,{id:f}));h.length===1&&(v.push(h[0]),y.push(...h[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}t.getExtensionDependencies=S}),define(Z[108],ee([0,1,25,9,64,7,42,8,78,23,24,41]),function($,t,C,b,w,I,R,T,l,d,E,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const g=f=>(0,l.localize)(0,null,f),S=(0,l.localize)(1,null,"ms-dotnettools.csharp");function u(f,h){return h?`${f.publisher}.${f.name}@${f.version}`:`${f.publisher}.${f.name}`}const c=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function v(f){const h=c.exec(f);return h&&h[1]?[(0,E.adoptToGalleryExtensionId)(h[1]),h[2]]:[(0,E.adoptToGalleryExtensionId)(f),void 0]}t.getIdAndVersion=v;let y=class{constructor(h,o){this.extensionManagementService=h,this.extensionGalleryService=o}get location(){}async listExtensions(h,o,s=console){let e=await this.extensionManagementService.getInstalled(1);const i=L.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(o&&o!==""){if(i.indexOf(o.toLowerCase())<0){s.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(r=>r.manifest.categories?r.manifest.categories.map(m=>m.toLowerCase()).indexOf(o.toLowerCase())>-1:!1)}else if(o===""){s.log("Possible Categories: "),i.forEach(r=>{s.log(r)});return}this.location&&s.log((0,l.localize)(2,null,this.location)),e=e.sort((r,a)=>r.identifier.id.localeCompare(a.identifier.id));let n;for(let r of e)n!==r.identifier.id&&(n=r.identifier.id,s.log(u(r.manifest,h)))}async installExtensions(h,o,s,e,i=console){const n=[],r=[];h.length&&i.log(this.location?(0,l.localize)(3,null,this.location):(0,l.localize)(4,null));const a=await this.extensionManagementService.getInstalled(1),m=(p,O)=>{const A=a.find(W=>(0,E.areSameExtensions)(W.identifier,{id:p}));if(A){if(!O&&!e)return i.log((0,l.localize)(5,null,p,A.manifest.version,p)),!1;if(O&&A.manifest.version===O)return i.log((0,l.localize)(6,null,`${p}@${O}`)),!1}return!0},P=[],F=[];for(const p of h)if(p instanceof T.URI)P.push(p);else{const[O,A]=v(p);m(O,A)&&F.push({id:O,version:A,installOptions:{isBuiltin:!1,isMachineScoped:s}})}for(const p of o){const[O,A]=v(p);m(O,A)&&F.push({id:O,version:A,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(P.length&&await Promise.all(P.map(async p=>{try{const O=await this.installVSIX(p,{isBuiltin:!1,isMachineScoped:s},e,i);O&&r.push(O)}catch(O){i.error(O.message||O.stack||O),n.push(p.toString())}})),F.length){const p=await this.getGalleryExtensions(F);await Promise.all(F.map(async O=>{const A=p.get(O.id.toLowerCase());if(A)try{const W=await this.installFromGallery(O,A,a,e,i);W&&r.push(W)}catch(W){i.error(W.message||W.stack||W),n.push(O.id)}else i.error(`${g(O.version?`${O.id}@${O.version}`:O.id)}
${S}`),n.push(O.id)}))}if(n.length)throw new Error((0,l.localize)(7,null,n.join(", ")))}async installVSIX(h,o,s,e){const i=await this.extensionManagementService.getManifest(h);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,s,e))try{return await this.extensionManagementService.install(h,o),e.log((0,l.localize)(8,null,(0,w.getBaseLabel)(h))),i}catch(r){if((0,b.isPromiseCanceledError)(r))return e.log((0,l.localize)(9,null,(0,w.getBaseLabel)(h))),null;throw r}return null}async getGalleryExtensions(h){const o=new Map,s=await this.extensionGalleryService.getExtensions(h,C.CancellationToken.None);for(const e of s)o.set(e.identifier.id.toLowerCase(),e);return o}async installFromGallery({id:h,version:o,installOptions:s},e,i,n,r){const a=await this.extensionGalleryService.getManifest(e,C.CancellationToken.None);if(a&&!this.validateExtensionKind(a,r))return null;const m=i.find(P=>(0,E.areSameExtensions)(P.identifier,e.identifier));if(m){if(e.version===m.manifest.version)return r.log((0,l.localize)(10,null,o?`${h}@${o}`:h)),null;r.log((0,l.localize)(11,null,h,e.version))}try{return s.isBuiltin?r.log(o?(0,l.localize)(12,null,h,o):(0,l.localize)(13,null,h)):r.log(o?(0,l.localize)(14,null,h,o):(0,l.localize)(15,null,h)),await this.extensionManagementService.installFromGallery(e,{...s,installGivenVersion:!!o}),r.log((0,l.localize)(16,null,h,e.version)),a}catch(P){if((0,b.isPromiseCanceledError)(P))return r.log((0,l.localize)(17,null,h)),null;throw P}}validateExtensionKind(h,o){return!0}async validateVSIX(h,o,s){const e={id:(0,E.getGalleryExtensionId)(h.publisher,h.name)},n=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,E.areSameExtensions)(e,r.identifier)&&(0,R.gt)(r.manifest.version,h.version));return n&&!o?(s.log((0,l.localize)(18,null,n.identifier.id,n.manifest.version,h.version)),!1):this.validateExtensionKind(h,s)}async uninstallExtensions(h,o,s=console){const e=async n=>{if(n instanceof T.URI){const r=await this.extensionManagementService.getManifest(n);return u(r)}return n},i=[];for(const n of h){const r=await e(n),m=(await this.extensionManagementService.getInstalled()).filter(P=>(0,E.areSameExtensions)(P.identifier,{id:r}));if(!m.length)throw new Error(`${this.notInstalled(r)}
${S}`);if(m.some(P=>P.type===0)){s.log((0,l.localize)(19,null,r));return}if(!o&&m.some(P=>P.isBuiltin)){s.log((0,l.localize)(20,null,r));return}s.log((0,l.localize)(21,null,r));for(const P of m)await this.extensionManagementService.uninstall(P),i.push(P);this.location?s.log((0,l.localize)(22,null,r,this.location)):s.log((0,l.localize)(23,null,r))}}async locateExtension(h,o=console){const s=await this.extensionManagementService.getInstalled();h.forEach(e=>{s.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===I.Schemas.file){o.log(i.location.fsPath);return}})})}notInstalled(h){return this.location?(0,l.localize)(24,null,h,this.location):(0,l.localize)(25,null,h)}};y=de([ce(0,d.IExtensionManagementService),ce(1,d.IExtensionGalleryService)],y),t.ExtensionManagementCLIService=y}),define(Z[109],ee([0,1,6,9,2,10,19,42,8,31,12,21,23,24,16,14]),function($,t,C,b,w,I,R,T,l,d,E,L,g,S,u,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let y=class extends w.Disposable{constructor(h,o,s,e){super();this.fileService=o,this.extensionGalleryService=s,this.logService=e,this.extensionsDownloadDir=l.URI.file(h.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(h,o){await this.cleanUpPromise;const s=this.getName(h),e=(0,R.joinPath)(this.extensionsDownloadDir,s);if(!await this.fileService.exists(e)){const i=(0,R.joinPath)(this.extensionsDownloadDir,`.${(0,d.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(h,i,o);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(r){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",h.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(h){await this.cleanUpPromise,await this.fileService.del(h)}async rename(h,o,s){try{await E.Promises.rename(h.fsPath,o.fsPath)}catch(e){if(I.isWindows&&e&&e.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${h} to ${o} with 'EPERM' error. Trying again...`),this.rename(h,o,s);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const h=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(h.children){const o=[],s=[];for(const n of h.children){const r=this.parse(n.name);r&&s.push([r,n])}const e=(0,S.groupByExtension)(s,([n])=>n),i=[];for(const n of e)n.sort((r,a)=>T.rcompare(r[0].version,a[0].version)),o.push(...n.slice(1).map(r=>r[1].resource)),i.push(n[0][1]);i.sort((n,r)=>n.mtime-r.mtime),o.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await C.Promises.settled(o.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(h){this.logService.error(h)}}getName(h){return this.cache?`${new S.ExtensionIdentifierWithVersion(h.identifier,h.version).key().toLowerCase()}${h.properties.targetPlatform!=="undefined"?`-${h.properties.targetPlatform}`:""}`:(0,d.generateUuid)()}parse(h){const o=v.exec(h);return o&&o[1]&&o[2]?new S.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};y=de([ce(0,L.INativeEnvironmentService),ce(1,u.IFileService),ce(2,g.IExtensionGalleryService),ce(3,c.ILogService)],y),t.ExtensionsDownloader=y}),define(Z[110],ee([0,1,2,3,12,41]),function($,t,C,b,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class R extends C.Disposable{constructor(l,d){super();this.environmentService=l,this.extensionsManifestCache=(0,b.join)(this.environmentService.userDataPath,I.MANIFEST_CACHE_FOLDER,I.USER_MANIFEST_CACHE_FILE),this._register(d.onDidInstallExtensions(E=>this.onDidInstallExtensions(E))),this._register(d.onDidUninstallExtension(E=>this.onDidUnInstallExtension(E)))}onDidInstallExtensions(l){l.some(d=>!!d.local)&&this.invalidate()}onDidUnInstallExtension(l){l.error||this.invalidate()}invalidate(){w.Promises.rm(this.extensionsManifestCache,w.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=R}),define(Z[111],ee([0,1,13,2,19,8,21,24,16,14]),function($,t,C,b,w,I,R,T,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let E=class extends b.Disposable{constructor(g,S,u,c){super();this.extensionsManagementService=g,this.logService=c,this._onDidChangeExtensionsByAnotherSource=this._register(new C.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(f=>{this.installedExtensions=f.map(h=>h.identifier),this.startTimestamp=Date.now()}),this._register(g.onInstallExtension(f=>this.onInstallExtension(f))),this._register(g.onDidInstallExtensions(f=>this.onDidInstallExtensions(f))),this._register(g.onDidUninstallExtension(f=>this.onDidUninstallExtension(f)));const v=I.URI.file(u.extensionsPath),y=new w.ExtUri(f=>!S.hasCapability(f,1024));this._register(S.watch(v)),this._register(C.Event.filter(S.onDidChangeFilesRaw,f=>f.changes.some(h=>this.doesChangeAffects(h,v,y)))(()=>this.onDidChange()))}doesChangeAffects(g,S,u){return u.isEqual(u.dirname(g.resource),S)?u.isEqual(g.resource,u.joinPath(S,".obsolete"))?!0:!(g.type!==1&&g.type!==2||u.basename(g.resource).startsWith(".")):!1}onInstallExtension(g){this.addInstallingExtension(g.identifier)}onDidInstallExtensions(g){for(const S of g)this.removeInstallingExtension(S.identifier),S.local&&this.addInstalledExtension(S.identifier)}onDidUninstallExtension(g){g.error||this.removeInstalledExtension(g.identifier)}addInstallingExtension(g){this.removeInstallingExtension(g),this.installingExtensions.push(g)}removeInstallingExtension(g){this.installingExtensions=this.installingExtensions.filter(S=>!(0,T.areSameExtensions)(S,g))}addInstalledExtension(g){this.installedExtensions&&(this.removeInstalledExtension(g),this.installedExtensions.push(g))}removeInstalledExtension(g){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(S=>!(0,T.areSameExtensions)(S,g)))}async onDidChange(){if(this.installedExtensions){const g=await this.extensionsManagementService.getInstalled(1),S=g.filter(c=>[...this.installingExtensions,...this.installedExtensions].some(v=>(0,T.areSameExtensions)(v,c.identifier))?!1:c.installedTimestamp&&c.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",c.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",c.identifier.id),!1)),u=this.installedExtensions.filter(c=>this.installingExtensions.some(v=>(0,T.areSameExtensions)(v,c))?!1:g.every(v=>!(0,T.areSameExtensions)(v.identifier,c))?(this.logService.info("Detected extension removed from another source",c.id),!0):!1);this.installedExtensions=g.map(c=>c.identifier),(S.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:S,removed:u})}}};E=de([ce(1,l.IFileService),ce(2,R.INativeEnvironmentService),ce(3,d.ILogService)],E),t.ExtensionsWatcher=E}),define(Z[112],ee([0,1,134,20,6,2,7,3,12,21,23,24,56,14]),function($,t,C,b,w,I,R,T,l,d,E,L,g,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let u=class extends I.Disposable{constructor(y,f,h){super();this.extensionManagementService=y,this.logService=h,this.cache=this._register(new c(f,h)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const y=await this.cache.getLanguagePacks(),f=["en",...Object.keys(y)];return(0,b.distinct)(f)}async postInstallExtension(y){y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",y.identifier.id),await this.update())}async postUninstallExtension(y){const f=await this.cache.getLanguagePacks();Object.keys(f).some(h=>f[h]&&f[h].extensions.some(o=>(0,L.areSameExtensions)(o.extensionIdentifier,y.identifier)))&&(this.logService.info("Removing language packs from the extension",y.identifier.id),await this.update())}async update(){const[y,f]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),h=await this.cache.update(f);return!(0,b.equals)(Object.keys(y),Object.keys(h))}};u=de([ce(0,E.IExtensionManagementService),ce(1,d.INativeEnvironmentService),ce(2,S.ILogService)],u),t.LocalizationsService=u;let c=class extends I.Disposable{constructor(y,f){super();this.logService=f,this.languagePacks={},this.languagePacksFilePath=(0,T.join)(y.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new w.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(y){return this.withLanguagePacks(f=>{Object.keys(f).forEach(h=>delete f[h]),this.createLanguagePacksFromExtensions(f,...y)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(y,...f){for(const h of f)h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(y,h);Object.keys(y).forEach(h=>this.updateHash(y[h]))}createLanguagePacksFromExtension(y,f){const h=f.identifier,o=f.manifest.contributes&&f.manifest.contributes.localizations?f.manifest.contributes.localizations:[];for(const s of o)if(f.location.scheme===R.Schemas.file&&(0,g.isValidLocalization)(s)){let e=y[s.languageId];e||(e={hash:"",extensions:[],translations:{}},y[s.languageId]=e);let i=e.extensions.filter(n=>(0,L.areSameExtensions)(n.extensionIdentifier,h))[0];i?i.version=f.manifest.version:e.extensions.push({extensionIdentifier:h,version:f.manifest.version});for(const n of s.translations)e.translations[n.id]=(0,T.join)(f.location.fsPath,n.path)}}updateHash(y){if(y){const f=(0,C.createHash)("md5");for(const h of y.extensions)f.update(h.extensionIdentifier.uuid||h.extensionIdentifier.id).update(h.version);y.hash=f.digest("hex")}}withLanguagePacks(y=()=>null){return this.languagePacksFileLimiter.queue(()=>{let f=null;return l.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,h=>h.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(h)).then(h=>{try{return JSON.parse(h)}catch(o){return{}}}).then(h=>(f=y(h),h)).then(h=>{for(const s of Object.keys(h))h[s]||delete h[s];this.languagePacks=h,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),l.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>f,h=>this.logService.error(h))})}};c=de([ce(0,d.INativeEnvironmentService),ce(1,S.ILogService)],c)}),define(Z[43],ee([0,1,17,86,33,15,26]),function($,t,C,b,w,I,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,I.createDecorator)("requestService");function T(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}t.isSuccess=T;function l(u){return u.res.statusCode===204}async function d(u){if(!T(u))throw new Error("Server returned "+u.res.statusCode);return l(u)?null:(await(0,C.streamToBuffer)(u.stream)).toString()}t.asText=d;async function E(u){if(!T(u))throw new Error("Server returned "+u.res.statusCode);if(l(u))return null;const v=(await(0,C.streamToBuffer)(u.stream)).toString();try{return JSON.parse(v)}catch(y){throw y.message+=`:
`+v,y}}t.asJson=E;function L(u){S(u)}t.updateProxyConfigurationsScope=L;let g;function S(u){const c=R.Registry.as(w.Extensions.Configuration),v=g;g={id:"http",order:15,title:(0,b.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,b.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,b.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,b.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,b.localize)(4,null),(0,b.localize)(5,null),(0,b.localize)(6,null),(0,b.localize)(7,null)],default:"override",description:(0,b.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,b.localize)(9,null),restricted:!0}}},c.updateConfigurations({add:[g],remove:v?[v]:[]})}S(2)}),define(Z[113],ee([0,1,25,7,16,43]),function($,t,C,b,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let R=class{constructor(l,d){this.requestService=l,this.fileService=d}async download(l,d,E=C.CancellationToken.None){if(l.scheme===b.Schemas.file||l.scheme===b.Schemas.vscodeRemote){await this.fileService.copy(l,d);return}const L={type:"GET",url:l.toString()},g=await this.requestService.request(L,E);if(g.res.statusCode===200)await this.fileService.writeFile(d,g.stream);else{const S=await(0,I.asText)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${S}`)}}};R=de([ce(0,I.IRequestService),ce(1,w.IFileService)],R),t.DownloadService=R}),define(Z[114],ee([0,1,115,11]),function($,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function w(R,T){return R.protocol==="http:"?T.HTTP_PROXY||T.http_proxy||null:R.protocol==="https:"&&(T.HTTPS_PROXY||T.https_proxy||T.HTTP_PROXY||T.http_proxy)||null}async function I(R,T,l={}){const d=(0,C.parse)(R),E=l.proxyUrl||w(d,T);if(!E)return null;const L=(0,C.parse)(E);if(!/^https?:$/.test(L.protocol||""))return null;const g={host:L.hostname||"",port:L.port||(L.protocol==="https"?"443":"80"),auth:L.auth,rejectUnauthorized:(0,b.isBoolean)(l.strictSSL)?l.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((S,u)=>{$(["http-proxy-agent"],S,u)}))(g):new(await new Promise((S,u)=>{$(["https-proxy-agent"],S,u)}))(g)}t.getProxyAgent=I}),define(Z[116],ee([0,1,17,31]),function($,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function w(I,R,T){let l=T&&T.get("storage.serviceMachineId",0)||null;if(l)return l;try{const E=(await R.readFile(I.serviceMachineIdResource)).value.toString();l=(0,b.isUUID)(E)?E:null}catch(d){l=null}if(!l){l=(0,b.generateUuid)();try{await R.writeFile(I.serviceMachineIdResource,C.VSBuffer.fromString(l))}catch(d){}}return T&&T.store("storage.serviceMachineId",l,0,1),l}t.getServiceMachineId=w}),define(Z[117],ee([0,1,6,13,2,11,67,15]),function($,t,C,b,w,I,R,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const l="__$__targetStorageMarker";t.IStorageService=(0,T.createDecorator)("storageService");var d;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(d=t.WillSaveStateReason||(t.WillSaveStateReason={}));var E;(function(c){c[c.GLOBAL=0]="GLOBAL",c[c.WORKSPACE=1]="WORKSPACE"})(E=t.StorageScope||(t.StorageScope={}));var L;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(L=t.StorageTarget||(t.StorageTarget={}));class g extends w.Disposable{constructor(v={flushInterval:g.DEFAULT_FLUSH_INTERVAL}){super();this.options=v,this._onDidChangeValue=this._register(new b.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new b.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new b.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new C.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new w.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,C.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,w.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,y){y===l?(v===0?this._globalKeyTargets=void 0:v===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:v})):this._onDidChangeValue.fire({scope:v,key:y,target:this.getKeyTargets(v)[y]})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,y,f){return this.getStorage(y)?.get(v,f)}getBoolean(v,y,f){return this.getStorage(y)?.getBoolean(v,f)}getNumber(v,y,f){return this.getStorage(y)?.getNumber(v,f)}store(v,y,f,h){if((0,I.isUndefinedOrNull)(y)){this.remove(v,f);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,f,h),this.getStorage(f)?.set(v,y)})}remove(v,y){this.withPausedEmitters(()=>{this.updateKeyTarget(v,y,void 0),this.getStorage(y)?.delete(v)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,y){const f=[],h=this.getKeyTargets(v);for(const o of Object.keys(h))h[o]===y&&f.push(o);return f}updateKeyTarget(v,y,f){const h=this.getKeyTargets(y);typeof f=="number"?h[v]!==f&&(h[v]=f,this.getStorage(y)?.set(l,JSON.stringify(h))):typeof h[v]=="number"&&(delete h[v],this.getStorage(y)?.set(l,JSON.stringify(h)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(v){return v===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(v){const y=this.get(l,v);if(y)try{return JSON.parse(y)}catch(f){}return Object.create(null)}isNew(v){return this.getBoolean(t.IS_NEW_KEY,v)===!0}async flush(v=d.NONE){this._onWillSaveState.fire({reason:v}),await C.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const v=this.getStorage(0)?.items??new Map,y=this.getStorage(1)?.items??new Map;return u(v,y,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=g,g.DEFAULT_FLUSH_INTERVAL=60*1e3;class S extends g{constructor(){super();this.globalStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.globalStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v)))}getStorage(v){return v===0?this.globalStorage:this.workspaceStorage}getLogDetails(v){return v===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(v){}}t.InMemoryStorageService=S;async function u(c,v,y,f){const h=a=>{try{return JSON.parse(a)}catch(m){return a}},o=new Map,s=new Map;c.forEach((a,m)=>{o.set(m,a),s.set(m,h(a))});const e=new Map,i=new Map;v.forEach((a,m)=>{e.set(m,a),i.set(m,h(a))}),console.group(`Storage: Global (path: ${y})`);let n=[];o.forEach((a,m)=>{n.push({key:m,value:a})}),console.table(n),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${f})`);let r=[];e.forEach((a,m)=>{r.push({key:m,value:a})}),console.table(r),console.groupEnd(),console.log(i)}t.logStorage=u}),define(Z[118],ee([0,1,10,28,8,31]),function($,t,C,b,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function R(d){if(C.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function T(d,E,L,g,S,u,c,v,y,f){const h=Object.create(null);h["common.machineId"]=c,h.sessionID=(0,I.generateUuid)()+Date.now(),h.commitHash=S,h.version=u,h["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,C.PlatformToString)(C.platform),h["common.nodePlatform"]=b.platform,h["common.nodeArch"]=g,h["common.product"]=f||"desktop";const o=l(v||[]);o&&(h["common.msftInternal"]=o);let s=0;const e=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),C.isLinuxSnap&&(h["common.snap"]="true");const i=R(L);i&&(h["common.platformDetail"]=i);try{const n=await d.readFile(w.URI.file(y));h["common.source"]=n.value.toString().slice(0,30)}catch(n){}return h}t.resolveCommonProperties=T;function l(d){const E=b.env.USERDNSDOMAIN;if(!E)return!1;const L=E.toLowerCase();return d.some(g=>L===g)}t.verifyMicrosoftInternalDomain=l}),define(Z[29],ee([0,1,15]),function($,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.TELEMETRY_OLD_SETTING_ID=t.TELEMETRY_SETTING_ID=t.TELEMETRY_SECTION_ID=t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,C.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,C.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId",t.TELEMETRY_SECTION_ID="telemetry",t.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",t.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var b;(function(I){I[I.NONE=0]="NONE",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(b=t.TelemetryLevel||(t.TelemetryLevel={}));var w;(function(I){I.OFF="off",I.ERROR="error",I.ON="on"})(w=t.TelemetryConfiguration||(t.TelemetryConfiguration={}))}),define(Z[119],ee([0,1,20,6,25,9,13,2,10,8,76,23,24,14,32,29]),function($,t,C,b,w,I,R,T,l,d,E,L,g,S,u,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=t.INSTALL_ERROR_LOCAL=t.ERROR_UNKNOWN=t.INSTALL_ERROR_VALIDATING=void 0,t.INSTALL_ERROR_VALIDATING="validating",t.ERROR_UNKNOWN="unknown",t.INSTALL_ERROR_LOCAL="local";let v=class extends T.Disposable{constructor(s,e,i){super();this.galleryService=s,this.telemetryService=e,this.logService=i,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new R.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new R.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new R.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new R.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,T.toDisposable)(()=>{this.installingExtensions.forEach(n=>n.cancel()),this.uninstallingExtensions.forEach(n=>n.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(s){const e=await this.getTargetPlatform();return s.allTargetPlatforms.some(i=>(0,L.isTargetPlatformCompatible)(i,s.allTargetPlatforms,e))}async installFromGallery(s,e={}){if(!this.galleryService.isEnabled())throw new Error(E.localize(0,null));if(!await this.canInstall(s)){const n=await this.getTargetPlatform(),r=new L.ExtensionManagementError(E.localize(1,null,s.identifier.id,u.default.nameLong,(0,L.TargetPlatformToString)(n)),t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Cannot install extension.",s.identifier.id,r.message),f(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(s),void 0,r),r}try{s=await this.checkAndGetCompatibleVersion(s,!e.installGivenVersion)}catch(n){throw this.logService.error((0,I.getErrorMessage)(n)),f(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(s),void 0,n),n}const i=await this.galleryService.getManifest(s,w.CancellationToken.None);if(i===null){const n=new L.ExtensionManagementError(`Missing manifest for extension ${s.identifier.id}`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",s.identifier.id,n.message),f(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(s),void 0,n),n}if(i.version!==s.version){const n=new L.ExtensionManagementError(`Cannot install '${s.identifier.id}' extension because of version mismatch in Marketplace`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error(n.message),f(this.telemetryService,"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(s),void 0,n),n}return this.installExtension(i,s,e)}async uninstall(s,e={}){return this.logService.trace("ExtensionManagementService#uninstall",s.identifier.id),this.unininstallExtension(s,e)}async reinstallFromGallery(s){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",s.identifier.id),!this.galleryService.isEnabled())throw new Error(E.localize(2,null));const e=await this.findGalleryExtension(s);if(!e)throw new Error(E.localize(3,null));await this.createUninstallExtensionTask(s,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsReport(){const s=new Date().getTime();return(!this.reportedExtensions||s-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=s),this.reportedExtensions}registerParticipant(s){this.participants.push(s)}async installExtension(s,e,i){if(!d.URI.isUri(e)){let P=this.installingExtensions.get(new g.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(P)return this.logService.info("Extensions is already requested to install",e.identifier.id),P.waitUntilTaskIsFinished();i={...i,installOnlyNewlyAddedFromExtensionPack:!0}}const n=[],r=[],a=this.createInstallExtensionTask(s,e,i);d.URI.isUri(e)||this.installingExtensions.set(new g.ExtensionIdentifierWithVersion(a.identifier,s.version).key(),a),this._onInstallExtension.fire({identifier:a.identifier,source:e}),this.logService.info("Installing extension:",a.identifier.id),n.push({task:a,manifest:s});let m=!1;try{if(i.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",a.identifier.id);else try{const F=await this.getAllDepsAndPackExtensionsToInstall(a.identifier,s,!!i.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:p,manifest:O}of F)if(m=m||!!O.extensionDependencies?.some(A=>(0,g.areSameExtensions)({id:A},a.identifier)),this.installingExtensions.has(new g.ExtensionIdentifierWithVersion(p.identifier,p.version).key()))this.logService.info("Extension is already requested to install",p.identifier.id);else{const A=this.createInstallExtensionTask(O,p,{...i,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new g.ExtensionIdentifierWithVersion(A.identifier,O.version).key(),A),this._onInstallExtension.fire({identifier:A.identifier,source:p}),this.logService.info("Installing extension:",A.identifier.id),n.push({task:A,manifest:O})}}catch(F){if(d.URI.isUri(a.source))(0,C.isNonEmptyArray)(s.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",a.identifier.id,F.message),(0,C.isNonEmptyArray)(s.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",a.identifier.id,F.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",a.identifier.id),this.logService.error(F),F}const P=n.reduce((F,{task:p,manifest:O})=>(F.set(p.identifier.id.toLowerCase(),{task:p,manifest:O}),F),new Map);for(;P.size;){let F;const p=[...P.values()].filter(({manifest:O})=>!O.extensionDependencies?.some(A=>P.has(A.toLowerCase())));p.length?F=P.size===1?p:p.filter(({task:O})=>!(O===a&&!m)):(this.logService.info("Found extensions with circular dependencies",p.map(({task:O})=>O.identifier.id)),F=[...P.values()]),await this.joinAllSettled(F.map(async({task:O})=>{const A=new Date().getTime();try{const W=await O.run();if(await this.joinAllSettled(this.participants.map(Y=>Y.postInstall(W,O.source,i,w.CancellationToken.None))),!d.URI.isUri(O.source)&&(f(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-A,void 0),l.isWeb&&O.operation===1))try{await this.galleryService.reportStatistic(W.manifest.publisher,W.manifest.name,W.manifest.version,"install")}catch(Y){}r.push({local:W,identifier:O.identifier,operation:O.operation,source:O.source})}catch(W){throw d.URI.isUri(O.source)||f(this.telemetryService,O.operation===2?"extensionGallery:update":"extensionGallery:install",(0,g.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-A,W),this.logService.error("Error while installing the extension:",O.identifier.id),this.logService.error(W),W}finally{P.delete(O.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:F})=>this.logService.info("Extension installed successfully:",F.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:F})=>(0,g.areSameExtensions)(F,a.identifier))[0].local}catch(P){if(n.forEach(({task:F})=>F.cancel()),r.length)try{const F=await Promise.allSettled(r.map(({local:p})=>this.createUninstallExtensionTask(p,{versionOnly:!0}).run()));for(let p=0;p<F.length;p++){const O=F[p],{identifier:A}=r[p];O.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",A.id):this.logService.warn("Rollback: Error while uninstalling extension",A.id,(0,I.getErrorMessage)(O.reason))}}catch(F){this.logService.warn("Error while rolling back extensions",(0,I.getErrorMessage)(F),r.map(({identifier:p})=>p.id))}throw this.logService.error("Failed to install extension:",a.identifier.id,(0,I.getErrorMessage)(P)),this._onDidInstallExtensions.fire(n.map(({task:F})=>({identifier:F.identifier,operation:1,source:F.source}))),P instanceof Error&&(P.name=P&&P.code?P.code:t.ERROR_UNKNOWN),P}finally{for(const{task:P,manifest:F}of n)if(!d.URI.isUri(P.source)){const p=new g.ExtensionIdentifierWithVersion(P.identifier,F.version).key();this.installingExtensions.delete(p)||this.logService.warn("Installation task is not found in the cache",p)}}}async joinAllSettled(s){const e=[],i=[],n=await Promise.allSettled(s);for(const r of n)r.status==="fulfilled"?e.push(r.value):i.push(r.reason);if(i.length)throw y(i);return e}async getAllDepsAndPackExtensionsToInstall(s,e,i){if(!this.galleryService.isEnabled())return[];let n=await this.getInstalled();const r=[s,...n.map(P=>P.identifier)],a=[],m=async(P,F)=>{const p=F.extensionDependencies||[],O=[...p];if(F.extensionPack){const A=i?n.find(W=>(0,g.areSameExtensions)(W.identifier,P)):void 0;for(const W of F.extensionPack)A&&A.manifest.extensionPack&&A.manifest.extensionPack.some(Y=>(0,g.areSameExtensions)({id:Y},{id:W}))||O.every(Y=>!(0,g.areSameExtensions)({id:Y},{id:W}))&&O.push(W)}if(O.length){const A=[...r,...a.map(Y=>Y.gallery.identifier)],W=O.filter(Y=>A.every(te=>!(0,g.areSameExtensions)(te,{id:Y})));if(W.length){const Y=await this.galleryService.query({names:W,pageSize:O.length},w.CancellationToken.None);for(const te of Y.firstPage){if(A.find(ue=>(0,g.areSameExtensions)(ue,te.identifier)))continue;if(!p.some(ue=>(0,g.areSameExtensions)({id:ue},te.identifier))&&!await this.canInstall(te)){this.logService.info("Skipping the packed extension as it cannot be installed",te.identifier.id);continue}const ie=await this.checkAndGetCompatibleVersion(te,!0),ae=await this.galleryService.getManifest(ie,w.CancellationToken.None);if(ae===null)throw new L.ExtensionManagementError(`Missing manifest for extension ${ie.identifier.id}`,t.INSTALL_ERROR_VALIDATING);a.push({gallery:ie,manifest:ae}),await m(ie.identifier,ae)}}}};return await m(s,e),n=await this.getInstalled(),a.filter(P=>!n.some(F=>(0,g.areSameExtensions)(F.identifier,P.gallery.identifier)))}async checkAndGetCompatibleVersion(s,e){if(await this.isMalicious(s))throw new L.ExtensionManagementError(E.localize(4,null,s.identifier.id),L.INSTALL_ERROR_MALICIOUS);const i=await this.getCompatibleVersion(s,e);if(!i)throw new L.ExtensionManagementError(E.localize(5,null,s.identifier.id,u.default.version),L.INSTALL_ERROR_INCOMPATIBLE);return i}async getCompatibleVersion(s,e){const i=await this.getTargetPlatform();let n=null;return await this.galleryService.isExtensionCompatible(s,i)&&(n=s),!n&&e&&(n=await this.galleryService.getCompatibleExtension(s,i)),n}async isMalicious(s){const e=await this.getExtensionsReport();return(0,g.getMaliciousExtensionsSet)(e).has(s.identifier.id)}async unininstallExtension(s,e){const i=this.uninstallingExtensions.get(s.identifier.id.toLowerCase());if(i)return this.logService.info("Extensions is already requested to uninstall",s.identifier.id),i.waitUntilTaskIsFinished();const n=(P,F)=>{const p=this.createUninstallExtensionTask(P,F);return this.uninstallingExtensions.set(p.extension.identifier.id.toLowerCase(),p),this.logService.info("Uninstalling extension:",P.identifier.id),this._onUninstallExtension.fire(P.identifier),p},r=(P,F)=>{F?this.logService.error("Failed to uninstall extension:",P.identifier.id,F.message):this.logService.info("Successfully uninstalled extension:",P.identifier.id),f(this.telemetryService,"extensionGallery:uninstall",(0,g.getLocalExtensionTelemetryData)(P),void 0,F),this._onDidUninstallExtension.fire({identifier:P.identifier,error:F?.code})},a=[],m=[];try{a.push(n(s,{}));const P=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",s.identifier.id);else{const F=this.getAllPackExtensionsToUninstall(s,P);for(const p of F)this.uninstallingExtensions.has(p.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",p.identifier.id):a.push(n(p,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",s.identifier.id):this.checkForDependents(a.map(F=>F.extension),P,s),await this.joinAllSettled(a.map(async F=>{try{if(await F.run(),await this.joinAllSettled(this.participants.map(p=>p.postUninstall(F.extension,e,w.CancellationToken.None))),F.extension.identifier.uuid)try{await this.galleryService.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,"uninstall")}catch(p){}r(F.extension)}catch(p){const O=p instanceof L.ExtensionManagementError?p:new L.ExtensionManagementError((0,I.getErrorMessage)(p),t.ERROR_UNKNOWN);throw r(F.extension,O),O}finally{m.push(F)}}))}catch(P){const F=P instanceof L.ExtensionManagementError?P:new L.ExtensionManagementError((0,I.getErrorMessage)(P),t.ERROR_UNKNOWN);for(const p of a){try{p.cancel()}catch(O){}m.includes(p)||r(p.extension,F)}throw F}finally{for(const P of a)this.uninstallingExtensions.delete(P.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",P.extension.identifier.id)}}checkForDependents(s,e,i){for(const n of s){const r=this.getDependents(n,e);if(r.length){const a=r.filter(m=>!s.some(P=>(0,g.areSameExtensions)(P.identifier,m.identifier)));if(a.length)throw new Error(this.getDependentsErrorMessage(n,a,i))}}}getDependentsErrorMessage(s,e,i){return i===s?e.length===1?E.localize(6,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?E.localize(7,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):E.localize(8,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?E.localize(9,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?E.localize(10,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):E.localize(11,null,i.manifest.displayName||i.manifest.name,s.manifest.displayName||s.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(s,e,i=[]){if(i.indexOf(s)!==-1)return[];i.push(s);const n=s.manifest.extensionPack?s.manifest.extensionPack:[];if(n.length){const r=e.filter(m=>!m.isBuiltin&&n.some(P=>(0,g.areSameExtensions)({id:P},m.identifier))),a=[];for(const m of r)a.push(...this.getAllPackExtensionsToUninstall(m,e,i));return[...r,...a]}return[]}getDependents(s,e){return e.filter(i=>i.manifest.extensionDependencies&&i.manifest.extensionDependencies.some(n=>(0,g.areSameExtensions)({id:n},s.identifier)))}async findGalleryExtension(s){if(s.identifier.uuid){const e=await this.findGalleryExtensionById(s.identifier.uuid);return e||this.findGalleryExtensionByName(s.identifier.id)}return this.findGalleryExtensionByName(s.identifier.id)}async findGalleryExtensionById(s){return(await this.galleryService.query({ids:[s],pageSize:1},w.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(s){return(await this.galleryService.query({names:[s],pageSize:1},w.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const s=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${s.length} reported extensions from service`),s}catch(s){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};v=de([ce(0,L.IExtensionGalleryService),ce(1,c.ITelemetryService),ce(2,S.ILogService)],v),t.AbstractExtensionManagementService=v;function y(o){const s=Array.isArray(o)?o:[o];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((e,i)=>new Error(`${e.message}${e.message?",":""}${i instanceof Error?i.message:i}`),new Error(""))}t.joinErrors=y;function f(o,s,e,i,n){const r=n?n instanceof L.ExtensionManagementError?n.code:t.ERROR_UNKNOWN:void 0;o.publicLogError(s,{...e,success:!n,duration:i,errorcode:r})}t.reportTelemetry=f;class h{constructor(){this.barrier=new b.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,b.createCancelablePromise)(s=>this.doRun(s))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,b.createCancelablePromise)(s=>new Promise((e,i)=>{const n=s.onCancellationRequested(()=>{n.dispose(),i((0,I.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=h}),define(Z[36],ee([0,1,18,11,27,29]),function($,t,C,b,w,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryLevel=t.supportsTelemetry=t.configurationTelemetry=t.NullAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=t.NullTelemetryServiceShape=void 0;class R{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(y,f){return Promise.resolve(void 0)}publicLog2(y,f){return this.publicLog(y,f)}publicLogError(y,f){return Promise.resolve(void 0)}publicLogError2(y,f){return this.publicLogError(y,f)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}t.NullTelemetryServiceShape=R,t.NullTelemetryService=new R;class T{async publicLog(y,f,h){}async publicLogError(y,f,h){}}t.NullEndpointTelemetryService=T,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function l(v,y){return y.onDidChangeConfiguration(f=>{f.source!==6&&v.publicLog2("updateConfiguration",{configurationSource:(0,w.ConfigurationTargetToString)(f.source),configurationKeys:u(f.sourceConfig)})})}t.configurationTelemetry=l;function d(v,y){return!(y.disableTelemetry||!v.enableTelemetry)}t.supportsTelemetry=d;function E(v){const y=v.getValue(I.TELEMETRY_SETTING_ID),f=v.getValue(I.TELEMETRY_OLD_SETTING_ID);if(f!==void 0&&f===!1)return 0;switch(y??"on"){case"on":return 3;case"error":return 2;case"off":return 0}}t.getTelemetryLevel=E;function L(v){const y=Object.create(null),f=Object.create(null),h=Object.create(null);S(v,h);for(let o in h){o=o.length>150?o.substr(o.length-149):o;const s=h[o];typeof s=="number"?f[o]=s:typeof s=="boolean"?f[o]=s?1:0:typeof s=="string"?y[o]=s.substring(0,1023):typeof s!="undefined"&&s!==null&&(y[o]=s)}return{properties:y,measurements:f}}t.validateTelemetryData=L;function g(v){if(!v)return"none";let y="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(h=>{v.indexOf(`${h}+`)===0&&(y=h)}),y}t.cleanRemoteAuthority=g;function S(v,y,f=0,h){if(!!v)for(let o of Object.getOwnPropertyNames(v)){const s=v[o],e=h?h+o:o;Array.isArray(s)?y[e]=(0,C.safeStringify)(s):s instanceof Date?y[e]=s.toISOString():(0,b.isObject)(s)?f<2?S(s,y,f+1,e+"."):y[e]=(0,C.safeStringify)(s):y[e]=s}}function u(v){if(!v)return[];const y=[];return c(y,"",v),y}function c(v,y,f){f&&typeof f=="object"&&!Array.isArray(f)?Object.keys(f).forEach(h=>c(v,y?`${y}.${h}`:h,f[h])):v.push(y)}}),define(Z[120],ee([0,1,20,25,9,18,10,28,8,27,21,23,24,51,16,14,40,43,116,117,29,36]),function($,t,C,b,w,I,R,T,l,d,E,L,g,S,u,c,v,y,f,h,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=t.sortExtensionVersions=void 0;const e=R.isWeb?"web":(0,L.getTargetPlatform)(R.platform,T.arch);var i;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished"})(i||(i={}));function n(...N){return String(N.reduce((k,j)=>k|j,0))}var r;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},m={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},F={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class p{constructor(k=F){this.state=k}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(k,j=this.state.pageSize){return new p({...this.state,pageNumber:k,pageSize:j})}withFilter(k,...j){const V=[...this.state.criteria,...j.length?j.map(X=>({filterType:k,value:X})):[{filterType:k}]];return new p({...this.state,criteria:V})}withSortBy(k){return new p({...this.state,sortBy:k})}withSortOrder(k){return new p({...this.state,sortOrder:k})}withFlags(...k){return new p({...this.state,flags:k.reduce((j,V)=>j|V,0)})}withAssetTypes(...k){return new p({...this.state,assetTypes:k})}get raw(){const{criteria:k,pageNumber:j,pageSize:V,sortBy:X,sortOrder:Q,flags:se,assetTypes:re}=this.state;return{filters:[{criteria:k,pageNumber:j,pageSize:V,sortBy:X,sortOrder:Q}],assetTypes:re,flags:se}}get searchText(){const k=this.state.criteria.filter(j=>j.filterType===r.SearchText)[0];return k&&k.value?k.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(k=>String(k.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function O(N,k){const j=(N||[]).filter(V=>V.statisticName===k)[0];return j?j.value:0}function A(N){const k="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(V=>V.assetType.indexOf(k)===0).reduce((V,X)=>{const Q=oe(N,X.assetType);return Q&&V.push([X.assetType.substring(k.length),Q]),V},[])}function W(N){if(N.properties){const k=N.properties.filter(X=>X.key===a.Repository),j=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),V=k.filter(X=>j.test(X.value))[0];return V?{uri:V.value,fallbackUri:V.value}:null}return oe(N,a.Repository)}function Y(N){return{uri:`${N.fallbackAssetUri}/${a.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${a.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function te(N){const k=oe(N,a.Icon);if(k)return k;const j=L.DefaultIconPath;return{uri:j,fallbackUri:j}}function oe(N,k){return N.files.filter(V=>V.assetType===k)[0]?{uri:`${N.assetUri}/${k}`,fallbackUri:`${N.fallbackAssetUri}/${k}`}:null}function ie(N,k){const j=N.properties?N.properties.filter(X=>X.key===k):[],V=j.length>0&&j[0].value;return V?V.split(",").map(X=>(0,g.adoptToGalleryExtensionId)(X)):[]}function ae(N){const k=N.properties?N.properties.filter(j=>j.key===m.Engine):[];return k.length>0&&k[0].value||""}function ue(N){const k=N.properties?N.properties.filter(V=>V.key===m.LocalizedLanguages):[],j=k.length>0&&k[0].value||"";return j?j.split(","):[]}function G(N){return N.indexOf("preview")!==-1}function ne(N){return N.targetPlatform?(0,L.toTargetPlatform)(N.targetPlatform):"undefined"}function z(N){const k=(0,C.distinct)(N.versions.map(ne)),j=!!N.tags?.includes(L.WEB_EXTENSION_TAG),V=k.indexOf("web");return j?V===-1&&k.push("web"):V!==-1&&k.splice(V,1),k}function D(N,k){const j=(0,L.getFallbackTargetPlarforms)(k);for(let V=0;V<N.length;V++){const X=N[V];if(X.version===N[V-1]?.version){let Q=V;const se=ne(X);if(se===k)for(;Q>0&&N[Q-1].version===X.version;)Q--;else if(j.includes(se))for(;Q>0&&N[Q-1].version===X.version&&ne(N[Q-1])!==k;)Q--;Q!==V&&(N.splice(V,1),N.splice(Q,0,X))}}return N}t.sortExtensionVersions=D;function M(N,k,j,V,X){const Q=z(N);let se=N.versions[0];return se=N.versions.find(re=>re.version===se.version&&(0,L.isTargetPlatformCompatible)(ne(re),Q,X))||se,U(N,se,Q,k,j,V)}function U(N,k,j,V,X,Q){const se={manifest:oe(k,a.Manifest),readme:oe(k,a.Details),changelog:oe(k,a.Changelog),license:oe(k,a.License),repository:W(k),download:Y(k),icon:te(k),coreTranslations:A(k)};return{identifier:{id:(0,g.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:k.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,description:N.shortDescription||"",installCount:O(N.statistics,"install"),rating:O(N.statistics,"averagerating"),ratingCount:O(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:j,assets:se,properties:{dependencies:ie(k,m.Dependency),extensionPack:ie(k,m.ExtensionPack),engine:ae(k),localizedLanguages:ue(k),targetPlatform:ne(k)},preview:G(N.flags),telemetryData:{index:(X.pageNumber-1)*X.pageSize+V,querySource:Q}}}let K=class{constructor(k,j,V,X,Q,se,re,me){this.requestService=j,this.logService=V,this.environmentService=X,this.telemetryService=Q,this.fileService=se,this.productService=re,this.configurationService=me;const ye=re.extensionsGallery;this.extensionsGalleryUrl=ye&&ye.serviceUrl,this.extensionsControlUrl=ye&&ye.controlUrl,this.commonHeadersPromise=q(re.version,re,this.environmentService,this.configurationService,this.fileService,k)}api(k=""){return`${this.extensionsGalleryUrl}${k}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(k,j){const V=[];let X=new p().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,k.length).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionName,...k.map(({id:se})=>se.toLowerCase()));k.every(se=>!se.version)&&(X=X.withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties,i.IncludeLatestVersionOnly));const{galleryExtensions:Q}=await this.queryGallery(X,e,b.CancellationToken.None);for(let se=0;se<Q.length;se++){const re=Q[se];if(!re.versions.length)continue;const me=(0,g.getGalleryExtensionId)(re.publisher.publisherName,re.extensionName),ye=k.find(fe=>(0,g.areSameExtensions)(fe,{id:me}))?.version;if(ye){const fe=re.versions.find(Pe=>Pe.version===ye);fe&&V.push(U(re,fe,z(re),se,X))}else V.push(M(re,se,X,void 0,e))}return V}async getCompatibleExtension(k,j){const V=(0,L.isIExtensionIdentifier)(k)?null:k;if(V){if((0,L.isNotWebExtensionInWebTargetPlatform)(V.allTargetPlatforms,j))return null;if(await this.isExtensionCompatible(V,j))return V}const{id:X,uuid:Q}=V?V.identifier:k;let se=new p().withFlags(i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");Q?se=se.withFilter(r.ExtensionId,Q):se=se.withFilter(r.ExtensionName,X);const{galleryExtensions:re}=await this.queryGallery(se,j,b.CancellationToken.None),[me]=re;if(!me||!me.versions.length)return null;const ye=z(me);if((0,L.isNotWebExtensionInWebTargetPlatform)(ye,j))return null;for(let fe of me.versions){if(!ae(fe)){const Pe=await this.getEngine(fe);fe={...fe,properties:[...fe.properties||[],{key:m.Engine,value:Pe}]}}if(await this.isRawExtensionVersionCompatible(fe,ye,j))return U(me,fe,ye,0,se)}return null}async isExtensionCompatible(k,j){if(!(0,L.isTargetPlatformCompatible)(k.properties.targetPlatform,k.allTargetPlatforms,j))return!1;let V=k.properties.engine;if(!V){const X=await this.getManifest(k,b.CancellationToken.None);if(!X)throw new Error("Manifest was not found");V=X.engines.vscode}return(0,S.isEngineValid)(V,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(k,j,V){if(!(0,L.isTargetPlatformCompatible)(ne(k),j,V))return!1;const X=await this.getEngine(k);return(0,S.isEngineValid)(X,this.productService.version,this.productService.date)}async query(k,j){const V=b.CancellationToken.isCancellationToken(k)?{}:k,X=b.CancellationToken.isCancellationToken(k)?k:j;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let Q=V.text||"";const se=(0,I.getOrDefault)(V,pe=>pe.pageSize,50);let re=new p().withFlags(i.IncludeLatestVersionOnly,i.IncludeAssetUri,i.IncludeStatistics,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,se).withFilter(r.Target,"Microsoft.VisualStudio.Code");Q?(Q=Q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,Ee,Ae)=>(re=re.withFilter(r.Category,Ae||Ee),"")),Q=Q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(pe,Ee,Ae)=>(re=re.withFilter(r.Tag,Ae||Ee),"")),Q=Q.replace(/\bfeatured(\s+|\b|$)/g,()=>(re=re.withFilter(r.Featured),"")),Q=Q.trim(),Q&&(Q=Q.length<200?Q:Q.substring(0,200),re=re.withFilter(r.SearchText,Q)),re=re.withSortBy(0)):V.ids?re=re.withFilter(r.ExtensionId,...V.ids):V.names?re=re.withFilter(r.ExtensionName,...V.names):re=re.withSortBy(4),typeof V.sortBy=="number"&&(re=re.withSortBy(V.sortBy)),typeof V.sortOrder=="number"&&(re=re.withSortOrder(V.sortOrder));const{galleryExtensions:me,total:ye}=await this.queryGallery(re,e,X),fe=me.map((pe,Ee)=>M(pe,Ee,re,V.source,e)),Pe=async(pe,Ee)=>{if(Ee.isCancellationRequested)throw(0,w.canceled)();const Ae=re.withPage(pe+1),{galleryExtensions:Me}=await this.queryGallery(Ae,e,Ee);return Me.map((Ue,ze)=>M(Ue,ze,Ae,V.source,e))};return{firstPage:fe,total:ye,pageSize:re.pageSize,getPage:Pe}}async queryGallery(k,j,V){if(!this.isEnabled())throw new Error("No extension gallery service configured.");k=k.withFlags(k.flags,i.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,n(i.Unpublished));const X=await this.commonHeadersPromise,Q=JSON.stringify(k.raw),se={...X,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Q.length)},re=new Date().getTime();let me,ye,fe=0;try{if(me=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Q,headers:se},V),me.res.statusCode&&me.res.statusCode>=400&&me.res.statusCode<500)return{galleryExtensions:[],total:fe};const Pe=await(0,y.asJson)(me);if(Pe){const pe=Pe.results[0],Ee=pe.extensions;Ee.forEach(Me=>D(Me.versions,j));const Ae=pe.resultMetadata&&pe.resultMetadata.filter(Me=>Me.metadataType==="ResultCount")[0];return fe=Ae&&Ae.metadataItems.filter(Me=>Me.name==="TotalCount")[0].count||0,{galleryExtensions:Ee,total:fe}}return{galleryExtensions:[],total:fe}}catch(Pe){throw ye=Pe,Pe}finally{this.telemetryService.publicLog2("galleryService:query",{...k.telemetryData,requestBodySize:String(Q.length),duration:new Date().getTime()-re,success:!!me&&(0,y.isSuccess)(me),responseBodySize:me?.res.headers["Content-Length"],statusCode:me?String(me.res.statusCode):void 0,errorCode:ye?(0,w.isPromiseCanceledError)(ye)?"canceled":(0,w.getErrorMessage)(ye).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(fe)})}}async reportStatistic(k,j,V,X){if(!this.isEnabled())return;const Q=R.isWeb?this.api(`/itemName/${k}.${j}/version/${V}/statType/${X==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${k}/extensions/${j}/${V}/stats?statType=${X}`),se=R.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.commonHeadersPromise,Accept:se};try{await this.requestService.request({type:"POST",url:Q,headers:me},b.CancellationToken.None)}catch(ye){}}async download(k,j,V){this.logService.trace("ExtensionGalleryService#download",k.identifier.id);const X=(0,g.getGalleryExtensionTelemetryData)(k),Q=new Date().getTime(),se=fe=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...X,duration:fe}),re=V===1?"install":V===2?"update":"",me=re?{uri:`${k.assets.download.uri}${l.URI.parse(k.assets.download.uri).query?"&":"?"}${re}=true`,fallbackUri:`${k.assets.download.fallbackUri}${l.URI.parse(k.assets.download.fallbackUri).query?"&":"?"}${re}=true`}:k.assets.download,ye=await this.getAsset(me);await this.fileService.writeFile(j,ye.stream),se(new Date().getTime()-Q)}async getReadme(k,j){if(k.assets.readme){const V=await this.getAsset(k.assets.readme,{},j);return await(0,y.asText)(V)||""}return""}async getManifest(k,j){if(k.assets.manifest){const V=await this.getAsset(k.assets.manifest,{},j),X=await(0,y.asText)(V);return X?JSON.parse(X):null}return null}async getManifestFromRawExtensionVersion(k,j){const V=oe(k,a.Manifest);if(!V)throw new Error("Manifest was not found");const X={"Accept-Encoding":"gzip"},Q=await this.getAsset(V,{headers:X});return await(0,y.asJson)(Q)}async getCoreTranslation(k,j){const V=k.assets.coreTranslations.filter(X=>X[0]===j.toUpperCase())[0];if(V){const X=await this.getAsset(V[1]),Q=await(0,y.asText)(X);return Q?JSON.parse(Q):null}return null}async getChangelog(k,j){if(k.assets.changelog){const V=await this.getAsset(k.assets.changelog,{},j);return await(0,y.asText)(V)||""}return""}async getAllCompatibleVersions(k,j){let V=new p().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");k.identifier.uuid?V=V.withFilter(r.ExtensionId,k.identifier.uuid):V=V.withFilter(r.ExtensionName,k.identifier.id);const{galleryExtensions:X}=await this.queryGallery(V,j,b.CancellationToken.None);if(!X.length)return[];const Q=z(X[0]);if((0,L.isNotWebExtensionInWebTargetPlatform)(Q,j))return[];const se=[];for(const re of X[0].versions)try{se[se.length-1]?.version!==re.version&&await this.isRawExtensionVersionCompatible(re,Q,j)&&se.push({version:re.version,date:re.lastUpdated})}catch(me){}return se}async getAsset(k,j={},V=b.CancellationToken.None){const X=await this.commonHeadersPromise,Q={type:"GET"},se={...X,...j.headers||{}};j={...j,...Q,headers:se};const re=k.uri,me=k.fallbackUri,ye={...j,url:re};try{const fe=await this.requestService.request(ye,V);if(fe.res.statusCode===200)return fe;const Pe=await(0,y.asText)(fe);throw new Error(`Expected 200, got back ${fe.res.statusCode} instead.

${Pe}`)}catch(fe){if((0,w.isPromiseCanceledError)(fe))throw fe;const Pe=(0,w.getErrorMessage)(fe);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:re,message:Pe});const pe={...j,url:me};return this.requestService.request(pe,V)}}async getEngine(k){let j=ae(k);if(!j){const V=await this.getManifestFromRawExtensionVersion(k,b.CancellationToken.None);if(!V)throw new Error("Manifest was not found");j=V.engines.vscode}return j}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const k=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},b.CancellationToken.None);if(k.res.statusCode!==200)throw new Error("Could not get extensions report.");const j=await(0,y.asJson)(k),V=new Map;if(j)for(const X of j.malicious){const Q=V.get(X)||{id:{id:X},malicious:!0,slow:!1};Q.malicious=!0,V.set(X,Q)}return[...V.values()]}};K=de([ce(1,y.IRequestService),ce(2,c.ILogService),ce(3,E.IEnvironmentService),ce(4,o.ITelemetryService),ce(5,u.IFileService),ce(6,v.IProductService),ce(7,d.IConfigurationService)],K);let B=class extends K{constructor(k,j,V,X,Q,se,re,me){super(k,j,V,X,Q,se,re,me)}};B=de([ce(0,h.IStorageService),ce(1,y.IRequestService),ce(2,c.ILogService),ce(3,E.IEnvironmentService),ce(4,o.ITelemetryService),ce(5,u.IFileService),ce(6,v.IProductService),ce(7,d.IConfigurationService)],B),t.ExtensionGalleryService=B;let J=class extends K{constructor(k,j,V,X,Q,se,re){super(void 0,k,j,V,X,Q,se,re)}};J=de([ce(0,y.IRequestService),ce(1,c.ILogService),ce(2,E.IEnvironmentService),ce(3,o.ITelemetryService),ce(4,u.IFileService),ce(5,v.IProductService),ce(6,d.IConfigurationService)],J),t.ExtensionGalleryServiceWithNoStorageService=J;async function q(N,k,j,V,X,Q){const se={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N}`},re=await(0,f.getServiceMachineId)(j,X,Q);return(0,s.supportsTelemetry)(k,j)&&(0,s.getTelemetryLevel)(V)===3&&(se["X-Market-User-Id"]=re),se}t.resolveMarketplaceHeaders=q}),define(Z[121],ee([0,1,2,18,10,22,87,27,33,32,26,29,36]),function($,t,C,b,w,I,R,T,l,d,E,L,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let S=class{constructor(v,y){this._configurationService=y,this._experimentProperties={},this._disposables=new C.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let f of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,I.escapeRegExpCharacters)(f),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(f=>{const h=/^[a-f0-9]+$/i.test(f["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!h})})}setExperimentProperty(v,y){this._experimentProperties[v]=y}_updateTelemetryLevel(){this._telemetryLevel=(0,g.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const v=await this._commonProperties;let y=v.sessionID,f=v["common.instanceId"],h=v["common.machineId"],o=v["common.firstSessionDate"],s=v["common.msftInternal"];return{sessionId:y,instanceId:f,machineId:h,firstSessionDate:o,msftInternal:s}}dispose(){this._disposables.dispose()}_log(v,y,f,h){return this.telemetryLevel<y?Promise.resolve(void 0):this._commonProperties.then(o=>{f=(0,b.mixin)(f,o),f=(0,b.mixin)(f,this._experimentProperties),f=(0,b.cloneAndChange)(f,s=>{if(typeof s=="string")return this._cleanupInfo(s,h)}),this._appenders.forEach(s=>s.log(v,f))},o=>{console.error(o)})}publicLog(v,y,f){return this._log(v,3,y,f)}publicLog2(v,y,f){return this.publicLog(v,y,f)}publicLogError(v,y){return this.sendErrorTelemetry?this._log(v,2,y,!0):Promise.resolve(void 0)}publicLogError2(v,y){return this.publicLogError(v,y)}_anonymizeFilePaths(v){let y=v;const f=[];for(let e of this._cleanupPatterns)for(;;){const i=e.exec(v);if(!i)break;f.push([i.index,e.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(y="";;){const e=o.exec(v);if(!e)break;!h.test(e[0])&&f.every(([i,n])=>e.index<i||e.index>=n)&&(y+=v.substring(s,e.index)+"<REDACTED: user-file-path>",s=o.lastIndex)}return s<v.length&&(y+=v.substr(s)),y}_removePropertiesWithPossibleUserInfo(v){if(!v)return v;const y=v.toLowerCase(),f=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(y)?"<REDACTED: secret>":f.test(y)?"<REDACTED: email>":v}_cleanupInfo(v,y){let f=v;y&&(f=this._anonymizeFilePaths(f));for(let h of this._cleanupPatterns)f=f.replace(h,"");return f=this._removePropertiesWithPossibleUserInfo(f),f}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=de([ce(1,T.IConfigurationService)],S),t.TelemetryService=S;const u=w.isWeb?"":" "+(0,R.localize)(0,null);E.Registry.as(l.Extensions.Configuration).registerConfiguration({id:L.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(1,null),properties:{[L.TELEMETRY_SETTING_ID]:{type:"string",enum:["on","error","off"],enumDescriptions:[(0,R.localize)(2,null),(0,R.localize)(3,null),(0,R.localize)(4,null)],markdownDescription:d.default.privacyStatementUrl?(0,R.localize)(6,null,d.default.nameLong,d.default.privacyStatementUrl)+u:(0,R.localize)(5,null,d.default.nameLong)+u,default:"on",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.Registry.as(l.Extensions.Configuration).registerConfiguration({id:L.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(7,null),properties:{[L.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,R.localize)(9,null,d.default.nameLong,d.default.privacyStatementUrl):(0,R.localize)(8,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(10,null,`\`#${L.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[122],ee([0,1,9,18,36]),function($,t,C,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function I(T){const l=await new Promise((E,L)=>{$(["applicationinsights"],E,L)});let d;return l.defaultClient?(d=new l.TelemetryClient(T),d.channel.setUseDiskRetryCaching(!0)):(l.setup(T).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),d=l.defaultClient),T.indexOf("AIF-")===0&&(d.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),d}class R{constructor(l,d,E){this._eventPrefix=l,this._defaultData=d,this._defaultData||(this._defaultData=Object.create(null)),typeof E=="function"?this._aiClient=E():this._aiClient=E,this._asyncAIClient=null}_withAIClient(l){if(!!this._aiClient){if(typeof this._aiClient!="string"){l(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=I(this._aiClient)),this._asyncAIClient.then(d=>{l(d)},d=>{(0,C.onUnexpectedError)(d),console.error(d)})}}log(l,d){!this._aiClient||(d=(0,b.mixin)(d,this._defaultData),d=(0,w.validateTelemetryData)(d),this._withAIClient(E=>E.trackEvent({name:this._eventPrefix+"/"+l,properties:d.properties,measurements:d.measurements})))}flush(){return this._aiClient?new Promise(l=>{this._withAIClient(d=>{d.flush({callback:()=>{this._aiClient=void 0,l(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=R}),define(Z[123],ee([0,1,3,12]),function($,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function w(I,R){const T=Object.create(null),l=(E,L)=>{const g=JSON.parse(E);T[L]=g};if(R){const E=[],L=await b.Promises.readdir(R);for(const S of L)try{(await b.Promises.stat((0,C.join)(R,S))).isDirectory()&&E.push(S)}catch{}const g=[];for(const S of E)(await b.Promises.readdir((0,C.join)(R,S))).filter(c=>c==="telemetry.json").length===1&&g.push(S);for(const S of g){const u=(await b.Promises.readFile((0,C.join)(R,S,"telemetry.json"))).toString();l(u,S)}}let d=(await b.Promises.readFile((0,C.join)(I,"telemetry-core.json"))).toString();return l(d,"vscode-core"),d=(await b.Promises.readFile((0,C.join)(I,"telemetry-extensions.json"))).toString(),l(d,"vscode-extensions"),JSON.stringify(T,null,4)}t.buildTelemetryMessage=w}),define(Z[44],ee([0,1,48,6,3,11,12,73,135,136]),function($,t,C,b,w,I,R,T,l,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class E extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=E;function L(s){const e=s.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function g(s){if(s instanceof E)return s;let e;return/end of central directory record signature not found/.test(s.message)&&(e="CorruptZip"),new E(e,s)}function S(s,e,i,n,r,a){const m=w.dirname(e),P=w.join(n,m);if(!P.startsWith(n))return Promise.reject(new Error(T.localize(0,null,e)));const F=w.join(n,e);let p;return a.onCancellationRequested(()=>{p&&p.destroy()}),Promise.resolve(R.Promises.mkdir(P,{recursive:!0})).then(()=>new Promise((O,A)=>{if(!a.isCancellationRequested)try{p=(0,C.createWriteStream)(F,{mode:i}),p.once("close",()=>O()),p.once("error",A),s.once("error",A),s.pipe(p)}catch(W){A(W)}}))}function u(s,e,i,n){let r=(0,b.createCancelablePromise)(()=>Promise.resolve()),a=0;return n.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((m,P)=>{const F=new b.Sequencer,p=O=>{O.isCancellationRequested||(a++,s.readEntry())};s.once("error",P),s.once("close",()=>r.then(()=>{n.isCancellationRequested||s.entryCount===a?m():P(new E("Incomplete",new Error(T.localize(1,null,a,s.entryCount))))},P)),s.readEntry(),s.on("entry",O=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(O.fileName)){p(n);return}const A=O.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(A)){const te=w.join(e,A);r=(0,b.createCancelablePromise)(oe=>R.Promises.mkdir(te,{recursive:!0}).then(()=>p(oe)).then(void 0,P));return}const W=v(s,O),Y=L(O);r=(0,b.createCancelablePromise)(te=>F.queue(()=>W.then(oe=>S(oe,A,Y,e,i,te).then(()=>p(te)))).then(null,P))})})}function c(s,e=!1){return new Promise((i,n)=>{(0,l.open)(s,e?{lazyEntries:!0}:void 0,(r,a)=>{r?n(g(r)):i((0,I.assertIsDefined)(a))})})}function v(s,e){return new Promise((i,n)=>{s.openReadStream(e,(r,a)=>{r?n(g(r)):i((0,I.assertIsDefined)(a))})})}function y(s,e){return new Promise((i,n)=>{const r=new d.ZipFile;e.forEach(m=>{m.contents?r.addBuffer(typeof m.contents=="string"?Buffer.from(m.contents,"utf8"):m.contents,m.path):m.localPath&&r.addFile(m.localPath,m.path)}),r.end();const a=(0,C.createWriteStream)(s);r.outputStream.pipe(a),r.outputStream.once("error",n),a.once("error",n),a.once("finish",()=>i(s))})}t.zip=y;function f(s,e,i={},n){const r=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let a=c(s,!0);return i.overwrite&&(a=a.then(m=>R.Promises.rm(e).then(()=>m))),a.then(m=>u(m,e,{sourcePathRegex:r},n))}t.extract=f;function h(s,e){return c(s).then(i=>new Promise((n,r)=>{i.on("entry",a=>{a.fileName===e&&v(i,a).then(m=>n(m),m=>r(m))}),i.once("close",()=>r(new Error(T.localize(2,null,e))))}))}function o(s,e){return h(s,e).then(i=>new Promise((n,r)=>{const a=[];i.once("error",r),i.on("data",m=>a.push(m)),i.on("end",()=>n(Buffer.concat(a)))}))}t.buffer=o}),define(Z[124],ee([0,1,44,80]),function($,t,C,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function w(I){return(0,C.buffer)(I,"extension/package.json").then(R=>{try{return JSON.parse(R.toString("utf8"))}catch(T){throw new Error((0,b.localize)(0,null))}})}t.getManifest=w}),define(Z[125],ee([0,1,20,6,9,2,7,3,10,19,42,8,31,12,44,81,21,23,24,91,16,14,40]),function($,t,C,b,w,I,R,T,l,d,E,L,g,S,u,c,v,y,f,h,o,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const i="scanningSystem",n="scanningUser",r="extracting",a="deleting",m="renaming";let P=class extends I.Disposable{constructor(p,O,A,W,Y){super();this.beforeRemovingExtension=p,this.fileService=O,this.logService=A,this.environmentService=W,this.productService=Y,this._devSystemExtensionsPath=null,this.systemExtensionsPath=W.builtinExtensionsPath,this.extensionsPath=W.extensionsPath,this.uninstalledPath=T.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new b.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(p){const O=[];(p===null||p===0)&&O.push(this.scanSystemExtensions().then(null,A=>Promise.reject(new y.ExtensionManagementError(this.joinErrors(A).message,i)))),(p===null||p===1)&&O.push(this.scanUserExtensions(!0).then(null,A=>Promise.reject(new y.ExtensionManagementError(this.joinErrors(A).message,n))));try{const A=await Promise.all(O);return(0,C.flatten)(A)}catch(A){throw this.joinErrors(A)}}async scanUserExtensions(p){this.logService.trace("Started scanning user extensions");let[O,A]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return A=A.filter(W=>!O[new f.ExtensionIdentifierWithVersion(W.identifier,W.manifest.version).key()]),p&&(A=(0,f.groupByExtension)(A,Y=>Y.identifier).map(Y=>Y.sort((te,oe)=>E.rcompare(te.manifest.version,oe.manifest.version))[0])),this.logService.trace("Scanned user extensions:",A.length),A}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(p,O,A,W){const Y=p.key(),te=T.join(this.extensionsPath,`.${(0,g.generateUuid)()}`),oe=T.join(this.extensionsPath,Y);try{await S.Promises.rm(oe)}catch(ae){try{await S.Promises.rm(oe)}catch(ue){}throw new y.ExtensionManagementError((0,c.localize)(0,null,oe,p.id),a)}await this.extractAtLocation(p,O,te,W);let ie=await this.scanExtension(L.URI.file(te),1);if(!ie)throw new Error((0,c.localize)(1,null,te));await this.storeMetadata(ie,{...A,installedTimestamp:Date.now()});try{await this.rename(p,te,oe,Date.now()+2*60*1e3),this.logService.info("Renamed to",oe)}catch(ae){try{await S.Promises.rm(te)}catch(ue){}if(ae.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",p.id);else throw this.logService.info(`Rename failed because of ${(0,w.getErrorMessage)(ae)}. Deleted from extracted location`,te),ae}try{ie=await this.scanExtension(L.URI.file(oe),1)}catch(ae){}if(ie)return ie;throw new Error((0,c.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(p,O){return this.setMetadata(p,O),await this.storeMetadata(p,{...O,installedTimestamp:p.installedTimestamp}),p}async storeMetadata(p,O){O.isMachineScoped=O.isMachineScoped||void 0,O.isBuiltin=O.isBuiltin||void 0,O.installedTimestamp=O.installedTimestamp||void 0;const A=T.join(p.location.fsPath,"package.json"),W=await S.Promises.readFile(A,"utf8"),{manifest:Y}=await this.parseManifest(W);return Y.__metadata=O,await S.Promises.writeFile(A,JSON.stringify(Y,null,"	")),p}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...p){const O=p.map(A=>new f.ExtensionIdentifierWithVersion(A.identifier,A.manifest.version));await this.withUninstalledExtensions(A=>{O.forEach(W=>A[W.key()]=!0)})}async setInstalled(p){await this.withUninstalledExtensions(W=>delete W[p.key()]);const A=(await this.scanExtensions(1)).find(W=>new f.ExtensionIdentifierWithVersion(W.identifier,W.manifest.version).equals(p))||null;return A?(await this.storeMetadata(A,{installedTimestamp:Date.now()}),this.scanExtension(A.location,1)):null}async withUninstalledExtensions(p){return this.uninstalledFileLimiter.queue(async()=>{let O;try{O=await S.Promises.readFile(this.uninstalledPath,"utf8")}catch(W){if(W.code!=="ENOENT")throw W}let A={};if(O)try{A=JSON.parse(O)}catch(W){}return p&&(p(A),Object.keys(A).length?await S.Promises.writeFile(this.uninstalledPath,JSON.stringify(A)):await S.Promises.rm(this.uninstalledPath)),A})}async removeExtension(p,O){this.logService.trace(`Deleting ${O} extension from disk`,p.identifier.id,p.location.fsPath),await S.Promises.rm(p.location.fsPath),this.logService.info("Deleted from disk",p.identifier.id,p.location.fsPath)}async removeUninstalledExtension(p){await this.removeExtension(p,"uninstalled"),await this.withUninstalledExtensions(O=>delete O[new f.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).key()])}async extractAtLocation(p,O,A,W){this.logService.trace(`Started extracting the extension from ${O} to ${A}`);try{await S.Promises.rm(A)}catch(Y){throw new y.ExtensionManagementError(this.joinErrors(Y).message,a)}try{await(0,u.extract)(O,A,{sourcePath:"extension",overwrite:!0},W),this.logService.info(`Extracted extension to ${A}:`,p.id)}catch(Y){try{await S.Promises.rm(A)}catch(te){}throw new y.ExtensionManagementError(Y.message,Y instanceof u.ExtractError&&Y.type?Y.type:r)}}async rename(p,O,A,W){try{await S.Promises.rename(O,A)}catch(Y){if(l.isWindows&&Y&&Y.code==="EPERM"&&Date.now()<W)return this.logService.info(`Failed renaming ${O} to ${A} with 'EPERM' error. Trying again...`,p.id),this.rename(p,O,A,W);throw new y.ExtensionManagementError(Y.message||(0,c.localize)(3,null,O,A),Y.code||m)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const p=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return p;const O=this.scanDevSystemExtensions(),[A,W]=await Promise.all([p,O]);return[...A,...W]}async scanExtensionsInDir(p,O){const A=new b.Limiter(10),W=await this.fileService.resolve(L.URI.file(p));return W.children?(await Promise.all(W.children.filter(te=>te.isDirectory).map(te=>A.queue(async()=>O===1&&(0,d.basename)(te.resource).indexOf(".")===0?null:this.scanExtension(te.resource,O))))).filter(te=>te&&te.identifier):[]}async scanExtension(p,O){try{const A=await this.fileService.resolve(p);if(A.children){const{manifest:W,metadata:Y}=await this.readManifest(p.fsPath),te=A.children.find(({name:ue})=>/^readme(\.txt|\.md|)$/i.test(ue))?.resource,oe=A.children.find(({name:ue})=>/^changelog(\.txt|\.md|)$/i.test(ue))?.resource,ie={id:(0,f.getGalleryExtensionId)(W.publisher,W.name)},ae={type:O,identifier:ie,manifest:W,location:p,readmeUrl:te,changelogUrl:oe,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:O===0};return Y&&(this.setMetadata(ae,Y),ae.installedTimestamp=Y.installedTimestamp),ae}}catch(A){O!==0&&this.logService.trace(A)}return null}async scanDefaultSystemExtensions(){const p=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",p.length),p}async scanDevSystemExtensions(){const p=this.getDevSystemExtensionsList();if(p.length){const O=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",O.length),O.filter(A=>p.some(W=>(0,f.areSameExtensions)(A.identifier,{id:W})))}else return[]}setMetadata(p,O){p.publisherDisplayName=O.publisherDisplayName||null,p.publisherId=O.publisherId||null,p.identifier.uuid=O.id,p.isMachineScoped=!!O.isMachineScoped,p.isBuiltin=p.type===0||!!O.isBuiltin}async removeUninstalledExtensions(){const p=await this.getUninstalledExtensions(),O=await this.scanAllUserExtensions(),A=new Set;for(const te of O)p[new f.ExtensionIdentifierWithVersion(te.identifier,te.manifest.version).key()]||A.add(te.identifier.id.toLowerCase());const W=(0,f.groupByExtension)(O,te=>te.identifier);await b.Promises.settled(W.map(async te=>{const oe=te.sort((ie,ae)=>E.rcompare(ie.manifest.version,ae.manifest.version))[0];A.has(oe.identifier.id.toLowerCase())||await this.beforeRemovingExtension(oe)}));const Y=O.filter(te=>p[new f.ExtensionIdentifierWithVersion(te.identifier,te.manifest.version).key()]);await b.Promises.settled(Y.map(te=>this.removeUninstalledExtension(te)))}async removeOutdatedExtensions(){const p=await this.scanAllUserExtensions(),O=[],A=(0,f.groupByExtension)(p,W=>W.identifier);O.push(...(0,C.flatten)(A.map(W=>W.sort((Y,te)=>E.rcompare(Y.manifest.version,te.manifest.version)).slice(1)))),await b.Promises.settled(O.map(W=>this.removeExtension(W,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(p=>p.name)}joinErrors(p){const O=Array.isArray(p)?p:[p];return O.length===1?O[0]instanceof Error?O[0]:new Error(O[0]):O.reduce((A,W)=>new Error(`${A.message}${A.message?",":""}${W instanceof Error?W.message:W}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=T.normalize(T.join(R.FileAccess.asFileUri("",$).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(p){const O=[S.Promises.readFile(T.join(p,"package.json"),"utf8").then(te=>this.parseManifest(te)),S.Promises.readFile(T.join(p,"package.nls.json"),"utf8").then(void 0,te=>te.code!=="ENOENT"?Promise.reject(te):"{}").then(te=>JSON.parse(te))],[{manifest:A,metadata:W},Y]=await Promise.all(O);return{manifest:(0,h.localizeManifest)(A,Y),metadata:W}}parseManifest(p){return new Promise((O,A)=>{try{const W=JSON.parse(p),Y=W.__metadata||null;O({manifest:W,metadata:Y})}catch(W){A(new Error((0,c.localize)(4,null)))}})}};P=de([ce(1,o.IFileService),ce(2,s.ILogService),ce(3,v.INativeEnvironmentService),ce(4,e.IProductService)],P),t.ExtensionsScanner=P}),define(Z[126],ee([0,1,30,9,7,3,10,28,19,42,8,31,12,44,79,53,21,119,23,24,109,100,124,110,125,111,51,16,15,14,32,29]),function($,t,C,b,w,I,R,T,l,d,E,L,g,S,u,c,v,y,f,h,o,s,e,i,n,r,a,m,P,F,p,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const A="unsetUninstalled",W="downloading";let Y=class extends y.AbstractExtensionManagementService{constructor(G,ne,z,D,M,U,K){super(G,ne,z);this.environmentService=D,this.downloadService=M,this.fileService=K;const B=this._register(U.createInstance(s.ExtensionsLifecycle));this.extensionsScanner=this._register(U.createInstance(n.ExtensionsScanner,q=>B.postUninstall(q))),this.manifestCache=this._register(new i.ExtensionsManifestCache(D,this)),this.extensionsDownloader=this._register(U.createInstance(o.ExtensionsDownloader));const J=this._register(new r.ExtensionsWatcher(this,K,D,z));this._register(J.onDidChangeExtensionsByAnotherSource(({added:q,removed:N})=>{q.length&&this._onDidInstallExtensions.fire(q.map(k=>({identifier:k.identifier,operation:0,local:k}))),N.forEach(k=>this._onDidUninstallExtension.fire({identifier:k}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const G=await this.isAlpineLinux(),ne=(0,f.getTargetPlatform)(G?"alpine":R.platform,T.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",ne),ne})()),this._targetPlatformPromise}async isAlpineLinux(){if(!R.isLinux)return!1;let G;try{G=(await this.fileService.readFile(E.URI.file("/etc/os-release"))).value.toString()}catch(ne){try{G=(await this.fileService.readFile(E.URI.file("/usr/lib/os-release"))).value.toString()}catch(z){this.logService.debug("Error while getting the os-release file.",(0,b.getErrorMessage)(z))}}return!!G&&(G.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(G){this.logService.trace("ExtensionManagementService#zip",G.identifier.id);const ne=await this.collectFiles(G),z=await(0,S.zip)((0,l.joinPath)(this.environmentService.tmpDir,(0,L.generateUuid)()).fsPath,ne);return E.URI.file(z)}async unzip(G){return this.logService.trace("ExtensionManagementService#unzip",G.toString()),(await this.install(G)).identifier}async getManifest(G){const ne=await this.downloadVsix(G),z=I.resolve(ne.fsPath);return(0,e.getManifest)(z)}getInstalled(G=null){return this.extensionsScanner.scanExtensions(G)}async install(G,ne={}){this.logService.trace("ExtensionManagementService#install",G.toString());const z=await this.downloadVsix(G),D=await(0,e.getManifest)(I.resolve(z.fsPath));if(D.engines&&D.engines.vscode&&!(0,a.isEngineValid)(D.engines.vscode,p.default.version,p.default.date))throw new Error(u.localize(0,null,(0,h.getGalleryExtensionId)(D.publisher,D.name),p.default.version));return this.installExtension(D,z,ne)}async updateMetadata(G,ne){return this.logService.trace("ExtensionManagementService#updateMetadata",G.identifier.id),G=await this.extensionsScanner.saveMetadataForLocalExtension(G,{...G.manifest.__metadata||{},...ne}),this.manifestCache.invalidate(),G}async updateExtensionScope(G,ne){return this.logService.trace("ExtensionManagementService#updateExtensionScope",G.identifier.id),G=await this.extensionsScanner.saveMetadataForLocalExtension(G,{...G.manifest.__metadata||{},isMachineScoped:ne}),this.manifestCache.invalidate(),G}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(G){if(G.scheme===w.Schemas.file)return G;const ne=(0,l.joinPath)(this.environmentService.tmpDir,(0,L.generateUuid)());return await this.downloadService.download(G,ne),ne}createInstallExtensionTask(G,ne,z){return E.URI.isUri(ne)?new ie(G,ne,z,this.galleryService,this.extensionsScanner,this.logService):new oe(ne,z,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(G,ne){return new ae(G,ne,this.extensionsScanner)}async collectFiles(G){const ne=async D=>{let M=await g.Promises.readdir(D);M=M.map(B=>I.join(D,B));const U=await Promise.all(M.map(B=>g.Promises.stat(B)));let K=Promise.resolve([]);return U.forEach((B,J)=>{const q=M[J];B.isFile()&&(K=K.then(N=>[...N,q])),B.isDirectory()&&(K=K.then(N=>ne(q).then(k=>[...N,...k])))}),K};return(await ne(G.location.fsPath)).map(D=>({path:`extension/${I.relative(G.location.fsPath,D)}`,localPath:D}))}};Y=de([ce(0,f.IExtensionGalleryService),ce(1,O.ITelemetryService),ce(2,F.ILogService),ce(3,v.INativeEnvironmentService),ce(4,c.IDownloadService),ce(5,P.IInstantiationService),ce(6,m.IFileService)],Y),t.ExtensionManagementService=Y;class te extends y.AbstractExtensionTask{constructor(G,ne,z,D){super();this.identifier=G,this.source=ne,this.extensionsScanner=z,this.logService=D,this._operation=1}get operation(){return this._operation}async installExtension(G,ne){try{const z=await this.unsetUninstalledAndGetLocal(G.identifierWithVersion);if(z)return G.metadata?this.extensionsScanner.saveMetadataForLocalExtension(z,G.metadata):z}catch(z){throw R.isMacintosh?new f.ExtensionManagementError(u.localize(1,null),A):new f.ExtensionManagementError(u.localize(2,null),A)}return this.extract(G,ne)}async unsetUninstalledAndGetLocal(G){if(!await this.isUninstalled(G))return null;this.logService.trace("Removing the extension from uninstalled list:",G.id);const z=await this.extensionsScanner.setInstalled(G);return this.logService.info("Removed the extension from uninstalled list:",G.id),z}async isUninstalled(G){return!!(await this.extensionsScanner.getUninstalledExtensions())[G.key()]}async extract({zipPath:G,identifierWithVersion:ne,metadata:z},D){let M=await this.extensionsScanner.extractUserExtension(ne,G,z,D);return this.logService.info("Extracting completed.",ne.id),M}}class oe extends te{constructor(G,ne,z,D,M){super(G.identifier,G,D,M);this.gallery=G,this.options=ne,this.extensionsDownloader=z}async doRun(G){const z=(await this.extensionsScanner.scanExtensions(null)).find(M=>(0,h.areSameExtensions)(M.identifier,this.gallery.identifier));z&&(this._operation=2);const D=await this.downloadInstallableExtension(this.gallery,this._operation);D.metadata.isMachineScoped=this.options.isMachineScoped||z?.isMachineScoped,D.metadata.isBuiltin=this.options.isBuiltin||z?.isBuiltin;try{const M=await this.installExtension(D,G);return z&&d.neq(z.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(z),M}catch(M){throw await this.deleteDownloadedVSIX(D.zipPath),M}}async deleteDownloadedVSIX(G){try{await this.extensionsDownloader.delete(E.URI.file(G))}catch(ne){this.logService.warn("Error while deleting the downloaded vsix",G.toString(),(0,b.getErrorMessage)(ne))}}async downloadInstallableExtension(G,ne){const z={id:G.identifier.uuid,publisherId:G.publisherId,publisherDisplayName:G.publisherDisplayName};let D;try{this.logService.trace("Started downloading extension:",G.identifier.id),D=(await this.extensionsDownloader.downloadExtension(G,ne)).fsPath,this.logService.info("Downloaded extension:",G.identifier.id,D)}catch(M){throw new f.ExtensionManagementError((0,y.joinErrors)(M).message,W)}try{const M=await(0,e.getManifest)(D);return{zipPath:D,identifierWithVersion:new h.ExtensionIdentifierWithVersion(G.identifier,M.version),metadata:z}}catch(M){throw await this.deleteDownloadedVSIX(D),new f.ExtensionManagementError((0,y.joinErrors)(M).message,y.INSTALL_ERROR_VALIDATING)}}}class ie extends te{constructor(G,ne,z,D,M,U){super({id:(0,h.getGalleryExtensionId)(G.publisher,G.name)},ne,M,U);this.manifest=G,this.location=ne,this.options=z,this.galleryService=D}async doRun(G){const ne=new h.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),D=(await this.extensionsScanner.scanExtensions(1)).find(U=>(0,h.areSameExtensions)(this.identifier,U.identifier)),M=await this.getMetadata(this.identifier.id,G);if(M.isMachineScoped=this.options.isMachineScoped||D?.isMachineScoped,M.isBuiltin=this.options.isBuiltin||D?.isBuiltin,D)if(this._operation=2,ne.equals(new h.ExtensionIdentifierWithVersion(D.identifier,D.manifest.version)))try{await this.extensionsScanner.removeExtension(D,"existing")}catch(U){throw new Error(u.localize(3,null,this.manifest.displayName||this.manifest.name))}else d.gt(D.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(D);else{const U=await this.unsetUninstalledAndGetLocal(ne);if(U)try{await this.extensionsScanner.removeExtension(U,"existing")}catch(K){throw new Error(u.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:I.resolve(this.location.fsPath),identifierWithVersion:ne,metadata:M},G)}async getMetadata(G,ne){try{const z=(await this.galleryService.query({names:[G],pageSize:1},ne)).firstPage[0];if(z)return{id:z.identifier.uuid,publisherDisplayName:z.publisherDisplayName,publisherId:z.publisherId}}catch(z){}return{}}}class ae extends y.AbstractExtensionTask{constructor(G,ne,z){super();this.extension=G,this.options=ne,this.extensionsScanner=z}async doRun(G){const ne=[],z=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const D=new h.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);ne.push(...z.filter(M=>D.equals(new h.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version))))}else ne.push(...z.filter(D=>(0,h.areSameExtensions)(D.identifier,this.extension.identifier)));if(!ne.length)throw new Error(u.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...ne),this.options.remove)for(const D of ne)try{G.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(D)}catch(M){throw new Error(u.localize(6,null,(0,C.toErrorMessage)(M)))}}}}),define(Z[127],ee([0,1,115,17,9,2,11,27,21,97,14,114,137]),function($,t,C,b,w,I,R,T,l,d,E,L,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let S=class extends I.Disposable{constructor(c,v,y){super();this.environmentService=v,this.logService=y,this.configure(c.getValue()),this._register(c.onDidChangeConfiguration(()=>this.configure(c.getValue()),this))}configure(c){this.proxyUrl=c.http&&c.http.proxy,this.strictSSL=!!(c.http&&c.http.proxyStrictSSL),this.authorization=c.http&&c.http.proxyAuthorization}async request(c,v){this.logService.trace("RequestService#request",c.url);const{proxyUrl:y,strictSSL:f}=this;let h;try{h=await(0,d.resolveShellEnv)(this.logService,this.environmentService.args,process.env)}catch(e){this.logService.error("RequestService#request resolving shell environment failed",e)}const o={...process.env,...h},s=c.agent?c.agent:await(0,L.getProxyAgent)(c.url||"",o,{proxyUrl:y,strictSSL:f});return c.agent=s,c.strictSSL=f,this.authorization&&(c.headers={...c.headers||{},"Proxy-Authorization":this.authorization}),this._request(c,v)}async getNodeRequest(c){return((0,C.parse)(c.url).protocol==="https:"?await new Promise((f,h)=>{$(["https"],f,h)}):await new Promise((f,h)=>{$(["http"],f,h)})).request}_request(c,v){return new Promise(async(y,f)=>{let h;const o=(0,C.parse)(c.url),s=c.getRawRequest?c.getRawRequest(c):await this.getNodeRequest(c),e={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,R.isBoolean)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(e.auth=c.user+":"+c.password),h=s(e,i=>{const n=(0,R.isNumber)(c.followRedirects)?c.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...c,url:i.headers.location,followRedirects:n-1},v).then(y,f);else{let r=i;i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,g.createGunzip)())),y({res:i,stream:(0,b.streamToBufferReadableStream)(r)})}}),h.on("error",f),c.timeout&&h.setTimeout(c.timeout),c.data&&typeof c.data=="string"&&h.write(c.data),h.end(),v.onCancellationRequested(()=>{h.abort(),f((0,w.canceled)())})})}async resolveProxy(c){}};S=de([ce(0,T.IConfigurationService),ce(1,l.INativeEnvironmentService),ce(2,E.ILogService)],S),t.RequestService=S}),define(Z[138],ee([0,1,48,139,34,6,17,30,9,2,7,3,28,8,12,27,106,53,113,21,90,120,23,108,126,16,102,103,52,99,55,56,112,14,101,32,40,43,127,118,29,121,36,122,123]),function($,t,C,b,w,I,R,T,l,d,E,L,g,S,u,c,v,y,f,h,o,s,e,i,n,r,a,m,P,F,p,O,A,W,Y,te,oe,ie,ae,ue,G,ne,z,D,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class U extends d.Disposable{constructor(J){super();this.argv=J,(0,b.gracefulify)(C),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[J,q]=await this.initServices();return J.invokeFunction(async N=>{const k=N.get(W.ILogService),j=N.get(r.IFileService),V=N.get(h.INativeEnvironmentService),X=N.get(e.IExtensionManagementCLIService);k.info("CLI main",this.argv),this.registerErrorHandler(k),await this.doRun(V,X,j),await Promise.all(q.map(Q=>{(0,I.raceTimeout)(Q.flush(),1e3)}))})}async initServices(){const J=new p.ServiceCollection,q={_serviceBrand:void 0,...te.default};J.set(oe.IProductService,q);const N=new o.NativeEnvironmentService(this.argv,q);J.set(h.INativeEnvironmentService,N),await Promise.all([N.appSettingsHome.fsPath,N.extensionsPath].map(me=>me?u.Promises.mkdir(me,{recursive:!0}):void 0));const k=(0,W.getLogLevel)(N),j=[];j.push(new Y.SpdLogLogger("cli",(0,L.join)(N.logsPath,"cli.log"),!0,k)),k===W.LogLevel.Trace&&j.push(new W.ConsoleLogger(k));const V=this._register(new W.MultiplexLogService(j));J.set(W.ILogService,V);const X=this._register(new a.FileService(V));J.set(r.IFileService,X);const Q=this._register(new m.DiskFileSystemProvider(V));X.registerProvider(E.Schemas.file,Q);const se=this._register(new v.ConfigurationService(N.settingsResource,X));J.set(c.IConfigurationService,se),await se.initialize(),J.set(ie.IRequestService,new P.SyncDescriptor(ae.RequestService)),J.set(y.IDownloadService,new P.SyncDescriptor(f.DownloadService)),J.set(e.IExtensionManagementService,new P.SyncDescriptor(n.ExtensionManagementService)),J.set(e.IExtensionGalleryService,new P.SyncDescriptor(s.ExtensionGalleryServiceWithNoStorageService)),J.set(e.IExtensionManagementCLIService,new P.SyncDescriptor(i.ExtensionManagementCLIService)),J.set(O.ILocalizationsService,new P.SyncDescriptor(A.LocalizationsService));const re=[];if((0,z.supportsTelemetry)(q,N)){q.aiConfig&&q.aiConfig.asimovKey&&re.push(new D.AppInsightsAppender("monacoworkbench",null,q.aiConfig.asimovKey));const{appRoot:me,extensionsPath:ye,installSourcePath:fe}=N,Pe={appenders:re,sendErrorTelemetry:!1,commonProperties:(async()=>{let pe;try{const Ee=await u.Promises.readFile((0,L.join)(N.userDataPath,"storage.json"));pe=JSON.parse(Ee.toString())[G.machineIdKey]}catch(Ee){Ee.code!=="ENOENT"&&V.error(Ee)}return(0,ue.resolveCommonProperties)(X,(0,w.release)(),(0,w.hostname)(),process.arch,q.commit,q.version,pe,q.msftInternalDomains,fe)})(),piiPaths:[me,ye]};J.set(G.ITelemetryService,new P.SyncDescriptor(ne.TelemetryService,[Pe]))}else J.set(G.ITelemetryService,z.NullTelemetryService);return[new F.InstantiationService(J),re]}registerErrorHandler(J){(0,l.setUnexpectedErrorHandler)(q=>{const N=(0,T.toErrorMessage)(q,!0);!N||J.error(`[uncaught exception in CLI]: ${N}`)}),process.on("uncaughtException",q=>(0,l.onUnexpectedError)(q)),process.on("unhandledRejection",q=>(0,l.onUnexpectedError)(q))}async doRun(J,q,N){if(this.argv["install-source"])return this.setInstallSource(J,N,this.argv["install-source"]);if(this.argv["list-extensions"])return q.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return q.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return q.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return q.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(J.appRoot,J.extensionsPath))}asExtensionIdOrVSIX(J){return J.map(q=>/\.vsix$/i.test(q)?S.URI.file((0,L.isAbsolute)(q)?q:(0,L.join)((0,g.cwd)(),q)):q)}async setInstallSource(J,q,N){await q.writeFile(S.URI.file(J.installSourcePath),R.VSBuffer.fromString(N.slice(0,30)))}}async function K(B){const J=new U(B);try{await J.run()}finally{J.dispose()}}t.main=K})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e96a97448aae1572246bf7c438b7c2ee68a964c0/core/vs/code/node/cliProcessMain.js.map
